<?= $this->extend('commanfile/header'); ?>
<?= $this->section('content'); ?>
<div class="row">
    <div class="col-md-12">
        <div class="card">
            <div class="card-header">
                <!-- <h3 class="card-title"></h3> -->
                <a href="javascript:void(0)" class="btn btn-md btn-primary" onclick="emp()">
                    Add Outcomes Here!
                </a>
            </div>
            <!-- /.card-header -->
            <div class="card-body">
                <table id="outcome-data-table" class="table table-bordered table-striped">
                    <thead>
                        <tr>
                            <th>Title</th>
                            <th>Share [%]</th>
                            <th>Type</th>
                            <th>Status</th>
                            <th>Action</th>
                        </tr>
                    </thead>
                    <tbody>

                    </tbody>
                    <tfoot>
                        <tr>
                            <th>Title</th>
                            <th>Share [%]</th>
                            <th>Type</th>
                            <th>Status</th>
                            <th>Action</th>
                        </tr>
                    </tfoot>
                </table>
            </div>
            <!-- /.card-body -->
        </div>
    </div>
</div>

<div class="modal fade" id="Addoutcome">
    <div class="modal-dialog modal-lg">
        <div class="modal-content">
            <div class="modal-header">
                <h4 class="modal-title">Add Outcomes Info Here</h4>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                <form id="outcomeform" action="POST">
                    <input type="text" name="sss_oc_id" hidden>
                    <div class="row">
                        <div class="col-md-6">
                            <label>Title</label>
                            <div class="form-group">
                                <div class="input-group">
                                    <input type="text" class="form-control" name="sss_oc_name" id="sss_oc_name" placeholder="e.g. Charity">
                                </div>
                                <span class="text-danger error-text sss_oc_name_error"></span>
                            </div>
                        </div>
                        <div class="col-md-6">
                            <label>Share</label>
                            <div class="form-group">
                                <div class="input-group">
                                    <input type="text" class="form-control" name="sss_oc_share" id="sss_oc_share" placeholder="share">
                                </div>
                                <span class="text-danger error-text sss_oc_share_error"></span>
                            </div>
                        </div>
                        <div class="col-md-6">
                            <label>Select Type</label>
                            <div class="form-group">
                                <div class="input-group">
                                    <select name="sss_oc_type" class="form-control" id="">
                                        <option value="" selected>Select Type</option>
                                        <option value="Charity">For Charity</option>
                                        <option value="Advertisment">Advertisment</option>
                                    </select>
                                </div>
                            </div>
                        </div>
                    </div>
                </form>
            </div>
            <div class="modal-footer justify-content-right">
                <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                <button type="button" onclick="save_outcome()" class="btn btn-primary">Save changes</button>
            </div>
        </div>
    </div>
</div>

<script>
    var save_method;
    $(document).ready(function() {
        emptable = $('#outcome-data-table').DataTable({
            "processing": true, //Feature control the processing indicator.
            "serverSide": true, //Feature control DataTables' server-side processing mode.
            "order": [], //Initial no order.
            "ordering": true,
            "searching": true,
            "responsive": true,
            "lengthChange": false,
            // Load data for the table's content from an Ajax source
            "ajax": {
                "url": "<?php echo base_url() ?>/getAlloutcome",
            },
            //Set column definition initialisation properties.
            "columnDefs": [{
                "targets": [-1], //last column
                "orderable": false, //set not orderable
            }, ],
        });
    });

    function emp() {
        save_method = 'add';
        $('.form-group').removeClass('has-error'); // clear error class
        $('.help-block').empty(); // clear error string
        $('#Addoutcome').modal('show'); // show bootstrap modal
    }

    function edit_outcome(emp_id) {
        save_method = 'update';
        var link = "<?php echo base_url() ?>/editoutcome/" + emp_id;
        //Ajax Load data from ajax
        $.ajax({
            url: link,
            type: "GET",
            dataType: "JSON",
            success: function(data) {
                $('[name="sss_oc_id"]').val(data.sss_oc_id);
                $('[name="sss_oc_name"]').val(data.sss_oc_name);
                $('[name="sss_oc_share"]').val(data.sss_oc_share);
                $('[name="sss_oc_type"]').val(data.sss_oc_type);
                $('#Addoutcome').modal('show'); // show bootstrap modal when complete loaded
                $('.modal-title').text('Edit Outcome Detail'); // Set title to Bootstrap modal title
            },
            error: function(jqXHR, textStatus, errorThrown) {
                alert(errorThrown);
            }
        });
    }

    function save_outcome() {
        $('#btnSave').text('saving info...'); //change button text
        $('#btnSave').attr('disabled', true); //set button disable 
        var url;
        if (save_method == 'add') {
            url = "<?= base_url() ?>/insertoutcome";
        } else {
            url = "<?php echo base_url() ?>/updateoutcome";
        }
        var formData = new FormData($('#outcomeform')[0]);
        $.ajax({
            url: url,
            type: "POST",
            data: formData,
            contentType: false,
            processData: false,
            dataType: "JSON",
            success: function(data) {
                if (data.status == true) //if success close modal and reload ajax table
                {
                    Swal.fire(
                        data.message
                    )
                    $('#Addoutcome').modal('hide');
                    $('#outcomeform')[0].reset();
                    emptable.ajax.reload(null, false); //reload datatable ajax 
                } else {
                    $.each(data.error, function(prefix, val) {
                        // $('[name="' + prefix + '"]').next().text(val);
                        $(`span.${prefix}_error`).text(val)
                        // $('#outcomeform').find(`span.${prefix}_error`).text(val);
                        // $(saccode_data).find('span.' +prefix+ '_error').text(val);
                    });
                }
                $('#btnSave').text('save'); //change button text
                $('#btnSave').attr('disabled', false); //set button enable 
            }
        });
    }
    // delete funtion....
    function delete_outcome(id) {
        Swal.fire({
            title: 'Are you sure?',
            text: "You won't be able to revert this!",
            icon: 'warning',
            showCancelButton: true,
            confirmButtonColor: '#3085d6',
            cancelButtonColor: '#d33',
            confirmButtonText: 'Yes, delete it!'
        }).then((result) => {
            if (result.isConfirmed) {
                $.ajax({
                    url: "<?php echo base_url() ?>/deleteoutcome/" + id,
                    type: "GET",
                    dataType: "JSON",
                    success: function(data) {
                        if (data.status == true) {
                            Swal.fire(
                                'Deleted!',
                                'Your file has been deleted.',
                                'success'
                            )
                            emptable.ajax.reload(null, false); //reload datatable ajax 
                        }
                    },
                    error: function(jqXHR, textStatus, errorThrown) {
                        alert(errorThrown);
                    }
                });
            }
        })
    }

    $(document).on('click', '.status_checks', function() {
        var status = ($(this).hasClass("btn-success")) ? '0' : '1';
        var msg = (status == '0') ? 'Inactive' : 'Active';
        Swal.fire({
            title: 'Are you sure to ' + msg + ' the record ?',
            icon: 'warning',
            showCancelButton: true,
            confirmButtonColor: '#3085d6',
            cancelButtonColor: '#d33',
            confirmButtonText: 'Yes, ' + msg + ' it!',
        }).then((result) => {
            if (result.value) {
                var current_element = $(this);
                var id = $(current_element).attr('data');
                var myurl = "<?php echo base_url() ?>/updateoutcomestatus/";
                $.ajax({
                    type: "GET",
                    url: myurl,
                    data: {
                        "sss_oc_id": id,
                        "sss_oc_status": status
                    },
                    success: function(data) {
                        Swal.fire({
                            icon: 'success',
                            title: 'Record ' + msg + ' Successfully..!',
                            showConfirmButton: true,
                            cancelButtonColor: '#d33',
                        });
                        emptable.ajax.reload(null, false); //reload datatable ajax 
                    }
                });
            } else if (result.dismiss == 'cancel') {
                reload_table()
                // function when cancel button is clicked
            }
        });

    });
</script>

<?= $this->endSection(); ?>