<?php

namespace App\Controllers;

use App\Models\PaymentReceived_m;
use App\Models\Bankbook_m;
use App\Models\Bankdetails_m;
use App\Models\Vendor_m;
use \Hermawan\DataTables\DataTable;


class BankBook extends BaseController
{
    public function index()
    {
      
        $data['pageTitle'] = 'Manage Bank Book';
        return view('bankBook', $data);
    }

    public function getbankbookdetail()
    {
        $db = db_connect();
        $builder = $db->table('sss_tbl_bankbook')
            ->select('sss_bankbook_id, sss_bb_transactiondate, sss_bb_reffno, sss_bb_transtype, sss_bb_transamt,sss_tbl_entity_bank_details.sss_ent_bank_name')
            ->join('sss_tbl_entity_bank_details', 'sss_tbl_entity_bank_details.sss_ent_bank_id = sss_tbl_bankbook.sss_bb_bankname');
        return DataTable::of($builder)
            // ->edit('status', function ($row) {
            //     $btnStatus = $row->status == 1 ? 'btn-success' : 'btn-secondary';
            //     $status = ($row->status == 1) ? "Active" : "Inactive";
            //     return '<span type="button" class="btn btn-sm ' . $btnStatus . ' status_checks" data=' . $row->sss_bankbook_id . '>' . $status . '</span>';
            // })
            ->add('action', function ($bbid) {
                return '<a class="btn btn-primary btn-sm" onclick="edit_bank(' . $bbid->sss_bankbook_id . ')"><i class="fa fa-edit"></i></a> | <a class="btn btn-danger btn-sm" onclick="delete_bankbook(' . $bbid->sss_bankbook_id . ')"><i class="fa fa-trash"></i></a>';
            }, 'last')
            ->hide('sss_bankbook_id')
            ->toJson();
    }

    public function Bankbook_delete($id)
    {
        $Bankbook_m = new Bankbook_m();
        $r = $Bankbook_m->delete_by_id($id);
        echo json_encode(array("status" => TRUE, "message" => $r));
    }
}
