<?php


namespace App\Controllers;

use App\Models\Employee_m;
use App\Models\Outcomes_m;
use App\Models\DDD_outcome_m;
use App\Models\DDD_emp_m;
use App\Models\Dealdetaildraft_m;
use App\Models\CreateInvoice_m;
use App\Models\Paymentreceived_m;
use App\Models\Users_m;

use \Hermawan\DataTables\DataTable;

class Ddd_report extends BaseController
{
    public function index()
    {
        $getInvoice_no = new CreateInvoice_m();
        $data['invoice_nos'] = $getInvoice_no->table('sss_tbl_invoices')->select('sss_inv_id ,sss_inv_bill_no')->findAll();

        $data['pageTitle'] = 'Deal Detail Draft Report';
        return view('ddd_report', $data);
    }

    public function get_Shno($invoiceno)
    {
        $dealdetaildraftModel = new Dealdetaildraft_m();
        $paymentreceivedModel = new Paymentreceived_m();

        $invoiceNumbers = $paymentreceivedModel->table('sss_tbl_paymentreceived')
            ->select('sss_pr_id')
            ->where('sss_inv_id', $invoiceno)
            ->get()
            ->getResult();

        $shRecords = array();
        foreach ($invoiceNumbers as $invoice) {
            $paymentReceivedId = $invoice->sss_pr_id;
            $shRecords[] = $dealdetaildraftModel->table('sss_tbl_dealdetaildraft')
                ->select('sss_ddd_id, sss_ddd_shno')
                ->where('sss_pr_id', $paymentReceivedId)
                ->get()
                ->getRow();
        }
        echo json_encode($shRecords);
    }

    public function getdddreport()
    {
        $invoiceno = $this->request->getPost('sss_invoiceno');
        $shno = $this->request->getPost('ddd_shno');

        $ddc = new Dealdetaildraft_m();
        $data['ddd'] = $ddc->table('sss_tbl_dealdetaildraft')->select("sss_tbl_dealdetaildraft.*,sss_tbl_paymentreceived.*,sss_tbl_invoices.*,sss_tbl_client.sss_client_name,sss_tbl_users.sss_ent_id,sss_tbl_entities.sss_ent_name")
            ->join('sss_tbl_paymentreceived', 'sss_tbl_paymentreceived.sss_pr_id = sss_tbl_dealdetaildraft.sss_pr_id')
            ->join('sss_tbl_invoices', 'sss_tbl_invoices.sss_inv_id = sss_tbl_paymentreceived.sss_inv_id')
            ->join('sss_tbl_client', 'sss_tbl_client.sss_client_id = sss_tbl_invoices.sss_inv_client_id')
            ->join('sss_tbl_users', 'sss_tbl_users.sss_ent_id = sss_tbl_dealdetaildraft.sss_ddd_createby')
            ->join('sss_tbl_entities', 'sss_tbl_entities.sss_ent_id = sss_tbl_users.sss_ent_id')
            ->where('sss_ddd_id', $shno)
            ->get()->getRow();

        $alloutcomerecord = new DDD_outcome_m();
        $data['outcome'] = $alloutcomerecord->table('sss_ddd_outcomes')->select("sss_ddd_outcomes.*,sss_tbl_outcomes.sss_oc_name,sss_tbl_outcomes.sss_oc_share,sss_tbl_outcomes.sss_oc_type,sss_ddd_outcomes.sss_dddoutcome_tds")->join('sss_tbl_outcomes', 'sss_tbl_outcomes.sss_oc_id = sss_ddd_outcomes.sss_ddd_oc_id')->where('sss_ddd_id', $shno)->get()->getResult();

        $allemprecord = new DDD_emp_m();
        $data['emps'] = $allemprecord->table('sss_ddd_employees')->select('sss_ddd_employees.*, sss_tbl_emp.sss_emp_fname,sss_tbl_emp.sss_emp_lname,sss_tbl_emp.sss_emp_share')->join('sss_tbl_emp', 'sss_tbl_emp.sss_emp_id = sss_ddd_employees.sss_emp_id')->where('sss_ddd_id', $shno)->get()->getResult();

        echo json_encode($data);
    }
}
