<?php


namespace App\Controllers;


use App\Models\CreateInvoice_m;
use App\Models\Paymentreceived_m;

class ProgressiveReport extends BaseController
{
    public function index()
    {
        // $getInvoice_no = new CreateInvoice_m();
        // $data['invoice_nos'] = $getInvoice_no->table('sss_tbl_invoices')->select('sss_inv_id ,sss_inv_bill_no')->findAll();
        $data['pageTitle'] = 'Progressive Report';
        return view('progressive_report', $data);
    }

    public function getInvoiceRecords()
    {
        $getPaymentReceived = new Paymentreceived_m();
        $dateComps = date_parse($this->request->getVar('month'));
        $year = $dateComps['year'];
        $month = $dateComps['month'];
        $invoice_month = $month . '-' . $year;

        $pre_invoice_month = $month - 1 . '-' . $year;

        $getInvoiceData = new CreateInvoice_m();

        if (!empty($invoice_month)) {
            $data['currentMonth'] = $getInvoiceData->table('sss_tbl_invoices')->select('sss_inv_id,sss_inv_bill_no,sss_inv_bill_date,sss_tbl_client.sss_client_name,sss_inv_brief,sss_inv_amt,sss_inv_sgst,sss_inv_cgst,sss_inv_igst,sss_inv_total_amt')
                ->join('sss_tbl_client', 'sss_tbl_client.sss_client_id = sss_tbl_invoices.sss_inv_client_id')
                ->where('sss_inv_month', $invoice_month)->findAll();

            for ($x = 0; $x < count($data['currentMonth']); $x++) {

                if ($data['currentMonth'][$x]['sss_inv_cgst'] != "0" || $data['currentMonth'][$x]['sss_inv_sgst'] != "0") {
                    $totalgst = $data['currentMonth'][$x]['sss_inv_cgst'] + $data['currentMonth'][$x]['sss_inv_sgst'];
                    $data['currentMonth'][$x]['totalgst'] = $totalgst;
                } else if ($data['currentMonth'][$x]['sss_inv_igst'] != "0" || $data['currentMonth'][$x]['sss_inv_igst'] != "") {
                    $totalgst = $data['currentMonth'][$x]['sss_inv_igst'];
                    $data['currentMonth'][$x]['totalgst'] = $totalgst;
                }

                if ($data['currentMonth'][$x]['sss_inv_bill_no'] != 0) {
                    $parts = explode("/", $data['currentMonth'][$x]['sss_inv_bill_no']);
                    $data['currentMonth'][$x]['invoiceno'] = $parts[0];
                }

                $data['currentMonth'][$x]['paymentreceived'] = $getPaymentReceived->table('sss_tbl_paymentreceived')->select('sss_pr_tdsamt,sss_pr_amtreceived,sss_pr_datereceived,sss_pr_balanceamt')->where('sss_inv_id', $data['currentMonth'][$x]['sss_inv_id'])->findAll();
            }
        }
        if (!empty($pre_invoice_month)) {
            $prevMonth = $getInvoiceData->table('sss_tbl_invoices')->select('sss_inv_amt,sss_inv_sgst,sss_inv_cgst,sss_inv_igst,sss_inv_total_amt')
                ->where('sss_inv_month', $pre_invoice_month)->findAll();

            for ($u = 0; $u < count($prevMonth); $u++) {

                if ($prevMonth[$u]['sss_inv_cgst'] != "0" || $prevMonth[$u]['sss_inv_sgst'] != "0") {
                    $prevtotalgst = $prevMonth[$u]['sss_inv_cgst'] + $prevMonth[$u]['sss_inv_sgst'];
                    $prevMonth[$u]['prevtotalgst'] = $prevtotalgst;
                } else if ($prevMonth[$u]['sss_inv_igst'] != "0" || $prevMonth[$u]['sss_inv_igst'] != "") {
                    $prevtotalgst = $prevMonth[$u]['sss_inv_igst'];
                    $prevMonth[$u]['prevtotalgst'] = $prevtotalgst;
                }
            }
            $prevMonth_allgsttotal = 0;
            $prevMonth_totalAmt = 0;
            $prevMonth_totalTotalAmt = 0;
            foreach ($prevMonth as $invoice) {
                $prevMonth_allgsttotal += $invoice['prevtotalgst'];
                $prevMonth_totalAmt += $invoice['sss_inv_amt'];
                $prevMonth_totalTotalAmt += $invoice['sss_inv_total_amt'];
            }

            $data['prevMonth_allgsttotal'] = $prevMonth_allgsttotal;
            $data['prevMonth_totalAmt'] = $prevMonth_totalAmt;
            $data['prevMonth_totalTotalAmt'] = $prevMonth_totalTotalAmt;
        }



        // echo "<pre>";print_r($data);exit;
        echo json_encode($data);
    }
}
