<?= $this->extend('commanfile/header'); ?>
<?= $this->section('content'); ?>
<div class="row">
    <div class="col-md-12">
        <div class="card">
            <div class="card-header">
                <!-- <h3 class="card-title">Clients</h3> -->
                <a href="javascript:void(0)" class="btn btn-md btn-primary" onclick="client()">
                    <i class="fa fa-user mr-1"></i> Add Client Here
                </a>
            </div>
            <!-- /.card-header -->
            <div class="card-body">
                <table id="client-data-table" class="table table-bordered table-striped">
                    <thead>
                        <tr>
                            <th>Client Name</th>
                            <th>GSTIN</th>
                            <th>Place Of Service</th>
                            <th>Status</th>
                            <th>Action</th>
                        </tr>
                    </thead>
                    <tbody>

                    </tbody>
                    <tfoot>
                        <tr>
                            <th>Client Name</th>
                            <th>GSTIN</th>
                            <th>Place Of Service</th>
                            <th>Status</th>
                            <th>Action</th>
                        </tr>
                    </tfoot>
                </table>
            </div>
            <!-- /.card-body -->
        </div>
    </div>
</div>

<div class="modal fade" id="AddClient">
    <div class="modal-dialog modal-lg">
        <div class="modal-content">
            <div class="modal-header">
                <h4 class="modal-title">Add Employee Info Here</h4>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                <form id="clientform" action="POST">
                    <input type="text" name="sss_client_id" hidden>
                    <div class="row">
                        <div class="col-md-6">
                            <label>Client Name</label>
                            <div class="form-group">
                                <div class="input-group">
                                    <input type="text" class="form-control" name="sss_client_name" id="sss_client_name" placeholder="Enter Client Name">
                                </div>
                                <span class="text-danger error-text sss_client_name_error"></span>
                            </div>
                        </div>
                        <div class="col-md-6">
                            <label>GSTIN</label>
                            <div class="form-group">
                                <div class="input-group">
                                    <input type="text" class="form-control" name="sss_client_gstno" id="sss_client_gstno" placeholder="Enter GST No.">
                                </div>
                                <span class="text-danger error-text sss_client_gstno_error"></span>
                            </div>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-md-6">
                            <label>Place Of Service</label>
                            <select class="form-control select2" name="sss_client_placeofservice" id="sss_client_placeofservice">
                                <option selected="selected">Maharashtra</option>
                                <option>Andhra Pradesh</option>
                            </select>
                            <span class="text-danger error-text sss_client_placeofservice_error"></span>
                        </div>
                        <div class="col-md-6">
                            <label>State Code</label>
                            <div class="form-group">
                                <div class="input-group">
                                    <input type="text" class="form-control" name="sss_client_statecode" id="sss_client_statecode" placeholder="Enter State Code">
                                </div>
                                <span class="text-danger error-text sss_client_statecode_error"></span>
                            </div>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-md-12">
                            <label>Address Of Client</label>
                            <textarea name="sss_client_addr" class="form-control" id="sss_client_addr" cols="30" rows="3" placeholder="Address of client"></textarea>
                        </div>
                    </div>
                </form>
            </div>
            <div class="modal-footer justify-content-right">
                <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                <button type="button" onclick="save_client()" class="btn btn-primary">Save changes</button>
            </div>
        </div>

    </div>
</div>



<script>
    var save_method;
    $(document).ready(function() {
        clienttable = $('#client-data-table').DataTable({
            "processing": true, //Feature control the processing indicator.
            "serverSide": true, //Feature control DataTables' server-side processing mode.
            "order": [], //Initial no order.
            "ordering": true,
            "searching": true,
            "responsive": true,
            "lengthChange": false,
            // Load data for the table's content from an Ajax source
            "ajax": {
                "url": "<?php echo base_url() ?>/getAllclient",
            },
            //Set column definition initialisation properties.
            "columnDefs": [{
                "targets": [-1], //last column
                "orderable": false, //set not orderable
            }, ],
        });
    });

    function client() {
        save_method = 'add';
        $('.form-group').removeClass('has-error'); // clear error class
        $('.help-block').empty(); // clear error string
        $('#AddClient').modal('show'); // show bootstrap modal
    }

    function edit_client(client_id) {
        save_method = 'update';
        var link = "<?php echo base_url() ?>/editclient/" + client_id;
        //Ajax Load data from ajax
        $.ajax({
            url: link,
            type: "GET",
            dataType: "JSON",
            success: function(data) {
                $('[name="sss_client_id"]').val(data.sss_client_id);
                $('[name="sss_client_name"]').val(data.sss_client_name);
                $('[name="sss_client_gstno"]').val(data.sss_client_gstno);
                $('[name="sss_client_placeofservice"]').val(data.sss_client_placeofservice);
                $('[name="sss_client_statecode"]').val(data.sss_client_statecode);
                $('[name="sss_client_addr"]').val(data.sss_client_addr);
                $('#AddClient').modal('show'); // show bootstrap modal when complete loaded
                $('.modal-title').text('Edit Client Detail'); // Set title to Bootstrap modal title
            },
            error: function(jqXHR, textStatus, errorThrown) {
                alert(errorThrown);
            }
        });
    }

    function save_client() {
        $('#btnSave').text('saving info...'); //change button text
        $('#btnSave').attr('disabled', true); //set button disable 
        var url;
        if (save_method == 'add') {
            url = "<?= base_url() ?>/insertclient";
        } else {
            url = "<?php echo base_url() ?>/updateclient";
        }
        var formData = new FormData($('#clientform')[0]);
        $.ajax({
            url: url,
            type: "POST",
            data: formData,
            contentType: false,
            processData: false,
            dataType: "JSON",
            success: function(data) {
                if (data.status == true) //if success close modal and reload ajax table
                {
                    Swal.fire(
                        data.message
                    )
                    $('#AddClient').modal('hide');
                    $('#clientform')[0].reset();
                    clienttable.ajax.reload(null, false); //reload datatable ajax 
                } else {
                    $.each(data.error, function(prefix, val) {
                        // $('[name="' + prefix + '"]').next().text(val);
                        $(`span.${prefix}_error`).text(val)
                        // $('#clientform').find(`span.${prefix}_error`).text(val);
                        // $(saccode_data).find('span.' +prefix+ '_error').text(val);
                    });
                }
                $('#btnSave').text('save'); //change button text
                $('#btnSave').attr('disabled', false); //set button enable 
            }
        });
    }
    // delete funtion....
    function delete_client(id) {
        Swal.fire({
            title: 'Are you sure?',
            text: "You won't be able to revert this!",
            icon: 'warning',
            showCancelButton: true,
            confirmButtonColor: '#3085d6',
            cancelButtonColor: '#d33',
            confirmButtonText: 'Yes, delete it!'
        }).then((result) => {
            if (result.isConfirmed) {
                $.ajax({
                    url: "<?php echo base_url() ?>/deleteclient/" + id,
                    type: "GET",
                    dataType: "JSON",
                    success: function(data) {
                        if (data.status == true) {
                            Swal.fire(
                                'Deleted!',
                                'Your file has been deleted.',
                                'success'
                            )
                            clienttable.ajax.reload(null, false); //reload datatable ajax 
                        }
                    },
                    error: function(jqXHR, textStatus, errorThrown) {
                        alert(errorThrown);
                    }
                });
            }
        })
    }

    $(document).on('click', '.status_checks', function() {
        var status = ($(this).hasClass("btn-success")) ? '0' : '1';
        var msg = (status == '0') ? 'Inactive' : 'Active';
        Swal.fire({
            title: 'Are you sure to ' + msg + ' the record ?',
            icon: 'warning',
            showCancelButton: true,
            confirmButtonColor: '#3085d6',
            cancelButtonColor: '#d33',
            confirmButtonText: 'Yes, ' + msg + ' it!',
        }).then((result) => {
            if (result.value) {
                var current_element = $(this);
                var id = $(current_element).attr('data');
                var myurl = "<?php echo base_url() ?>/updateclientstatus/";
                $.ajax({
                    type: "GET",
                    url: myurl,
                    data: {
                        "sss_client_id": id,
                        "sss_client_status": status
                    },
                    success: function(data) {
                        Swal.fire({
                            icon: 'success',
                            title: 'Record ' + msg + ' Successfully..!',
                            showConfirmButton: true,
                            cancelButtonColor: '#d33',
                        });
                        clienttable.ajax.reload(null, false); //reload datatable ajax 
                    }
                });
            } else if (result.dismiss == 'cancel') {
                reload_table()
            }
        });

    });
</script>
<?= $this->endSection(); ?>