<?= $this->extend('commanfile/header'); ?>
<?= $this->section('content'); ?>
<div class="row">
    <div class="col-md-12">
        <div class="card">
            <div class="card-header">
                <!-- <h3 class="card-title">Bank Details</h3> -->
                <a href="javascript:void(0)" class="btn btn-md btn-info" onclick="saccode()">
                    <i class="fa fa-plus-square mr-1"></i> Add SAC Code
                </a>
            </div>
            <!-- /.card-header -->
            <div class="card-body">
                <table id="AddSac-data-table" class="table table-bordered table-striped">
                    <thead>
                        <tr>
                            <th>Entity Name</th>
                            <th>Invoice Type</th>
                            <th>SAC Code</th>
                            <th>Status</th>
                            <th>Action</th>
                        </tr>
                    </thead>
                    <tbody>
                    </tbody>
                    <tfoot>
                        <tr>
                            <th>Entity Name</th>
                            <th>Invoice Type</th>
                            <th>SAC Code</th>
                            <th>Status</th>
                            <th>Action</th>
                        </tr>
                    </tfoot>
                </table>
            </div>
            <!-- /.card-body -->
        </div>
    </div>
</div>
<div class="modal fade" id="AddSac">
    <div class="modal-dialog modal-lg">
        <div class="modal-content">
            <div class="modal-header">
                <h4 class="modal-title">Add SAC Code Here</h4>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                <form id="saccodeform" method="POST">
                    <input type="text" name="id" hidden>
                    <div class="row">
                        <div class="col-md-6">
                            <label>Select Entity Name :</label>
                            <div class="form-group">
                                <div class="input-group">
                                    <select class="form-control" name="sss_ent_id" id="sss_ent_id">
                                        <option value="">Select an Entity</option>
                                        <?php foreach ($entities as $ent) { ?>
                                            <option value="<?= $ent->sss_ent_id ?>" <?php set_value('sss_ent_id', $ent->sss_ent_id) ?>><?= $ent->sss_ent_name ?></option>
                                        <?php } ?>
                                    </select>
                                </div>
                                <span class="text-danger error-text sss_ent_id_error"></span>
                            </div>
                        </div>
                        <div class="col-md-6">
                            <label>Select Invoice Type :</label>
                            <div class="form-group">
                                <div class="input-group">
                                    <select class="form-control" name="sss_invoice_type" id="sss_invoice_type">
                                        <option value="">Select an Invoice Type</option>
                                        <!-- <option value="Rental">Rental</option> -->
                                        <option value="Rental-Commercial">Rental - Commercial</option>
                                        <option value="Rental-Residential">Rental - Residential</option>
                                        <option value="Sub-Brokerage">Sub - Brokerage</option>
                                        <option value="Sub-Brokerage">Sub - Brokerage</option>
                                    </select>
                                </div>
                                <span class="text-danger error-text sss_invoice_type_error"></span>
                            </div>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-md-6">
                            <label>SAC Code</label>
                            <div class="form-group">
                                <div class="input-group">
                                    <input type="text" class="form-control" name="sss_sac_code" id="sss_sac_code" placeholder="Enter SAC Code">
                                </div>
                                <div class="input-group">
                                    <input type="text" hidden class="form-control" name="sss_sac_code_created_by" id="sss_sac_code_created_by" value="1" placeholder="Enter SAC Code">
                                </div>
                                <span class="text-danger error-text sss_invoice_type_error"></span>
                            </div>
                        </div>
                    </div>
            </div>
            <div class="modal-footer justify-content-right">
                <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                <button type="button" onclick="save_saccode()" class="btn btn-primary">Save changes</button>
            </div>
            </form>
        </div>
    </div>
</div>
<script>
    var save_method;
    // sac code operations ...
    $(document).ready(function() {
        table = $('#AddSac-data-table').DataTable({
            "processing": true, //Feature control the processing indicator.
            "serverSide": true, //Feature control DataTables' server-side processing mode.
            "order": [], //Initial no order.
            "ordering": true,
            "searching": true,
            "responsive": true,
            "lengthChange": false,
            // Load data for the table's content from an Ajax source
            "ajax": {
                "url": "<?php echo base_url() ?>/get_saccodes",
            },
            //Set column definition initialisation properties.
            "columnDefs": [{
                "targets": [-1], //last column
                "orderable": false, //set not orderable
            }, ],
        });
    });

    function saccode() {
        save_method = 'add';
        $('.form-group').removeClass('has-error'); // clear error class
        $('.help-block').empty(); // clear error string
        $('#AddSac').modal('show'); // show bootstrap modal
    }

    function edit_saccode(saccode_id) {
        save_method = 'update';
        var link = "<?php echo base_url() ?>/editrecord/" + saccode_id;
        //Ajax Load data from ajax
        $.ajax({
            url: link,
            type: "GET",
            dataType: "JSON",
            success: function(data) {
                $('[name="id"]').val(data.sss_sac_code_id);
                $('[name="sss_ent_id"]').val(data.sss_ent_id);
                // $('[name="sss_invoice_type"]').val(data.sss_invoice_type);
                if (data.sss_invoice_type != 0) {
                    $('[name="sss_invoice_type"]').val(data.sss_invoice_type).attr("selected", "selected");
                }

                $('[name="sss_sac_code"]').val(data.sss_sac_code);
                $('#AddSac').modal('show'); // show bootstrap modal when complete loaded
                $('.modal-title').text('Edit SAC Code'); // Set title to Bootstrap modal title
            },
            error: function(jqXHR, textStatus, errorThrown) {
                alert(errorThrown);
            }
        });
    }

    function save_saccode() {
        $('#btnSave').text('saving info...'); //change button text
        $('#btnSave').attr('disabled', true); //set button disable 
        var url;
        if (save_method == 'add') {
            url = "<?= base_url() ?>/insertsaccode";
        } else {
            url = "<?php echo base_url() ?>/updatesaccode";
        }
        var formData = new FormData($('#saccodeform')[0]);
        $.ajax({
            url: url,
            type: "POST",
            data: formData,
            contentType: false,
            processData: false,
            dataType: "JSON",
            success: function(data) {
                if (data.status == true) //if success close modal and reload ajax table
                {
                    // Swal.fire(
                    //     data.message
                    // )
                    // $('#AddSac').modal('hide');
                    // $('#saccodeform')[0].reset();
                    // table.ajax.reload(null, false); //reload datatable ajax 


                    Swal.fire({
                        text: data.message,
                        focusConfirm: true,
                        confirmButtonText: '<a class="btn btn-sm" style="color:#fff;" onclick="location.reload()">OK</a>',
                    });
                    setTimeout(function() {
                        $('#loader').show();
                        location.reload();
                    }, 2500);

                } else {
                    $.each(data.error, function(prefix, val) {
                        // $('[name="' + prefix + '"]').next().text(val);
                        // $(`span.${prefix}_error`).text(val)
                        $('#saccodeform').find(`span.${prefix}_error`).text(val);
                        // $(saccode_data).find('span.' +prefix+ '_error').text(val);
                    });
                }
                $('#btnSave').text('save'); //change button text
                $('#btnSave').attr('disabled', false); //set button enable 
            }
        });
    }
    // delete funtion....
    function delete_saccode(id) {
        Swal.fire({
            title: 'Are you sure?',
            text: "You won't be able to revert this!",
            icon: 'warning',
            showCancelButton: true,
            confirmButtonColor: '#3085d6',
            cancelButtonColor: '#d33',
            confirmButtonText: 'Yes, delete it!'
        }).then((result) => {
            if (result.isConfirmed) {
                $.ajax({
                    url: "<?php echo base_url() ?>/deleterecord/" + id,
                    type: "GET",
                    dataType: "JSON",
                    success: function(data) {
                        if (data.status == true) {
                            Swal.fire(
                                'Deleted!',
                                'Your file has been deleted.',
                                'success'
                            )
                            table.ajax.reload(null, false); //reload datatable ajax 
                        }
                    },
                    error: function(jqXHR, textStatus, errorThrown) {
                        alert(errorThrown);
                    }
                });
            }
        })
    }

    $(document).on('click', '.status_checks', function() {
        var status = ($(this).hasClass("btn-success")) ? '0' : '1';
        var msg = (status == '0') ? 'Inactive' : 'Active';
        Swal.fire({
            title: 'Are you sure to ' + msg + ' the record ?',
            icon: 'warning',
            showCancelButton: true,
            confirmButtonColor: '#3085d6',
            cancelButtonColor: '#d33',
            confirmButtonText: 'Yes, ' + msg + ' it!',
        }).then((result) => {
            if (result.value) {
                var current_element = $(this);
                var id = $(current_element).attr('data');
                var myurl = "<?php echo base_url() ?>/updatedsacstatus/";
                $.ajax({
                    type: "GET",
                    url: myurl,
                    data: {
                        "id": id,
                        "status": status
                    },
                    success: function(data) {
                        Swal.fire({
                            icon: 'success',
                            title: 'Record ' + msg + ' Successfully..!',
                            showConfirmButton: true,
                            cancelButtonColor: '#d33',
                        });
                        table.ajax.reload(null, false); //reload datatable ajax 
                    }
                });
            } else if (result.dismiss == 'cancel') {
                reload_table()
                // function when cancel button is clicked
            }
        });

    });
</script>
<?= $this->endSection(); ?>