<?php

namespace App\Controllers;

use App\Models\Bankbook_m;
use App\Models\Bankdetails_m;
use App\Models\MonthsBalances_m;

use \Hermawan\DataTables\DataTable;

class BankBook extends BaseController
{
    public function index()
    {
        $allbank = new Bankdetails_m();
        $data['allbanks'] = $allbank->table('sss_tbl_entity_bank_details')->select("sss_ent_bank_id, sss_ent_bank_acc_name, sss_ent_bank_name, sss_ent_bank_acc_no,sss_ent_bank_acc_ifsc")->where('sss_ent_bank_acc_status', 1)->get()->getResult();
        $data['pageTitle'] = 'Manage Bank Book';
        return view('bankBook', $data);
    }

    // public function getbankbookdetail()
    // {
    //     $bankbook = new Bankbook_m();
    //     $sss_allbankid = $this->request->getPost('sss_bb_sourcebankid');

    //     $dateComps = date_parse($this->request->getVar('month'));
    //     $year = $dateComps['year'];
    //     $month = $dateComps['month'];
    //     $bankmonth = $month . '-' . $year;
    //     // echo $bankmonth."<br>";
    //     // echo $sss_allbankid;exit;
    //     $data = $bankbook->table('sss_tbl_bankbook')
    //         ->select('sss_bankbook_id,sss_pr_id,sss_ddd_id,sss_bb_wdrwl_reffid,sss_bb_transactiondate,sss_bb_particulars,sss_bb_transmode,sss_bb_transreffno')
    //         ->select('sss_bb_isdeposit, sss_bb_iswithdrawl, sss_bb_balance')
    //         // ->select('(SELECT openingbal FROM sss_openingbalance_month where sss_openingbalance_month.bankid = sss_tbl_bankbook.sss_allbankid) as Balance')
    //         // ->select('(SELECT * FROM sss_openingbalance_month where sss_openingbalance_month.bankid = sss_tbl_bankbook.sss_allbankid AND sss_openingbalance_month.balance_month = sss_tbl_bankbook.sss_bb_transmonth ) as Balance')
    //         ->orderBy('sss_tbl_bankbook.sss_bankbook_id', 'DESC')
    //         ->where('sss_allbankid', $sss_allbankid)->where('sss_bb_transmonth', $bankmonth)->get()->getResult();
    //     // $CronModel = new Cron_m();
    //     // $data = $CronModel->table('sss_openingbalance_month')->select('openingbal')->where('bankid', $sss_allbankid)->where('balance_month', $bankmonthmonth)->get()->getRow();

    //     echo json_encode($data);   

    // }

    public function getbankbookdetail()
    {
        $bankbook = new Bankbook_m();
        $MonthB = new MonthsBalances_m();
        $sss_allbankid = $this->request->getPost('sss_bb_sourcebankid');

        $dateComps = date_parse($this->request->getVar('month'));
        $year = $dateComps['year'];
        $month = $dateComps['month'];
        $bankmonth = $month . '-' . $year;

        $data['bankbooktable'] = $bankbook->table('sss_tbl_bankbook')
            ->select('sss_bankbook_id,sss_pr_id,sss_ddd_id,sss_bb_wdrwl_reffid,sss_bb_transactiondate,sss_bb_particulars,sss_bb_transmode,sss_bb_transreffno,sss_bb_lastbalance')
            ->select('sss_bb_isdeposit, sss_bb_iswithdrawl, sss_bb_balance')
            ->orderBy('sss_tbl_bankbook.sss_bb_transactiondate', 'ASC')
            ->where('sss_allbankid', $sss_allbankid)->where('sss_bb_transmonth', $bankmonth)->get()->getResult();
        if(!empty($sss_allbankid) && !empty($bankmonth))
            $data['blncd'] = $MonthB->table('sss_openingbalance_month')->select('openingbal')->where('bankid', $sss_allbankid)->where('balancemonth', $bankmonth)->get()->getRow();
        echo json_encode($data);
    }

    public function Bankbook_delete($id)
    {
        $Bankbook_m = new Bankbook_m();
        $r = $Bankbook_m->delete_by_id($id);
        echo json_encode(array("status" => TRUE, "message" => $r));
    }

    public function print_book($bankid)
    {
        $printentry = new Bankbook_m();
        $data['printentry'] = $printentry->table('sss_tbl_bankbook')->select("sss_bankbook_id, sss_bb_transactiondate, sss_bb_particulars, sss_bb_isdeposit, sss_bb_iswithdrawl, sss_bb_balance, sss_ent_bank_acc_name, sss_ent_bank_name, sss_ent_bank_acc_no")
            ->join('sss_tbl_entity_bank_details t3', 't3.sss_ent_bank_id = sss_tbl_bankbook.sss_allbankid', 'left')
            ->like('sss_allbankid', $bankid)->get()->getResult();

        $dompdf = new \Dompdf\Dompdf();
        $dompdf->loadHtml(view('printbankbook', $data));
        $dompdf->setPaper('A4', 'portrait');
        $dompdf->render();
        $dompdf->stream();
    }
}
