<?php

namespace App\Controllers;

use App\Models\PaymentReceived_m;
use App\Models\Bankbook_m;
use App\Models\Bankdetails_m;
use App\Models\Vendor_m;
use \Hermawan\DataTables\DataTable;


class BankBook extends BaseController
{
    public function index()
    {

        $data['pageTitle'] = 'Manage Bank Book';
        return view('bankBook', $data);
    }

    public function getbankbookdetail()
    {
        $db = db_connect();
        // $builder = $db->table('sss_tbl_bankbook')->select("sss_bankbook_id, sss_bb_transactiondate, ,tbl_vendors.sss_vendor_name, sss_tbl_entity_bank_details.sss_ent_bank_name, sss_bb_transamt, sss_bb_finalamt, sss_bb_transtype")
        //     ->join('tbl_vendors', 'tbl_vendors.sss_vendor_id = sss_tbl_bankbook.sss_bb_vendorid')
        //     ->join('sss_tbl_entity_bank_details', 'sss_tbl_entity_bank_details.sss_ent_bank_id = sss_tbl_bankbook.sss_bb_sourcebankid');

        $builder = $db->table('sss_tbl_bankbook')->select("sss_bankbook_id, sss_bb_transactiondate, sss_bb_particulars, sss_bb_transtype,t1.sss_ent_bank_name as sourcebankname, t2.sss_ent_bank_name as destbankname, sss_bb_transamt, t3.sss_ent_bank_acc_openingbal as sourcebankbalance, t4.sss_ent_bank_acc_openingbal as destibankbalance")
            // ->join('tbl_vendors', 'tbl_vendors.sss_vendor_id = sss_tbl_bankbook.sss_bb_vendorid')
            ->join('sss_tbl_entity_bank_details t1', 't1.sss_ent_bank_id = sss_tbl_bankbook.sss_bb_sourcebankid', 'left')
            ->join('sss_tbl_entity_bank_details t2', 't2.sss_ent_bank_id = sss_tbl_bankbook.sss_bb_destinationbankid', 'left')
            ->join('sss_tbl_entity_bank_details t3', 't3.sss_ent_bank_id = sss_tbl_bankbook.sss_bb_sourcebankid', 'left')
            ->join('sss_tbl_entity_bank_details t4', 't4.sss_ent_bank_id = sss_tbl_bankbook.sss_bb_destinationbankid', 'left');

        // <a class="btn btn-primary btn-sm" onclick="view_entry(' . $bbid->sss_bankbook_id . ')"><i class="fa fa-eye"></i></a> |

        return DataTable::of($builder)
            // ->add('action', function ($bbid) {
            //     return ' <a class="btn btn-danger btn-sm" onclick="delete_bankbook(' . $bbid->sss_bankbook_id . ')"><i class="fa fa-trash"></i></a>';
            // }, 'last')
            ->hide('sss_bankbook_id')
            ->toJson();
    }

    public function Bankbook_delete($id)
    {
        $Bankbook_m = new Bankbook_m();
        $r = $Bankbook_m->delete_by_id($id);
        echo json_encode(array("status" => TRUE, "message" => $r));
    }

    public function show_entry($bbid)
    {
        $showentry = new Bankbook_m();
        $data = $showentry->table('sss_tbl_bankbook')->select("sss_bankbook_id, sss_bb_transactiondate, tbl_vendors.sss_vendor_name, sss_tbl_entity_bank_details.sss_ent_bank_name, sss_bb_transamt, sss_bb_finalamt, sss_bb_transtype")
            ->join('tbl_vendors', 'tbl_vendors.sss_vendor_id = sss_tbl_bankbook.sss_bb_vendorid')
            ->join('sss_tbl_entity_bank_details', 'sss_tbl_entity_bank_details.sss_ent_bank_id = sss_tbl_bankbook.sss_bb_sourcebankid')
            ->where('sss_tbl_bankbook.sss_bankbook_id', $bbid)->get()->getRow();
        echo json_encode($data);
    }
}
