<?php

namespace App\Controllers;


use App\Models\Bankbook_m;
use App\Models\Bankdetails_m;
use App\Models\Vendor_m;
use App\Models\Vendorpurpose_m;
use App\Models\Tdsentries_m;
use App\Models\Client_m;

use App\Models\MonthsBalances_m;

class CreateBankBookEntry extends BaseController
{
    public function index()
    {
        $entityid = session('ent_id');

        //entities bank...
        $Bankdetails_m = new Bankdetails_m();
        $data['bankdetails'] = $Bankdetails_m->table('sss_tbl_entity_bank_details')->select("sss_ent_bank_id, sss_ent_bank_acc_name, sss_ent_bank_name, sss_ent_bank_acc_no,sss_ent_bank_acc_ifsc")->where('sss_ent_id', $entityid)->where('sss_ent_bank_acc_status', 1)->get()->getResult();

        //destination bank list...
        $allbank = new Bankdetails_m();
        $data['allbanks'] = $allbank->table('sss_tbl_entity_bank_details')->select("sss_ent_bank_id, sss_ent_bank_acc_name, sss_ent_bank_name, sss_ent_bank_acc_no,sss_ent_bank_acc_ifsc")->where('sss_ent_bank_acc_status', 1)->get()->getResult();

        //vendorlist..
        $Vendor_m = new Vendor_m();
        $data['vendordetails'] = $Vendor_m->table('tbl_vendors')->select("sss_vendor_id , sss_vendor_name")->where('sss_vendor_status', 1)->get()->getResult();

        $allclients = new Client_m();
        $data['allclient'] = $allclients->table('sss_tbl_client')->select("sss_client_id, sss_client_name")->where('sss_client_status', 1)->get()->getResult();


        // echo "<pre>";print_r($data);exit;
        $data['pageTitle'] = 'Manage Bank Book Entries';
        return view('createBankBookEntry', $data);
    }

    public function getPurpose($vendorid)
    {
        $purposelist = new Vendorpurpose_m();
        $data = $purposelist->where('sss_v_id', $vendorid)->get()->getResult();
        echo json_encode($data);
    }

    public function getVendor_Type($vendorid)
    {
        $vendortype = new Vendor_m();
        $data = $vendortype->where('sss_vendor_id', $vendorid)->get()->getRow();
        echo json_encode($data);
    }

    // public function getTotalFinancial_Amount($vendorid)
    // {
    //     $getValue = new Tdsentries_m();
    //     $data = $getValue->table('sss_tbl_totaltds')->select('sss_totalfin_amt,sss_trans_date')->where('sss_vid', $vendorid)->orderBy('sss_tt_id ', "desc")->get()->getRow();
    //     echo json_encode($data);
    // }

    public function getTotalFinancial_Amount($vendorid)
    {
        $getValue = new Bankbook_m();
        $data = $getValue->table('sss_tbl_bankbook')->select('sss_totalfin_amt,sss_bb_transactiondate')->where('sss_bb_vendorid', $vendorid)->orderBy('sss_bankbook_id', "desc")->get()->getRow();
        echo json_encode($data);
    }

    public function getOpening_Bal($bankid)
    {
        $getOpngBal = new Bankdetails_m();
        $data = $getOpngBal->table('sss_tbl_entity_bank_details')->select('sss_ent_bank_acc_openingbal')->where('sss_ent_bank_id ', $bankid)->get()->getRow();
        echo json_encode($data);
    }

    public function insert_bbentry()
    {
        $validation = \Config\Services::validation();
        $this->validate([
            'sss_bb_vendorid' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Please Select Vendor',
                ]
            ],
            'sss_bb_transactiondate' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Please select Transaction Date'
                ]
            ],
            'sss_bb_transamt' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Please enter Transaction Amount'
                ]
            ],

        ]);
        if ($validation->run() == FALSE) {
            $errors = $validation->getErrors();
            echo json_encode(['code' => 0, 'error' => $errors]);
        } else {

            $iswithdr = 0;
            $isDepo = 0;
            $isCheque = 0;

            // get vendor name...
            $Vendor_m = new Vendor_m();
            $vendorname = $Vendor_m->find($this->request->getVar('sss_bb_vendorid'));
            // get vendor purpose...

            $Vendorpurpose_m = new Vendorpurpose_m();
            $vendorp = $Vendorpurpose_m->find($this->request->getVar('sss_bb_vpid'));
            // exit;

            $dateComps = date_parse($this->request->getVar('sss_bb_transactiondate'));
            $year = $dateComps['year'];
            $month = $dateComps['month'];
            $sss_bb_transmonth = $month . '-' . $year;

            if ($this->request->getVar('sss_bb_transtype') == 'Withdrawl') {
                $iswithdr = $this->request->getVar('sss_bb_finalamt');
            } else if ($this->request->getVar('sss_bb_transtype') == 'Deposit') {
                $isDepo = $this->request->getVar('sss_bb_finalamt');
            }

            $bbparticulars = $vendorname['sss_vendor_name'] . ' - ' . $vendorp['sss_vp_purpose'] . ' - ' . $this->request->getVar('sss_bb_particulars');

            $insertbankbook = new Bankbook_m();
            $wdata = [
                'sss_bb_vendorid' => $this->request->getVar('sss_bb_vendorid'),
                'sss_bb_clientid' => $this->request->getVar('sss_bb_clientid'),
                'sss_bb_vpid' => $this->request->getVar('sss_bb_vpid'),
                'sss_bb_particulars' => $bbparticulars,
                'sss_bb_sourcebankid' => $this->request->getVar('sss_bb_sourcebankid'),
                'sss_bb_transactiondate' => $this->request->getVar('sss_bb_transactiondate'),
                'sss_bb_transamt' => $this->request->getVar('sss_bb_transamt'),
                'sss_bb_tdsper' => $this->request->getVar('sss_bb_tdsper'),
                'sss_bb_tdsamt' => $this->request->getVar('sss_bb_tdsamt'),
                'sss_bb_gstamt' => $this->request->getVar('sss_bb_gstamt'),
                'sss_bb_finalamt' => $this->request->getVar('sss_bb_finalamt'),
                'sss_bb_transmode' => $this->request->getVar('sss_bb_transmode'),
                'sss_bb_transreffno' => $this->request->getVar('sss_bb_transreffno'),
                'sss_bb_transtype' => $this->request->getVar('sss_bb_transtype'),
                'sss_bb_iswithdrawl' => $iswithdr,
                'sss_bb_isdeposit' => $isDepo,
                'sss_bb_openingbal' => $this->request->getVar('sss_bb_openingbal'),
                'sss_bb_closingbal' => $this->request->getVar('sss_bb_closingbal'),
                'sss_bb_transmonth' => $sss_bb_transmonth,
                'sss_bb_lastbalance' => $this->request->getVar('sss_bb_openingbal'),
                'sss_bb_balance' => $this->request->getVar('sss_bb_closingbal'),
                'sss_allbankid' => $this->request->getVar('sss_bb_sourcebankid'),
                'sss_totalfin_amt' => $this->request->getVar('sss_totalfin_amt'),
                'createdby' => session('userid'),
                'createdate' => date('Y-m-d')
            ];
            $isInserted = $insertbankbook->insert($wdata);

            $updaterecord = new Bankdetails_m();
            $id = $this->request->getVar('sss_bb_sourcebankid');
            $bdata = [
                'sss_ent_bank_acc_openingbal' => $this->request->getVar('sss_bb_closingbal'),
                'sss_ent_bank_last_updated_by' => session('userid'),
                'sss_ent_bank_updated_date' => date('Y-m-d')
            ];
            $isbankupdated = $updaterecord->update($id, $bdata);


            if ($this->request->getVar('sss_bb_destinationbankid') != 0) {
                $getOpngBal = new Bankdetails_m();
                $data['opngbalfordeposite'] = $getOpngBal->find($this->request->getVar('sss_bb_destinationbankid'));
                $destination_bank = $data['opngbalfordeposite']['sss_ent_bank_acc_openingbal'];
                $depositeamt = $destination_bank + $this->request->getVar('sss_bb_finalamt');
                $depo_bdata = [
                    'sss_ent_bank_acc_openingbal' => $depositeamt,
                    'sss_ent_bank_last_updated_by' => session('userid'),
                    'sss_ent_bank_updated_date' => date('Y-m-d')
                ];
                $getOpngBal->update($this->request->getVar('sss_bb_destinationbankid'), $depo_bdata);

                $depositedata = [
                    'sss_bb_wdrwl_reffid' => $isInserted,
                    'sss_bb_vendorid' => $this->request->getVar('sss_bb_vendorid'),
                    'sss_bb_vpid' => $this->request->getVar('sss_bb_vpid'),
                    'sss_bb_clientid' => $this->request->getVar('sss_bb_clientid'),
                    'sss_bb_particulars' => $bbparticulars,
                    'sss_bb_destinationbankid' => $this->request->getVar('sss_bb_destinationbankid'),
                    'sss_bb_transactiondate' => $this->request->getVar('sss_bb_transactiondate'),
                    'sss_bb_transamt' => $this->request->getVar('sss_bb_transamt'),
                    'sss_bb_tdsper' => $this->request->getVar('sss_bb_tdsper'),
                    'sss_bb_tdsamt' => $this->request->getVar('sss_bb_tdsamt'),
                    'sss_bb_gstamt' => $this->request->getVar('sss_bb_gstamt'),
                    'sss_bb_finalamt' => $this->request->getVar('sss_bb_finalamt'),
                    'sss_bb_transmode' => $this->request->getVar('sss_bb_transmode'),
                    'sss_bb_transreffno' => $this->request->getVar('sss_bb_transreffno'),
                    'sss_bb_transtype' => 'Deposit',
                    'sss_bb_iswithdrawl' => '0',
                    'sss_bb_isdeposit' => $isDepo,
                    'sss_bb_isdeposit' => $this->request->getVar('sss_bb_finalamt'),
                    'sss_bb_openingbal' => $this->request->getVar('sss_bb_openingbal'),
                    'sss_bb_closingbal' => $this->request->getVar('sss_bb_closingbal'),
                    'sss_bb_transmonth' => $sss_bb_transmonth,
                    'sss_bb_balance' => $depositeamt,
                    'sss_allbankid' => $this->request->getVar('sss_bb_destinationbankid'),
                    'sss_totalfin_amt' => $this->request->getVar('sss_totalfin_amt'),
                    'createdby' => session('userid'),
                    'createdate' => date('Y-m-d')
                ];

                $insertbankbook->insert($depositedata);
            }

            if (!empty($this->request->getVar('sss_bb_tdsper'))) {
                $TDsEntry = new Tdsentries_m();
                $Tdsdata = [
                    'sss_vid' => $this->request->getVar('sss_bb_vendorid'),
                    'sss_vpid' => $this->request->getVar('sss_bb_vpid'),
                    'sss_bb_id' => $isInserted,
                    'sss_bankid' => $this->request->getVar('sss_bb_sourcebankid'),
                    'sss_trans_date' => $this->request->getVar('sss_bb_transactiondate'),
                    'sss_transamt' => $this->request->getVar('sss_bb_transamt'),
                    'sss_tdsinper' => $this->request->getVar('sss_bb_tdsper'),
                    'sss_tdsamt' => $this->request->getVar('sss_bb_tdsamt'),
                    'sss_totalfin_amt' => $this->request->getVar('sss_totalfin_amt'),
                    'sss_tdsmonth' => $sss_bb_transmonth,
                    'createdate' => date('Y-m-d')
                ];
                $TDsEntry->insert($Tdsdata);
            }
            echo json_encode(array("status" => true, "message" => 'Entry Done'));
        }
    }


    public function delete_bankbook($bankbookid)
    {
        $getBankBook = new Bankbook_m();
        $bankbookrecord = $getBankBook->find($bankbookid);
        // echo "<pre>";print_r($bankbookrecord);exit;
        // $isselectedAmt = $bankbookrecord['sss_bb_finalamt']; // use to for rearrange all balances...
        // echo "Amount to be deleted .".$isdepositedAmt."<br>";

        $isWithdrawled = 0;
        $isDeposited = 0;
        if ($bankbookrecord['sss_bb_transtype'] == 'Withdrawl') {
            $isWithdrawled = $bankbookrecord['sss_bb_transamt'];
            // echo 'Withdrawled Value '.$isWithdrawled."<br>";
        }
        if ($bankbookrecord['sss_bb_transtype'] == 'Deposit') {
            $isDeposited = $bankbookrecord['sss_bb_transamt'];
            // echo 'Deposite Value '.$isDeposited."<br>";
        }
        $BankBalance  = new Bankdetails_m();

        if (!empty($bankbookrecord)) {
            //re-arrange the balances....
            $next_BankBook_entries = $getBankBook->table('sss_tbl_bankbook')->where('sss_bankbook_id >', $bankbookid)->orderBy('sss_bankbook_id', 'ASC')->get()->getResult(); // next bankbook entries which from deleting id..
            if (!empty($next_BankBook_entries)) {
                foreach ($next_BankBook_entries as $nextentries) {

                    // if ($nextentries->sss_bb_transtype == 'Withdrawl') {
                    //     $withdrawl_bankbookid = $nextentries->sss_bankbook_id;
                    //     $lastbalanceamt_row = $nextentries->sss_bb_lastbalance;
                    //     $currentbalance = $nextentries->sss_bb_balance;
                    //     echo "withdrawl -".$lastbalanceamt_row."<br>";
                    //     $last_withdrawlbalances_bb = $lastbalanceamt_row - $isselectedAmt; // calcualte prev balamt..
                    //     echo "new withdrawl -".$last_withdrawlbalances_bb."<br>";
                    //     $newbalance_withdrawl_bb = $currentbalance - $isselectedAmt; // new balance amt...
                    //     echo "withdrawl New current bal -".$newbalance_withdrawl_bb."<br>";
                    //     $new_withdrawlBalances = [
                    //         'sss_bb_lastbalance' => $last_withdrawlbalances_bb,
                    //         'sss_bb_balance' => $newbalance_withdrawl_bb,
                    //         'sss_bb_updated_by' => session('userid'),
                    //         'sss_bb_update_date' => date('Y-m-d')
                    //     ];
                    //     echo "Withdrawl Array";
                    //     echo "<pre>";print_r($new_withdrawlBalances);
                    //     // $getBankBook->update($withdrawl_bankbookid, $new_withdrawlBalances);
                    // } 
                    // if ($nextentries->sss_bb_transtype == 'Deposit') {
                    //     $deposite_bankbookid = $nextentries->sss_bankbook_id;
                    //     $deposite_lastbalanceamt_row = $nextentries->sss_bb_lastbalance;
                    //     $deposite_currentbalanceamt_row = $nextentries->sss_bb_balance;
                    //     echo "Last Balance of next row .." . $lastbalanceamt_row . "<br>";
                    //     $last_balances_bb = $deposite_lastbalanceamt_row + $isselectedAmt; // calcualte prev balamt..
                    //     echo "New Last Balance " . $last_balances_bb . "<br>";
                    //     $newbalance_amt_bb = $deposite_currentbalanceamt_row + $nextentries->sss_bb_transamt; // new balance amt...
                    //     $new_depositeBalances = [
                    //         'sss_bb_lastbalance' => $last_balances_bb,
                    //         'sss_bb_balance' => $newbalance_amt_bb,
                    //         'sss_bb_updated_by' => session('userid'),
                    //         'sss_bb_update_date' => date('Y-m-d')
                    //     ];
                    //     echo "Deposite Array";
                    //     echo "<pre>";print_r($new_depositeBalances);
                    //     // $getBankBook->update($deposite_bankbookid, $new_depositeBalances);
                    // }

                    if ($bankbookrecord['sss_bb_transtype'] == 'Deposit') {
                        $withdrawl_bankbookid = $nextentries->sss_bankbook_id;
                        $lastbalanceamt_row = $nextentries->sss_bb_lastbalance;
                        $currentbalance = $nextentries->sss_bb_balance;
                        $last_withdrawlbalances_bb = $lastbalanceamt_row - $isDeposited; // calcualte prev balamt..
                        $newbalance_withdrawl_bb = $currentbalance - $isDeposited; // new balance amt...
                        $new_withdrawlBalances = [
                            'sss_bb_lastbalance' => $last_withdrawlbalances_bb,
                            'sss_bb_balance' => $newbalance_withdrawl_bb,
                            'sss_bb_updated_by' => session('userid'),
                            'sss_bb_update_date' => date('Y-m-d')
                        ];
                        $getBankBook->update($withdrawl_bankbookid, $new_withdrawlBalances);
                    } else if ($bankbookrecord['sss_bb_transtype'] == 'Withdrawl') {
                        $withdrawl_bankbookid = $nextentries->sss_bankbook_id;
                        $lastbalanceamt_row = $nextentries->sss_bb_lastbalance;
                        $currentbalance = $nextentries->sss_bb_balance;
                        $last_withdrawlbalances_bb = $lastbalanceamt_row + $isWithdrawled; // calcualte prev balamt..
                        $newbalance_withdrawl_bb = $currentbalance + $isWithdrawled; // new balance amt...
                        $new_withdrawlBalances = [
                            'sss_bb_lastbalance' => $last_withdrawlbalances_bb,
                            'sss_bb_balance' => $newbalance_withdrawl_bb,
                            'sss_bb_updated_by' => session('userid'),
                            'sss_bb_update_date' => date('Y-m-d')
                        ];
                        $getBankBook->update($withdrawl_bankbookid, $new_withdrawlBalances);
                    }
                }
            }

            // exit;

            $forrefid = $bankbookrecord['sss_bankbook_id'];
            $check_refid = $getBankBook->where('sss_bb_wdrwl_reffid', $forrefid)->orderBy('sss_bankbook_id', 'DESC')->get()->getRow();
            $get_trans_month = $bankbookrecord['sss_bb_transmonth'];
            $sourcebankid = $bankbookrecord['sss_bb_sourcebankid']; // get source bank id...

            $MonthsBalances_m = new MonthsBalances_m();

            if (!empty($sourcebankid)) {
                $get_MonthsBalance_Row = $MonthsBalances_m->table('sss_openingbalance_month')->where('bankid', $sourcebankid)->where('balancemonth', $get_trans_month)->get()->getRow();
                $get_MonthsBalance_Row_id = $get_MonthsBalance_Row->id;

                if ($bankbookrecord['sss_bb_transtype'] == 'Withdrawl') {
                    $getOpeningbalofsourcebank = $BankBalance->find($sourcebankid); // get source bank balance.....
                    $sourcebankbal = $getOpeningbalofsourcebank['sss_ent_bank_acc_openingbal'];
                    $updatewithdrawlbankbalance = $sourcebankbal + $bankbookrecord['sss_bb_finalamt'];

                    $updatewithdrawlbank = new Bankdetails_m();
                    $update_sourcebank = [
                        'sss_ent_bank_acc_openingbal' => $updatewithdrawlbankbalance,
                        'sss_ent_bank_last_updated_by' => session('userid'),
                        'sss_ent_bank_updated_date' => date('Y-m-d')
                    ];
                    $updatewithdrawlbank->update($sourcebankid, $update_sourcebank);

                    //month ... commented on 4-7-23
                    // $update_Months_Balance = [
                    //     'openingbal' => $updatewithdrawlbankbalance,
                    // ];
                    // $MonthsBalances_m->update($get_MonthsBalance_Row_id, $update_Months_Balance);

                    $getBankBook->table('sss_tbl_bankbook')->where('sss_bankbook_id', $bankbookid)->delete();
                } else {
                    $getOpeningbalofsourcebank = $BankBalance->find($sourcebankid); // get source bank balance.....

                    $sourcebankbal = $getOpeningbalofsourcebank['sss_ent_bank_acc_openingbal'];
                    $updatewithdrawlbankbalance = $sourcebankbal - $bankbookrecord['sss_bb_finalamt'];

                    $updatedepositebank = new Bankdetails_m();
                    $update_sourcebank = [
                        'sss_ent_bank_acc_openingbal' => $updatewithdrawlbankbalance,
                        'sss_ent_bank_last_updated_by' => session('userid'),
                        'sss_ent_bank_updated_date' => date('Y-m-d')
                    ];
                    $updatedepositebank->update($sourcebankid, $update_sourcebank);

                    //month ... commented on 4-7-23
                    // $update_Months_Balance = [
                    //     'openingbal' => $updatewithdrawlbankbalance,
                    // ];
                    // $MonthsBalances_m->update($get_MonthsBalance_Row_id, $update_Months_Balance);

                    $getBankBook->table('sss_tbl_bankbook')->where('sss_bankbook_id', $bankbookid)->delete();
                }
            }

            if (!empty($check_refid)) {

                $deposited_balance = $check_refid->sss_bb_isdeposit;
                $destinationbankid = $check_refid->sss_bb_destinationbankid; // get destination bank.....

                $getOpeningbalofdestinationbank = $BankBalance->find($destinationbankid); // get destination bank balance.....

                $destinationbankbal = $getOpeningbalofdestinationbank['sss_ent_bank_acc_openingbal'];
                $updatedepositebankbalance = $destinationbankbal - $deposited_balance;

                $updatedepositebank = new Bankdetails_m();
                $update_destinationbank = [
                    'sss_ent_bank_acc_openingbal' => $updatedepositebankbalance,
                    'sss_ent_bank_last_updated_by' => session('userid'),
                    'sss_ent_bank_updated_date' => date('Y-m-d')
                ];
                $updatedepositebank->update($destinationbankid, $update_destinationbank);

                $get_MonthsBalance_Row_dest = $MonthsBalances_m->table('sss_openingbalance_month')->where('bankid', $destinationbankid)->where('balancemonth', $get_trans_month)->get()->getRow();
                $get_MonthsBalance_Row_id_destination = $get_MonthsBalance_Row_dest->id;

                //month ... commented on 4-7-23
                // $update_Months_Balance_destination = [
                //     'openingbal' => $updatedepositebankbalance,
                // ];
                // $MonthsBalances_m->update($get_MonthsBalance_Row_id_destination, $update_Months_Balance_destination);

                $getBankBook->table('sss_tbl_bankbook')->where('sss_bb_wdrwl_reffid', $bankbookid)->delete();
            }
        }
        // exit;
        // enter tds entries.....
        $Tdsentries_m = new Tdsentries_m();
        $Tdsentries_m->table('sss_tbl_totaltds')->where('sss_bb_id', $bankbookid)->delete();

        $isDeleted = $getBankBook->table('sss_tbl_bankbook')->where('sss_bankbook_id', $bankbookid)->delete();

        if ($isDeleted)
            echo json_encode(array("status" => TRUE));
        else
            echo json_encode(array("status" => FALSE));
    }
}
