<?php

namespace App\Controllers;

use App\Models\CreateInvoice_m;
use App\Models\Paymentreceived_m;
use App\Models\Bankbook_m;
use App\Models\Bankdetails_m;
use App\Models\Client_m;
use App\Models\Dealdetaildraft_m;
use App\Models\Dealdisbursalchart_m;
use App\Models\Tdsentries_m;
use App\Models\DDD_emp_m;
use App\Models\DDD_outcome_m;
use App\Models\MonthsBalances_m;

use \Hermawan\DataTables\DataTable;

class PaymentReceived extends BaseController
{
    public function index($invId)
    {
        $data['invId'] = $invId;
        $paymentlastid = new Paymentreceived_m();
        $data['lastbalamt'] = $paymentlastid->table('sss_tbl_paymentreceived')->select("sss_pr_tdsper,sss_pr_tdsamt,sss_pr_finalamt,sss_pr_balanceamt,sss_pr_prev_balamt")
            ->orderBy('sss_pr_id', 'DESC')
            ->where('sss_inv_id', $invId)
            ->get()->getRow();

        // echo "<pre>";$data['lastbalamt'];exit;

        $invoices = new CreateInvoice_m();
        $data['invoice'] = $invoices->table('sss_tbl_invoices')->select("sss_inv_bill_no, sss_inv_bill_date,sss_tbl_client.sss_client_name,sss_inv_amt,sss_inv_desc,sss_inv_brief,sss_inv_sgst,sss_inv_cgst,sss_inv_igst,sss_inv_total_amt")
            ->join('sss_tbl_client', 'sss_tbl_client.sss_client_id = sss_tbl_invoices.sss_inv_client_id')
            ->where('sss_inv_id', $invId)
            ->get()->getRow();
        if ($data['invoice']->sss_inv_cgst != "0" || $data['invoice']->sss_inv_sgst != "0") {
            $totalgst = $data['invoice']->sss_inv_cgst + $data['invoice']->sss_inv_sgst;
            $data['totalgst'] = $totalgst;
        } else {
            $totalgst = $data['invoice']->sss_inv_igst;
            $data['totalgst'] = $totalgst;
        }

        $lastprid = new Paymentreceived_m();
        $lastid = $lastprid->table('sss_tbl_paymentreceived')->select("sss_pr_id")->orderBy('sss_pr_id', 'DESC')->get()->getRow();
        if (empty($lastid)) {
            $data['sss_pr_reffno'] = 'PR' . str_pad(0 + 1, 5, '0', STR_PAD_LEFT);
        } else {
            $data['sss_pr_reffno'] = 'PR' . str_pad($lastid->sss_pr_id + 1, 5, '0', STR_PAD_LEFT);
        }

        // echo '<pre>';print_r($data['sss_pr_reffno']);exit;
        $data['pageTitle'] = 'Payment Received';
        return view('paymentreceived_v', $data);
    }

    public function getPayment_details($invId)
    {
        $db = db_connect();
        $builder = $db->table('sss_tbl_paymentreceived')
            ->select("sss_pr_id, sss_pr_reffno, sss_tbl_invoices.sss_inv_total_amt, sss_pr_amtreceived, sss_pr_balanceamt, sss_pr_datereceived, sss_pr_paymenttype")
            ->join('sss_tbl_invoices', 'sss_tbl_invoices.sss_inv_id = sss_tbl_paymentreceived.sss_inv_id')
            ->where('sss_tbl_paymentreceived.sss_inv_id', $invId)
            ->orderBy('sss_pr_id', 'DESC');

        return DataTable::of($builder)
            ->add('action', function ($prid) {
                $btnStatus = $prid->sss_pr_balanceamt == 0 ? 'd-none d-lg-none d-md-none d-sm-none' : '';
                return '<a class="btn btn-sm ' . $btnStatus . '" onclick="edit_paymentdetail(' . $prid->sss_pr_id . ')"><i class="fa fa-edit"></i></a> | <a class="btn btn-danger btn-sm" onclick="delete_paymentdetail(' . $prid->sss_pr_id . ')"><i class="fa fa-trash"></i></a> | <a class="btn btn-primary btn-sm mt-1" href="' . base_url() . '/DealDisbursalChart/' . $prid->sss_pr_id . '"> DDC </a>';
            }, 'last')
            ->hide('sss_pr_id')
            ->toJson();
    }

    // // last module...
    // public function insert_paymentdetail()
    // {
    //     $validation = \Config\Services::validation();
    //     $this->validate([
    //         'sss_pr_tdsper' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Select TDS',
    //             ]
    //         ],
    //         'sss_pr_datereceived' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Please select received date of payment',
    //             ]
    //         ],
    //         'sss_pr_paymentmode' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Select Payment Mode'
    //             ]
    //         ],
    //         'sss_pr_amtreceived' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Enter Amount which you receive',
    //             ]
    //         ]
    //     ]);
    //     if ($validation->run() == FALSE) {
    //         $errors = $validation->getErrors();
    //         echo json_encode(['code' => 0, 'error' => $errors]);
    //     } else {
            
    //         // $dateComps = date_parse(date('Y-m-d'));
    //         $dateComps = date_parse($this->request->getVar('sss_pr_datereceived'));
    //         $year = $dateComps['year'];
    //         $month = $dateComps['month'];
    //         $sss_bb_transmonth = $month . '-' . $year;
    //         // payment received entry...
    //         $insertrecord = new Paymentreceived_m();
    //         $data = [
    //             'sss_inv_id' => $this->request->getVar('sss_inv_id'),
    //             'sss_pr_tdsper' => $this->request->getVar('sss_pr_tdsper'),
    //             'sss_pr_tdsamt' => $this->request->getVar('sss_pr_tdsamt'),
    //             'sss_pr_reffno' => $this->request->getVar('sss_pr_reffno'),
    //             'sss_pr_finalamt' =>  $this->request->getVar('sss_pr_finalamt'),
    //             'sss_pr_datereceived' => $this->request->getVar('sss_pr_datereceived'),
    //             'sss_pr_chequereceiveddate' => $this->request->getVar('sss_pr_chequereceiveddate'),
    //             'sss_pr_paymentmode' => $this->request->getVar('sss_pr_paymentmode'),
    //             'sss_pr_transreffno' => $this->request->getVar('sss_pr_transreffno'),
    //             'sss_pr_amtreceived' => $this->request->getVar('sss_pr_amtreceived'),
    //             'sss_pr_balanceamt' => $this->request->getVar('sss_pr_balanceamt'),
    //             'sss_pr_prev_balamt' => $this->request->getVar('sss_pr_prev_balamt'),
    //             'sss_pr_paymenttype' => $this->request->getVar('sss_pr_paymenttype'),
    //             'sss_sac_code_created_by' => session('userid'),
    //             'sss_pr_create_date' => date('Y-m-d')
    //         ];
    //         // echo "<pre>";print_r($data);echo "<br>";
            
    //         $prinsertid = $insertrecord->insert($data);

            
    //         // get bank and its opening balance...
    //         $invoices = new CreateInvoice_m();
    //         $invid = $this->request->getVar('sss_inv_id');

    //         $invoicerecord = $invoices->find($invid);
    //         $clientid = $invoicerecord['sss_inv_client_id'];

    //         //get client name
    //         $client = new Client_m();
    //         $clientname = $client->find($clientid);
            
    //         $lastopngBal = 0;
    //         $openingbalance = 0;
    //         $depositeamt = 0;

    //         $insertrecord->insertID();
    //         $bankid = $invoicerecord['sss_inv_bankid'];
    //         $getopeningbal = new Bankdetails_m();
    //         $openingbalance = $getopeningbal->find($bankid);
    //         $lastopngBal = $openingbalance['sss_ent_bank_acc_openingbal'];
            
    //          // value deposite to destination bank..
    //         $depositeamt = $this->request->getVar('sss_pr_amtreceived') + $lastopngBal;
    //         // echo $depositeamt;exit;
    //         $updatedepositebank = new Bankdetails_m();
    //         $depositebank = [
    //             'sss_ent_bank_acc_openingbal' => $depositeamt,
    //             'sss_ent_bank_last_updated_by' => session('userid'),
    //             'sss_ent_bank_updated_date' => date('Y-m-d')
    //         ];
    //         $updatedepositebank->update($bankid, $depositebank);
            
    //         $bbparticulars_pr = $clientname['sss_client_name'] . ' - ' . $invoicerecord['sss_inv_bill_no'] . ' - ' .  'Payment Received';
    //         $paymentreceivedamt = 0;
    //         // get next entries of bankbook of payment received.....
    //         $nextBankbookentries = new Bankbook_m();
    //         $getnextentriesby_transactiondate = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', $bankid)->where('sss_bb_transactiondate >', $this->request->getVar('sss_pr_datereceived'))->orderBy('sss_bb_transactiondate','ASC')->get()->getRow();
            
            
    //         // echo "<br>";
    //         // exit;
    //         //end..
            
    //         $isBankbook = new Bankbook_m();

    //         if ($getnextentriesby_transactiondate != '') 
    //         {
    //             $get_lastBalance_nextentry = $getnextentriesby_transactiondate->sss_bb_lastbalance; // next entries last balance....
                
    //             // echo "Last Balance f Next Entru -".$get_lastBalance_nextentry;
    //             // echo "<br>";
                
    //             $paymentreceivedamt = $this->request->getVar('sss_pr_amtreceived'); // payment received amount...
                
    //             $newCurrentBalance = $get_lastBalance_nextentry + $paymentreceivedamt; // calculate current balance ....
    //             // echo "New Current Balance -".$newCurrentBalance;
    //             // echo "<br>";
                
    //             $bankbookdata = [
    //                 // 'sss_pr_id' => 0,
    //                 'sss_pr_id' => $prinsertid,
    //                 'sss_bb_vendorid' => 'NA',
    //                 'sss_bb_vpid' => 'NA',
    //                 'sss_bb_clientid' => 'NA',
    //                 'sss_bb_invid' => $this->request->getVar('sss_inv_id'),
    //                 'sss_bb_particulars' => $bbparticulars_pr,
    //                 'sss_bb_sourcebankid' => '',
    //                 'sss_bb_destinationbankid' => $bankid,
    //                 'sss_bb_transamt' => $this->request->getVar('sss_pr_amtreceived'),
    //                 'sss_bb_finalamt' => $this->request->getVar('sss_pr_amtreceived'),
    //                 'sss_bb_transmode' => $this->request->getVar('sss_pr_paymentmode'),
    //                 'sss_bb_transreffno' => $this->request->getVar('sss_pr_transreffno'),
    //                 'sss_bb_transtype' => 'Deposit',
    //                 'sss_bb_iswithdrawl' => '',
    //                 'sss_bb_isdeposit' => $this->request->getVar('sss_pr_amtreceived'),
    //                 'sss_bb_transactiondate' => $this->request->getVar('sss_pr_datereceived'),
    //                 'sss_bb_transmonth' => $sss_bb_transmonth,
    //                 'sss_bb_lastbalance' => $get_lastBalance_nextentry,
    //                 'sss_bb_balance' => $newCurrentBalance,
    //                 'sss_allbankid' => $bankid,
    //                 'createdate' => date('Y-m-d')
    //             ];
    //             // echo "<pre>";print_r($bankbookdata);
                
    //             $isInserted = $isBankbook->insert($bankbookdata);
                
    //             // update all next balances....
    //             // exit;
    //             // echo "Date"; echo "<br>";
    //             // echo $this->request->getVar('sss_pr_datereceived');
    //             // echo "<br>";
                
    //             $allEntries = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', $bankid)->where('sss_bb_transactiondate >', $this->request->getVar('sss_pr_datereceived'))->orderBy('sss_bb_transactiondate','ASC')->get()->getResult();
    //             // exit;
    //             // echo "<pre>";print_r($allEntries);exit;
                
    //             foreach ($allEntries as $bb_entries) {
    //                 if ($bb_entries->sss_bb_transtype == 'Deposit') {
    //                     $Bb_id = $bb_entries->sss_bankbook_id;
    //                     $lastBalance = $bb_entries->sss_bb_lastbalance;
                        
    //                     // echo "BankBook Date -".$bb_entries->sss_bb_transactiondate;
                        
    //                     // echo "Last Balance -".$lastBalance;
    //                     // echo "<br>";
                        
    //                     // echo "Amount Added -".$paymentreceivedamt; echo "<br>";
    //                     $newLastBalance = $lastBalance + $paymentreceivedamt;
    //                     // echo "New Last Balance -".$newLastBalance;
    //                     // echo "<br>";
    //                     $newcurrentBalance = $newLastBalance + $bb_entries->sss_bb_transamt;
                       
    //                     $new_amountBalances = [
    //                         'sss_bb_lastbalance' => $newLastBalance,
    //                         'sss_bb_balance' => $newcurrentBalance,
    //                         'updatedate	' => date('Y-m-d')
    //                     ];
    //                     // echo "a";
    //                     // echo "<pre>";print_r($new_amountBalances);
    //                     $nextBankbookentries->update($Bb_id, $new_amountBalances);
    //                 } else {

    //                     $Bb_id = $bb_entries->sss_bankbook_id;
    //                     $lastBalance = $bb_entries->sss_bb_lastbalance;
    //                     $newLastBalance = $lastBalance + $paymentreceivedamt;
    //                     $newcurrentBalance = $newLastBalance - $bb_entries->sss_bb_transamt;
    //                     $new_amountBalances = [
    //                         'sss_bb_lastbalance' => $newLastBalance,
    //                         'sss_bb_balance' => $newcurrentBalance,
    //                         'updatedate	' => date('Y-m-d')
    //                     ];
    //                     // echo "Withdrawl";
    //                     // echo "<pre>";print_r($new_amountBalances);exit;
    //                     $nextBankbookentries->update($Bb_id, $new_amountBalances);
    //                 }
    //             }
                
    //         } 
    //         else {
                
                
    //             $bankbookdata1 = [
    //                 'sss_pr_id' => $prinsertid,
    //                 'sss_bb_vendorid' => 'NA',
    //                 'sss_bb_vpid' => 'NA',
    //                 'sss_bb_clientid' => 'NA',
    //                 'sss_bb_invid' => $this->request->getVar('sss_inv_id'),
    //                 'sss_bb_particulars' => $bbparticulars_pr,
    //                 'sss_bb_sourcebankid' => '',
    //                 'sss_bb_destinationbankid' => $bankid,
    //                 'sss_bb_transamt' => $this->request->getVar('sss_pr_amtreceived'),
    //                 'sss_bb_finalamt' => $this->request->getVar('sss_pr_amtreceived'),
    //                 'sss_bb_transmode' => $this->request->getVar('sss_pr_paymentmode'),
    //                 'sss_bb_transreffno' => $this->request->getVar('sss_pr_transreffno'),
    //                 'sss_bb_transtype' => 'Deposit',
    //                 'sss_bb_iswithdrawl' => '',
    //                 'sss_bb_isdeposit' => $this->request->getVar('sss_pr_amtreceived'),
    //                 'sss_bb_transactiondate' => $this->request->getVar('sss_pr_datereceived'),
    //                 'sss_bb_transmonth' => $sss_bb_transmonth,
    //                 'sss_bb_lastbalance' => $lastopngBal,
    //                 'sss_bb_balance' => $depositeamt,
    //                 'sss_allbankid' => $bankid,
    //                 'createdate' => date('Y-m-d')
    //             ];
                
    //             $isInserted = $isBankbook->insert($bankbookdata1);
    //         }



    //         // rearrange all balance on bankbook entries...

    //         if (!empty($isInserted)) {
    //             echo json_encode(array("status" => true, "message" => 'Payment Details Inserted'));
    //         } else {
    //             echo json_encode(array("status" => false, "message" => 'Something error while inserting Payment Details'));
    //         }
    //     }
    // }
    
    // without month and without opening month...
    // public function insert_paymentdetail()
    // {
    //     $validation = \Config\Services::validation();
    //     $this->validate([
    //         'sss_pr_tdsper' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Select TDS',
    //             ]
    //         ],
    //         'sss_pr_datereceived' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Please select received date of payment',
    //             ]
    //         ],
    //         'sss_pr_paymentmode' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Select Payment Mode'
    //             ]
    //         ],
    //         'sss_pr_amtreceived' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Enter Amount which you receive',
    //             ]
    //         ]
    //     ]);
    //     if ($validation->run() == FALSE) {
    //         $errors = $validation->getErrors();
    //         echo json_encode(['code' => 0, 'error' => $errors]);
    //     } else {

    //         // $dateComps = date_parse(date('Y-m-d'));
    //         $dateComps = date_parse($this->request->getVar('sss_pr_datereceived'));
    //         $year = $dateComps['year'];
    //         $month = $dateComps['month'];
    //         $sss_bb_transmonth = $month . '-' . $year;

    //         // calcualte next month....
    //         $nxtyear = $year;
    //         $nxtmonth = $month + 1;
    //         $nextMonthwithdate = $nxtmonth . '-' . $nxtyear;

    //         // payment received entry...
    //         $insertrecord = new Paymentreceived_m();
    //         $data = [
    //             'sss_inv_id' => $this->request->getVar('sss_inv_id'),
    //             'sss_pr_tdsper' => $this->request->getVar('sss_pr_tdsper'),
    //             'sss_pr_tdsamt' => $this->request->getVar('sss_pr_tdsamt'),
    //             'sss_pr_reffno' => $this->request->getVar('sss_pr_reffno'),
    //             'sss_pr_finalamt' =>  $this->request->getVar('sss_pr_finalamt'),
    //             'sss_pr_datereceived' => $this->request->getVar('sss_pr_datereceived'),
    //             'sss_pr_chequereceiveddate' => $this->request->getVar('sss_pr_chequereceiveddate'),
    //             'sss_pr_paymentmode' => $this->request->getVar('sss_pr_paymentmode'),
    //             'sss_pr_transreffno' => $this->request->getVar('sss_pr_transreffno'),
    //             'sss_pr_amtreceived' => $this->request->getVar('sss_pr_amtreceived'),
    //             'sss_pr_balanceamt' => $this->request->getVar('sss_pr_balanceamt'),
    //             'sss_pr_prev_balamt' => $this->request->getVar('sss_pr_prev_balamt'),
    //             'sss_pr_paymenttype' => $this->request->getVar('sss_pr_paymenttype'),
    //             'sss_sac_code_created_by' => session('userid'),
    //             'sss_pr_create_date' => date('Y-m-d')
    //         ];
    //         // echo "<pre>";print_r($data);echo "<br>";

    //         $prinsertid = $insertrecord->insert($data);


    //         // get bank and its opening balance...
    //         $invoices = new CreateInvoice_m();
    //         $invid = $this->request->getVar('sss_inv_id');

    //         $invoicerecord = $invoices->find($invid);
    //         $clientid = $invoicerecord['sss_inv_client_id'];

    //         //get client name
    //         $client = new Client_m();
    //         $clientname = $client->find($clientid);

    //         $lastopngBal = 0;
    //         $openingbalance = 0;
    //         $depositeamt = 0;

    //         $insertrecord->insertID();
    //         $bankid = $invoicerecord['sss_inv_bankid'];
    //         $getopeningbal = new Bankdetails_m();
    //         $openingbalance = $getopeningbal->find($bankid);
    //         $lastopngBal = $openingbalance['sss_ent_bank_acc_openingbal'];

    //         // value deposite to destination bank..
    //         $depositeamt = $this->request->getVar('sss_pr_amtreceived') + $lastopngBal;

    //         // echo $depositeamt;exit;

    //         $updatedepositebank = new Bankdetails_m();
    //         $depositebank = [
    //             'sss_ent_bank_acc_openingbal' => $depositeamt,
    //             'sss_ent_bank_last_updated_by' => session('userid'),
    //             'sss_ent_bank_updated_date' => date('Y-m-d')
    //         ];
    //         $updatedepositebank->update($bankid, $depositebank);

    //         $bbparticulars_pr = $clientname['sss_client_name'] . ' - ' . $invoicerecord['sss_inv_bill_no'] . ' - ' .  'Payment Received';


    //         $new_next_month  =
    //             $paymentreceivedamt = 0;
    //         // get next entries of bankbook of payment received.....
    //         $nextBankbookentries = new Bankbook_m();
    //         $getnextentriesby_transactiondate = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', $bankid)->where('sss_bb_transactiondate >', $this->request->getVar('sss_pr_datereceived'))->orderBy('sss_bb_transactiondate', 'ASC')->get()->getRow();

    //         //end..

    //         $isBankbook = new Bankbook_m();

    //         if ($getnextentriesby_transactiondate != '') {

    //             $get_lastBalance_nextentry = $getnextentriesby_transactiondate->sss_bb_lastbalance; // next entries last balance....

    //             $paymentreceivedamt = $this->request->getVar('sss_pr_amtreceived'); // payment received amount...

    //             $newCurrentBalance = $get_lastBalance_nextentry + $paymentreceivedamt; // calculate current balance ....

    //             $bankbookdata = [
    //                 // 'sss_pr_id' => 0,
    //                 'sss_pr_id' => $prinsertid,
    //                 'sss_bb_vendorid' => 'NA',
    //                 'sss_bb_vpid' => 'NA',
    //                 'sss_bb_clientid' => 'NA',
    //                 'sss_bb_invid' => $this->request->getVar('sss_inv_id'),
    //                 'sss_bb_particulars' => $bbparticulars_pr,
    //                 'sss_bb_sourcebankid' => '',
    //                 'sss_bb_destinationbankid' => $bankid,
    //                 'sss_bb_transamt' => $this->request->getVar('sss_pr_amtreceived'),
    //                 'sss_bb_finalamt' => $this->request->getVar('sss_pr_amtreceived'),
    //                 'sss_bb_transmode' => $this->request->getVar('sss_pr_paymentmode'),
    //                 'sss_bb_transreffno' => $this->request->getVar('sss_pr_transreffno'),
    //                 'sss_bb_transtype' => 'Deposit',
    //                 'sss_bb_iswithdrawl' => '',
    //                 'sss_bb_isdeposit' => $this->request->getVar('sss_pr_amtreceived'),
    //                 'sss_bb_transactiondate' => $this->request->getVar('sss_pr_datereceived'),
    //                 'sss_bb_transmonth' => $sss_bb_transmonth,
    //                 'sss_bb_lastbalance' => $get_lastBalance_nextentry,
    //                 'sss_bb_balance' => $newCurrentBalance,
    //                 'sss_allbankid' => $bankid,
    //                 'createdate' => date('Y-m-d')
    //             ];
    //             // echo "<pre>";print_r($bankbookdata);
    //             $isInserted = $isBankbook->insert($bankbookdata);

    //             // update all next balances....
    //             // exit;
           

    //             $allEntries = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', $bankid)->where('sss_bb_transactiondate >', $this->request->getVar('sss_pr_datereceived'))->orderBy('sss_bb_transactiondate', 'ASC')->get()->getResult();
            
    //             $MonthsBalances_m = new MonthsBalances_m();

    //             $getValueofMonthBalance = $MonthsBalances_m->where('bankid', $bankid)->where('balancemonth', $nextMonthwithdate)->get()->getRow();
    //             $opngmonthbal_id = $getValueofMonthBalance->id;

    //             foreach ($allEntries as $bb_entries) {
    //                 if ($bb_entries->sss_bb_transtype == 'Deposit') {
    //                     $Bb_id = $bb_entries->sss_bankbook_id;
    //                     $lastBalance = $bb_entries->sss_bb_lastbalance;
    //                     $newLastBalance = $lastBalance + $paymentreceivedamt;
    //                     $newcurrentBalance = $newLastBalance + $bb_entries->sss_bb_transamt;

    //                     $new_amountBalances = [
    //                         'sss_bb_lastbalance' => $newLastBalance,
    //                         'sss_bb_balance' => $newcurrentBalance,
    //                         'updatedate	' => date('Y-m-d')
    //                     ];
    //                     $nextBankbookentries->update($Bb_id, $new_amountBalances);


    //                     // update opening month clsng or opening bal......
    //                     // update opening months balance...
    //                     $monthsBalancesModel = new MonthsBalances_m();
    //                     $updateData = [
    //                         'openingbal' => $newcurrentBalance,
    //                     ];
    //                     $monthsBalancesModel->update($opngmonthbal_id, $updateData);
    //                     //  end
    //                 } else {

    //                     $Bb_id = $bb_entries->sss_bankbook_id;
    //                     $lastBalance = $bb_entries->sss_bb_lastbalance;
    //                     $newLastBalance = $lastBalance + $paymentreceivedamt;
    //                     $newcurrentBalance = $newLastBalance - $bb_entries->sss_bb_transamt;
    //                     $new_amountBalances = [
    //                         'sss_bb_lastbalance' => $newLastBalance,
    //                         'sss_bb_balance' => $newcurrentBalance,
    //                         'updatedate	' => date('Y-m-d')
    //                     ];
    //                     $nextBankbookentries->update($Bb_id, $new_amountBalances);

    //                     // update Balance.....
    //                     $monthsBalancesModel = new MonthsBalances_m();
    //                     $updateData = [
    //                         'openingbal' => $newcurrentBalance,
    //                     ];
    //                     $monthsBalancesModel->update($opngmonthbal_id, $updateData);
    //                 }
    //             }
    //         } else {


    //             $bankbookdata1 = [
    //                 'sss_pr_id' => $prinsertid,
    //                 'sss_bb_vendorid' => 'NA',
    //                 'sss_bb_vpid' => 'NA',
    //                 'sss_bb_clientid' => 'NA',
    //                 'sss_bb_invid' => $this->request->getVar('sss_inv_id'),
    //                 'sss_bb_particulars' => $bbparticulars_pr,
    //                 'sss_bb_sourcebankid' => '',
    //                 'sss_bb_destinationbankid' => $bankid,
    //                 'sss_bb_transamt' => $this->request->getVar('sss_pr_amtreceived'),
    //                 'sss_bb_finalamt' => $this->request->getVar('sss_pr_amtreceived'),
    //                 'sss_bb_transmode' => $this->request->getVar('sss_pr_paymentmode'),
    //                 'sss_bb_transreffno' => $this->request->getVar('sss_pr_transreffno'),
    //                 'sss_bb_transtype' => 'Deposit',
    //                 'sss_bb_iswithdrawl' => '',
    //                 'sss_bb_isdeposit' => $this->request->getVar('sss_pr_amtreceived'),
    //                 'sss_bb_transactiondate' => $this->request->getVar('sss_pr_datereceived'),
    //                 'sss_bb_transmonth' => $sss_bb_transmonth,
    //                 'sss_bb_lastbalance' => $lastopngBal,
    //                 'sss_bb_balance' => $depositeamt,
    //                 'sss_allbankid' => $bankid,
    //                 'createdate' => date('Y-m-d')
    //             ];

    //             $isInserted = $isBankbook->insert($bankbookdata1);
    //         }

    //         // rearrange all balance on bankbook entries...

    //         if (!empty($isInserted)) {
    //             echo json_encode(array("status" => true, "message" => 'Payment Details Inserted'));
    //         } else {
    //             echo json_encode(array("status" => false, "message" => 'Something error while inserting Payment Details'));
    //         }
    //     }
    // }
    
    public function insert_paymentdetail()
    {
        $validation = \Config\Services::validation();
        $this->validate([
            'sss_pr_tdsper' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Select TDS',
                ]
            ],
            'sss_pr_datereceived' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Please select received date of payment',
                ]
            ],
            'sss_pr_paymentmode' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Select Payment Mode'
                ]
            ],
            'sss_pr_amtreceived' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Enter Amount which you receive',
                ]
            ]
        ]);
        if ($validation->run() == FALSE) {
            $errors = $validation->getErrors();
            echo json_encode(['code' => 0, 'error' => $errors]);
        } else {

            // $dateComps = date_parse(date('Y-m-d'));
            $dateComps = date_parse($this->request->getVar('sss_pr_datereceived'));
            $year = $dateComps['year'];
            $month = $dateComps['month'];
            $sss_bb_transmonth = $month . '-' . $year;

            // calcualte next month....
            $nxtyear = $year;
            $nxtmonth = $month + 1;
            $nextMonthwithdate = $nxtmonth . '-' . $nxtyear;

            // payment received entry...
            $insertrecord = new Paymentreceived_m();

            $data = [
                'sss_inv_id' => $this->request->getVar('sss_inv_id'),
                'sss_pr_tdsper' => $this->request->getVar('sss_pr_tdsper'),
                'sss_pr_tdsamt' => $this->request->getVar('sss_pr_tdsamt'),
                'sss_pr_reffno' => $this->request->getVar('sss_pr_reffno'),
                'sss_pr_finalamt' =>  $this->request->getVar('sss_pr_finalamt'),
                'sss_pr_datereceived' => $this->request->getVar('sss_pr_datereceived'),
                'sss_pr_chequereceiveddate' => $this->request->getVar('sss_pr_chequereceiveddate'),
                'sss_pr_paymentmode' => $this->request->getVar('sss_pr_paymentmode'),
                'sss_pr_transreffno' => $this->request->getVar('sss_pr_transreffno'),
                'sss_pr_amtreceived' => $this->request->getVar('sss_pr_amtreceived'),
                'sss_pr_balanceamt' => $this->request->getVar('sss_pr_balanceamt'),
                'sss_pr_prev_balamt' => $this->request->getVar('sss_pr_prev_balamt'),
                'sss_pr_paymenttype' => $this->request->getVar('sss_pr_paymenttype'),
                'sss_sac_code_created_by' => session('userid'),
                'sss_pr_create_date' => date('Y-m-d')
            ];

            // echo "<pre>";print_r($data);echo "<br>";
            $prinsertid = $insertrecord->insert($data);

            // get bank and its opening balance...
            $invoices = new CreateInvoice_m();
            $invid = $this->request->getVar('sss_inv_id');

            $invoicerecord = $invoices->find($invid);
            $clientid = $invoicerecord['sss_inv_client_id'];

            //get client name
            $client = new Client_m();
            $clientname = $client->find($clientid);

            $lastopngBal = 0;
            $openingbalance = 0;
            $depositeamt = 0;

            $insertrecord->insertID();
            $bankid = $invoicerecord['sss_inv_bankid'];

            $getopeningbal = new Bankdetails_m();
            $openingbalance = $getopeningbal->find($bankid);
            $lastopngBal = $openingbalance['sss_ent_bank_acc_openingbal'];

            // value deposite to destination bank..
            $depositeamt = $this->request->getVar('sss_pr_amtreceived') + $lastopngBal;

            // update current bank info.....
            $updatedepositebank = new Bankdetails_m();
            $depositebank = [
                'sss_ent_bank_acc_openingbal' => $depositeamt,
                'sss_ent_bank_last_updated_by' => session('userid'),
                'sss_ent_bank_updated_date' => date('Y-m-d')
            ];
            $updatedepositebank->update($bankid, $depositebank);

            // get nextmonths bank by balancemonth and bankid....
            $MonthsBalances_m = new MonthsBalances_m();
            $getValueofMonthBalance = $MonthsBalances_m->where('bankid', $bankid)->where('balancemonth', $nextMonthwithdate)->get()->getRow();
            
            $opngmonthbal_id = $getValueofMonthBalance->id;
            // update next bank info.....
            $deposite_nextmonth = [
                'openingbal' => $depositeamt,
            ];
            $MonthsBalances_m->update($opngmonthbal_id, $deposite_nextmonth);

            
            $bbparticulars_pr = $clientname['sss_client_name'] . ' - ' . $invoicerecord['sss_inv_bill_no'] . ' - ' .  'Payment Received';

            $paymentreceivedamt = 0;
            // get next entries of bankbook of payment received.....
            $nextBankbookentries = new Bankbook_m();
            $getnextentriesby_transactiondate = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', $bankid)->where('sss_bb_transactiondate >', $this->request->getVar('sss_pr_datereceived'))->orderBy('sss_bb_transactiondate', 'ASC')->get()->getRow();

            $isBankbook = new Bankbook_m();

            if ($getnextentriesby_transactiondate != '') {

                $get_lastBalance_nextentry = $getnextentriesby_transactiondate->sss_bb_lastbalance; // next entries last balance....

                $paymentreceivedamt = $this->request->getVar('sss_pr_amtreceived'); // payment received amount...

                $newCurrentBalance = $get_lastBalance_nextentry + $paymentreceivedamt; // calculate current balance ....

                $bankbookdata = [
                    // 'sss_pr_id' => 0,
                    'sss_pr_id' => $prinsertid,
                    'sss_bb_vendorid' => 'NA',
                    'sss_bb_vpid' => 'NA',
                    'sss_bb_clientid' => 'NA',
                    'sss_bb_invid' => $this->request->getVar('sss_inv_id'),
                    'sss_bb_particulars' => $bbparticulars_pr,
                    'sss_bb_sourcebankid' => '',
                    'sss_bb_destinationbankid' => $bankid,
                    'sss_bb_transamt' => $this->request->getVar('sss_pr_amtreceived'),
                    'sss_bb_finalamt' => $this->request->getVar('sss_pr_amtreceived'),
                    'sss_bb_transmode' => $this->request->getVar('sss_pr_paymentmode'),
                    'sss_bb_transreffno' => $this->request->getVar('sss_pr_transreffno'),
                    'sss_bb_transtype' => 'Deposit',
                    'sss_bb_iswithdrawl' => '',
                    'sss_bb_isdeposit' => $this->request->getVar('sss_pr_amtreceived'),
                    'sss_bb_transactiondate' => $this->request->getVar('sss_pr_datereceived'),
                    'sss_bb_transmonth' => $sss_bb_transmonth,
                    'sss_bb_lastbalance' => $get_lastBalance_nextentry,
                    'sss_bb_balance' => $newCurrentBalance,
                    'sss_allbankid' => $bankid,
                    'createdate' => date('Y-m-d')
                ];
                // echo "<pre>";print_r($bankbookdata);
                $isInserted = $isBankbook->insert($bankbookdata);

                $allEntries = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', $bankid)->where('sss_bb_transactiondate >', $this->request->getVar('sss_pr_datereceived'))->orderBy('sss_bb_transactiondate', 'ASC')->get()->getResult();
                // exit;
                // echo "<pre>";print_r($allEntries);exit;

                foreach ($allEntries as $bb_entries) {
                    if ($bb_entries->sss_bb_transtype == 'Deposit') {
                        $Bb_id = $bb_entries->sss_bankbook_id;
                        $lastBalance = $bb_entries->sss_bb_lastbalance;
                        $newLastBalance = $lastBalance + $paymentreceivedamt;
                        $newcurrentBalance = $newLastBalance + $bb_entries->sss_bb_transamt;

                        $new_amountBalances = [
                            'sss_bb_lastbalance' => $newLastBalance,
                            'sss_bb_balance' => $newcurrentBalance,
                            'updatedate	' => date('Y-m-d')
                        ];
                        $nextBankbookentries->update($Bb_id, $new_amountBalances);

                        // update opening month clsng or opening bal......
                        // update opening months balance...
                        $monthsBalancesModel = new MonthsBalances_m();
                        $updateData = [
                            'openingbal' => $newcurrentBalance,
                        ];
                        $monthsBalancesModel->update($opngmonthbal_id, $updateData);

                        //  end
                    } else {

                        $Bb_id = $bb_entries->sss_bankbook_id;
                        $lastBalance = $bb_entries->sss_bb_lastbalance;
                        $newLastBalance = $lastBalance + $paymentreceivedamt;
                        $newcurrentBalance = $newLastBalance - $bb_entries->sss_bb_transamt;
                        $new_amountBalances = [
                            'sss_bb_lastbalance' => $newLastBalance,
                            'sss_bb_balance' => $newcurrentBalance,
                            'updatedate	' => date('Y-m-d')
                        ];
                        $nextBankbookentries->update($Bb_id, $new_amountBalances);

                        // update Balance.....
                        $monthsBalancesModel = new MonthsBalances_m();
                        $updateData = [
                            'openingbal' => $newcurrentBalance,
                        ];
                        $monthsBalancesModel->update($opngmonthbal_id, $updateData);

                    }
                }


            } else {

                $bankbookdata1 = [
                    'sss_pr_id' => $prinsertid,
                    'sss_bb_vendorid' => 'NA',
                    'sss_bb_vpid' => 'NA',
                    'sss_bb_clientid' => 'NA',
                    'sss_bb_invid' => $this->request->getVar('sss_inv_id'),
                    'sss_bb_particulars' => $bbparticulars_pr,
                    'sss_bb_sourcebankid' => '',
                    'sss_bb_destinationbankid' => $bankid,
                    'sss_bb_transamt' => $this->request->getVar('sss_pr_amtreceived'),
                    'sss_bb_finalamt' => $this->request->getVar('sss_pr_amtreceived'),
                    'sss_bb_transmode' => $this->request->getVar('sss_pr_paymentmode'),
                    'sss_bb_transreffno' => $this->request->getVar('sss_pr_transreffno'),
                    'sss_bb_transtype' => 'Deposit',
                    'sss_bb_iswithdrawl' => '',
                    'sss_bb_isdeposit' => $this->request->getVar('sss_pr_amtreceived'),
                    'sss_bb_transactiondate' => $this->request->getVar('sss_pr_datereceived'),
                    'sss_bb_transmonth' => $sss_bb_transmonth,
                    'sss_bb_lastbalance' => $lastopngBal,
                    'sss_bb_balance' => $depositeamt,
                    'sss_allbankid' => $bankid,
                    'createdate' => date('Y-m-d')
                ];

                $isInserted = $isBankbook->insert($bankbookdata1);
            }

            // rearrange all balance on bankbook entries...

            if (!empty($isInserted)) {
                echo json_encode(array("status" => true, "message" => 'Payment Details Inserted'));
            } else {
                echo json_encode(array("status" => false, "message" => 'Something error while inserting Payment Details'));
            }
        }
    }
    
    
    // with month...
    // public function insert_paymentdetail()
    // {
    //     $validation = \Config\Services::validation();
    //     $this->validate([
    //         'sss_pr_tdsper' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Select TDS',
    //             ]
    //         ],
    //         'sss_pr_datereceived' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Please select received date of payment',
    //             ]
    //         ],
    //         'sss_pr_paymentmode' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Select Payment Mode'
    //             ]
    //         ],
    //         'sss_pr_amtreceived' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Enter Amount which you receive',
    //             ]
    //         ]
    //     ]);
    //     if ($validation->run() == FALSE) {
    //         $errors = $validation->getErrors();
    //         echo json_encode(['code' => 0, 'error' => $errors]);
    //     } else {
            
    //         // $dateComps = date_parse(date('Y-m-d'));
    //         $dateComps = date_parse($this->request->getVar('sss_pr_datereceived'));
    //         $year = $dateComps['year'];
    //         $month = $dateComps['month'];
    //         $sss_bb_transmonth = $month . '-' . $year;
    //         // payment received entry...
    //         $insertrecord = new Paymentreceived_m();
    //         $data = [
    //             'sss_inv_id' => $this->request->getVar('sss_inv_id'),
    //             'sss_pr_tdsper' => $this->request->getVar('sss_pr_tdsper'),
    //             'sss_pr_tdsamt' => $this->request->getVar('sss_pr_tdsamt'),
    //             'sss_pr_reffno' => $this->request->getVar('sss_pr_reffno'),
    //             'sss_pr_finalamt' =>  $this->request->getVar('sss_pr_finalamt'),
    //             'sss_pr_datereceived' => $this->request->getVar('sss_pr_datereceived'),
    //             'sss_pr_chequereceiveddate' => $this->request->getVar('sss_pr_chequereceiveddate'),
    //             'sss_pr_paymentmode' => $this->request->getVar('sss_pr_paymentmode'),
    //             'sss_pr_transreffno' => $this->request->getVar('sss_pr_transreffno'),
    //             'sss_pr_amtreceived' => $this->request->getVar('sss_pr_amtreceived'),
    //             'sss_pr_balanceamt' => $this->request->getVar('sss_pr_balanceamt'),
    //             'sss_pr_prev_balamt' => $this->request->getVar('sss_pr_prev_balamt'),
    //             'sss_pr_paymenttype' => $this->request->getVar('sss_pr_paymenttype'),
    //             'sss_sac_code_created_by' => session('userid'),
    //             'sss_pr_create_date' => date('Y-m-d')
    //         ];
    //         // echo "<pre>";print_r($data);echo "<br>";
    //         $prinsertid = $insertrecord->insert($data);
            
    //         // get bank and its opening balance...
    //         $invoices = new CreateInvoice_m();
    //         $invid = $this->request->getVar('sss_inv_id');

    //         $invoicerecord = $invoices->find($invid);
    //         $clientid = $invoicerecord['sss_inv_client_id'];

    //         //get client name
    //         $client = new Client_m();
    //         $clientname = $client->find($clientid);
            
    //         $lastopngBal = 0;
    //         $openingbalance = 0;
    //         $depositeamt = 0;

    //         $insertrecord->insertID();
    //         $bankid = $invoicerecord['sss_inv_bankid'];
    //         $getopeningbal = new Bankdetails_m();
    //         $openingbalance = $getopeningbal->find($bankid);
    //         $lastopngBal = $openingbalance['sss_ent_bank_acc_openingbal'];
            
    //          // value deposite to destination bank..
    //         $depositeamt = $this->request->getVar('sss_pr_amtreceived') + $lastopngBal;
    //         // update current balance..bankinfo table
    //         $updatedepositebank = new Bankdetails_m();
    //         $depositebank = [
    //             'sss_ent_bank_acc_openingbal' => $depositeamt,
    //             'sss_ent_bank_last_updated_by' => session('userid'),
    //             'sss_ent_bank_updated_date' => date('Y-m-d')
    //         ];
    //         $updatedepositebank->update($bankid, $depositebank);
            
    //         $bbparticulars_pr = $clientname['sss_client_name'] . ' - ' . $invoicerecord['sss_inv_bill_no'] . ' - ' .  'Payment Received';
            
    //         $paymentreceivedamt = 0;
    //         // get next entries of bankbook of payment received.....

    //         $nextBankbookentries = new Bankbook_m();
    //         $getnextentriesby_transactiondate = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', $bankid)->where('sss_bb_transactiondate >', $this->request->getVar('sss_pr_datereceived'))->where('sss_bb_transmonth',$sss_bb_transmonth)->orderBy('sss_bb_transactiondate','ASC')->get()->getRow();
    //         $isBankbook = new Bankbook_m();

    //         if ($getnextentriesby_transactiondate != '') 
    //         {
    //             $get_lastBalance_nextentry = $getnextentriesby_transactiondate->sss_bb_lastbalance; // next entries last balance....
    //             // echo "Last Balance f Next Entru -".$get_lastBalance_nextentry;
    //             // echo "<br>";
    //             $paymentreceivedamt = $this->request->getVar('sss_pr_amtreceived'); // payment received amount...
    //             $newCurrentBalance = $get_lastBalance_nextentry + $paymentreceivedamt; // calculate current balance ....
    //             // echo "New Current Balance -".$newCurrentBalance;
    //             // echo "<br>";

    //             $bankbookdata = [
    //                 // 'sss_pr_id' => 0,
    //                 'sss_pr_id' => $prinsertid,
    //                 'sss_bb_vendorid' => 'NA',
    //                 'sss_bb_vpid' => 'NA',
    //                 'sss_bb_clientid' => 'NA',
    //                 'sss_bb_invid' => $this->request->getVar('sss_inv_id'),
    //                 'sss_bb_particulars' => $bbparticulars_pr,
    //                 'sss_bb_sourcebankid' => '',
    //                 'sss_bb_destinationbankid' => $bankid,
    //                 'sss_bb_transamt' => $this->request->getVar('sss_pr_amtreceived'),
    //                 'sss_bb_finalamt' => $this->request->getVar('sss_pr_amtreceived'),
    //                 'sss_bb_transmode' => $this->request->getVar('sss_pr_paymentmode'),
    //                 'sss_bb_transreffno' => $this->request->getVar('sss_pr_transreffno'),
    //                 'sss_bb_transtype' => 'Deposit',
    //                 'sss_bb_iswithdrawl' => '',
    //                 'sss_bb_isdeposit' => $this->request->getVar('sss_pr_amtreceived'),
    //                 'sss_bb_transactiondate' => $this->request->getVar('sss_pr_datereceived'),
    //                 'sss_bb_transmonth' => $sss_bb_transmonth,
    //                 'sss_bb_lastbalance' => $get_lastBalance_nextentry,
    //                 'sss_bb_balance' => $newCurrentBalance,
    //                 'sss_allbankid' => $bankid,
    //                 'createdate' => date('Y-m-d')
    //             ];
                
    //             // echo "<pre>";print_r($bankbookdata);
                
    //             $isInserted = $isBankbook->insert($bankbookdata);
                
    //             $allEntries = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', $bankid)->where('sss_bb_transactiondate >', $this->request->getVar('sss_pr_datereceived'))->orderBy('sss_bb_transactiondate','ASC')->where('sss_bb_transmonth',$sss_bb_transmonth)->get()->getResult();
                
    //             foreach ($allEntries as $bb_entries) {
    //                 if ($bb_entries->sss_bb_transtype == 'Deposit') {
    //                     $Bb_id = $bb_entries->sss_bankbook_id;
    //                     $lastBalance = $bb_entries->sss_bb_lastbalance;
    //                     $newLastBalance = $lastBalance + $paymentreceivedamt;
    //                     $newcurrentBalance = $newLastBalance + $bb_entries->sss_bb_transamt;
                       
    //                     $new_amountBalances = [
    //                         'sss_bb_lastbalance' => $newLastBalance,
    //                         'sss_bb_balance' => $newcurrentBalance,
    //                         'updatedate	' => date('Y-m-d')
    //                     ];
    //                     $nextBankbookentries->update($Bb_id, $new_amountBalances);
    //                 } else {

    //                     $Bb_id = $bb_entries->sss_bankbook_id;
    //                     $lastBalance = $bb_entries->sss_bb_lastbalance;
    //                     $newLastBalance = $lastBalance + $paymentreceivedamt;
    //                     $newcurrentBalance = $newLastBalance - $bb_entries->sss_bb_transamt;
    //                     $new_amountBalances = [
    //                         'sss_bb_lastbalance' => $newLastBalance,
    //                         'sss_bb_balance' => $newcurrentBalance,
    //                         'updatedate	' => date('Y-m-d')
    //                     ];
    //                     $nextBankbookentries->update($Bb_id, $new_amountBalances);
    //                 }
    //             }

    //             $MonthsBalances_m = new MonthsBalances_m();
    //             $getValueofMonthBalance = $MonthsBalances_m->where('bankid',$bankid)->where('balancemonth',$sss_bb_transmonth)->get()->getRow();
                
    //             $opngmonthbal_id = $getValueofMonthBalance->id;
                
    //             $updateData_nextentries = [
    //                 'clsngbalance' => $newcurrentBalance,
    //             ];
    //             $MonthsBalances_m->update($opngmonthbal_id, $updateData_nextentries);
    //         } 
    //         else {
    //             // get opening months balance of banks for a particular month...
    //             $currentMonths_lastBalance = 0;
    //             $currentMonths_currentamt = 0;

    //             $MonthsBalances_m = new MonthsBalances_m();
    //             $getValueofMonthBalance = $MonthsBalances_m->where('bankid',$bankid)->where('balancemonth',$sss_bb_transmonth)->get()->getRow();
                
    //             $opngmonthbal_id = $getValueofMonthBalance->id;
    //             $currentMonths_clsngBalance = $getValueofMonthBalance->clsngbalance;  
                
    //             $amtrcv = $this->request->getVar('sss_pr_amtreceived');
                
    //             if($currentMonths_clsngBalance == '')
    //             {
    //                 $currentMonths_lastBalance = $getValueofMonthBalance->openingbal;
    //                 $currentMonths_currentamt = $currentMonths_lastBalance + $amtrcv;
    //             }
    //             else{
    //                 $currentMonths_lastBalance = $getValueofMonthBalance->clsngbalance;
    //                 $currentMonths_currentamt = $currentMonths_lastBalance + $amtrcv;
    //             }
                
    //             $monthsBalancesModel = new MonthsBalances_m();
               
    //             $updateData = [
    //                 'clsngbalance' => $currentMonths_currentamt,
    //             ];
    //             $monthsBalancesModel->update($opngmonthbal_id, $updateData);

    //             $bankbookdata1 = [
    //                 'sss_pr_id' => $prinsertid,
    //                 'sss_bb_vendorid' => 'NA',
    //                 'sss_bb_vpid' => 'NA',
    //                 'sss_bb_clientid' => 'NA',
    //                 'sss_bb_invid' => $this->request->getVar('sss_inv_id'),
    //                 'sss_bb_particulars' => $bbparticulars_pr,
    //                 'sss_bb_sourcebankid' => '',
    //                 'sss_bb_destinationbankid' => $bankid,
    //                 'sss_bb_transamt' => $this->request->getVar('sss_pr_amtreceived'),
    //                 'sss_bb_finalamt' => $this->request->getVar('sss_pr_amtreceived'),
    //                 'sss_bb_transmode' => $this->request->getVar('sss_pr_paymentmode'),
    //                 'sss_bb_transreffno' => $this->request->getVar('sss_pr_transreffno'),
    //                 'sss_bb_transtype' => 'Deposit',
    //                 'sss_bb_iswithdrawl' => '',
    //                 'sss_bb_isdeposit' => $this->request->getVar('sss_pr_amtreceived'),
    //                 'sss_bb_transactiondate' => $this->request->getVar('sss_pr_datereceived'),
    //                 'sss_bb_transmonth' => $sss_bb_transmonth,
    //                 'sss_bb_lastbalance' => $currentMonths_lastBalance,
    //                 'sss_bb_balance' => $currentMonths_currentamt,
    //                 'sss_allbankid' => $bankid,
    //                 'createdate' => date('Y-m-d')
    //             ];
                
    //             $isInserted = $isBankbook->insert($bankbookdata1);
    //             // update opening months closing balance...
    //         }

    //         // rearrange all balance on bankbook entries...

    //         if (!empty($isInserted)) {
    //             echo json_encode(array("status" => true, "message" => 'Payment Details Inserted'));
    //         } else {
    //             echo json_encode(array("status" => false, "message" => 'Something error while inserting Payment Details'));
    //         }
    //     }
    // }

    public function edit_paymentdetail($prid)
    {
        $editrecord = new PaymentReceived_m();
        $data = $editrecord->find($prid);
        echo json_encode($data);
    }

    public function update_paymentdetail()
    {
        $update_paymentreceived = new PaymentReceived_m();
        $Bankbook_m = new Bankbook_m();
        $id = $this->request->getVar('sss_pr_id');
        if (!empty($id)) {
            $current_received_amt  = $this->request->getVar('sss_pr_amtreceived');
            $getLastRow_pr = $update_paymentreceived->table('sss_pr_amtreceived')->find($id);
            $last_amount_received = $getLastRow_pr['sss_pr_amtreceived'];

            $bankbook_row = $Bankbook_m->table('sss_tbl_bankbook')->select('*')->where('sss_pr_id', $id)->get()->getRow();
            if (!empty($bankbook_row)) {
                $bankbook_id = $bankbook_row->sss_bankbook_id;
                $sourcebank_id = $bankbook_row->sss_allbankid;
                $get_Bank_Balance = new Bankdetails_m();
                $BankBalance = $get_Bank_Balance->find($sourcebank_id);
                $last_Balance = $BankBalance['sss_ent_bank_acc_openingbal'];
                $account_balance = $last_Balance - $last_amount_received;
                $final_amt = $account_balance + $current_received_amt;
                $update_bankbook = [
                    'sss_bb_transamt' => $this->request->getVar('sss_pr_amtreceived'),
                    'sss_bb_finalamt' => $this->request->getVar('sss_pr_amtreceived'),
                    'sss_bb_transmode' => $this->request->getVar('sss_pr_paymentmode'),
                    'sss_bb_transreffno' => $this->request->getVar('sss_pr_transreffno'),
                    'sss_bb_isdeposit' => $this->request->getVar('sss_pr_amtreceived'),
                    'sss_bb_transactiondate' => $this->request->getVar('sss_pr_datereceived'),
                    'sss_bb_lastbalance' => $last_Balance,
                    'sss_bb_balance' => $final_amt,
                    'updatedate' => date('Y-m-d')
                ];
                $Bankbook_m->update($bankbook_id, $update_bankbook);
                $updatedepositebank = new Bankdetails_m();
                $update_bank = [
                    'sss_ent_bank_acc_openingbal' => $final_amt,
                    'sss_ent_bank_last_updated_by' => session('userid'),
                    'sss_ent_bank_updated_date' => date('Y-m-d')
                ];
                $updatedepositebank->update($sourcebank_id, $update_bank);
            }
            $updaterecord = new PaymentReceived_m();
            $data = [
                'sss_pr_tdsper' => $this->request->getVar('sss_pr_tdsper'),
                'sss_pr_tdsamt' => $this->request->getVar('sss_pr_tdsamt'),
                'sss_pr_finalamt' =>  $this->request->getVar('sss_pr_finalamt'),
                'sss_pr_datereceived' => $this->request->getVar('sss_pr_datereceived'),
                'sss_pr_chequereceiveddate' => $this->request->getVar('sss_pr_chequereceiveddate'),
                'sss_pr_paymentmode' => $this->request->getVar('sss_pr_paymentmode'),
                'sss_pr_amtreceived' => $this->request->getVar('sss_pr_amtreceived'),
                'sss_pr_balanceamt' => $this->request->getVar('sss_pr_balanceamt'),
                'sss_pr_paymenttype' => $this->request->getVar('sss_pr_paymenttype'),
                'sss_sac_code_created_by' => session('userid'),
                'sss_pr_create_date' => date('Y-m-d')
            ];
            $isupdated = $updaterecord->update($id, $data);
        }

        if (!empty($isupdated)) {
            echo json_encode(array("status" => true, "message" => 'Payment Details Updated'));
        } else {
            echo json_encode(array("status" => false, "message" => 'Something error while updating Payment Details'));
        }
    }

    // public function delete_paymentdetail($prid)
    // {
    //     // delete payment received and update bank accoutns....
    //     $Bankbook_m = new Bankbook_m();
    //     $PaymentReceived_m = new PaymentReceived_m();
    //     $getrecords = $PaymentReceived_m->find($prid);
    //     // $amtreceived_row = $getrecords['sss_pr_amtreceived'];

    //     $transamt = $getrecords['sss_pr_amtreceived'];
    //     // echo $transamt;exit;
    //     if (!empty($prid))
    //         // $PaymentReceived_m->table('sss_tbl_paymentreceived')->where('sss_pr_id', $prid)->delete(); // delete pr qry
    //         // $Bankbook_m->table('sss_tbl_bankbook')->where('sss_pr_id', $prid)->delete();  // also delete entry for bb via payment received..

    //     //find bank account ...
    //     $invoices = new CreateInvoice_m();
    //     $invoicerecord = $invoices->find($getrecords['sss_inv_id']);
    //     $bankid = $invoicerecord['sss_inv_bankid'];

    //     //fetch payment received for re-arrange all balances...fetch by invoice id..
    //     if (!empty($getrecords)) {
    //         $get_all_paymentreceived = $PaymentReceived_m->where('sss_pr_id >', $prid)->where('sss_tbl_paymentreceived.sss_inv_id', $getrecords['sss_inv_id'])->orderBy('sss_pr_id', 'DESC')->get()->getResult();
    //         if (!empty($get_all_paymentreceived)) {
    //             foreach ($get_all_paymentreceived as $pr_entries) {
    //                 $paymentReceivedId = $pr_entries->sss_pr_id;
    //                 $balanceamt_row = $pr_entries->sss_pr_balanceamt;
    //                 $lastbalanceamt_row = $pr_entries->sss_pr_prev_balamt;
    //                 $last_balances = $lastbalanceamt_row + $transamt; // calcualte prev balamt..
    //                 $newbalance_amt = $transamt + $balanceamt_row; // new balance amt...
    //                 $new_amountBalances = [
    //                     'sss_pr_balanceamt' => $newbalance_amt,
    //                     'sss_pr_prev_balamt' => $last_balances,
    //                     'sss_pr_paymenttype' => 'Part Payment',
    //                     'sss_pr_updated_by' => session('userid'),
    //                     'sss_pr_update_date' => date('Y-m-d')
    //                 ];
    //                 // $PaymentReceived_m->update($paymentReceivedId, $new_amountBalances);
    //             }
    //         }

    //         $getBankBooks = new Bankbook_m();
    //         $current_BankBook_entries = $getBankBooks->table('sss_tbl_bankbook')->where('sss_pr_id', $prid)->get()->getRow(); // get current payment received entry which selct to delete...

    //         $get_all_BankBook_entries = $getBankBooks->table('sss_tbl_bankbook')->where('sss_bankbook_id >',$current_BankBook_entries->sss_bankbook_id)->orderBy('sss_bankbook_id', 'ASC')->get()->getResult();

    //         // echo "<pre>";print_r($get_all_BankBook_entries);exit;

    //         if (!empty($get_all_BankBook_entries)) {

    //             foreach ($get_all_BankBook_entries as $bb_entries) {
    //                 $BankBookId = $bb_entries->sss_bankbook_id;
    //                 $balanceamt_row = $bb_entries->sss_bb_balance;
    //                 $lastbalanceamt_row = $bb_entries->sss_bb_lastbalance;
    //                 $last_balances_bb = $lastbalanceamt_row - $transamt; // calcualte prev balamt..
    //                 $newbalance_amt_bb = $balanceamt_row - $transamt; // new balance amt...
    //                 $new_Balances = [
    //                     'sss_bb_balance' => $newbalance_amt_bb,
    //                     'sss_bb_lastbalance' => $last_balances_bb,
    //                     'sss_pr_updated_by' => session('userid'),
    //                     'sss_pr_update_date' => date('Y-m-d')
    //                 ];
    //                 $Bankbook_m->update($BankBookId, $new_Balances);
    //             }

    //         }
    //     }
    //     // exit;
    //     // payment received with bank balance ....
    //     if (!empty($transamt)) {
    //         $getopeningbal = new Bankdetails_m();
    //         $openingbalance = $getopeningbal->find($bankid);
    //         // $opningbalofsoucebank = $openingbalance['sss_ent_bank_acc_openingbal'];
    //         $lastupdatebal = ($openingbalance['sss_ent_bank_acc_openingbal']) - $transamt;
    //         $updatedepositebank = new Bankdetails_m();
    //         $depositebank = [
    //             'sss_ent_bank_acc_openingbal' => $lastupdatebal,
    //             'sss_ent_bank_last_updated_by' => session('userid'),
    //             'sss_ent_bank_updated_date' => date('Y-m-d')
    //         ];
    //         $updatedepositebank->update($bankid, $depositebank);
    //     }

    //     // end pr with bank balance..

    //     // delete ddc start...
    //     $Dealdisbursalchart_m = new Dealdisbursalchart_m();
    //     $ddcid = $Dealdisbursalchart_m->table('sss_tbl_dealdisbursalchart')->select('sss_pr_id')->where('sss_pr_id', $prid)->get()->getRow();
    //     if (!empty($ddcid)) {
    //         $Dealdisbursalchart_m->table('sss_tbl_dealdisbursalchart')->where('sss_pr_id', $prid)->delete();
    //     }

    //     // ddd delete and update bank balance start ....
    //     $Dealdetaildraft_m = new Dealdetaildraft_m();
    //     // find for bankbook id..
    //     $dddidForBB = $Dealdetaildraft_m->table('sss_tbl_dealdetaildraft')->where('sss_pr_id', $prid)->get()->getRow();


    //     $updatedepositebank = new Bankdetails_m();

    //     if (!empty($dddidForBB)) {

    //         $bb = $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->get()->getResult();
    //         $getbankid = new Bankdetails_m();
    //         if (!empty($bb)) {
    //             foreach ($bb as $b) {
    //                 if ($b->sss_bb_transtype == 'Withdrawl' && $b->sss_bb_iswithdrawl != '') {
    //                     $ssdddid = $b->sss_ddd_id;
    //                     $sbankid = $b->sss_bb_sourcebankid;
    //                     $sourcetransamt = $b->sss_bb_iswithdrawl;

    //                     $openingbalance = $getbankid->find($sbankid);
    //                     $opningbalofwithdrawlbank = $openingbalance['sss_ent_bank_acc_openingbal'];

    //                     $bankbalanceupdat = $opningbalofwithdrawlbank + $sourcetransamt;

    //                     $sourcebankwithdrawarray = [
    //                         'sss_ent_bank_acc_openingbal' => $bankbalanceupdat,
    //                         'sss_ent_bank_last_updated_by' => session('userid'),
    //                         'sss_ent_bank_updated_date' => date('Y-m-d')
    //                     ];
    //                     $updatedepositebank->update($sbankid, $sourcebankwithdrawarray);
    //                     $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $ssdddid)->delete();
    //                 }

    //                 if ($b->sss_bb_transtype == 'Deposit' && $b->sss_bb_isdeposit != '') {

    //                     $ssdddid = $b->sss_ddd_id;
    //                     $dbankid = $b->sss_bb_destinationbankid;
    //                     $openingbalance = $getbankid->find($dbankid);
    //                     $opningbalofdestinationbank = $openingbalance['sss_ent_bank_acc_openingbal'];
    //                     $destinationtransamt = $b->sss_bb_isdeposit;

    //                     $depositebankbalanceupdat = $opningbalofdestinationbank - $destinationtransamt;
    //                     $destinationbankdepositearray = [
    //                         'sss_ent_bank_acc_openingbal' => $depositebankbalanceupdat,
    //                         'sss_ent_bank_last_updated_by' => session('userid'),
    //                         'sss_ent_bank_updated_date' => date('Y-m-d')
    //                     ];
    //                     $updatedepositebank->update($dbankid, $destinationbankdepositearray);
    //                     $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $ssdddid)->delete();
    //                 }

    //                 // else if ($b->sss_bb_destinationbankid == 3 || $b->sss_bb_destinationbankid != '') {
    //                 //     $taxdddid = $b->sss_ddd_id;
    //                 //     // $taxbankid = $b->sss_bb_destinationbankid;
    //                 //     $taxtransamt = $b->sss_bb_isdeposit;  //deposite destination bank
    //                 //     $taxlastupdatebal = ($openingbalanceoftax['sss_ent_bank_acc_openingbal']) - $taxtransamt;

    //                 //     $updatebalindestinationbank_tax = new Bankdetails_m();
    //                 //     $depositetaxbankdata = [
    //                 //         'sss_ent_bank_acc_openingbal' => $taxlastupdatebal,
    //                 //         'sss_ent_bank_last_updated_by' => session('userid'),
    //                 //         'sss_ent_bank_updated_date' => date('Y-m-d')
    //                 //     ];
    //                 //     $updatebalindestinationbank_tax->update(3, $depositetaxbankdata);
    //                 //     $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $taxdddid)->delete();
    //                 // } 
    //                 // else if ($b->sss_bb_destinationbankid == 2 || $b->sss_bb_destinationbankid != '') {
    //                 //     $dddid = $b->sss_ddd_id;
    //                 //     $advbankid = $b->sss_bb_destinationbankid;
    //                 //     $dtransamt = $b->sss_bb_isdeposit;  //deposite destination bank

    //                 //     $advlastupdatebal = ($openingbalanceofadv['sss_ent_bank_acc_openingbal']) - $dtransamt;

    //                 //     $updatebalindestinationbank_tax = new Bankdetails_m();
    //                 //     $depositeadvbankdata = [
    //                 //         'sss_ent_bank_acc_openingbal' => $advlastupdatebal,
    //                 //         'sss_ent_bank_last_updated_by' => session('userid'),
    //                 //         'sss_ent_bank_updated_date' => date('Y-m-d')
    //                 //     ];
    //                 //     $updatebalindestinationbank_tax->update(2, $depositeadvbankdata);
    //                 //     $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $dddid)->delete();
    //                 // }
    //             }
    //         }


    //         $Tdsentries_m = new Tdsentries_m();
    //         $isTDSFound = $Tdsentries_m->table('sss_tbl_totaltds')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->findAll();

    //         if (!empty($isTDSFound)) {
    //             foreach ($isTDSFound as $Tds) {
    //                 $Tdsentries_m->table('sss_tbl_totaltds')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->delete();
    //             }
    //         }

    //         $allemprecord = new DDD_emp_m();
    //         $isEmpFound = $allemprecord->table('sss_ddd_employees')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->get()->getResult();
    //         if (!empty($isEmpFound)) {
    //             foreach ($isEmpFound as $emp) {
    //                 $allemprecord->table('sss_ddd_employees')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->delete();
    //             }
    //         }

    //         $alloutcomerecord = new DDD_outcome_m();
    //         $isOutcomeFound = $alloutcomerecord->table('sss_ddd_outcomes')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->get()->getResult();

    //         if (!empty($isOutcomeFound)) {
    //             foreach ($isOutcomeFound as $outcome) {

    //                 $alloutcomerecord->table('sss_ddd_outcomes')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->delete();
    //             }
    //         }
    //     }

    //     if (!empty($prid)) {
    //         // $Bankbook_m->table('sss_tbl_bankbook')->where('sss_pr_id', $prid)->delete();  // also delete entry for bb via payment received..

    //         $Dealdetaildraft_m->table('sss_tbl_dealdetaildraft')->where('sss_pr_id', $prid)->delete(); // delete ddd entry from pr  
    //     }

    //     echo json_encode(array("status" => TRUE));
    // }


    //2.
    // backup 
    // public function delete_paymentdetail($prid)
    // {
    //     // delete payment received and update bank accoutns....
    //     $Bankbook_m = new Bankbook_m();
    //     $PaymentReceived_m = new PaymentReceived_m();
    //     $getrecords = $PaymentReceived_m->find($prid);
    //     $bank_bookId = $Bankbook_m->table('sss_tbl_bankbook')->where('sss_pr_id', $prid)->get()->getRow();

    //     $transamt = $getrecords['sss_pr_amtreceived'];

    //     if (!empty($prid))
    //         $PaymentReceived_m->table('sss_tbl_paymentreceived')->where('sss_pr_id', $prid)->delete(); // delete pr qry
    //     $Bankbook_m->table('sss_tbl_bankbook')->where('sss_pr_id', $prid)->delete();  // also delete entry for bb via payment received..

    //     //find bank account ...
    //     $invoices = new CreateInvoice_m();
    //     $invoicerecord = $invoices->find($getrecords['sss_inv_id']);
    //     $bankid = $invoicerecord['sss_inv_bankid'];

    //     //fetch payment received for re-arrange all balances...fetch by invoice id..
    //     if (!empty($getrecords)) {
    //         // for payment received table....
    //         $get_all_paymentreceived = $PaymentReceived_m->where('sss_pr_id >', $prid)->where('sss_tbl_paymentreceived.sss_inv_id', $getrecords['sss_inv_id'])->orderBy('sss_pr_id', 'Asc')->get()->getResult();

    //         if (!empty($get_all_paymentreceived)) {
    //             foreach ($get_all_paymentreceived as $pr_entries) {
    //                 $paymentReceivedId = $pr_entries->sss_pr_id;
    //                 $balanceamt_row = $pr_entries->sss_pr_balanceamt;
    //                 $lastbalanceamt_row = $pr_entries->sss_pr_prev_balamt;
    //                 $last_balances = $lastbalanceamt_row + $transamt; // calcualte prev balamt..
    //                 $newbalance_amt = $transamt + $balanceamt_row; // new balance amt...

    //                 $new_amountBalances = [
    //                     'sss_pr_balanceamt' => $newbalance_amt,
    //                     'sss_pr_prev_balamt' => $last_balances,
    //                     'sss_pr_paymenttype' => 'Part Payment',
    //                     'sss_pr_updated_by' => session('userid'),
    //                     'sss_pr_update_date' => date('Y-m-d')
    //                 ];
    //                 $PaymentReceived_m->update($paymentReceivedId, $new_amountBalances);
    //             }
    //         }

    //         // end....

    //         // for bankbook table....
    //         $getBankBooks = new Bankbook_m();
    //         $get_all_BankBook_entries = $getBankBooks->table('sss_tbl_bankbook')->where('sss_bankbook_id >', $bank_bookId->sss_bankbook_id)->where('sss_tbl_bankbook.sss_bb_invid', $getrecords['sss_inv_id'])->orderBy('sss_bankbook_id', 'ASC')->get()->getResult();
    //         if (!empty($get_all_BankBook_entries)) {
    //             foreach ($get_all_BankBook_entries as $bb_entries) {
    //                 $BankBookId = $bb_entries->sss_bankbook_id;
    //                 $balanceamt_row = $bb_entries->sss_bb_balance;
    //                 $lastbalanceamt_row = $bb_entries->sss_bb_lastbalance;
    //                 $last_balances_bb = $lastbalanceamt_row - $transamt; // calcualte prev balamt..
    //                 $newbalance_amt_bb = $last_balances_bb + $bb_entries->sss_bb_transamt; // new balance amt...

    //                 $new_Balances = [
    //                     'sss_bb_balance' => $newbalance_amt_bb,
    //                     'sss_bb_lastbalance' => $last_balances_bb,
    //                     'sss_pr_updated_by' => session('userid'),
    //                     'sss_pr_update_date' => date('Y-m-d')
    //                 ];
    //                 $Bankbook_m->update($BankBookId, $new_Balances);
    //             }
    //         }
    //     }

    //     // payment received with bank balance ....
    //     if (!empty($transamt)) {
    //         $getopeningbal = new Bankdetails_m();
    //         $openingbalance = $getopeningbal->find($bankid);
    //         // $opningbalofsoucebank = $openingbalance['sss_ent_bank_acc_openingbal'];
    //         $lastupdatebal = ($openingbalance['sss_ent_bank_acc_openingbal']) - $transamt;
    //         $updatedepositebank = new Bankdetails_m();
    //         $depositebank = [
    //             'sss_ent_bank_acc_openingbal' => $lastupdatebal,
    //             'sss_ent_bank_last_updated_by' => session('userid'),
    //             'sss_ent_bank_updated_date' => date('Y-m-d')
    //         ];
    //         $updatedepositebank->update($bankid, $depositebank);
    //     }

    //     // end pr with bank balance..

    //     // delete ddc start...
    //     $Dealdisbursalchart_m = new Dealdisbursalchart_m();
    //     $ddcid = $Dealdisbursalchart_m->table('sss_tbl_dealdisbursalchart')->select('sss_pr_id')->where('sss_pr_id', $prid)->get()->getRow();
    //     if (!empty($ddcid)) {
    //         $Dealdisbursalchart_m->table('sss_tbl_dealdisbursalchart')->where('sss_pr_id', $prid)->delete();
    //     }

    //     // ddd delete and update bank balance start ....
    //     $Dealdetaildraft_m = new Dealdetaildraft_m();
    //     // find for bankbook id..
    //     $dddidForBB = $Dealdetaildraft_m->table('sss_tbl_dealdetaildraft')->where('sss_pr_id', $prid)->get()->getRow();


    //     $updatedepositebank = new Bankdetails_m();

    //     if (!empty($dddidForBB)) {

    //         $bb = $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->get()->getResult();
    //         $getbankid = new Bankdetails_m();
    //         if (!empty($bb)) {
    //             foreach ($bb as $b) {
    //                 if ($b->sss_bb_transtype == 'Withdrawl' && $b->sss_bb_iswithdrawl != '') {
    //                     $ssdddid = $b->sss_ddd_id;
    //                     $sbankid = $b->sss_bb_sourcebankid;
    //                     $sourcetransamt = $b->sss_bb_iswithdrawl;

    //                     $openingbalance = $getbankid->find($sbankid);
    //                     $opningbalofwithdrawlbank = $openingbalance['sss_ent_bank_acc_openingbal'];

    //                     $bankbalanceupdat = $opningbalofwithdrawlbank + $sourcetransamt;

    //                     $sourcebankwithdrawarray = [
    //                         'sss_ent_bank_acc_openingbal' => $bankbalanceupdat,
    //                         'sss_ent_bank_last_updated_by' => session('userid'),
    //                         'sss_ent_bank_updated_date' => date('Y-m-d')
    //                     ];
    //                     $updatedepositebank->update($sbankid, $sourcebankwithdrawarray);
    //                     $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $ssdddid)->delete();
    //                 }

    //                 if ($b->sss_bb_transtype == 'Deposit' && $b->sss_bb_isdeposit != '') {

    //                     $ssdddid = $b->sss_ddd_id;
    //                     $dbankid = $b->sss_bb_destinationbankid;
    //                     $openingbalance = $getbankid->find($dbankid);
    //                     $opningbalofdestinationbank = $openingbalance['sss_ent_bank_acc_openingbal'];
    //                     $destinationtransamt = $b->sss_bb_isdeposit;

    //                     $depositebankbalanceupdat = $opningbalofdestinationbank - $destinationtransamt;
    //                     $destinationbankdepositearray = [
    //                         'sss_ent_bank_acc_openingbal' => $depositebankbalanceupdat,
    //                         'sss_ent_bank_last_updated_by' => session('userid'),
    //                         'sss_ent_bank_updated_date' => date('Y-m-d')
    //                     ];
    //                     $updatedepositebank->update($dbankid, $destinationbankdepositearray);
    //                     $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $ssdddid)->delete();
    //                 }

    //                 // else if ($b->sss_bb_destinationbankid == 3 || $b->sss_bb_destinationbankid != '') {
    //                 //     $taxdddid = $b->sss_ddd_id;
    //                 //     // $taxbankid = $b->sss_bb_destinationbankid;
    //                 //     $taxtransamt = $b->sss_bb_isdeposit;  //deposite destination bank
    //                 //     $taxlastupdatebal = ($openingbalanceoftax['sss_ent_bank_acc_openingbal']) - $taxtransamt;

    //                 //     $updatebalindestinationbank_tax = new Bankdetails_m();
    //                 //     $depositetaxbankdata = [
    //                 //         'sss_ent_bank_acc_openingbal' => $taxlastupdatebal,
    //                 //         'sss_ent_bank_last_updated_by' => session('userid'),
    //                 //         'sss_ent_bank_updated_date' => date('Y-m-d')
    //                 //     ];
    //                 //     $updatebalindestinationbank_tax->update(3, $depositetaxbankdata);
    //                 //     $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $taxdddid)->delete();
    //                 // } 
    //                 // else if ($b->sss_bb_destinationbankid == 2 || $b->sss_bb_destinationbankid != '') {
    //                 //     $dddid = $b->sss_ddd_id;
    //                 //     $advbankid = $b->sss_bb_destinationbankid;
    //                 //     $dtransamt = $b->sss_bb_isdeposit;  //deposite destination bank

    //                 //     $advlastupdatebal = ($openingbalanceofadv['sss_ent_bank_acc_openingbal']) - $dtransamt;

    //                 //     $updatebalindestinationbank_tax = new Bankdetails_m();
    //                 //     $depositeadvbankdata = [
    //                 //         'sss_ent_bank_acc_openingbal' => $advlastupdatebal,
    //                 //         'sss_ent_bank_last_updated_by' => session('userid'),
    //                 //         'sss_ent_bank_updated_date' => date('Y-m-d')
    //                 //     ];
    //                 //     $updatebalindestinationbank_tax->update(2, $depositeadvbankdata);
    //                 //     $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $dddid)->delete();
    //                 // }
    //             }
    //         }


    //         $Tdsentries_m = new Tdsentries_m();
    //         $isTDSFound = $Tdsentries_m->table('sss_tbl_totaltds')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->findAll();

    //         if (!empty($isTDSFound)) {
    //             foreach ($isTDSFound as $Tds) {
    //                 $Tdsentries_m->table('sss_tbl_totaltds')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->delete();
    //             }
    //         }

    //         $allemprecord = new DDD_emp_m();
    //         $isEmpFound = $allemprecord->table('sss_ddd_employees')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->get()->getResult();
    //         if (!empty($isEmpFound)) {
    //             foreach ($isEmpFound as $emp) {
    //                 $allemprecord->table('sss_ddd_employees')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->delete();
    //             }
    //         }

    //         $alloutcomerecord = new DDD_outcome_m();
    //         $isOutcomeFound = $alloutcomerecord->table('sss_ddd_outcomes')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->get()->getResult();

    //         if (!empty($isOutcomeFound)) {
    //             foreach ($isOutcomeFound as $outcome) {

    //                 $alloutcomerecord->table('sss_ddd_outcomes')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->delete();
    //             }
    //         }
    //     }

    //     if (!empty($prid)) {
    //         // $Bankbook_m->table('sss_tbl_bankbook')->where('sss_pr_id', $prid)->delete();  // also delete entry for bb via payment received..
    //         $Dealdetaildraft_m->table('sss_tbl_dealdetaildraft')->where('sss_pr_id', $prid)->delete(); // delete ddd entry from pr  
    //     }

    //     echo json_encode(array("status" => TRUE));
    // }

    // last backup...
    // public function delete_paymentdetail($prid)
    // {
    //     // delete payment received and update bank accoutns....
    //     $Bankbook_m = new Bankbook_m();
    //     $PaymentReceived_m = new PaymentReceived_m();
    //     $getrecords = $PaymentReceived_m->find($prid);

    //     $bank_bookId = $Bankbook_m->table('sss_tbl_bankbook')->where('sss_pr_id', $prid)->get()->getRow();
    //     // get bank id for next entries invoices.....sss_bb_transactiondate
    //     $bankId  = $bank_bookId->sss_allbankid;

    //     $transamt = $getrecords['sss_pr_amtreceived'];

    //     if (!empty($prid))
    //         $PaymentReceived_m->table('sss_tbl_paymentreceived')->where('sss_pr_id', $prid)->delete(); // delete pr qry
    //         $Bankbook_m->table('sss_tbl_bankbook')->where('sss_pr_id', $prid)->delete();  // also delete entry for bb via payment received..

    //     //find bank account ...
    //     $invoices = new CreateInvoice_m();
    //     $invoicerecord = $invoices->find($getrecords['sss_inv_id']);
    //     $bankid = $invoicerecord['sss_inv_bankid'];

    //     //fetch payment received for re-arrange all balances...fetch by invoice id..
    //     if (!empty($getrecords)) {
    //         // for payment received table....
    //         $get_all_paymentreceived = $PaymentReceived_m->where('sss_pr_id >', $prid)->where('sss_tbl_paymentreceived.sss_inv_id', $getrecords['sss_inv_id'])->orderBy('sss_pr_id', 'Asc')->get()->getResult();

    //         if (!empty($get_all_paymentreceived)) {
    //             foreach ($get_all_paymentreceived as $pr_entries) {
    //                 $paymentReceivedId = $pr_entries->sss_pr_id;
    //                 $balanceamt_row = $pr_entries->sss_pr_balanceamt;
    //                 $lastbalanceamt_row = $pr_entries->sss_pr_prev_balamt;
    //                 $last_balances = $lastbalanceamt_row + $transamt; // calcualte prev balamt..
    //                 $newbalance_amt = $transamt + $balanceamt_row; // new balance amt...

    //                 $new_amountBalances = [
    //                     'sss_pr_balanceamt' => $newbalance_amt,
    //                     'sss_pr_prev_balamt' => $last_balances,
    //                     'sss_pr_paymenttype' => 'Part Payment',
    //                     'sss_pr_updated_by' => session('userid'),
    //                     'sss_pr_update_date' => date('Y-m-d')
    //                 ];
    //                 $PaymentReceived_m->update($paymentReceivedId, $new_amountBalances);
    //             }
    //         }

    //         // end....

    //         // for bankbook table....
    //         $getBankBooks = new Bankbook_m();
    //         $get_all_BankBook_entries = $getBankBooks->table('sss_tbl_bankbook')->where('sss_bb_transactiondate >', $bank_bookId->sss_bb_transactiondate)->where('sss_allbankid', $bankId)->get()->getResult();

    //         // echo "<pre>";print_r($get_all_BankBook_entries);exit;

    //         // $get_all_BankBook_entries = $getBankBooks->table('sss_tbl_bankbook')->where('sss_bankbook_id >', $bank_bookId->sss_bankbook_id)->where('sss_tbl_bankbook.sss_bb_invid', $getrecords['sss_inv_id'])->orderBy('sss_bankbook_id', 'ASC')->get()->getResult();
    //         if (!empty($get_all_BankBook_entries)) {
    //             foreach ($get_all_BankBook_entries as $bb_entries) {

    //                 if ($bb_entries->sss_bb_transtype  == 'Deposit') {
    //                     $BankBookId = $bb_entries->sss_bankbook_id;
    //                     $balanceamt_row = $bb_entries->sss_bb_balance;
    //                     $lastbalanceamt_row = $bb_entries->sss_bb_lastbalance;
    //                     $newlast_balances_bb = $lastbalanceamt_row - $transamt; // calcualte prev balamt..
    //                     $newbalance_amt_bb = $newlast_balances_bb + $bb_entries->sss_bb_transamt; // new balance amt...

    //                     $deposite_new_Balances = [
    //                         'sss_bb_balance' => $newbalance_amt_bb,
    //                         'sss_bb_lastbalance' => $newlast_balances_bb,
    //                         'updatedate' => date('Y-m-d')
    //                     ];
    //                     $Bankbook_m->update($BankBookId, $deposite_new_Balances);
    //                 } else {
    //                     $BankBookId = $bb_entries->sss_bankbook_id;
    //                     $balanceamt_row = $bb_entries->sss_bb_balance;
    //                     $lastbalanceamt_row = $bb_entries->sss_bb_lastbalance;
    //                     $newlast_balances_bb = $lastbalanceamt_row - $transamt; // calcualte prev balamt..
    //                     $newbalance_amt_bb = $newlast_balances_bb - $bb_entries->sss_bb_transamt; // new balance amt...

    //                     $withdrawl_new_Balances = [
    //                         'sss_bb_balance' => $newbalance_amt_bb,
    //                         'sss_bb_lastbalance' => $newlast_balances_bb,
    //                         'updatedate' => date('Y-m-d')
    //                     ];
    //                     $Bankbook_m->update($BankBookId, $withdrawl_new_Balances);
    //                 }
    //             }
    //         }
    //     }

    //     // payment received with bank balance ....
    //     if (!empty($transamt)) {
    //         $getopeningbal = new Bankdetails_m();
    //         $openingbalance = $getopeningbal->find($bankid);
    //         // $opningbalofsoucebank = $openingbalance['sss_ent_bank_acc_openingbal'];
    //         $lastupdatebal = ($openingbalance['sss_ent_bank_acc_openingbal']) - $transamt;
    //         $updatedepositebank = new Bankdetails_m();
    //         $depositebank = [
    //             'sss_ent_bank_acc_openingbal' => $lastupdatebal,
    //             'sss_ent_bank_last_updated_by' => session('userid'),
    //             'sss_ent_bank_updated_date' => date('Y-m-d')
    //         ];
    //         $updatedepositebank->update($bankid, $depositebank);
    //     }

    //     // end pr with bank balance..

    //     // delete ddc start...
    //     $Dealdisbursalchart_m = new Dealdisbursalchart_m();
    //     $ddcid = $Dealdisbursalchart_m->table('sss_tbl_dealdisbursalchart')->select('sss_pr_id')->where('sss_pr_id', $prid)->get()->getRow();
    //     if (!empty($ddcid)) {
    //         $Dealdisbursalchart_m->table('sss_tbl_dealdisbursalchart')->where('sss_pr_id', $prid)->delete();
    //     }

    //     // ddd delete and update bank balance start ....
    //     $Dealdetaildraft_m = new Dealdetaildraft_m();
    //     // find for bankbook id..
    //     $dddidForBB = $Dealdetaildraft_m->table('sss_tbl_dealdetaildraft')->where('sss_pr_id', $prid)->get()->getRow();


    //     $updatedepositebank = new Bankdetails_m();

    //     if (!empty($dddidForBB)) {

    //         $bb = $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->get()->getResult();
    //         $getbankid = new Bankdetails_m();
    //         if (!empty($bb)) {
    //             foreach ($bb as $b) {
    //                 if ($b->sss_bb_transtype == 'Withdrawl' && $b->sss_bb_iswithdrawl != '') {
    //                     $ssdddid = $b->sss_ddd_id;
    //                     $sbankid = $b->sss_bb_sourcebankid;
    //                     $sourcetransamt = $b->sss_bb_iswithdrawl;

    //                     $openingbalance = $getbankid->find($sbankid);
    //                     $opningbalofwithdrawlbank = $openingbalance['sss_ent_bank_acc_openingbal'];

    //                     $bankbalanceupdat = $opningbalofwithdrawlbank + $sourcetransamt;

    //                     $sourcebankwithdrawarray = [
    //                         'sss_ent_bank_acc_openingbal' => $bankbalanceupdat,
    //                         'sss_ent_bank_last_updated_by' => session('userid'),
    //                         'sss_ent_bank_updated_date' => date('Y-m-d')
    //                     ];
    //                     $updatedepositebank->update($sbankid, $sourcebankwithdrawarray);
    //                     $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $ssdddid)->delete();
    //                 }

    //                 if ($b->sss_bb_transtype == 'Deposit' && $b->sss_bb_isdeposit != '') {

    //                     $ssdddid = $b->sss_ddd_id;
    //                     $dbankid = $b->sss_bb_destinationbankid;
    //                     $openingbalance = $getbankid->find($dbankid);
    //                     $opningbalofdestinationbank = $openingbalance['sss_ent_bank_acc_openingbal'];
    //                     $destinationtransamt = $b->sss_bb_isdeposit;

    //                     $depositebankbalanceupdat = $opningbalofdestinationbank - $destinationtransamt;
    //                     $destinationbankdepositearray = [
    //                         'sss_ent_bank_acc_openingbal' => $depositebankbalanceupdat,
    //                         'sss_ent_bank_last_updated_by' => session('userid'),
    //                         'sss_ent_bank_updated_date' => date('Y-m-d')
    //                     ];
    //                     $updatedepositebank->update($dbankid, $destinationbankdepositearray);
    //                     $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $ssdddid)->delete();
    //                 }

    //                 // else if ($b->sss_bb_destinationbankid == 3 || $b->sss_bb_destinationbankid != '') {
    //                 //     $taxdddid = $b->sss_ddd_id;
    //                 //     // $taxbankid = $b->sss_bb_destinationbankid;
    //                 //     $taxtransamt = $b->sss_bb_isdeposit;  //deposite destination bank
    //                 //     $taxlastupdatebal = ($openingbalanceoftax['sss_ent_bank_acc_openingbal']) - $taxtransamt;

    //                 //     $updatebalindestinationbank_tax = new Bankdetails_m();
    //                 //     $depositetaxbankdata = [
    //                 //         'sss_ent_bank_acc_openingbal' => $taxlastupdatebal,
    //                 //         'sss_ent_bank_last_updated_by' => session('userid'),
    //                 //         'sss_ent_bank_updated_date' => date('Y-m-d')
    //                 //     ];
    //                 //     $updatebalindestinationbank_tax->update(3, $depositetaxbankdata);
    //                 //     $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $taxdddid)->delete();
    //                 // } 
    //                 // else if ($b->sss_bb_destinationbankid == 2 || $b->sss_bb_destinationbankid != '') {
    //                 //     $dddid = $b->sss_ddd_id;
    //                 //     $advbankid = $b->sss_bb_destinationbankid;
    //                 //     $dtransamt = $b->sss_bb_isdeposit;  //deposite destination bank

    //                 //     $advlastupdatebal = ($openingbalanceofadv['sss_ent_bank_acc_openingbal']) - $dtransamt;

    //                 //     $updatebalindestinationbank_tax = new Bankdetails_m();
    //                 //     $depositeadvbankdata = [
    //                 //         'sss_ent_bank_acc_openingbal' => $advlastupdatebal,
    //                 //         'sss_ent_bank_last_updated_by' => session('userid'),
    //                 //         'sss_ent_bank_updated_date' => date('Y-m-d')
    //                 //     ];
    //                 //     $updatebalindestinationbank_tax->update(2, $depositeadvbankdata);
    //                 //     $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $dddid)->delete();
    //                 // }
    //             }
    //         }


    //         $Tdsentries_m = new Tdsentries_m();
    //         $isTDSFound = $Tdsentries_m->table('sss_tbl_totaltds')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->findAll();

    //         if (!empty($isTDSFound)) {
    //             foreach ($isTDSFound as $Tds) {
    //                 $Tdsentries_m->table('sss_tbl_totaltds')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->delete();
    //             }
    //         }

    //         $allemprecord = new DDD_emp_m();
    //         $isEmpFound = $allemprecord->table('sss_ddd_employees')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->get()->getResult();
    //         if (!empty($isEmpFound)) {
    //             foreach ($isEmpFound as $emp) {
    //                 $allemprecord->table('sss_ddd_employees')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->delete();
    //             }
    //         }

    //         $alloutcomerecord = new DDD_outcome_m();
    //         $isOutcomeFound = $alloutcomerecord->table('sss_ddd_outcomes')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->get()->getResult();

    //         if (!empty($isOutcomeFound)) {
    //             foreach ($isOutcomeFound as $outcome) {

    //                 $alloutcomerecord->table('sss_ddd_outcomes')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->delete();
    //             }
    //         }
    //     }

    //     if (!empty($prid)) {
    //         // $Bankbook_m->table('sss_tbl_bankbook')->where('sss_pr_id', $prid)->delete();  // also delete entry for bb via payment received..
    //         $Dealdetaildraft_m->table('sss_tbl_dealdetaildraft')->where('sss_pr_id', $prid)->delete(); // delete ddd entry from pr  
    //     }

    //     echo json_encode(array("status" => TRUE));
    // }
    
    
    public function delete_paymentdetail($prid)
    {
        // delete payment received and update bank accoutns....
        $Bankbook_m = new Bankbook_m();
        $PaymentReceived_m = new PaymentReceived_m();
        $getrecords = $PaymentReceived_m->find($prid);

        $bank_bookId = $Bankbook_m->table('sss_tbl_bankbook')->where('sss_pr_id', $prid)->get()->getRow();
        // get bank id for next entries invoices.....sss_bb_transactiondate
        $bankId  = $bank_bookId->sss_allbankid;

        $dateComps = date_parse($bank_bookId->sss_bb_transactiondate);
        $year = $dateComps['year'];
        $month = $dateComps['month'];
        $getnextmonth = $month + 1 . '-' . $year;
        $transamt = $getrecords['sss_pr_amtreceived'];

        if (!empty($prid))
            $PaymentReceived_m->table('sss_tbl_paymentreceived')->where('sss_pr_id', $prid)->delete(); // delete pr qry
            $Bankbook_m->table('sss_tbl_bankbook')->where('sss_pr_id', $prid)->delete();  // also delete entry for bb via payment received..

        //find bank account ...
        $invoices = new CreateInvoice_m();
        $invoicerecord = $invoices->find($getrecords['sss_inv_id']);
        $bankid = $invoicerecord['sss_inv_bankid'];

        //fetch payment received for re-arrange all balances...fetch by invoice id..
        if (!empty($getrecords)) {
            // for payment received table....
            $get_all_paymentreceived = $PaymentReceived_m->where('sss_pr_id >', $prid)->where('sss_tbl_paymentreceived.sss_inv_id', $getrecords['sss_inv_id'])->orderBy('sss_pr_id', 'Asc')->get()->getResult();
            if (!empty($get_all_paymentreceived)) {
                foreach ($get_all_paymentreceived as $pr_entries) {
                    $paymentReceivedId = $pr_entries->sss_pr_id;
                    $balanceamt_row = $pr_entries->sss_pr_balanceamt;
                    $lastbalanceamt_row = $pr_entries->sss_pr_prev_balamt;
                    $last_balances = $lastbalanceamt_row + $transamt; // calcualte prev balamt..
                    $newbalance_amt = $transamt + $balanceamt_row; // new balance amt...

                    $new_amountBalances = [
                        'sss_pr_balanceamt' => $newbalance_amt,
                        'sss_pr_prev_balamt' => $last_balances,
                        'sss_pr_paymenttype' => 'Part Payment',
                        'sss_pr_updated_by' => session('userid'),
                        'sss_pr_update_date' => date('Y-m-d')
                    ];
                    $PaymentReceived_m->update($paymentReceivedId, $new_amountBalances);
                }
            }
            // end....

            // for bankbook table....
            $getBankBooks = new Bankbook_m();
            $get_all_BankBook_entries = $getBankBooks->table('sss_tbl_bankbook')->where('sss_bb_transactiondate >', $bank_bookId->sss_bb_transactiondate)->where('sss_allbankid', $bankId)->get()->getResult();

            $MonthsBalances_m = new MonthsBalances_m();
            $getValueofMonthBalance = $MonthsBalances_m->where('bankid', $bankid)->where('balancemonth', $getnextmonth)->get()->getRow();
            $opngmonthbal_id = $getValueofMonthBalance->id;
            $openingBal_of_nextmonth = $getValueofMonthBalance->openingbal;
            
            $newcurrentopeningbal = $openingBal_of_nextmonth - $transamt;
            
            // update next mon...
            $deposite_nextmonth = [
                    'openingbal'=> $newcurrentopeningbal,
            ];
            $MonthsBalances_m->update($opngmonthbal_id, $deposite_nextmonth);
            

            // $get_all_BankBook_entries = $getBankBooks->table('sss_tbl_bankbook')->where('sss_bankbook_id >', $bank_bookId->sss_bankbook_id)->where('sss_tbl_bankbook.sss_bb_invid', $getrecords['sss_inv_id'])->orderBy('sss_bankbook_id', 'ASC')->get()->getResult();
            
            if (!empty($get_all_BankBook_entries)) {
                foreach ($get_all_BankBook_entries as $bb_entries) {
                    if ($bb_entries->sss_bb_transtype  == 'Deposit') {
                        $BankBookId = $bb_entries->sss_bankbook_id;
                        $balanceamt_row = $bb_entries->sss_bb_balance;
                        $lastbalanceamt_row = $bb_entries->sss_bb_lastbalance;
                        $newlast_balances_bb = $lastbalanceamt_row - $transamt; // calcualte prev balamt..
                        $newbalance_amt_bb = $newlast_balances_bb + $bb_entries->sss_bb_transamt; // new balance amt...

                        $deposite_new_Balances = [
                            'sss_bb_balance' => $newbalance_amt_bb,
                            'sss_bb_lastbalance' => $newlast_balances_bb,
                            'updatedate' => date('Y-m-d')
                        ];
                        $Bankbook_m->update($BankBookId, $deposite_new_Balances);

                        // update Balance of current month.....
                        
                        // $monthsBalancesModel = new MonthsBalances_m();
                        // $updateData = [
                        //     'openingbal' => $newbalance_amt_bb,
                        // ];
                        // $monthsBalancesModel->update($opngmonthbal_id, $updateData);


                    } else {
                        $BankBookId = $bb_entries->sss_bankbook_id;
                        $balanceamt_row = $bb_entries->sss_bb_balance;
                        $lastbalanceamt_row = $bb_entries->sss_bb_lastbalance;
                        $newlast_balances_bb = $lastbalanceamt_row - $transamt; // calcualte prev balamt..
                        $newbalance_amt_bb = $newlast_balances_bb - $bb_entries->sss_bb_transamt; // new balance amt...

                        $withdrawl_new_Balances = [
                            'sss_bb_balance' => $newbalance_amt_bb,
                            'sss_bb_lastbalance' => $newlast_balances_bb,
                            'updatedate' => date('Y-m-d')
                        ];
                        $Bankbook_m->update($BankBookId, $withdrawl_new_Balances);

                        // update Balance.....
                        // $monthsBalancesModel = new MonthsBalances_m();
                        // $updateData = [
                        //     'openingbal' => $newbalance_amt_bb,
                        // ];
                        // $monthsBalancesModel->update($opngmonthbal_id, $updateData);
                    }
                }
                
              
                
            }
        }

        // payment received with bank balance ....
        if (!empty($transamt)) {
            $getopeningbal = new Bankdetails_m();
            $openingbalance = $getopeningbal->find($bankid);
            // $opningbalofsoucebank = $openingbalance['sss_ent_bank_acc_openingbal'];
            $lastupdatebal = ($openingbalance['sss_ent_bank_acc_openingbal']) - $transamt;
            $updatedepositebank = new Bankdetails_m();
            $depositebank = [
                'sss_ent_bank_acc_openingbal' => $lastupdatebal,
                'sss_ent_bank_last_updated_by' => session('userid'),
                'sss_ent_bank_updated_date' => date('Y-m-d')
            ];
            $updatedepositebank->update($bankid, $depositebank);
        }

        // end pr with bank balance..

        // delete ddc start...
        $Dealdisbursalchart_m = new Dealdisbursalchart_m();
        $ddcid = $Dealdisbursalchart_m->table('sss_tbl_dealdisbursalchart')->select('sss_pr_id')->where('sss_pr_id', $prid)->get()->getRow();
        if (!empty($ddcid)) {
            $Dealdisbursalchart_m->table('sss_tbl_dealdisbursalchart')->where('sss_pr_id', $prid)->delete();
        }

        // ddd delete and update bank balance start ....
        $Dealdetaildraft_m = new Dealdetaildraft_m();
        // find for bankbook id..
        $dddidForBB = $Dealdetaildraft_m->table('sss_tbl_dealdetaildraft')->where('sss_pr_id', $prid)->get()->getRow();


        $updatedepositebank = new Bankdetails_m();

        if (!empty($dddidForBB)) {
            $bb = $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->get()->getResult();
            $getbankid = new Bankdetails_m();
            if (!empty($bb)) {
                foreach ($bb as $b) {
                    if ($b->sss_bb_transtype == 'Withdrawl' && $b->sss_bb_iswithdrawl != '') {
                        $ssdddid = $b->sss_ddd_id;
                        $sbankid = $b->sss_bb_sourcebankid;
                        $sourcetransamt = $b->sss_bb_iswithdrawl;

                        $openingbalance = $getbankid->find($sbankid);
                        $opningbalofwithdrawlbank = $openingbalance['sss_ent_bank_acc_openingbal'];

                        $bankbalanceupdat = $opningbalofwithdrawlbank + $sourcetransamt;

                        $sourcebankwithdrawarray = [
                            'sss_ent_bank_acc_openingbal' => $bankbalanceupdat,
                            'sss_ent_bank_last_updated_by' => session('userid'),
                            'sss_ent_bank_updated_date' => date('Y-m-d')
                        ];
                        $updatedepositebank->update($sbankid, $sourcebankwithdrawarray);
                        $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $ssdddid)->delete();
                    }

                    if ($b->sss_bb_transtype == 'Deposit' && $b->sss_bb_isdeposit != '') {

                        $ssdddid = $b->sss_ddd_id;
                        $dbankid = $b->sss_bb_destinationbankid;
                        $openingbalance = $getbankid->find($dbankid);
                        $opningbalofdestinationbank = $openingbalance['sss_ent_bank_acc_openingbal'];
                        $destinationtransamt = $b->sss_bb_isdeposit;

                        $depositebankbalanceupdat = $opningbalofdestinationbank - $destinationtransamt;
                        $destinationbankdepositearray = [
                            'sss_ent_bank_acc_openingbal' => $depositebankbalanceupdat,
                            'sss_ent_bank_last_updated_by' => session('userid'),
                            'sss_ent_bank_updated_date' => date('Y-m-d')
                        ];
                        $updatedepositebank->update($dbankid, $destinationbankdepositearray);
                        $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $ssdddid)->delete();
                    }
                }
            }

            $Tdsentries_m = new Tdsentries_m();
            $isTDSFound = $Tdsentries_m->table('sss_tbl_totaltds')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->findAll();

            if (!empty($isTDSFound)) {
                foreach ($isTDSFound as $Tds) {
                    $Tdsentries_m->table('sss_tbl_totaltds')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->delete();
                }
            }

            $allemprecord = new DDD_emp_m();
            $isEmpFound = $allemprecord->table('sss_ddd_employees')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->get()->getResult();
            if (!empty($isEmpFound)) {
                foreach ($isEmpFound as $emp) {
                    $allemprecord->table('sss_ddd_employees')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->delete();
                }
            }

            $alloutcomerecord = new DDD_outcome_m();
            $isOutcomeFound = $alloutcomerecord->table('sss_ddd_outcomes')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->get()->getResult();

            if (!empty($isOutcomeFound)) {
                foreach ($isOutcomeFound as $outcome) {

                    $alloutcomerecord->table('sss_ddd_outcomes')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->delete();
                }
            }
        }

        if (!empty($prid)) {
            // $Bankbook_m->table('sss_tbl_bankbook')->where('sss_pr_id', $prid)->delete();  // also delete entry for bb via payment received..
            $Dealdetaildraft_m->table('sss_tbl_dealdetaildraft')->where('sss_pr_id', $prid)->delete(); // delete ddd entry from pr  
        }

        echo json_encode(array("status" => TRUE));
    }

    
    
    
    
    // with month...
    // public function delete_paymentdetail($prid)
    // {
    //     // delete payment received and update bank accoutns....
    //     $Bankbook_m = new Bankbook_m();
    //     $PaymentReceived_m = new PaymentReceived_m();
        
    //     $getrecords = $PaymentReceived_m->find($prid);

    //     $bank_bookId = $Bankbook_m->table('sss_tbl_bankbook')->where('sss_pr_id', $prid)->get()->getRow();
    //     // echo "<pre>";print_r($bank_bookId);exit;

    //     // get bank id for next entries invoices.....sss_bb_transactiondate
    //     $bankId  = $bank_bookId->sss_allbankid;
    //     $bbtransaction_month = $bank_bookId->sss_bb_transmonth;

    //     $transamt = $getrecords['sss_pr_amtreceived'];

    //     if (!empty($prid))
    //         $PaymentReceived_m->table('sss_tbl_paymentreceived')->where('sss_pr_id', $prid)->delete(); // delete pr qry
    //         $Bankbook_m->table('sss_tbl_bankbook')->where('sss_pr_id', $prid)->delete();  // also delete entry for bb via payment received..

    //     //find bank account ...
    //     $invoices = new CreateInvoice_m();
    //     $invoicerecord = $invoices->find($getrecords['sss_inv_id']);
    //     $bankid = $invoicerecord['sss_inv_bankid'];

    //     //fetch payment received for re-arrange all balances...fetch by invoice id..
    //     if (!empty($getrecords)) {
            
    //         // for payment received table....
    //         $get_all_paymentreceived = $PaymentReceived_m->where('sss_pr_id >', $prid)->where('sss_tbl_paymentreceived.sss_inv_id', $getrecords['sss_inv_id'])->orderBy('sss_pr_id', 'Asc')->get()->getResult();
    //         if (!empty($get_all_paymentreceived)) {
    //             foreach ($get_all_paymentreceived as $pr_entries) {
    //                 $paymentReceivedId = $pr_entries->sss_pr_id;
    //                 $balanceamt_row = $pr_entries->sss_pr_balanceamt;
    //                 $lastbalanceamt_row = $pr_entries->sss_pr_prev_balamt;
    //                 $last_balances = $lastbalanceamt_row + $transamt; // calcualte prev balamt..
    //                 $newbalance_amt = $transamt + $balanceamt_row; // new balance amt...

    //                 $new_amountBalances = [
    //                     'sss_pr_balanceamt' => $newbalance_amt,
    //                     'sss_pr_prev_balamt' => $last_balances,
    //                     'sss_pr_paymenttype' => 'Part Payment',
    //                     'sss_pr_updated_by' => session('userid'),
    //                     'sss_pr_update_date' => date('Y-m-d')
    //                 ];
    //                 $PaymentReceived_m->update($paymentReceivedId, $new_amountBalances);
    //             }
    //         }

    //         // end....
    //         // for bankbook table....
    //         $getBankBooks = new Bankbook_m();
            
    //         $get_all_BankBook_entries = $getBankBooks->table('sss_tbl_bankbook')->where('sss_bb_transactiondate >', $bank_bookId->sss_bb_transactiondate)->where('sss_bb_transmonth',$bbtransaction_month)->where('sss_allbankid', $bankId)->get()->getResult();
            
    //         // $get_all_BankBook_entries = $getBankBooks->table('sss_tbl_bankbook')->where('sss_bankbook_id >', $bank_bookId->sss_bankbook_id)->where('sss_tbl_bankbook.sss_bb_invid', $getrecords['sss_inv_id'])->orderBy('sss_bankbook_id', 'ASC')->get()->getResult();
            
            
    //         // update openingmonths closing balance.....
    //         $MonthsBalances_m = new MonthsBalances_m();
    //         $getValueofMonthBalance = $MonthsBalances_m->where('bankid', $bankId)->where('balancemonth', $bbtransaction_month)->get()->getRow();
    //         $opngmonthbal_id = $getValueofMonthBalance->id;
            
    //         if (!empty($get_all_BankBook_entries)) {

    //             foreach ($get_all_BankBook_entries as $bb_entries) {
    //                 if ($bb_entries->sss_bb_transtype  == 'Deposit') {
    //                     $BankBookId = $bb_entries->sss_bankbook_id;
    //                     $balanceamt_row = $bb_entries->sss_bb_balance;
    //                     $lastbalanceamt_row = $bb_entries->sss_bb_lastbalance;
    //                     $newlast_balances_bb = $lastbalanceamt_row - $transamt; // calcualte prev balamt..
    //                     $newbalance_amt_bb = $newlast_balances_bb + $bb_entries->sss_bb_transamt; // new balance amt...

    //                     $deposite_new_Balances = [
    //                         'sss_bb_balance' => $newbalance_amt_bb,
    //                         'sss_bb_lastbalance' => $newlast_balances_bb,
    //                         'updatedate' => date('Y-m-d')
    //                     ];
    //                     $Bankbook_m->update($BankBookId, $deposite_new_Balances);
                        
    //                     // update openingmonths balance....
    //                     $updateData_nextentries = [
    //                         'clsngbalance' => $newbalance_amt_bb,
    //                     ];
    //                     $MonthsBalances_m->update($opngmonthbal_id, $updateData_nextentries);
                        
    //                 } else {
    //                     $BankBookId = $bb_entries->sss_bankbook_id;
    //                     $balanceamt_row = $bb_entries->sss_bb_balance;
    //                     $lastbalanceamt_row = $bb_entries->sss_bb_lastbalance;
    //                     $newlast_balances_bb = $lastbalanceamt_row - $transamt; // calcualte prev balamt..
    //                     $newbalance_amt_bb = $newlast_balances_bb - $bb_entries->sss_bb_transamt; // new balance amt...

    //                     $withdrawl_new_Balances = [
    //                         'sss_bb_balance' => $newbalance_amt_bb,
    //                         'sss_bb_lastbalance' => $newlast_balances_bb,
    //                         'updatedate' => date('Y-m-d')
    //                     ];
    //                     $Bankbook_m->update($BankBookId, $withdrawl_new_Balances);
                        
    //                     // update openingmonths balance....
    //                     $updateData_nextentries = [
    //                         'clsngbalance' => $newbalance_amt_bb,
    //                     ];
    //                     $MonthsBalances_m->update($opngmonthbal_id, $updateData_nextentries);
    //                 }
    //             }
    //         }

    //     }
        
    //     // payment received with bank balance ....
    //     if (!empty($transamt)) {
    //         $getopeningbal = new Bankdetails_m();
    //         $openingbalance = $getopeningbal->find($bankid);
    //         // $opningbalofsoucebank = $openingbalance['sss_ent_bank_acc_openingbal'];
    //         $lastupdatebal = ($openingbalance['sss_ent_bank_acc_openingbal']) - $transamt;
    //         $updatedepositebank = new Bankdetails_m();
    //         $depositebank = [
    //             'sss_ent_bank_acc_openingbal' => $lastupdatebal,
    //             'sss_ent_bank_last_updated_by' => session('userid'),
    //             'sss_ent_bank_updated_date' => date('Y-m-d')
    //         ];
    //         $updatedepositebank->update($bankid, $depositebank);
    //     }

    //     // end pr with bank balance..

    //     // delete ddc start...
    //     $Dealdisbursalchart_m = new Dealdisbursalchart_m();
    //     $ddcid = $Dealdisbursalchart_m->table('sss_tbl_dealdisbursalchart')->select('sss_pr_id')->where('sss_pr_id', $prid)->get()->getRow();
        
    //     if (!empty($ddcid)) {
    //         $Dealdisbursalchart_m->table('sss_tbl_dealdisbursalchart')->where('sss_pr_id', $prid)->delete();
    //     }

    //     // ddd delete and update bank balance start ....
    //     $Dealdetaildraft_m = new Dealdetaildraft_m();
    //     // find for bankbook id..
    //     $dddidForBB = $Dealdetaildraft_m->table('sss_tbl_dealdetaildraft')->where('sss_pr_id', $prid)->get()->getRow();

    //     $updatedepositebank = new Bankdetails_m();

    //     if (!empty($dddidForBB)) {

    //         $bb = $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->get()->getResult();
    //         $getbankid = new Bankdetails_m();

    //         if (!empty($bb)) {
    //             foreach ($bb as $b) {
    //                 if ($b->sss_bb_transtype == 'Withdrawl' && $b->sss_bb_iswithdrawl != '') {
    //                     $ssdddid = $b->sss_ddd_id;
    //                     $sbankid = $b->sss_bb_sourcebankid;
    //                     $sourcetransamt = $b->sss_bb_iswithdrawl;

    //                     $openingbalance = $getbankid->find($sbankid);
    //                     $opningbalofwithdrawlbank = $openingbalance['sss_ent_bank_acc_openingbal'];

    //                     $bankbalanceupdat = $opningbalofwithdrawlbank + $sourcetransamt;

    //                     $sourcebankwithdrawarray = [
    //                         'sss_ent_bank_acc_openingbal' => $bankbalanceupdat,
    //                         'sss_ent_bank_last_updated_by' => session('userid'),
    //                         'sss_ent_bank_updated_date' => date('Y-m-d')
    //                     ];
    //                     $updatedepositebank->update($sbankid, $sourcebankwithdrawarray);
    //                     $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $ssdddid)->delete();
    //                 }

    //                 if ($b->sss_bb_transtype == 'Deposit' && $b->sss_bb_isdeposit != '') {

    //                     $ssdddid = $b->sss_ddd_id;
    //                     $dbankid = $b->sss_bb_destinationbankid;
    //                     $openingbalance = $getbankid->find($dbankid);
    //                     $opningbalofdestinationbank = $openingbalance['sss_ent_bank_acc_openingbal'];
    //                     $destinationtransamt = $b->sss_bb_isdeposit;

    //                     $depositebankbalanceupdat = $opningbalofdestinationbank - $destinationtransamt;
    //                     $destinationbankdepositearray = [
    //                         'sss_ent_bank_acc_openingbal' => $depositebankbalanceupdat,
    //                         'sss_ent_bank_last_updated_by' => session('userid'),
    //                         'sss_ent_bank_updated_date' => date('Y-m-d')
    //                     ];
    //                     $updatedepositebank->update($dbankid, $destinationbankdepositearray);
    //                     $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $ssdddid)->delete();
    //                 }

    //                 // else if ($b->sss_bb_destinationbankid == 3 || $b->sss_bb_destinationbankid != '') {
    //                 //     $taxdddid = $b->sss_ddd_id;
    //                 //     // $taxbankid = $b->sss_bb_destinationbankid;
    //                 //     $taxtransamt = $b->sss_bb_isdeposit;  //deposite destination bank
    //                 //     $taxlastupdatebal = ($openingbalanceoftax['sss_ent_bank_acc_openingbal']) - $taxtransamt;

    //                 //     $updatebalindestinationbank_tax = new Bankdetails_m();
    //                 //     $depositetaxbankdata = [
    //                 //         'sss_ent_bank_acc_openingbal' => $taxlastupdatebal,
    //                 //         'sss_ent_bank_last_updated_by' => session('userid'),
    //                 //         'sss_ent_bank_updated_date' => date('Y-m-d')
    //                 //     ];
    //                 //     $updatebalindestinationbank_tax->update(3, $depositetaxbankdata);
    //                 //     $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $taxdddid)->delete();
    //                 // } 
    //                 // else if ($b->sss_bb_destinationbankid == 2 || $b->sss_bb_destinationbankid != '') {
    //                 //     $dddid = $b->sss_ddd_id;
    //                 //     $advbankid = $b->sss_bb_destinationbankid;
    //                 //     $dtransamt = $b->sss_bb_isdeposit;  //deposite destination bank

    //                 //     $advlastupdatebal = ($openingbalanceofadv['sss_ent_bank_acc_openingbal']) - $dtransamt;

    //                 //     $updatebalindestinationbank_tax = new Bankdetails_m();
    //                 //     $depositeadvbankdata = [
    //                 //         'sss_ent_bank_acc_openingbal' => $advlastupdatebal,
    //                 //         'sss_ent_bank_last_updated_by' => session('userid'),
    //                 //         'sss_ent_bank_updated_date' => date('Y-m-d')
    //                 //     ];
    //                 //     $updatebalindestinationbank_tax->update(2, $depositeadvbankdata);
    //                 //     $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $dddid)->delete();
    //                 // }
    //             }
    //         }

    //         $Tdsentries_m = new Tdsentries_m();
    //         $isTDSFound = $Tdsentries_m->table('sss_tbl_totaltds')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->findAll();

    //         if (!empty($isTDSFound)) {
    //             foreach ($isTDSFound as $Tds) {
    //                 $Tdsentries_m->table('sss_tbl_totaltds')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->delete();
    //             }
    //         }

    //         $allemprecord = new DDD_emp_m();
    //         $isEmpFound = $allemprecord->table('sss_ddd_employees')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->get()->getResult();
    //         if (!empty($isEmpFound)) {
    //             foreach ($isEmpFound as $emp) {
    //                 $allemprecord->table('sss_ddd_employees')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->delete();
    //             }
    //         }

    //         $alloutcomerecord = new DDD_outcome_m();
    //         $isOutcomeFound = $alloutcomerecord->table('sss_ddd_outcomes')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->get()->getResult();

    //         if (!empty($isOutcomeFound)) {
    //             foreach ($isOutcomeFound as $outcome) {

    //                 $alloutcomerecord->table('sss_ddd_outcomes')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->delete();
    //             }
    //         }
    //     }

    //     if (!empty($prid)) {
    //         // $Bankbook_m->table('sss_tbl_bankbook')->where('sss_pr_id', $prid)->delete();  // also delete entry for bb via payment received..
    //         $Dealdetaildraft_m->table('sss_tbl_dealdetaildraft')->where('sss_pr_id', $prid)->delete(); // delete ddd entry from pr  
    //     }

    //     echo json_encode(array("status" => TRUE));
    // }


    // public function delete_paymentdetail($prid)
    // {
    //     $tax_destinationbankid = new Bankdetails_m();
    //     $openingbalanceoftax = $tax_destinationbankid->find(3);

    //     $adv_destinationbankid = new Bankdetails_m();
    //     $openingbalanceofadv = $adv_destinationbankid->find(2);

    //     // delete payment received and update bank accoutns....
    //     $PaymentReceived_m = new PaymentReceived_m();
    //     $getrecords = $PaymentReceived_m->find($prid);
    //     $transamt = $getrecords['sss_pr_amtreceived'];


    //     // payment received with bank balance ....

    //     //find bank account ...
    //     $invoices = new CreateInvoice_m();
    //     $invoicerecord = $invoices->find($getrecords['sss_inv_id']);
    //     $bankid = $invoicerecord['sss_inv_bankid'];


    //     // get last balance of bank..
    //     $getopeningbal = new Bankdetails_m();
    //     $openingbalance = $getopeningbal->find($bankid);
    //     $opningbalofsoucebank = $openingbalance['sss_ent_bank_acc_openingbal'];

    //     $lastupdatebal = ($openingbalance['sss_ent_bank_acc_openingbal']) - $transamt;

    //     $updatedepositebank = new Bankdetails_m();
    //     $depositebank = [
    //         'sss_ent_bank_acc_openingbal' => $lastupdatebal,
    //         'sss_ent_bank_last_updated_by' => session('userid'),
    //         'sss_ent_bank_updated_date' => date('Y-m-d')
    //     ];

    //     $updatedepositebank->update($invoicerecord['sss_inv_bankid'], $depositebank);

    //     // end pr with bank balance..
    //     // delete ddc start...
    //     $Dealdisbursalchart_m = new Dealdisbursalchart_m();
    //     $ddcid = $Dealdisbursalchart_m->table('sss_tbl_dealdisbursalchart')->select('sss_pr_id')->where('sss_pr_id', $prid)->get()->getRow();
    //     // echo $ddcid['sss_pr_id'];
    //     if(!empty($ddcid))
    //     {
    //         $Dealdisbursalchart_m->table('sss_tbl_dealdisbursalchart')->where('sss_pr_id', $prid)->delete();
    //     }
    //     // ddd delete and update bank balance start ....
    //     $Dealdetaildraft_m = new Dealdetaildraft_m();
    //     // find for bankbook id..
    //     $dddidForBB = $Dealdetaildraft_m->table('sss_tbl_dealdetaildraft')->where('sss_pr_id', $prid)->get()->getRow();

    //     // echo "<pre>";print_r($dddidForBB);exit;
    //     $Bankbook_m = new Bankbook_m();
    //     if(!empty($dddidForBB))
    //     {
    //         $Dealdetaildraft_m->table('sss_tbl_dealdetaildraft')->where('sss_pr_id', $prid)->delete(); // delete ddd entry from pr  
    //         $bb = $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->get()->getResult();
    //         if(!empty($bb))
    //         {
    //              foreach ($bb as $b) 
    //              {
    //                 if ($b->sss_bb_transtype == 'Withdrawl' && $b->sss_bb_sourcebankid != '') {
    //                     // echo $openingbalance['sss_ent_bank_acc_openingbal'];
    //                     $ssdddid = $b->sss_ddd_id;
    //                     $sbankid = $b->sss_bb_sourcebankid;
    //                     $sourcetransamt = $b->sss_bb_iswithdrawl;
    //                     // echo "<br>" . $opningbalofsoucebank . "<br>";
    //                     $bankbalanceupdat = $opningbalofsoucebank + $sourcetransamt;

    //                     $updatedepositebank = new Bankdetails_m();
    //                     $sourcebankwithdrawarray = [
    //                         'sss_ent_bank_acc_openingbal' => $bankbalanceupdat,
    //                         'sss_ent_bank_last_updated_by' => session('userid'),
    //                         'sss_ent_bank_updated_date' => date('Y-m-d')
    //                     ];
    //                     $updatedepositebank->update($sbankid, $sourcebankwithdrawarray);
    //                     $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $ssdddid)->delete();
    //                 }

    //                 else if ($b->sss_bb_destinationbankid == 3) {

    //                     $taxdddid = $b->sss_ddd_id;
    //                     $taxbankid = $b->sss_bb_destinationbankid;
    //                     $taxtransamt = $b->sss_bb_isdeposit;  //deposite destination bank
    //                     $taxlastupdatebal = ($openingbalanceoftax['sss_ent_bank_acc_openingbal']) - $taxtransamt;

    //                     $updatebalindestinationbank_tax = new Bankdetails_m();
    //                     $depositetaxbankdata = [
    //                         'sss_ent_bank_acc_openingbal' => $taxlastupdatebal,
    //                         'sss_ent_bank_last_updated_by' => session('userid'),
    //                         'sss_ent_bank_updated_date' => date('Y-m-d')
    //                     ];
    //                     $updatebalindestinationbank_tax->update($taxbankid, $depositetaxbankdata);
    //                     $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $taxdddid)->delete();
    //                 }
    //                 else if ($b->sss_bb_destinationbankid == 2) {
    //                     $dddid = $b->sss_ddd_id;
    //                     $advbankid = $b->sss_bb_destinationbankid;
    //                     $dtransamt = $b->sss_bb_isdeposit;  //deposite destination bank

    //                     $advlastupdatebal = ($openingbalanceofadv['sss_ent_bank_acc_openingbal']) - $dtransamt;
    //                     $updatebalindestinationbank_tax = new Bankdetails_m();
    //                     $depositeadvbankdata = [
    //                         'sss_ent_bank_acc_openingbal' => $advlastupdatebal,
    //                         'sss_ent_bank_last_updated_by' => session('userid'),
    //                         'sss_ent_bank_updated_date' => date('Y-m-d')
    //                     ];
    //                     $updatebalindestinationbank_tax->update($advbankid, $depositeadvbankdata);
    //                     $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $dddid)->delete();
    //                 }
    //             }
    //         }

    //         $Tdsentries_m = new Tdsentries_m();
    //         $Tdsentries_m->table('sss_tbl_totaltds')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->delete();
    //     }



    //     $Bankbook_m->table('sss_tbl_bankbook')->where('sss_pr_id', $prid)->delete(); // also delete entry for bb via payment received..
    //     // enter tds entries.....

    //     $PaymentReceived_m->table('sss_tbl_paymentreceived')->where('sss_pr_id', $prid)->delete(); // delete pr qry
    //     echo json_encode(array("status" => TRUE));
    // }
}
