<?= $this->extend('commanfile/header'); ?>
<?= $this->section('content'); ?>
<form action="invoiceform" action="POST">
  <div class="card card-default">
    <div class="card-body">
      <div class="row">
        <div class="col-md-4">
          <div class="form-group">
            <label>Invoice Type</label>
            <select class="form-control select2" name="sss_inv_type" id="sss_inv_type">
              <option value="">Select Invoice Type</option>
              <?php foreach ($Saccode as $invoicetype) { ?>
                <option value="<?= $invoicetype->sss_sac_code_id ?>"><?= $invoicetype->sss_invoice_type ?></option>
              <?php } ?>
            </select>
            <span class="text-danger error-text sss_inv_type_error"></span>
          </div>
        </div>
        <div class="col-md-4">
          <div class="form-group">
            <label>Disbursement Status</label>
            <select class="form-control select2" name="sss_inv_disbursement_status" id="disbursementStatus">
              <option selected="selected">Disbursement</option>
              <option>No Disbursement</option>
            </select>
            <span class="text-danger error-text sss_inv_disbursement_status_error"></span>
          </div>
        </div>
        <!-- <div class="col-md-4">
          <div class="form-group">
            <label>Select Year</label>
            <select class="form-control select2" name="sss_inv_disbursement_status" id="disbursementStatus">
              <option selected="selected">Select Year</option>
              <option>No Disbursement</option>
            </select>
          </div>
        </div> -->
      </div>
      <div class="row">
        <div class="col-md-6">
          <label>Bill Number</label>
          <div class="row">
            <div class="col-md-3">
              <div class="form-group">
                <div class="input-group">
                  <input type="text" class="form-control" value="<?= $billno ?>" readonly name="sss_inv_bill_no" id="billNumber">
                </div>
              </div>
            </div><span class="slash">/</span>
            <div class="col-md-3">
              <div class="form-group">
                <div class="input-group">
                  <input type="text" class="form-control" id="billDefaultText" name="" value="<?= session('inv_initial') ?>" readonly>
                </div>
              </div>
            </div><span class="slash">/</span>
            <div class="col-md-3">
              <div class="form-group">
                <div class="input-group">
                  <input type="text" class="form-control" id="billCurrentFinYear" value="<?php echo date('y') . ' - ' . date('y', strtotime('+1 year')) ?>"  disabled>
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="col-md-6">
          <div class="form-group">
            <label>Bill Date</label>
            <div class="input-group date" id="billDate" data-target-input="nearest">
              <input type="text" name="sss_inv_bill_date" class="form-control datetimepicker-input" data-target="#billDate" />
              <div class="input-group-append" id="billDate" data-target="#billDate" data-toggle="datetimepicker">
                <div class="input-group-text"><i class="fa fa-calendar"></i></div>
              </div>
              <span class="text-danger error-text sss_inv_bill_date_error"></span>
            </div>
          </div>
        </div>
      </div>
      <div class="row">
        <div class="col-md-6">
          <div class="form-group">
            <label>Client Name</label>
            <select class="form-control select2" name="sss_inv_client_id" id="sss_inv_client_id">
              <option selected="selected">Select Client Name</option>
              <?php foreach ($clients as $client) { ?>
                <option value="<?= $client->sss_client_id ?>"><?= $client->sss_client_name ?></option>
              <?php } ?>
            </select>
            <span class="text-danger error-text sss_inv_client_id_error"></span>
          </div>
        </div>
        <div class="col-md-6">
          <div class="form-group">
            <label>Place of Service</label>
            <div class="input-group">
              <input type="text" class="form-control" id="placeofservice" disabled>
            </div>
          </div>
        </div>
      </div>
      <div class="row">
        <div class="col-md-6">
          <div class="form-group">
            <label>State Code</label>
            <div class="input-group">
              <input type="text" class="form-control" id="statecode" disabled>
            </div>
          </div>
        </div>
        <div class="col-md-6">
          <div class="form-group">
            <label>GSTIN Number</label>
            <div class="input-group">
              <input type="text" class="form-control" id="cxgstnumber" disabled>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>

  <div class="card card-default">
    <div class="card-header">
      <h3 class="card-title">Invoice Transactions</h3>
    </div>
    <div class="card-body">
      <div class="row">
        <div class="col-md-9">
          <label>DESCRIPTION</label>
        </div>
        <div class="col-md-3">
          <label>AMOUNT</label>
        </div>
      </div>
      <div class="row">
        <div class="col-md-9">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control" id="scode" name="scode" placeholder="Property management services on a feee or a commission basis. [Real Estate Agent] SAC Code - " disabled>
            </div>
          </div>
        </div>
        <div class="col-md-3">
        </div>
      </div>
      <div class="row">
        <div class="col-md-9">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control" id="sss_inv_brief" name="sss_inv_brief" placeholder="Brief Description">
            </div>
            <span class="text-danger error-text sss_inv_brief_error"></span>
          </div>
        </div>
        <div class="col-md-3">
        </div>
      </div>
      <div class="row">
        <div class="col-md-9">
          <div class="row">
            <div class="col-md-4">
              <div class="form-group">
                <div class="input-group">
                  <select class="form-control select2" name="sss_inv_duration" id="duration">
                    <option selected="selected">1 Month</option>
                    <option>2 Months</option>
                    <option>3 Months</option>
                    <option>4 Months</option>
                    <option>5 Months</option>
                    <option>6 Months</option>
                    <option>7 Months</option>
                    <option>8 Months</option>
                    <option>9 Months</option>
                    <option>10 Months</option>
                    <option>11 Months</option>
                    <option>12 Months</option>
                    <option>15 Days</option>
                    <option>LUMPSUM</option>
                    <option>Others</option>
                  </select>
                  <span class="text-danger error-text sss_inv_duration_error"></span>
                </div>
              </div>
            </div>
            <div class="col-md-4">
              <div class="form-group">
                <div class="input-group">
                  <input type="text" class="form-control" name="sss_inv_duration_others" id="sss_inv_duration_others" placeholder="" disabled>
                </div>
                <span class="text-danger error-text sss_inv_duration_others_error"></span>
              </div>
            </div>
          </div>
        </div>
        <div class="col-md-3">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control" name="sss_inv_amt" id="sss_inv_amt" placeholder="">
            </div>
            <span class="text-danger error-text sss_inv_amt_error"></span>
          </div>
        </div>
      </div>
      <div class="row">
        <div class="col-md-9">
          <div class="row">
            <div class="col-md-4">
              <div class="form-group">
                <div class="input-group">
                  <select class="form-control select2" name="sss_inv_transaction_type" id="sss_inv_transaction_type">
                    <option selected="selected">Premise</option>
                    <option>Liasoning Charges</option>
                  </select>
                  <span class="text-danger error-text sss_inv_transaction_type_error"></span>
                </div>
              </div>
            </div>
            <div class="col-md-8">
              <div class="form-group">
                <div class="input-group">
                  <input type="text" class="form-control" name="sss_inv_addr" id="sss_inv_addr" placeholder="Invoice Address">
                </div>
                <span class="text-danger error-text sss_inv_addr_error"></span>
              </div>
            </div>
          </div>
        </div>
        <div class="col-md-3">
        </div>
      </div>
      <div class="row">
        <div class="col-md-9">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control" id="depositLabel" placeholder="Deposit" disabled>
            </div>
          </div>
        </div>
        <div class="col-md-3">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control" name="sss_inv_deposite_amt" id="sss_inv_deposite_amt">
            </div>
          </div>
        </div>
      </div>
      <div class="row">
        <div class="col-md-9">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control" name="" id="" placeholder="SGST" disabled>
            </div>
          </div>
        </div>
        <div class="col-md-3">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control" name="sss_inv_sgst" id="sss_inv_sgst">
            </div>
          </div>
        </div>
      </div>
      <div class="row">
        <div class="col-md-9">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control" id="cgstLabel" placeholder="CGST" disabled>
            </div>
          </div>
        </div>
        <div class="col-md-3">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control" name="sss_inv_cgst" id="sss_inv_cgst">
            </div>
          </div>
        </div>
      </div>
      <div class="row">
        <div class="col-md-9">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control" id="igstLabel" placeholder="IGST" disabled>
            </div>
          </div>
        </div>
        <div class="col-md-3">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control" name="sss_inv_igst" id="sss_inv_igst">
            </div>
          </div>
        </div>
      </div>
      <div class="row">
        <div class="col-md-9">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control" id="invoiceAmountInWords" placeholder="Amount In Words" disabled>
            </div>
          </div>
        </div>
        <div class="col-md-3">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control" id="sss_inv_total_amt" name="sss_inv_total_amt" placeholder="Total Amount" disabled>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
  <div class="card card-default">
    <div class="card-header">
      <h3 class="card-title">RTGS Details</h3>
    </div>
    <div class="card-body">
      <div class="row">
        <div class="col-md-3">
          <div class="form-group">
            <label>Bank Name</label>
            <div class="input-group">
              <select class="form-control select2" name="sss_inv_bankid" id="sss_inv_bankid">
                <option selected="selected">Select Bank</option>
                <?php foreach ($bankdetails as $bank) { ?>
                  <option value="<?= $bank->sss_ent_bank_id ?>"><?= $bank->sss_ent_bank_name ?></option>
                <?php } ?>
              </select>
              <span class="text-danger error-text sss_inv_bankid_error"></span>
            </div>
          </div>
        </div>
        <div class="col-md-3">
          <div class="form-group">
            <label>Account Name</label>
            <div class="input-group">
              <input type="text" class="form-control" id="bankname" readonly>
            </div>
          </div>
        </div>

        <div class="col-md-3">
          <div class="form-group">
            <label>Account Number</label>
            <div class="input-group">
              <input type="text" class="form-control" id="accno" disabled>
            </div>
          </div>
        </div>
        <div class="col-md-3">
          <div class="form-group">
            <label>IFSC Code</label>
            <div class="input-group">
              <input type="text" class="form-control" id="ifsccode" disabled>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
  <div class="card card-default">
    <div class="card-header">
      <h3 class="card-title">Entity Details</h3>
    </div>
    <div class="card-body">
      <div class="row">
        <div class="col-md-6">
          <div class="form-group">
            <label>GST Number</label>
            <div class="input-group">
              <input type="text" class="form-control" id="entityGSTNumber" value="<?= session('gstno') ?>" disabled>
            </div>
          </div>
        </div>
        <div class="col-md-6">
          <div class="form-group">
            <label>PAN Number</label>
            <div class="input-group">
              <input type="text" class="form-control" id="entityPAN" value="<?= session('panno') ?>" disabled>
            </div>
          </div>
        </div>
      </div>
      <div class="row">
        <div class="col-md-12">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control" id="forStatementEntity" value="<?= session('ent_name') ?>" placeholder="For Sure Shot Suggestions India Private Limited" disabled>
            </div>
          </div>
        </div>
      </div>
      <div class="row">
        <div class="col-md-12">
          <button type="button" class="btn btn-secondary float-left">Cancel</button>
          <button type="button" onclick="save_invoice()" class="btn btn-warning float-left" style="margin-left: 10px;">Submit</button>
        </div>
      </div>
    </div>
  </div>
</form>
<script>
  $(document).ready(function() {
    $('#sss_inv_type').on('change', function() {
      let sid = this.value;
      let url = "<?= base_url() ?>/getsaccode/" + sid;
      $.ajax({
        url: url,
        type: "GET",
        dataType: "JSON",
        success: function(data) {
          document.getElementById("scode").placeholder = "Property management services on a feee or a commission basis. [Real Estate Agent] SAC Code - " + data.sss_sac_code;
        },

      });
    });

    $('#sss_inv_client_id').on('change', function() {
      let sss_inv_client_id = this.value;
      let url = "<?= base_url() ?>/getcx/" + sss_inv_client_id;
      $.ajax({
        url: url,
        type: "GET",
        dataType: "JSON",
        success: function(data) {
          $('#placeofservice').val(data.sss_client_placeofservice);
          $('#statecode').val(data.sss_client_statecode);
          $('#cxgstnumber').val(data.sss_client_gstno);
        },
      });
    });
    $('#sss_inv_bankid').on('change', function() {
      let sss_inv_bankid = this.value;
      let url = "<?= base_url() ?>/getbank/" + sss_inv_bankid;
      $.ajax({
        url: url,
        type: "GET",
        dataType: "JSON",
        success: function(data) {
          $('#bankname').val(data.sss_ent_bank_acc_name);
          $('#accno').val(data.sss_ent_bank_acc_no);
          $('#ifsccode').val(data.sss_ent_bank_acc_ifsc);
        },
      });
    });
  });

  function save_invoice() {
    $('#btnSave').text('saving info...'); //change button text
    $('#btnSave').attr('disabled', true); //set button disable 
    var url = "<?= base_url() ?>/saveinvoice";
    // if (save_method == 'add') {
    //   url = "<?= base_url() ?>/insertbankdetail";
    // } else {
    //   url = "<?php echo base_url() ?>/updatebankdetail";
    // }
    var formData = new FormData($('#invoiceform')[0]);
    $.ajax({
      url: url,
      type: "POST",
      data: formData,
      contentType: false,
      processData: false,
      dataType: "JSON",
      success: function(data) {
        if (data.status == true) //if success close modal and reload ajax table
        {
          Swal.fire(
            data.message
          )
          $('#invoiceform')[0].reset();
          form.ajax.reload(null, false); //reload datatable ajax 
        } else {
          $.each(data.error, function(prefix, val) {
            $(`span.${prefix}_error`).text(val)
            // $('#addbankform').find(`span.${prefix}_error`).text(val);
            // $(saccode_data).find('span.' +prefix+ '_error').text(val);
          });
        }
        $('#btnSave').text('save'); //change button text
        $('#btnSave').attr('disabled', false); //set button enable 
      }
    });
  }
</script>
<?= $this->endSection(); ?>