<?= $this->extend('commanfile/header'); ?>
<?= $this->section('content'); ?>
<form id="invoiceform" action="POST">
  <div class="card card-default">
    <div class="card-body">
      <div class="row">
        <div class="col-md-4">
          <div class="form-group">
            <label>Invoice Type</label>
            <select class="form-control select2" name="sss_inv_type" id="sss_inv_type">
              <option value="">Select Invoice Type</option>
              <?php foreach ($Saccode as $invoicetype) { ?>
                <option value="<?= $invoicetype->sss_sac_code_id ?>"><?= $invoicetype->sss_invoice_type ?></option>
              <?php } ?>
            </select>
          </div>
          <span class="text-danger error-text sss_inv_type_error"></span>
        </div>
        <div class="col-md-4">
          <div class="form-group">
            <label>Disbursement Status</label>
            <select class="form-control select2" name="sss_inv_disbursement_status" id="disbursementStatus">
              <option selected="selected">Disbursement</option>
              <option>No Disbursement</option>
            </select>
            <span class="text-danger error-text sss_inv_disbursement_status_error"></span>
          </div>
        </div>
        <!-- <div class="col-md-4">
          <div class="form-group">
            <label>Disbursement Status</label>
            <select class="form-control select2" name="financial_year" id="disbursementStatus">
              <option selected="selected">Disbursement</option>
              <option>No Disbursement</option>
            </select>
            <span class="text-danger error-text sss_inv_disbursement_status_error"></span>
          </div>
        </div> -->
      </div>
      <div class="row">
        <div class="col-md-6">
          <div class="form-group">
            <label>Bill Date</label>
            <!-- <div class="input-group date" id="billDate" data-target-input="nearest">
              <input type="text" name="sss_inv_bill_date" id="sss_inv_bill_date" class="form-control  datetimepicker-input" data-target="#billDate" />
              <div class="input-group-append" id="billDate" data-target="#billDate" data-toggle="datetimepicker">
                <div class="input-group-text" id="invdate"><i class="fa fa-calendar"></i></div>
              </div>
            </div> -->
            <input type="date" class="form-control" name="sss_inv_bill_date" min="1997-01-01" max="2030-12-31" id="sss_inv_bill_date" />

          </div>
          <span class="text-danger error-text sss_inv_bill_date_error"></span>
        </div>

        <div class="col-md-6">
          <label>Bill Number</label>
          <div class="row">
            <div class="col-md-3">
              <div class="form-group">
                <div class="input-group">
                  <input type="text" class="form-control" value="<?= $billno ?>" readonly name="sss_inv_bill_no" id="billNumber">
                </div>
              </div>
            </div><span class="slash">/</span>
            <div class="col-md-3">
              <div class="form-group">
                <div class="input-group">
                  <input type="text" class="form-control" id="billDefaultText" name="invinitial" value="<?= session('inv_initial') ?>" readonly>
                </div>
              </div>
            </div><span class="slash">/</span>
            <div class="col-md-3">
              <div class="form-group">
                <div class="input-group">
                  <input type="text" class="form-control" name="invyear" id="invyear" value="" readonly>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
      <div class="row">
        <div class="col-md-4">
          <div class="form-group">
            <label>Client Name</label>
            <select class="form-control select2" name="sss_inv_client_id" id="sss_inv_client_id">
              <option>Select Client Name</option>
              <?php foreach ($clients as $client) { ?>
                <option value="<?= $client->sss_client_id ?>"><?= $client->sss_client_name ?></option>
              <?php } ?>
            </select>
            <span class="text-danger error-text sss_inv_client_id_error"></span>
          </div>
        </div>
        <div class="col-md-4">
          <div class="form-group">
            <label>Place of Service</label>
            <div class="input-group">
              <input type="text" class="form-control" name="placeofservice" id="placeofservice" disabled>
            </div>
          </div>
        </div>
        <div class="col-md-4">
          <div class="form-group">
            <label>City</label>
            <div class="input-group">
              <input type="text" class="form-control" name="sss_inv_city" placeholder="Mention City">
            </div>
          </div>
        </div>
      </div>
      <div class="row">
        <div class="col-md-6">
          <div class="form-group">
            <label>State Code</label>
            <div class="input-group">
              <input type="text" class="form-control" id="statecode" disabled>
            </div>
          </div>
        </div>
        <div class="col-md-6">
          <div class="form-group">
            <label>GSTIN Number</label>
            <div class="input-group">
              <input type="text" class="form-control" id="cxgstnumber" disabled>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
  <div class="card card-default">
    <div class="card-header">
      <h3 class="card-title">Invoice Transactions</h3>
    </div>
    <div class="card-body">
      <div class="row">
        <div class="col-md-9">
          <label>DESCRIPTION</label>
        </div>
        <div class="col-md-3">
          <label>AMOUNT</label>
        </div>
      </div>
      <div class="row">
        <div class="col-md-9">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control" id="scode" name="scode" placeholder="Property management services on a feee or a commission basis. [Real Estate Agent] SAC Code - " readonly>
              <input type="text" class="form-control" hidden id="sss_inv_desc" name="sss_inv_desc">
            </div>
          </div>
        </div>
        <div class="col-md-3">
        </div>
      </div>
      <div class="row">
        <div class="col-md-9">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control" id="sss_inv_brief" name="sss_inv_brief" placeholder="Brief Description">
            </div>
            <span class="text-danger error-text sss_inv_brief_error"></span>
          </div>
        </div>
        <div class="col-md-3">
        </div>
      </div>
      <div class="row">
        <div class="col-md-9">
          <div class="row">
            <div class="col-md-4">
              <div class="form-group">
                <div class="input-group">
                  <select class="form-control select2" name="sss_inv_duration" id="sss_inv_duration">
                    <option value="1 Month" selected="selected">1 Month</option>
                    <option value="2 Months">2 Months</option>
                    <option value="3 Months">3 Months</option>
                    <option value="4 Months">4 Months</option>
                    <option value="5 Months">5 Months</option>
                    <option value="6 Months">6 Months</option>
                    <option value="7 Months">7 Months</option>
                    <option value="8 Months">8 Months</option>
                    <option value="9 Months">9 Months</option>
                    <option value="10 Months">10 Months</option>
                    <option value="11 Months">11 Months</option>
                    <option value="12 Months">12 Months</option>
                    <option value="15 Days">15 Days</option>
                    <option value="LUMPSUM">LUMPSUM</option>
                    <option value="Others">Others</option>
                  </select>
                  <span class="text-danger error-text sss_inv_duration_error"></span>
                </div>
              </div>
            </div>
            <div class="col-md-4">
              <div class="form-group otherblock" style="display: none;">
                <div class="input-group">
                  <input type="text" class="form-control" name="sss_inv_duration_others" id="sss_inv_duration_others" placeholder="Other Duration">
                </div>
                <span class="text-danger error-text sss_inv_duration_others_error"></span>
              </div>
            </div>
          </div>
        </div>
        <div class="col-md-3">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control sss_inv_amt" name="sss_inv_amt" id="sss_inv_amt" placeholder="Amount">
            </div>
            <span class="text-danger error-text sss_inv_amt_error"></span>
          </div>
        </div>
      </div>
      <div class="row">
        <div class="col-md-9">
          <div class="row">
            <div class="col-md-4">
              <div class="form-group">
                <div class="input-group">
                  <select class="form-control select2" name="sss_inv_transaction_type" id="sss_inv_transaction_type">
                    <option selected="selected">Premise</option>
                    <option>Liasoning Charges</option>
                  </select>
                  <span class="text-danger error-text sss_inv_transaction_type_error"></span>
                </div>
              </div>
            </div>
            <div class="col-md-8">
              <div class="form-group">
                <div class="input-group">
                  <input type="text" class="form-control" name="sss_inv_addr" id="clientaddr" readonly placeholder="Invoice Address">
                </div>
                <span class="text-danger error-text sss_inv_addr_error"></span>
              </div>
            </div>
          </div>
        </div>
        <div class="col-md-3">
        </div>
      </div>
      <div class="row">
        <div class="col-md-9">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control" id="depositLabel" placeholder="Deposit" disabled>
            </div>
          </div>
        </div>
        <div class="col-md-3">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control" name="sss_inv_deposite_amt" placeholder="Deposit Amount" id="sss_inv_deposite_amt">
            </div>
            <span class="text-danger error-text sss_inv_deposite_amt_error"></span>
          </div>
        </div>
      </div>
      <div class="row">
        <div class="col-md-9">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control" name="" id="" placeholder="SGST" disabled>
            </div>
          </div>
        </div>
        <div class="col-md-3">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control sss_inv_sgst" name="sss_inv_sgst" placeholder="SGST" id="sss_inv_sgst">
            </div>
          </div>
        </div>
      </div>
      <div class="row">
        <div class="col-md-9">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control" readonly id="cgstLabel" placeholder="CGST">
            </div>
          </div>
        </div>
        <div class="col-md-3">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control sss_inv_cgst" name="sss_inv_cgst" placeholder="CGST" id="sss_inv_cgst">
            </div>
          </div>
        </div>
      </div>
      <div class="row">
        <div class="col-md-9">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control " id="igstLabel" placeholder="IGST" disabled>
            </div>
          </div>
        </div>
        <div class="col-md-3">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control sss_inv_igst" name="sss_inv_igst" placeholder="IGST" id="sss_inv_igst">
            </div>
          </div>
        </div>
      </div>
      <div class="row">
        <div class="col-md-9">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control" name="sss_inv_amtinwords" id="invoiceAmountInWords" placeholder="Amount In Words">
            </div>
          </div>
        </div>
        <div class="col-md-3">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control sss_inv_total_amt" id="sss_inv_total_amt" name="sss_inv_total_amt" placeholder="Total Amount">
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
  <div class="card card-default">
    <div class="card-header">
      <h3 class="card-title">RTGS Details</h3>
    </div>
    <div class="card-body">
      <div class="row">
        <div class="col-md-6">
          <div class="form-group">
            <label>Bank Name</label>
            <div class="input-group">
              <select class="form-control select2 sss_inv_bankid" name="sss_inv_bankid" id="sss_inv_bankid">
                <option selected="selected">Select Bank</option>
                <?php foreach ($bankdetails as $bank) { ?>
                  <option value="<?= $bank->sss_ent_bank_id ?>" <?php if ($bank->sss_ent_bank_name == 'HDFC BANK') echo 'selected="selected"'; ?>><?= $bank->sss_ent_bank_name ?></option>
                <?php } ?>
              </select>
              <span class="text-danger error-text sss_inv_bankid_error"></span>
            </div>
          </div>
        </div>
        <div class="col-md-6">
          <div class="form-group">
            <label>Account Name</label>
            <div class="input-group">
              <input type="text" class="form-control" id="bankname" readonly>
            </div>
          </div>
        </div>
      </div>
      <div class="row">
        <div class="col-md-6">
          <div class="form-group">
            <label>Account Number</label>
            <div class="input-group">
              <input type="text" class="form-control" id="accno" disabled>
            </div>
          </div>
        </div>
        <div class="col-md-6">
          <div class="form-group">
            <label>IFSC Code</label>
            <div class="input-group">
              <input type="text" class="form-control" id="ifsccode" disabled>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
  <div class="card card-default">
    <div class="card-header">
      <h3 class="card-title">Entity Details</h3>
    </div>
    <div class="card-body">
      <div class="row">
        <div class="col-md-6">
          <div class="form-group">
            <label>GST Number</label>
            <div class="input-group">
              <input type="text" class="form-control" id="entityGSTNumber" value="<?= session('gstno') ?>" disabled>
            </div>
          </div>
        </div>
        <div class="col-md-6">
          <div class="form-group">
            <label>PAN Number</label>
            <div class="input-group">
              <input type="text" class="form-control" id="entityPAN" value="<?= session('panno') ?>" disabled>
            </div>
          </div>
        </div>
      </div>
      <div class="row">
        <div class="col-md-6">
          <div class="form-group">
            <label>Udhyam Adhar Number</label>
            <div class="input-group">
              <input type="text" class="form-control" id="uadhar" value="<?= session('uadhar') ?>" placeholder="" disabled>
            </div>
          </div>
        </div>
        <div class="col-md-6">
          <div class="form-group">
            <label>For</label>
            <div class="input-group">
              <input type="text" class="form-control" id="forStatementEntity" value="<?= session('ent_name') ?>" placeholder="For Sure Shot Suggestions India Private Limited" disabled>
            </div>
          </div>
        </div>
      </div>
      <div class="row">
        <div class="col-md-12">
          <button type="button" onclick="save_invoice()" class="btn btn-warning float-left" style="margin-right:10px;">Submit</button>
          <a href="<?= base_url() ?>/invoicetable" class="btn btn-secondary float-left">Cancel</a>
        </div>
      </div>
    </div>
  </div>
</form>
<script>
  function converttocomma(x) {
    x = x.toString();
    var afterPoint = '';
    if (x.indexOf('.') > 0)
      afterPoint = x.substring(x.indexOf('.'), x.length);
    x = Math.floor(x);
    x = x.toString();
    var lastThree = x.substring(x.length - 3);
    var otherNumbers = x.substring(0, x.length - 3);
    if (otherNumbers != '')
      lastThree = ',' + lastThree;
    var res = otherNumbers.replace(/\B(?=(\d{2})+(?!\d))/g, ",") + lastThree + afterPoint;
    return res;
  }
  $(document).ready(function() {

    // select hdfc bank by default...
    let sss_inv_bankid = $('.sss_inv_bankid').val();
    let url = "<?= base_url() ?>/getbank/" + sss_inv_bankid;
    $.ajax({
      url: url,
      type: "GET",
      dataType: "JSON",
      success: function(data) {
        $('#bankname').val(data.sss_ent_bank_acc_name);
        $('#accno').val(data.sss_ent_bank_acc_no);
        $('#ifsccode').val(data.sss_ent_bank_acc_ifsc);

      },
    });

    let gstapplicable = 0;
    let finalamount = 0;

    // $('.sss_inv_sgst').prop('readonly', true);
    // $('.sss_inv_cgst').prop('readonly', true);
    // $('.sss_inv_igst').prop('readonly', true);

    // remove validation message
    $("input").change(function() {
      $(this).parent().parent().children().remove(`span`);
    });

    $("select").change(function() {
      $(this).parent().parent().children().remove(`span`);

    });


    $('#sss_inv_bill_date').on('change', function() {
      bdate = $(this).val();
      var dates = new Date(bdate);
      var str = dates.getMonth() + 1;
      if ((dates.getMonth() + 1) <= 3) {
        fiscalyear = (dates.getFullYear() - 1) + "-" + dates.getFullYear();
        // console.log(fiscalyear);
        $('#invyear').val(fiscalyear);
      } else {
        fiscalyear = dates.getFullYear() + "-" + (dates.getFullYear() + 1);
        // console.log(fiscalyear);
        $('#invyear').val(fiscalyear);
      }
    });


    $('#sss_inv_type').on('change', function() {
      let sid = this.value;
      let url = "<?= base_url() ?>/getsaccode/" + sid;
      $.ajax({
        url: url,
        type: "GET",
        dataType: "JSON",
        success: function(data) {

          if (data.sss_invoice_type == "Rental-Residential") {
            let desc = document.getElementById("scode").placeholder = "Rental or Leasing Service involving Own Or Leased Residential Property - SAC Code - " + data.sss_sac_code;
            $('#sss_inv_desc').val(desc);
          } else if (data.sss_invoice_type == "Rental-Commercial") {
            let desc = document.getElementById("scode").placeholder = "Rental or Leasing Service involving Own Or Leased Non-Residential Property - SAC Code - " + data.sss_sac_code;
            $('#sss_inv_desc').val(desc);
          } else {
            let desc = document.getElementById("scode").placeholder = "Property management services on a feee or a commission basis. [Real Estate Agent] SAC Code - " + data.sss_sac_code;
            $('#sss_inv_desc').val(desc);
          }
        },

      });
    });

    $('#sss_inv_client_id').on('change', function() {

      $('.sss_inv_amt').val();
      $('.sss_inv_cgst').val();
      $('.sss_inv_sgst').val();
      $('.sss_inv_igst').val();
      $('.sss_inv_total_amt').val();
      $('.sss_inv_deposite_amt').val();

      let sss_inv_client_id = this.value;
      let url = "<?= base_url() ?>/getcx/" + sss_inv_client_id;
      $.ajax({
        url: url,
        type: "GET",
        dataType: "JSON",
        success: function(data) {
          $('#placeofservice').val(data.sss_client_placeofservice);
          $('#statecode').val(data.sss_client_statecode);
          $('#cxgstnumber').val(data.sss_client_gstno);
          $('#clientaddr').val(data.sss_client_addr);
          gstapplicable = data.sss_client_gstapplicable;
          // if (data.sss_client_gstapplicable == 'Yes') {
          //   $('.sss_inv_cgst').prop('readonly', true)
          //   $('.sss_inv_sgst').prop('readonly', true)
          //   $('.sss_inv_igst').prop('readonly', true)
          // } else {
          //   $('.sss_inv_cgst').prop('readonly', false)
          //   $('.sss_inv_sgst').prop('readonly', false)
          //   $('.sss_inv_igst').prop('readonly', false)
          // }
        },

      });
    });

    $('#sss_inv_bankid').on('change', function() {

      let sss_inv_bankid = this.value;
      let url = "<?= base_url() ?>/getbank/" + sss_inv_bankid;
      $.ajax({
        url: url,
        type: "GET",
        dataType: "JSON",
        success: function(data) {
          $('#bankname').val(data.sss_ent_bank_acc_name);
          $('#accno').val(data.sss_ent_bank_acc_no);
          $('#ifsccode').val(data.sss_ent_bank_acc_ifsc);

        },
      });
    });

    $('#sss_inv_duration').on('change', function() {
      if (this.value == "Others") {
        $('#sss_inv_duration_others').attr('required', false);
        $('.otherblock').css('display', 'block');
      } else {
        $('#sss_inv_duration_others').attr('required', true);
        $('.otherblock').css('display', 'none');
        $('#sss_inv_duration_others').val('');
      }
    });

    $('[name="sss_inv_amt"]').on('type, change', function() {
      let placeofservice = $('[name="placeofservice"]').val();
      let amount = $(this).val();
      let depositeamount = $('[name="sss_inv_deposite_amt"]').val();
      let cgsts = Number(amount * 9) / 100;
      let cgst = cgsts.toFixed()
      let sgsts = Number(amount * 9) / 100;
      let sgst = sgsts.toFixed()
      let igsts = Number(amount * 18) / 100;
      let igst = igsts.toFixed()
      // if (placeofservice != "Maharashtra") {
      //   $('[name="sss_inv_cgst"]').val();
      //   $('[name="sss_inv_sgst"]').val();
      //   $('[name="sss_inv_igst"]').val(igst);
      // } else {
      //   $('[name="sss_inv_cgst"]').val(cgst);
      //   $('[name="sss_inv_sgst"]').val(sgst);
      //   $('[name="sss_inv_igst"]').val();
      // }
    });

    $('[name="sss_inv_deposite_amt"]').on('type, change', function() {
      let amount = $('[name="sss_inv_amt"]').val();
      let depositeamount = $(this).val();
      let totalamount = Number(amount) + Number(depositeamount);
      var place = $('#placeofservice').val();

      if (gstapplicable == 'Yes') {
        if (place !== "Maharashtra" || place == "") {
          let igsts = Number(totalamount * 18) / 100;
          let igst = igsts.toFixed();
          $('[name="sss_inv_cgst"]').val();
          $('[name="sss_inv_sgst"]').val();
          $('[name="sss_inv_igst"]').val(igst);
          finalamount = parseInt(totalamount) + parseInt(igst);
          $('[name="sss_inv_total_amt"]').val(finalamount);
          let result = numberToWords(finalamount);
          result = result.toLowerCase().replace(/\b[a-z]/g, function(letter) {
            return letter.toUpperCase();
          });
          $('#invoiceAmountInWords').val(result);
        } else {
          let cgsts = Number(totalamount * 9) / 100;
          let cgst = cgsts.toFixed();
          let sgsts = Number(totalamount * 9) / 100;
          let sgst = sgsts.toFixed();
          $('[name="sss_inv_cgst"]').val(cgst);
          $('[name="sss_inv_sgst"]').val(sgst);
          $('[name="sss_inv_igst"]').val();
          finalamount = parseInt(totalamount) + parseInt(cgst) + parseInt(sgst);

          $('[name="sss_inv_total_amt"]').val(finalamount);
          
          // var v = converttocomma(finalamount);
          // $('[name="sss_inv_total_amt"]').val(v);
        
          let result = numberToWords(finalamount);
          result = result.toLowerCase().replace(/\b[a-z]/g, function(letter) {
            return letter.toUpperCase();
          });
          $('#invoiceAmountInWords').val(result);
        }
      } else {
        let amount = $('[name="sss_inv_amt"]').val();
        let depositeamount = $(this).val();
        let totalamount = Number(amount) + Number(depositeamount);
        $('[name="sss_inv_cgst"]').val();
        $('[name="sss_inv_sgst"]').val();
        $('[name="sss_inv_igst"]').val();
        $('[name="sss_inv_total_amt"]').val(totalamount);

        let result = numberToWords(totalamount);
        result = result.toLowerCase().replace(/\b[a-z]/g, function(letter) {
          return letter.toUpperCase();
        });
        $('#invoiceAmountInWords').val(result);
      }

    });
  });




  function save_invoice() {
    $('#btnSave').text('saving info...'); //change button text
    $('#btnSave').attr('disabled', true); //set button disable 
    var url = "<?= base_url() ?>/saveinvoice";
    var formData = new FormData($('#invoiceform')[0]);
    $.ajax({
      url: url,
      type: "post",
      data: formData,
      contentType: false,
      processData: false,
      dataType: "JSON",
      success: function(data) {
        if (data.status == true) //if success close modal and reload ajax table
        {
          Swal.fire({
            text: data.message,
            focusConfirm: true,
            confirmButtonText: '<a class="btn btn-sm" style="color:#fff;" onclick="location.reload()">OK</a>',
          });
          setTimeout(function() {
            $('#loader').show();
          }, 2500);
          setTimeout(function() {
            location.reload();
          }, 2700);
          // $('#invoiceform')[0].reset();
          // location.reload();
        } else {
          $.each(data.error, function(prefix, val) {
            // $(`span.${prefix}_error`).text(val);
            $('#invoiceform').find(`span.${prefix}_error`).text(val);
            // $(saccode_data).find('span.' +prefix+ '_error').text(val);
          });
        }
        $('#btnSave').text('save'); //change button text
        $('#btnSave').attr('disabled', false); //set button enable 
      }
    });
  }

  function numberToWords(num) {
    // var digit = ['zero', 'one', 'two', 'three', 'four', 'five', 'six', 'seven', 'eight', 'nine'];
    // var elevenSeries = ['ten', 'eleven', 'twelve', 'thirteen', 'fourteen', 'fifteen', 'sixteen', 'seventeen', 'eighteen', 'nineteen'];
    // var countingByTens = ['twenty', 'thirty', 'forty', 'fifty', 'sixty', 'seventy', 'eighty', 'ninety'];
    // var shortScale = ['', 'thousand', 'million', 'billion', 'trillion'];

    // number = number.toString();
    // number = number.replace(/[\, ]/g, '');
    // if (number != parseFloat(number)) return 'not a number';
    // var x = number.indexOf('.');
    // if (x == -1) x = number.length;
    // if (x > 15) return 'too big';
    // var n = number.split('');
    // var str = '';
    // var sk = 0;
    // for (var i = 0; i < x; i++) {
    //   if ((x - i) % 3 == 2) {
    //     if (n[i] == '1') {
    //       str += elevenSeries[Number(n[i + 1])] + ' ';
    //       i++;
    //       sk = 1;
    //     } else if (n[i] != 0) {
    //       str += countingByTens[n[i] - 2] + ' ';
    //       sk = 1;
    //     }
    //   } else if (n[i] != 0) {
    //     str += digit[n[i]] + ' ';
    //     if ((x - i) % 3 == 0) str += 'hundred ';
    //     sk = 1;
    //   }
    //   if ((x - i) % 3 == 1) {
    //     if (sk) str += shortScale[(x - i - 1) / 3] + ' ';
    //     sk = 0;
    //   }
    // }
    // if (x != number.length) {
    //   var y = number.length;
    //   str += 'point ';
    //   for (var i = x + 1; i < y; i++) str += digit[n[i]] + ' ';
    // }
    // str = str.replace(/\number+/g, ' ');
    // return str.trim() + ".";
    var ones = ["", "One ", "Two ", "Three ", "Four ", "Five ", "Six ", "Seven ", "Eight ", "Nine ", "Ten ", "Eleven ", "Twelve ", "Thirteen ", "Fourteen ", "Fifteen ", "Sixteen ", "Seventeen ", "Eighteen ", "Nineteen "];
    var tens = ["", "", "Twenty", "Thirty", "Forty", "Fifty", "Sixty", "Seventy", "Eighty", "Ninety"];
    if ((num = num.toString()).length > 9) return "Overflow: Maximum 9 digits supported";
    n = ("000000000" + num).substr(-9).match(/^(\d{2})(\d{2})(\d{2})(\d{1})(\d{2})$/);
    if (!n) return;
    var str = "";
    str += n[1] != 0 ? (ones[Number(n[1])] || tens[n[1][0]] + " " + ones[n[1][1]]) + "Crore " : "";
    str += n[2] != 0 ? (ones[Number(n[2])] || tens[n[2][0]] + " " + ones[n[2][1]]) + "Lakh " : "";
    str += n[3] != 0 ? (ones[Number(n[3])] || tens[n[3][0]] + " " + ones[n[3][1]]) + "Thousand " : "";
    str += n[4] != 0 ? (ones[Number(n[4])] || tens[n[4][0]] + " " + ones[n[4][1]]) + "Hundred " : "";
    str += n[5] != 0 ? (str != "" ? "and " : "") + (ones[Number(n[5])] || tens[n[5][0]] + " " + ones[n[5][1]]) : "";
    return str;
  }


  function convertNumberToWords(num) {
    var ones = ["", "One ", "Two ", "Three ", "Four ", "Five ", "Six ", "Seven ", "Eight ", "Nine ", "Ten ", "Eleven ", "Twelve ", "Thirteen ", "Fourteen ", "Fifteen ", "Sixteen ", "Seventeen ", "Eighteen ", "Nineteen "];
    var tens = ["", "", "Twenty", "Thirty", "Forty", "Fifty", "Sixty", "Seventy", "Eighty", "Ninety"];
    if ((num = num.toString()).length > 9) return "Overflow: Maximum 9 digits supported";
    n = ("000000000" + num).substr(-9).match(/^(\d{2})(\d{2})(\d{2})(\d{1})(\d{2})$/);
    if (!n) return;
    var str = "";
    str += n[1] != 0 ? (ones[Number(n[1])] || tens[n[1][0]] + " " + ones[n[1][1]]) + "Crore " : "";
    str += n[2] != 0 ? (ones[Number(n[2])] || tens[n[2][0]] + " " + ones[n[2][1]]) + "Lakh " : "";
    str += n[3] != 0 ? (ones[Number(n[3])] || tens[n[3][0]] + " " + ones[n[3][1]]) + "Thousand " : "";
    str += n[4] != 0 ? (ones[Number(n[4])] || tens[n[4][0]] + " " + ones[n[4][1]]) + "Hundred " : "";
    str += n[5] != 0 ? (str != "" ? "and " : "") + (ones[Number(n[5])] || tens[n[5][0]] + " " + ones[n[5][1]]) : "";
    return str;
  }
</script>
<?= $this->endSection(); ?>