<?php

namespace App\Controllers;

use App\Controllers\BaseController;
use App\Models\Deficite_m;
use App\Models\Entities_m;
use \Hermawan\DataTables\DataTable;

class Deficite extends BaseController
{
    public function index()
    {
        $entities = new Entities_m();
        $data['entities']  = $entities->table('sss_tbl_entities')->select("sss_ent_id ,sss_ent_name")->where('sss_ent_status', 1)->get()->getResult();
        $data['pageTitle'] = 'Manage Target';
        return view('deficite_v', $data);
    }

    public function getdeficite()
    {
        $db = db_connect();
        $builder = $db->table('tbl_deficite')
                    ->select("def_id, sss_tbl_entities.sss_ent_name, target_year, def_amt")
                    ->join('sss_tbl_entities', 'sss_tbl_entities.sss_ent_id  = tbl_deficite.entity_id');

        return DataTable::of($builder)
            ->add('action', function ($saccodeid) {
                  return '<a class="btn btn-primary btn-sm" onclick="edit_deficite(' . $saccodeid->def_id . ')"><i class="fa fa-edit"></i></a> | <a class="btn btn-danger btn-sm" onclick="delete_deficite(' . $saccodeid->def_id . ')"><i class="fa fa-trash"></i></a>';
            }, 'last')
            ->hide('def_id')
            ->toJson();
    }


    public function insert_deficite()
    {
        $validation = \Config\Services::validation();
        $this->validate([

            'entity_id' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Please Select Entity',
                ]
            ],
            
            'def_amt' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Please Enter Amount',
                ]
            ],
            'target_year' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Please Select Year'
                ]
            ]
        ]);
        if ($validation->run() == FALSE) {
            $errors = $validation->getErrors();
            echo json_encode(['code' => 0, 'error' => $errors]);
        } else {
            
            $insertrecord = new Deficite_m();
            $data = [
                'entity_id' => $this->request->getVar('entity_id'),
                'target_year' => $this->request->getVar('target_year'),
                'def_amt' => $this->request->getVar('def_amt'),
                'createdate' => date('Y-m-d')
            ];
           
            $isInserted = $insertrecord->insert($data);
            if (!empty($isInserted)) {
                echo json_encode(array("status" => true, "message" => 'Record Inserted'));
            } else {
                echo json_encode(array("status" => false, "message" => 'Something error while inserting record'));
            }
        }
    }

    public function deficite_edit($id)
    {
        $Deficite_m = new Deficite_m();
        $data = $Deficite_m->find($id);
        echo json_encode($data);
    }

    public function deficite_update()
    {
        $updaterecord = new Deficite_m();
        $id = $this->request->getVar('def_id');
        $data = [
            'entity_id' => $this->request->getVar('entity_id'),
            'target_year' => $this->request->getVar('target_year'),
            'def_amt' => $this->request->getVar('def_amt'),
        ];
        $isUpdated = $updaterecord->update($id, $data);
        if (!empty($isUpdated)) {
            echo json_encode(array("status" => true, "message" => 'Record Updated'));
        } else {
            echo json_encode(array("status" => false, "message" => 'Something error while updating record'));
        }
    }

    public function deficite_delete($id)
    {
        $Deficite_m = new Deficite_m();
        $r = $Deficite_m->delete_by_id($id);
        echo json_encode(array("status" => TRUE, "message" => $r));
    }

    public function update_sac_status()
    {
        $upadtestatus = new Deficite_m();
        $id = $this->request->getVar('id');
        $data = [
            'status' => $this->request->getVar('status'),
        ];
        $upadtestatus->update($id, $data);
    }
}
