<?php

namespace App\Controllers;

use App\Models\CreateInvoice_m;
use App\Models\Paymentreceived_m;
use App\Models\Bankbook_m;
use App\Models\Bankdetails_m;
use App\Models\Client_m;
use App\Models\Dealdetaildraft_m;
use App\Models\Dealdisbursalchart_m;
use App\Models\Tdsentries_m;
use App\Models\DDD_emp_m;
use App\Models\DDD_outcome_m;
use App\Models\MonthsBalances_m;

use \Hermawan\DataTables\DataTable;

class PaymentReceived extends BaseController
{
    public function index($invId)
    {
        $data['invId'] = $invId;
        $paymentlastid = new Paymentreceived_m();
        $data['lastbalamt'] = $paymentlastid->table('sss_tbl_paymentreceived')->select("sss_pr_tdsper,sss_pr_tdsamt,sss_pr_finalamt,sss_pr_balanceamt,sss_pr_prev_balamt")
            ->orderBy('sss_pr_id', 'DESC')
            ->where('sss_inv_id', $invId)
            ->get()->getRow();

        // echo "<pre>";$data['lastbalamt'];exit;

        $invoices = new CreateInvoice_m();
        $data['invoice'] = $invoices->table('sss_tbl_invoices')->select("sss_inv_bill_no, sss_inv_bill_date,sss_tbl_client.sss_client_name,sss_inv_amt,sss_inv_desc,sss_inv_brief,sss_inv_sgst,sss_inv_cgst,sss_inv_igst,sss_inv_total_amt")
            ->join('sss_tbl_client', 'sss_tbl_client.sss_client_id = sss_tbl_invoices.sss_inv_client_id')
            ->where('sss_inv_id', $invId)
            ->get()->getRow();
        if ($data['invoice']->sss_inv_cgst != "0" || $data['invoice']->sss_inv_sgst != "0") {
            $totalgst = $data['invoice']->sss_inv_cgst + $data['invoice']->sss_inv_sgst;
            $data['totalgst'] = $totalgst;
        } else {
            $totalgst = $data['invoice']->sss_inv_igst;
            $data['totalgst'] = $totalgst;
        }

        $lastprid = new Paymentreceived_m();
        $lastid = $lastprid->table('sss_tbl_paymentreceived')->select("sss_pr_id")->orderBy('sss_pr_id', 'DESC')->get()->getRow();
        if (empty($lastid)) {
            $data['sss_pr_reffno'] = 'PR' . str_pad(0 + 1, 5, '0', STR_PAD_LEFT);
        } else {
            $data['sss_pr_reffno'] = 'PR' . str_pad($lastid->sss_pr_id + 1, 5, '0', STR_PAD_LEFT);
        }

        // echo '<pre>';print_r($data['sss_pr_reffno']);exit;
        $data['pageTitle'] = 'Payment Received';
        return view('paymentreceived_v', $data);
    }

    public function getPayment_details($invId)
    {
        $db = db_connect();
        $builder = $db->table('sss_tbl_paymentreceived')
            ->select("sss_pr_id, sss_pr_reffno, sss_tbl_invoices.sss_inv_total_amt, sss_pr_amtreceived, sss_pr_balanceamt, sss_pr_datereceived, sss_pr_paymenttype")
            ->join('sss_tbl_invoices', 'sss_tbl_invoices.sss_inv_id = sss_tbl_paymentreceived.sss_inv_id')
            ->where('sss_tbl_paymentreceived.sss_inv_id', $invId)
            ->orderBy('sss_pr_id', 'DESC');

        return DataTable::of($builder)
            ->add('action', function ($prid) {
                $btnStatus = $prid->sss_pr_balanceamt == 0 ? 'd-none d-lg-none d-md-none d-sm-none' : '';
                return '<a class="btn btn-danger btn-sm" onclick="delete_paymentdetail(' . $prid->sss_pr_id . ')"><i class="fa fa-trash"></i></a> | <a class="btn btn-primary btn-sm mt-1" href="' . base_url() . '/DealDisbursalChart/' . $prid->sss_pr_id . '"> DDC </a>';
                // return '<a class="btn btn-sm ' . $btnStatus . '" onclick="edit_paymentdetail(' . $prid->sss_pr_id . ')"><i class="fa fa-edit"></i></a> | <a class="btn btn-danger btn-sm" onclick="delete_paymentdetail(' . $prid->sss_pr_id . ')"><i class="fa fa-trash"></i></a> | <a class="btn btn-primary btn-sm mt-1" href="' . base_url() . '/DealDisbursalChart/' . $prid->sss_pr_id . '"> DDC </a>';
            }, 'last')
            ->hide('sss_pr_id')
            ->toJson();
    }


    // last updated on 22-09-2023 with entid and replace bb transction date to transction time in orderby..
    public function insert_paymentdetail()
    {
        $validation = \Config\Services::validation();
        $this->validate([
            'sss_pr_tdsper' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Select TDS',
                ]
            ],
            'sss_pr_datereceived' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Please select received date of payment',
                ]
            ],
            'sss_pr_paymentmode' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Select Payment Mode'
                ]
            ],
            'sss_pr_amtreceived' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Enter Amount which you receive',
                ]
            ]
        ]);
        if ($validation->run() == FALSE) {
            $errors = $validation->getErrors();
            echo json_encode(['code' => 0, 'error' => $errors]);
        } else {
            // $dateComps = date_parse(date('Y-m-d'));
            $dateComps = date_parse($this->request->getVar('sss_pr_datereceived'));
            $year = $dateComps['year'];
            $month = $dateComps['month'];
            $sss_bb_transmonth = $month . '-' . $year;

            // calcualte next month....
            $nxtyear = $year;
            $nxtmonth = $month + 1;
            $nextMonthwithdate = $nxtmonth . '-' . $nxtyear;

            $currentTime = date('H:i:s');

            // $payment_received = $this->request->getVar('sss_pr_amtreceived');
            // payment received entry...
            $insertrecord = new Paymentreceived_m();

            $data = [
                'sss_inv_id' => $this->request->getVar('sss_inv_id'),
                'sss_pr_tdsper' => $this->request->getVar('sss_pr_tdsper'),
                'sss_pr_tdsamt' => $this->request->getVar('sss_pr_tdsamt'),
                'sss_pr_reffno' => $this->request->getVar('sss_pr_reffno'),
                'sss_pr_finalamt' =>  $this->request->getVar('sss_pr_finalamt'),
                'sss_pr_datereceived' => $this->request->getVar('sss_pr_datereceived'),
                'sss_pr_chequereceiveddate' => $this->request->getVar('sss_pr_chequereceiveddate'),
                'sss_pr_paymentmode' => $this->request->getVar('sss_pr_paymentmode'),
                'sss_pr_transreffno' => $this->request->getVar('sss_pr_transreffno'),
                'sss_pr_amtreceived' => $this->request->getVar('sss_pr_amtreceived'),
                'sss_pr_balanceamt' => $this->request->getVar('sss_pr_balanceamt'),
                'sss_pr_prev_balamt' => $this->request->getVar('sss_pr_prev_balamt'),
                'sss_pr_paymenttype' => $this->request->getVar('sss_pr_paymenttype'),
                'sss_sac_code_created_by' => session('userid'),
                'sss_pr_create_date' => date('Y-m-d')
            ];
            $prinsertid = $insertrecord->insert($data);

            // get bank and its opening balance...
            $invoices = new CreateInvoice_m();
            $invid = $this->request->getVar('sss_inv_id');

            $invoicerecord = $invoices->find($invid);
            $clientid = $invoicerecord['sss_inv_client_id'];

            //get client name
            $client = new Client_m();
            $clientname = $client->find($clientid);

            $lastopngBal = 0;
            $openingbalance = 0;
            $depositeamt = 0;

            $insertrecord->insertID();
            $bankid = $invoicerecord['sss_inv_bankid'];

            $getopeningbal = new Bankdetails_m();
            $openingbalance = $getopeningbal->find($bankid);
            $lastopngBal = $openingbalance['sss_ent_bank_acc_openingbal'];

            // value deposite to destination bank..
            $depositeamt = $this->request->getVar('sss_pr_amtreceived') + $lastopngBal;
            // update current bank info.....
            $updatedepositebank = new Bankdetails_m();
            $depositebank = [
                'sss_ent_bank_acc_openingbal' => $depositeamt,
                'sss_ent_bank_last_updated_by' => session('userid'),
                'sss_ent_bank_updated_date' => date('Y-m-d')
            ];
            $updatedepositebank->update($bankid, $depositebank);

            $bbparticulars_pr = $clientname['sss_client_name'] . ' - ' . $invoicerecord['sss_inv_bill_no'] . ' - ' .  'Payment Received';
            $paymentreceivedamt = 0;

            // get next entries of bankbook of payment received.....

            $nextBankbookentries = new Bankbook_m();
            $getnextentriesby_transactiondate = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', $bankid)->where('sss_bb_transactiondate >', $this->request->getVar('sss_pr_datereceived'))->orderBy('sss_bb_transactiontime', 'ASC')->get()->getRow();
            $isBankbook = new Bankbook_m();

            if ($getnextentriesby_transactiondate != '') {

                $get_lastBalance_nextentry = $getnextentriesby_transactiondate->sss_bb_lastbalance; // next entries last balance....
                $paymentreceivedamt = $this->request->getVar('sss_pr_amtreceived'); // payment received amount...
                $newCurrentBalance = $get_lastBalance_nextentry + $paymentreceivedamt; // calculate current balance ....

                $bankbookdata = [
                    'sss_pr_id' => $prinsertid,
                    'sss_bb_vendorid' => 'NA',
                    'sss_bb_vpid' => 'NA',
                    'sss_bb_clientid' => 'NA',
                    'sss_bb_invid' => $this->request->getVar('sss_inv_id'),
                    'sss_bb_particulars' => $bbparticulars_pr,
                    'sss_bb_sourcebankid' => '',
                    'sss_bb_destinationbankid' => $bankid,
                    'sss_bb_transamt' => $this->request->getVar('sss_pr_amtreceived'),
                    'sss_bb_finalamt' => $this->request->getVar('sss_pr_amtreceived'),
                    'sss_bb_transmode' => $this->request->getVar('sss_pr_paymentmode'),
                    'sss_bb_transreffno' => $this->request->getVar('sss_pr_transreffno'),
                    'sss_bb_transtype' => 'Deposit',
                    'sss_bb_iswithdrawl' => '',
                    'sss_bb_isdeposit' => $this->request->getVar('sss_pr_amtreceived'),
                    'sss_bb_transactiondate' => $this->request->getVar('sss_pr_datereceived'),
                    'sss_bb_transactiontime' => $this->request->getVar('sss_pr_datereceived') . ' ' . $currentTime,
                    'sss_bb_transmonth' => $sss_bb_transmonth,
                    'sss_bb_lastbalance' => $get_lastBalance_nextentry,
                    'sss_bb_balance' => $newCurrentBalance,
                    'sss_allbankid' => $bankid,
                    'sss_bb_entityid' => session('ent_id'),
                    'createdate' => date('Y-m-d')
                ];

                $isInserted = $isBankbook->insert($bankbookdata);

                $allEntries = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', $bankid)->where('sss_bb_transactiondate >', $this->request->getVar('sss_pr_datereceived'))->orderBy('sss_bb_transactiontime', 'ASC')->get()->getResult();
                // exit;

                foreach ($allEntries as $bb_entries) {
                    if ($bb_entries->sss_bb_transtype == 'Deposit') {

                        $Bb_id = $bb_entries->sss_bankbook_id;
                        $lastBalance = $bb_entries->sss_bb_lastbalance;
                        $newLastBalance = $lastBalance + $paymentreceivedamt;
                        $newcurrentBalance = $newLastBalance + $bb_entries->sss_bb_transamt;
                        $new_amountBalances = [
                            'sss_bb_lastbalance' => $newLastBalance,
                            'sss_bb_balance' => $newcurrentBalance,
                            'updatedate	' => date('Y-m-d')
                        ];
                        $nextBankbookentries->update($Bb_id, $new_amountBalances);
                    } else {

                        $Bb_id = $bb_entries->sss_bankbook_id;
                        $lastBalance = $bb_entries->sss_bb_lastbalance;
                        $newLastBalance = $lastBalance + $paymentreceivedamt;
                        $newcurrentBalance = $newLastBalance - $bb_entries->sss_bb_transamt;
                        $new_amountBalances = [
                            'sss_bb_lastbalance' => $newLastBalance,
                            'sss_bb_balance' => $newcurrentBalance,
                            'updatedate	' => date('Y-m-d')
                        ];
                        $nextBankbookentries->update($Bb_id, $new_amountBalances);
                    }
                }

                $lastRecord = new Bankbook_m();
                $getlastRecord_transactiondate = $lastRecord->table('sss_tbl_bankbook')
                    ->select('sss_bankbook_id,sss_pr_id,sss_ddd_id,sss_bb_wdrwl_reffid,sss_bb_transactiondate,sss_bb_particulars,sss_bb_transmode,sss_bb_transreffno,sss_bb_lastbalance')
                    ->select('sss_bb_isdeposit, sss_bb_iswithdrawl, sss_bb_balance')
                    ->orderBy('sss_tbl_bankbook.sss_bb_transactiontime', 'ASC')
                    ->where('sss_allbankid', $bankid)->where('sss_bb_transmonth', $sss_bb_transmonth)->get()->getResult();
                $lastBankBookEntry = end($getlastRecord_transactiondate); // get last entry of bankbookid end and id pass to next query...

                $closing_Bal = $lastBankBookEntry->sss_bb_balance;

                $NextMonthsBalances_m = new MonthsBalances_m();
                $getValueofNextMonthBalance = $NextMonthsBalances_m
                    ->where('bankid', $bankid)
                    ->where('month >', $month)
                    ->where('year', $year)
                    ->orderBy('id', 'Asc')
                    ->get()
                    ->getResult();

                for ($i = 0; $i < count($getValueofNextMonthBalance); $i++) {

                    // Get closing bal of prev month and update in current month ... 
                    $NextMonthsBal = new MonthsBalances_m();
                    $NextMonthsBal->update($getValueofNextMonthBalance[$i]->id, ['openingbal' =>  $closing_Bal]);

                    // shift closing bal for null entry...
                    $prevClosing = $closing_Bal;
                    // return the closing balance of current month....
                    $closing_Bal = $lastRecord->table('sss_tbl_bankbook')
                        ->select('sss_bb_balance,sss_bb_transmonth')
                        ->orderBy('sss_bb_transactiontime', 'Desc')
                        ->where('sss_allbankid', $getValueofNextMonthBalance[$i]->bankid)
                        ->where('sss_bb_transmonth', $getValueofNextMonthBalance[$i]->balancemonth)
                        ->get()
                        ->getRow();

                    // $closing_Bal = $closing_Bal->sss_bb_balance;
                    if (!empty($closing_Bal)) {
                        $closing_Bal = $closing_Bal->sss_bb_balance;
                    } else {
                        $closing_Bal = $prevClosing;
                    }
                }
            } else {

                $bankbookdata1 = [
                    'sss_pr_id' => $prinsertid,
                    'sss_bb_vendorid' => 'NA',
                    'sss_bb_vpid' => 'NA',
                    'sss_bb_clientid' => 'NA',
                    'sss_bb_invid' => $this->request->getVar('sss_inv_id'),
                    'sss_bb_particulars' => $bbparticulars_pr,
                    'sss_bb_sourcebankid' => '',
                    'sss_bb_destinationbankid' => $bankid,
                    'sss_bb_transamt' => $this->request->getVar('sss_pr_amtreceived'),
                    'sss_bb_finalamt' => $this->request->getVar('sss_pr_amtreceived'),
                    'sss_bb_transmode' => $this->request->getVar('sss_pr_paymentmode'),
                    'sss_bb_transreffno' => $this->request->getVar('sss_pr_transreffno'),
                    'sss_bb_transtype' => 'Deposit',
                    'sss_bb_iswithdrawl' => '',
                    'sss_bb_isdeposit' => $this->request->getVar('sss_pr_amtreceived'),
                    'sss_bb_transactiondate' => $this->request->getVar('sss_pr_datereceived'),
                    'sss_bb_transactiontime' => $this->request->getVar('sss_pr_datereceived') . ' ' . $currentTime,
                    'sss_bb_transmonth' => $sss_bb_transmonth,
                    'sss_bb_lastbalance' => $lastopngBal,
                    'sss_bb_balance' => $depositeamt,
                    'sss_allbankid' => $bankid,
                    'sss_bb_entityid' => session('ent_id'),
                    'createdate' => date('Y-m-d')
                ];
                $isInserted = $isBankbook->insert($bankbookdata1);

                // update oprning balance for openingmonths bank.....
                $lastRecord = new Bankbook_m();
                $getlastRecord_transactiondate = $lastRecord->table('sss_tbl_bankbook')->orderBy('sss_bb_transactiontime', 'Asc')->where('sss_allbankid', $bankid)->where('sss_bb_transmonth', $sss_bb_transmonth)->get()->getRow();

                $newopningbal1 = $getlastRecord_transactiondate->sss_bb_balance;

                $NextMonthsBalances_m = new MonthsBalances_m();
                $getValueofNextMonthBalance1 = $NextMonthsBalances_m->where('bankid', $bankid)->where('month >', $month)->where('year', $year)->orderBy('id', 'Asc')->get()->getResult();

                if (!empty($getlastRecord_transactiondate)) {
                    foreach ($getValueofNextMonthBalance1 as $nextmonths_openingBalances) {
                        $opngmonthbal_id1 = $nextmonths_openingBalances->id;
                        $deposite_nextmonth_opngbalances1 = [
                            'openingbal' => $newopningbal1,
                        ];
                        $NextMonthsBalances_m->update($opngmonthbal_id1, $deposite_nextmonth_opngbalances1);
                    }
                }
            }

            if (!empty($isInserted)) {
                echo json_encode(array("status" => true, "message" => 'Payment Details Inserted'));
            } else {
                echo json_encode(array("status" => false, "message" => 'Something error while inserting Payment Details'));
            }
        }
    }

    public function edit_paymentdetail($prid)
    {
        $editrecord = new PaymentReceived_m();
        $data = $editrecord->find($prid);
        echo json_encode($data);
    }


    // last updated on 7-9-2023...
    public function delete_paymentdetail($prid)
    {
        // delete payment received and update bank accoutns....
        $Bankbook_m = new Bankbook_m();
        $PaymentReceived_m = new PaymentReceived_m();
        $getrecords = $PaymentReceived_m->find($prid);
        $transamt = $getrecords['sss_pr_amtreceived'];
        $bank_bookId = $Bankbook_m->table('sss_tbl_bankbook')->where('sss_pr_id', $prid)->get()->getRow();

        // get bank id for next entries invoices.....sss_bb_transactiondate
        $bankId  = $bank_bookId->sss_allbankid;

        $dateComps = date_parse($bank_bookId->sss_bb_transactiondate);
        $year = $dateComps['year'];
        $month = $dateComps['month'];
        $currentmonth = $month . '-' . $year;

        // get current openingmonth balances and update only closing bal....
        $CurrentMonthsBalances_m = new MonthsBalances_m();
        $getValueofcurrentMonthBalance = $CurrentMonthsBalances_m->where('bankid', $bankId)->where('month', $month)->where('year', $year)->orderBy('id', 'Asc')->get()->getRow();

        if (!empty($getValueofcurrentMonthBalance)) {
            $NextMonthsBalances_m = new MonthsBalances_m();
            $getValueofNextMonthBalance1 = $NextMonthsBalances_m->where('bankid', $bankId)->where('month >', $month)->where('year', $year)->orderBy('id', 'Asc')->get()->getResult();
            if (!empty($getValueofNextMonthBalance1)) {
                foreach ($getValueofNextMonthBalance1 as $nextmonths_openingBalances) {
                    $opningbal = $nextmonths_openingBalances->openingbal;
                    $newopng = $opningbal - $transamt;
                    $opngmonthbal_id1 = $nextmonths_openingBalances->id;
                    $deposite_nextmonth_opngbalances1 = [
                        'openingbal' => $newopng,
                    ];
                    $NextMonthsBalances_m->update($opngmonthbal_id1, $deposite_nextmonth_opngbalances1);
                }
            }
        }
        if (!empty($prid))
            $PaymentReceived_m->table('sss_tbl_paymentreceived')->where('sss_pr_id', $prid)->delete(); // delete pr qry
            $Bankbook_m->table('sss_tbl_bankbook')->where('sss_pr_id', $prid)->delete();  // also delete entry for bb via payment received..

        //find bank account ...
        $invoices = new CreateInvoice_m();
        $invoicerecord = $invoices->find($getrecords['sss_inv_id']);
        $bankid = $invoicerecord['sss_inv_bankid'];

        //fetch payment received for re-arrange all balances...fetch by invoice id..
        if (!empty($getrecords)) {
            // for payment received table....
            $get_all_paymentreceived = $PaymentReceived_m->where('sss_pr_id >', $prid)->where('sss_tbl_paymentreceived.sss_inv_id', $getrecords['sss_inv_id'])->orderBy('sss_pr_id', 'Asc')->get()->getResult();
            if (!empty($get_all_paymentreceived)) {
                foreach ($get_all_paymentreceived as $pr_entries) {
                    $paymentReceivedId = $pr_entries->sss_pr_id;
                    $balanceamt_row = $pr_entries->sss_pr_balanceamt;
                    $lastbalanceamt_row = $pr_entries->sss_pr_prev_balamt;
                    $last_balances = $lastbalanceamt_row + $transamt; // calcualte prev balamt..
                    $newbalance_amt = $transamt + $balanceamt_row; // new balance amt...

                    $new_amountBalances = [
                        'sss_pr_balanceamt' => $newbalance_amt,
                        'sss_pr_prev_balamt' => $last_balances,
                        'sss_pr_paymenttype' => 'Part Payment',
                        'sss_pr_updated_by' => session('userid'),
                        'sss_pr_update_date' => date('Y-m-d')
                    ];
                    $PaymentReceived_m->update($paymentReceivedId, $new_amountBalances);
                }
            }
            // end....

            // for bankbook table....
            $getBankBooks = new Bankbook_m();
            // $get_all_BankBook_entries = $getBankBooks->table('sss_tbl_bankbook')->where('sss_bb_transactiondate >=', $bank_bookId->sss_bb_transactiondate)->where('sss_allbankid', $bankId)->get()->getResult();

            // last update on 7-9-2023.. only change transactiondate to trnsaction time...
            $get_all_BankBook_entries = $getBankBooks->table('sss_tbl_bankbook')->where('sss_bb_transactiontime >=', $bank_bookId->sss_bb_transactiontime)->where('sss_allbankid', $bankId)->get()->getResult();

            // current month balance entry....
            $MonthsBalances_m = new MonthsBalances_m();
            $getValueofcurrentMonthBalance = $MonthsBalances_m->where('bankid', $bankid)->where('balancemonth', $currentmonth)->get()->getRow();
            $opng_currentmonthbal_id = $getValueofcurrentMonthBalance->id;
            if (!empty($get_all_BankBook_entries)) {

                foreach ($get_all_BankBook_entries as $bb_entries) {
                    $BankBookId = $bb_entries->sss_bankbook_id;
                    $balanceamt_row = $bb_entries->sss_bb_balance;
                    $lastbalanceamt_row = $bb_entries->sss_bb_lastbalance;
                    $currentbalanceamt_row = $bb_entries->sss_bb_balance;
                    $newlast_balances_bb = $lastbalanceamt_row - $transamt; // calcualte prev balamt..
                    $newbalance_amt_bb = $currentbalanceamt_row - $transamt; // new balance amt...
                    $withdrawl_new_Balances = [
                        'sss_bb_balance' => $newbalance_amt_bb,
                        'sss_bb_lastbalance' => $newlast_balances_bb,
                        'updatedate' => date('Y-m-d')
                    ];
                    $Bankbook_m->update($BankBookId, $withdrawl_new_Balances);
                }
            }
        }

        // payment received with bank balances ....
        if (!empty($transamt)) {
            // update bankinfo....
            $getopeningbal = new Bankdetails_m();
            $openingbalance = $getopeningbal->find($bankid);
            $lastupdatebal = ($openingbalance['sss_ent_bank_acc_openingbal']) - $transamt;
            $updatedepositebank = new Bankdetails_m();
            $depositebank = [
                'sss_ent_bank_acc_openingbal' => $lastupdatebal,
                'sss_ent_bank_last_updated_by' => session('userid'),
                'sss_ent_bank_updated_date' => date('Y-m-d')
            ];
            $updatedepositebank->update($bankid, $depositebank);
        }
        // end pr with bank balance..
        // delete ddc start...
        $Dealdisbursalchart_m = new Dealdisbursalchart_m();
        $ddcid = $Dealdisbursalchart_m->table('sss_tbl_dealdisbursalchart')->select('sss_pr_id')->where('sss_pr_id', $prid)->get()->getRow();
        if (!empty($ddcid)) {
            $Dealdisbursalchart_m->table('sss_tbl_dealdisbursalchart')->where('sss_pr_id', $prid)->delete();
        }

        // ddd delete and update bank balance start ....
        $Dealdetaildraft_m = new Dealdetaildraft_m();
        // find for bankbook id..
        $dddidForBB = $Dealdetaildraft_m->table('sss_tbl_dealdetaildraft')->where('sss_pr_id', $prid)->get()->getRow();

        $updatedepositebank = new Bankdetails_m();

        if (!empty($dddidForBB)) {
            $bb = $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->get()->getResult();
            $getbankid = new Bankdetails_m();
            if (!empty($bb)) {
                foreach ($bb as $b) {
                    if ($b->sss_bb_transtype == 'Withdrawl' && $b->sss_bb_iswithdrawl != '') {
                        $ssdddid = $b->sss_ddd_id;
                        $sbankid = $b->sss_bb_sourcebankid;
                        $sourcetransamt = $b->sss_bb_iswithdrawl;
                        $openingbalance = $getbankid->find($sbankid);
                        $opningbalofwithdrawlbank = $openingbalance['sss_ent_bank_acc_openingbal'];
                        $bankbalanceupdat = $opningbalofwithdrawlbank + $sourcetransamt;
                        $sourcebankwithdrawarray = [
                            'sss_ent_bank_acc_openingbal' => $bankbalanceupdat,
                            'sss_ent_bank_last_updated_by' => session('userid'),
                            'sss_ent_bank_updated_date' => date('Y-m-d')
                        ];
                        $updatedepositebank->update($sbankid, $sourcebankwithdrawarray);
                        $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $ssdddid)->delete();
                    }

                    if ($b->sss_bb_transtype == 'Deposit' && $b->sss_bb_isdeposit != '') {
                        $ssdddid = $b->sss_ddd_id;
                        $dbankid = $b->sss_bb_destinationbankid;
                        $openingbalance = $getbankid->find($dbankid);
                        $opningbalofdestinationbank = $openingbalance['sss_ent_bank_acc_openingbal'];
                        $destinationtransamt = $b->sss_bb_isdeposit;

                        $depositebankbalanceupdat = $opningbalofdestinationbank - $destinationtransamt;
                        $destinationbankdepositearray = [
                            'sss_ent_bank_acc_openingbal' => $depositebankbalanceupdat,
                            'sss_ent_bank_last_updated_by' => session('userid'),
                            'sss_ent_bank_updated_date' => date('Y-m-d')
                        ];
                        $updatedepositebank->update($dbankid, $destinationbankdepositearray);
                        $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $ssdddid)->delete();
                    }
                }
            }

            $Tdsentries_m = new Tdsentries_m();
            $isTDSFound = $Tdsentries_m->table('sss_tbl_totaltds')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->findAll();

            if (!empty($isTDSFound)) {
                foreach ($isTDSFound as $Tds) {
                    $Tdsentries_m->table('sss_tbl_totaltds')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->delete();
                }
            }

            $allemprecord = new DDD_emp_m();
            $isEmpFound = $allemprecord->table('sss_ddd_employees')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->get()->getResult();
            if (!empty($isEmpFound)) {
                foreach ($isEmpFound as $emp) {
                    $allemprecord->table('sss_ddd_employees')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->delete();
                }
            }

            $alloutcomerecord = new DDD_outcome_m();
            $isOutcomeFound = $alloutcomerecord->table('sss_ddd_outcomes')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->get()->getResult();

            if (!empty($isOutcomeFound)) {
                foreach ($isOutcomeFound as $outcome) {

                    $alloutcomerecord->table('sss_ddd_outcomes')->where('sss_ddd_id', $dddidForBB->sss_ddd_id)->delete();
                }
            }
        }
        if (!empty($prid)) {
            // $Bankbook_m->table('sss_tbl_bankbook')->where('sss_pr_id', $prid)->delete();  // also delete entry for bb via payment received..
            $Dealdetaildraft_m->table('sss_tbl_dealdetaildraft')->where('sss_pr_id', $prid)->delete(); // delete ddd entry from pr  
        }
        echo json_encode(array("status" => TRUE));
    }
}
