<?php


namespace App\Controllers;


use App\Models\CreateInvoice_m;
use App\Models\Paymentreceived_m;
use App\Models\ClosingBal_m;
use PhpParser\Node\Stmt\Else_;

class ProgressiveReport extends BaseController
{
    public function index()
    {
        // $getInvoice_no = new CreateInvoice_m();
        // $data['invoice_nos'] = $getInvoice_no->table('sss_tbl_invoices')->select('sss_inv_id ,sss_inv_bill_no')->findAll();
        $data['pageTitle'] = 'Turnover Report';
        return view('progressive_report', $data);
    }

    public function getInvoiceRecords()
    {
        $getPaymentReceived = new Paymentreceived_m();
        $dateComps = date_parse($this->request->getVar('month'));
        $year = $dateComps['year'];
        $month = $dateComps['month'];
        $invoice_month = $month . '-' . $year;
        $next_invoice_month = $month + 1 . '-' . $year;
        $pre_invoice_month = $month - 1 . '-' . $year;

        $data['invoice_month'] = $next_invoice_month;
        $getInvoiceData = new CreateInvoice_m();

        if (!empty($invoice_month)) {
            

            $data['currentMonth'] = $getInvoiceData->table('sss_tbl_invoices')->select('sss_inv_id,sss_inv_bill_no,sss_inv_bill_date,sss_tbl_client.sss_client_name,sss_tbl_client.sss_client_id,sss_inv_brief,sss_inv_amt,sss_inv_sgst,sss_inv_cgst,sss_inv_igst,sss_inv_total_amt,sss_inv_client_id')
                ->join('sss_tbl_client', 'sss_tbl_client.sss_client_id = sss_tbl_invoices.sss_inv_client_id')
                ->where('sss_tbl_invoices.sss_inv_entityId', session('ent_id'))
                ->where('sss_inv_month', $invoice_month)->findAll();

            for ($x = 0; $x < count($data['currentMonth']); $x++) {

                if ($data['currentMonth'][$x]['sss_inv_cgst'] != "0" || $data['currentMonth'][$x]['sss_inv_sgst'] != "0") {
                    $totalgst = $data['currentMonth'][$x]['sss_inv_cgst'] + $data['currentMonth'][$x]['sss_inv_sgst'];
                    $data['currentMonth'][$x]['totalgst'] = $totalgst;
                } else if ($data['currentMonth'][$x]['sss_inv_igst'] != "0" || $data['currentMonth'][$x]['sss_inv_igst'] != "") {
                    $totalgst = $data['currentMonth'][$x]['sss_inv_igst'];
                    $data['currentMonth'][$x]['totalgst'] = $totalgst;
                }

                if ($data['currentMonth'][$x]['sss_inv_bill_no'] != 0) {
                    $parts = explode("/", $data['currentMonth'][$x]['sss_inv_bill_no']);
                    $data['currentMonth'][$x]['invoiceno'] = $parts[0];
                }
                $data['currentMonth'][$x]['paymentreceived'] = $getPaymentReceived->table('sss_tbl_paymentreceived')->select('sss_pr_tdsamt,sss_pr_amtreceived,sss_pr_datereceived,sss_pr_balanceamt')->where('sss_inv_id', $data['currentMonth'][$x]['sss_inv_id'])->findAll();
            }

            $currentMonth_totalAmt = 0;
            $currentMonth_allgsttotal = 0;
            $currentMonth_totalTotalAmt = 0;
            foreach ($data['currentMonth'] as $currentmonths) {
                if ($currentmonths['sss_inv_client_id'] != 16 && $currentmonths['sss_inv_client_id'] != 14) {
                    $currentMonth_totalAmt += $currentmonths['sss_inv_amt'];
                    $currentMonth_allgsttotal += $currentmonths['totalgst'];
                    $currentMonth_totalTotalAmt += $currentmonths['sss_inv_total_amt'];
                }
            }
            $data['currentMonth_totalAmt'] = $currentMonth_totalAmt;
            $data['currentMonth_allgsttotal'] = $currentMonth_allgsttotal;
            $data['currentMonth_totalTotalAmt'] = $currentMonth_totalTotalAmt;

            $closingbal = new ClosingBal_m();
            $data['currentmonth_closingbal'] = $closingbal->table('tbl_progressive_closingbal')
                ->select('id, month, closing_amount, closing_gst, closing_finalamt')
                ->where('closing_entityId', session('ent_id'))
                ->where('month', $invoice_month)
                ->orderBy('id', 'desc') // Order by id in descending order
                ->first(); // Retrieve only the first record
            
            if ($data['currentmonth_closingbal'] == '' || empty($data['currentmonth_closingbal'])) {
              
                $data['progressive_closing_amount'] = 0;
                $data['progressive_closing_gst'] = 0;
                $data['progressive_closing_finalamt'] = 0;
            }
            else{
                $data['progressive_closing_amount'] = $data['currentmonth_closingbal']['closing_amount'];
                $data['progressive_closing_gst'] = $data['currentmonth_closingbal']['closing_gst'];
                $data['progressive_closing_finalamt'] = $data['currentmonth_closingbal']['closing_finalamt'];
            }

        }
        if (!empty($pre_invoice_month)) {
            $prevMonth = $getInvoiceData->table('sss_tbl_invoices')->select('sss_inv_id,sss_inv_month,sss_inv_amt,sss_inv_sgst,sss_inv_cgst,sss_inv_igst,sss_inv_entityId,sss_inv_total_amt,sss_inv_client_id')
                ->where('sss_tbl_invoices.sss_inv_entityId', session('ent_id'))
                ->where('sss_inv_month', $pre_invoice_month)->findAll();

            for ($u = 0; $u < count($prevMonth); $u++) {

                if ($prevMonth[$u]['sss_inv_cgst'] != "0" || $prevMonth[$u]['sss_inv_sgst'] != "0") {
                    $prevtotalgst = $prevMonth[$u]['sss_inv_cgst'] + $prevMonth[$u]['sss_inv_sgst'];
                    $prevMonth[$u]['prevtotalgst'] = $prevtotalgst;
                } else if ($prevMonth[$u]['sss_inv_igst'] != "0" || $prevMonth[$u]['sss_inv_igst'] != "") {
                    $prevtotalgst = $prevMonth[$u]['sss_inv_igst'];
                    $prevMonth[$u]['prevtotalgst'] = $prevtotalgst;
                }
            }
            $prevMonth_allgsttotal = 0;
            $prevMonth_totalAmt = 0;
            $prevMonth_totalTotalAmt = 0;
            foreach ($prevMonth as $invoice) {
                if ($invoice['sss_inv_client_id'] != 16 && $invoice['sss_inv_client_id'] != 14) {
                    $prevMonth_allgsttotal += $invoice['prevtotalgst'];
                    $prevMonth_totalAmt += $invoice['sss_inv_amt'];
                    $prevMonth_totalTotalAmt += $invoice['sss_inv_total_amt'];
                }
            }
            $data['prevMonth_allgsttotal'] = $prevMonth_allgsttotal;
            $data['prevMonth_totalAmt'] = $prevMonth_totalAmt;
            $data['prevMonth_totalTotalAmt'] = $prevMonth_totalTotalAmt;
        }



        // echo "<pre>";print_r($data);exit;
        echo json_encode($data);
    }

    public function insert_closing()
    {
        $insertrecord = new ClosingBal_m();
        $data = [
            'closing_amount' => $this->request->getVar('closing_amount'),
            'closing_gst' => $this->request->getVar('closing_gst'),
            'closing_finalamt' => $this->request->getVar('closing_finalamt'),
            'month' => $this->request->getVar('month'),
            'closing_entityId' => session('ent_id'),
            'createdate' => date('Y-m-d')
        ];
        $isInserted = $insertrecord->insert($data);
        if ($isInserted > 0) {
            echo json_encode(array('status' => true));
        }
    }


    // public function getInvoiceRecords()
    // {
    //     $getPaymentReceived = new Paymentreceived_m();
    //     $dateComps = date_parse($this->request->getVar('month'));
    //     $year = $dateComps['year'];
    //     $month = $dateComps['month'];
    //     $invoice_month = $month . '-' . $year;

    //     $pre_invoice_month = $month - 1 . '-' . $year;

    //     $pre_invoice_month2 = $month - 2 . '-' . $year;

    //     $getInvoiceData = new CreateInvoice_m();

    //     if (!empty($invoice_month)) {
    //         $data['currentMonth'] = $getInvoiceData->table('sss_tbl_invoices')->select('sss_inv_id,sss_inv_bill_no,sss_inv_bill_date,sss_tbl_client.sss_client_name,sss_tbl_client.sss_client_id,sss_inv_brief,sss_inv_amt,sss_inv_sgst,sss_inv_cgst,sss_inv_igst,sss_inv_total_amt')
    //             ->join('sss_tbl_client', 'sss_tbl_client.sss_client_id = sss_tbl_invoices.sss_inv_client_id')
    //             ->where('sss_tbl_invoices.sss_inv_entityId', session('ent_id'))
    //             ->where('sss_inv_month', $invoice_month)->findAll();

    //         for ($x = 0; $x < count($data['currentMonth']); $x++) {

    //             if ($data['currentMonth'][$x]['sss_inv_cgst'] != "0" || $data['currentMonth'][$x]['sss_inv_sgst'] != "0") {
    //                 $totalgst = $data['currentMonth'][$x]['sss_inv_cgst'] + $data['currentMonth'][$x]['sss_inv_sgst'];
    //                 $data['currentMonth'][$x]['totalgst'] = $totalgst;
    //             } else if ($data['currentMonth'][$x]['sss_inv_igst'] != "0" || $data['currentMonth'][$x]['sss_inv_igst'] != "") {
    //                 $totalgst = $data['currentMonth'][$x]['sss_inv_igst'];
    //                 $data['currentMonth'][$x]['totalgst'] = $totalgst;
    //             }

    //             if ($data['currentMonth'][$x]['sss_inv_bill_no'] != 0) {
    //                 $parts = explode("/", $data['currentMonth'][$x]['sss_inv_bill_no']);
    //                 $data['currentMonth'][$x]['invoiceno'] = $parts[0];
    //             }

    //             $data['currentMonth'][$x]['paymentreceived'] = $getPaymentReceived->table('sss_tbl_paymentreceived')->select('sss_pr_tdsamt,sss_pr_amtreceived,sss_pr_datereceived,sss_pr_balanceamt')->where('sss_inv_id', $data['currentMonth'][$x]['sss_inv_id'])->findAll();
    //         }

    //         $currentMonth_allgsttotal = 0;
    //         $currentMonth_totalAmt = 0;
    //         $currentMonth_totalTotalAmt = 0;
    //         foreach ($data['currentMonth'] as $current) {

    //             if ($current['sss_client_id'] != 16 && $current['sss_client_id'] != 14) {
    //                 $currentMonth_allgsttotal += $current['totalgst'];
    //                 $currentMonth_totalAmt += $current['sss_inv_amt'];
    //                 $currentMonth_totalTotalAmt += $current['sss_inv_total_amt'];
    //             }
    //         }
    //     }

    //     $data['currentMonth_allgsttotal']  = $currentMonth_allgsttotal;
    //     $data['currentMonth_totalAmt'] =  $currentMonth_totalAmt;
    //     $data['currentMonth_totalTotalAmt'] =  $currentMonth_totalTotalAmt;


    //     if (!empty($pre_invoice_month)) {
    //         $prevMonth = $getInvoiceData->table('sss_tbl_invoices')->select('sss_inv_id,sss_inv_month,sss_inv_amt,sss_inv_sgst,sss_inv_cgst,sss_inv_igst,sss_inv_entityId,sss_inv_total_amt,sss_inv_client_id')
    //             ->where('sss_tbl_invoices.sss_inv_entityId', session('ent_id'))
    //             ->where('sss_inv_month', $pre_invoice_month)->findAll();

    //         for ($u = 0; $u < count($prevMonth); $u++) {

    //             if ($prevMonth[$u]['sss_inv_cgst'] != "0" || $prevMonth[$u]['sss_inv_sgst'] != "0") {
    //                 $prevtotalgst = $prevMonth[$u]['sss_inv_cgst'] + $prevMonth[$u]['sss_inv_sgst'];
    //                 $prevMonth[$u]['prevtotalgst'] = $prevtotalgst;
    //             } else if ($prevMonth[$u]['sss_inv_igst'] != "0" || $prevMonth[$u]['sss_inv_igst'] != "") {
    //                 $prevtotalgst = $prevMonth[$u]['sss_inv_igst'];
    //                 $prevMonth[$u]['prevtotalgst'] = $prevtotalgst;
    //             }
    //         }
    //         $prevMonth_allgsttotal = 0;
    //         $prevMonth_totalAmt = 0;
    //         $prevMonth_totalTotalAmt = 0;
    //         foreach ($prevMonth as $invoice) {
    //             if ($invoice['sss_inv_client_id'] != 16 && $invoice['sss_inv_client_id'] != 14) {
    //                 $prevMonth_allgsttotal += $invoice['prevtotalgst'];
    //                 $prevMonth_totalAmt += $invoice['sss_inv_amt'];
    //                 $prevMonth_totalTotalAmt += $invoice['sss_inv_total_amt'];
    //             }
    //         }

    //         $data['prevMonth_allgsttotal'] = $prevMonth_allgsttotal;
    //         $data['prevMonth_totalAmt'] = $prevMonth_totalAmt;
    //         $data['prevMonth_totalTotalAmt'] = $prevMonth_totalAmt;


    //         // echo $pre_invoice_month;
    //         // echo "<br>";
    //         // echo $prevMonth_allgsttotal.' / '.$prevMonth_totalAmt.' / '.$prevMonth_totalAmt;
    //         // echo "<hr>";
    //     }





    //     // echo "<pre>";print_r($data);exit;
    //     echo json_encode($data);
    // }
}
