<?php

namespace App\Controllers;

use App\Models\Bankdetails_m;
use App\Models\Paymentreceived_m;
use App\Models\Client_m;
use App\Models\CreateInvoice_m;

class Sc_report extends BaseController
{
    public function index()
    {
        $allclients = new Client_m();
        $data['allclient'] = $allclients->table('sss_tbl_client')->select("sss_client_id, sss_client_name")->where('sss_client_status', 1)->get()->getResult();
        $data['pageTitle'] = 'Ciril & Subbrokerage Report';
        return view('screport', $data);
    }

    public function get_SC_Entries()
    {
        $data['types'] = 0;
        $data['totalamount'] = 0;
        $invoice = new CreateInvoice_m();
        $client = $this->request->getVar('client');
        $month = $this->request->getVar('month');
        $types = $this->request->getVar('type');
        $fiscalyear = $this->request->getVar('fiscalyear');
        list($year1, $year2) = explode("-", $fiscalyear);
        $year1 = $year1 . '-04-01';
        $year2 = $year2 . '-03-31';
        $data['types'] = $types;
        $query = $invoice->table('sss_tbl_invoices')
            ->select('sss_tbl_invoices.*,sss_tbl_invoices.sss_inv_id as invId,sss_tbl_client.sss_client_id,sss_tbl_client.sss_client_name,sss_tbl_paymentreceived.sss_pr_id,sss_tbl_dealdisbursalchart.sss_pr_id as PRId,sss_tbl_dealdisbursalchart.*') // Select only the columns you need from sss_tbl_entities
            ->whereIn('sss_tbl_paymentreceived.sss_inv_id', function ($builder) {
                $builder->select('sss_inv_id')
                    ->from('sss_tbl_paymentreceived');
            })
            ->whereIn('sss_tbl_dealdisbursalchart.sss_pr_id', function ($builder) {
                $builder->select('sss_pr_id')
                    ->from('sss_tbl_dealdisbursalchart');
            })
            ->where('DATE(sss_tbl_invoices.sss_inv_bill_date) >=', $year1)
            ->where('DATE(sss_tbl_invoices.sss_inv_bill_date) <=', $year2)
            ->join('sss_tbl_client', 'sss_tbl_client.sss_client_id = sss_tbl_invoices.sss_inv_client_id', 'left', false)
            ->join('sss_tbl_paymentreceived', 'sss_tbl_paymentreceived.sss_inv_id = sss_tbl_invoices.sss_inv_id', 'left', false)
            ->join('sss_tbl_dealdisbursalchart', 'sss_tbl_dealdisbursalchart.sss_pr_id = sss_tbl_paymentreceived.sss_pr_id', 'left', false);

        if (!empty($fiscalyear)) {
            $query->where('DATE(sss_tbl_invoices.sss_inv_bill_date) >=', $year1);
            $query->where('DATE(sss_tbl_invoices.sss_inv_bill_date) <=', $year2);
        }
        if (!empty($month)) {
            $query->where('MONTH(sss_tbl_invoices.sss_inv_bill_date) =', $month);
        }
        if (!empty($client)) {
            $query->where('sss_tbl_invoices.sss_inv_client_id', $client);
        }
        if (!empty($types)) {
            if ($types == 'ciril') {
                $query->where('sss_tbl_dealdisbursalchart.sss_dd_royality > 0');
            } else {
                $query->where('sss_tbl_dealdisbursalchart.sss_dd_sbamt > 0');
            }
        }
        $data['sc_records'] = $query->get()->getResult();
        foreach ($data['sc_records'] as $screcord) {
            if ($screcord->sss_dd_royality > 0) {
                $data['totalamount'] += ($screcord->sss_dd_royality) ? $screcord->sss_dd_royality : 0;
            } else {
                $data['totalamount'] += ($screcord->sss_dd_sbamt) ? $screcord->sss_dd_sbamt : 0;
            }
        }
       
        echo json_encode($data);
    }

    public function print_screport()
    {
        helper('number');
         $data['totalamount'] = 0;
        $invoice = new CreateInvoice_m();
        $client = $this->request->getVar('client');
        $month = $this->request->getVar('month');
        $types = $this->request->getVar('type');
        $fiscalyear = explode("-", $this->request->getVar('fiscalyear'));
        // list($year1, $year2) = explode("-", $fiscalyear);
        // $year1 = $year1 . '-04-01';
        // $year2 = $year2 . '-03-31';
        
        if (isset($fiscalyear[0]) && isset($fiscalyear[1])) {
            $year1 = $fiscalyear[0] . '-04-01';
            $year2 = $fiscalyear[1] . '-03-31';
        } else {
            $year1 = '';
            $year2 = '';
        }
        
        
        $query = $invoice->table('sss_tbl_invoices')
            ->select('sss_tbl_invoices.*,sss_tbl_invoices.sss_inv_id as invId,sss_tbl_client.sss_client_id,sss_tbl_client.sss_client_name,sss_tbl_paymentreceived.sss_pr_id,sss_tbl_dealdisbursalchart.sss_pr_id as PRId,sss_tbl_dealdisbursalchart.*') // Select only the columns you need from sss_tbl_entities
            ->whereIn('sss_tbl_paymentreceived.sss_inv_id', function ($builder) {
                $builder->select('sss_inv_id')
                    ->from('sss_tbl_paymentreceived');
            })
            ->whereIn('sss_tbl_dealdisbursalchart.sss_pr_id', function ($builder) {
                $builder->select('sss_pr_id')
                    ->from('sss_tbl_dealdisbursalchart');
            })
            ->where('DATE(sss_tbl_invoices.sss_inv_bill_date) >=', $year1)
            ->where('DATE(sss_tbl_invoices.sss_inv_bill_date) <=', $year2)
            ->join('sss_tbl_client', 'sss_tbl_client.sss_client_id = sss_tbl_invoices.sss_inv_client_id', 'left', false)
            ->join('sss_tbl_paymentreceived', 'sss_tbl_paymentreceived.sss_inv_id = sss_tbl_invoices.sss_inv_id', 'left', false)
            ->join('sss_tbl_dealdisbursalchart', 'sss_tbl_dealdisbursalchart.sss_pr_id = sss_tbl_paymentreceived.sss_pr_id', 'left', false);

        if (!empty($fiscalyear)) {
            $query->where('DATE(sss_tbl_invoices.sss_inv_bill_date) >=', $year1);
            $query->where('DATE(sss_tbl_invoices.sss_inv_bill_date) <=', $year2);
        }
        if (!empty($month)) {
            $query->where('MONTH(sss_tbl_invoices.sss_inv_bill_date) =', $month);
        }
        if (!empty($client)) {
            $query->where('sss_tbl_invoices.sss_inv_client_id', $client);
        }
        if (!empty($types)) {
            if ($types == 'ciril') {
                $query->where('sss_tbl_dealdisbursalchart.sss_dd_royality > 0');
            } else {
                $query->where('sss_tbl_dealdisbursalchart.sss_dd_sbamt > 0');
            }
        }
        $results = $query->get()->getResult();
        foreach ($results as $screcord) {
            if ($screcord->sss_dd_royality > 0) {
                $data['totalamount'] += ($screcord->sss_dd_royality) ? $screcord->sss_dd_royality : 0;
            } else {
                $data['totalamount'] += ($screcord->sss_dd_sbamt) ? $screcord->sss_dd_sbamt : 0;
            }
        }
        $data['screport'] = $results;
        $data['types'] = $types;

        
        $dompdf = new \Dompdf\Dompdf(['isRemoteEnabled' => true]);
        $dompdf->loadHtml(view('print_screport', $data), 'UTF-8');
        $dompdf->setPaper('A4', 'portrait');
        $dompdf->render();
        // $dompdf->stream('bbreport');
        
        // Save the PDF file on the server
        $pdfFileName = 'screport.pdf';
        $pdfFilePath = FCPATH . 'public/uploads/' . $pdfFileName;
        file_put_contents($pdfFilePath, $dompdf->output());
        $downloadUrl = base_url('public/uploads/' . $pdfFileName);
        return $this->response->setJSON(['download_url' => $downloadUrl]);
    }
}
