<?php


namespace App\Controllers;

use App\Models\Paymentreceived_m;
use App\Models\Dealdetaildraft_m;
use App\Models\Deficite_m;
use App\Models\CreateInvoice_m;

class Turnover_progressive extends BaseController
{
    public function index()
    {
        $data['pageTitle'] = 'Progressive Report of Turnover, Cheque Receipt & Our Share';
        return view('turnover_progessive', $data);
    }

    public function TurnoverProgressiveReport()
    {
        $data['grand_total_suggestion'] = 0;
        $data['grand_total_service'] = 0;
        $data['grand_total_service_ourshareOurshare'] = 0;
        $data['grand_total_suggestionOurshare'] = 0;


        $fiscalyear = $this->request->getVar('fiscalyear');
        list($year1, $year2) = explode("-", $fiscalyear);

        $data['startyear'] = $year1;
        $data['endyear'] = $year2;

        $year1 = $year1 . '-04-01';
        $year2 = $year2 . '-03-31';


        $deficite = new Deficite_m();
        $data['suggestion_deficite'] = $deficite->table('tbl_deficite')
            ->select('tbl_deficite.def_id ,tbl_deficite.entity_id,tbl_deficite.target_year,tbl_deficite.def_amt')
            ->where('tbl_deficite.target_year', $fiscalyear)
            ->where('tbl_deficite.entity_id', 1)
            ->get()->getRow();


        $data['service_deficite'] = $deficite->table('tbl_deficite')
            ->select('tbl_deficite.def_id ,tbl_deficite.entity_id,tbl_deficite.target_year,tbl_deficite.def_amt')
            ->where('tbl_deficite.target_year', $fiscalyear)
            ->where('tbl_deficite.entity_id', 2)
            ->get()->getRow();

        $getInvoiceData = new CreateInvoice_m();
        $data['suggestion'] = $getInvoiceData->table('sss_tbl_invoices')->select('sss_inv_id,sss_inv_bill_no,sss_inv_bill_date,sss_inv_brief,sss_inv_amt,sss_inv_sgst,sss_inv_cgst,sss_inv_igst,sss_inv_total_amt')
            ->where('DATE(sss_tbl_invoices.sss_inv_bill_date) >=', $year1)
            ->where('DATE(sss_tbl_invoices.sss_inv_bill_date) <=', $year2)
            ->where('sss_tbl_invoices.sss_inv_entityId', 1)
            ->whereNotIn('sss_tbl_invoices.sss_inv_client_id', [16, 14])
            ->select('SUM(sss_tbl_invoices.sss_inv_amt) as suggestiontotalAmount')
            ->groupBy('MONTH(sss_tbl_invoices.sss_inv_bill_date)')
            ->get()->getResult();

        foreach ($data['suggestion'] as $suggestion) {
            $data['grand_total_suggestion'] += $suggestion->suggestiontotalAmount;
        }
        $data['service'] = $getInvoiceData->table('sss_tbl_invoices')->select('sss_inv_id,sss_inv_bill_no,sss_inv_bill_date,sss_inv_brief,sss_inv_amt,sss_inv_sgst,sss_inv_cgst,sss_inv_igst,sss_inv_total_amt')
            ->where('DATE(sss_tbl_invoices.sss_inv_bill_date) >=', $year1)
            ->where('DATE(sss_tbl_invoices.sss_inv_bill_date) <=', $year2)
            ->where('sss_tbl_invoices.sss_inv_entityId', 2)
            ->whereNotIn('sss_tbl_invoices.sss_inv_client_id', [16, 14])
            ->select('SUM(sss_tbl_invoices.sss_inv_amt) as servicetotalAmount')
            ->groupBy('MONTH(sss_tbl_invoices.sss_inv_bill_date)')
            ->get()->getResult();

        foreach ($data['service'] as $service) {
            $data['grand_total_service'] += $service->servicetotalAmount;
        }

        // monthly receipt our share....
        $oursharereport = new Dealdetaildraft_m();
        $data['suggestion_ourshare'] = $oursharereport->table('sss_tbl_dealdetaildraft')
            ->select('sss_tbl_dealdetaildraft.sss_pr_id as prId,sss_tbl_dealdetaildraft.sss_ddd_ourshare,sss_tbl_dealdetaildraft.sss_ddd_generatedate,sss_tbl_dealdetaildraft.sss_pr_id ,sss_tbl_paymentreceived.sss_pr_id as prId,sss_tbl_invoices.sss_inv_id as invId,sss_tbl_invoices.sss_inv_entityId as EntityId')
            ->where('DATE(sss_tbl_dealdetaildraft.sss_ddd_generatedate) >=', $year1)
            ->where('DATE(sss_tbl_dealdetaildraft.sss_ddd_generatedate) <=', $year2)
            ->where('sss_tbl_invoices.sss_inv_entityId', 1)
            ->join('sss_tbl_paymentreceived', 'sss_tbl_paymentreceived.sss_pr_id = sss_tbl_dealdetaildraft.sss_pr_id')
            ->join('sss_tbl_invoices', 'sss_tbl_invoices.sss_inv_id = sss_tbl_paymentreceived.sss_inv_id')
            ->select('MONTH(sss_tbl_dealdetaildraft.sss_ddd_generatedate) as ourshare_suggestion_receivedmonth')
            ->select('SUM(sss_tbl_dealdetaildraft.sss_ddd_ourshare) as suggestiontotalOurshare')
            ->groupBy('MONTH(sss_tbl_dealdetaildraft.sss_ddd_generatedate)')
            ->get()->getResult();

        foreach ($data['suggestion_ourshare'] as $suggestion_ourshare) {
            $data['grand_total_suggestionOurshare'] += $suggestion_ourshare->suggestiontotalOurshare;
        }

        $data['service_ourshare'] = $oursharereport->table('sss_tbl_dealdetaildraft')
            ->select('sss_tbl_dealdetaildraft.sss_pr_id as prId,sss_tbl_dealdetaildraft.sss_ddd_ourshare,sss_tbl_dealdetaildraft.sss_ddd_generatedate,sss_tbl_dealdetaildraft.sss_pr_id ,sss_tbl_paymentreceived.sss_pr_id as prId,sss_tbl_invoices.sss_inv_id as invId,sss_tbl_invoices.sss_inv_entityId as EntityId')
            ->where('DATE(sss_tbl_dealdetaildraft.sss_ddd_generatedate) >=', $year1)
            ->where('DATE(sss_tbl_dealdetaildraft.sss_ddd_generatedate) <=', $year2)
            ->where('sss_tbl_invoices.sss_inv_entityId', 2)
            ->join('sss_tbl_paymentreceived', 'sss_tbl_paymentreceived.sss_pr_id = sss_tbl_dealdetaildraft.sss_pr_id')
            ->join('sss_tbl_invoices', 'sss_tbl_invoices.sss_inv_id = sss_tbl_paymentreceived.sss_inv_id')
            ->select('MONTH(sss_tbl_dealdetaildraft.sss_ddd_generatedate) as ourshare_suggestion_receivedmonth')
            ->select('SUM(sss_tbl_dealdetaildraft.sss_ddd_ourshare) as servicetotalOurshare')
            ->groupBy('MONTH(sss_tbl_dealdetaildraft.sss_ddd_generatedate)')
            ->get()->getResult();

        foreach ($data['service_ourshare'] as $service_ourshare) {
            $data['grand_total_service_ourshare'] += $service_ourshare->servicetotalOurshare;
        }
        echo json_encode($data);
    }


    // public function print_monthlyreceipt()
    // {

    //     $data['sss_pr_amtreceived'] =  0;
    //     $data['sss_ddd_sbamt_amt'] =  0;
    //     $data['sss_ddd_cirilroyalityamt'] =  0;
    //     $data['sss_ddd_gst_finalamt'] =  0;
    //     $data['sss_ddd_misc'] = 0;
    //     $data['sss_ddd_ourshare'] = 0;
    //     $data['sss_pr_tdsamt'] = 0;
    //     $data['totalgross_share'] = 0;

    //     helper('number');
    //     $month = $this->request->getVar('month');

    //     $fiscalyear = $this->request->getVar('fiscalyear');

    //     list($year1, $year2) = explode("-", $fiscalyear);

    //     $year1 = $year1 . '-04-01';
    //     $year2 = $year2 . '-03-31';

    //     $ddd = new Dealdetaildraft_m();
    //     $query = $ddd->table('sss_tbl_dealdetaildraft')
    //         ->select('sss_tbl_dealdetaildraft.sss_ddd_id,sss_tbl_dealdetaildraft.sss_ddd_shno,sss_tbl_dealdetaildraft.sss_ddd_generatedate,sss_tbl_dealdetaildraft.sss_ddd_sbamt_amt,sss_tbl_dealdetaildraft.sss_ddd_cirilroyalityamt,sss_tbl_dealdetaildraft.sss_ddd_ourshare,sss_tbl_dealdetaildraft.sss_ddd_gst_finalamt,sss_tbl_dealdetaildraft.sss_ddd_misc,sss_tbl_dealdetaildraft.sss_pr_id as ddc_prId,sss_tbl_paymentreceived.sss_pr_id as prId,sss_tbl_paymentreceived.sss_pr_amtreceived,sss_tbl_paymentreceived.sss_pr_tdsamt,sss_tbl_invoices.sss_inv_id as invId,sss_tbl_invoices.sss_inv_client_id,sss_tbl_invoices.sss_inv_brief,sss_tbl_client.sss_client_id,sss_tbl_client.sss_client_name')
    //         ->join('sss_tbl_paymentreceived', 'sss_tbl_paymentreceived.sss_pr_id = sss_tbl_dealdetaildraft.sss_pr_id')
    //         ->join('sss_tbl_invoices', 'sss_tbl_invoices.sss_inv_id = sss_tbl_paymentreceived.sss_inv_id')
    //         ->join('sss_tbl_client', 'sss_tbl_client.sss_client_id = sss_tbl_invoices.sss_inv_client_id')
    //         ->select('(sss_tbl_paymentreceived.sss_pr_amtreceived + sss_tbl_paymentreceived.sss_pr_tdsamt - sss_tbl_dealdetaildraft.sss_ddd_gst_finalamt) as gross_share');

    //     // Apply conditions based on provided input values
    //     if (!empty($fiscalyear)) {
    //         $query->where('DATE( sss_tbl_dealdetaildraft.sss_ddd_generatedate) >=', $year1);
    //         $query->where('DATE( sss_tbl_dealdetaildraft.sss_ddd_generatedate) <=', $year2);
    //     }
    //     if (!empty($month)) {
    //         $query->where('MONTH(sss_tbl_dealdetaildraft.sss_ddd_generatedate) =', $month);
    //     }
    //     $data['monthly_report'] = $query->get()->getResult();

    //     foreach ($data['monthly_report'] as $monthly_receipt) {

    //         $data['sss_pr_amtreceived'] += $monthly_receipt->sss_pr_amtreceived ? $monthly_receipt->sss_pr_amtreceived : 0;
    //         $data['sss_ddd_sbamt_amt'] += $monthly_receipt->sss_ddd_sbamt_amt  ? $monthly_receipt->sss_ddd_sbamt_amt : 0;
    //         $data['sss_ddd_cirilroyalityamt'] += $monthly_receipt->sss_ddd_cirilroyalityamt  ? $monthly_receipt->sss_ddd_cirilroyalityamt : 0;
    //         $data['sss_ddd_gst_finalamt'] += $monthly_receipt->sss_ddd_gst_finalamt  ? $monthly_receipt->sss_ddd_gst_finalamt : 0;
    //         $data['sss_ddd_misc'] += $monthly_receipt->sss_ddd_misc  ? $monthly_receipt->sss_ddd_misc : 0;
    //         $data['sss_ddd_ourshare'] += $monthly_receipt->sss_ddd_ourshare  ? $monthly_receipt->sss_ddd_ourshare : 0;
    //         $data['sss_pr_tdsamt'] += $monthly_receipt->sss_pr_tdsamt  ? $monthly_receipt->sss_pr_tdsamt : 0;
    //         $data['totalgross_share'] += $monthly_receipt->gross_share  ? $monthly_receipt->gross_share : 0;
    //     }


    //     $dompdf = new \Dompdf\Dompdf(['isRemoteEnabled' => true]);
    //     $dompdf->loadHtml(view('printmothlyreceipt', $data), 'UTF-8');
    //     $dompdf->setPaper('A3', 'portrait');
    //     $dompdf->render();
    //     $pdfFileName = 'printmothlyreceipt.pdf';
    //     $pdfFilePath = FCPATH . 'public/uploads/' . $pdfFileName;
    //     file_put_contents($pdfFilePath, $dompdf->output());
    //     $downloadUrl = base_url('public/uploads/' . $pdfFileName);
    //     return $this->response->setJSON(['download_url' => $downloadUrl]);
    // }
}
