<?= $this->extend('commanfile/header'); ?>
<?= $this->section('content'); ?>
<div class="card card-default">

    <div class="card-body">
        <form id="bbreports" method="POST">
            <div class="row mb-2">
                <div class="col-md-3">
                    <div class="form-group">
                        <select class="form-control select2" id="fiscalyear" name="fiscalyear">
                            <option value="">Select Year</option>
                            <?php
                            $starting_year = date('Y', strtotime('-2 year')); // Adjust as needed
                            $ending_year = date('Y', strtotime('+40 year')); // Adjust as needed
                            for ($year = $starting_year; $year <= $ending_year; $year++) {
                                $next_year = $year + 1;
                                $fiscal_year = $year . '-' . $next_year; // Format fiscal year as YYYY-YY
                                echo '<option value="' . $fiscal_year . '">' . $fiscal_year . '</option>';
                            }
                            ?>
                        </select>
                    </div>
                </div>
                <div class="col-md-3">
                    <select class="form-control select2" name="month" id="month">
                        <option value="">Select Month</option>
                        <option value="4">April</option>
                        <option value="5">May</option>
                        <option value="6">June</option>
                        <option value="7">July</option>
                        <option value="8">August</option>
                        <option value="9">September</option>
                        <option value="10">October</option>
                        <option value="11">November</option>
                        <option value="12">December</option>
                        <option value="1">January</option>
                        <option value="2">February</option>
                        <option value="3">March</option>
                    </select>
                </div>
                <div class="col-md-3">
                    <div class="form-group">
                        <select class="form-control select2 sss_bb_vendorid" name="sss_bb_vendorid" id="sss_bb_vendorid">
                            <div class="form-group">
                                <option value="">Select Vendor</option>
                                <?php foreach ($vendordetails as $vd) { ?>
                                    <option value="<?= $vd->sss_vendor_id  ?>"><?= $vd->sss_vendor_name ?></option>
                                <?php } ?>
                            </div>
                        </select>
                    </div>
                </div>
                <div class="col-md-3">
                    <div class="form-group">
                        <div class="form-group">
                            <select class="form-control select2" name="sss_bb_vpid" id="purpose">
                                <option value="">Select Vendor Purpose </option>
                                <?php foreach ($vendorpurposes as $vp) { ?>
                                    <option value="<?= $vp->sss_vp_id  ?>"><?= $vp->sss_vp_purpose ?></option>
                                <?php } ?>
                            </select>
                        </div>
                    </div>
                </div>
                <div class="col-md-3">
                    <select class="form-control select2" name="sss_bankid" id="sss_bankid">
                        <div class="form-group">
                            <option value="">Select Bank</option>
                            <?php foreach ($allbanks as $bank) {
                            ?>
                                <option value="<?= $bank->sss_ent_bank_id ?>"><?= $bank->sss_ent_bank_name  . '-' . $bank->sss_ent_bank_acc_no ?></option>
                            <?php }
                            ?>
                        </div>
                    </select>
                </div>
                <div class="col-md-3">
                    <input type="text" name="particulars" id="particulars" class="form-control" placeholder="Enter Particulars">
                </div>


                <div class="col-md-2">
                    <button type="button" id="btnsearch" onclick="gebbreports()" class="btn btn-warning btn-block">Search Record</button>
                </div><!-- end col-->
                <div class="col-md-1">
                    <button type="button" id="btnreset" onclick="reload()" class="btn btn-dark btn-block">Refresh</button>
                </div><!-- end col-->
                <div class="col-md-2">
                    <a class="btn btn-danger" id="btngetreport" style="display: none;" onclick="printbbreport()">Get Report</a>
                </div>
            </div>
        </form>

        <table class="table table-bordered table-striped">
            <thead>
                <tr>
                    <th>Date</th>
                    <th>Vendor Name</th>
                    <th>Vendor Purpose</th>
                    <th>Bank Name</th>
                    <th>Particulars</th>
                    <th>Amount</th>
                </tr>
            </thead>
            <tbody id="bankbookreport_record">

            </tbody>
            <tfoot>
                <tr>
                    <th></th>
                    <th></th>
                    <th></th>
                    <th></th>
                    <th>Total Amount</th>
                    <th id="grandtotal"></th>
                </tr>
            </tfoot>
        </table>

    </div>
</div>

<script>
    $(document).ready(function() {
        $('#month').prop('disabled', true);
        $('#fiscalyear').change(function() {
            var selectedYear = $(this).val();
            if (selectedYear !== '') {
                $('#month').prop('disabled', false);
            } else {
                $('#month').prop('disabled', true);
            }
        });
    });

    function converttocomma(x) {
        x = x.toString();
        var afterPoint = '';
        if (x.indexOf('.') > 0)
            afterPoint = x.substring(x.indexOf('.'), x.length);
        x = Math.floor(x);
        x = x.toString();
        var lastThree = x.substring(x.length - 3);
        var otherNumbers = x.substring(0, x.length - 3);
        if (otherNumbers != '')
            lastThree = ',' + lastThree;
        var res = otherNumbers.replace(/\B(?=(\d{2})+(?!\d))/g, ",") + lastThree + afterPoint;
        return res;
    }

    // $(".sss_bb_vendorid").change(function() {
    //     let vendor = $(this).val();
    //     let url = '<?= base_url(); ?>/getPurposedropdown/' + vendor;
    //     $.ajax({
    //         url: url,
    //         method: "GET",
    //         dataType: "JSON",
    //         success: function(response) {
    //             // Remove options
    //             $('#purpose').find('option').not(':first').remove();
    //             $.each(response, function(index, data) {
    //                 $("#purpose").append(
    //                     '<option value="' + data.sss_vp_id + '">' + data.sss_vp_purpose + "</option>"
    //                 );
    //             });
    //         },
    //     });
    // });

    function gebbreports() {
        var url = "<?= base_url() ?>/get_bbreport";
        var formData = new FormData($('#bbreports')[0]);
        $("#bankbookreport_record").empty();

        $.ajax({
            url: url,
            type: "POST",
            data: formData,
            contentType: false,
            processData: false,
            dataType: "JSON",
            success: function(response) {
                if (response.length > 0) {
                    $('#grandtotal').text(0);
                    let sum = 0;
                    for (let i = 0; i < response.length; i++) {
                            var particulars = response[i]['sss_bb_particulars'].split(' _ ');
                            particulars = (particulars[2]) ? particulars[2] : response[i]['sss_bb_particulars'];
                            $('#bankbookreport_record').append('<tr class="searchrecord"><td>' + response[i]['sss_bb_transactiondate'].split('-').reverse().join('-') + '</td><td>' + response[i]['sss_vendor_name'] + '</td><td>' + response[i]['sss_vp_purpose'] + '</td><td>' + response[i]['sss_ent_bank_name'] + '</td><td>' + particulars + '</td><td>' + converttocomma(response[i]['sss_bb_finalamt']) + '</td><td class="tdsamt d-none">' + response[i]['sss_bb_finalamt'] + '</td>');
                        }
                    $('#btngetreport').css('display', 'block');
                    calc_total();
                } else {
                    $('#bankbookreport_record').append('<tr><td colspan="5">No Record Found<td></tr>');
                    calc_total();
                }
            }
        });
    }

    let sum = 0;

    function calc_total() {
        sum = 0;
        $(".tdsamt").each(function() {
            sum += parseFloat($(this).text());
        });
        $('#grandtotal').text(converttocomma(sum));
    }

    function reload() {
        location.reload();
    }

    function printbbreport() {
        // window.location.href = '<?= base_url() ?>/printbbreport/' + fiscalyear + '/' + month + '/' + sss_bb_vendorid + '/' + purpose + '/' + sss_bankid + '/' + particulars  ;
        var url = "<?= base_url() ?>/printbbreport";
        var formData = new FormData($('#bbreports')[0]);
        $("#bankbookreport_record").empty();
        $.ajax({
            url: url,
            type: "POST",
            data: formData,
            contentType: false,
            processData: false,
            dataType: "JSON",
            success: function(response) {
                // window.location.href = '<?= base_url() ?>/printbbreport';
                var downloadLink = document.createElement('a');
                downloadLink.href = response.download_url;
                downloadLink.download = 'bbreport.pdf';
                downloadLink.addEventListener('click', function() {
                    // Show success message
                    alert('Report downloaded successfully');
                    // Reload the page after a delay (you can adjust the delay time)
                    setTimeout(function() {
                        location.reload();
                    }, 2000); // 2000 milliseconds = 2 seconds
                });
                downloadLink.click();
            }
        });
    }
</script>
<?= $this->endSection(); ?>