<?= $this->extend('commanfile/header'); ?>
<?= $this->section('content'); ?>
<meta charset="utf-8">
<style>
    html,
    body {
        margin: 0;
        padding: 0;
    }

    * {
        box-sizing: border-box;
    }

    @page {
        size: A4;
        margin: 0;
    }

    @media print {
        table {
            max-height: 100% !important;
            overflow: hidden !important;
            page-break-after: always;
        }
    }
</style>

<div class="card card-default">
    <div class="card-header">
        <h3 class="card-title">Generate Report for DDD</h3>
        <div class="card-tools">
            <button type="button" class="btn btn-sm btn-danger" onclick='printPageArea("printreport")' ;> <i class="fa fa-print"></i> Print Report</button>
            <!-- <button type="button" class="btn btn-tool" data-card-widget="collapse"><i class="fa fa-minus"></i></button> -->
        </div>
    </div>
    <div class="card-body">
        <form id="searchreports" method="POST">
            <div class="row mb-2">
                <div class="col-md-3">
                    <div class="form-group">
                        <select class="form-control select2 sss_invoiceno" name="sss_invoiceno">
                            <option>Select Invoice</option>
                            <?php foreach ($invoice_nos as $invoice) { ?>
                                <option value="<?= $invoice['sss_inv_id'] ?>"><?= $invoice['sss_inv_bill_no'] ?></option>
                            <?php } ?>
                        </select>
                    </div>
                </div>
                <div class="col-md-3">
                    <div class="form-group">
                        <select class="form-control select2 ddd_shno" name="ddd_shno">
                            <option>Select Invoice</option>
                        </select>
                    </div>
                </div>
                <div class="col-md-1">
                    <button type="button" id="btnsearch" onclick="searchreports()" class="btn btn-info"><i style="font-size: 18px;" class="mdi mdi-account-search me-2"></i>Search</button>
                </div><!-- end col-->
                <div class="col-md-1">
                    <button type="button" id="btnreset" onclick="reload()" class="btn btn-dark"><i style="font-size:18px;" class="mdi mdi-reload me-2"></i>Refresh</button>
                </div><!-- end col-->
            </div>
        </form>
    </div>
</div>
<div class="card card-default" id="printreport">
    <div class="card-body">
        <div class="row">
            <div class="col-md-4">
                <label>DDD Date</label>
                <div class="form-group">
                    <input type="text" class="form-control sss_ddd_generatedate" id="sss_ddd_generatedate" />
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-md-4">
                <label>Organization Name</label>
                <div class="form-group">
                    <div class="input-group">
                        <input type="text" class="form-control sss_ent_name" id="sss_ent_name" name="sss_ent_name" readonly>
                    </div>
                </div>
            </div>
            <div class="col-md-4">
                <label>Bill Number</label>
                <div class="form-group">
                    <div class="input-group">
                        <input type="text" readonly class="form-control billNumber" name="billnoforparticulars" readonly>
                    </div>
                </div>
            </div>
            <div class="col-md-4">
                <label>Bill Date</label>
                <div class="form-group">
                    <div class="input-group">
                        <input type="text" readonly class="form-control billDate">
                    </div>
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-md-4">
                <label>Client Name</label>
                <div class="form-group">
                    <div class="input-group">
                        <input type="text" readonly class="form-control clientName" readonly>
                    </div>
                </div>
            </div>
            <div class="col-md-4">
                <label>Premises</label>
                <div class="form-group">
                    <div class="input-group">
                        <input type="text" readonly class="form-control premises" readonly>
                    </div>
                </div>
            </div>
            <div class="col-md-4">
                <label>SH Number</label>
                <div class="form-group">
                    <div class="input-group">
                        <input type="text" readonly class="form-control sss_ddd_shno">
                    </div>
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-md-2">
                <label>Rent Amount</label>
                <div class="form-group">
                    <div class="input-group">
                        <input type="text" readonly class="form-control rentamount" readonly>
                    </div>
                </div>
            </div>
            <div class="col-md-2">
                <label>GST</label>
                <div class="form-group">
                    <div class="input-group">
                        <input type="text" readonly class="form-control gst" readonly>
                    </div>
                </div>
            </div>
            <div class="col-md-2">
                <label>Invoice Amount</label>
                <div class="form-group">
                    <div class="input-group">
                        <input type="text" readonly class="form-control billAmount" readonly>
                    </div>
                </div>
            </div>
            <div class="col-md-2">
                <label>TDS</label>
                <div class="form-group">
                    <div class="input-group">
                        <input type="text" readonly class="form-control tdsamt" readonly>
                    </div>
                </div>
            </div>
            <div class="col-md-2">
                <label>Miscellaneous</label>
                <div class="form-group">
                    <div class="input-group">
                        <input type="text" readonly class="form-control sss_ddd_misc">
                    </div>
                </div>
            </div>
            <div class="col-md-2">
                <label>Balance Due</label>
                <div class="form-group">
                    <div class="input-group">
                        <input type="text" readonly class="form-control balanceamt" readonly>
                    </div>
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-md-2">
                <label>Amount Received</label>
                <div class="form-group">
                    <div class="input-group">
                        <input type="text" readonly class="form-control amountreceived" readonly>
                    </div>
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-md-6">
                <label>Our Service Fees</label>
                <div class="form-group">
                    <div class="input-group">
                        <input type="text" readonly class="form-control ddd_service" readonly>
                    </div>
                </div>
            </div>
            <div class="col-md-6">
                <label>GST</label>
                <div class="form-group">
                    <div class="input-group">
                        <input type="text" readonly class="form-control ddd_service_gst" readonly>
                    </div>
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-md-12">
                <table id="sub-brokerage-details-data-table" class="table table-bordered table-striped">
                    <tbody>
                        <tr>
                            <td>Particulars</td>
                            <td>Amount</td>
                            <td>TDS</td>
                        </tr>
                        <tr>
                            <td>
                                SUB BROKERAGE
                                <input type="text" hidden name="sss_ddd_sbbrkg" value="SUB BROKERAGE">
                            </td>
                            <td>
                                <div class="form-group">
                                    <div class="input-group">
                                        <input type="text" readonly class="form-control sss_ddd_sbamt_amt" readonly>
                                    </div>
                                </div>
                            </td>
                            <td>
                                <div class="row">
                                    <div class="col-md-6">
                                        <div class="form-group">
                                            <div class="input-group mb-1">
                                                <input type="text" readonly class="form-control sss_ddd_sbamt_tdsper" readonly>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="col-md-6">
                                        <div class="form-group">
                                            <div class="input-group mb-1">
                                                <input type="text" readonly class="form-control sss_ddd_sbamt_tds" readonly>
                                            </div>
                                        </div>

                                    </div>
                                </div>

                                <!-- <div class="input-group">
                                    </div> -->
                                <!-- <small>( 5 % on Amount )</small> -->

                            </td>
                        </tr>
                        <tr>
                            <td>
                                CIRIL ROYALTY
                                <input type="text" hidden name="sss_ddd_cirilroyality" value="CIRIL ROYALTY">
                            </td>
                            <td>
                                <div class="form-group">
                                    <div class="input-group">
                                        <input type="text" readonly class="form-control sss_ddd_cirilroyalityamt" name="" id="sss_ddd_cirilroyalityamt" readonly>
                                    </div>
                                </div>
                            </td>
                            <td>
                                <div class="row">
                                    <div class="col-md-6">
                                        <div class="form-group">
                                            <div class="input-group mb-1">
                                                <input type="text" readonly class="form-control sss_ddd_cirilroyality_tdsper" readonly>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="col-md-6">
                                        <div class="form-group">
                                            <div class="input-group">
                                                <input type="text" readonly class="form-control sss_ddd_cirilroyality_tds" readonly>
                                            </div>
                                        </div>
                                    </div>
                                    </small>
                                </div>
                            </td>
                        </tr>
                        <tr>
                            <td>
                                <div class="input-group">
                                    <input type="text" readonly class="form-control sss_ddd_unknown" name="sss_ddd_unknown" id="sss_ddd_unknown" placeholder="UNKNOWN">
                                </div>
                            </td>
                            <td>
                                <div class="form-group">
                                    <div class="input-group">
                                        <input type="text" readonly class="form-control sss_ddd_unknownamt" name="sss_ddd_unknownamt" id="sss_ddd_unknownamt" placeholder="Enter Amount">
                                    </div>
                                </div>

                            </td>
                            <td>
                                <div class="row">
                                    <div class="col-md-6">
                                        <div class="form-group">
                                            <div class="input-group mb-1">
                                                <input type="text" readonly class="form-control sss_ddd_unknown_tdsper" readonly>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="col-md-6">
                                        <div class="input-group">
                                            <input type="text" readonly class="form-control sss_ddd_unknown_tds" readonly>
                                        </div>
                                    </div>
                                </div>
                            </td>
                        </tr>
                        <tr>
                            <td>
                                BALANCE [OUR SHARE]
                            </td>
                            <td>
                                <div class="form-group">
                                    <div class="input-group">
                                        <input type="text" readonly class="form-control sss_ddd_ourshare" readonly>
                                        <input type="text" hidden readonly class="form-control" name="seventypercentageamt" id="seventypercentageamt" readonly>
                                    </div>
                                </div>
                            </td>
                            <td colspan="3"></td>
                        </tr>
                    </tbody>
                </table>
            </div>

            <div class="row">
                <div class="col-md-12">
                    <h5>Our Share Calculations - W.E.F 01.09.14 everything is calculated on 70% of Our Share</h5>
                </div>
            </div>
            <div class="row">
                <div class="col-md-12">
                    <table id="" class="table table-head-fixed table-bordered table-striped text-nowrap">
                        <thead>
                            <tr>
                                <th>#</th>
                                <th>Details</th>
                                <th>Amount</th>
                                <th>Rounded</th>
                                <th>Total</th>
                                <th>TDS</th>
                                <th>Final Amount</th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr>
                                <td>1</td>
                                <td>GST [TAX]</td>
                                <td>
                                    <div class="form-group">
                                        <div class="input-group">
                                            <input type="text" readonly class="form-control sss_ddd_gst_amt" readonly>
                                        </div>
                                    </div>
                                </td>
                                <td>
                                    <div class="form-group">
                                        <div class="input-group">
                                            <input type="text" readonly class="form-control sss_ddd_gst_rounded" readonly>
                                        </div>
                                    </div>
                                </td>
                                <td>
                                    <div class="form-group">
                                        <div class="input-group">
                                            <input type="text" readonly class="form-control sss_ddd_gst_total" readonly>
                                        </div>
                                    </div>
                                </td>
                                <td>
                                    <div class="form-group">
                                        <div class="input-group">
                                            <input type="text" readonly class="form-control sss_ddd_gst_tds">
                                        </div>
                                    </div>
                                </td>
                                <td>
                                    <div class="form-group">
                                        <div class="input-group">
                                            <input type="text" readonly class="form-control sss_ddd_gst_finalamt" readonly>
                                        </div>
                                    </div>
                                </td>
                            </tr>
                        </tbody>


                        <tbody id="outcomes">

                        </tbody>
                        <tbody id="emps">

                        </tbody>


                        <tr>
                            <td></td>
                            <td><b>Total Expenses</b></td>
                            <td>
                                <div class="form-group">
                                    <div class="input-group">
                                        <input type="text" readonly class="form-control totalAmt" readonly>
                                    </div>
                                </div>
                            </td>
                            <td>
                                <div class="form-group">
                                    <div class="input-group">
                                        <input type="text" readonly class="form-control sss_ddd_total_roundvalue" readonly>
                                    </div>
                                </div>
                            </td>
                            <td>
                                <div class="form-group">
                                    <div class="input-group">
                                        <input type="text" readonly class="form-control sss_ddd_sumofroundvalue" readonly>
                                    </div>
                                </div>
                            </td>
                            <td>
                                <div class="form-group">
                                    <div class="input-group">
                                        <input type="text" readonly class="form-control sss_ddd_total_tds" readonly>
                                    </div>
                                </div>
                            </td>
                            <td>
                                <div class="form-group">
                                    <div class="input-group">
                                        <input type="text" readonly class="form-control sss_ddd_total_finalamt" readonly>
                                    </div>
                                </div>
                            </td>
                        </tr>
                        <tr>
                            <td></td>
                            <td><b>BALANCE IN <br> [Current A/C]</b></td>
                            <td>
                                <div class="form-group">
                                    <div class="input-group">
                                        <input type="text" readonly class="form-control sss_ddd_balanceincurrent" readonly>
                                    </div>
                                </div>
                            </td>
                            <td>
                                <b>BALANCE IN <br> [CURRENT A/C %]</b>
                            </td>
                            <td>
                                <div class="form-group">
                                    <div class="input-group">
                                        <input type="text" readonly class="form-control sss_ddd_balanceincurrentinper" readonly>
                                    </div>
                                </div>
                            </td>
                        </tr>

                        <tr style="display:none">
                            <td></td>
                            <td></td>
                            <td>
                                <input type="text" class="totaltax" name="totaltax">
                            </td>
                            <td><input type="text" class="taxinvno" name="taxinvno">
                            </td>
                            <td>
                            </td>
                            <td></td>
                        </tr>
                        <tr style="display:none">
                            <td></td>
                            <td></td>
                            <td>
                                <input type="text" class="sourcebank" name="sourcebank">
                            </td>
                            <td><input type="text" class="advinvno" name="advinvno">
                            </td>
                            <td><input type="text" class="totaladvertisment" name="totaladvertisment">
                            </td>
                            <td></td>
                        </tr>
                        <tr style="display:none">
                            <td></td>
                            <td></td>
                            <td>
                                <input type="text" placeholder="f" id="sumofempRoundvalues" class="totalempsalary" name="totalempsalary">
                            </td>
                            <td><input type="text" class="empinvno" name="empinvno">
                            </td>
                            <td>
                            </td>
                            <td><input type="text" class="totaltdsofemp" name="totaltdsofemp"></td>
                        </tr>
                        </tbody>
                    </table>
                </div>
            </div>
            <div class="row">
                <div class="col-md-6">
                    <label>Transaction Mode</label>
                    <div class="form-group">
                        <input type="text" readonly class="form-control sss_ddd_transmode">
                    </div>
                </div>
                <div class="col-md-6">
                    <label>Transaction Ref. No.</label>
                    <div class="form-group">
                        <div class="input-group">
                            <input type="text" readonly class="form-control sss_ddd_transreffno">
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>



<script>
    $('.sss_invoiceno').on('change', function() {

        let invoiceno = $('.sss_invoiceno').val();
        // alert(invoiceno);
        let url = "<?= base_url() ?>/getShno/" + invoiceno;
        $.ajax({
            url: url,
            type: "GET",
            dataType: "JSON",
            success: function(response) {
                
                $('.ddd_shno').find('option').not(':first').remove();
                $.each(response, function(index, data) {
                    $(".ddd_shno").append(
                        '<option value="' + data.sss_ddd_id + '">' + data.sss_ddd_shno + "</option>"
                    );
                });
            },
        });
    });



    function searchreports() {
        var url = "<?= base_url() ?>/get_dddreport";
        var formData = new FormData($('#searchreports')[0]);
        
        var premise_brief;
        
        $.ajax({
            url: url,
            type: "POST",
            data: formData,
            contentType: false,
            processData: false,
            dataType: "JSON",
            success: function(response) {
                
                premise_brief = response.ddd.sss_inv_brief;
                premise_brief = premise_brief.split(";");
                premise_brief = premise_brief[1];
                
                $('.sss_ent_name').attr('value', response.ddd.sss_ent_name);

                $('.sss_ddd_generatedate').attr('value', response.ddd.sss_ddd_generatedate);
                $('.billNumber').attr('value', response.ddd.sss_inv_bill_no);
                $('.sss_ddd_shno').attr('value', response.ddd.sss_ddd_shno);
                $('.billDate').attr('value', response.ddd.sss_inv_bill_date);
                $('.clientName').attr('value', response.ddd.sss_client_name);
                $('.premises').attr('value', premise_brief);
                $('.rentamount').attr('value', response.ddd.sss_inv_amt);
                $('.gst').attr('value', response.ddd.sss_ddd_gst_amt);
                $('.billAmount').attr('value', response.ddd.sss_inv_total_amt);
                $('.tdsamt').attr('value', response.ddd.sss_pr_tdsamt);
                $('.sss_ddd_misc').attr('value', response.ddd.sss_ddd_misc);
                $('.balanceamt').attr('value', response.ddd.sss_pr_balanceamt);
                $('.amountreceived').attr('value', response.ddd.sss_pr_amtreceived);
                $('.ddd_service').attr('value', response.ddd.sss_inv_amt);
                $('.ddd_service_gst').attr('value', response.ddd.sss_ddd_gst_amt);
                $('.sss_ddd_sbamt_amt').attr('value', response.ddd.sss_ddd_sbamt_amt);
                $('.sss_ddd_sbamt_tds').attr('value', response.ddd.sss_ddd_sbamt_tds);
                $('.sss_ddd_sbamt_tdsper').attr('value', response.ddd.sss_ddd_sbamt_tdsper);
                $('.sss_ddd_cirilroyalityamt').attr('value', response.ddd.sss_ddd_cirilroyalityamt);
                $('.sss_ddd_cirilroyality_tds').attr('value', response.ddd.sss_ddd_cirilroyality_tds);
                $('.sss_ddd_cirilroyality_tdsper').attr('value', response.ddd.sss_ddd_cirilroyality_tdsper);
                $('.sss_ddd_unknown').attr('value', response.ddd.sss_ddd_unknown);
                $('.sss_ddd_unknownamt').attr('value', response.ddd.sss_ddd_unknownamt);
                $('.sss_ddd_unknown_tdsper').attr('value', response.ddd.sss_ddd_unknown_tdsper);
                $('.sss_ddd_unknown_tds').attr('value', response.ddd.sss_ddd_unknown_tds);
                $('.sss_ddd_ourshare').attr('value', response.ddd.sss_ddd_ourshare);
                $('.sss_ddd_gst_amt').attr('value', response.ddd.sss_ddd_gst_amt);
                $('.sss_ddd_gst_rounded').attr('value', response.ddd.sss_ddd_gst_rounded);
                $('.sss_ddd_gst_total').attr('value', response.ddd.sss_ddd_gst_finalamt);
                $('.sss_ddd_gst_finalamt').attr('value', response.ddd.sss_ddd_gst_finalamt);
                $('.sss_ddd_gst_tds').attr('value', response.ddd.sss_ddd_gst_tds);
                $('.sss_ddd_total_roundvalue').attr('value', response.ddd.sss_ddd_total_roundvalue);
                $('.sss_ddd_total_tds').attr('value', response.ddd.sss_ddd_total_tds);
                $('.sss_ddd_total_finalamt').attr('value', response.ddd.sss_ddd_total_finalamt);
                $('.sss_ddd_balanceincurrent').attr('value', response.ddd.sss_ddd_balanceincurrent);
                $('.sss_ddd_balanceincurrentinper').attr('value', response.ddd.sss_ddd_balanceincurrentinper);
                $('.sss_ddd_transmode').attr('value', response.ddd.sss_ddd_transmode);
                $('.sss_ddd_transreffno').attr('value', response.ddd.sss_ddd_transreffno);

                if (response.outcome.length > 0) {
                    let no = 1;
                    for (let i = 0; i < response.outcome.length; i++) {
                        let n = no++;
                        $('#outcomes').append('<tr><td>' + n + '</td><td>' + response.outcome[i]['sss_oc_name'] + '</td><td><input type="text" readonly class="form-control tdsamt" value="' + response.outcome[i]['sss_ddd_outcomeamt'] + '" readonly></td><td><input type="text" readonly class="form-control tdsamt" value="' + response.outcome[i]['sss_ddd_outcomeroundamt'] + '" readonly></td><td><input type="text" readonly class="form-control tdsamt" value="' + response.outcome[i]['sss_ddd_outcometotalamt'] + '" readonly></td><td><input type="text" readonly class="form-control tdsamt" value="' + response.outcome[i]['sss_dddoutcome_tds'] + '" readonly></td><td><input type="text" readonly class="form-control tdsamt" value="' + response.outcome[i]['sss_ddd_outcomefinalamt'] + '" readonly></td><tr>');
                    }
                } else {
                    $('#outcomes').append('<tr><td colspan="5">No Record Found<td></tr>');
                }

                if (response.emps.length > 0) {
                    let mo = 1;
                    for (let i = 0; i < response.emps.length; i++) {
                        let m = mo++;
                        $('#emps').append('<tr><td>' + m + '</td><td>' + response.emps[i]['sss_emp_fname'] + ' ' + response.emps[i]['sss_emp_lname'] + '</td><td><input type="text" readonly class="form-control" value="' + response.emps[i]['sss_dddemp_amt'] + '" readonly></td><td><input type="text" readonly class="form-control" value="' + response.emps[i]['sss_dddemp_roundedamt'] + '" readonly></td><td><input type="text" readonly class="form-control" value="" readonly></td><td><input type="text" readonly class="form-control" value="' + response.emps[i]['sss_dddemp_tds'] + '" readonly></td><td><input type="text" readonly class="form-control" value="' + response.emps[i]['sss_dddemp_finalamt'] + '" readonly></td></tr>');
                        // $('#emps').append('<tr><td>' + m + '</td><td>' + response.emps[i]['sss_emp_fname']+ ' ' + response.emps[i]['sss_emp_lname']+ '</td><td>' + response.emps[i]['sss_dddemp_amt'] + '</td><td>' + response.emps[i]['sss_dddemp_roundedamt'] + '</td><td></td><td>' + response.emps[i]['sss_dddemp_tds'] + '</td><td>' + response.emps[i]['sss_dddemp_finalamt'] + '</td></tr>');

                    }

                } else {
                    $('#emps').append('<tr><td colspan="5">No Record Found<td></tr>');

                }


            }
        });
    }


    function printPageArea(printreport) {
        var printContent = document.getElementById(printreport).innerHTML;
        var originalContent = document.body.innerHTML;
        document.body.innerHTML = printContent;
        window.print();
        // document.body.innerHTML = originalContent;
    }

    function reload() {
        location.reload();
    }
</script>

<?= $this->endSection(); ?>