<?= $this->extend('commanfile/header'); ?>
<?= $this->section('content'); ?>
<div class="row">
    <div class="col-md-12">
        <div class="card">
            <div class="card-header">
                <!-- <h3 class="card-title">Bank Details</h3> -->
                <a href="javascript:void(0)" class="btn btn-md btn-info" onclick="deficite()">
                    <i class="fa fa-plus-square mr-1"></i> Add Target
                </a>
            </div>
            <!-- /.card-header -->
            <div class="card-body">
                <table id="def_table" class="table table-bordered table-striped">
                    <thead>
                        <tr>
                            <th>Entity Name</th>
                            <th>Target Year</th>
                            <th>Target Amount</th>
                            <th>Action</th>
                        </tr>
                    </thead>
                    <tbody>
                    </tbody>
                    <tfoot>
                        <tr>
                            <th>Entity Name</th>
                            <th>Target Year</th>
                            <th>Target Amount</th>
                            <th>Action</th>
                        </tr>
                    </tfoot>
                </table>
            </div>
            <!-- /.card-body -->
        </div>
    </div>
</div>
<div class="modal fade" id="Adddeficite">
    <div class="modal-dialog modal-lg">
        <div class="modal-content">
            <div class="modal-header">
                <h4 class="modal-title">Add Deficite Here</h4>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                <form id="defform" method="POST">
                    <input type="text" name="def_id" hidden>
                    <div class="row">
                        <div class="col-md-6">
                            <label>Select Entity Name :</label>
                            <div class="form-group">
                                <div class="input-group">
                                    <select class="form-control" name="entity_id" id="entity_id">
                                        <option value="">Select an Entity</option>
                                        <?php foreach ($entities as $ent) { ?>
                                            <option value="<?= $ent->sss_ent_id  ?>" <?php set_value('entity_id', $ent->sss_ent_id ) ?>><?= $ent->sss_ent_name ?></option>
                                        <?php } ?>
                                    </select>
                                </div>
                                <span class="text-danger error-text entity_id_error"></span>
                            </div>
                        </div>
                        <div class="col-md-6">
                            <label>Target Year:</label>
                            <div class="form-group">
                                <select class="form-control select2" id="target_year" name="target_year">
                                    <option value="">Select Year</option>
                                    <?php
                                    $starting_year = date('Y', strtotime('-2 year')); // Adjust as needed
                                    $ending_year = date('Y', strtotime('+40 year')); // Adjust as needed
                                    for ($year = $starting_year; $year <= $ending_year; $year++) {
                                        $next_year = $year + 1;
                                        $fiscal_year = $year . '-' . $next_year; // Format fiscal year as YYYY-YY
                                        echo '<option value="' . $fiscal_year . '">' . $fiscal_year . '</option>';
                                    }
                                    ?>
                                </select>
                            </div>
                        </div>

                    </div>
                    <div class="row">
                        <div class="col-md-6">
                            <label>Target Amount</label>
                            <div class="form-group">
                                <div class="input-group">
                                    <input type="text" class="form-control" name="def_amt" id="def_amt" placeholder="Enter Amount">
                                </div>
                                <span class="text-danger error-text sss_invoice_type_error"></span>
                            </div>
                        </div>
                    </div>
            </div>
            <div class="modal-footer justify-content-right">
                <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                <button type="button" onclick="save_deficite()" class="btn btn-primary">Save changes</button>
            </div>
            </form>
        </div>
    </div>
</div>
<script>
    var save_method;
    // sac code operations ...
    $(document).ready(function() {
        table = $('#def_table').DataTable({
            "processing": true, //Feature control the processing indicator.
            "serverSide": true, //Feature control DataTables' server-side processing mode.
            "order": [], //Initial no order.
            "ordering": true,
            "searching": true,
            "responsive": true,
            "lengthChange": false,
            // Load data for the table's content from an Ajax source
            "ajax": {
                "url": "<?php echo base_url() ?>/get_deficite",
            },
            //Set column definition initialisation properties.
            "columnDefs": [{
                "targets": [-1], //last column
                "orderable": false, //set not orderable
            }, ],
        });
    });

    function deficite() {
        save_method = 'add';
        $('.form-group').removeClass('has-error'); // clear error class
        $('.help-block').empty(); // clear error string
        $('#Adddeficite').modal('show'); // show bootstrap modal
    }

    function edit_deficite(deficite_id) {
        alert(deficite_id);
        save_method = 'update';
        var link = "<?php echo base_url() ?>/edit_deficiterecord/" + deficite_id;
        //Ajax Load data from ajax
        $.ajax({
            url: link,
            type: "GET",
            dataType: "JSON",
            success: function(data) {
                $('[name="def_id"]').val(data.def_id);
                $('[name="entity_id"]').val(data.entity_id);
                $('[name="def_amt"]').val(data.def_amt);
                $('[name="target_year"]').val(data.target_year);
                $('#Adddeficite').modal('show'); // show bootstrap modal when complete loaded
                $('.modal-title').text('Edit Deficite'); // Set title to Bootstrap modal title
            },
            error: function(jqXHR, textStatus, errorThrown) {
                alert(errorThrown);
            }
        });
    }

    function save_deficite() {
        $('#btnSave').text('saving info...'); //change button text
        $('#btnSave').attr('disabled', true); //set button disable 
        var url;
        if (save_method == 'add') {
            url = "<?= base_url() ?>/insertdeficite";
        } else {
            url = "<?php echo base_url() ?>/updatedeficite";
        }
        var formData = new FormData($('#defform')[0]);
        $.ajax({
            url: url,
            type: "POST",
            data: formData,
            contentType: false,
            processData: false,
            dataType: "JSON",
            success: function(data) {
                if (data.status == true) //if success close modal and reload ajax table
                {
                    Swal.fire(
                        data.message
                    )
                    $('#Adddeficite').modal('hide');
                    $('#defform')[0].reset();
                    table.ajax.reload(null, false); //reload datatable ajax 

                    // Swal.fire({
                    //     text: data.message,
                    //     focusConfirm: true,
                    //     confirmButtonText: '<a class="btn btn-sm" style="color:#fff;" onclick="location.reload()">OK</a>',
                    // });
                    // setTimeout(function() {
                    //     $('#loader').show();
                    //     location.reload();
                    // }, 2500);

                } else {
                    $.each(data.error, function(prefix, val) {
                        // $('[name="' + prefix + '"]').next().text(val);
                        // $(`span.${prefix}_error`).text(val)
                        $('#defform').find(`span.${prefix}_error`).text(val);
                        // $(saccode_data).find('span.' +prefix+ '_error').text(val);
                    });
                }
                $('#btnSave').text('save'); //change button text
                $('#btnSave').attr('disabled', false); //set button enable 
            }
        });
    }
    // delete funtion....
    function delete_deficite(id) {
        Swal.fire({
            title: 'Are you sure?',
            text: "You won't be able to revert this!",
            icon: 'warning',
            showCancelButton: true,
            confirmButtonColor: '#3085d6',
            cancelButtonColor: '#d33',
            confirmButtonText: 'Yes, delete it!'
        }).then((result) => {
            if (result.isConfirmed) {
                $.ajax({
                    url: "<?php echo base_url() ?>/deleterecord/" + id,
                    type: "GET",
                    dataType: "JSON",
                    success: function(data) {
                        if (data.status == true) {
                            Swal.fire(
                                'Deleted!',
                                'Your file has been deleted.',
                                'success'
                            )
                            table.ajax.reload(null, false); //reload datatable ajax 
                        }
                    },
                    error: function(jqXHR, textStatus, errorThrown) {
                        alert(errorThrown);
                    }
                });
            }
        })
    }


</script>
<?= $this->endSection(); ?>