<?= $this->extend('commanfile/header'); ?>
<?= $this->section('content'); ?>
<div class="card card-default">
    <div class="card-body">
        <form id="monthly_receipt_form" method="POST">
            <div class="row mb-2">
                <div class="col-md-3">
                    <div class="form-group">
                        <select class="form-control select2" id="fiscalyear" name="fiscalyear">
                            <option value="">Select Year</option>
                            <?php
                            $starting_year = date('Y', strtotime('-2 year')); // Adjust as needed
                            $ending_year = date('Y', strtotime('+40 year')); // Adjust as needed
                            for ($year = $starting_year; $year <= $ending_year; $year++) {
                                $next_year = $year + 1;
                                $fiscal_year = $year . '-' . $next_year; // Format fiscal year as YYYY-YY
                                echo '<option value="' . $fiscal_year . '">' . $fiscal_year . '</option>';
                            }
                            ?>
                        </select>
                    </div>
                </div>

                <div class="col-md-3">
                    <select class="form-control select2" name="month" id="month">
                        <option value="">Select Month</option>
                        <option value="4">April</option>
                        <option value="5">May</option>
                        <option value="6">June</option>
                        <option value="7">July</option>
                        <option value="8">August</option>
                        <option value="9">September</option>
                        <option value="10">October</option>
                        <option value="11">November</option>
                        <option value="12">December</option>
                        <option value="1">January</option>
                        <option value="2">February</option>
                        <option value="3">March</option>
                    </select>
                </div>

        </form>
        <div class="col-md-2">
            <button type="button" id="btnsearch" onclick="get_monthlyreceipt()" class="btn btn-info btn-block">Search</button>
        </div><!-- end col-->
        <div class="col-md-2">
            <button type="button" id="btnreset" onclick="location.reload()" class="btn btn-dark btn-block">Refresh</button>
        </div><!-- end col-->
        <div class="col-md-2">
            <a class="btn btn-danger" id="btngetreport" style="display: none;" onclick="printscreport()">Get Report</a>
        </div>
    </div>


    <div class="card">
        <div class="card-body">
            <table id="" class="table table-bordered table-striped">
                <thead>
                    <tr>
                        <th>Sheet No.</th>
                        <th>Disbursement Date</th>
                        <th>Client & Premise</th>
                        <th>Amount Received</th>
                        <th>TDS</th>
                        <th>GST</th>
                        <th>Gross Share</th>
                        <th>Sub Brokerage</th>
                        <th>Ciril Royality</th>
                        <th>Misc</th>
                        <th>Our Share</th>
                    </tr>
                </thead>
                <tbody id="monthly_record">

                </tbody>
            </table>
        </div>
    </div>
</div>
</div>

<script>
    var save_method;

    $(document).ready(function() {

        $('#btnsearch').attr('disabled', true); //set button disable 

        function checkDropdowns() {
            var fiscalYearValue = $('#fiscalyear').val();
            var typeValue = $('#type').val();

            // Enable the button if both dropdowns have a selected value
            if (fiscalYearValue !== '' && typeValue !== '') {
                $('#btnsearch').removeAttr('disabled');
            } else {
                $('#btnsearch').attr('disabled', 'disabled');
            }
        }

        // Event handler for dropdown change
        $('#fiscalyear, #type').change(function() {
            checkDropdowns();
        });
    });
</script>

<script>
    let paidon_date = 'not selected';

    function converttocomma(x) {
        x = x.toString();
        var afterPoint = '';
        if (x.indexOf('.') > 0)
            afterPoint = x.substring(x.indexOf('.'), x.length);
        x = Math.floor(x);
        x = x.toString();
        var lastThree = x.substring(x.length - 3);
        var otherNumbers = x.substring(0, x.length - 3);
        if (otherNumbers != '')
            lastThree = ',' + lastThree;
        var res = otherNumbers.replace(/\B(?=(\d{2})+(?!\d))/g, ",") + lastThree + afterPoint;
        return res;
    }

    // function get_monthlyreceipt() {
    //     var url = "<?= base_url() ?>/get_monthlyreceipt";
    //     var formData = new FormData($('#monthly_receipt_form')[0]);
    //     $("#monthly_record").empty();
    //     $.ajax({
    //         url: url,
    //         type: "POST",
    //         data: formData,
    //         contentType: false,
    //         processData: false,
    //         dataType: "JSON",
    //         success: function(response) {
    //             if (response.length > 0) {
    //                 for (let i = 0; i < response.length; i++) {
    //                     var premises = response[i]['sss_inv_brief'].split('; ');
    //                     premises = (premises[2]) ? premises[2] : '';
    //                     $('#monthly_record').append('<tr class="searchrecord"><td>' + response[i]['sss_ddd_shno']  + '</td><td>' + response[i]['sss_ddd_generatedate'].split('-').reverse().join('-') + '</td><td>' + response[i]['sss_client_name'] + '<hr>' + premises + '</td><td>' + converttocomma(response[i]['sss_pr_amtreceived']) + '</td><td>' + converttocomma(response[i]['sss_pr_tdsamt']) + '</td><td>' + converttocomma(response[i]['sss_ddd_gst_finalamt']) + '</td><td>' + converttocomma(response[i]['gross_share']) + '</td><td>' + converttocomma(response[i]['sss_ddd_sbamt_amt']) + '</td><td>' + converttocomma(response[i]['sss_ddd_cirilroyalityamt']) + '</td><td>' + converttocomma(response[i]['sss_ddd_misc']) + '</td><td>' + converttocomma(response[i]['sss_ddd_ourshare']) + '</td>');
    //                 }
    //                 $('#btngetreport').css('display', 'block');
    //             } else {
    //                 $('#monthly_record').append('<tr><td colspan="4">No Record Found<td></tr>');
    //             }
    //         }
    //     });
    // }
    
    function get_monthlyreceipt() {
        var url = "<?= base_url() ?>/get_monthlyreceipt";
        var formData = new FormData($('#monthly_receipt_form')[0]);
        $("#monthly_record").empty();
        $.ajax({
            url: url,
            type: "POST",
            data: formData,
            contentType: false,
            processData: false,
            dataType: "JSON",
            success: function(response) {
                var monthlyreceipt = response.monthlyreceipt;
                
                var sss_pr_amtreceived = response.sss_pr_amtreceived;
                var sss_pr_tdsamt = response.sss_pr_tdsamt;
                var sss_ddd_gst_finalamt = response.sss_ddd_gst_finalamt;
                var totalgross_share = response.totalgross_share;
                var sss_ddd_sbamt_amt = response.sss_ddd_sbamt_amt;
                var sss_ddd_cirilroyalityamt = response.sss_ddd_cirilroyalityamt;
                var sss_ddd_misc = response.sss_ddd_misc;
                var sss_ddd_ourshare = response.sss_ddd_ourshare;
                if (monthlyreceipt.length > 0) {
                    for (let i = 0; i < monthlyreceipt.length; i++) {
                        var premises = monthlyreceipt[i]['sss_inv_brief'].split('; ');
                        premises = (premises[1]) ? premises[1] : '';
                        $('#monthly_record').append('<tr class="searchrecord"><td>' + monthlyreceipt[i]['sss_ddd_shno'] + '</td><td>' + monthlyreceipt[i]['sss_ddd_generatedate'].split('-').reverse().join('-') + '</td><td>' + monthlyreceipt[i]['sss_client_name'] + '<hr>' + premises + '</td><td>' + converttocomma(monthlyreceipt[i]['sss_pr_amtreceived']) + '</td><td>' + converttocomma(monthlyreceipt[i]['sss_pr_tdsamt']) + '</td><td>' + converttocomma(monthlyreceipt[i]['sss_ddd_gst_finalamt']) + '</td><td>' + converttocomma(monthlyreceipt[i]['gross_share']) + '</td><td>' + converttocomma(monthlyreceipt[i]['sss_ddd_sbamt_amt']) + '</td><td>' + converttocomma(monthlyreceipt[i]['sss_ddd_cirilroyalityamt']) + '</td><td>' + converttocomma(monthlyreceipt[i]['sss_ddd_misc']) + '</td><td>' + converttocomma(monthlyreceipt[i]['sss_ddd_ourshare']) + '</td>');
                    }
                    $('#monthly_record').append('<tr><td colspan="2"></td><td>Total</td><td>' + converttocomma(sss_pr_amtreceived) + '</td><td>' + converttocomma(sss_pr_tdsamt) + '</td><td>' + converttocomma(sss_ddd_gst_finalamt) + '</td><td>' + converttocomma(totalgross_share) + '</td><td>' + converttocomma(sss_ddd_sbamt_amt) + '</td><td>' + converttocomma(sss_ddd_cirilroyalityamt) + '</td><td>' + converttocomma(sss_ddd_misc) + '</td><td>' + converttocomma(sss_ddd_ourshare) + '</td>');

                    $('#btngetreport').css('display', 'block');
                } else {
                    $('#monthly_record').append('<tr><td colspan="4">No Record Found<td></tr>');
                }
            }
        });
    }

    // function printscreport() {
    //     window.location.href = '<?= base_url() ?>/printscreport/';
    // }

    function printscreport() {
        var url = "<?= base_url() ?>/print_monthlyreport";
        var formData = new FormData($('#monthly_receipt_form')[0]);
        $.ajax({
            url: url,
            type: "POST",
            data: formData,
            contentType: false,
            processData: false,
            dataType: "JSON",
            success: function(response) {
                var downloadLink = document.createElement('a');
                downloadLink.href = response.download_url;
                downloadLink.download = 'monthlyreceipt.pdf';
                downloadLink.addEventListener('click', function() {
                    // Show success message
                    // Reload the page after a delay (you can adjust the delay time)
                    setTimeout(function() {
                        location.reload();
                    }, 2000); // 2000 milliseconds = 2 seconds
                });
                downloadLink.click();
                alert('Report downloaded successfully');
            }
        });
    }
</script>
<?= $this->endSection(); ?>