<?= $this->extend('commanfile/header'); ?>
<?= $this->section('content'); ?>
<div class="card card-default">
    <div class="card-body">
        <form id="outstandreport" method="POST">
            <div class="row mb-2">
                <div class="col-md-4">
                    <div class="form-group">
                        <select class="form-control select2" id="fiscalyear" name="fiscalyear">
                            <option value="">Select Year</option>
                            <?php
                            $starting_year = date('Y', strtotime('-2 year')); // Adjust as needed
                            $ending_year = date('Y', strtotime('+40 year')); // Adjust as needed
                            for ($year = $starting_year; $year <= $ending_year; $year++) {
                                $next_year = $year + 1;
                                $fiscal_year = $year . '-' . $next_year; // Format fiscal year as YYYY-YY
                                echo '<option value="' . $fiscal_year . '">' . $fiscal_year . '</option>';
                            }
                            ?>
                        </select>
                    </div>
                </div>
                <div class="col-md-2">
                    <button type="button" id="btnsearch" onclick="geoutstandreports()" class="btn btn-info btn-block">Search</button>
                </div><!-- end col-->
                <div class="col-md-2">
                    <button type="button" id="btnreset" onclick="location.reload()" class="btn btn-dark btn-block">Refresh</button>
                </div><!-- end col-->
                <div class="col-md-2">
                    <a class="btn btn-danger" id="btngetreport" style="display: none;" onclick="get_outstandingreport($('#fiscalyear').val())">Get Report</a>
                </div>
            </div>
        </form>


        <div class="accordion" id="accordionExample">
            <div class="card">
                <div class="card-header" id="headingOne" style="display: none;">
                    <h2 class="mb-0">
                        <button class="btn btn-link btn-block text-left collapsed" type="button" data-toggle="collapse" data-target="#collapseOne" aria-expanded="false" aria-controls="collapseOne">
                            Sure Shot Suggestions India Private Limited
                        </button>
                    </h2>
                </div>
                <div id="collapseOne" class="collapse" aria-labelledby="headingOne" data-parent="#accordionExample">
                    <div class="card-body">
                        <table id="outstandtable" class="table table-bordered table-striped">
                            <thead>
                                <tr>
                                    <th>Bill Date</th>
                                    <th>Invoice Number</th>
                                    <th>CO Name</th>
                                    <th>Premise</th>
                                    <th>Service Charge</th>
                                    <th>GST</th>
                                    <th>Amount</th>
                                </tr>
                            </thead>
                            <tbody id="outstandreport_record">

                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
            <div class="card">
                <div class="card-header" id="headingTwo" style="display: none;">
                    <h2 class="mb-0">
                        <button class="btn btn-link btn-block text-left collapsed" type="button" data-toggle="collapse" data-target="#collapseTwo" aria-expanded="false" aria-controls="collapseTwo">
                            Sure Shot Services India Private Limited
                        </button>
                    </h2>
                </div>
                <div id="collapseTwo" class="collapse" aria-labelledby="headingTwo" data-parent="#accordionExample">
                    <div class="card-body">
                        <table id="" class="table table-bordered table-striped">
                            <thead>
                                <tr>
                                    <th>Bill Date</th>
                                    <th>Invoice Number</th>
                                    <th>CO Name</th>
                                    <th>Premise</th>
                                    <th>Service Charge</th>
                                    <th>GST</th>
                                    <th>Amount</th>
                                </tr>
                            </thead>
                            <tbody id="outstandreport_record_service">

                            </tbody>
                        </table>
                    </div>
                </div>
            </div>

            <div class="card">
                <div class="card-header" id="headingThree" style="display: none;">
                    <h2 class="mb-0">
                        <button class="btn btn-link btn-block text-left collapsed" type="button" data-toggle="collapse" data-target="#collapseThree" aria-expanded="false" aria-controls="collapseTwo">
                            Total Outstanding (SSSIPL + Service)
                        </button>
                    </h2>
                </div>
                <div id="collapseThree" class="collapse" aria-labelledby="headingThree" data-parent="#accordionExample">
                    <div class="card-body">
                        <table id="" class="table table-bordered table-striped">
                            <tbody id="total_outstanding">
                              
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<!-- <script>
    var save_method;
    
    $(document).ready(function() {
        table = $('#outstandtable').DataTable({
            "processing": true, //Feature control the processing indicator.
            "serverSide": true, //Feature control DataTables' server-side processing mode.
            "order": [], //Initial no order.
            "ordering": true,
            "searching": true,
            "responsive": true,
            "lengthChange": false,
            // Load data for the table's content from an Ajax source
            "ajax": {
                "url": "<?php echo base_url() ?>/getAlloutstandingreport",
            },
            //Set column definition initialisation properties.
            "columnDefs": [{
                "targets": [-1], //last column
                "orderable": false, //set not orderable
            }, ],
        });
    });
    
</script> -->

<script>
    let sum = 0;
    let gsttamt1 = 0;
    let invamt1 = 0;
    let sum2 = 0;
    let gsttamt2 = 0;
    let invamt2 = 0;
    let finaltotal_both = 0;
    let suggestionbrief = '';

    function converttocomma(x) {
        x = x.toString();
        var afterPoint = '';
        if (x.indexOf('.') > 0)
            afterPoint = x.substring(x.indexOf('.'), x.length);
        x = Math.floor(x);
        x = x.toString();
        var lastThree = x.substring(x.length - 3);
        var otherNumbers = x.substring(0, x.length - 3);
        if (otherNumbers != '')
            lastThree = ',' + lastThree;
        var res = otherNumbers.replace(/\B(?=(\d{2})+(?!\d))/g, ",") + lastThree + afterPoint;
        return res;
    }

    function geoutstandreports() {
        var url = "<?= base_url() ?>/get_outstandingreport";
        var formData = new FormData($('#outstandreport')[0]);
        $("#outstandreport_record").empty();
        $.ajax({
            url: url,
            type: "POST",
            data: formData,
            contentType: false,
            processData: false,
            dataType: "JSON",
            success: function(response) {
                
                var suggestionresponse = response.suggestionreport;
                var serviceresponse = response.servicereport;

                $('#total_outstanding').append('<tr><td colspan="4"><b>TAX INVOICE</td></tr><tr><td colspan="3">SSSIPL</td><td>' + converttocomma(response['suggestiontotalbillamt']) + '</td></tr><tr><td colspan="3">Service</td><td>' + converttocomma(response['servicetotalbillamt']) + '</td></tr><tr><td colspan="3">Total</td><td>' + converttocomma(response['totalamount']) + '</td></tr>');
                $('#headingThree').css('display', 'block');
                
                if (suggestionresponse.length > 0) {
                    for (let i = 0; i < suggestionresponse.length; i++) {
                        var suggestionbrief = suggestionresponse[i]['sss_inv_brief'].split(';');
                        suggestionpremises = (suggestionbrief[1]) ? suggestionbrief[1] : '';
                        console.log(suggestionpremises);
                        if (suggestionresponse[i]['sss_inv_igst'] > 0) {
                            var gstt = suggestionresponse[i]['sss_inv_igst']
                        } else {
                            var gstt = parseFloat(suggestionresponse[i]['sss_inv_sgst']) + parseFloat(suggestionresponse[i]['sss_inv_cgst'])
                        }
                        
                        $('#outstandreport_record').append('<tr class="searchrecord"><td>' + suggestionresponse[i]['sss_inv_bill_date'].split('-').reverse().join('-') + '</td><td>' + suggestionresponse[i]['sss_inv_bill_no'] + '</td><td>' + suggestionresponse[i]['sss_client_name'] + '</td><td>' + suggestionpremises + '</td><td>' + converttocomma(suggestionresponse[i]['sss_inv_amt']) + '</td><td>' + converttocomma(gstt) + '</td><td>' + converttocomma(suggestionresponse[i]['sss_inv_total_amt']) + '</td><td class="sss_inv_amt1 d-none">' + (suggestionresponse[i]['sss_inv_amt']) + '</td><td class="gsttamt1 d-none">' + gstt + '</td><td class="sss_inv_total_amt1 d-none">' + (suggestionresponse[i]['sss_inv_total_amt']) + '</td>');
                        
                    }
                    $('#outstandreport_record').append('<tr><td colspan="4"></td><td id="sss_inv_amt1"></td><td id="gsttamt1"></td><td id="sss_inv_total_amt1"></td></tr>');

                    $('#btngetreport').css('display', 'block');
                    $('#headingOne').css('display', 'block');
                    
                }

                if (serviceresponse.length > 0) {
                    for (let i = 0; i < serviceresponse.length; i++) {
                        var servicebrief = serviceresponse[i]['sss_inv_brief'].split('; ');
                        servicebrief = (servicebrief[1]) ? servicebrief[1] : '';

                        if (serviceresponse[i]['sss_inv_igst'] > 0) {
                            var servicegstt = serviceresponse[i]['sss_inv_igst']
                        } else {
                            var servicegstt = parseFloat(serviceresponse[i]['sss_inv_sgst']) + parseFloat(serviceresponse[i]['sss_inv_cgst'])
                        }

                        $('#outstandreport_record_service').append('<tr class="searchrecord"><td>' + serviceresponse[i]['sss_inv_bill_date'].split('-').reverse().join('-') + '</td><td>' + serviceresponse[i]['sss_inv_bill_no'] + '</td><td>' + serviceresponse[i]['sss_client_name'] + '</td><td>' + servicebrief + '</td><td>' + converttocomma(suggestionresponse[i]['sss_inv_amt']) + '</td><td>' + converttocomma(servicegstt) + '</td><td>' + converttocomma(serviceresponse[i]['sss_inv_total_amt']) + '</td><td class="sss_inv_total_amt2 d-none">' + (serviceresponse[i]['sss_inv_total_amt']) + '</td><td class="gsttamt2 d-none">' + servicegstt + '</td><td class="sss_inv_amt2 d-none">' + (serviceresponse[i]['sss_inv_amt']) + '</td>');
                    }
                    $('#outstandreport_record_service').append('<tr><td colspan="4"></td><td id="sss_inv_amt2"></td><td id="gsttamt2"></td><td id="sss_inv_total_amt2"></td></tr>');
                    
                    $('#btngetreport').css('display', 'block');
                    $('#headingTwo').css('display', 'block');
                    $('#headingThree').css('display', 'block');
                    
                } else {
                    $('#outstandreport_record').append('<tr><td colspan="5">No Record Found<td></tr>');
                }
                calc_total();
            }
        });
    }

    function get_outstandingreport(fiscalyear) {
        window.location.href = '<?= base_url() ?>/printoutstandingreport/' + fiscalyear;
    }

    function calc_total() {
        $(".sss_inv_total_amt1").each(function() {
            sum += parseFloat($(this).text());
        });
        $('#sss_inv_total_amt1').text(converttocomma(sum));

        $(".gsttamt1").each(function() {
            gsttamt1 += parseFloat($(this).text());
        });
        $('#gsttamt1').text(converttocomma(gsttamt1));

        $(".sss_inv_amt1").each(function() {
            invamt1 += parseFloat($(this).text());
        });
        $('#sss_inv_amt1').text(converttocomma(invamt1));




        $(".sss_inv_total_amt2").each(function() {
            sum2 += parseFloat($(this).text());
        });
        $('#sss_inv_total_amt2').text(converttocomma(sum2));

        $(".gsttamt2").each(function() {
            gsttamt2 += parseFloat($(this).text());
        });
        $('#gsttamt2').text(converttocomma(gsttamt2));

        $(".sss_inv_amt2").each(function() {
            invamt2 += parseFloat($(this).text());
        });
        $('#sss_inv_amt2').text(converttocomma(invamt2));




        
    }
</script>
<?= $this->endSection(); ?>