<!DOCTYpe html>
<html>

<head>
    <title>BankBook Report</title>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
    <script src="https://code.jquery.com/jquery-3.6.4.min.js" integrity="sha256-oP6HI9z1XaZNBrJURtCoUT5SUnxFr8s3BzRl+cbzUq8=" crossorigin="anonymous"></script>
    <style>
        .row {
            margin-right: -15px;
            margin-left: -15px;
        }

        .col-xs-1,
        .col-sm-1,
        .col-md-1,
        .col-lg-1,
        .col-xs-2,
        .col-sm-2,
        .col-md-2,
        .col-lg-2,
        .col-xs-3,
        .col-sm-3,
        .col-md-3,
        .col-lg-3,
        .col-xs-4,
        .col-sm-4,
        .col-md-4,
        .col-lg-4,
        .col-xs-5,
        .col-sm-5,
        .col-md-5,
        .col-lg-5,
        .col-xs-6,
        .col-sm-6,
        .col-md-6,
        .col-lg-6,
        .col-xs-7,
        .col-sm-7,
        .col-md-7,
        .col-lg-7,
        .col-xs-8,
        .col-sm-8,
        .col-md-8,
        .col-lg-8,
        .col-xs-9,
        .col-sm-9,
        .col-md-9,
        .col-lg-9,
        .col-xs-10,
        .col-sm-10,
        .col-md-10,
        .col-lg-10,
        .col-xs-11,
        .col-sm-11,
        .col-md-11,
        .col-lg-11,
        .col-xs-12,
        .col-sm-12,
        .col-md-12,
        .col-lg-12 {
            position: relative;
            min-height: 1px;
            padding-right: 15px;
            padding-left: 15px;
        }

        .col-lg-12 {
            width: 100%;
        }

        .text-center {
            text-align: center;
        }

        body {
            font-family: "Source Sans Pro", -apple-system, BlinkMacSystemFont, "Segoe UI", Roboto, "Helvetica Neue", Arial, sans-serif, "Apple Color Emoji", "Segoe UI Emoji", "Segoe UI Symbol";
            font-size: 14px;
            line-height: 1.42857143;
            color: #333;
            background-color: #fff;
        }

        .container {
            max-width: 1200px;
            margin: 0 auto;
            border: 1px #333;
        }

        .content {
            padding: 10px;
            border: 1px solid;
        }


        .table-bordered tr,
        td {
            border: 1px solid #ddd;
        }

        .table {
            border-collapse: collapse !important
        }

        .table td,
        .table th {
            background-color: #fff !important
        }

        .table-bordered td,
        .table-bordered th {
            border: 1px solid #ddd !important
        }

        .table>tbody>tr>td,
        .table>tbody>tr>th,
        .table>tfoot>tr>td,
        .table>tfoot>tr>th,
        .table>thead>tr>td,
        .table>thead>tr>th {
            padding: 8px;
            line-height: 1.42857143;
            vertical-align: top;
            border-top: 1px solid #ddd;
        }
    </style>
</head>

<body>
    <div class="container">
        <div class="content">
            <div class='header'>
                <h3 class='text-center'><?php echo strtoupper($types).' Report';?> </h3>
            </div>
            <div class="table-responsive">
                <table class="table table-bordered table-striped table-center">
                    <thead>
                        <tr>
                            <th>Date</th>
                            <th>Invoice Number</th>
                            <th>Client Name</th>
                            <th>Premise</th>
                            <th>Amount</th>
                            <th>Paid On Date</th>
                        </tr>
                    </thead>
                    <tbody id="">
                        <?php
                        $paidondate = '';
                        $amount = 0;
                        foreach ($screport as $report) {
                            $splitString = explode(";", $report->sss_inv_brief);
                            $premise = isset($splitString[1]) ? $splitString[1] : null;

                            if ($types == 'ciril') {
                                $paidondate  = $report->sss_dd_royalitypaidon;
                                $amount = $report->sss_dd_royality;
                            } else {
                                $paidondate  = $report->sss_dd_cpaidon;
                                $amount = $report->sss_dd_sbamt;
                            }
                        ?>
                            <tr>
                                <td><?php echo date('d-m-Y', strtotime($report->sss_inv_bill_date)) ?></td>
                                <td><?= $report->sss_inv_bill_no ?></td>
                                <td><?= $report->sss_client_name ?></td>
                                <td><?php echo $premise ?></td>
                                <td><?php echo mb_substr(number_to_currency($amount, '', 'en-IN'), 1); ?></td>
                                <td><?= $paidondate ?></td>
                            </tr>
                        <?php } ?>

                    </tbody>
                      <tfoot>
                        <th></th>
                        <th></th>
                        <th></th>
                        <th>Total </th>
                        <th><?php echo mb_substr(number_to_currency($totalamount, '', 'en-IN'), 1); ?></th>
                        <th></th>
                    </tfoot>
                </table>
            </div>
        </div>
    </div>
</body>


</html>