<?= $this->extend('commanfile/header'); ?>
<?= $this->section('content'); ?>
<div class="row">
    <div class="col-md-12">
        <div class="card">
            <div class="card-header">
                <h3 class="card-title">View Invoices</h3>
            </div>
            <!-- /.card-header -->
            <div class="card-body">
                <form id="searchrecords" method="POST">
                    <div class="row mb-2">
                        <div class="col-md-3">
                            <select class="form-control select2" name="sss_bankid" id="">
                                <div class="form-group">
                                    <option>Select Bank</option>
                                    <?php foreach ($allbanks as $bank) { 
                                    ?>
                                        <option value="<?= $bank->sss_ent_bank_id  ?>"><?= $bank->sss_ent_bank_name  .'-'. $bank->sss_ent_bank_acc_no ?></option>
                                    <?php } 
                                    ?>
                                </div>
                            </select>
                        </div>
                        <div class="col-md-3">
                            <div class="input-group date" id="chequeClearedOn" data-target-input="nearest">
                                <input type="month" class="form-control" name="month" min="1997-01-01" max="2030-12-31" id="sss_inv_created_date" placeholder="" />
                            </div>
                        </div>
                        <!-- <h5>to</h5>
                        <div class="col-md-3">
                            <div class="input-group date" id="chequeClearedOn" data-target-input="nearest">
                                <input type="date" class="form-control" name="sss_inv_created_date" min="1997-01-01" max="2030-12-31" id="enddate" />
                            </div>
                        </div> -->
                        <!-- <div class="col-md-3">
                            <div class="form-group">
                                <label>Date range:</label>
                                <div class="input-group">
                                    <div class="input-group-prepend">
                                        <span class="input-group-text">
                                            <i class="far fa-calendar-alt"></i>
                                        </span>
                                    </div>
                                    <input type="text" class="form-control float-left" id="reservation">
                                </div>
                            </div>
                        </div> -->
                        <div class="col-md-1">
                            <button type="button" id="btnsearch" onclick="searchrecords()" class="btn btn-info"><i style="font-size: 18px;" class="mdi mdi-account-search me-2"></i>Search</button>
                        </div><!-- end col-->
                        <div class="col-md-1">
                            <button type="button" id="btnreset" onclick="reload()" class="btn btn-dark"><i style="font-size:18px;" class="mdi mdi-reload me-2"></i>Refresh</button>
                        </div><!-- end col-->
                    </div>
                </form>
                <table id="-data-table" class="table table-bordered table-striped">
                    <thead>
                        <tr>
                            <th>Trans. Date</th>
                            <th>Vendor Name</th>
                            <th>Vendor Purpose</th>
                            <th>Particulars</th>
                            <th>TDS Amount</th>
                        </tr>
                    </thead>
                    <tbody id="productrecord">

                    </tbody>
                    <tfoot>
                        <tr>
                            <th></th>
                            <th></th>
                            <th></th>
                            <th>Total TDS Amount</th>
                            <th id="grandtotal"></th>
                        </tr>
                    </tfoot>
                </table>
            </div>
            <!-- /.card-body -->
        </div>
    </div>
</div>

<script>
    // $(document).ready(function() {
    //     table = $('#tds-data-table').DataTable({
    //         "processing": true, //Feature control the processing indicator.
    //         "serverSide": true, //Feature control DataTables' server-side processing mode.
    //         "order": [], //Initial no order.
    //         "ordering": true,
    //         "searching": true,
    //         "responsive": true,
    //         "lengthChange": false,
    //         // Load data for the table's content from an Ajax source
    //         "ajax": {
    //             "url": "<?php echo base_url() ?>/get_tdsentries",
    //             // "data": function(d) {
    //             //     d.sdate = $('#reservation').val();
    //             // }
    //         },
    //         //Set column definition initialisation properties.
    //         "columnDefs": [{
    //             "targets": [-1], //last column
    //             "orderable": false, //set not orderable
    //         }, ],
    //     });

    //     $('#btnsearch').click(function() { //button filter event click
    //         table.ajax.reload();
    //     });
    //     $('#btnreset').click(function() { //button filter event click
    //         $('#searchform')[0].reset();
    //         location.reload();
    //     });
    // });


    function searchrecords() {
        let totaltdsamt = 0;
        var url = "<?= base_url() ?>/get_tdsentries";
        var formData = new FormData($('#searchrecords')[0]);
        $("#productrecord").empty();
        $.ajax({
            url: url,
            type: "POST",
            data: formData,
            contentType: false,
            processData: false,
            dataType: "JSON",
            success: function(response) {
                if (response.length > 0) {
                    for (let i = 0; i < response.length; i++) {
                        if(response[i]['sss_tdsamt'] > 0 )
                        {
                          $('#productrecord').append('<tr class="searchrecord"><td>' + response[i]['sss_trans_date'].split('-').reverse().join('-') + '</td><td>' + response[i]['sss_vendor_name'] + '</td><td>' + response[i]['sss_vp_purpose'] + '</td><td>' + response[i]['sss_bb_particulars']+'</td><td class="tdsamt">' + response[i]['sss_tdsamt']);  
                        }
                        
                    }
                    calc_total();
                } else {
                    $('#productrecord').append('<tr><td colspan="5">No Record Found<td></tr>');
                    calc_total();
                }
            }
        });
    }
    let sum = 0;
    function calc_total() {
        $(".tdsamt").each(function() {
            sum += parseFloat($(this).text());
        });
        $('#grandtotal').text(sum);
    }

    function reload() {
        location.reload();
    }
</script>
<?= $this->endSection(); ?>