<?= $this->extend('commanfile/header'); ?>
<?= $this->section('content'); ?>
<div class="card card-default">
    <div class="card-body">
        <form id="turnover_form" method="POST">
            <div class="row mb-2">
                <div class="col-md-3">
                    <div class="form-group">
                        <select class="form-control select2" id="fiscalyear" name="fiscalyear">
                            <th value="">Select Year</th>
                            <?php
                            $starting_year = date('Y', strtotime('-2 year')); // Adjust as needed
                            $ending_year = date('Y', strtotime('+40 year')); // Adjust as needed
                            for ($year = $starting_year; $year <= $ending_year; $year++) {
                                $next_year = $year + 1;
                                $fiscal_year = $year . '-' . $next_year; // Format fiscal year as YYYY-YY
                                echo '<option value="' . $fiscal_year . '">' . $fiscal_year . '</option>';
                            }
                            ?>
                        </select>
                    </div>
                </div>
        </form>
        <div class="col-md-2">
            <button type="button" id="btnsearch" onclick="get_turnoverreport()" class="btn btn-info btn-block">Search</button>
        </div><!-- end col-->
        <div class="col-md-2">
            <button type="button" id="btnreset" onclick="location.reload()" class="btn btn-dark btn-block">Refresh</button>
        </div><!-- end col-->

    </div>

    <div class="card">
        <div class="card-body">
            <div class="row">
                <div class="col-md-12" style="overflow:auto;">
                    <div>
                        <h4 class="tbheading" style="display: none;">Turnover Progressive</h4>
                    </div>
                    <table id="example" class="table table-bordered table-striped">

                        <tr id="months">
                        </tr>
                        <tr id="deficite">
                        </tr>
                        <tr id="suggestion_record">
                        </tr>
                        <tr id="servicedeficite">
                        </tr>
                        <tr id="service_record">
                        </tr>
                        <tr id="totalamt_record">
                        </tr>
                        <tr class="d-none" id="totalamt_record1">
                        </tr>
                        <tr id="turnover_prog_total">
                        </tr>
                        <tr id="turnover_average">
                        </tr>
                    </table>
                </div>
            </div>

            <div class="row">
                <div class="col-md-12" style="overflow:auto;">
                    <div>
                        <h4 class="tbheading" style="display: none;">Monthly Receipt Our Share</h4>
                    </div>
                    <table class="table table-bordered table-striped">
                        <tr id="ourshare_months">
                        </tr>
                        <tr id="ourshare_suggestion_record">
                        </tr>
                        <tr id="ourshare_service_record">
                        </tr>
                        <tr id="ourshare_totalamt_record">
                        </tr>
                        <tr class="d-none" id="ourshare_totalamt_record1">
                        </tr>
                        <tr id="ourshare_turnover_prog_total">
                        </tr>
                        <tr id="ourshare_turnover_average">
                        </tr>
                    </table>
                </div>
            </div>
        </div>
    </div>


    <script>
        var save_method;
        let paidon_date = 'not selected';
        let grand_total_suggestion = 0;
        let grand_total_service = 0;

        let suggestion_record = '';
        let service_record = '';

        let deficiterecord = '';
        let servicedeficiterecord = '';

        let prog_total_record = '';
        let avg_record = '';

        let ourshare_suggestion_record = '';
        let ourshare_service_record = '';
        let ourshare_totalamt_record = '';
        let ourshare_prog_total_record = '';
        let ourshare_avg_record = '';

        let grandtotal_suggestion = 0;
        let grandtotal_service = 0;


        $(document).ready(function() {

            $('#btnsearch').attr('disabled', true); //set button disable 
            // $('.tbl_heading').css('display','none');
            function checkDropdowns() {
                var fiscalYearValue = $('#fiscalyear').val();
                var typeValue = $('#type').val();
                // Enable the button if both dropdowns have a selected value
                if (fiscalYearValue !== '' && typeValue !== '') {
                    $('#btnsearch').removeAttr('disabled');
                } else {
                    $('#btnsearch').attr('disabled', 'disabled');
                }
            }

            // Event handler for dropdown change
            $('#fiscalyear, #type').change(function() {
                checkDropdowns();
            });

            $('.tbheading').css('display', 'none');

        });


        function converttocomma(x) {
            x = x.toString();
            var afterPoint = '';
            if (x.indexOf('.') > 0)
                afterPoint = x.substring(x.indexOf('.'), x.length);
            x = Math.floor(x);
            x = x.toString();
            var lastThree = x.substring(x.length - 3);
            var otherNumbers = x.substring(0, x.length - 3);
            if (otherNumbers != '')
                lastThree = ',' + lastThree;
            var res = otherNumbers.replace(/\B(?=(\d{2})+(?!\d))/g, ",") + lastThree + afterPoint;
            return res;
        }


        function printscreport() {
            var url = "<?= base_url() ?>/print_monthlyreport";
            var formData = new FormData($('#turnover_form')[0]);
            $.ajax({
                url: url,
                type: "POST",
                data: formData,
                contentType: false,
                processData: false,
                dataType: "JSON",
                success: function(response) {
                    var downloadLink = document.createElement('a');
                    downloadLink.href = response.download_url;
                    downloadLink.download = 'response.pdf';
                    downloadLink.addEventListener('click', function() {
                        // Show success message
                        // Reload the page after a delay (you can adjust the delay time)
                        setTimeout(function() {
                            location.reload();
                        }, 2000); // 2000 milliseconds = 2 seconds
                    });
                    downloadLink.click();
                    alert('Report downloaded successfully');
                }
            });
        }


        function get_turnoverreport() {
            var url = "<?= base_url() ?>/get_turnover";
            var formData = new FormData($('#turnover_form')[0]);
            $("#turnrecord_record").empty();
            $.ajax({
                url: url,
                type: "POST",
                data: formData,
                contentType: false,
                processData: false,
                dataType: "JSON",
                success: function(response) {

                    $('.tbheading').css('display', 'block');
                    var suggestion = response.suggestion;
                    var service = response.service;
                    var startYear = response.startyear;
                    var endYear = response.endyear;

                    var ourshare_suggestion = response.suggestion_ourshare;
                    var ourshare_service = response.service_ourshare;
                    var sugg_deficite = response.suggestion_deficite.def_amt;
                    var ser_deficite = response.service_deficite.def_amt;

                    var suggestion_prog_total = response.monthlyTotal;


                    // Create an array of month names
                    var months = ['APR', 'MAY', 'JUN', 'JUL', 'AUG', 'SEPT', 'OCT', 'NOV', 'DEC', 'JAN', 'FEB', 'MAR'];

                    var html = '';
                    // Loop through the months array
                    for (var i = 0; i < months.length; i++) {
                        // Create the class name by concatenating the month name and the year
                        var className = months[i] + '' + (i < 9 ? startYear : endYear);
                        html += '<td class="' + className + '">' + months[i] + ' ' + (i < 9 ? startYear : endYear) + '</td>';

                        var deficiteclassName = months[i] + '' + (i < 9 ? startYear : endYear);
                        deficiterecord += '<td class="' + deficiteclassName + '"></td>';

                        //suggestion record...
                        var suggestionclassName = months[i] + '' + (i < 9 ? startYear : endYear);
                        suggestion_record += '<td class="suggestion' + suggestionclassName + '"></td>';

                        var servicedeficiteclassName = months[i] + '' + (i < 9 ? startYear : endYear);
                        servicedeficiterecord += '<td class="' + servicedeficiteclassName + '"></td>';

                        //services record///
                        var serviceclassName = months[i] + '' + (i < 9 ? startYear : endYear);
                        service_record += '<td class="service' + serviceclassName + '"></td>';

                        //total record///
                        var totalofentities = months[i] + '' + (i < 9 ? startYear : endYear);
                        totalamt_record += '<td class="total' + totalofentities + '"></td>';
                        totalamt_record1 += '<td class="total1' + totalofentities + '"></td>';

                        var prog_total = months[i] + '' + (i < 9 ? startYear : endYear);
                        prog_total_record += '<td id="progressive_total' + prog_total + '"></td>';

                        var avg = months[i] + '' + (i < 9 ? startYear : endYear);
                        avg_record += '<td id="avg_total' + avg + '"></td>';
                    }

                    if (html != '') {
                        $('#months').append('<th>Months</th>' + html + '<td>Total</td><td>Deficite</td>');
                    }

                    if (deficiterecord != '') {
                        $('#deficite').append('<th></th>' + deficiterecord + '<td></td><td id="deficite_amt_sugg">' + converttocomma(sugg_deficite) + '</td>');
                    }

                    if (suggestion_record != '') {
                        $('#suggestion_record').append('<th>IPL</th>' + suggestion_record + '<td id ="grandtotal_suggestion"></td><td id="final_suggestiondeficite"></td>');
                    }

                    if (servicedeficiterecord != '') {
                        $('#servicedeficite').append('<th></th>' + servicedeficiterecord + '<td></td><td id="deficite_amt_ser">' + converttocomma(ser_deficite) + '</td>');
                    }


                    if (service_record != '') {
                        $('#service_record').append('<th>Service</th>' + service_record + '<td id="grandtotal_service"></td><td id="final_servicedeficite"></td>');
                    }

                    if (totalamt_record != '') {
                        $('#totalamt_record').append('<th>Total</th>' + totalamt_record + '<td id="grandtotal_both"></td><td></td>');
                    }

                    if (totalamt_record1 != '') {
                        $('#totalamt_record1').append('<th>Total</th>' + totalamt_record1 + '<td id="grandtotal_both"></td><td></td>');
                    }

                    if (prog_total_record != '') {
                        $('#turnover_prog_total').append('<th>Prog. Total</th>' + prog_total_record + '<td id=""></td><td></td>');
                    }

                    if (avg_record != '') {
                        $('#turnover_average').append('<th>Average</th>' + avg_record + '<td id=""></td><td></td>');
                    }


                    if (suggestion.length > 0) {
                        suggestion.forEach(function(item) {
                            var dateReceived = item['sss_inv_bill_date'];
                            var formattedDate = new Date(dateReceived).toLocaleString('en-US', {
                                month: 'short',
                                year: 'numeric'
                            }).toUpperCase();
                            // Rest of the code logic here
                            var sanitizedFormattedDate = formattedDate.replace(/\s+/g, '');
                            if ($('td').filter('[class*=suggestion' + sanitizedFormattedDate + ']').length > 0) {
                                $('[class*=suggestion' + sanitizedFormattedDate + ']').text(converttocomma(item.suggestiontotalAmount));
                                $('[class*=total' + sanitizedFormattedDate + ']').text(converttocomma(item.suggestiontotalAmount));
                                $('[class*=total1' + sanitizedFormattedDate + ']').text((item.suggestiontotalAmount));

                            } else {
                                $('[class*=suggestion' + sanitizedFormattedDate + ']').text(0);
                            }
                        });

                        grandtotal_suggestion = response.grand_total_suggestion;
                        $('#grandtotal_suggestion').text(converttocomma(response.grand_total_suggestion));
                        // calculate deficite..
                        let total_suggestion_deficite = parseFloat(sugg_deficite) - parseFloat(grandtotal_suggestion);
                        $('#final_suggestiondeficite').text(converttocomma(total_suggestion_deficite));
                        $('#btngetreport').css('display', 'block');
                    }
                    if (service.length > 0) {
                        var prog_total = 0;
                        service.forEach(function(servicerecord) {
                            var dateReceived = servicerecord['sss_inv_bill_date'];
                            var serviceformattedDate = new Date(dateReceived).toLocaleString('en-US', {
                                month: 'short',
                                year: 'numeric'
                            }).toUpperCase();
                            let sanitized_serviceFormattedDate = serviceformattedDate.replace(/\s+/g, '');

                            if ($('td').filter('[class*=service' + sanitized_serviceFormattedDate + ']').length > 0) {
                                let service_totalmonth = converttocomma(servicerecord.servicetotalAmount);
                                $('[class*=service' + sanitized_serviceFormattedDate + ']').text(converttocomma(servicerecord.servicetotalAmount));
                                let checksuggestionamt = $('[class*=total' + sanitized_serviceFormattedDate + ']').text();
                                let suggestionamt = '';
                                let serviceamt = '';
                                if (checksuggestionamt != '') {
                                    let numberArray = checksuggestionamt.split(",");
                                    let serviceArray = service_totalmonth.split(",");
                                    for (var i = 0; i < numberArray.length; i++) {
                                        suggestionamt += numberArray[i];
                                    }
                                    for (var i = 0; i < serviceArray.length; i++) {
                                        serviceamt += serviceArray[i];
                                    }
                                    if (suggestionamt > 0 && serviceamt > 0) {
                                        let total_of_entity = parseInt(suggestionamt) + parseInt(serviceamt);
                                        $('[class*=total' + sanitized_serviceFormattedDate + ']').text(converttocomma(total_of_entity));
                                        $('[class*=total1' + sanitized_serviceFormattedDate + ']').text((total_of_entity));

                                    }
                                } else {
                                    $('[class*=total' + sanitized_serviceFormattedDate + ']').text(converttocomma(servicerecord.servicetotalAmount));
                                    $('[class*=total1' + sanitized_serviceFormattedDate + ']').text((servicerecord.servicetotalAmount));
                                }


                            } else {
                                $('[class*=service' + sanitized_serviceFormattedDate + ']').text(0);
                            }
                        });

                        grandtotal_service = response.grand_total_service;

                        $('#grandtotal_service').text(converttocomma(response.grand_total_service));

                        // calculate deficite..
                        let total_service_deficite = parseFloat(ser_deficite) - parseFloat(grandtotal_service);
                        $('#final_servicedeficite').text(converttocomma(total_service_deficite));


                    } else {
                        $('#monthly_record').append('<tr><td colspan="4">No Record Found<td></tr>');
                    }
                    // total of grandtotal....
                    // if (grandtotal_service != 0 && grandtotal_suggestion != 0) {
                    //     let final_total_ofGrandtotal = parseInt(grandtotal_service) + parseInt(grandtotal_suggestion);
                    //     $('#grandtotal_both').text(converttocomma(final_total_ofGrandtotal));
                    // }


                    let progressive = 0;
                    let parsedValue = 0;
                    let index = 1;
                    let avg_total = 0;
                    for (var i = 0; i < months.length; i++) {
                        var totalofentities = months[i] + '' + (i < 9 ? startYear : endYear);
                        let total = ($('[class*=total1' + totalofentities + ']').text());
                        let parsedTotal = parseInt(total);
                        if (!isNaN(parsedTotal)) {
                            parsedValue += parsedTotal;
                        } else {
                            parsedValue += 0;
                        }
                        $('[id*=progressive_total' + totalofentities + ']').text(converttocomma(parsedValue));
                        
                        // average...
                        avg_total = parseInt(parsedValue)/ parseInt(index) ;
                        let avg = Math.round(avg_total)
                        $('[id*=avg_total' + totalofentities + ']').text(converttocomma(avg));
                        index++;
                    }

                    // our share table

                    var ourshare_months = ['APR', 'MAY', 'JUN', 'JUL', 'AUG', 'SEPT', 'OCT', 'NOV', 'DEC', 'JAN', 'FEB', 'MAR'];
                    var ourshare_td = '';
                    // Loop through the months array
                    for (var i = 0; i < ourshare_months.length; i++) {
                        // Create the class name by concatenating the month name and the year
                        var ourshare_className = ourshare_months[i] + '' + (i < 9 ? startYear : endYear);
                        ourshare_td += '<td class="' + ourshare_className + '">' + ourshare_months[i] + ' ' + (i < 9 ? startYear : endYear) + '</td>';

                        //suggestion record...
                        var ourshare_suggestionclassName = ourshare_months[i] + '' + (i < 9 ? startYear : endYear);
                        ourshare_suggestion_record += '<td class="ourshare_suggestion' + ourshare_suggestionclassName + '"></td>';

                        //services record///
                        var ourshare_serviceclassName = ourshare_months[i] + '' + (i < 9 ? startYear : endYear);
                        ourshare_service_record += '<td class="ourshare_service' + ourshare_serviceclassName + '"></td>';

                        //total record///
                        var ourshare_totalofentities = ourshare_months[i] + '' + (i < 9 ? startYear : endYear);
                        ourshare_totalamt_record += '<td class="ourshare_total' + ourshare_totalofentities + '"></td>';
                        ourshare_totalamt_record1 += '<td class="ourshare_total1' + ourshare_totalofentities + '"></td>';

                        //total record///
                        var ourshare_prog_total = ourshare_months[i] + '' + (i < 9 ? startYear : endYear);
                        ourshare_prog_total_record += '<td class="os_progressivetotal' + ourshare_prog_total + '"></td>';

                        //total record///
                        var ourshare_avg_total = ourshare_months[i] + '' + (i < 9 ? startYear : endYear);
                        ourshare_avg_record += '<td id="os_avg_total' + ourshare_avg_total + '"></td>';
                    }
                    if (ourshare_td != '') {
                        $('#ourshare_months').append('<th>Months</th>' + ourshare_td + '<td>Total</td>');
                    }
                    if (ourshare_suggestion_record != '') {
                        $('#ourshare_suggestion_record').append('<th>IPL</th>' + ourshare_suggestion_record + '<td id ="grandtotal_suggestion_os"></td>');
                    }
                    if (ourshare_service_record != '') {
                        $('#ourshare_service_record').append('<th>Service</th>' + ourshare_service_record + '<td id ="grandtotal_service"></td>');
                    }
                    if (ourshare_totalamt_record != '') {
                        $('#ourshare_totalamt_record').append('<th>Total</th>' + ourshare_totalamt_record);
                    }

                    if (ourshare_totalamt_record1 != '') {
                        $('#ourshare_totalamt_record1').append('<th>Total</th>' + ourshare_totalamt_record1);
                    }


                    if (ourshare_prog_total_record != '') {
                        $('#ourshare_turnover_prog_total').append('<th>Prog. Total</th>' + ourshare_prog_total_record);
                    }
                    if (ourshare_avg_record != '') {
                        $('#ourshare_turnover_average').append('<th>Average</th>' + ourshare_avg_record);
                    }

                    if (ourshare_suggestion.length > 0) {
                        ourshare_suggestion.forEach(function(os_suggestion) {
                            var os_dateReceived = os_suggestion['sss_ddd_generatedate'];
                            var os_formattedDate = new Date(os_dateReceived).toLocaleString('en-US', {
                                month: 'short',
                                year: 'numeric'
                            }).toUpperCase();
                            // Rest of the code logic here
                            var os_sanitizedFormattedDate = os_formattedDate.replace(/\s+/g, '');
                            if ($('td').filter('[class*=ourshare_suggestion' + os_sanitizedFormattedDate + ']').length > 0) {
                                $('[class*=ourshare_suggestion' + os_sanitizedFormattedDate + ']').text(converttocomma(os_suggestion.suggestiontotalOurshare));
                                $('[class*=ourshare_total' + os_sanitizedFormattedDate + ']').text(converttocomma(os_suggestion.suggestiontotalOurshare));
                                $('[class*=ourshare_total1' + os_sanitizedFormattedDate + ']').text((os_suggestion.suggestiontotalOurshare));
                            } else {
                                $('[class*=ourshare_suggestion' + os_sanitizedFormattedDate + ']').text(0);
                            }
                        });
                        grandtotal_suggestionOurshare = response.grand_total_suggestionOurshare;

                        $('#grandtotal_suggestion_os').text(converttocomma(response.grand_total_suggestionOurshare));
                        $('#btngetreport').css('display', 'block');
                    }
                    if (ourshare_service.length > 0) {
                        ourshare_service.forEach(function(ourshare_servicerecord) {
                            var ourshare_dateReceived = ourshare_servicerecord['sss_ddd_generatedate'];
                            var ourshare_serviceformattedDate = new Date(ourshare_dateReceived).toLocaleString('en-US', {
                                month: 'short',
                                year: 'numeric'
                            }).toUpperCase();
                            var ourshare_sanitized_serviceFormattedDate = ourshare_serviceformattedDate.replace(/\s+/g, '');
                            if ($('td').filter('[class*=ourshare_service' + ourshare_sanitized_serviceFormattedDate + ']').length > 0) {
                                let os_service_totalmonth = converttocomma(ourshare_servicerecord.servicetotalOurshare);
                                $('[class*=ourshare_service' + ourshare_sanitized_serviceFormattedDate + ']').text(converttocomma(ourshare_servicerecord.servicetotalOurshare));
                                let os_checksuggestionamt = $('[class*=ourshare_total' + ourshare_sanitized_serviceFormattedDate + ']').text();

                                let ossuggestionamt = '';
                                let osserviceamt = '';


                                if (os_checksuggestionamt != '') {
                                    let os_numberArray = os_checksuggestionamt.split(",");
                                    let os_serviceArray = os_service_totalmonth.split(",");
                                    for (var i = 0; i < os_numberArray.length; i++) {
                                        ossuggestionamt += os_numberArray[i];
                                    }
                                    for (var i = 0; i < os_serviceArray.length; i++) {
                                        osserviceamt += os_serviceArray[i];
                                    }
                                    if (ossuggestionamt > 0 && osserviceamt > 0) {
                                        let os_total_of_entity = parseInt(ossuggestionamt) + parseInt(osserviceamt);
                                        $('[class*=ourshare_total' + ourshare_sanitized_serviceFormattedDate + ']').text(converttocomma(os_total_of_entity));
                                        $('[class*=ourshare_total1' + ourshare_sanitized_serviceFormattedDate + ']').text((os_total_of_entity));

                                    }
                                } else {
                                    $('[class*=ourshare_total' + ourshare_sanitized_serviceFormattedDate + ']').text(converttocomma(ourshare_servicerecord.servicetotalOurshare));
                                    $('[class*=ourshare_total1' + ourshare_sanitized_serviceFormattedDate + ']').text((ourshare_servicerecord.servicetotalOurshare));
                                }

                            } else {
                                $('[class*=ourshare_service' + ourshare_sanitized_serviceFormattedDate + ']').text(0);
                            }
                        });
                        grandtotal_service_os = response.grand_total_service_ourshare;

                        $('#grandtotal_service').text(converttocomma(response.grand_total_service_ourshare));
                    }

                    let ourshare_progressive = 0;
                    let ourshare_parsedValue = 0;
                    let os_index = 1;
                    let os_avg_total = 0;
                    for (var i = 0; i < ourshare_months.length; i++) {
                        var os_totalofentities = ourshare_months[i] + '' + (i < 9 ? startYear : endYear);
                        let os_total = ($('[class*=ourshare_total1' + os_totalofentities + ']').text());
                       
                        let ourshare_parsedTotal = parseInt(os_total);
                        if (!isNaN(ourshare_parsedTotal)) {
                            ourshare_parsedValue += ourshare_parsedTotal;
                        } else {
                            ourshare_parsedValue += 0;
                        }
                        
                        $('[class*=os_progressivetotal' + os_totalofentities + ']').text(converttocomma(ourshare_parsedValue));
                        
                        os_avg_total = parseInt(ourshare_parsedValue)/ parseInt(os_index) ;
                        let os_avg = Math.round(os_avg_total)
                        $('[id*=os_avg_total' + os_totalofentities + ']').text(converttocomma(os_avg));
                        os_index++;
                    }
                }
            });
        }
    </script>

    <?= $this->endSection(); ?>