<?= $this->extend('commanfile/header'); ?>
<?= $this->section('content'); ?>
<div class="row">
    <div class="col-md-12">
        <div class="card">
            <div class="card-header">
                <!-- <h3 class="card-title">Bank Details</h3> -->
                <a href="javascript:void(0)" class="btn btn-md btn-danger" onclick="add_vp()">
                    <i class="fa fa-plus-square mr-1"></i> Vendor Purpose
                </a>
            </div>
            <!-- /.card-header -->
            <div class="card-body">
                <table id="vp-data-table" class="table table-bordered table-striped">
                    <thead>
                        <tr>

                            <th>Vendor Name</th>
                            <th>Purpose</th>
                            <th>Status</th>
                            <th>Action</th>
                        </tr>
                    </thead>
                    <tbody>
                    </tbody>
                    <tfoot>
                        <tr>

                            <th>Vendor Name</th>
                            <th>Purpose</th>
                            <th>Status</th>
                            <th>Action</th>
                        </tr>
                    </tfoot>
                </table>
            </div>
            <!-- /.card-body -->
        </div>
    </div>
</div>
<div class="modal fade" id="Addvp">
    <div class="modal-dialog modal-lg">
        <div class="modal-content">
            <div class="modal-header">
                <h4 class="modal-title">Add Vendor Purpose Here</h4>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                <form id="vpform" method="POST">
                    <input type="text" name="sss_vp_id" hidden>
                    <div class="row">
                        <div class="col-md-6">
                            <label>Vendors</label>
                            <select class="form-control select2" name="sss_v_id" id="sss_v_id">
                                <option>Select Vendor Name</option>
                                <?php foreach ($vendorlist as $vl) { ?>
                                    <option value="<?= $vl->sss_vendor_id ?>" <?= set_select('sss_v_id', $vl->sss_vendor_id, TRUE) ?>><?= $vl->sss_vendor_name ?></option>
                                <?php } ?>
                            </select>
                            <span class="text-danger error-text sss_v_id_error"></span>
                        </div>
                        <div class="col-md-12">
                            <label>Purpose </label>
                            <div class="form-group">
                                <div class="input-group">
                                    <input type="text" class="form-control" name="sss_vp_purpose" id="sss_vp_purpose" placeholder="Enter Purpose">
                                </div>
                                <span class="text-danger error-text sss_vp_purpose_error"></span>
                            </div>
                        </div>
                    </div>

            </div>
            <div class="modal-footer justify-content-right">
                <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                <button type="button" onclick="save_vp()" class="btn btn-primary">Save changes</button>
            </div>
            </form>
        </div>
    </div>
</div>
<script>
    var save_method;

    $(document).ready(function() {
        table = $('#vp-data-table').DataTable({
            "processing": true, //Feature control the processing indicator.
            "serverSide": true, //Feature control DataTables' server-side processing mode.
            "order": [], //Initial no order.
            "ordering": true,
            "searching": true,
            "responsive": true,
            "lengthChange": false,
            // Load data for the table's content from an Ajax source
            "ajax": {
                "url": "<?php echo base_url() ?>/get_vp",
            },
            //Set column definition initialisation properties.
            "columnDefs": [{
                "targets": [-1], //last column
                "orderable": false, //set not orderable
            }, ],
        });
    });

    function add_vp() {
        save_method = 'add';
        $('.form-group').removeClass('has-error'); // clear error class
        $('.help-block').empty(); // clear error string
        $('#Addvp').modal('show'); // show bootstrap modal
    }

    function edit_vp(vendor_id) {
        save_method = 'update';
        var link = "<?php echo base_url() ?>/editvprecord/" + vendor_id;
        //Ajax Load data from ajax
        $.ajax({
            url: link,
            type: "GET",
            dataType: "JSON",
            success: function(data) {
                $('[name="sss_vp_id"]').val(data.sss_vp_id);
                $('[name="sss_v_id"]').val(data.sss_v_id);
                $('[name="sss_vp_purpose"]').val(data.sss_vp_purpose);
                $('#Addvp').modal('show'); // show bootstrap modal when complete loaded
                $('.modal-title').text('Edit Vendor Purpose Information'); // Set title to Bootstrap modal title
            },
            error: function(jqXHR, textStatus, errorThrown) {
                alert(errorThrown);
            }
        });
    }

    function save_vp() {
        $('#btnSave').text('saving info...'); //change button text
        $('#btnSave').attr('disabled', true); //set button disable 
        var url;
        if (save_method == 'add') {
            url = "<?= base_url() ?>/insertvp";
        } else {
            url = "<?php echo base_url() ?>/updatevp";
        }
        var formData = new FormData($('#vpform')[0]);

        $.ajax({
            url: url,
            type: "POST",
            data: formData,
            contentType: false,
            processData: false,
            dataType: "JSON",
            success: function(data) {
                if (data.status == true) //if success close modal and reload ajax table
                {
                    // Swal.fire(
                    //     data.message
                    // )
                    // $('#Addvp').modal('hide');
                    // $('#vpform')[0].reset();
                    // location.reload();

                    Swal.fire({
                        text: data.message,
                        focusConfirm: true,
                        confirmButtonText: '<a class="btn btn-sm" style="color:#fff;" onclick="location.reload()">OK</a>',
                    });
                    setTimeout(function() {
                        $('#loader').show();
                        location.reload();
                    }, 2500);
                } else {
                    $.each(data.error, function(prefix, val) {
                        $('#vpform').find(`span.${prefix}_error`).text(val);
                    });
                }
                $('#btnSave').text('save'); //change button text
                $('#btnSave').attr('disabled', false); //set button enable 
            }
        });
    }
    // delete funtion....
    function delete_vp(id) {
        Swal.fire({
            title: 'Are you sure?',
            text: "You won't be able to revert this!",
            icon: 'warning',
            showCancelButton: true,
            confirmButtonColor: '#3085d6',
            cancelButtonColor: '#d33',
            confirmButtonText: 'Yes, delete it!'
        }).then((result) => {
            if (result.isConfirmed) {
                $.ajax({
                    url: "<?php echo base_url() ?>/deletevprecord/" + id,
                    type: "GET",
                    dataType: "JSON",
                    success: function(data) {
                        if (data.status == true) {
                            Swal.fire(
                                'Deleted!',
                                'Your file has been deleted.',
                                'success'
                            )
                            location.reload();
                        }
                    },
                    error: function(jqXHR, textStatus, errorThrown) {
                        alert(errorThrown);
                    }
                });
            }
        })
    }

    $(document).on('click', '.status_checks', function() {
        var status = ($(this).hasClass("btn-success")) ? '0' : '1';
        var msg = (status == '0') ? 'Inactive' : 'Active';
        Swal.fire({
            title: 'Are you sure to ' + msg + ' the record ?',
            icon: 'warning',
            showCancelButton: true,
            confirmButtonColor: '#3085d6',
            cancelButtonColor: '#d33',
            confirmButtonText: 'Yes, ' + msg + ' it!',
        }).then((result) => {
            if (result.value) {
                var current_element = $(this);
                var id = $(current_element).attr('data');
                var myurl = "<?php echo base_url() ?>/updatedvpstatus/";
                $.ajax({
                    type: "GET",
                    url: myurl,
                    data: {
                        "id": id,
                        "sss_vp_status": status
                    },
                    success: function(data) {
                        Swal.fire({
                            icon: 'success',
                            title: 'Record ' + msg + ' Successfully..!',
                            showConfirmButton: true,
                            cancelButtonColor: '#d33',
                        });
                        location.reload();
                    }
                });
            } else if (result.dismiss == 'cancel') {
                reload_table()
                // function when cancel button is clicked
            }
        });
    });
</script>
<?= $this->endSection(); ?>