<?php


namespace App\Controllers;

use App\Models\Client_m;
use App\Models\Entities_m;
use App\Models\Bankdetails_m;
use App\Models\SacCode_m;
use App\Models\CreateInvoice_m;
use \Hermawan\DataTables\DataTable;

class CreateInvoice extends BaseController
{
    public function index()
    {
        $entityid = session('ent_id');

        $entities = new Entities_m();
        $data['entities']  = $entities->table('sss_tbl_entities')->select("sss_ent_id,sss_ent_name")->where('sss_ent_status', 1)->get()->getResult();

        $SacCode_m = new SacCode_m();
        $data['Saccode'] = $SacCode_m->table('sss_tbl_sac_code')->select("sss_sac_code_id, sss_invoice_type, sss_sac_code")->where('sss_ent_id', $entityid)->where('status', 1)->get()->getResult();

        $Bankdetails_m = new Bankdetails_m();
        $data['bankdetails'] = $Bankdetails_m->table('sss_tbl_entity_bank_details')->select("sss_ent_bank_id, sss_ent_bank_acc_name, sss_ent_bank_name, sss_ent_bank_acc_no,sss_ent_bank_acc_ifsc")->where('sss_ent_id', $entityid)->where('sss_ent_bank_acc_status', 1)->get()->getResult();

        $clients = new Client_m();
        $data['clients']  = $clients->table('sss_tbl_client')->select("sss_client_id,sss_client_name")->where('sss_client_status', 1)->get()->getResult();

        $lastidd = new CreateInvoice_m();
        $lastid = $lastidd->table('sss_tbl_invoices')->select("sss_inv_id")->orderBy('sss_inv_id', 'DESC')->get()->getRow();
        // $lastinserted_id = $lastidd->insertID();
        // echo $lastinserted_id;exit;
        $d = $lastid->sss_inv_id;
        $data['billno'] = str_pad($d + 1, 5, '0', STR_PAD_LEFT);
        if (session('logged_in') == true && session('logged_in') == 1) {
            $data['pageTitle'] = 'Generate Invoices';
            return view('createinvoice_v', $data);
        } else {
            return view('login', $data);
        }
    }

    public function viewInvoice()
    {
        $data['pageTitle'] = 'Invoices';
        return view('invoices_table',$data);
    }

    public function getinvoices()
    {
        $db = db_connect();
        $builder = $db->table('sss_tbl_invoices')->select("sss_inv_id, sss_inv_bill_no, sss_inv_bill_date, sss_tbl_client.sss_client_name,sss_inv_total_amt")
            ->join('sss_tbl_client', 'sss_tbl_client.sss_client_id = sss_tbl_invoices.sss_inv_client_id');
        return DataTable::of($builder)
            ->add('action', function ($invid) {
                return '<a class="btn btn-primary btn-sm" href="' . base_url() . '/editinvoice/' . $invid->sss_inv_id . '"><i class="fa fa-edit"></i></a> | <a href="' . base_url() . '/PaymentReceived/'. $invid->sss_inv_id .'"> Payment Received</a> |<a class="btn btn-danger btn-sm" href="' . base_url() . '/printInvoice/' . $invid->sss_inv_id .'"><i class="fa fa-file-download"></i></a>';
            }, 'last')
           
            ->hide('sss_inv_id')
            ->toJson();
    }

    public function getsaccode($sid)
    {
        $sssid = new SacCode_m();
        $data = $sssid->find($sid);
        echo json_encode($data);
    }

    public function getclient($cxid)
    {
        $Client_m = new Client_m();
        $data = $Client_m->find($cxid);
        echo json_encode($data);
        # code...
    }
    public function getbankdetails($bankid)
    {
        $Bankdetails_m = new Bankdetails_m();
        $data = $Bankdetails_m->find($bankid);
        echo json_encode($data);
        # code...
    }

    public function insert_invoice()
    {
        $validation = \Config\Services::validation();
        $this->validate([
            'sss_inv_type' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Please select Type',
                ]
            ],
            'sss_inv_disbursement_status' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Please select Disbursment Status',
                ]
            ],
            'sss_inv_bill_date' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Enter Date'
                ]
            ],
            'sss_inv_client_id' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Please select Client',
                ]
            ],
            'sss_inv_brief' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Give Brief',
                ]
            ],
            'sss_inv_duration' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Select Correct Option'
                ]
            ],
            // 'sss_inv_duration_others' => [
            //     'rules' => 'required',
            //     'errors' => [
            //         'required' => 'Please Mention Something',
            //     ]
            // ],
            'sss_inv_amt' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Enter Amount',
                ]
            ],
            'sss_inv_transaction_type' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Select Correct Option'
                ]
            ],
            'sss_inv_addr' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Enter Address'
                ]
            ],
            'sss_inv_bankid' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Select Bank'
                ]
            ]
        ]);
        if ($validation->run() == FALSE) {
            $errors = $validation->getErrors();
            echo json_encode(['code' => 0, 'error' => $errors]);
        } else {
            $startdate = $this->request->getVar('sss_inv_bill_date');
            $dateComps = date_parse($startdate);
            $year = $dateComps['year'];
            $month = $dateComps['month'];
            $invmonth = $month . '-' . $year;
            $billno = $this->request->getVar('sss_inv_bill_no') . '/' . $this->request->getVar('invinitial') . '/' . $this->request->getVar('invyear');
           
            $data = [
                'sss_inv_type' => $this->request->getVar('sss_inv_type'),
                'sss_inv_disbursement_status' => $this->request->getVar('sss_inv_disbursement_status'),
                'sss_inv_bill_no' => $billno,
                'sss_inv_month' => $invmonth,
                'sss_inv_bill_date' => date('Y-m-d', strtotime($this->request->getVar('sss_inv_bill_date'))),
                'sss_inv_client_id' => $this->request->getVar('sss_inv_client_id'),
                'sss_inv_desc' => $this->request->getVar('sss_inv_desc'),
                'sss_inv_brief' => $this->request->getVar('sss_inv_brief'),
                'sss_inv_duration' => $this->request->getVar('sss_inv_duration'),
                'sss_inv_duration_others' => $this->request->getVar('sss_inv_duration_others'),
                'sss_inv_addr' => $this->request->getVar('sss_inv_addr'),
                'sss_inv_amt' => $this->request->getVar('sss_inv_amt'),
                'sss_inv_transaction_type' => $this->request->getVar('sss_inv_transaction_type'),
                'sss_inv_deposite_amt' => $this->request->getVar('sss_inv_deposite_amt'),
                'sss_inv_sgst' => $this->request->getVar('sss_inv_sgst'),
                'sss_inv_cgst' => $this->request->getVar('sss_inv_cgst'),
                'sss_inv_igst' => $this->request->getVar('sss_inv_igst'),
                'sss_inv_total_amt' => $this->request->getVar('sss_inv_total_amt'),
                'sss_inv_bankid' => $this->request->getVar('sss_inv_bankid'),
                'sss_inv_created_by' => session('userid'),
                'sss_inv_created_date' => date('Y-m-d')
            ];
            $insertinvoice = new CreateInvoice_m();
            $isCreatInvoice = $insertinvoice->insert($data);
            // echo "<pre>";print_r($data);exit;
            if (!empty($isCreatInvoice)) {
                echo json_encode(array("status" => true, "message" => 'Invoice Generated'));
            } else {
                echo json_encode(array("status" => false, "message" => 'Something error while generating invoice'));
            }
        }
    }

    public function editinvoice($invId)
    {
        $entityid = session('ent_id');
        $entities = new Entities_m();
        $data['entities']  = $entities->table('sss_tbl_entities')->select("sss_ent_id,sss_ent_name")->where('sss_ent_status', 1)->get()->getResult();
        $SacCode_m = new SacCode_m();
        $data['Saccode'] = $SacCode_m->table('sss_tbl_sac_code')->select("sss_sac_code_id, sss_invoice_type, sss_sac_code")->where('sss_ent_id', $entityid)->where('status', 1)->get()->getResult();
        $Bankdetails_m = new Bankdetails_m();
        $data['bankdetails'] = $Bankdetails_m->table('sss_tbl_entity_bank_details')->select("sss_ent_bank_id, sss_ent_bank_acc_name, sss_ent_bank_name, sss_ent_bank_acc_no,sss_ent_bank_acc_ifsc")->where('sss_ent_id', $entityid)->where('sss_ent_bank_acc_status', 1)->get()->getResult();
        $clients = new Client_m();
        $data['clients']  = $clients->table('sss_tbl_client')->select("sss_client_id,sss_client_name")->where('sss_client_status', 1)->get()->getResult();
        $editinv_m = new CreateInvoice_m();
        $data['editinvoice'] = $editinv_m->table('sss_tbl_invoices')->select("sss_inv_id, sss_inv_type, sss_inv_disbursement_status, sss_inv_bill_no, sss_inv_month, sss_inv_bill_date, sss_inv_client_id, sss_inv_brief, sss_inv_duration, sss_inv_duration_others, sss_inv_transaction_type, sss_inv_addr, sss_inv_amt, sss_inv_deposite_amt, sss_inv_sgst, sss_inv_cgst, sss_inv_igst, sss_inv_total_amt, sss_inv_bankid")->where('sss_inv_id', $invId)->get()->getRow();
        list($billno, $initial, $year) = explode("/", $data['editinvoice']->sss_inv_bill_no);
        $data['billno'] = $billno;
        $data['initial'] = $initial;
        $data['year'] = $year;
        echo "<pre>";print_r($data);exit;
        return view('editinvoice', $data);
    }

    public function update_invoice()
    {
        $invId = $this->request->getVar('sss_inv_id');
        $startdate = $this->request->getVar('sss_inv_bill_date');
        $dateComps = date_parse($startdate);
        $year = $dateComps['year'];
        $month = $dateComps['month'];
        $invmonth = $month . '-' . $year;
        $billno = $this->request->getVar('sss_inv_bill_no') . '/' . $this->request->getVar('invinitial') . '/' . $this->request->getVar('invyear');
        // echo "<pre>";print_r($billno);exit;
        $insertinvoice = new CreateInvoice_m();
        $data = [
            'sss_inv_type' => $this->request->getVar('sss_inv_type'),
            'sss_inv_disbursement_status' => $this->request->getVar('sss_inv_disbursement_status'),
            'sss_inv_month' => $invmonth,
            'sss_inv_bill_date' => date('Y-m-d', strtotime($this->request->getVar('sss_inv_bill_date'))),
            'sss_inv_client_id' => $this->request->getVar('sss_inv_client_id'),
            'sss_inv_desc' => $this->request->getVar('sss_inv_desc'),
            'sss_inv_brief' => $this->request->getVar('sss_inv_brief'),
            'sss_inv_bill_no' => $billno,
            'sss_inv_duration' => $this->request->getVar('sss_inv_duration'),
            'sss_inv_amt' => $this->request->getVar('sss_inv_amt'),
            'sss_inv_transaction_type' => $this->request->getVar('sss_inv_transaction_type'),
            'sss_inv_addr' => $this->request->getVar('sss_inv_addr'),
            'sss_inv_deposite_amt' => $this->request->getVar('sss_inv_deposite_amt'),
            'sss_inv_sgst' => $this->request->getVar('sss_inv_sgst'),
            'sss_inv_cgst' => $this->request->getVar('sss_inv_cgst'),
            'sss_inv_igst' => $this->request->getVar('sss_inv_igst'),
            'sss_inv_total_amt' => $this->request->getVar('sss_inv_total_amt'),
            'sss_inv_bankid' => $this->request->getVar('sss_inv_bankid'),
            'sss_inv_updated_by' => session('userid'),
            'sss_inv_updated_date' => date('Y-m-d')
        ];
       
        $isCreatInvoice = $insertinvoice->update($invId, $data);
        // echo "<pre>";print_r($data);exit;
        if (!empty($isCreatInvoice)) {
            echo json_encode(array("status" => true, "message" => 'Invoice Updated'));
        } else {
            echo json_encode(array("status" => false, "message" => 'Something error while updating invoice'));
        }
    }

    public function print_Invoice($invId)
    {
        
        $editinv_m = new CreateInvoice_m();
        $data['printinvoice'] = $editinv_m->table('sss_tbl_invoices')->select("sss_inv_id, sss_inv_type, sss_inv_disbursement_status, sss_inv_bill_no, sss_inv_month, sss_inv_bill_date, sss_tbl_client.sss_client_name,sss_tbl_client.sss_client_placeofservice, sss_tbl_client.sss_client_statecode, sss_client_gstno, sss_inv_desc, sss_inv_brief, sss_inv_duration, sss_inv_duration_others, sss_inv_transaction_type, sss_inv_addr, sss_inv_amt, sss_inv_deposite_amt, sss_inv_sgst, sss_inv_cgst, sss_inv_igst, sss_inv_total_amt, sss_tbl_entity_bank_details.*,sss_tbl_entities.*, sss_inv_created_by")
                                ->join('sss_tbl_client' , 'sss_tbl_client.sss_client_id = sss_tbl_invoices.sss_inv_client_id')
                                ->join('sss_tbl_entity_bank_details' , 'sss_tbl_entity_bank_details.sss_ent_bank_id = sss_tbl_invoices.sss_inv_bankid')
                                ->join('sss_tbl_entities' , 'sss_tbl_entities.sss_ent_id = sss_tbl_entity_bank_details.sss_ent_id')
                                ->where('sss_tbl_invoices.sss_inv_id', $invId)->get()->getRow();
        list($billno, $initial, $year) = explode("/", $data['printinvoice']->sss_inv_bill_no);
        $data['billno'] = $billno;
        $data['initial'] = $initial;
        $data['year'] = $year;
        // echo "<pre>";print_r($data);exit;
        $dompdf = new \Dompdf\Dompdf(['isRemoteEnabled' => true]);
        $dompdf->loadHtml(view('printinvoice_v',$data));
        $dompdf->setPaper('A4', 'landscape');
        $dompdf->render();
        $dompdf->stream();
        // return view('printinvoice_v',$data);
    }
}
