<?= $this->extend('commanfile/header'); ?>
<?= $this->section('content'); ?>
<div class="row">
    <div class="col-md-12">
        <div class="card">
            <div class="card-header">
                <!-- <h3 class="card-title">Bank Book</h3> -->
            </div>
            <!-- /.card-header -->
            <div class="card-body">
                <table id="bankBook-data-table" class="table table-bordered table-striped">
                    <thead>
                        <tr>
                            <th>Date</th>
                            <th>Reference Number</th>
                            <th>Type</th>
                            <th>Amount</th>
                            <th>Bank Name</th>
                            <!-- <th>Status</th> -->
                            <th>Action</th>
                        </tr>
                    </thead>
                    <tbody>

                    </tbody>
                    <tfoot>
                        <tr>
                            <th>Date</th>
                            <th>Reference Number</th>
                            <th>Type</th>
                            <th>Amount</th>
                            <th>Bank Name</th>
                            <!-- <th>Status</th> -->
                            <th>Action</th>
                        </tr>
                    </tfoot>
                </table>
            </div>
            <!-- /.card-body -->
        </div>
    </div>
</div>

<script>
    var save_method;
    // sac code operations ...
    $(document).ready(function() {
        table = $('#bankBook-data-table').DataTable({
            "processing": true, //Feature control the processing indicator.
            "serverSide": true, //Feature control DataTables' server-side processing mode.
            "order": [], //Initial no order.
            "ordering": true,
            "searching": true,
            "responsive": true,
            "lengthChange": false,
            // Load data for the table's content from an Ajax source
            "ajax": {
                "url": "<?php echo base_url() ?>/getAllbankbook",
            },
            //Set column definition initialisation properties.
            "columnDefs": [{
                "targets": [-1], //last column
                "orderable": false, //set not orderable
            }, ],
        });
    });

    function delete_bankbook(id) {
        alert(id);
        Swal.fire({
            title: 'Are you sure?',
            text: "You won't be able to revert this!",
            icon: 'warning',
            showCancelButton: true,
            confirmButtonColor: '#3085d6',
            cancelButtonColor: '#d33',
            confirmButtonText: 'Yes, delete it!'
        }).then((result) => {
            if (result.isConfirmed) {
                $.ajax({
                    url: "<?php echo base_url() ?>/deletebankbook/" + id,
                    type: "GET",
                    dataType: "JSON",
                    success: function(data) {
                        if (data.status == true) {
                            Swal.fire(
                                'Deleted!',
                                'Your file has been deleted.',
                                'success'
                            )
                            table.ajax.reload(null, false); //reload datatable ajax 
                        }
                    },
                    error: function(jqXHR, textStatus, errorThrown) {
                        alert(errorThrown);
                    }
                });
            }
        })
    }
</script>
<?= $this->endSection(); ?>