<?php


namespace App\Controllers;

use App\Models\Employee_m;
use App\Models\Outcomes_m;
use App\Models\DDD_outcome_m;
use App\Models\DDD_emp_m;
use App\Models\Dealdetaildraft_m;
use App\Models\Dealdisbursalchart_m;
use \Hermawan\DataTables\DataTable;

class DealDetailsDraft extends BaseController
{
    public function index($dddId)
    {
        $data['dddId'] = $dddId;
        $getEmp = new Employee_m();
        $data['activeEmp'] = $getEmp->table("sss_tbl_emp")->select('*')->where('sss_emp_status', 1)->get()->getResult();

        $outcomes = new Outcomes_m();
        $data['activeOutcomes'] = $outcomes->table('sss_tbl_outcomes')->select('*')->where('sss_oc_status', 1)->get()->getResult();


        $ddc = new Dealdisbursalchart_m();
        $data['ddc'] = $ddc->table('sss_tbl_dealdisbursalchart')->select("sss_tbl_dealdisbursalchart.sss_dd_sbamt, sss_tbl_dealdisbursalchart.sss_dd_royality, sss_tbl_paymentreceived.sss_pr_tdsamt,sss_tbl_paymentreceived.sss_pr_balanceamt,sss_tbl_paymentreceived.sss_pr_amtreceived,sss_tbl_invoices.sss_inv_bill_no,sss_tbl_invoices.sss_inv_bill_date,sss_tbl_invoices.sss_inv_amt,sss_tbl_invoices.sss_inv_sgst,sss_tbl_invoices.sss_inv_cgst,sss_tbl_invoices.sss_inv_igst,sss_tbl_invoices.sss_inv_total_amt,sss_tbl_invoices.sss_inv_client_id,sss_tbl_client.sss_client_name")
            ->join('sss_tbl_paymentreceived', 'sss_tbl_paymentreceived.sss_pr_id = sss_tbl_dealdisbursalchart.sss_pr_id')
            ->join('sss_tbl_invoices', 'sss_tbl_invoices.sss_inv_id = sss_tbl_paymentreceived.sss_inv_id')
            ->join('sss_tbl_client', 'sss_tbl_client.sss_client_id = sss_tbl_invoices.sss_inv_client_id')
            ->where('sss_dd_id', $dddId)
            ->get()->getRow();
        if ($data['ddc']->sss_inv_cgst != "0" || $data['ddc']->sss_inv_sgst != "0") {
            $totalgst = $data['ddc']->sss_inv_cgst + $data['ddc']->sss_inv_sgst;
            $data['totalgst'] = $totalgst;
        } else {
            $totalgst = $data['ddc']->sss_inv_igst;
            $data['totalgst'] = $totalgst;
        }

        $data['pageTitle'] = 'Deal Detail Draft';
        return view('dealDetailsDraft', $data);
    }

    public function get_ddd($dddId)
    {
        $db = db_connect();
        $builder = $db->table('sss_tbl_dealdetaildraft')->select("sss_ddd_id, sss_ddc_id, sss_ddd_misc")
            ->where('sss_tbl_dealdetaildraft.sss_ddc_id', $dddId)->orderBy('sss_ddd_id', 'DESC');
        return DataTable::of($builder)
            ->add('action', function ($edit_dddId) {
                return '<a class="btn btn-seccondary btn-sm" href="' . base_url() . '/editddd/' . $edit_dddId->sss_ddd_id . '"><i class="fa fa-edit"></i></a> | <a class="btn btn-damger btn-sm" onclick="delete_ddd(' . $edit_dddId->sss_ddd_id . ')"><i class="fa fa-trash"></i></a>';
                // return '<a class="btn btn-seccondary btn-sm" onclick="edit_ddd(' . $edit_dddId->sss_ddd_id . ')"><i class="fa fa-edit"></i></a> | <a class="btn btn-damger btn-sm" onclick="delete_ddd(' . $edit_dddId->sss_ddd_id . ')"><i class="fa fa-trash"></i></a>';
            }, 'last')
            ->hide('sss_ddd_id')
            ->toJson();
    }


    public function insert_ddd()
    {
        $validation = \Config\Services::validation();
        $this->validate([
            'sss_ddd_misc' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Please enter Misc. Amount',
                ]
            ],
            'sss_ddd_sbamt_tdsper' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Select TDS Percent',
                ]
            ],
            'sss_ddd_cirilroyality_tdsper' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Select TDS Percent'
                ]
            ],
            'sss_ddd_unknown' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Mention Required Particulars',
                ]
            ],
            'sss_ddd_unknownamt' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Enter Particulars Amount',
                ]
            ],
            'sss_ddd_unknown_tdsper' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Select TDS Percent',
                ]
            ],
        ]);
        if ($validation->run() == FALSE) {
            $errors = $validation->getErrors();
            echo json_encode(['code' => 0, 'error' => $errors]);
        } else {
            unset($_POST['sss_ddd_service_fees']);
            unset($_POST['sss_ddd_service_gst']);
            unset($_POST['sss_ddd_sbbrkg']);
            unset($_POST['sss_ddd_cirilroyality']);
            unset($_POST['sss_ddd_gst']);
            unset($_POST['sss_ddd_miscexp']);

            $outcomeno = count($_POST['sss_ddd_oc_id']);
            $empno = count($_POST['sss_emp_id']);

            $insertrecord = new Dealdetaildraft_m();
            $data = [
                'sss_ddc_id' => $this->request->getVar('sss_ddc_id'),
                'sss_ddd_misc' => $this->request->getVar('sss_ddd_misc'),
                'sss_ddd_sbamt_amt' => $this->request->getVar('sss_ddd_sbamt_amt'),
                'sss_ddd_sbamt_tdsper' =>  $this->request->getVar('sss_ddd_sbamt_tdsper'),
                'sss_ddd_sbamt_tds' => $this->request->getVar('sss_ddd_sbamt_tds'),
                'sss_ddd_cirilroyalityamt' => $this->request->getVar('sss_ddd_cirilroyalityamt'),
                'sss_ddd_cirilroyality_tdsper' => $this->request->getVar('sss_ddd_cirilroyality_tdsper'),
                'sss_ddd_cirilroyality_tds' => $this->request->getVar('sss_ddd_cirilroyality_tds'),
                'sss_ddd_unknown' => $this->request->getVar('sss_ddd_unknown'),
                'sss_ddd_unknownamt' => $this->request->getVar('sss_ddd_unknownamt'),
                'sss_ddd_unknown_tdsper' => $this->request->getVar('sss_ddd_unknown_tdsper'),
                'sss_ddd_unknown_tds' => $this->request->getVar('sss_ddd_unknown_tds'),
                'sss_ddd_ourshare' => $this->request->getVar('sss_ddd_ourshare'),
                'sss_ddd_gst' => $this->request->getVar('sss_ddd_gst'),
                'sss_ddd_gst_amt' => $this->request->getVar('sss_ddd_gst_amt'),
                'sss_ddd_gst_rounded' => $this->request->getVar('sss_ddd_gst_rounded'),
                'sss_ddd_gst_total' => $this->request->getVar('sss_ddd_gst_total'),
                'sss_ddd_gst_tds' => $this->request->getVar('sss_ddd_gst_tds'),
                'sss_ddd_gst_finalamt' => $this->request->getVar('sss_ddd_gst_finalamt'),
                'sss_ddd_total_roundvalue' => $this->request->getVar('sss_ddd_total_roundvalue'),
                'sss_ddd_sumofroundvalue' => $this->request->getVar('sss_ddd_sumofroundvalue'),
                'sss_ddd_total_tds' => $this->request->getVar('sss_ddd_total_tds'),
                'sss_ddd_total_finalamt' => $this->request->getVar('sss_ddd_total_finalamt'),
                'sss_ddd_balanceincurrent' => $this->request->getVar('sss_ddd_balanceincurrent'),
                'sss_ddd_balanceincurrentinper' => $this->request->getVar('sss_ddd_balanceincurrentinper'),
                'sss_ddd_status' => true,
                'sss_ddd_createdby' => session('userid'),
                'sss_ddd_createdate' => date('Y-m-d')
            ];

            $isInserted = $insertrecord->insert($data);
            $lastinserted_id = $insertrecord->insertID();
            $isOutcomes = new DDD_outcome_m();
            for ($i = 0; $i < $outcomeno; $i++) {
                $outcomevalues = [
                    'sss_ddd_id' => $lastinserted_id,
                    'sss_ddd_oc_id' => $_POST['sss_ddd_oc_id'][$i],
                    'sss_ddd_outcomeamt' => $_POST['sss_ddd_outcomeamt'][$i],
                    'sss_ddd_outcomeroundamt' => $_POST['sss_ddd_outcomeroundamt'][$i],
                    'sss_ddd_outcometotalamt' => $_POST['sss_ddd_outcometotalamt'][$i],
                    'sss_ddd_outcomefinalamt' => $_POST['sss_ddd_outcomefinalamt'][$i],
                    'sss_dddemp_createdby' => session('userid')[$i],
                    'sss_dddemp_createdate' => date('Y-m-d')[$i]
                ];
                $isOutcomes->insert($outcomevalues);
            }
            $isEmps = new DDD_emp_m();
            for ($i = 0; $i < $empno; $i++) {
                $empvalues = [
                    'sss_ddd_id' => $lastinserted_id,
                    'sss_emp_id' => $_POST['sss_emp_id'][$i],
                    'sss_dddemp_amt' => $_POST['sss_ddd_empamt'][$i],
                    'sss_dddemp_roundedamt' => $_POST['sss_ddd_emproundamt'][$i],
                    'sss_dddemp_totalamt' => $_POST['sss_ddd_emptotalamt'][$i],
                    'sss_dddemp_tds' => $_POST['sss_ddd_emptdsamt'][$i],
                    'sss_dddemp_finalamt' => $_POST['sss_ddd_empfinalamt'][$i],
                    'sss_dddemp_createdby' => session('userid')[$i],
                    'sss_dddemp_createdate' => date('Y-m-d')[$i]
                ];
                $isEmps->insert($empvalues);
            }
            if (!empty($isInserted)) {
                echo json_encode(array("status" => true, "message" => 'Deal Details Draft is Inserted'));
            } else {
                echo json_encode(array("status" => false, "message" => 'Something error while inserting Deal Details Draft'));
            }
        }
    }

    public function edit_ddd($dddid)
    {
        $editrecord = new Dealdetaildraft_m();
        $data = $editrecord->find($dddid);
        $ddcid  = $data['sss_ddc_id'];

        $allemprecord = new DDD_emp_m();
        $data['emp'] = $allemprecord->table('sss_ddd_employees')->select('sss_ddd_employees.*, sss_tbl_emp.sss_emp_fname,sss_tbl_emp.sss_emp_lname,sss_tbl_emp.sss_emp_share')->join('sss_tbl_emp', 'sss_tbl_emp.sss_emp_id = sss_ddd_employees.sss_emp_id')->where('sss_ddd_id', $dddid)->get()->getResult();

        $ddc = new Dealdisbursalchart_m();
        $data['ddc'] = $ddc->table('sss_tbl_dealdisbursalchart')->select("sss_tbl_dealdisbursalchart.sss_dd_sbamt, sss_tbl_dealdisbursalchart.sss_dd_royality, sss_tbl_paymentreceived.sss_pr_tdsamt,sss_tbl_paymentreceived.sss_pr_balanceamt,sss_tbl_paymentreceived.sss_pr_amtreceived,sss_tbl_invoices.sss_inv_bill_no,sss_tbl_invoices.sss_inv_bill_date,sss_tbl_invoices.sss_inv_amt,sss_tbl_invoices.sss_inv_sgst,sss_tbl_invoices.sss_inv_cgst,sss_tbl_invoices.sss_inv_igst,sss_tbl_invoices.sss_inv_total_amt,sss_tbl_invoices.sss_inv_client_id,sss_tbl_client.sss_client_name")
            ->join('sss_tbl_paymentreceived', 'sss_tbl_paymentreceived.sss_pr_id = sss_tbl_dealdisbursalchart.sss_pr_id')
            ->join('sss_tbl_invoices', 'sss_tbl_invoices.sss_inv_id = sss_tbl_paymentreceived.sss_inv_id')
            ->join('sss_tbl_client', 'sss_tbl_client.sss_client_id = sss_tbl_invoices.sss_inv_client_id')
            ->where('sss_dd_id', $ddcid)
            ->get()->getRow();
        if ($data['ddc']->sss_inv_cgst != "0" || $data['ddc']->sss_inv_sgst != "0") {
            $totalgst = $data['ddc']->sss_inv_cgst + $data['ddc']->sss_inv_sgst;
            $data['totalgst'] = $totalgst;
        } else {
            $totalgst = $data['ddc']->sss_inv_igst;
            $data['totalgst'] = $totalgst;
        }
        $alloutcomerecord = new DDD_outcome_m();
        $data['outcome'] = $alloutcomerecord->table('sss_ddd_outcomes')->select("sss_ddd_outcomes.*,sss_tbl_outcomes.sss_oc_name,sss_tbl_outcomes.sss_oc_share,sss_tbl_outcomes.sss_oc_type")->join('sss_tbl_outcomes', 'sss_tbl_outcomes.sss_oc_id = sss_ddd_outcomes.sss_ddd_oc_id')->where('sss_ddd_id', $dddid)->get()->getResult();
        // echo "<pre>";print_r($data['outcome']);exit;
        return view('edit_ddd', $data);
        // echo json_encode($data);
    }

    public function update_ddd()
    {
        $id = $this->request->getVar('sss_ddd_id');
        $occount = count($_POST['sss_ddd_oc_id']);
        $isOutcomes = new DDD_outcome_m();
        for ($i = 0; $i < $occount; $i++) {
            $outcomeid = $_POST['sss_ddd_outcomes_id'][$i];
            $sss_ddd_outcomeamt = $_POST['sss_ddd_outcomeamt'][$i];
            $sss_ddd_outcomeroundamt = $_POST['sss_ddd_outcomeroundamt'][$i];
            $sss_ddd_outcometotalamt = $_POST['sss_ddd_outcometotalamt'][$i];
            $sss_ddd_outcomefinalamt = $_POST['sss_ddd_outcomefinalamt'][$i];
            $isOutcomes->table('sss_ddd_outcomes')->set(['sss_ddd_outcomeamt' => $sss_ddd_outcomeamt, 'sss_ddd_outcomeroundamt' => $sss_ddd_outcomeroundamt, 'sss_ddd_outcometotalamt' => $sss_ddd_outcometotalamt, 'sss_ddd_outcomefinalamt' => $sss_ddd_outcomefinalamt])->where('sss_ddd_outcomes_id', $outcomeid)->update();
        }
        $empno = count($_POST['sss_emp_id']);
        $isEmps = new DDD_emp_m();
        for ($i = 0; $i < $empno; $i++) {
            $empid = $_POST['id'][$i];
            $sss_dddemp_amt = $_POST['sss_dddemp_amt'][$i];
            $sss_ddd_emproundamt = $_POST['sss_ddd_emproundamt'][$i];
            $sss_ddd_emptdsamt = $_POST['sss_ddd_emptdsamt'][$i];
            $sss_ddd_empfinalamt = $_POST['sss_ddd_empfinalamt'][$i];
            $isEmps->table('sss_ddd_employees')->set(['sss_dddemp_amt' => $sss_dddemp_amt, 'sss_dddemp_roundedamt' => $sss_ddd_emproundamt, 'sss_dddemp_tds' => $sss_ddd_emptdsamt, 'sss_dddemp_finalamt' => $sss_ddd_empfinalamt])->where('id', $empid)->update();
        }
        
        $updaterecord = new Dealdetaildraft_m();
        $data = [
            'sss_ddc_id' => $this->request->getVar('sss_ddc_id'),
            'sss_ddd_misc' => $this->request->getVar('sss_ddd_misc'),
            'sss_ddd_sbamt_amt' => $this->request->getVar('sss_ddd_sbamt_amt'),
            'sss_ddd_sbamt_tdsper' =>  $this->request->getVar('sss_ddd_sbamt_tdsper'),
            'sss_ddd_sbamt_tds' => $this->request->getVar('sss_ddd_sbamt_tds'),
            'sss_ddd_cirilroyalityamt' => $this->request->getVar('sss_ddd_cirilroyalityamt'),
            'sss_ddd_cirilroyality_tdsper' => $this->request->getVar('sss_ddd_cirilroyality_tdsper'),
            'sss_ddd_cirilroyality_tds' => $this->request->getVar('sss_ddd_cirilroyality_tds'),
            'sss_ddd_unknown' => $this->request->getVar('sss_ddd_unknown'),
            'sss_ddd_unknownamt' => $this->request->getVar('sss_ddd_unknownamt'),
            'sss_ddd_unknown_tdsper' => $this->request->getVar('sss_ddd_unknown_tdsper'),
            'sss_ddd_unknown_tds' => $this->request->getVar('sss_ddd_unknown_tds'),
            'sss_ddd_ourshare' => $this->request->getVar('sss_ddd_ourshare'),
            'sss_ddd_gst' => $this->request->getVar('sss_ddd_gst'),
            'sss_ddd_gst_amt' => $this->request->getVar('sss_ddd_gst_amt'),
            'sss_ddd_gst_rounded' => $this->request->getVar('sss_ddd_gst_rounded'),
            'sss_ddd_gst_total' => $this->request->getVar('sss_ddd_gst_total'),
            'sss_ddd_gst_tds' => $this->request->getVar('sss_ddd_gst_tds'),
            'sss_ddd_gst_finalamt' => $this->request->getVar('sss_ddd_gst_finalamt'),
            'sss_ddd_total_roundvalue' => $this->request->getVar('sss_ddd_total_roundvalue'),
            'sss_ddd_sumofroundvalue' => $this->request->getVar('sss_ddd_sumofroundvalue'),
            'sss_ddd_total_tds' => $this->request->getVar('sss_ddd_total_tds'),
            'sss_ddd_total_finalamt' => $this->request->getVar('sss_ddd_total_finalamt'),
            'sss_ddd_balanceincurrent' => $this->request->getVar('sss_ddd_balanceincurrent'),
            'sss_ddd_balanceincurrentinper' => $this->request->getVar('sss_ddd_balanceincurrentinper'),
            'sss_ddd_updateby' => session('userid'),
            'sss_ddd_updatedate' => date('Y-m-d')
        ];
        $isupdated = $updaterecord->update($id, $data);
        if (!empty($isupdated)) {
            echo json_encode(array("status" => true, "message" => 'Deal Disbursal Draft Updated'));
        } else {
            echo json_encode(array("status" => false, "message" => 'Something error while updating Deal Disbursal Draft'));
        }
    }

    public function delete_ddd($dddid)
    {
        $isDelete = new Dealdetaildraft_m();
        $r = $isDelete->delete_by_id($dddid);
        echo json_encode(array("status" => TRUE, "message" => $r));
    }
}
