<?php

namespace App\Controllers;

use App\Models\Dealdisbursalchart_m;
use App\Models\Paymentreceived_m;
use \Hermawan\DataTables\DataTable;

class DealDisbursalChart extends BaseController
{
    public function index($prId)
    {
        $data['prId'] = $prId;
        $ddc = new Paymentreceived_m();
        $data['ddc'] = $ddc->table('sss_tbl_paymentreceived')->select("sss_tbl_invoices.sss_inv_bill_no, sss_tbl_invoices.sss_inv_bill_date, sss_tbl_invoices.sss_inv_brief, sss_tbl_invoices.sss_inv_amt, sss_tbl_invoices.sss_inv_sgst, sss_tbl_invoices.sss_inv_cgst, sss_tbl_invoices.sss_inv_igst, sss_tbl_invoices.sss_inv_total_amt,sss_pr_tdsamt, sss_pr_finalamt, sss_pr_amtreceived, sss_pr_datereceived, sss_pr_balanceamt, sss_pr_paymenttype, sss_tbl_client.sss_client_name")
            ->join('sss_tbl_invoices', 'sss_tbl_invoices.sss_inv_id = sss_tbl_paymentreceived.sss_inv_id')
            ->join('sss_tbl_client', 'sss_tbl_client.sss_client_id = sss_tbl_invoices.sss_inv_client_id')
            ->where('sss_pr_id', $prId)
            ->get()->getRow();
        if ($data['ddc']->sss_inv_cgst != "0" || $data['ddc']->sss_inv_sgst != "0") {
            $totalgst = $data['ddc']->sss_inv_cgst + $data['ddc']->sss_inv_sgst;
            $data['totalgst'] = $totalgst;
        } else {
            $totalgst = $data['ddc']->sss_inv_igst;
            $data['totalgst'] = $totalgst;
        }
        // echo  "<pre>";print_r($data['ddc']);exit;
        $data['pageTitle'] = 'Deal Disbursal Chart';
        return view('dealDisbursalChart', $data);
    }

    public function get_ddc($prId)
    {
        $db = db_connect();
        $builder = $db->table('sss_tbl_dealdisbursalchart')->select("sss_dd_id, sss_dd_sbamt, sss_dd_cname, sss_dd_pname,sss_dd_royality")
            ->where('sss_tbl_dealdisbursalchart.sss_pr_id', $prId)->orderBy('sss_dd_id', 'DESC');
        return DataTable::of($builder)
            ->add('action', function ($ddid) {
                return '<a class="btn btn-seccondary btn-sm" onclick="edit_ddc(' . $ddid->sss_dd_id . ')"><i class="fa fa-edit"></i></a> | <a class="btn btn-damger btn-sm" onclick="delete_ddc(' . $ddid->sss_dd_id . ')"><i class="fa fa-trash"></i></a> | <a class="btn btn-warning btn-sm mt-1" href="' . base_url() . '/DealDetailsDraft/'. $ddid->sss_dd_id .'"> DealDetailsDraft </a>';
            }, 'last')
            ->hide('sss_dd_id')
            ->toJson();
    }


    public function insert_ddc()
    {
        $validation = \Config\Services::validation();
        $this->validate([
            'sss_dd_sbamt' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Please enter Sub-Brokerage Amount',
                ]
            ],
            'sss_dd_cname' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Please Enter Company Name',
                ]
            ],
            'sss_dd_cpersonname' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Please Enter Person Name'
                ]
            ],
            'sss_dd_cpaidon' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Select Paid on Date',
                ]
            ],

            'sss_dd_pname' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Please enter person name',
                ]
            ],
            'sss_dd_prequiredon' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Required On',
                ]
            ],
            'sss_ppaidon' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Select Paid On Date'
                ]
            ],
            'sss_dd_royality' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Enter Royality',
                ]
            ],


            'sss_dd_royalitypaidon' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Select Paid On Date',
                ]
            ],
            'sss_dd_locker' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Enter Locker/Source'
                ]
            ],
            'sss_dd_profitamt' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Enter Profit Amount',
                ]
            ],
            'sss_dd_sheetno' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Enter Sheet Number',
                ]
            ]
        ]);
        if ($validation->run() == FALSE) {
            $errors = $validation->getErrors();
            echo json_encode(['code' => 0, 'error' => $errors]);
        } else {
            $insertrecord = new Dealdisbursalchart_m();
            $data = [
                'sss_pr_id' => $this->request->getVar('sss_pr_id'),
                'sss_dd_sbamt' => $this->request->getVar('sss_dd_sbamt'),
                'sss_dd_cname' => $this->request->getVar('sss_dd_cname'),
                'sss_dd_cpersonname' =>  $this->request->getVar('sss_dd_cpersonname'),
                'sss_dd_cpaidon' => $this->request->getVar('sss_dd_cpaidon'),
                'sss_dd_pname' => $this->request->getVar('sss_dd_pname'),
                'sss_dd_prequiredon' => $this->request->getVar('sss_dd_prequiredon'),
                'sss_ppaidon' => $this->request->getVar('sss_ppaidon'),
                'sss_dd_royality' => $this->request->getVar('sss_dd_royality'),
                'sss_dd_royalitypaidon' => $this->request->getVar('sss_dd_royalitypaidon'),
                'sss_dd_locker' => $this->request->getVar('sss_dd_locker'),
                'sss_dd_profitamt' => $this->request->getVar('sss_dd_profitamt'),
                'sss_dd_sheetno' => $this->request->getVar('sss_dd_sheetno'),
                'sss_dd_createdby' => session('userid'),
                'sss_dd_createdate' => date('Y-m-d')
            ];
          
            $isInserted = $insertrecord->insert($data);
            if (!empty($isInserted)) {
                echo json_encode(array("status" => true, "message" => 'Deal Disbursal Chart Inserted'));
            } else {
                echo json_encode(array("status" => false, "message" => 'Something error while inserting Deal Disbursal Chart'));
            }
        }
    }

    public function edit_ddc($prid)
    {
        $editrecord = new Dealdisbursalchart_m();
        $data = $editrecord->find($prid);
        echo json_encode($data);
    }

    public function update_ddc()
    {
        $id = $this->request->getVar('sss_dd_id');
        $updaterecord = new Dealdisbursalchart_m();
        $data = [
            'sss_pr_id' => $this->request->getVar('sss_pr_id'),
            'sss_dd_sbamt' => $this->request->getVar('sss_dd_sbamt'),
            'sss_dd_cname' => $this->request->getVar('sss_dd_cname'),
            'sss_dd_cpersonname' =>  $this->request->getVar('sss_dd_cpersonname'),
            'sss_dd_cpaidon' => $this->request->getVar('sss_dd_cpaidon'),
            'sss_dd_pname' => $this->request->getVar('sss_dd_pname'),
            'sss_dd_prequiredon' => $this->request->getVar('sss_dd_prequiredon'),
            'sss_ppaidon' => $this->request->getVar('sss_ppaidon'),
            'sss_dd_royality' => $this->request->getVar('sss_dd_royality'),
            'sss_dd_royalitypaidon' => $this->request->getVar('sss_dd_royalitypaidon'),
            'sss_dd_locker' => $this->request->getVar('sss_dd_locker'),
            'sss_dd_profitamt' => $this->request->getVar('sss_dd_profitamt'),
            'sss_dd_sheetno' => $this->request->getVar('sss_dd_sheetno'),
            'sss_dd_updateby' => session('userid'),
            'sss_dd_updatedate' => date('Y-m-d')
        ];
        $isupdated = $updaterecord->update($id, $data);
        if (!empty($isupdated)) {
            echo json_encode(array("status" => true, "message" => 'Payment Details Updated'));
        } else {
            echo json_encode(array("status" => false, "message" => 'Something error while updating Payment Details'));
        }
    }

    public function delete_ddc($prid)
    {
        $PaymentReceived_m = new Dealdisbursalchart_m();
        $r = $PaymentReceived_m->delete_by_id($prid);
        echo json_encode(array("status" => TRUE, "message" => $r));
    }
}
