<?= $this->extend('commanfile/header'); ?>
<?= $this->section('content'); ?>
<form id="invoiceform" action="POST">
  <div class="card card-default">
    <div class="card-body">
      <div class="row">
        <div class="col-md-4">
          <div class="form-group">
            <label>Invoice Type</label>
            <select class="form-control select2" name="sss_inv_type" id="sss_inv_type">
              <option value="">Select Invoice Type</option>
              <?php foreach ($Saccode as $invoicetype) { ?>
                <option value="<?= $invoicetype->sss_sac_code_id ?>"><?= $invoicetype->sss_invoice_type ?></option>
              <?php } ?>
            </select>
            <span class="text-danger error-text sss_inv_type_error"></span>
          </div>
        </div>
        <div class="col-md-4">
          <div class="form-group">
            <label>Disbursement Status</label>
            <select class="form-control select2" name="sss_inv_disbursement_status" id="disbursementStatus">
              <option selected="selected">Disbursement</option>
              <option>No Disbursement</option>
            </select>
            <span class="text-danger error-text sss_inv_disbursement_status_error"></span>
          </div>
        </div>
        <!-- <div class="col-md-4">
          <div class="form-group">
            <label>Disbursement Status</label>
            <select class="form-control select2" name="financial_year" id="disbursementStatus">
              <option selected="selected">Disbursement</option>
              <option>No Disbursement</option>
            </select>
            <span class="text-danger error-text sss_inv_disbursement_status_error"></span>
          </div>
        </div> -->
      </div>
      <div class="row">
        <div class="col-md-6">
          <div class="form-group">
            <label>Bill Date</label>
            <!-- <div class="input-group date" id="billDate" data-target-input="nearest">
              <input type="text" name="sss_inv_bill_date" id="sss_inv_bill_date" class="form-control  datetimepicker-input" data-target="#billDate" />
              <div class="input-group-append" id="billDate" data-target="#billDate" data-toggle="datetimepicker">
                <div class="input-group-text" id="invdate"><i class="fa fa-calendar"></i></div>
              </div>
            </div> -->
            <input type="date" class="form-control" name="sss_inv_bill_date" min="1997-01-01" max="2030-12-31" id="sss_inv_bill_date" />
            <span class="text-danger error-text sss_inv_bill_date_error"></span>
          </div>
        </div>

        <div class="col-md-6">
          <label>Bill Number</label>
          <div class="row">
            <div class="col-md-3">
              <div class="form-group">
                <div class="input-group">
                  <input type="text" class="form-control" value="<?= $billno ?>" readonly name="sss_inv_bill_no" id="billNumber">
                </div>
              </div>
            </div><span class="slash">/</span>
            <div class="col-md-3">
              <div class="form-group">
                <div class="input-group">
                  <input type="text" class="form-control" id="billDefaultText" name="invinitial" value="<?= session('inv_initial') ?>" readonly>
                </div>
              </div>
            </div><span class="slash">/</span>
            <div class="col-md-3">
              <div class="form-group">
                <div class="input-group">
                  <input type="text" class="form-control" name="invyear" id="invyear" value="" readonly>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
      <div class="row">
        <div class="col-md-6">
          <div class="form-group">
            <label>Client Name</label>
            <select class="form-control select2" name="sss_inv_client_id" id="sss_inv_client_id">
              <option selected="selected">Select Client Name</option>
              <?php foreach ($clients as $client) { ?>
                <option value="<?= $client->sss_client_id ?>"><?= $client->sss_client_name ?></option>
              <?php } ?>
            </select>
            <span class="text-danger error-text sss_inv_client_id_error"></span>
          </div>
        </div>
        <div class="col-md-6">
          <div class="form-group">
            <label>Place of Service</label>
            <div class="input-group">
              <input type="text" class="form-control" name="placeofservice" id="placeofservice" disabled>
            </div>
          </div>
        </div>
      </div>
      <div class="row">
        <div class="col-md-6">
          <div class="form-group">
            <label>State Code</label>
            <div class="input-group">
              <input type="text" class="form-control" id="statecode" disabled>
            </div>
          </div>
        </div>
        <div class="col-md-6">
          <div class="form-group">
            <label>GSTIN Number</label>
            <div class="input-group">
              <input type="text" class="form-control" id="cxgstnumber" disabled>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
  <div class="card card-default">
    <div class="card-header">
      <h3 class="card-title">Invoice Transactions</h3>
    </div>
    <div class="card-body">
      <div class="row">
        <div class="col-md-9">
          <label>DESCRIPTION</label>
        </div>
        <div class="col-md-3">
          <label>AMOUNT</label>
        </div>
      </div>
      <div class="row">
        <div class="col-md-9">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control" id="scode" name="scode" placeholder="Property management services on a feee or a commission basis. [Real Estate Agent] SAC Code - " readonly>
              <input type="text" class="form-control" hidden id="sss_inv_desc" name="sss_inv_desc">
            </div>
          </div>
        </div>
        <div class="col-md-3">
        </div>
      </div>
      <div class="row">
        <div class="col-md-9">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control" id="sss_inv_brief" name="sss_inv_brief" placeholder="Brief Description">
            </div>
            <span class="text-danger error-text sss_inv_brief_error"></span>
          </div>
        </div>
        <div class="col-md-3">
        </div>
      </div>
      <div class="row">
        <div class="col-md-9">
          <div class="row">
            <div class="col-md-4">
              <div class="form-group">
                <div class="input-group">
                  <select class="form-control select2" name="sss_inv_duration" id="sss_inv_duration">
                    <option value="1 Month" selected="selected">1 Month</option>
                    <option value="2 Months">2 Months</option>
                    <option value="3 Months">3 Months</option>
                    <option value="4 Months">4 Months</option>
                    <option value="5 Months">5 Months</option>
                    <option value="6 Months">6 Months</option>
                    <option value="7 Months">7 Months</option>
                    <option value="8 Months">8 Months</option>
                    <option value="9 Months">9 Months</option>
                    <option value="10 Months">10 Months</option>
                    <option value="11 Months">11 Months</option>
                    <option value="12 Months">12 Months</option>
                    <option value="15 Days">15 Days</option>
                    <option value="LUMPSUM">LUMPSUM</option>
                    <option value="Others">Others</option>
                  </select>
                  <span class="text-danger error-text sss_inv_duration_error"></span>
                </div>
              </div>
            </div>
            <div class="col-md-4">
              <div class="form-group otherblock" style="display: none;">
                <div class="input-group">
                  <input type="text" class="form-control" name="sss_inv_duration_others" id="sss_inv_duration_others" placeholder="Other Duration">
                </div>
                <span class="text-danger error-text sss_inv_duration_others_error"></span>
              </div>
            </div>
          </div>
        </div>
        <div class="col-md-3">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control" name="sss_inv_amt" id="sss_inv_amt" placeholder="Amount">
            </div>
            <span class="text-danger error-text sss_inv_amt_error"></span>
          </div>
        </div>
      </div>
      <div class="row">
        <div class="col-md-9">
          <div class="row">
            <div class="col-md-4">
              <div class="form-group">
                <div class="input-group">
                  <select class="form-control select2" name="sss_inv_transaction_type" id="sss_inv_transaction_type">
                    <option selected="selected">Premise</option>
                    <option>Liasoning Charges</option>
                  </select>
                  <span class="text-danger error-text sss_inv_transaction_type_error"></span>
                </div>
              </div>
            </div>
            <div class="col-md-8">
              <div class="form-group">
                <div class="input-group">
                  <input type="text" class="form-control" name="sss_inv_addr" id="sss_inv_addr" placeholder="Invoice Address">
                </div>
                <span class="text-danger error-text sss_inv_addr_error"></span>
              </div>
            </div>
          </div>
        </div>
        <div class="col-md-3">
        </div>
      </div>
      <div class="row">
        <div class="col-md-9">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control" id="depositLabel" placeholder="Deposit" disabled>
            </div>
          </div>
        </div>
        <div class="col-md-3">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control" name="sss_inv_deposite_amt" placeholder="Deposite Amount" id="sss_inv_deposite_amt">
            </div>
            <span class="text-danger error-text sss_inv_deposite_amt_error"></span>
          </div>
        </div>
      </div>
      <div class="row">
        <div class="col-md-9">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control" name="" id="" placeholder="SGST" disabled>
            </div>
          </div>
        </div>
        <div class="col-md-3">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control" readonly name="sss_inv_sgst" placeholder="SGST" id="sss_inv_sgst">
            </div>
          </div>
        </div>
      </div>
      <div class="row">
        <div class="col-md-9">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control" readonly id="cgstLabel" placeholder="CGST" disabled>
            </div>
          </div>
        </div>
        <div class="col-md-3">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control" readonly name="sss_inv_cgst" placeholder="CGST" id="sss_inv_cgst">
            </div>
          </div>
        </div>
      </div>
      <div class="row">
        <div class="col-md-9">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control" id="igstLabel" placeholder="IGST" disabled>
            </div>
          </div>
        </div>
        <div class="col-md-3">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control" readonly name="sss_inv_igst" placeholder="IGST" id="sss_inv_igst">
            </div>
          </div>
        </div>
      </div>
      <div class="row">
        <div class="col-md-9">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control" id="invoiceAmountInWords" placeholder="Amount In Words" disabled>
            </div>
          </div>
        </div>
        <div class="col-md-3">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control" id="sss_inv_total_amt" name="sss_inv_total_amt" placeholder="Total Amount" readonly>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
  <div class="card card-default">
    <div class="card-header">
      <h3 class="card-title">RTGS Details</h3>
    </div>
    <div class="card-body">
      <div class="row">
        <div class="col-md-6">
          <div class="form-group">
            <label>Bank Name</label>
            <div class="input-group">
              <select class="form-control select2" name="sss_inv_bankid" id="sss_inv_bankid">
                <option selected="selected">Select Bank</option>
                <?php foreach ($bankdetails as $bank) { ?>
                  <option value="<?= $bank->sss_ent_bank_id ?>"><?= $bank->sss_ent_bank_name ?></option>
                <?php } ?>
              </select>
              <span class="text-danger error-text sss_inv_bankid_error"></span>
            </div>
          </div>
        </div>
        <div class="col-md-6">
          <div class="form-group">
            <label>Account Name</label>
            <div class="input-group">
              <input type="text" class="form-control" id="bankname" readonly>
            </div>
          </div>
        </div>
      </div>
      <div class="row">
        <div class="col-md-6">
          <div class="form-group">
            <label>Account Number</label>
            <div class="input-group">
              <input type="text" class="form-control" id="accno" disabled>
            </div>
          </div>
        </div>
        <div class="col-md-6">
          <div class="form-group">
            <label>IFSC Code</label>
            <div class="input-group">
              <input type="text" class="form-control" id="ifsccode" disabled>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
  <div class="card card-default">
    <div class="card-header">
      <h3 class="card-title">Entity Details</h3>
    </div>
    <div class="card-body">
      <div class="row">
        <div class="col-md-6">
          <div class="form-group">
            <label>GST Number</label>
            <div class="input-group">
              <input type="text" class="form-control" id="entityGSTNumber" value="<?= session('gstno') ?>" disabled>
            </div>
          </div>
        </div>
        <div class="col-md-6">
          <div class="form-group">
            <label>PAN Number</label>
            <div class="input-group">
              <input type="text" class="form-control" id="entityPAN" value="<?= session('panno') ?>" disabled>
            </div>
          </div>
        </div>
      </div>
      <div class="row">
        <div class="col-md-6">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control" id="uadhar" value="<?= session('uadhar') ?>" placeholder="" disabled>
            </div>
          </div>
        </div>
        <div class="col-md-6">
          <div class="form-group">
            <div class="input-group">
              <input type="text" class="form-control" id="forStatementEntity" value="<?= session('ent_name') ?>" placeholder="For Sure Shot Suggestions India Private Limited" disabled>
            </div>
          </div>
        </div>
      </div>
      <div class="row">
        <div class="col-md-12">
          <button type="button" class="btn btn-secondary float-left">Cancel</button>
          <button type="button" onclick="save_invoice()" class="btn btn-warning float-left" style="margin-left:10px;">Submit</button>
        </div>
      </div>
    </div>
  </div>
</form>
<script>
  // $(document).ready(function() {
  //   var current_year = new Date().getFullYear()
  //   var amount_of_years = 30
  //   for (var i = 0; i < amount_of_years + 1; i++) {
  //     var year = (current_year - i).toString();
  //     var element = '<option value="' + year + '">' + year + '</option>';
  //     $('select[name="financial_year"]').append(element)
  //   }
  // })
  $(document).ready(function() {
    $('#sss_inv_bill_date').on('change', function() {
      bdate = $(this).val();
      var date = new Date(bdate);
      var str = date.getMonth() + 1;
      if ((date.getMonth() + 1) <= 3) {
        fiscalyear = (date.getFullYear() - 1) + "-" + date.getFullYear();
        $('#invyear').val(fiscalyear);
      } else {
        fiscalyear = bdate.getFullYear() + "-" + (bdate.getFullYear() + 1)
        $('#invyear').val(fiscalyear);
      }
    });
    $('#sss_inv_type').on('change', function() {
      let sid = this.value;
      let url = "<?= base_url() ?>/getsaccode/" + sid;
      $.ajax({
        url: url,
        type: "GET",
        dataType: "JSON",
        success: function(data) {
          let desc = document.getElementById("scode").placeholder = "Property management services on a feee or a commission basis. [Real Estate Agent] SAC Code - " + data.sss_sac_code;
          $('#sss_inv_desc').val(desc)
        },

      });
    });

    $('#sss_inv_client_id').on('change', function() {
      let sss_inv_client_id = this.value;
      let url = "<?= base_url() ?>/getcx/" + sss_inv_client_id;
      $.ajax({
        url: url,
        type: "GET",
        dataType: "JSON",
        success: function(data) {
          $('#placeofservice').val(data.sss_client_placeofservice);
          $('#statecode').val(data.sss_client_statecode);
          $('#cxgstnumber').val(data.sss_client_gstno);
        },

      });
    });

    $('#sss_inv_bankid').on('change', function() {

      let sss_inv_bankid = this.value;
      let url = "<?= base_url() ?>/getbank/" + sss_inv_bankid;
      $.ajax({
        url: url,
        type: "GET",
        dataType: "JSON",
        success: function(data) {
          $('#bankname').val(data.sss_ent_bank_acc_name);
          $('#accno').val(data.sss_ent_bank_acc_no);
          $('#ifsccode').val(data.sss_ent_bank_acc_ifsc);
        },
      });
    });

    $('#sss_inv_duration').on('change', function() {
      if (this.value == "Others") {
        $('#sss_inv_duration_others').attr('required', false);
        $('.otherblock').css('display', 'block');
      } else {
        $('#sss_inv_duration_others').attr('required', true);
        $('.otherblock').css('display', 'none');
        $('#sss_inv_duration_others').val('');
      }
    });

    $('[name="sss_inv_amt"]').on('change', function() {
      let placeofservice = $('[name="placeofservice"]').val();
      let amount = $(this).val();
      let depositeamount = $('[name="sss_inv_deposite_amt"]').val();
      let cgst = Number(amount * 9) / 100;
      let sgst = Number(amount * 9) / 100;
      let igst = Number(amount * 18) / 100;
      // if (placeofservice != "Maharashtra") {
      //   $('[name="sss_inv_cgst"]').val();
      //   $('[name="sss_inv_sgst"]').val();
      //   $('[name="sss_inv_igst"]').val(igst);
      // } else {
      //   $('[name="sss_inv_cgst"]').val(cgst);
      //   $('[name="sss_inv_sgst"]').val(sgst);
      //   $('[name="sss_inv_igst"]').val();
      // }
    });

    $('[name="sss_inv_deposite_amt"]').on('change', function() {
      let amount = $('[name="sss_inv_amt"]').val();
      let depositeamount = $(this).val();
      let totalamount = Number(amount) + Number(depositeamount);
      var place = $('#placeofservice').val();
      if (place !== "Maharashtra" || place == "") {
        let igst = Number(totalamount * 18) / 100;
        $('[name="sss_inv_cgst"]').val();
        $('[name="sss_inv_sgst"]').val();
        $('[name="sss_inv_igst"]').val(igst);
        let finalamount = parseInt(totalamount) + parseInt(igst);
        $('[name="sss_inv_total_amt"]').val(finalamount);
        let result = numberToWords(finalamount);
        result = result.toLowerCase().replace(/\b[a-z]/g, function(letter) {
          return letter.toUpperCase();
        });
        $('#invoiceAmountInWords').val(result);
      } else {
        let cgst = Number(totalamount * 9) / 100;
        let sgst = Number(totalamount * 9) / 100;
        $('[name="sss_inv_cgst"]').val(cgst);
        $('[name="sss_inv_sgst"]').val(sgst);
        $('[name="sss_inv_igst"]').val();
        let finalamount = parseInt(totalamount) + parseInt(cgst) + parseInt(sgst);
        $('[name="sss_inv_total_amt"]').val(finalamount);
        let result = numberToWords(finalamount);
        result = result.toLowerCase().replace(/\b[a-z]/g, function(letter) {
          return letter.toUpperCase();
        });
        $('#invoiceAmountInWords').val(result);
      }
    });
  });

  function save_invoice() {
    $('#btnSave').text('saving info...'); //change button text
    $('#btnSave').attr('disabled', true); //set button disable 
    var url = "<?= base_url() ?>/saveinvoice";
    var formData = new FormData($('#invoiceform')[0]);
    $.ajax({
      url: url,
      type: "post",
      data: formData,
      contentType: false,
      processData: false,
      dataType: "JSON",
      success: function(data) {
        if (data.status == true) //if success close modal and reload ajax table
        {
          Swal.fire(
            data.message
          )
          $('#invoiceform')[0].reset();
          form.ajax.reload(null, false); //reload datatable ajax 
        } else {
          $.each(data.error, function(prefix, val) {
            $(`span.${prefix}_error`).text(val)
            // $('#addbankform').find(`span.${prefix}_error`).text(val);
            // $(saccode_data).find('span.' +prefix+ '_error').text(val);
          });
        }
        $('#btnSave').text('save'); //change button text
        $('#btnSave').attr('disabled', false); //set button enable 
      }
    });
  }

  function numberToWords(number) {
    var digit = ['zero', 'one', 'two', 'three', 'four', 'five', 'six', 'seven', 'eight', 'nine'];
    var elevenSeries = ['ten', 'eleven', 'twelve', 'thirteen', 'fourteen', 'fifteen', 'sixteen', 'seventeen', 'eighteen', 'nineteen'];
    var countingByTens = ['twenty', 'thirty', 'forty', 'fifty', 'sixty', 'seventy', 'eighty', 'ninety'];
    var shortScale = ['', 'thousand', 'million', 'billion', 'trillion'];

    number = number.toString();
    number = number.replace(/[\, ]/g, '');
    if (number != parseFloat(number)) return 'not a number';
    var x = number.indexOf('.');
    if (x == -1) x = number.length;
    if (x > 15) return 'too big';
    var n = number.split('');
    var str = '';
    var sk = 0;
    for (var i = 0; i < x; i++) {
      if ((x - i) % 3 == 2) {
        if (n[i] == '1') {
          str += elevenSeries[Number(n[i + 1])] + ' ';
          i++;
          sk = 1;
        } else if (n[i] != 0) {
          str += countingByTens[n[i] - 2] + ' ';
          sk = 1;
        }
      } else if (n[i] != 0) {
        str += digit[n[i]] + ' ';
        if ((x - i) % 3 == 0) str += 'hundred ';
        sk = 1;
      }
      if ((x - i) % 3 == 1) {
        if (sk) str += shortScale[(x - i - 1) / 3] + ' ';
        sk = 0;
      }
    }
    if (x != number.length) {
      var y = number.length;
      str += 'point ';
      for (var i = x + 1; i < y; i++) str += digit[n[i]] + ' ';
    }
    str = str.replace(/\number+/g, ' ');
    return str.trim() + ".";

  }
</script>
<?= $this->endSection(); ?>