<?= $this->extend('commanfile/header'); ?>
<?= $this->section('content'); ?>
<div class="row">
    <div class="col-md-12">
        <div class="card">
            <div class="card-header">
                <!-- <h3 class="card-title">Entites</h3> -->
                <a href="javascript:void(0)" class="btn btn-md btn-primary" onclick="entity()">
                    Add Entity Here!
                </a>
            </div>
            <!-- /.card-header -->
            <div class="card-body">
                <table id="entity-data-table" class="table table-bordered table-striped">
                    <thead>
                        <tr>
                            <th>Entity Name</th>
                            <th>GST Number</th>
                            <th>PAN Number</th>
                            <th>Status</th>
                            <th>Action</th>
                        </tr>
                    </thead>
                    <tbody>
                        <!-- <tr>
                            <td>00001-IPL-2022/23</td>
                            <td>31-12-2022</td>
                            <td>ABC Industries</td>
                            <td>150000</td>
                            <td>150000</td>
                            <td><a href="/CreateClient">Edit</a></td>
                        </tr> -->
                    </tbody>
                    <tfoot>
                        <tr>
                            <th>Entity Name</th>
                            <th>GST Number</th>
                            <th>PAN</th>
                            <th>Status</th>
                            <th>Action</th>
                        </tr>
                    </tfoot>
                </table>
            </div>
            <!-- /.card-body -->
        </div>
    </div>
</div>
<!-- form modal -->
<div class="modal fade" id="AddEntity">
    <div class="modal-dialog modal-lg">
        <div class="modal-content">
            <div class="modal-header">
                <h4 class="modal-title">Add Entity Details Here</h4>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                <form id="entitiesform" method="POST">
                    <div class="row">
                        <input type="text" name="sss_ent_id" hidden>
                        <div class="col-md-6">
                            <label>Entity Name</label>
                            <div class="form-group">
                                <div class="input-group">
                                    <input type="text" class="form-control" name="sss_ent_name" id="sss_ent_name" placeholder="Enter Entity Name">
                                </div>
                                <span class="text-danger error-text sss_ent_name_error"></span>
                            </div>
                        </div>
                        <div class="col-md-6">
                            <label>Invoice Initial</label>
                            <div class="form-group">
                                <div class="input-group">
                                    <input type="text" class="form-control" name="sss_ent_inv_initial" id="sss_ent_inv_initial" placeholder="Enter invoice initial which you want">
                                </div>
                                <span class="text-danger error-text sss_ent_inv_initial_error"></span>
                            </div>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-md-6">
                            <label>GST Number</label>
                            <div class="input-group">
                                <input type="text" class="form-control" name="sss_ent_gst_no" id="sss_ent_gst_no" placeholder="Enter GST No.">
                            </div>
                            <span class="text-danger error-text sss_ent_gst_no_error"></span>
                        </div>
                        <div class="col-md-6">
                            <label>PANCARD Number</label>
                            <div class="form-group">
                                <div class="input-group">
                                    <input type="text" class="form-control" name="sss_ent_pan_no" id="sss_ent_pan_no" placeholder="Enter PAN No.">
                                </div>
                                <span class="text-danger error-text sss_ent_pan_no_error"></span>
                            </div>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-md-6">
                            <label>Email Id</label>
                            <div class="form-group">
                                <div class="input-group">
                                    <input type="email" class="form-control" name="sss_ent_email" id="sss_ent_email" placeholder="Enter email id">
                                </div>
                                <span class="text-danger error-text sss_ent_email_error"></span>
                            </div>
                        </div>
                        <div class="col-md-6">
                            <label>Udyam Adhar</label>
                            <div class="form-group">
                                <div class="input-group">
                                    <input type="email" class="form-control" name="sss_ent_uadhar" id="sss_ent_uadhar" placeholder="Enter Udyam Adhar No">
                                </div>
                                <span class="text-danger error-text"></span>
                            </div>
                        </div>
                    </div>
                </form>
            </div>
            <div class="modal-footer justify-content-right">
                <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                <button type="button" onclick="save_entity()" class="btn btn-primary">Save changes</button>
            </div>
        </div>
    </div>
</div>
<!-- form modal end -->
<script>
    var save_method;
    // sac code operations ...

    $(document).ready(function() {
        entitytable = $('#entity-data-table').DataTable({
            "processing": true, //Feature control the processing indicator.
            "serverSide": true, //Feature control DataTables' server-side processing mode.
            "order": [], //Initial no order.
            "ordering": true,
            "searching": true,
            "responsive": true,
            "lengthChange": false,
            // Load data for the table's content from an Ajax source
            "ajax": {
                "url": "<?php echo base_url() ?>/getAllentity",
            },
            //Set column definition initialisation properties.
            "columnDefs": [{
                "targets": [-1], //last column
                "orderable": false, //set not orderable
            }, ],
        });
    });

    function entity() {
        save_method = 'add';
        $('.form-group').removeClass('has-error'); // clear error class
        $('.help-block').empty(); // clear error string
        $('#AddEntity').modal('show'); // show bootstrap modal
    }

    function edit_entity(ent_id) {
        save_method = 'update';
        var link = "<?php echo base_url() ?>/editent/" + ent_id;
        //Ajax Load data from ajax
        $.ajax({
            url: link,
            type: "GET",
            dataType: "JSON",
            success: function(data) {
                console.log(data);
                $('[name="sss_ent_id"]').val(data.sss_ent_id);
                $('[name="sss_ent_name"]').val(data.sss_ent_name);
                $('[name="sss_ent_inv_initial"]').val(data.sss_ent_inv_initial);
                $('[name="sss_ent_gst_no"]').val(data.sss_ent_gst_no);
                $('[name="sss_ent_pan_no"]').val(data.sss_ent_pan_no);
                $('[name="sss_ent_email"]').val(data.sss_ent_email);
                $('[name="sss_ent_uadhar"]').val(data.sss_ent_uadhar);
                $('#AddEntity').modal('show'); // show bootstrap modal when complete loaded
                $('.modal-title').text('Edit Entity'); // Set title to Bootstrap modal title
            },
            error: function(jqXHR, textStatus, errorThrown) {
                alert(errorThrown);
            }
        });
    }

    function save_entity() {
        $('#btnSave').text('saving info...'); //change button text
        $('#btnSave').attr('disabled', true); //set button disable 
        var url;
        if (save_method == 'add') {
            url = "<?= base_url() ?>/insertentity";
        } else {
            url = "<?php echo base_url() ?>/updateentity";
        }
        var EntityForm = new FormData($('#entitiesform')[0]);
        $.ajax({
            url: url,
            type: "POST",
            data: EntityForm,
            contentType: false,
            processData: false,
            dataType: "JSON",
            success: function(data) {
                if (data.status == true) //if success close modal and reload ajax table
                {
                    Swal.fire(
                        data.message
                    )
                    $('#AddEntity').modal('hide');
                    $('#entitiesform')[0].reset();
                    entitytable.ajax.reload(null, false); //reload datatable ajax 
                } else {
                    $.each(data.error, function(prefix, val) {
                        // $('[name="' + prefix + '"]').next().text(val);
                        $(`span.${prefix}_error`).text(val)
                        // $('#entitiesform').find(`span.${prefix}_error`).text(val);
                        // $(saccode_data).find('span.' +prefix+ '_error').text(val);
                    });
                }
                $('#btnSave').text('save'); //change button text
                $('#btnSave').attr('disabled', false); //set button enable 
            }
        });
    }
    // delete funtion....
    function delete_entity(id) {
        Swal.fire({
            title: 'Are you sure?',
            text: "You won't be able to revert this!",
            icon: 'warning',
            showCancelButton: true,
            confirmButtonColor: '#3085d6',
            cancelButtonColor: '#d33',
            confirmButtonText: 'Yes, delete it!'
        }).then((result) => {
            if (result.isConfirmed) {
                $.ajax({
                    url: "<?php echo base_url() ?>/deleteentity/" + id,
                    type: "GET",
                    dataType: "JSON",
                    success: function(data) {
                        if (data.status == true) {
                            Swal.fire(
                                'Deleted!',
                                'Your file has been deleted.',
                                'success'
                            )
                            entitytable.ajax.reload(null, false); //reload datatable ajax 
                        }
                    },
                    error: function(jqXHR, textStatus, errorThrown) {
                        alert(errorThrown);
                    }
                });
            }
        })
    }

    $(document).on('click', '.status_checks', function() {
        var sss_ent_status = ($(this).hasClass("btn-success")) ? '0' : '1';
        var msg = (sss_ent_status == '0') ? 'Inactive' : 'Active';
        Swal.fire({
            title: 'Are you sure to ' + msg + ' the record ?',
            icon: 'warning',
            showCancelButton: true,
            confirmButtonColor: '#3085d6',
            cancelButtonColor: '#d33',
            confirmButtonText: 'Yes, ' + msg + ' it!',
        }).then((result) => {
            if (result.value) {
                var current_element = $(this);
                var id = $(current_element).attr('data');
                var myurl = "<?php echo base_url() ?>/updatedentstatus/";
                $.ajax({
                    type: "GET",
                    url: myurl,
                    data: {
                        "sss_ent_id": id,
                        "sss_ent_status": sss_ent_status
                    },
                    success: function(data) {
                        Swal.fire({
                            icon: 'success',
                            title: 'Record ' + msg + ' Successfully..!',
                            showConfirmButton: true,
                            cancelButtonColor: '#d33',
                        });
                        entitytable.ajax.reload(null, false); //reload datatable ajax 
                    }
                });
            } else if (result.dismiss == 'cancel') {
                reload_table()
                // function when cancel button is clicked
            }
        });

    });
</script>
<?= $this->endSection(); ?>