<?= $this->extend('commanfile/header'); ?>
<?= $this->section('content'); ?>
<div class="row">
    <div class="col-md-12">
        <div class="card">
            <div class="card-header">
                <!-- <h3 class="card-title">Bank Details</h3> -->
                <a href="javascript:void(0)" class="btn btn-md btn-primary" onclick="add_vendors()">
                    Add Vendors !
                </a>
            </div>
            <!-- /.card-header -->
            <div class="card-body">
                <table id="Addvendors-data-table" class="table table-bordered table-striped">
                    <thead>
                        <tr>
                            <th></th>
                            <th>Vendor Name</th>
                            <th>PAN No</th>
                            <th>Status</th>
                            <th>Action</th>
                        </tr>
                    </thead>
                    <tbody>
                    </tbody>
                    <tfoot>
                        <tr>
                            <th></th>
                            <th>Vendor Name</th>
                            <th>PAN No</th>
                            <th>Status</th>
                            <th>Action</th>
                        </tr>
                    </tfoot>
                </table>
            </div>
            <!-- /.card-body -->
        </div>
    </div>
</div>
<div class="modal fade" id="Addvendors">
    <div class="modal-dialog modal-lg">
        <div class="modal-content">
            <div class="modal-header">
                <h4 class="modal-title">Add Vendor Here</h4>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                <form id="vendorform" method="POST">
                    <input type="text" name="sss_vendor_id" hidden>
                    <div class="row">
                        <div class="col-md-6">
                            <label>Vendor Name</label>
                            <div class="form-group">
                                <div class="input-group">
                                    <div class="input-group">
                                        <input type="text" class="form-control" name="sss_vendor_name" id="sss_vendor_name" placeholder="Enter Vendor Name">
                                    </div>
                                </div>
                                <span class="text-danger error-text sss_vendor_name_error"></span>
                            </div>
                        </div>
                        <div class="col-md-6">
                            <label>PAN No.</label>
                            <div class="form-group">
                                <div class="input-group">
                                    <input type="text" class="form-control" name="sss_vendor_panno" id="sss_vendor_panno" placeholder="Enter PAN No">
                                </div>
                                <span class="text-danger error-text sss_vendor_panno_error"></span>
                            </div>
                        </div>
                    </div>

            </div>
            <div class="modal-footer justify-content-right">
                <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                <button type="button" onclick="save_vendors()" class="btn btn-primary">Save changes</button>
            </div>
            </form>
        </div>
    </div>
</div>
<script>
    var save_method;
    // sac code operations ...
    $(document).ready(function() {
        table = $('#Addvendors-data-table').DataTable({
            "processing": true, //Feature control the processing indicator.
            "serverSide": true, //Feature control DataTables' server-side processing mode.
            "order": [], //Initial no order.
            "ordering": true,
            "searching": true,
            "responsive": true,
            "lengthChange": false,
            // Load data for the table's content from an Ajax source
            "ajax": {
                "url": "<?php echo base_url() ?>/get_vendor",
            },
            //Set column definition initialisation properties.
            "columnDefs": [{
                "targets": [-1], //last column
                "orderable": false, //set not orderable
            }, ],
        });
    });

    function add_vendors() {
        save_method = 'add';
        $('.form-group').removeClass('has-error'); // clear error class
        $('.help-block').empty(); // clear error string
        $('#Addvendors').modal('show'); // show bootstrap modal
    }

    function edit_vendor(vendor_id) {
        save_method = 'update';
        var link = "<?php echo base_url() ?>/editvendorrecord/" + vendor_id;
        //Ajax Load data from ajax
        $.ajax({
            url: link,
            type: "GET",
            dataType: "JSON",
            success: function(data) {
                $('[name="sss_vendor_id"]').val(data.sss_vendor_id);
                $('[name="sss_vendor_name"]').val(data.sss_vendor_name);
                $('[name="sss_vendor_panno"]').val(data.sss_vendor_panno);
                $('#Addvendors').modal('show'); // show bootstrap modal when complete loaded
                $('.modal-title').text('Edit Vendor Information'); // Set title to Bootstrap modal title
            },
            error: function(jqXHR, textStatus, errorThrown) {
                alert(errorThrown);
            }
        });
    }

    function save_vendors() {
        $('#btnSave').text('saving info...'); //change button text
        $('#btnSave').attr('disabled', true); //set button disable 
        var url;
        if (save_method == 'add') {
            url = "<?= base_url() ?>/insertvendor";
        } else {
            url = "<?php echo base_url() ?>/updatevendor";
        }
        var formData = new FormData($('#vendorform')[0]);
        $.ajax({
            url: url,
            type: "POST",
            data: formData,
            contentType: false,
            processData: false,
            dataType: "JSON",
            success: function(data) {
                if (data.status == true) //if success close modal and reload ajax table
                {
                    Swal.fire(
                        data.message
                    )
                    $('#Addvendors').modal('hide');
                    $('#vendorform')[0].reset();
                    location.reload();
                } else {
                    $.each(data.error, function(prefix, val) {
                        $('#vendorform').find(`span.${prefix}_error`).text(val);
                    });
                }
                $('#btnSave').text('save'); //change button text
                $('#btnSave').attr('disabled', false); //set button enable 
            }
        });
    }
    // delete funtion....
    function delete_vendor(id) {
        Swal.fire({
            title: 'Are you sure?',
            text: "You won't be able to revert this!",
            icon: 'warning',
            showCancelButton: true,
            confirmButtonColor: '#3085d6',
            cancelButtonColor: '#d33',
            confirmButtonText: 'Yes, delete it!'
        }).then((result) => {
            if (result.isConfirmed) {
                $.ajax({
                    url: "<?php echo base_url() ?>/deletevendorrecord/" + id,
                    type: "GET",
                    dataType: "JSON",
                    success: function(data) {
                        if (data.status == true) {
                            Swal.fire(
                                'Deleted!',
                                'Your file has been deleted.',
                                'success'
                            )
                            location.reload();
                        }
                    },
                    error: function(jqXHR, textStatus, errorThrown) {
                        alert(errorThrown);
                    }
                });
            }
        })
    }

    $(document).on('click', '.status_checks', function() {
        var status = ($(this).hasClass("btn-success")) ? '0' : '1';
        var msg = (status == '0') ? 'Inactive' : 'Active';
        Swal.fire({
            title: 'Are you sure to ' + msg + ' the record ?',
            icon: 'warning',
            showCancelButton: true,
            confirmButtonColor: '#3085d6',
            cancelButtonColor: '#d33',
            confirmButtonText: 'Yes, ' + msg + ' it!',
        }).then((result) => {
            if (result.value) {
                var current_element = $(this);
                var id = $(current_element).attr('data');
                var myurl = "<?php echo base_url() ?>/updatedvendorstatus/";
                $.ajax({
                    type: "GET",
                    url: myurl,
                    data: {
                        "id": id,
                        "sss_vendor_status": status
                    },
                    success: function(data) {
                        Swal.fire({
                            icon: 'success',
                            title: 'Record ' + msg + ' Successfully..!',
                            showConfirmButton: true,
                            cancelButtonColor: '#d33',
                        });
                        location.reload();
                    }
                });
            } else if (result.dismiss == 'cancel') {
                reload_table()
                // function when cancel button is clicked
            }
        });
    });
</script>
<?= $this->endSection(); ?>