<?= $this->extend('commanfile/header'); ?>
<?= $this->section('content'); ?>
<form id="invoiceform" action="POST">
    <input type="text" name="sss_inv_id" hidden value="<?= $editinvoice->sss_inv_id ?>">
    <div class="card card-default">
        <div class="card-body">
            <div class="row">
                <div class="col-md-4">
                    <div class="form-group">
                        <label>Invoice Type</label>
                        <select class="form-control select2" name="sss_inv_type" id="sss_inv_type">
                            <option value="">Select Invoice Type</option>
                            <?php foreach ($Saccode as $invoicetype) { ?>
                                <option value="<?= $invoicetype->sss_sac_code_id ?>" <?php if ($invoicetype->sss_sac_code_id == $editinvoice->sss_inv_type) echo 'selected="selected"'; ?>><?= $invoicetype->sss_invoice_type ?></option>
                            <?php } ?>
                        </select>
                        <span class="text-danger error-text sss_inv_type_error"></span>
                    </div>
                </div>
                <div class="col-md-4">
                    <div class="form-group">
                        <label>Disbursement Status</label>
                        <select class="form-control select2" name="sss_inv_disbursement_status" id="disbursementStatus">
                            <option value="<?= $editinvoice->sss_inv_disbursement_status ?>" <?php if ($editinvoice->sss_inv_disbursement_status) echo 'selected="selected"'; ?>">Disbursement</option>
                            <option value="<?= $editinvoice->sss_inv_disbursement_status ?>" <?php if ($editinvoice->sss_inv_disbursement_status) echo 'selected="selected"'; ?>">No Disbursement</option>
                        </select>
                        <span class="text-danger error-text sss_inv_disbursement_status_error"></span>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-md-6">
                    <div class="form-group">
                        <label>Bill Date</label>
                        <input type="date" class="form-control" name="sss_inv_bill_date" value="<?= $editinvoice->sss_inv_bill_date ?>" min="1997-01-01" max="2030-12-31" id="sss_inv_bill_date" />
                        <span class="text-danger error-text sss_inv_bill_date_error"></span>
                    </div>
                </div>
                <div class="col-md-6">
                    <label>Bill Number</label>
                    <div class="row">
                        <div class="col-md-3">
                            <div class="form-group">
                                <div class="input-group">
                                    <input type="text" class="form-control" value="<?= $billno ?>" readonly name="sss_inv_bill_no" id="billNumber">
                                </div>
                            </div>
                        </div><span class="slash">/</span>
                        <div class="col-md-3">
                            <div class="form-group">
                                <div class="input-group">
                                    <input type="text" class="form-control" id="billDefaultText" value="<?= $initial ?>" name="invinitial" value="<?= session('inv_initial') ?>" readonly>
                                </div>
                            </div>
                        </div><span class="slash">/</span>
                        <div class="col-md-3">
                            <div class="form-group">
                                <div class="input-group">
                                    <input type="text" class="form-control invyear" name="invyear" value="<?= $year ?>" readonly>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-md-6">
                    <div class="form-group">
                        <label>Client Name</label>
                        <select class="form-control select2" name="sss_inv_client_id" id="sss_inv_client_id">
                            <option selected="selected">Select Client Name</option>
                            <?php foreach ($clients as $client) { ?>
                                <option value="<?= $client->sss_client_id ?>" <?php if ($client->sss_client_id == $editinvoice->sss_inv_client_id) echo 'selected="selected"'; ?>><?= $client->sss_client_name ?></option>
                            <?php } ?>
                        </select>
                        <span class="text-danger error-text sss_inv_client_id_error"></span>
                    </div>
                </div>
                <div class="col-md-6">
                    <div class="form-group">
                        <label>Place of Service</label>
                        <div class="input-group">
                            <input type="text" class="form-control" name="placeofservice" id="placeofservice" disabled>
                        </div>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-md-6">
                    <div class="form-group">
                        <label>State Code</label>
                        <div class="input-group">
                            <input type="text" class="form-control" id="statecode" disabled>
                        </div>
                    </div>
                </div>
                <div class="col-md-6">
                    <div class="form-group">
                        <label>GSTIN Number</label>
                        <div class="input-group">
                            <input type="text" class="form-control" id="cxgstnumber" disabled>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <div class="card card-default">
        <div class="card-header">
            <h3 class="card-title">Invoice Transactions</h3>
        </div>
        <div class="card-body">
            <div class="row">
                <div class="col-md-9">
                    <label>DESCRIPTION</label>
                </div>
                <div class="col-md-3">
                    <label>AMOUNT</label>
                </div>
            </div>
            <div class="row">
                <div class="col-md-9">
                    <div class="form-group">
                        <div class="input-group">
                            <input type="text" class="form-control" hidden id="sss_inv_desc" name="sss_inv_desc">
                            <input type="text" class="form-control" id="scode" name="scode" placeholder="Property management services on a feee or a commission basis. [Real Estate Agent] SAC Code - " disabled>
                        </div>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-md-9">
                    <div class="form-group">
                        <div class="input-group">
                            <input type="text" class="form-control" id="sss_inv_brief" name="sss_inv_brief" value="<?= $editinvoice->sss_inv_brief ?>" placeholder="Brief Description">
                        </div>
                        <span class="text-danger error-text sss_inv_brief_error"></span>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-md-9">
                    <div class="row">
                        <div class="col-md-4">
                            <div class="form-group">
                                <div class="input-group">
                                    <select class="form-control select2" name="sss_inv_duration" id="sss_inv_duration">
                                        <option value="1 Months" <?php if ($editinvoice->sss_inv_duration == '1 Months') echo 'selected="selected"'; ?>>1 Month</option>
                                        <option value="2 Months" <?php if ($editinvoice->sss_inv_duration == '2 Months') echo 'selected="selected"'; ?>>2 Months</option>
                                        <option value="3 Months" <?php if ($editinvoice->sss_inv_duration == '3 Months') echo 'selected="selected"'; ?>>3 Months</option>
                                        <option value="4 Months" <?php if ($editinvoice->sss_inv_duration == '4 Months') echo 'selected="selected"'; ?>>4 Months</option>
                                        <option value="5 Months" <?php if ($editinvoice->sss_inv_duration == '5 Months') echo 'selected="selected"'; ?>>5 Months</option>
                                        <option value="6 Months" <?php if ($editinvoice->sss_inv_duration == '6 Months') echo 'selected="selected"'; ?>>6 Months</option>
                                        <option value="7 Months" <?php if ($editinvoice->sss_inv_duration == '7 Months') echo 'selected="selected"'; ?>>7 Months</option>
                                        <option value="8 Months" <?php if ($editinvoice->sss_inv_duration == '8 Months') echo 'selected="selected"'; ?>>8 Months</option>
                                        <option value="9 Months" <?php if ($editinvoice->sss_inv_duration == '9 Months') echo 'selected="selected"'; ?>>9 Months</option>
                                        <option value="10 Months" <?php if ($editinvoice->sss_inv_duration == '10 Months') echo 'selected="selected"'; ?>>10 Months</option>
                                        <option value="11 Months" <?php if ($editinvoice->sss_inv_duration == '11 Months') echo 'selected="selected"'; ?>>11 Months</option>
                                        <option value="12 Months" <?php if ($editinvoice->sss_inv_duration == '12 Months') echo 'selected="selected"'; ?>>12 Months</option>
                                        <option value="15 Days" <?php if ($editinvoice->sss_inv_duration == '15 Days') echo 'selected="selected"'; ?>>15 Days</option>
                                        <option value="LUMPSUM" <?php if ($editinvoice->sss_inv_duration == 'LUMPSUM') echo 'selected="selected"'; ?>>LUMPSUM</option>
                                        <option value="Others" <?php if ($editinvoice->sss_inv_duration == 'Others') echo 'selected="selected"'; ?>>Others</option>
                                    </select>
                                    <span class="text-danger error-text sss_inv_duration_error"></span>
                                </div>
                            </div>
                        </div>
                        <div class="col-md-4">
                            <div class="form-group otherblock" style="display: none;">
                                <div class="input-group">
                                    <input type="text" class="form-control" name="sss_inv_duration_others" id="sss_inv_duration_others" value="<?= $editinvoice->sss_inv_duration_others ?>" placeholder="Other Duration">
                                </div>
                                <span class="text-danger error-text sss_inv_duration_others_error"></span>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="col-md-3">
                    <div class="form-group">
                        <div class="input-group">
                            <input type="number" class="form-control" name="sss_inv_amt" value="<?php echo $editinvoice->sss_inv_amt; ?>" id="sss_inv_amt" placeholder="Amount">
                        </div>
                        <span class="text-danger error-text sss_inv_amt_error"></span>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-md-9">
                    <div class="row">
                        <div class="col-md-4">
                            <div class="form-group">
                                <div class="input-group">
                                    <select class="form-control select2" name="sss_inv_transaction_type" id="sss_inv_transaction_type">
                                        <option value="<?= $editinvoice->sss_inv_transaction_type ?>" <?php if ($editinvoice->sss_inv_transaction_type) echo 'selected="selected"'; ?>">Premise</option>
                                        <option value="<?= $editinvoice->sss_inv_transaction_type ?>" <?php if ($editinvoice->sss_inv_transaction_type) echo 'selected="selected"'; ?>">Liasoning Charges</option>
                                    </select>
                                    <span class="text-danger error-text sss_inv_transaction_type_error"></span>
                                </div>
                            </div>
                        </div>
                        <div class="col-md-8">
                            <div class="form-group">
                                <div class="input-group">
                                    <input type="text" class="form-control" name="sss_inv_addr" value="<?= $editinvoice->sss_inv_addr ?>" id="sss_inv_addr" placeholder="Invoice Address">
                                </div>
                                <span class="text-danger error-text sss_inv_addr_error"></span>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="col-md-3">
                </div>
            </div>
            <div class="row">
                <div class="col-md-9">
                    <div class="form-group">
                        <div class="input-group">
                            <input type="text" class="form-control" id="depositLabel" placeholder="Deposit" disabled>
                        </div>
                    </div>
                </div>
                <div class="col-md-3">
                    <div class="form-group">
                        <div class="input-group">
                            <input type="number" class="form-control" name="sss_inv_deposite_amt" value="<?= $editinvoice->sss_inv_deposite_amt ?>" placeholder="Deposite Amount" id="sss_inv_deposite_amt">
                        </div>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-md-9">
                    <div class="form-group">
                        <div class="input-group">
                            <input type="text" class="form-control" placeholder="SGST" disabled>
                        </div>
                    </div>
                </div>
                <div class="col-md-3">
                    <div class="form-group">
                        <div class="input-group">
                            <input type="text" class="form-control" readonly name="sss_inv_sgst" value="<?= $editinvoice->sss_inv_sgst ?>" placeholder="SGST" id="sss_inv_sgst">
                        </div>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-md-9">
                    <div class="form-group">
                        <div class="input-group">
                            <input type="text" class="form-control" readonly id="cgstLabel" placeholder="CGST" disabled>
                        </div>
                    </div>
                </div>
                <div class="col-md-3">
                    <div class="form-group">
                        <div class="input-group">
                            <input type="text" class="form-control" readonly name="sss_inv_cgst" value="<?= $editinvoice->sss_inv_cgst ?>" placeholder="CGST" id="sss_inv_cgst">
                        </div>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-md-9">
                    <div class="form-group">
                        <div class="input-group">
                            <input type="text" class="form-control" id="igstLabel" placeholder="IGST" disabled>
                        </div>
                    </div>
                </div>
                <div class="col-md-3">
                    <div class="form-group">
                        <div class="input-group">
                            <input type="text" class="form-control" readonly name="sss_inv_igst" placeholder="IGST" value="<?= $editinvoice->sss_inv_igst ?>" id="sss_inv_igst">
                        </div>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-md-9">
                    <div class="form-group">
                        <div class="input-group">
                            <input type="text" class="form-control" id="invoiceAmountInWords" placeholder="Amount In Words" disabled>
                        </div>
                    </div>
                </div>
                <div class="col-md-3">
                    <div class="form-group">
                        <div class="input-group">
                            <input type="text" class="form-control" id="sss_inv_total_amt" name="sss_inv_total_amt" value="<?= $editinvoice->sss_inv_total_amt ?>" placeholder="Total Amount" readonly>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="card card-default">
        <div class="card-header">
            <h3 class="card-title">RTGS Details</h3>
        </div>
        <div class="card-body">
            <div class="row">
                <div class="col-md-3">
                    <div class="form-group">
                        <label>Bank Name</label>
                        <div class="input-group">
                            <select class="form-control select2" name="sss_inv_bankid" id="sss_inv_bankid">
                                <option selected="selected">Select Bank</option>
                                <?php foreach ($bankdetails as $bank) { ?>
                                    <option value="<?= $bank->sss_ent_bank_id ?>" <?php if ($bank->sss_ent_bank_id == $editinvoice->sss_inv_bankid) echo 'selected="selected"'; ?>><?= $bank->sss_ent_bank_name ?></option>
                                <?php } ?>
                            </select>
                            <span class="text-danger error-text sss_inv_bankid_error"></span>
                        </div>
                    </div>
                </div>
                <div class="col-md-3">
                    <div class="form-group">
                        <label>Account Name</label>
                        <div class="input-group">
                            <input type="text" class="form-control" name="bank_name" id="bankname" disabled>
                        </div>
                    </div>
                </div>
                <div class="col-md-3">
                    <div class="form-group">
                        <label>Account Number</label>
                        <div class="input-group">
                            <input type="text" class="form-control" name="accno" id="accno" disabled>
                        </div>
                    </div>
                </div>
                <div class="col-md-3">
                    <div class="form-group">
                        <label>IFSC Code</label>
                        <div class="input-group">
                            <input type="text" class="form-control" name="ifsccode" id="ifsccode" disabled>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="card card-default">
        <div class="card-header">
            <h3 class="card-title">Entity Details</h3>
        </div>
        <div class="card-body">
            <div class="row">
                <div class="col-md-6">
                    <div class="form-group">
                        <label>GST Number</label>
                        <div class="input-group">
                            <input type="text" class="form-control" id="entityGSTNumber" value="<?= session('gstno') ?>" disabled>
                        </div>
                    </div>
                </div>
                <div class="col-md-6">
                    <div class="form-group">
                        <label>PAN Number</label>
                        <div class="input-group">
                            <input type="text" class="form-control" id="entityPAN" value="<?= session('panno') ?>" disabled>
                        </div>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-md-12">
                    <div class="form-group">
                        <div class="input-group">
                            <input type="text" class="form-control" id="forStatementEntity" value="<?= session('ent_name') ?>" placeholder="For Sure Shot Suggestions India Private Limited" disabled>
                        </div>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-md-12">
                    <button type="button" class="btn btn-secondary float-left">Cancel</button>
                    <button type="button" onclick="update_invoice()" class="btn btn-warning float-left" style="margin-left: 10px;">Submit</button>
                </div>
            </div>
        </div>
    </div>
</form>
<script>
    $(document).ready(function() {
        let sss_inv_client_id = $('#sss_inv_client_id').val();
        let url = "<?= base_url() ?>/getcx/" + sss_inv_client_id;
        $.ajax({
            url: url,
            type: "GET",
            dataType: "JSON",
            success: function(data) {
                $('#placeofservice').val(data.sss_client_placeofservice);
                $('#statecode').val(data.sss_client_statecode);
                $('#cxgstnumber').val(data.sss_client_gstno);
            },

        });
    });

    // bankid
    $(document).ready(function() {
        let sss_inv_bankid = $('#sss_inv_bankid').val();
        let url = "<?= base_url() ?>/getbank/" + sss_inv_bankid;
        $.ajax({
            url: url,
            type: "GET",
            dataType: "JSON",
            success: function(data) {
                $('#bankname').val(data.sss_ent_bank_acc_name);
                $('#accno').val(data.sss_ent_bank_acc_no);
                $('#ifsccode').val(data.sss_ent_bank_acc_ifsc);
            },
        });
    });


    $(document).ready(function() {
        let sid = $('#sss_inv_type').val();
        let url = "<?= base_url() ?>/getsaccode/" + sid;
        $.ajax({
            url: url,
            type: "GET",
            dataType: "JSON",
            success: function(data) {
                document.getElementById("scode").placeholder = "Property management services on a feee or a commission basis. [Real Estate Agent] SAC Code - " + data.sss_sac_code;
                $('#sss_inv_desc').val(desc)
            },
        });
    });


    $(document).ready(function() {
        let duration = $('#sss_inv_duration').val();
        if (duration == "Others") {
            $('#sss_inv_duration_others').attr('required', false);
            $('.otherblock').css('display', 'block');
        } else {
            $('#sss_inv_duration_others').attr('required', true);
            $('.otherblock').css('display', 'none');
        }
    });

    $('[name="sss_inv_amt"]').change(function() {
        
        // $('[name="sss_inv_amt"]').on('change', function() {
        let placeofservice = $('[name="placeofservice"]').val();
        
        let amount = $(this).val();
        let depositeamount = $('[name="sss_inv_deposite_amt"]').val();
        let cgst = Number(amount * 9) / 100;
        let sgst = Number(amount * 9) / 100;
        let igst = Number(amount * 18) / 100;
        if (placeofservice != "Maharashtra") {
          $('[name="sss_inv_cgst"]').val(0);
          $('[name="sss_inv_sgst"]').val(0);
          $('[name="sss_inv_igst"]').val(igst);
        } else {
          $('[name="sss_inv_cgst"]').val(cgst);
          $('[name="sss_inv_sgst"]').val(sgst);
          $('[name="sss_inv_igst"]').val();
        }
        // });
    });

    $(document).ready(function() {
        $('[name="sss_inv_bill_date"]').on('change', function() {
            bdate = $(this).val();
            var date = new Date(bdate);
            var str = date.getMonth() + 1;
            $('.invyear').val();
            if (str <= 3) {
                fiscalyear = (date.getFullYear() - 1) + "-" + date.getFullYear();
                $('.invyear').text(fiscalyear);
            } else {
                fiscalyear = bdate.getFullYear() + "-" + (bdate.getFullYear() + 1);
                $('.invyear').val(fiscalyear);
            }
        });
    });

    $('[name="sss_inv_type"]').change(function() {
        let sid = this.value;
        let url = "<?= base_url() ?>/getsaccode/" + sid;
        $.ajax({
            url: url,
            type: "GET",
            dataType: "JSON",
            success: function(data) {
                document.getElementById("scode").placeholder = "Property management services on a feee or a commission basis. [Real Estate Agent] SAC Code - " + data.sss_sac_code;
            },

        });
    });

    $('[name="sss_inv_client_id"]').change(function() {
        let sss_inv_client_id = this.value;
        let url = "<?= base_url() ?>/getcx/" + sss_inv_client_id;
        $.ajax({
            url: url,
            type: "GET",
            dataType: "JSON",
            success: function(data) {
                $('#placeofservice').val(data.sss_client_placeofservice);
                $('#statecode').val(data.sss_client_statecode);
                $('#cxgstnumber').val(data.sss_client_gstno);
            },

        });
    });

    $('[name="sss_inv_bankid"]').change(function() {
        let sss_inv_bankid = $(this).val();
        
        let url = "<?= base_url() ?>/getbank/" + sss_inv_bankid;
        $.ajax({
            url: url,
            type: "GET",
            dataType: "JSON",
            success: function(data) {
                $('#bankname').val(data.sss_ent_bank_acc_name);
                $('#accno').val(data.sss_ent_bank_acc_no);
                $('#ifsccode').val(data.sss_ent_bank_acc_ifsc);
            },
        });
    });

    $('#sss_inv_deposite_amt').on('type, change', function() {
        let amount = $('[name="sss_inv_amt"]').val();
        let depositeamount = $(this).val();
        let totalamount = Number(amount) + Number(depositeamount);
        var place = $('#placeofservice').val();

        if (place !== "Maharashtra" || place == "") {
            let igst = Number(totalamount * 18) / 100;
            $('[name="sss_inv_cgst"]').val();
            $('[name="sss_inv_sgst"]').val();
            $('[name="sss_inv_igst"]').val(igst);
            let finalamount = parseInt(totalamount) + parseInt(igst);
            $('#sss_inv_total_amt').val(finalamount);
            let result = numberToWords(finalamount);
            $('#invoiceAmountInWords').val(result);
        } else {
            let cgst = Number(totalamount * 9) / 100;
            let sgst = Number(totalamount * 9) / 100;
            $('[name="sss_inv_cgst"]').val(cgst);
            $('[name="sss_inv_sgst"]').val(sgst);
            $('[name="sss_inv_igst"]').val();
            let finalamount = parseInt(totalamount) + parseInt(cgst) + parseInt(sgst);
            $('#sss_inv_total_amt').val(finalamount);
            let result = numberToWords(finalamount);
            $('#invoiceAmountInWords').val(result);
        }
    });

    $('#sss_inv_duration').change(function() {
        let duration = $(this).val();
        if (duration == "Others") {
            $('#sss_inv_duration_others').attr('required', false);
            $('.otherblock').css('display', 'block');
        } else {
            $('#sss_inv_duration_others').attr('required', true);
            $('.otherblock').css('display', 'none');
        }
    });



    function update_invoice() {
        $('#btnSave').text('saving info...'); //change button text
        $('#btnSave').attr('disabled', true); //set button disable 
        var url = "<?= base_url() ?>/updateinvoice";
        var formData = new FormData($('#invoiceform')[0]);
        $.ajax({
            url: url,
            type: "post",
            data: formData,
            contentType: false,
            processData: false,
            dataType: "JSON",
            success: function(data) {
                if (data.status == true) //if success close modal and reload ajax table
                {
                    Swal.fire({
                        text: data.message,
                        focusConfirm: false,
                        confirmButtonText: '<a class="btn btn-primary" href="<?= base_url() ?>/invoicetable">OK</a>',
                    })
                    $('#invoiceform')[0].reset();
                } else {
                    $.each(data.error, function(prefix, val) {
                        $(`span.${prefix}_error`).text(val)
                        // $('#addbankform').find(`span.${prefix}_error`).text(val);
                        // $(saccode_data).find('span.' +prefix+ '_error').text(val);
                    });
                }
                $('#btnSave').text('save'); //change button text
                $('#btnSave').attr('disabled', false); //set button enable 
            }
        });
    }

    function numberToWords(number) {
        var digit = ['zero', 'one', 'two', 'three', 'four', 'five', 'six', 'seven', 'eight', 'nine'];
        var elevenSeries = ['ten', 'eleven', 'twelve', 'thirteen', 'fourteen', 'fifteen', 'sixteen', 'seventeen', 'eighteen', 'nineteen'];
        var countingByTens = ['twenty', 'thirty', 'forty', 'fifty', 'sixty', 'seventy', 'eighty', 'ninety'];
        var shortScale = ['', 'thousand', 'million', 'billion', 'trillion'];

        number = number.toString();
        number = number.replace(/[\, ]/g, '');
        if (number != parseFloat(number)) return 'not a number';
        var x = number.indexOf('.');
        if (x == -1) x = number.length;
        if (x > 15) return 'too big';
        var n = number.split('');
        var str = '';
        var sk = 0;
        for (var i = 0; i < x; i++) {
            if ((x - i) % 3 == 2) {
                if (n[i] == '1') {
                    str += elevenSeries[Number(n[i + 1])] + ' ';
                    i++;
                    sk = 1;
                } else if (n[i] != 0) {
                    str += countingByTens[n[i] - 2] + ' ';
                    sk = 1;
                }
            } else if (n[i] != 0) {
                str += digit[n[i]] + ' ';
                if ((x - i) % 3 == 0) str += 'hundred ';
                sk = 1;
            }
            if ((x - i) % 3 == 1) {
                if (sk) str += shortScale[(x - i - 1) / 3] + ' ';
                sk = 0;
            }
        }
        if (x != number.length) {
            var y = number.length;
            str += 'point ';
            for (var i = x + 1; i < y; i++) str += digit[n[i]] + ' ';
        }
        str = str.replace(/\number+/g, ' ');
        return str.trim() + ".";

    }
</script>
<?= $this->endSection(); ?>