<?= $this->extend('commanfile/header'); ?>
<?= $this->section('content'); ?>

<div class="row">
    <div class="col-md-12">
        <div class="card">
            <div class="card-header">
                <a href="javascript:void(0)" class="btn btn-md btn-primary" onclick="user()">
                    Add Users Here!
                </a>
            </div>
            <!-- /.card-header -->
            <div class="card-body">
                <table id="user-data-table" class="table table-bordered table-striped">
                    <thead>
                        <tr>
                            <th>Name</th>
                            <th>Entity</th>
                            <th>Role</th>
                            <th>Status</th>
                            <th>Action</th>
                        </tr>
                    </thead>
                    <tbody>
                    </tbody>
                    <tfoot>
                        <tr>
                            <th>Name</th>
                            <th>Entity</th>
                            <th>Role</th>
                            <th>Status</th>
                            <th>Action</th>
                        </tr>
                    </tfoot>
                </table>
            </div>
            <!-- /.card-body -->
        </div>
    </div>
</div>

<div class="modal fade" id="AddUser">
    <div class="modal-dialog modal-lg">
        <div class="modal-content">
            <div class="modal-header">
                <h4 class="modal-title">Add Users Here</h4>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                <form id="userform" action="POST">
                    <input type="text" name="sss_user_id" hidden>
                    <div class="row">
                        <div class="col-md-6">
                            <label>Select Entity Name :</label>
                            <div class="form-group">
                                <div class="input-group">
                                    <select class="form-control" name="ent_id" id="ent_id">
                                        <option>Select an Entity</option>
                                        <?php foreach ($entities as $ent) { ?>
                                            <option value="<?= $ent->sss_ent_id ?>"><?= $ent->sss_ent_name ?></option>
                                        <?php } ?>
                                    </select>
                                </div>
                                <span class="text-danger error-text ent_id_error"></span>
                            </div>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-md-6">
                            <label>First Name</label>
                            <div class="form-group">
                                <div class="input-group">
                                    <input type="text" class="form-control" name="sss_user_fname" id="sss_user_fname" placeholder="Enter First Name.">
                                </div>
                                <span class="text-danger error-text sss_user_fname_error"></span>
                            </div>
                        </div>
                        <div class="col-md-6">
                            <label>Last Name</label>
                            <div class="form-group">
                                <div class="input-group">
                                    <input type="text" class="form-control" name="sss_user_lname" id="sss_user_lname" placeholder="Enter Last Name.">
                                </div>
                                <span class="text-danger error-text sss_user_lname_error"></span>
                            </div>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-md-6">
                            <label>Email Id</label>
                            <div class="input-group">
                                <input type="email" class="form-control" name="sss_user_email" id="sss_user_email" placeholder="Enter Email.">
                            </div>
                            <span class="text-danger error-text sss_user_email_error"></span>
                        </div>
                        <div class="col-md-6">
                            <label>Password</label>
                            <div class="form-group">
                                <div class="input-group">
                                    <input type="text" class="form-control" name="sss_user_password" id="sss_user_password" placeholder="Enter Password.">
                                </div>
                                <span class="text-danger error-text sss_user_password_error"></span>
                            </div>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-md-3">
                            <label>Designation</label>
                            <select class="form-control" name="sss_user_designation" id="sss_user_designation">
                                <option>Select Designation</option>
                                <option value="designation1">Designation 1</option>
                                <option value="designation2">Designation 2</option>
                                <option value="designation3">Designation 3</option>
                            </select>
                            <span class="text-danger error-text sss_user_designation_error"></span>
                        </div>
                        <div class="col-md-3">
                            <label>Role</label>
                            <select class="form-control" name="sss_user_role" id="sss_user_role">
                                <option>Select Designation</option>
                                <option value="Admin">Admin</option>
                                <option value="Sale">Super Sales</option>
                            </select>
                            <span class="text-danger error-text sss_user_role_error"></span>
                        </div>
                        <div class="col-md-6">
                            <label>Mobile Number</label>
                            <div class="row">
                                <div class="col-md-2">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <input type="text" class="form-control" placeholder="+91" disabled>
                                        </div>
                                    </div>
                                </div>
                                <div class="col-md-10">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <input type="text" class="form-control" name="sss_user_mob" id="sss_user_mob" placeholder="Enter Mobile Number.">
                                        </div>
                                        <span class="text-danger error-text sss_user_mob_error"></span>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-md-9">
                            <label>Address</label>
                            <div class="input-group">
                                <textarea type="text" class="form-control" name="sss_user_addr" id="sss_user_addr" placeholder="Enter Address"></textarea>
                            </div>
                            <span class="text-danger error-text sss_user_addr_error"></span>
                        </div>
                        <div class="col-md-3">
                            <label>Pin Code</label>
                            <div class="form-group">
                                <div class="input-group">
                                    <input type="text" class="form-control" name="sss_user_pincode" id="sss_user_pincode" placeholder="Enter Pincode">
                                </div>
                                <span class="text-danger error-text sss_user_pincode_error"></span>
                            </div>
                        </div>
                    </div>
                </form>
            </div>
            <div class="modal-footer justify-content-right">
                <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                <button type="button" onclick="save_user()" class="btn btn-primary">Save changes</button>
            </div>
        </div>

    </div>
</div>

<script>
    var save_method;
    $(document).ready(function() {
        usertable = $('#user-data-table').DataTable({
            "processing": true, //Feature control the processing indicator.
            "serverSide": true, //Feature control DataTables' server-side processing mode.
            "order": [], //Initial no order.
            "ordering": true,
            "searching": true,
            "responsive": true,
            "lengthChange": false,
            // Load data for the table's content from an Ajax source
            "ajax": {
                "url": "<?php echo base_url() ?>/getAlluser",
            },
            //Set column definition initialisation properties.
            "columnDefs": [{
                "targets": [-1], //last column
                "orderable": false, //set not orderable
            }, ],
        });
    });
    function user() {
        save_method = 'add';
        $('.form-group').removeClass('has-error'); // clear error class
        $('.help-block').empty(); // clear error string
        $('#AddUser').modal('show'); // show bootstrap modal
    }

    function edit_user(user_id) {
        save_method = 'update';
        var link = "<?php echo base_url() ?>/edituser/" + user_id;
        //Ajax Load data from ajax
        $.ajax({
            url: link,
            type: "GET",
            dataType: "JSON",
            success: function(data) {
                $('[name="sss_user_id"]').val(data.sss_user_id);
                $('[name="ent_id"]').val(data.sss_ent_id);
                $('[name="sss_user_fname"]').val(data.sss_user_fname);
                $('[name="sss_user_lname"]').val(data.sss_user_lname);
                $('[name="sss_user_email"]').val(data.sss_user_email);
                $('[name="sss_user_password"]').val(data.sss_user_unencrypt_password);
                $('[name="sss_user_designation"]').val(data.sss_user_designation);
                $('[name="sss_user_mob"]').val(data.sss_user_mob);
                $('[name="sss_user_addr"]').val(data.sss_user_addr);
                $('[name="sss_user_pincode"]').val(data.sss_user_pincode);
                $('#AddUser').modal('show'); // show bootstrap modal when complete loaded
                $('.modal-title').text('Edit Bank Detail'); // Set title to Bootstrap modal title
            },
            error: function(jqXHR, textStatus, errorThrown) {
                alert(errorThrown);
            }
        });
    }

    function save_user() {
        $('#btnSave').text('saving info...'); //change button text
        $('#btnSave').attr('disabled', true); //set button disable 
        var url;
        if (save_method == 'add') {
            url = "<?= base_url() ?>/insertuser";
        } else {
            url = "<?php echo base_url() ?>/updateuser";
        }
        var formData = new FormData($('#userform')[0]);
        $.ajax({
            url: url,
            type: "POST",
            data: formData,
            contentType: false,
            processData: false,
            dataType: "JSON",
            success: function(data) {
                if (data.status == true) //if success close modal and reload ajax table
                {
                    Swal.fire(
                        data.message
                    )
                    $('#AddUser').modal('hide');
                    $('#userform')[0].reset();
                    usertable.ajax.reload(null, false); //reload datatable ajax 
                } else {
                    $.each(data.error, function(prefix, val) {
                        // $('[name="' + prefix + '"]').next().text(val);
                        $(`span.${prefix}_error`).text(val)
                        // $('#userform').find(`span.${prefix}_error`).text(val);
                        // $(saccode_data).find('span.' +prefix+ '_error').text(val);
                    });
                }
                $('#btnSave').text('save'); //change button text
                $('#btnSave').attr('disabled', false); //set button enable 
            }
        });
    }
    // delete funtion....
    function delete_user(id) {
        Swal.fire({
            title: 'Are you sure?',
            text: "You won't be able to revert this!",
            icon: 'warning',
            showCancelButton: true,
            confirmButtonColor: '#3085d6',
            cancelButtonColor: '#d33',
            confirmButtonText: 'Yes, delete it!'
        }).then((result) => {
            if (result.isConfirmed) {
                $.ajax({
                    url: "<?php echo base_url() ?>/deleteuser/" + id,
                    type: "GET",
                    dataType: "JSON",
                    success: function(data) {
                        if (data.status == true) {
                            Swal.fire(
                                'Deleted!',
                                'Your file has been deleted.',
                                'success'
                            )
                            usertable.ajax.reload(null, false); //reload datatable ajax 
                        }
                    },
                    error: function(jqXHR, textStatus, errorThrown) {
                        alert(errorThrown);
                    }
                });
            }
        })
    }

    $(document).on('click', '.status_checks', function() {
        var status = ($(this).hasClass("btn-success")) ? '0' : '1';
        var msg = (status == '0') ? 'Inactive' : 'Active';
        Swal.fire({
            title: 'Are you sure to ' + msg + ' the record ?',
            icon: 'warning',
            showCancelButton: true,
            confirmButtonColor: '#3085d6',
            cancelButtonColor: '#d33',
            confirmButtonText: 'Yes, ' + msg + ' it!',
        }).then((result) => {
            if (result.value) {
                var current_element = $(this);
                var id = $(current_element).attr('data');
                var myurl = "<?php echo base_url() ?>/updateuserstatus/";
                $.ajax({
                    type: "GET",
                    url: myurl,
                    data: {
                        "sss_user_id": id,
                        "sss_user_status": status
                    },
                    success: function(data) {
                        Swal.fire({
                            icon: 'success',
                            title: 'Record ' + msg + ' Successfully..!',
                            showConfirmButton: true,
                            cancelButtonColor: '#d33',
                        });
                        usertable.ajax.reload(null, false); //reload datatable ajax 
                    }
                });
            } else if (result.dismiss == 'cancel') {
                reload_table()
                // function when cancel button is clicked
            }
        });

    });
</script>

<?= $this->endSection(); ?>