<?php


namespace App\Controllers;

use App\Models\Employee_m;
use App\Models\Outcomes_m;
use App\Models\DDD_outcome_m;
use App\Models\DDD_emp_m;
use App\Models\Dealdetaildraft_m;
use App\Models\Dealdisbursalchart_m;
use App\Models\Bankdetails_m;
use App\Models\Bankbook_m;
use App\Models\CreateInvoice_m;
use App\Models\Paymentreceived_m;
use App\Models\Tdsentries_m;
use App\Models\Vendor_m;
use App\Models\Vendorpurpose_m;
use App\Models\MonthsBalances_m;

use \Hermawan\DataTables\DataTable;

class DealDetailsDraft extends BaseController
{
    public function index($dddId)
    {
        $data['dddId'] = $dddId;
        $getEmp = new Employee_m();
        // $data['activeEmp'] = $getEmp->table("sss_tbl_emp")->select('*')->where('sss_emp_status', 1)->orderBy('sss_emp_position', 'ASC')->get()->getResult();
        $data['activeEmp'] = $getEmp->table("sss_tbl_emp")->select('*')->where('sss_emp_share >', 0)->where('sss_emp_status', 1)->orderBy('sss_emp_position', 'ASC')->get()->getResult();

        $outcomes = new Outcomes_m();
        $data['activeOutcomes'] = $outcomes->table('sss_tbl_outcomes')->select('*')->where('sss_oc_status', 1)->get()->getResult();

        $ddc = new Dealdisbursalchart_m();
        $data['ddc'] = $ddc->table('sss_tbl_dealdisbursalchart')->select("sss_tbl_dealdisbursalchart.sss_dd_sbamt, sss_tbl_dealdisbursalchart.sss_dd_royality, sss_tbl_paymentreceived.sss_pr_id,sss_tbl_paymentreceived.sss_pr_tdsamt,sss_tbl_paymentreceived.sss_pr_balanceamt,sss_tbl_paymentreceived.sss_pr_amtreceived,sss_tbl_invoices.sss_inv_id,sss_tbl_invoices.sss_inv_bill_no,sss_tbl_invoices.sss_inv_bill_date,sss_tbl_invoices.sss_inv_amt,sss_tbl_invoices.sss_inv_sgst,sss_tbl_invoices.sss_inv_cgst,sss_tbl_invoices.sss_inv_igst,sss_tbl_invoices.sss_inv_total_amt,sss_tbl_invoices.sss_inv_client_id,sss_tbl_invoices.sss_inv_bankid,sss_tbl_client.sss_client_name")
            ->join('sss_tbl_paymentreceived', 'sss_tbl_paymentreceived.sss_pr_id = sss_tbl_dealdisbursalchart.sss_pr_id')
            ->join('sss_tbl_invoices', 'sss_tbl_invoices.sss_inv_id = sss_tbl_paymentreceived.sss_inv_id')
            ->join('sss_tbl_client', 'sss_tbl_client.sss_client_id = sss_tbl_invoices.sss_inv_client_id')
            ->where('sss_dd_id', $dddId)
            ->get()->getRow();
        // echo "<pre>";print_r($data);exit;
        // echo $data['ddc']->sss_inv_bill_no;
        $splitword = explode("/", $data['ddc']->sss_inv_bill_no);
        $y = $splitword[2];
        if ($data['ddc']->sss_inv_cgst != "0" || $data['ddc']->sss_inv_sgst != "0") {
            $totalgst = $data['ddc']->sss_inv_cgst + $data['ddc']->sss_inv_sgst;
            $data['totalgst'] = $totalgst;
        } else {
            $totalgst = $data['ddc']->sss_inv_igst;
            $data['totalgst'] = $totalgst;
        }

        $lastidd = new Dealdetaildraft_m();
        $lastid = $lastidd->table('sss_tbl_dealdetaildraft')->select("sss_ddd_id")->orderBy('sss_ddd_id', 'DESC')->get()->getRow();

        // $sh_no = ;
        if (empty($lastid)) {
            $data['shno'] = 0 + 1 . "/" . $y;
        } else {
            $data['shno'] = $lastid->sss_ddd_id + 1 . "/" . $y;
        }

        $check_ddcid = new Dealdetaildraft_m();
        $ddcid_available = $check_ddcid->table('sss_tbl_dealdetaildraft')
            ->select('sss_ddc_id')
            ->where('sss_ddc_id', $dddId)
            ->get()->getRow();

        if ($ddcid_available > 0) {
            $data['ddcid_available'] = $ddcid_available->sss_ddc_id;
        } else {
            $data['ddcid_available'] = 0;
        }


        $data['pageTitle'] = 'Deal Detail Draft';
        return view('dealDetailsDraft', $data);
    }

    public function get_ddd($dddId)
    {
        $db = db_connect();
        $builder = $db->table('sss_tbl_dealdetaildraft')->select("sss_ddd_id, sss_ddd_shno, sss_ddd_misc")
            ->where('sss_tbl_dealdetaildraft.sss_ddc_id', $dddId)->orderBy('sss_ddd_id', 'DESC');
        return DataTable::of($builder)
            ->add('action', function ($edit_dddId) {
                return '<a class="btn btn-danger btn-sm" onclick="delete_ddd(' . $edit_dddId->sss_ddd_id . ')"><i class="fa fa-trash"></i> Delete</a>';
                // return '<a class="btn btn-seccondary btn-sm" href="' . base_url() . '/editddd/' . $edit_dddId->sss_ddd_id . '"><i class="fa fa-edit"></i></a> | <a class="btn btn-damger btn-sm" onclick="delete_ddd(' . $edit_dddId->sss_ddd_id . ')"><i class="fa fa-trash"></i></a>';
                // return '<a class="btn btn-seccondary btn-sm" onclick="edit_ddd(' . $edit_dddId->sss_ddd_id . ')"><i class="fa fa-edit"></i></a> | <a class="btn btn-damger btn-sm" onclick="delete_ddd(' . $edit_dddId->sss_ddd_id . ')"><i class="fa fa-trash"></i></a>';
            }, 'last')
            ->hide('sss_ddd_id')
            ->toJson();
    }

    // public function insert_ddd()
    // {
    //     $validation = \Config\Services::validation();
    //     $this->validate([
    //         'sss_ddd_misc' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Please enter Misc. Amount',
    //             ]
    //         ],
    //         'sss_ddd_sbamt_tdsper' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Select TDS Percent',
    //             ]
    //         ],
    //         'sss_ddd_cirilroyality_tdsper' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Select TDS Percent'
    //             ]
    //         ],
    //         'sss_ddd_unknown' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Mention Required Particulars',
    //             ]
    //         ],
    //         'sss_ddd_unknownamt' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Enter Particulars Amount',
    //             ]
    //         ],
    //         'sss_ddd_outcomeroundamt.*' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Select TDS Percent',
    //             ]
    //         ],
    //         'sss_ddd_generatedate' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Please Select Date',
    //             ]
    //         ],

    //     ]);
    //     if ($validation->run() == FALSE) {
    //         $errors = $validation->getErrors();
    //         echo json_encode(['code' => 0, 'error' => $errors]);
    //     } else {
    //         unset($_POST['sss_ddd_service_fees']);
    //         unset($_POST['sss_ddd_service_gst']);
    //         unset($_POST['sss_ddd_sbbrkg']);
    //         unset($_POST['sss_ddd_cirilroyality']);
    //         unset($_POST['sss_ddd_gst']);
    //         unset($_POST['sss_ddd_miscexp']);

    //         $dddempamt = 0;
    //         $depositedddempamt = 0;
    //         $embankid = 0;
    //         $opngbalfordddempsfromsourcebank = 0;
    //         $opngbalofsourcebankfortax = 0;
    //         $totaltax = 0;
    //         $withdrawltaxamount = 0;
    //         $tax_destinationbankclsngbal = 0;
    //         $destinationbankOpngBal_tax = 0;
    //         $tax_destinationbankclsngbal = 0;
    //         $opngbalofsourcebankforadv = 0;
    //         $destinationbankOpngBal_adv = 0;
    //         $totaladv = 0;
    //         $withdrawadvbal = 0;
    //         $adv_destinationbankclsngbal = 0;
    //         $clsngempsalarybal = 0;
    //         $sourcebankopeningbal = 0;
    //         $totalempsalary = 0;

    //         // echo "<pre>";print_r($_POST);exit;

    //         $outcomeno = count($_POST['sss_ddd_oc_id']);
    //         $empno = count($_POST['sss_emp_id']);


    //         $insertrecord = new Dealdetaildraft_m();
    //         $data = [
    //             'sss_ddc_id' => $this->request->getVar('sss_ddc_id'),
    //             'sss_pr_id' => $this->request->getVar('sss_pr_id'),
    //             'sss_ddd_misc' => $this->request->getVar('sss_ddd_misc'),
    //             'sss_ddd_generatedate' => $this->request->getVar('sss_ddd_generatedate'),
    //             'sss_ddd_shno' => $this->request->getVar('sss_ddd_shno'),
    //             'sss_ddd_transmode' => $this->request->getVar('sss_ddd_transmode'),
    //             'sss_ddd_transreffno' => $this->request->getVar('sss_ddd_transreffno'),
    //             'sss_ddd_sbamt_amt' => $this->request->getVar('sss_ddd_sbamt_amt'),
    //             'sss_ddd_sbamt_tdsper' =>  $this->request->getVar('sss_ddd_sbamt_tdsper'),
    //             'sss_ddd_sbamt_tds' => $this->request->getVar('sss_ddd_sbamt_tds'),
    //             'sss_ddd_cirilroyalityamt' => $this->request->getVar('sss_ddd_cirilroyalityamt'),
    //             'sss_ddd_cirilroyality_tdsper' => $this->request->getVar('sss_ddd_cirilroyality_tdsper'),
    //             'sss_ddd_cirilroyality_tds' => $this->request->getVar('sss_ddd_cirilroyality_tds'),
    //             'sss_ddd_unknown' => $this->request->getVar('sss_ddd_unknown'),
    //             'sss_ddd_unknownamt' => $this->request->getVar('sss_ddd_unknownamt'),
    //             'sss_ddd_unknown_tdsper' => $this->request->getVar('sss_ddd_unknown_tdsper'),
    //             'sss_ddd_unknown_tds' => $this->request->getVar('sss_ddd_unknown_tds'),
    //             'sss_ddd_ourshare' => $this->request->getVar('sss_ddd_ourshare'),
    //             'sss_ddd_gst' => $this->request->getVar('sss_ddd_gst'),
    //             'sss_ddd_gst_amt' => $this->request->getVar('sss_ddd_gst_amt'),
    //             'sss_ddd_gst_rounded' => $this->request->getVar('sss_ddd_gst_rounded'),
    //             'sss_ddd_gst_total' => $this->request->getVar('sss_ddd_gst_total'),
    //             'sss_ddd_gst_tds' => $this->request->getVar('sss_ddd_gst_tds'),
    //             'sss_ddd_gst_finalamt' => $this->request->getVar('sss_ddd_gst_finalamt'),
    //             'sss_ddd_total_roundvalue' => $this->request->getVar('sss_ddd_total_roundvalue'),
    //             'sumofempRoundvalues' => $this->request->getVar('sumofempRoundvalues'),
    //             'sss_ddd_sumofroundvalue' => $this->request->getVar('sss_ddd_sumofroundvalue'),
    //             'sumoftax' => $this->request->getVar('totaltax'),
    //             'sumofAdv' => $this->request->getVar('totaladvertisment'),
    //             'sss_ddd_total_tds' => $this->request->getVar('sss_ddd_total_tds'),
    //             'sss_ddd_total_finalamt' => $this->request->getVar('sss_ddd_total_finalamt'),
    //             'sss_ddd_balanceincurrent' => $this->request->getVar('sss_ddd_balanceincurrent'),
    //             'sss_ddd_balanceincurrentinper' => $this->request->getVar('sss_ddd_balanceincurrentinper'),
    //             'sss_ddd_status' => true,
    //             'sss_ddd_createby' => session('userid'),
    //             'sss_ddd_createdate' => date('Y-m-d')
    //         ];

    //         $isDDDInserted = $insertrecord->insert($data);

    //         $lastinserted_id = $insertrecord->insertID();

    //         $insertby = session('userid');
    //         $insertdate = date('Y-m-d');

    //         $sourceb = $this->request->getVar('sourcebank');

    //         $isOutcomes = new DDD_outcome_m();

    //         for ($i = 0; $i < $outcomeno; $i++) {
    //             $outcomevalues = [
    //                 'sss_ddd_id' => $lastinserted_id,
    //                 'sss_ddd_oc_id' => $_POST['sss_ddd_oc_id'][$i],
    //                 'sss_ddd_outcomeamt' => $_POST['sss_ddd_outcomeamt'][$i],
    //                 'sss_ddd_outcomeroundamt' => $_POST['sss_ddd_outcomeroundamt'][$i],
    //                 'sss_ddd_outcometotalamt' => $_POST['sss_ddd_outcometotalamt'][$i],
    //                 'sss_dddoutcome_tds' => $_POST['sss_dddoutcome_tds'][$i],
    //                 'sss_ddd_outcomefinalamt' => $_POST['sss_ddd_outcomefinalamt'][$i],
    //                 'sss_dddoutcome_createdate' => $insertby,
    //                 'sss_dddoutcome_createdby' => $insertdate,
    //             ];
    //             // echo "<pre>";print_r($outcomevalues);
    //             $isOutcomes->insert($outcomevalues);
    //         }

    //         //create bb entries for TAX advertisment and employees..
    //         // $dateComps = date_parse(date('Y-m-d'));
    //         $dateComps = date_parse($this->request->getVar('sss_ddd_generatedate'));
    //         $year = $dateComps['year'];
    //         $month = $dateComps['month'];
    //         $sss_bb_transmonth = $month . '-' . $year;
    //         // echo $sss_bb_transmonth;exit;
    //         $isEmps = new DDD_emp_m();
    //         $emp = new Employee_m();
    //         $isBankBookEntry = new Bankbook_m();
    //         for ($i = 0; $i < $empno; $i++) {
    //             $empvalues = [
    //                 'sss_ddd_id' => $lastinserted_id,
    //                 'sss_emp_id' => $_POST['sss_emp_id'][$i],
    //                 'sss_dddemp_amt' => $_POST['sss_ddd_empamt'][$i],
    //                 'sss_dddemp_roundedamt' => $_POST['sss_ddd_emproundamt'][$i],
    //                 'sss_dddemp_totalamt' => null,
    //                 'sss_dddemp_tds' => $_POST['sss_ddd_emptdsamt'][$i],
    //                 'sss_dddemp_finalamt' => $_POST['sss_ddd_empfinalamt'][$i],
    //                 'sss_dddemp_createdby' => $insertby,
    //                 'sss_dddemp_createdate' => $insertdate,
    //             ];
    //             // echo "<pre>";print_r($empvalues);
    //             $isEmps->insert($empvalues);

    //             $getbanksemp = $emp->select('sss_emp_id,sss_emp_bankid')->where('sss_hadbank', "Yes")->where('sss_emp_id', $_POST['sss_emp_id'][$i])->get()->getRow();

    //             // if(!empty($getbanksemp))
    //             if (isset($getbanksemp->sss_emp_id) && isset($getbanksemp->sss_emp_bankid)) {
    //                 $emid =  $getbanksemp->sss_emp_id;
    //                 $embankid = $getbanksemp->sss_emp_bankid;

    //                 $isEmps = new DDD_emp_m();
    //                 $empsoutcomes = $isEmps->select('sss_emp_id,sss_dddemp_amt')->where('sss_emp_id', $emid)->orderBy('id', 'Desc')->get()->getRow();
    //                 $dddempamt = $empsoutcomes->sss_dddemp_amt;

    //                 // get source bank amout for ddd emp....
    //                 $getOpngBaldddempfromsourcebank = new Bankdetails_m();
    //                 $data['opngbalfordddemp'] = $getOpngBaldddempfromsourcebank->find($sourceb);
    //                 $opngbalfordddempsfromsourcebank = $data['opngbalfordddemp']['sss_ent_bank_acc_openingbal'];

    //                 // get ddd emp bank amount...
    //                 $getOpngBaldddemp = new Bankdetails_m();
    //                 $data['opngbalfordddemp'] = $getOpngBaldddemp->find($embankid);
    //                 $opngbalfordddempsfromsempbank = $data['opngbalfordddemp']['sss_ent_bank_acc_openingbal'];

    //                 // deposite ddd emp amount...

    //                 $depositedddempamt = $opngbalfordddempsfromsempbank + $dddempamt;  // deposite balance to destination bank...
    //                 $updatebalindestinationbank_dddemp = new Bankdetails_m();
    //                 $depositeldddempamtdata = [
    //                     'sss_ent_bank_acc_openingbal' => $depositedddempamt,
    //                     'sss_ent_bank_last_updated_by' => session('userid'),
    //                     'sss_ent_bank_updated_date' => date('Y-m-d')
    //                 ];
    //                 $updatebalindestinationbank_dddemp->update($embankid, $depositeldddempamtdata);
    //                 $bbparticulars_dddempdeposite = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' . 'Employee Commission';

    //                 $DepositeDDDEmparray = [
    //                     'sss_ddd_id' => $lastinserted_id,
    //                     'sss_bb_vendorid' => 57,
    //                     'sss_bb_vpid' => 61,
    //                     'sss_bb_particulars' => $bbparticulars_dddempdeposite,
    //                     'sss_bb_sourcebankid' => '',
    //                     'sss_bb_destinationbankid' => $embankid,
    //                     'sss_bb_transamt' => $dddempamt,
    //                     'sss_bb_finalamt' => $dddempamt,
    //                     'sss_bb_transtype' => 'Deposit',
    //                     'sss_bb_iswithdrawl' => '',
    //                     'sss_bb_isdeposit' => $dddempamt,
    //                     'sss_bb_transmode' => $this->request->getVar('sss_ddd_transmode'),
    //                     'sss_bb_transreffno' => $this->request->getVar('sss_ddd_transreffno'),
    //                     'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //                     'sss_bb_transmonth' => $sss_bb_transmonth,
    //                     'sss_bb_lastbalance' => $opngbalfordddempsfromsempbank,
    //                     'sss_bb_balance' => $depositedddempamt,
    //                     'sss_allbankid' => $embankid,
    //                     'createdate' => date('Y-m-d')
    //                 ];
    //                 // echo "<pre>";print_r($DepositeDDDEmparray);
    //                 $isBankBookEntry->insert($DepositeDDDEmparray);
    //             }
    //         }
    //         // exit;

    //         // get vendor name... for deposite entry
    //         $Vendor_m = new Vendor_m();
    //         $vendorname = $Vendor_m->find(55);

    //         // get vendor purpose...for deposite entry
    //         $Vendorpurpose_m = new Vendorpurpose_m();
    //         $vendorp = $Vendorpurpose_m->find(55);

    //         $tax_destinationbankid = 3;
    //         $adv_destinationbankid = 2;

    //         $getOpngBal = new Bankdetails_m();
    //         $data['opngbalfortax'] = $getOpngBal->find($sourceb); // get source bank for tax

    //         $data['destinationbankfortax'] = $getOpngBal->find($tax_destinationbankid); // get destination bank for tax....
    //         $opngbalofsourcebankfortax = $data['opngbalfortax']['sss_ent_bank_acc_openingbal'];

    //         $updatelastbalinsourcebank = new Bankdetails_m(); //update bank balance....

    //         $totaltax = $this->request->getVar('totaltax');

    //         $withdrawltaxamount = $opngbalofsourcebankfortax - $totaltax; // withdraw tax from source bank....
    //         // echo "withdraw amt - ".$withdrawltaxamount."<br>";
    //         $withdrawtaxbankdata = [
    //             'sss_ent_bank_acc_openingbal' => $withdrawltaxamount,
    //             'sss_ent_bank_last_updated_by' => session('userid'),
    //             'sss_ent_bank_updated_date' => date('Y-m-d')
    //         ];
    //         // echo $sourceb."<br>";
    //         // echo "<pre>";print_r($withdrawtaxbankdata);exit;
    //         $updatelastbalinsourcebank->update($sourceb, $withdrawtaxbankdata);

    //         $destinationbankOpngBal_tax = $data['destinationbankfortax']['sss_ent_bank_acc_openingbal'];  //deposite destination bank
    //         $tax_destinationbankclsngbal = $destinationbankOpngBal_tax + $totaltax;  // deposite balance to destination bank...

    //         $updatebalindestinationbank_tax = new Bankdetails_m();
    //         $depositetaxbankdata = [
    //             'sss_ent_bank_acc_openingbal' => $tax_destinationbankclsngbal,
    //             'sss_ent_bank_last_updated_by' => session('userid'),
    //             'sss_ent_bank_updated_date' => date('Y-m-d')
    //         ];

    //         $updatebalindestinationbank_tax->update($tax_destinationbankid, $depositetaxbankdata);
    //         // exit;
    //         $bbparticulars_deposite  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' . $this->request->getVar('taxinvno');
    //         $isBankBookEntry = new Bankbook_m();
    //         // income tax start....

    //         $WithdrawlTaxarray = [
    //             'sss_ddd_id' => $isDDDInserted,
    //             'sss_bb_vendorid' => 55,
    //             'sss_bb_vpid' => 55,
    //             'sss_bb_particulars' => $bbparticulars_deposite,
    //             'sss_bb_sourcebankid' => $this->request->getVar('sourcebank'),
    //             'sss_bb_destinationbankid' => '',
    //             'sss_bb_transamt' => $this->request->getVar('totaltax'),
    //             'sss_bb_finalamt' => $this->request->getVar('totaltax'),
    //             'sss_bb_transtype' => 'Withdrawl',
    //             'sss_bb_iswithdrawl' => $this->request->getVar('totaltax'),
    //             'sss_bb_isdeposit' => '',
    //             'sss_bb_transmode' => 'NA',
    //             'sss_bb_transreffno' => 'NA',
    //             'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //             'sss_bb_transmonth' => $sss_bb_transmonth,
    //             'sss_bb_lastbalance' => $opngbalofsourcebankfortax,
    //             'sss_bb_balance' => $withdrawltaxamount,
    //             'sss_allbankid' => $this->request->getVar('sourcebank'),
    //             'createdate' => date('Y-m-d')
    //         ];
    //         $isBankBookEntry->insert($WithdrawlTaxarray);

    //         $DepositeTaxarray = [
    //             'sss_ddd_id' => $isDDDInserted,
    //             'sss_bb_vendorid' => 55,
    //             'sss_bb_vpid' => 55,
    //             'sss_bb_particulars' => $bbparticulars_deposite,
    //             'sss_bb_sourcebankid' => '',
    //             'sss_bb_destinationbankid' => 3,
    //             'sss_bb_transamt' => $this->request->getVar('totaltax'),
    //             'sss_bb_finalamt' => $this->request->getVar('totaltax'),
    //             'sss_bb_transtype' => 'Deposit',
    //             'sss_bb_iswithdrawl' => '',
    //             'sss_bb_isdeposit' => $this->request->getVar('totaltax'),
    //             'sss_bb_transmode' => 'NA',
    //             'sss_bb_transreffno' => 'NA',
    //             'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //             'sss_bb_transmonth' => $sss_bb_transmonth,
    //             'sss_bb_lastbalance' => $destinationbankOpngBal_tax,
    //             'sss_bb_balance' => $tax_destinationbankclsngbal,
    //             'sss_allbankid' => 3,
    //             'createdate' => date('Y-m-d')
    //         ];

    //         $isBankBookEntry->insert($DepositeTaxarray);

    //         // end income tax ....
    //         //----------------------------------------------------
    //         //2. start adv /// 
    //         // get vendor name... for withdraw entry
    //         $Vendor_m = new Vendor_m();
    //         $vendor_name = $Vendor_m->find(56);

    //         // get vendor purpose...for withdraw entry
    //         $Vendorpurpose_m = new Vendorpurpose_m();
    //         $vendor_p = $Vendorpurpose_m->find(56);


    //         $getOpngBal = new Bankdetails_m();
    //         $data['opngbalforadv'] = $getOpngBal->find($sourceb);

    //         $data['destinationbankforadv'] = $getOpngBal->find($adv_destinationbankid); // get destination bank for adv....
    //         $opngbalofsourcebankforadv = $data['opngbalforadv']['sss_ent_bank_acc_openingbal'];
    //         $destinationbankOpngBal_adv =  $data['destinationbankforadv']['sss_ent_bank_acc_openingbal'];

    //         $totaladv = $this->request->getVar('totaladvertisment');
    //         $withdrawadvbal = $opngbalofsourcebankforadv - $totaladv; // withdrawl bank balance

    //         $updatelastbalinsourcebank = new Bankdetails_m();
    //         $adv_destinationbankclsngbal = $destinationbankOpngBal_adv + $totaladv; // adv deposite to destination bank
    //         $depositeadvbankdata = [
    //             'sss_ent_bank_acc_openingbal' => $adv_destinationbankclsngbal,
    //             'sss_ent_bank_last_updated_by' => session('userid'),
    //             'sss_ent_bank_updated_date' => date('Y-m-d')
    //         ];
    //         $updatelastbalinsourcebank->update($adv_destinationbankid, $depositeadvbankdata);

    //         $bbparticulars_adv_withdraw  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno')  . ' - ' . $this->request->getVar('advinvno');

    //         $withdrawlAdvArray = [
    //             'sss_ddd_id' => $isDDDInserted,
    //             'sss_bb_vendorid' => 56,
    //             'sss_bb_vpid' => 56,
    //             'sss_bb_particulars' => $bbparticulars_adv_withdraw,
    //             'sss_bb_sourcebankid' => $this->request->getVar('sourcebank'),
    //             'sss_bb_destinationbankid' => '',
    //             'sss_bb_transamt' => $this->request->getVar('totaladvertisment'),
    //             'sss_bb_finalamt' => $this->request->getVar('totaladvertisment'),
    //             'sss_bb_transtype' => 'Withdrawl',
    //             'sss_bb_iswithdrawl' => $this->request->getVar('totaladvertisment'),
    //             'sss_bb_isdeposit' => '',
    //             'sss_bb_transmode' => 'NA',
    //             'sss_bb_transreffno' => 'NA',
    //             'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //             'sss_bb_transmonth' => $sss_bb_transmonth,
    //             'sss_bb_lastbalance' => $opngbalofsourcebankforadv,
    //             'sss_bb_balance' => $withdrawadvbal,
    //             'sss_allbankid' => $this->request->getVar('sourcebank'),
    //             'createdate' => date('Y-m-d')
    //         ];
    //         $isBankBookEntry->insert($withdrawlAdvArray);
    //         $updatelastbalinsourcebank = new Bankdetails_m();
    //         $withdrawadvbankdata = [
    //             'sss_ent_bank_acc_openingbal' => $withdrawadvbal,
    //             'sss_ent_bank_last_updated_by' => session('userid'),
    //             'sss_ent_bank_updated_date' => date('Y-m-d')
    //         ];
    //         $updatelastbalinsourcebank->update($sourceb, $withdrawadvbankdata);

    //         $bbparticulars_adv_deposite  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' .  $this->request->getVar('advinvno');

    //         $DepositeAdvArray = [
    //             'sss_ddd_id' => $isDDDInserted,
    //             'sss_bb_vendorid' => 56,
    //             'sss_bb_vpid' => 56,
    //             'sss_bb_particulars' => $bbparticulars_adv_deposite,
    //             'sss_bb_sourcebankid' => '',
    //             'sss_bb_destinationbankid' => 2,
    //             'sss_bb_transamt' => $this->request->getVar('totaladvertisment'),
    //             'sss_bb_finalamt' => $this->request->getVar('totaladvertisment'),
    //             'sss_bb_transtype' => 'Deposit',
    //             'sss_bb_iswithdrawl' => '',
    //             'sss_bb_isdeposit' => $this->request->getVar('totaladvertisment'),
    //             'sss_bb_transmode' => 'NA',
    //             'sss_bb_transreffno' => 'NA',
    //             'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //             'sss_bb_transmonth' => $sss_bb_transmonth,
    //             'sss_bb_lastbalance' => $destinationbankOpngBal_adv,
    //             'sss_bb_balance' => $adv_destinationbankclsngbal,
    //             'sss_allbankid' => 2,
    //             'createdate' => date('Y-m-d')
    //         ];
    //         $isBankBookEntry->insert($DepositeAdvArray);

    //         // end emp salary...
    //         $totalempsalary = $this->request->getVar('sumofempRoundvalues');

    //         $getOpngBal = new Bankdetails_m();
    //         $data['opngbalforemp'] = $getOpngBal->find($sourceb);
    //         $sourcebankopeningbal = $data['opngbalforemp']['sss_ent_bank_acc_openingbal'];
    //         $clsngempsalarybal = $sourcebankopeningbal - $totalempsalary;

    //         $bbparticulars_emp_withdraw  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' . $this->request->getVar('empinvno');

    //         $EmpArray = [
    //             'sss_ddd_id' => $isDDDInserted,
    //             'sss_bb_vendorid' => 57,
    //             'sss_bb_vpid' => 61,
    //             'sss_bb_particulars' => $bbparticulars_emp_withdraw,
    //             'sss_bb_sourcebankid' => $this->request->getVar('sourcebank'),
    //             'sss_bb_destinationbankid' => '',
    //             'sss_bb_transamt' => $this->request->getVar('sumofempRoundvalues'),
    //             'sss_bb_finalamt' => $this->request->getVar('sumofempRoundvalues'),
    //             'sss_bb_transtype' => 'Withdrawl',
    //             'sss_bb_iswithdrawl' => $this->request->getVar('sumofempRoundvalues'),
    //             'sss_bb_isdeposit' => '',
    //             'sss_bb_transmode' => $this->request->getVar('sss_ddd_transmode'),
    //             'sss_bb_transreffno' => $this->request->getVar('sss_ddd_transreffno'),
    //             'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //             'sss_bb_transmonth' => $sss_bb_transmonth,
    //             'sss_bb_lastbalance' => $sourcebankopeningbal,
    //             'sss_bb_balance' => $clsngempsalarybal,
    //             'sss_allbankid' => $this->request->getVar('sourcebank'),
    //             'createdate' => date('Y-m-d')
    //         ];

    //         $isInserted = $isBankBookEntry->insert($EmpArray);

    //         $updatelastbalinsourcebank = new Bankdetails_m();
    //         $updateempbankdata = [
    //             'sss_ent_bank_acc_openingbal' => $clsngempsalarybal,
    //             'sss_ent_bank_last_updated_by' => session('userid'),
    //             'sss_ent_bank_updated_date' => date('Y-m-d')
    //         ];
    //         $updatelastbalinsourcebank->update($sourceb, $updateempbankdata);
    //         // get empbank account and make emp's bb entry of deposite and withdrawl.....
    //         // calcualte emp tds and store it into tdstable....
    //         $emptds = new Tdsentries_m();
    //         $empTdsArray = [
    //             'sss_vid' => 57,
    //             'sss_vpid' => 57,
    //             'sss_bb_id' => $isInserted,
    //             'sss_bankid' => $this->request->getVar('sourcebank'),
    //             'sss_ddd_id' => $isDDDInserted,
    //             'sss_trans_date' => date('Y-m-d'),
    //             'sss_transamt' => $this->request->getVar('sumofempRoundvalues'),
    //             'sss_tdsamt' => $this->request->getVar('sss_ddd_total_tds'),
    //             'sss_tdsmonth' => $sss_bb_transmonth,
    //             'createdate' => date('Y-m-d'),
    //         ];
    //         $emptds->insert($empTdsArray);
    //         echo json_encode(array("status" => true, "message" => 'Deal Details Draft is Inserted'));
    //     }
    // }

    // 1.1
    // public function insert_ddd()
    // {
    //     $validation = \Config\Services::validation();
    //     $this->validate([
    //         'sss_ddd_misc' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Please enter Misc. Amount',
    //             ]
    //         ],
    //         'sss_ddd_sbamt_tdsper' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Select TDS Percent',
    //             ]
    //         ],
    //         'sss_ddd_cirilroyality_tdsper' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Select TDS Percent'
    //             ]
    //         ],
    //         'sss_ddd_unknown' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Mention Required Particulars',
    //             ]
    //         ],
    //         'sss_ddd_unknownamt' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Enter Particulars Amount',
    //             ]
    //         ],
    //         'sss_ddd_outcomeroundamt.*' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Select TDS Percent',
    //             ]
    //         ],
    //         'sss_ddd_generatedate' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Please Select Date',
    //             ]
    //         ],

    //     ]);
    //     if ($validation->run() == FALSE) {
    //         $errors = $validation->getErrors();
    //         echo json_encode(['code' => 0, 'error' => $errors]);
    //     } else {
    //         unset($_POST['sss_ddd_service_fees']);
    //         unset($_POST['sss_ddd_service_gst']);
    //         unset($_POST['sss_ddd_sbbrkg']);
    //         unset($_POST['sss_ddd_cirilroyality']);
    //         unset($_POST['sss_ddd_gst']);
    //         unset($_POST['sss_ddd_miscexp']);

    //         $dddempamt = 0;
    //         $depositedddempamt = 0;
    //         $embankid = 0;
    //         $opngbalfordddempsfromsourcebank = 0;
    //         $opngbalofsourcebankfortax = 0;
    //         $totaltax = 0;
    //         $withdrawltaxamount = 0;
    //         $tax_destinationbankclsngbal = 0;
    //         $destinationbankOpngBal_tax = 0;
    //         $tax_destinationbankclsngbal = 0;
    //         $opngbalofsourcebankforadv = 0;
    //         $destinationbankOpngBal_adv = 0;
    //         $totaladv = 0;
    //         $withdrawadvbal = 0;
    //         $adv_destinationbankclsngbal = 0;
    //         $clsngempsalarybal = 0;
    //         $sourcebankopeningbal = 0;
    //         $totalempsalary = 0;
    //         $sumofwithdrawled = 0;
    //         $outcomeno = count($_POST['sss_ddd_oc_id']);
    //         $empno = count($_POST['sss_emp_id']);


    //         $payment = new Paymentreceived_m();
    //         $getsourcebankid = $payment->table('sss_tbl_paymentreceived')->where('sss_pr_id', $this->request->getVar('sss_pr_id'))->get()->getRow();

    //         $invoice = new CreateInvoice_m();
    //         $getInvoice = $invoice->find($getsourcebankid->sss_inv_id);
    //         $invBankid = $getInvoice['sss_inv_bankid']; // getbank id for checking into loop of balance reflushing....
            
            
            
    //         // save to ddd table....
    //         $insertDDDrecord = new Dealdetaildraft_m();
    //         $ddd_data = [
    //             'sss_ddc_id' => $this->request->getVar('sss_ddc_id'),
    //             'sss_pr_id' => $this->request->getVar('sss_pr_id'),
    //             'sss_ddd_misc' => $this->request->getVar('sss_ddd_misc'),
    //             'sss_ddd_generatedate' => $this->request->getVar('sss_ddd_generatedate'),
    //             'sss_ddd_shno' => $this->request->getVar('sss_ddd_shno'),
    //             'sss_ddd_transmode' => $this->request->getVar('sss_ddd_transmode'),
    //             'sss_ddd_transreffno' => $this->request->getVar('sss_ddd_transreffno'),
    //             'sss_ddd_sbamt_amt' => $this->request->getVar('sss_ddd_sbamt_amt'),
    //             'sss_ddd_sbamt_tdsper' =>  $this->request->getVar('sss_ddd_sbamt_tdsper'),
    //             'sss_ddd_sbamt_tds' => $this->request->getVar('sss_ddd_sbamt_tds'),
    //             'sss_ddd_cirilroyalityamt' => $this->request->getVar('sss_ddd_cirilroyalityamt'),
    //             'sss_ddd_cirilroyality_tdsper' => $this->request->getVar('sss_ddd_cirilroyality_tdsper'),
    //             'sss_ddd_cirilroyality_tds' => $this->request->getVar('sss_ddd_cirilroyality_tds'),
    //             'sss_ddd_unknown' => $this->request->getVar('sss_ddd_unknown'),
    //             'sss_ddd_unknownamt' => $this->request->getVar('sss_ddd_unknownamt'),
    //             'sss_ddd_unknown_tdsper' => $this->request->getVar('sss_ddd_unknown_tdsper'),
    //             'sss_ddd_unknown_tds' => $this->request->getVar('sss_ddd_unknown_tds'),
    //             'sss_ddd_ourshare' => $this->request->getVar('sss_ddd_ourshare'),
    //             'sss_ddd_gst' => $this->request->getVar('sss_ddd_gst'),
    //             'sss_ddd_gst_amt' => $this->request->getVar('sss_ddd_gst_amt'),
    //             'sss_ddd_gst_rounded' => $this->request->getVar('sss_ddd_gst_rounded'),
    //             'sss_ddd_gst_total' => $this->request->getVar('sss_ddd_gst_total'),
    //             'sss_ddd_gst_tds' => $this->request->getVar('sss_ddd_gst_tds'),
    //             'sss_ddd_gst_finalamt' => $this->request->getVar('sss_ddd_gst_finalamt'),
    //             'sss_ddd_total_roundvalue' => $this->request->getVar('sss_ddd_total_roundvalue'),
    //             'sumofempRoundvalues' => $this->request->getVar('sumofempRoundvalues'),
    //             'sss_ddd_sumofroundvalue' => $this->request->getVar('sss_ddd_sumofroundvalue'),
    //             'sss_ddd_total_tds' => $this->request->getVar('sss_ddd_total_tds'),
    //             'sss_ddd_total_finalamt' => $this->request->getVar('sss_ddd_total_finalamt'),
    //             'sss_ddd_balanceincurrent' => $this->request->getVar('sss_ddd_balanceincurrent'),
    //             'sss_ddd_balanceincurrentinper' => $this->request->getVar('sss_ddd_balanceincurrentinper'),
    //             'sss_ddd_status' => true,
    //             'sss_ddd_createby' => session('userid'),
    //             'sss_ddd_createdate' => date('Y-m-d')
    //         ];
    //         // echo "<pre>";print_r($ddd_data);exit;
    //         $isDDDInserted = $insertDDDrecord->insert($ddd_data);
    //         $lastinserted_id = $insertDDDrecord->insertID();
            
    //         $insertby = session('userid');
    //         $insertdate = date('Y-m-d');

    //         $sourceb = $this->request->getVar('sourcebank');

    //         $isOutcomes = new DDD_outcome_m();

    //         for ($i = 0; $i < $outcomeno; $i++) {
    //             $outcomevalues = [
    //                 // 'sss_ddd_id' => 0,
    //                 'sss_ddd_id' => $lastinserted_id,
    //                 'sss_ddd_oc_id' => $_POST['sss_ddd_oc_id'][$i],
    //                 'sss_ddd_outcomeamt' => $_POST['sss_ddd_outcomeamt'][$i],
    //                 'sss_ddd_outcomeroundamt' => $_POST['sss_ddd_outcomeroundamt'][$i],
    //                 'sss_ddd_outcometotalamt' => $_POST['sss_ddd_outcometotalamt'][$i],
    //                 'sss_dddoutcome_tds' => $_POST['sss_dddoutcome_tds'][$i],
    //                 'sss_ddd_outcomefinalamt' => $_POST['sss_ddd_outcomefinalamt'][$i],
    //                 'sss_dddoutcome_createdate' => $insertby,
    //                 'sss_dddoutcome_createdby' => $insertdate,
    //             ];
    //             $isOutcomes->insert($outcomevalues);
    //         }

    //         //create bb entries for TAX advertisment and employees..
    //         // $dateComps = date_parse(date('Y-m-d'));
    //         $dateComps = date_parse($this->request->getVar('sss_ddd_generatedate'));
    //         $year = $dateComps['year'];
    //         $month = $dateComps['month'];
    //         $sss_bb_transmonth = $month . '-' . $year;
    //         // echo $sss_bb_transmonth;exit;
    //         $isEmps = new DDD_emp_m();
            
    //         $isBankBookEntry = new Bankbook_m();

    //         $nextBankbookentries = new Bankbook_m();

    //         for ($i = 0; $i < $empno; $i++) {
    //             $empvalues = [
    //                 // 'sss_ddd_id' => 0,
    //                 'sss_ddd_id' => $lastinserted_id,
    //                 'sss_emp_id' => $_POST['sss_emp_id'][$i],
    //                 'sss_dddemp_amt' => $_POST['sss_ddd_empamt'][$i],
    //                 'sss_dddemp_roundedamt' => $_POST['sss_ddd_emproundamt'][$i],
    //                 'sss_dddemp_totalamt' => null,
    //                 'sss_dddemp_tds' => $_POST['sss_ddd_emptdsamt'][$i],
    //                 'sss_dddemp_finalamt' => $_POST['sss_ddd_empfinalamt'][$i],
    //                 'sss_dddemp_createdby' => $insertby,
    //                 'sss_dddemp_createdate' => $insertdate,
    //             ];
    //             // echo "<pre>";print_r($empvalues);
    //             $isEmps->insert($empvalues);
    //             $emp = new Employee_m();
    //             $getbanksemp0 = $emp->select('sss_emp_id,sss_emp_bankid')->where('sss_hadbank', "Yes")->where('sss_emp_id', $_POST['sss_emp_id'][$i])->get()->getRow();
    //             // echo $getbanksemp0['sss_emp_id'];
    //             $dddempamt = 0;
                
    //             if (isset($getbanksemp0->sss_emp_id) && isset($getbanksemp0->sss_emp_bankid)) {
                    
    //                 $empid = $getbanksemp0->sss_emp_id;
    //                 $embankid = $getbanksemp0->sss_emp_bankid;
                    
    //                 $empsoutcomes = $isEmps->select('sss_emp_id,sss_dddemp_amt')->where('sss_emp_id', $empid)->orderBy('id', 'Desc')->get()->getRow();
    //                 $dddempamt = $empsoutcomes->sss_dddemp_amt; // get emp amount which had bank...

    //                 $Empgetnextentriesby_transactiondate = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', $embankid)->where('sss_bb_transactiondate >', $this->request->getVar('sss_ddd_generatedate'))->orderBy('sss_bb_transactiondate','ASC')->get()->getRow();
                    
    //                 if ($Empgetnextentriesby_transactiondate != '') {
                      
    //                     $Emp_lastBalance = $Empgetnextentriesby_transactiondate->sss_bb_lastbalance; // next entries first row of last balances...
    //                     $currentBalance_Emp = $Emp_lastBalance + $dddempamt;

    //                     $bbparticulars_dddempdeposite = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' . 'Employee Commission';
                        
    //                     $DepositeDDDEmparray2 = [
    //                         'sss_ddd_id' => $lastinserted_id,
    //                         'sss_bb_vendorid' => 57,
    //                         'sss_bb_vpid' => 61,
    //                         'sss_bb_particulars' => $bbparticulars_dddempdeposite,
    //                         'sss_bb_sourcebankid' => '',
    //                         'sss_bb_destinationbankid' => $embankid,
    //                         'sss_bb_transamt' => $dddempamt,
    //                         'sss_bb_finalamt' => $dddempamt,
    //                         'sss_bb_transtype' => 'Deposit',
    //                         'sss_bb_iswithdrawl' => '',
    //                         'sss_bb_isdeposit' => $dddempamt,
    //                         'sss_bb_transmode' => $this->request->getVar('sss_ddd_transmode'),
    //                         'sss_bb_transreffno' => $this->request->getVar('sss_ddd_transreffno'),
    //                         'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //                         'sss_bb_transmonth' => $sss_bb_transmonth,
    //                         'sss_bb_lastbalance' => $Emp_lastBalance,
    //                         'sss_bb_balance' => $currentBalance_Emp,
    //                         'sss_allbankid' => $embankid,
    //                         'createdate' => date('Y-m-d')
    //                     ];
                        
    //                     $isBankBookEntry->insert($DepositeDDDEmparray2);

    //                     // deposite amount to main bank...
    //                     $getOpngBaldddemp = new Bankdetails_m();
    //                     $data['opngbalfordddemp'] = $getOpngBaldddemp->find($embankid);
    //                     $opngbalfordddempsfromsempbank = $data['opngbalfordddemp']['sss_ent_bank_acc_openingbal'];
    //                     $depositedddempamt0 = $opngbalfordddempsfromsempbank + $currentBalance_Emp;  // deposite balance to destination bank...
                    
    //                     $Emp_allnextEntries = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', $embankid)->where('sss_bb_transactiondate >', $this->request->getVar('sss_ddd_generatedate'))->orderBy('sss_bb_transactiondate','ASC')->get()->getResult();
                       
    //                     foreach ($Emp_allnextEntries as $emp_entries) {
    //                         $Emp_bb_id = $emp_entries->sss_bankbook_id;
    //                         $lastBalance = $emp_entries->sss_bb_lastbalance;
    //                         $Emp_newLastBalance = $lastBalance + $dddempamt; // substract sum of all withdrawl from last balances...
    //                         $Emp_newcurrentBalance = $Emp_newLastBalance + $emp_entries->sss_bb_transamt;
    //                         $emp_new_amountBalances = [
    //                             'sss_bb_lastbalance' => $Emp_newLastBalance,
    //                             'sss_bb_balance' => $Emp_newcurrentBalance,
    //                             'updatedate	' => date('Y-m-d')
    //                         ];
    //                         echo "<pre>";print_r($emp_new_amountBalances);echo "<br>";
    //                         $nextBankbookentries->update($Emp_bb_id, $emp_new_amountBalances);
    //                     }
    //                     $updatebalindestinationbank_dddemp = new Bankdetails_m();
    //                     $depositeldddempamtdata = [
    //                         'sss_ent_bank_acc_openingbal' => $Emp_newcurrentBalance,
    //                         'sss_ent_bank_last_updated_by' => session('userid'),
    //                         'sss_ent_bank_updated_date' => date('Y-m-d')
    //                     ];
    //                     $updatebalindestinationbank_dddemp->update($embankid, $depositeldddempamtdata);


    //                 } else {
                        
    //                     // get source bank amout for ddd emp....
    //                     $getOpngBaldddempfromsourcebank = new Bankdetails_m();
    //                     $data['opngbalfordddemp1'] = $getOpngBaldddempfromsourcebank->find($sourceb);
    //                     $opngbalfordddempsfromsourcebank = $data['opngbalfordddemp1']['sss_ent_bank_acc_openingbal'];
                      
    //                     // get ddd emp bank amount...
    //                     $getOpngBaldddemp1 = new Bankdetails_m();
    //                     $data['opngbalfordddemp'] = $getOpngBaldddemp1->find($embankid);
    //                     $opngbalfordddempsfromsempbank = $data['opngbalfordddemp']['sss_ent_bank_acc_openingbal'];
    //                     // deposite ddd emp amount...
                    
    //                     $depositedddempamt = $opngbalfordddempsfromsempbank + $dddempamt;  // deposite balance to destination bank...
                        
    //                     $updatebalindestinationbank_dddemp = new Bankdetails_m();
    //                     $depositeldddempamtdata = [
    //                         'sss_ent_bank_acc_openingbal' => $depositedddempamt,
    //                         'sss_ent_bank_last_updated_by' => session('userid'),
    //                         'sss_ent_bank_updated_date' => date('Y-m-d')
    //                     ];
    //                     $updatebalindestinationbank_dddemp->update($embankid, $depositeldddempamtdata);

    //                     $bbparticulars_dddempdeposite = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' . 'Employee Commission';

    //                     $DepositeDDDEmparray = [
    //                         // 'sss_ddd_id' => 0,
    //                         'sss_ddd_id' => $lastinserted_id,
    //                         'sss_bb_vendorid' => 57,
    //                         'sss_bb_vpid' => 61,
    //                         'sss_bb_particulars' => $bbparticulars_dddempdeposite,
    //                         'sss_bb_sourcebankid' => '',
    //                         'sss_bb_destinationbankid' => $embankid,
    //                         'sss_bb_transamt' => $dddempamt,
    //                         'sss_bb_finalamt' => $dddempamt,
    //                         'sss_bb_transtype' => 'Deposit',
    //                         'sss_bb_iswithdrawl' => '',
    //                         'sss_bb_isdeposit' => $dddempamt,
    //                         'sss_bb_transmode' => $this->request->getVar('sss_ddd_transmode'),
    //                         'sss_bb_transreffno' => $this->request->getVar('sss_ddd_transreffno'),
    //                         'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //                         'sss_bb_transmonth' => $sss_bb_transmonth,
    //                         'sss_bb_lastbalance' => $opngbalfordddempsfromsempbank,
    //                         'sss_bb_balance' => $depositedddempamt,
    //                         'sss_allbankid' => $embankid,
    //                         'createdate' => date('Y-m-d')
    //                     ];
    //                     // echo "<pre>";print_r($DepositeDDDEmparray);
    //                     $isBankBookEntry->insert($DepositeDDDEmparray);
    //                 }
    //             }
    //         }
            
    //         // all withdrawl entry...
    //         $getnextentriesby_transactiondate = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', $invBankid)->where('sss_bb_transactiondate >', $this->request->getVar('sss_ddd_generatedate'))->orderBy('sss_bb_transactiondate','ASC')->get()->getRow();
            
            
    //         if ($getnextentriesby_transactiondate != '') {
    //             // exit;
    //             $getOpngBal = new Bankdetails_m();
    //             $data['opngbal'] = $getOpngBal->find($sourceb);
    //             $opngbalofsourcebank = $data['opngbal']['sss_ent_bank_acc_openingbal'];
    //             // echo "Source Opening Bal -".$opngbalofsourcebank;exit;
    //             //withdrawl entries....
    //             $tax_lastBalance = $getnextentriesby_transactiondate->sss_bb_lastbalance; // next entries first row of last balances...
                
    //             $totalTaxx =  $this->request->getVar('totaltax');
    //             // echo "Total Tax".$totalTaxx;exit;
    //             $currentBalance_tax = $tax_lastBalance - $totalTaxx;
                
                
    //             $bbparticulars_deposite  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' . $this->request->getVar('taxinvno');
    //             $WithdrawlTaxarray = [
    //                 // 'sss_ddd_id' => 0,
    //                 'sss_ddd_id' => $lastinserted_id,
    //                 'sss_bb_vendorid' => 55,
    //                 'sss_bb_vpid' => 55,
    //                 'sss_bb_particulars' => $bbparticulars_deposite,
    //                 'sss_bb_sourcebankid' => $this->request->getVar('sourcebank'),
    //                 'sss_bb_destinationbankid' => '',
    //                 'sss_bb_transamt' => $this->request->getVar('totaltax'),
    //                 'sss_bb_finalamt' => $this->request->getVar('totaltax'),
    //                 'sss_bb_transtype' => 'Withdrawl',
    //                 'sss_bb_iswithdrawl' => $this->request->getVar('totaltax'),
    //                 'sss_bb_isdeposit' => '',
    //                 'sss_bb_transmode' => 'NA',
    //                 'sss_bb_transreffno' => 'NA',
    //                 'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //                 'sss_bb_transmonth' => $sss_bb_transmonth,
    //                 'sss_bb_lastbalance' => $tax_lastBalance,
    //                 'sss_bb_balance' => $currentBalance_tax,
    //                 'sss_allbankid' => $this->request->getVar('sourcebank'),
    //                 'createdate' => date('Y-m-d')
    //             ];
                
                
    //             $isBankBookEntry->insert($WithdrawlTaxarray);
               

    //             // advetisment entries....
    //             $totaladv = $this->request->getVar('totaladvertisment');
    //             $get_Adv_lastBalance = $currentBalance_tax;
    //             $get_Adv_currentBalance = $currentBalance_tax - $totaladv;

    //             $bbparticulars_adv_withdraw  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno')  . ' - ' . $this->request->getVar('advinvno');
                
    //             $withdrawlAdvArray = [
    //                 // 'sss_ddd_id' => 0,
    //                 'sss_ddd_id' => $lastinserted_id,
    //                 'sss_bb_vendorid' => 56,
    //                 'sss_bb_vpid' => 56,
    //                 'sss_bb_particulars' => $bbparticulars_adv_withdraw,
    //                 'sss_bb_sourcebankid' => $this->request->getVar('sourcebank'),
    //                 'sss_bb_destinationbankid' => '',
    //                 'sss_bb_transamt' => $this->request->getVar('totaladvertisment'),
    //                 'sss_bb_finalamt' => $this->request->getVar('totaladvertisment'),
    //                 'sss_bb_transtype' => 'Withdrawl',
    //                 'sss_bb_iswithdrawl' => $this->request->getVar('totaladvertisment'),
    //                 'sss_bb_isdeposit' => '',
    //                 'sss_bb_transmode' => 'NA',
    //                 'sss_bb_transreffno' => 'NA',
    //                 'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //                 'sss_bb_transmonth' => $sss_bb_transmonth,
    //                 'sss_bb_lastbalance' => $get_Adv_lastBalance,
    //                 'sss_bb_balance' => $get_Adv_currentBalance,
    //                 'sss_allbankid' => $this->request->getVar('sourcebank'),
    //                 'createdate' => date('Y-m-d')
    //             ];
                
    //             $isBankBookEntry->insert($withdrawlAdvArray);
                
    //             //Emp Salary...
    //             $totalempsalary = $this->request->getVar('sumofempRoundvalues');
    //             $get_empsalary_lastBalance = $get_Adv_currentBalance;
    //             $get_Empsalary_currentBalance = $get_empsalary_lastBalance - $totalempsalary;

    //             $bbparticulars_emp_withdraw  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' . $this->request->getVar('empinvno');
                
    //             $EmpArray = [
    //                 // 'sss_ddd_id' => 0,
    //                 'sss_ddd_id' => $lastinserted_id,
    //                 'sss_bb_vendorid' => 57,
    //                 'sss_bb_vpid' => 61,
    //                 'sss_bb_particulars' => $bbparticulars_emp_withdraw,
    //                 'sss_bb_sourcebankid' => $this->request->getVar('sourcebank'),
    //                 'sss_bb_destinationbankid' => '',
    //                 'sss_bb_transamt' => $this->request->getVar('sumofempRoundvalues'),
    //                 'sss_bb_finalamt' => $this->request->getVar('sumofempRoundvalues'),
    //                 'sss_bb_transtype' => 'Withdrawl',
    //                 'sss_bb_iswithdrawl' => $this->request->getVar('sumofempRoundvalues'),
    //                 'sss_bb_isdeposit' => '',
    //                 'sss_bb_transmode' => $this->request->getVar('sss_ddd_transmode'),
    //                 'sss_bb_transreffno' => $this->request->getVar('sss_ddd_transreffno'),
    //                 'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //                 'sss_bb_transmonth' => $sss_bb_transmonth,
    //                 'sss_bb_lastbalance' => $get_empsalary_lastBalance,
    //                 'sss_bb_balance' => $get_Empsalary_currentBalance,
    //                 'sss_allbankid' => $this->request->getVar('sourcebank'),
    //                 'createdate' => date('Y-m-d')
    //             ];
                
               
    //             $isInserted = $isBankBookEntry->insert($EmpArray);
                

    //             $allEntries = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', $invBankid)->where('sss_bb_transactiondate >', $this->request->getVar('sss_ddd_generatedate'))->orderBy('sss_bb_transactiondate','ASC')->get()->getResult();
    
    //             $sumofwithdrawled = $this->request->getVar('totaltax') + $this->request->getVar('totaladvertisment') + $this->request->getVar('sumofempRoundvalues');
                

    //             foreach ($allEntries as $bb_entries) {
                    
    //                 if ($bb_entries->sss_bb_transtype == 'Deposit') {
    //                     $Bb_id = $bb_entries->sss_bankbook_id;
    //                     $lastBalance = $bb_entries->sss_bb_lastbalance;
                        
    //                     $newLastBalance = $lastBalance - $sumofwithdrawled; // substract sum of all withdrawl from last balances...
                        
    //                     $newcurrentBalance = $newLastBalance + $bb_entries->sss_bb_transamt;
                        
    //                     $deposite_new_amountBalances = [
    //                         'sss_bb_lastbalance' => $newLastBalance,
    //                         'sss_bb_balance' => $newcurrentBalance,
    //                         'updatedate	' => date('Y-m-d')
    //                     ];
                        
    //                     $nextBankbookentries->update($Bb_id, $deposite_new_amountBalances);


    //                     $withdrawbankdata = [
    //                         'sss_ent_bank_acc_openingbal' => $newcurrentBalance,
    //                         'sss_ent_bank_last_updated_by' => session('userid'),
    //                         'sss_ent_bank_updated_date' => date('Y-m-d')
    //                     ];
    //                     $getOpngBal->update($sourceb, $withdrawbankdata);
    //                 } 
    //                 else {
    //                     // when next entries will be withdrawl...
    //                     $Bb_id = $bb_entries->sss_bankbook_id;
    //                     $lastBalance = $bb_entries->sss_bb_lastbalance;
                        
    //                     $newLastBalance = $lastBalance - $sumofwithdrawled;
                        
    //                     $newcurrentBalance = $newLastBalance - $bb_entries->sss_bb_transamt;
                        
    //                     $withdrwl_new_amountBalances = [
    //                         'sss_bb_lastbalance' => $newLastBalance,
    //                         'sss_bb_balance' => $newcurrentBalance,
    //                         'updatedate	' => date('Y-m-d')
    //                     ];
                        
                        
    //                     $nextBankbookentries->update($Bb_id, $withdrwl_new_amountBalances);

    //                     $withdrawbankdata1 = [
    //                         'sss_ent_bank_acc_openingbal' => $newcurrentBalance,
    //                         'sss_ent_bank_last_updated_by' => session('userid'),
    //                         'sss_ent_bank_updated_date' => date('Y-m-d')
    //                     ];
    //                     $getOpngBal->update($sourceb, $withdrawbankdata1);
    //                 }
    //             }
    //         } 
    //         else 
    //         {
                
    //             $updatelastbalinsourcebank = new Bankdetails_m(); //update bank balance....
    //             $totaltax = $this->request->getVar('totaltax');
    //             $getOpngBal = new Bankdetails_m();
    //             $data['opngbalfortax'] = $getOpngBal->find($sourceb);
    //             $opngbalofsourcebankfortax = $data['opngbalfortax']['sss_ent_bank_acc_openingbal'];

    //             $withdrawltaxamount = $opngbalofsourcebankfortax - $totaltax; // withdraw tax from source bank....
    //             $withdrawtaxbankdata0 = [
    //                 'sss_ent_bank_acc_openingbal' => $withdrawltaxamount,
    //                 'sss_ent_bank_last_updated_by' => session('userid'),
    //                 'sss_ent_bank_updated_date' => date('Y-m-d')
    //             ];
    //             // echo "<pre>";print_r($withdrawtaxbankdata0);exit;
    //             $updatelastbalinsourcebank->update($sourceb, $withdrawtaxbankdata0);


    //             $bbparticulars_deposite  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' . $this->request->getVar('taxinvno');
    //             $isBankBookEntry = new Bankbook_m();
    //             $WithdrawlTaxarray1 = [
    //                 // 'sss_ddd_id' => 0,
    //                 'sss_ddd_id' => $lastinserted_id,
    //                 'sss_bb_vendorid' => 55,
    //                 'sss_bb_vpid' => 55,
    //                 'sss_bb_particulars' => $bbparticulars_deposite,
    //                 'sss_bb_sourcebankid' => $this->request->getVar('sourcebank'),
    //                 'sss_bb_destinationbankid' => '',
    //                 'sss_bb_transamt' => $this->request->getVar('totaltax'),
    //                 'sss_bb_finalamt' => $this->request->getVar('totaltax'),
    //                 'sss_bb_transtype' => 'Withdrawl',
    //                 'sss_bb_iswithdrawl' => $this->request->getVar('totaltax'),
    //                 'sss_bb_isdeposit' => '',
    //                 'sss_bb_transmode' => 'NA',
    //                 'sss_bb_transreffno' => 'NA',
    //                 'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //                 'sss_bb_transmonth' => $sss_bb_transmonth,
    //                 'sss_bb_lastbalance' => $opngbalofsourcebankfortax,
    //                 'sss_bb_balance' => $withdrawltaxamount,
    //                 'sss_allbankid' => $this->request->getVar('sourcebank'),
    //                 'createdate' => date('Y-m-d')
    //             ];
    //             // echo "<pre>";print_r($WithdrawlTaxarray1);exit;
    //             $isBankBookEntry->insert($WithdrawlTaxarray1);

    //             // withdrawl Adv Array....
    //             $getOpngBal = new Bankdetails_m();
    //             $data['opngbalforadv'] = $getOpngBal->find($sourceb);
                
    //             $opngbalofsourcebankforadv = $data['opngbalforadv']['sss_ent_bank_acc_openingbal'];

                
    //             $totaladv1 = $this->request->getVar('totaladvertisment');
    //             $withdrawadvbal = $opngbalofsourcebankforadv - $totaladv1; // withdrawl bank balance
    //             $updatelastbalinsourcebank = new Bankdetails_m();

    //             $withdrawadvbankdata = [
    //                 'sss_ent_bank_acc_openingbal' => $withdrawadvbal,
    //                 'sss_ent_bank_last_updated_by' => session('userid'),
    //                 'sss_ent_bank_updated_date' => date('Y-m-d')
    //             ];
    //             // echo "<pre>";print_r($withdrawadvbankdata);exit;
    //             $updatelastbalinsourcebank->update($sourceb, $withdrawadvbankdata);

    //             $bbparticulars_adv_withdraw  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno')  . ' - ' . $this->request->getVar('advinvno');
    //             $withdrawlAdvArray1 = [
    //                 // 'sss_ddd_id' => 0,
    //                 'sss_ddd_id' => $lastinserted_id,
    //                 'sss_bb_vendorid' => 56,
    //                 'sss_bb_vpid' => 56,
    //                 'sss_bb_particulars' => $bbparticulars_adv_withdraw,
    //                 'sss_bb_sourcebankid' => $this->request->getVar('sourcebank'),
    //                 'sss_bb_destinationbankid' => '',
    //                 'sss_bb_transamt' => $this->request->getVar('totaladvertisment'),
    //                 'sss_bb_finalamt' => $this->request->getVar('totaladvertisment'),
    //                 'sss_bb_transtype' => 'Withdrawl',
    //                 'sss_bb_iswithdrawl' => $this->request->getVar('totaladvertisment'),
    //                 'sss_bb_isdeposit' => '',
    //                 'sss_bb_transmode' => 'NA',
    //                 'sss_bb_transreffno' => 'NA',
    //                 'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //                 'sss_bb_transmonth' => $sss_bb_transmonth,
    //                 'sss_bb_lastbalance' => $opngbalofsourcebankforadv,
    //                 'sss_bb_balance' => $withdrawadvbal,
    //                 'sss_allbankid' => $this->request->getVar('sourcebank'),
    //                 'createdate' => date('Y-m-d')
    //             ];
    //             // echo "<pre>";print_r($withdrawlAdvArray1);exit;
    //             $isBankBookEntry->insert($withdrawlAdvArray1);

    //             //withdrawl Emp Salary...
    //             $totalempsalary1 = $this->request->getVar('sumofempRoundvalues');

    //             $getOpngBal = new Bankdetails_m();
    //             $data['opngbalforemp'] = $getOpngBal->find($sourceb);
    //             $sourcebankopeningbal = $data['opngbalforemp']['sss_ent_bank_acc_openingbal'];
    //             $clsngempsalarybal = $sourcebankopeningbal - $totalempsalary1;

    //             $updatelastbalinsourcebank = new Bankdetails_m();
    //             $updateempbankdata = [
    //                 'sss_ent_bank_acc_openingbal' => $clsngempsalarybal,
    //                 'sss_ent_bank_last_updated_by' => session('userid'),
    //                 'sss_ent_bank_updated_date' => date('Y-m-d')
    //             ];
    //             // echo "<pre>";print_r($updateempbankdata);exit;
    //             $updatelastbalinsourcebank->update($sourceb, $updateempbankdata);

    //             $bbparticulars_emp_withdraw  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' . $this->request->getVar('empinvno');

    //             $EmpArray1 = [
    //                 // 'sss_ddd_id' => 0,
    //                 'sss_ddd_id' => $lastinserted_id,
    //                 'sss_bb_vendorid' => 57,
    //                 'sss_bb_vpid' => 61,
    //                 'sss_bb_particulars' => $bbparticulars_emp_withdraw,
    //                 'sss_bb_sourcebankid' => $this->request->getVar('sourcebank'),
    //                 'sss_bb_destinationbankid' => '',
    //                 'sss_bb_transamt' => $this->request->getVar('sumofempRoundvalues'),
    //                 'sss_bb_finalamt' => $this->request->getVar('sumofempRoundvalues'),
    //                 'sss_bb_transtype' => 'Withdrawl',
    //                 'sss_bb_iswithdrawl' => $this->request->getVar('sumofempRoundvalues'),
    //                 'sss_bb_isdeposit' => '',
    //                 'sss_bb_transmode' => $this->request->getVar('sss_ddd_transmode'),
    //                 'sss_bb_transreffno' => $this->request->getVar('sss_ddd_transreffno'),
    //                 'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //                 'sss_bb_transmonth' => $sss_bb_transmonth,
    //                 'sss_bb_lastbalance' => $sourcebankopeningbal,
    //                 'sss_bb_balance' => $clsngempsalarybal,
    //                 'sss_allbankid' => $this->request->getVar('sourcebank'),
    //                 'createdate' => date('Y-m-d')
    //             ];
    //             // echo "<pre>";print_r($EmpArray1);exit;
    //             $isInserted = $isBankBookEntry->insert($EmpArray1);
    //         }
            
    //         $Taxgetnextentriesby_transactiondate = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', 3)->where('sss_bb_transactiondate >', $this->request->getVar('sss_ddd_generatedate'))->orderBy('sss_bb_transactiondate','ASC')->get()->getRow();
            
    //         if ($Taxgetnextentriesby_transactiondate != '') {
               
    //             //deposite entries
    //             $tax_destinationbankid = 3;
    //             $tax_lastBalance = $Taxgetnextentriesby_transactiondate->sss_bb_lastbalance; // next entries first row of last balances...
    //             //TAX entries....
    //             $tx = $this->request->getVar('totaltax');
    //             $currentBalance_tax = $tax_lastBalance + $tx;
    //             $bbparticulars_deposite  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' . $this->request->getVar('taxinvno');

    //             $DepositeTaxarray = [
    //                 'sss_ddd_id' => $lastinserted_id,
    //                 'sss_bb_vendorid' => 55,
    //                 'sss_bb_vpid' => 55,
    //                 'sss_bb_particulars' => $bbparticulars_deposite,
    //                 'sss_bb_sourcebankid' => '',
    //                 'sss_bb_destinationbankid' => 3,
    //                 'sss_bb_transamt' => $this->request->getVar('totaltax'),
    //                 'sss_bb_finalamt' => $this->request->getVar('totaltax'),
    //                 'sss_bb_transtype' => 'Deposit',
    //                 'sss_bb_iswithdrawl' => '',
    //                 'sss_bb_isdeposit' => $this->request->getVar('totaltax'),
    //                 'sss_bb_transmode' => 'NA',
    //                 'sss_bb_transreffno' => 'NA',
    //                 'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //                 'sss_bb_transmonth' => $sss_bb_transmonth,
    //                 'sss_bb_lastbalance' => $tax_lastBalance,
    //                 'sss_bb_balance' => $currentBalance_tax,
    //                 'sss_allbankid' => 3,
    //                 'createdate' => date('Y-m-d')
    //             ];
    //             $isBankBookEntry->insert($DepositeTaxarray);

    //             $Tax_allnextEntries = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', 3)->where('sss_bb_transactiondate >', $this->request->getVar('sss_ddd_generatedate'))->orderBy('sss_bb_transactiondate','ASC')->get()->getResult();
                
    //             foreach ($Tax_allnextEntries as $tax_entries) {
                    
    //                 $Tax_bb_id = $tax_entries->sss_bankbook_id;
    //                 $lastBalance = $tax_entries->sss_bb_lastbalance;
    //                 $taxes = $this->request->getVar('totaltax');
    //                 $Tax_newLastBalance = $lastBalance + $taxes; // substract sum of all withdrawl from last balances...
    //                 $Tax_newcurrentBalance = $Tax_newLastBalance + $tax_entries->sss_bb_transamt;
    //                 $Tax_new_amountBalances = [
    //                     'sss_bb_lastbalance' => $Tax_newLastBalance,
    //                     'sss_bb_balance' => $Tax_newcurrentBalance,
    //                     'updatedate	' => date('Y-m-d')
    //                 ];
    //                 // echo "<pre>";print_r($Tax_new_amountBalances);
    //                 $nextBankbookentries->update($Tax_bb_id, $Tax_new_amountBalances);
    //             }

    //             $updatebalindestinationbank_tax = new Bankdetails_m();
                
    //             $depositetaxbankdata = [
    //                 'sss_ent_bank_acc_openingbal' => $Tax_newcurrentBalance,
    //                 'sss_ent_bank_last_updated_by' => session('userid'),
    //                 'sss_ent_bank_updated_date' => date('Y-m-d')
    //             ];
    //             $updatebalindestinationbank_tax->update($tax_destinationbankid, $depositetaxbankdata);

                
    //         } else {

                
    //             $tax_destinationbankid = 3;
    //             $getOpngBal = new Bankdetails_m();

    //             $data['opngbalfortax1'] = $getOpngBal->find($sourceb); // get source bank for tax
    //             $data['destinationbankfortax'] = $getOpngBal->find($tax_destinationbankid); // get destination bank for tax....

    //             $opngbalofsourcebankfortax = $data['opngbalfortax1']['sss_ent_bank_acc_openingbal'];
    //             $destinationbankOpngBal_tax = $data['destinationbankfortax']['sss_ent_bank_acc_openingbal'];  //deposite destination bank

    //             $taxxs = $this->request->getVar('totaltax');
    //             $tax_destinationbankclsngbal = $destinationbankOpngBal_tax + $taxxs;  // deposite balance to destination bank...
    //             $updatebalindestinationbank_tax = new Bankdetails_m();
    //             $depositetaxbankdata0 = [
    //                 'sss_ent_bank_acc_openingbal' => $tax_destinationbankclsngbal,
    //                 'sss_ent_bank_last_updated_by' => session('userid'),
    //                 'sss_ent_bank_updated_date' => date('Y-m-d')
    //             ];
    //             $updatebalindestinationbank_tax->update($tax_destinationbankid, $depositetaxbankdata0);

    //             $bbparticulars_deposite  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' . $this->request->getVar('taxinvno');

    //             $DepositeTaxarray1 = [
    //                 'sss_ddd_id' => $lastinserted_id,
    //                 'sss_bb_vendorid' => 55,
    //                 'sss_bb_vpid' => 55,
    //                 'sss_bb_particulars' => $bbparticulars_deposite,
    //                 'sss_bb_sourcebankid' => '',
    //                 'sss_bb_destinationbankid' => 3,
    //                 'sss_bb_transamt' => $this->request->getVar('totaltax'),
    //                 'sss_bb_finalamt' => $this->request->getVar('totaltax'),
    //                 'sss_bb_transtype' => 'Deposit',
    //                 'sss_bb_iswithdrawl' => '',
    //                 'sss_bb_isdeposit' => $this->request->getVar('totaltax'),
    //                 'sss_bb_transmode' => 'NA',
    //                 'sss_bb_transreffno' => 'NA',
    //                 'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //                 'sss_bb_transmonth' => $sss_bb_transmonth,
    //                 'sss_bb_lastbalance' => $destinationbankOpngBal_tax,
    //                 'sss_bb_balance' => $tax_destinationbankclsngbal,
    //                 'sss_allbankid' => 3,
    //                 'createdate' => date('Y-m-d')
    //             ];
                
    //             $isBankBookEntry->insert($DepositeTaxarray1);
    //         }

    //         $Advgetnextentriesby_transactiondate = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', 2)->where('sss_bb_transactiondate >', $this->request->getVar('sss_ddd_generatedate'))->orderBy('sss_bb_transactiondate','ASC')->get()->getRow();

    //         if ($Advgetnextentriesby_transactiondate != '') {
                
    //             $adv_destinationbankid = 2;
    //             $adv_lastBalance = $Advgetnextentriesby_transactiondate->sss_bb_lastbalance; // next entries first row of last balances...
    //             $advertisments = $this->request->getVar('totaladvertisment');
    //             $currentBalance_Adv = $adv_lastBalance + $advertisments;
    //             $bbparticulars_adv_deposite  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' .  $this->request->getVar('advinvno');

    //             $DepositeAdvArray = [
    //                 'sss_ddd_id' => $lastinserted_id,
    //                 'sss_bb_vendorid' => 56,
    //                 'sss_bb_vpid' => 56,
    //                 'sss_bb_particulars' => $bbparticulars_adv_deposite,
    //                 'sss_bb_sourcebankid' => '',
    //                 'sss_bb_destinationbankid' => 2,
    //                 'sss_bb_transamt' => $this->request->getVar('totaladvertisment'),
    //                 'sss_bb_finalamt' => $this->request->getVar('totaladvertisment'),
    //                 'sss_bb_transtype' => 'Deposit',
    //                 'sss_bb_iswithdrawl' => '',
    //                 'sss_bb_isdeposit' => $this->request->getVar('totaladvertisment'),
    //                 'sss_bb_transmode' => 'NA',
    //                 'sss_bb_transreffno' => 'NA',
    //                 'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //                 'sss_bb_transmonth' => $sss_bb_transmonth,
    //                 'sss_bb_lastbalance' => $adv_lastBalance,
    //                 'sss_bb_balance' => $currentBalance_Adv,
    //                 'sss_allbankid' => 2,
    //                 'createdate' => date('Y-m-d')
    //             ];
    //             // echo "<pre>";print_r($DepositeAdvArray);
    //             $isBankBookEntry->insert($DepositeAdvArray);
                
    //             $Adv_allnextEntries = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', 2)->where('sss_bb_transactiondate >', $this->request->getVar('sss_ddd_generatedate'))->orderBy('sss_bb_transactiondate','ASC')->get()->getResult();
                
    //             foreach ($Adv_allnextEntries as $adv_entries) {
    //                 $Adv_bb_id = $adv_entries->sss_bankbook_id;
    //                 $lastBalance = $adv_entries->sss_bb_lastbalance;
    //                 $ad = $this->request->getVar('totaladvertisment');
    //                 $Adv_newLastBalance = $lastBalance + $ad; // substract sum of all withdrawl from last balances...
    //                 $Adv_newcurrentBalance = $Adv_newLastBalance + $adv_entries->sss_bb_transamt;   
    //                 $Adv_new_amountBalances = [
    //                     'sss_bb_lastbalance' => $Adv_newLastBalance,
    //                     'sss_bb_balance' => $Adv_newcurrentBalance,
    //                     'updatedate	' => date('Y-m-d')
    //                 ];
    //                 $nextBankbookentries->update($Adv_bb_id, $Adv_new_amountBalances);
    //             }

    //             $updatebalindestinationbank_withdrawl = new Bankdetails_m();
    //             $depositeadvbankdata1 = [
    //                 'sss_ent_bank_acc_openingbal' => $Adv_newcurrentBalance,
    //                 'sss_ent_bank_last_updated_by' => session('userid'),
    //                 'sss_ent_bank_updated_date' => date('Y-m-d')
    //             ];
    //             $updatebalindestinationbank_withdrawl->update($adv_destinationbankid, $depositeadvbankdata1);
                
    //         } 
    //         else {
    //             // echo "No NExt entry for ADv";exit;
    //             $adv_destinationbankid1 = 2;
    //             $getOpngBal1 = new Bankdetails_m();
    //             // $data['opngbalforadv'] = $getOpngBal1->find($sourceb);
    //             $data['destinationbankforadv'] = $getOpngBal1->find($adv_destinationbankid1); // get destination bank for adv....
                
                
    //             $adv_s = $this->request->getVar('totaladvertisment');
                
    //             $destinationbankOpngBal_adv =  $data['destinationbankforadv']['sss_ent_bank_acc_openingbal'];
                
    //             $adv_destinationbankclsngbal1 = $destinationbankOpngBal_adv + $adv_s; // adv deposite to destination bank
                
    //             $depositeadvbankdata1 = [
    //                 'sss_ent_bank_acc_openingbal' => $adv_destinationbankclsngbal1,
    //                 'sss_ent_bank_last_updated_by' => session('userid'),
    //                 'sss_ent_bank_updated_date' => date('Y-m-d')
    //             ];
    //             // echo "<pre>";print_r($depositeadvbankdata1);exit;
    //             $updatelastbalinsourcebank->update($adv_destinationbankid1, $depositeadvbankdata1);

    //             $bbparticulars_adv_deposite  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' .  $this->request->getVar('advinvno');
    //             $DepositeAdvArray1 = [
    //                 // 'sss_ddd_id' => 0,
    //                 'sss_ddd_id' => $lastinserted_id,
    //                 'sss_bb_vendorid' => 56,
    //                 'sss_bb_vpid' => 56,
    //                 'sss_bb_particulars' => $bbparticulars_adv_deposite,
    //                 'sss_bb_sourcebankid' => '',
    //                 'sss_bb_destinationbankid' => 2,
    //                 'sss_bb_transamt' => $this->request->getVar('totaladvertisment'),
    //                 'sss_bb_finalamt' => $this->request->getVar('totaladvertisment'),
    //                 'sss_bb_transtype' => 'Deposit',
    //                 'sss_bb_iswithdrawl' => '',
    //                 'sss_bb_isdeposit' => $this->request->getVar('totaladvertisment'),
    //                 'sss_bb_transmode' => 'NA',
    //                 'sss_bb_transreffno' => 'NA',
    //                 'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //                 'sss_bb_transmonth' => $sss_bb_transmonth,
    //                 'sss_bb_lastbalance' => $destinationbankOpngBal_adv,
    //                 'sss_bb_balance' => $adv_destinationbankclsngbal1,
    //                 'sss_allbankid' => 2,
    //                 'createdate' => date('Y-m-d')
    //             ];
    //             // echo "<pre>";print_r($DepositeAdvArray1);exit;
    //             $isBankBookEntry->insert($DepositeAdvArray1);
    //         }
            
    //         // get empbank account and make emp's bb entry of deposite and withdrawl.....
    //         // calcualte emp tds and store it into tdstable....
    //         $emptds = new Tdsentries_m();
    //         $empTdsArray = [
    //             'sss_vid' => 57,
    //             'sss_vpid' => 57,
    //             'sss_bb_id' => $isInserted,
    //             'sss_bankid' => $this->request->getVar('sourcebank'),
    //             'sss_ddd_id' => $lastinserted_id,
    //             'sss_trans_date' => date('Y-m-d'),
    //             'sss_transamt' => $this->request->getVar('sumofempRoundvalues'),
    //             'sss_tdsamt' => $this->request->getVar('sss_ddd_total_tds'),
    //             'sss_tdsmonth' => $sss_bb_transmonth,
    //             'createdate' => date('Y-m-d'),
    //         ];
    //         $emptds->insert($empTdsArray);
            
    //         echo json_encode(array("status" => true, "message" => 'Deal Details Draft is Inserted'));
    //     }
    // }
    
    // public function insert_ddd()
    // {
    //     $validation = \Config\Services::validation();
    //     $this->validate([
    //         'sss_ddd_misc' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Please enter Misc. Amount',
    //             ]
    //         ],
    //         'sss_ddd_sbamt_tdsper' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Select TDS Percent',
    //             ]
    //         ],
    //         'sss_ddd_cirilroyality_tdsper' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Select TDS Percent'
    //             ]
    //         ],
    //         'sss_ddd_unknown' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Mention Required Particulars',
    //             ]
    //         ],
    //         'sss_ddd_unknownamt' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Enter Particulars Amount',
    //             ]
    //         ],
    //         'sss_ddd_outcomeroundamt.*' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Select TDS Percent',
    //             ]
    //         ],
    //         'sss_ddd_generatedate' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Please Select Date',
    //             ]
    //         ],

    //     ]);
    //     if ($validation->run() == FALSE) {
    //         $errors = $validation->getErrors();
    //         echo json_encode(['code' => 0, 'error' => $errors]);
    //     } else {
    //         unset($_POST['sss_ddd_service_fees']);
    //         unset($_POST['sss_ddd_service_gst']);
    //         unset($_POST['sss_ddd_sbbrkg']);
    //         unset($_POST['sss_ddd_cirilroyality']);
    //         unset($_POST['sss_ddd_gst']);
    //         unset($_POST['sss_ddd_miscexp']);

    //         $dddempamt = 0;
    //         $depositedddempamt = 0;
    //         $embankid = 0;
    //         $opngbalfordddempsfromsourcebank = 0;
    //         $opngbalofsourcebankfortax = 0;
    //         $totaltax = 0;
    //         $withdrawltaxamount = 0;
    //         $tax_destinationbankclsngbal = 0;
    //         $destinationbankOpngBal_tax = 0;
    //         $tax_destinationbankclsngbal = 0;
    //         $opngbalofsourcebankforadv = 0;
    //         $destinationbankOpngBal_adv = 0;
    //         $totaladv = 0;
    //         $withdrawadvbal = 0;
    //         $adv_destinationbankclsngbal = 0;
    //         $clsngempsalarybal = 0;
    //         $sourcebankopeningbal = 0;
    //         $totalempsalary = 0;
    //         $sumofwithdrawled = 0;
    //         $outcomeno = count($_POST['sss_ddd_oc_id']);
    //         $empno = count($_POST['sss_emp_id']);


    //         $payment = new Paymentreceived_m();
    //         $getsourcebankid = $payment->table('sss_tbl_paymentreceived')->where('sss_pr_id', $this->request->getVar('sss_pr_id'))->get()->getRow();

    //         $invoice = new CreateInvoice_m();
    //         $getInvoice = $invoice->find($getsourcebankid->sss_inv_id);
    //         $invBankid = $getInvoice['sss_inv_bankid']; // getbank id for checking into loop of balance reflushing....
    //         $month = 0;
    //         $year = 0;
    //         $dateComps = date_parse($this->request->getVar('sss_ddd_generatedate'));
    //         $year = $dateComps['year'];
    //         $month = $dateComps['month'];
    //         $sss_bb_transmonth = $month . '-' . $year;

    //         $updatelastbalinsourcebank = new Bankdetails_m();


    //         // save to ddd table....
    //         $insertDDDrecord = new Dealdetaildraft_m();
    //         $ddd_data = [
    //             'sss_ddc_id' => $this->request->getVar('sss_ddc_id'),
    //             'sss_pr_id' => $this->request->getVar('sss_pr_id'),
    //             'sss_ddd_misc' => $this->request->getVar('sss_ddd_misc'),
    //             'sss_ddd_generatedate' => $this->request->getVar('sss_ddd_generatedate'),
    //             'sss_ddd_shno' => $this->request->getVar('sss_ddd_shno'),
    //             'sss_ddd_transmode' => $this->request->getVar('sss_ddd_transmode'),
    //             'sss_ddd_transreffno' => $this->request->getVar('sss_ddd_transreffno'),
    //             'sss_ddd_sbamt_amt' => $this->request->getVar('sss_ddd_sbamt_amt'),
    //             'sss_ddd_sbamt_tdsper' =>  $this->request->getVar('sss_ddd_sbamt_tdsper'),
    //             'sss_ddd_sbamt_tds' => $this->request->getVar('sss_ddd_sbamt_tds'),
    //             'sss_ddd_cirilroyalityamt' => $this->request->getVar('sss_ddd_cirilroyalityamt'),
    //             'sss_ddd_cirilroyality_tdsper' => $this->request->getVar('sss_ddd_cirilroyality_tdsper'),
    //             'sss_ddd_cirilroyality_tds' => $this->request->getVar('sss_ddd_cirilroyality_tds'),
    //             'sss_ddd_unknown' => $this->request->getVar('sss_ddd_unknown'),
    //             'sss_ddd_unknownamt' => $this->request->getVar('sss_ddd_unknownamt'),
    //             'sss_ddd_unknown_tdsper' => $this->request->getVar('sss_ddd_unknown_tdsper'),
    //             'sss_ddd_unknown_tds' => $this->request->getVar('sss_ddd_unknown_tds'),
    //             'sss_ddd_ourshare' => $this->request->getVar('sss_ddd_ourshare'),
    //             'sss_ddd_gst' => $this->request->getVar('sss_ddd_gst'),
    //             'sss_ddd_gst_amt' => $this->request->getVar('sss_ddd_gst_amt'),
    //             'sss_ddd_gst_rounded' => $this->request->getVar('sss_ddd_gst_rounded'),
    //             'sss_ddd_gst_total' => $this->request->getVar('sss_ddd_gst_total'),
    //             'sss_ddd_gst_tds' => $this->request->getVar('sss_ddd_gst_tds'),
    //             'sss_ddd_gst_finalamt' => $this->request->getVar('sss_ddd_gst_finalamt'),
    //             'sss_ddd_total_roundvalue' => $this->request->getVar('sss_ddd_total_roundvalue'),
    //             'sumofempRoundvalues' => $this->request->getVar('sumofempRoundvalues'),
    //             'sss_ddd_sumofroundvalue' => $this->request->getVar('sss_ddd_sumofroundvalue'),
    //             'sss_ddd_total_tds' => $this->request->getVar('sss_ddd_total_tds'),
    //             'sss_ddd_total_finalamt' => $this->request->getVar('sss_ddd_total_finalamt'),
    //             'sss_ddd_balanceincurrent' => $this->request->getVar('sss_ddd_balanceincurrent'),
    //             'sss_ddd_balanceincurrentinper' => $this->request->getVar('sss_ddd_balanceincurrentinper'),
    //             'sss_ddd_status' => true,
    //             'sss_ddd_createby' => session('userid'),
    //             'sss_ddd_createdate' => date('Y-m-d')
    //         ];
    //         // echo "<pre>";print_r($ddd_data);
            
    //         $isDDDInserted = $insertDDDrecord->insert($ddd_data);
    //         $lastinserted_id = $insertDDDrecord->insertID();

    //         $insertby = session('userid');
    //         $insertdate = date('Y-m-d');

    //         $sourceb = $this->request->getVar('sourcebank');

    //         $isOutcomes = new DDD_outcome_m();

    //         for ($i = 0; $i < $outcomeno; $i++) {
    //             $outcomevalues = [
                    
    //                 'sss_ddd_id' => $lastinserted_id,
    //                 'sss_ddd_oc_id' => $_POST['sss_ddd_oc_id'][$i],
    //                 'sss_ddd_outcomeamt' => $_POST['sss_ddd_outcomeamt'][$i],
    //                 'sss_ddd_outcomeroundamt' => $_POST['sss_ddd_outcomeroundamt'][$i],
    //                 'sss_ddd_outcometotalamt' => $_POST['sss_ddd_outcometotalamt'][$i],
    //                 'sss_dddoutcome_tds' => $_POST['sss_dddoutcome_tds'][$i],
    //                 'sss_ddd_outcomefinalamt' => $_POST['sss_ddd_outcomefinalamt'][$i],
    //                 'sss_dddoutcome_createdate' => $insertby,
    //                 'sss_dddoutcome_createdby' => $insertdate,
    //             ];
    //             $isOutcomes->insert($outcomevalues);
    //         }
            
    //         // exit;

    //         //create bb entries for TAX advertisment and employees..
    //         // $dateComps = date_parse(date('Y-m-d'));

    //         // echo $sss_bb_transmonth;exit;
    //         $isEmps = new DDD_emp_m();

    //         $isBankBookEntry = new Bankbook_m();
    //         $nextBankbookentries = new Bankbook_m();
    //         for ($i = 0; $i < $empno; $i++) {
    //             $empvalues = [
    //                 // 'sss_ddd_id' => 0,
    //                 'sss_ddd_id' => $lastinserted_id,
    //                 'sss_emp_id' => $_POST['sss_emp_id'][$i],
    //                 'sss_dddemp_amt' => $_POST['sss_ddd_empamt'][$i],
    //                 'sss_dddemp_roundedamt' => $_POST['sss_ddd_emproundamt'][$i],
    //                 'sss_dddemp_totalamt' => null,
    //                 'sss_dddemp_tds' => $_POST['sss_ddd_emptdsamt'][$i],
    //                 'sss_dddemp_finalamt' => $_POST['sss_ddd_empfinalamt'][$i],
    //                 'sss_dddemp_createdby' => $insertby,
    //                 'sss_dddemp_createdate' => $insertdate,
    //             ];
    //             $isEmps->insert($empvalues);

    //             $emp = new Employee_m();
    //             $getbanksemp0 = $emp->select('sss_emp_id,sss_emp_bankid')->where('sss_hadbank', "Yes")->where('sss_emp_id', $_POST['sss_emp_id'][$i])->get()->getRow();
    //             // echo $getbanksemp0['sss_emp_id'];
    //             $dddempamt = 0;

    //             if (isset($getbanksemp0->sss_emp_id) && isset($getbanksemp0->sss_emp_bankid)) {
                    
    //                 $empid = $getbanksemp0->sss_emp_id;
    //                 $embankid = $getbanksemp0->sss_emp_bankid;

    //                 $empsoutcomes = $isEmps->select('sss_emp_id,sss_dddemp_amt')->where('sss_emp_id', $empid)->orderBy('id', 'Desc')->get()->getRow();
    //                 $dddempamt = $empsoutcomes->sss_dddemp_amt; // get emp amount which had bank...

    //                 $Empgetnextentriesby_transactiondate = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', $embankid)->where('sss_bb_transactiondate >', $this->request->getVar('sss_ddd_generatedate'))->orderBy('sss_bb_transactiondate', 'ASC')->get()->getRow();

    //                 if ($Empgetnextentriesby_transactiondate != '') {
    //                     // echo "Next Employee Entries";
    //                     // echo "<br>";
    //                     $Emp_lastBalance = $Empgetnextentriesby_transactiondate->sss_bb_lastbalance; // next entries first row of last balances...
    //                     $currentBalance_Emp = $Emp_lastBalance + $dddempamt;

    //                     $bbparticulars_dddempdeposite = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' . 'Employee Commission';

    //                     $DepositeDDDEmparray2 = [
    //                         // 'sss_ddd_id' => 0,
    //                         'sss_ddd_id' => $lastinserted_id,
    //                         'sss_bb_vendorid' => 57,
    //                         'sss_bb_vpid' => 61,
    //                         'sss_bb_particulars' => $bbparticulars_dddempdeposite,
    //                         'sss_bb_sourcebankid' => '',
    //                         'sss_bb_destinationbankid' => $embankid,
    //                         'sss_bb_transamt' => $dddempamt,
    //                         'sss_bb_finalamt' => $dddempamt,
    //                         'sss_bb_transtype' => 'Deposit',
    //                         'sss_bb_iswithdrawl' => '',
    //                         'sss_bb_isdeposit' => $dddempamt,
    //                         'sss_bb_transmode' => $this->request->getVar('sss_ddd_transmode'),
    //                         'sss_bb_transreffno' => $this->request->getVar('sss_ddd_transreffno'),
    //                         'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //                         'sss_bb_transmonth' => $sss_bb_transmonth,
    //                         'sss_bb_lastbalance' => $Emp_lastBalance,
    //                         'sss_bb_balance' => $currentBalance_Emp,
    //                         'sss_allbankid' => $embankid,
    //                         // 'createdatetime' => microtime(true),
    //                         'createdate' => date('Y-m-d')
    //                     ];
                        
    //                     $isBankBookEntry->insert($DepositeDDDEmparray2);
                        
    //                     // deposite amount to main bank...
    //                     $getOpngBaldddemp = new Bankdetails_m();
    //                     $data['opngbalfordddemp'] = $getOpngBaldddemp->find($embankid);
    //                     $opngbalfordddempsfromsempbank = $data['opngbalfordddemp']['sss_ent_bank_acc_openingbal'];
    //                     $depositedddempamt0 = $opngbalfordddempsfromsempbank + $currentBalance_Emp;  // deposite balance to destination bank...

    //                     $Emp_allnextEntries = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', $embankid)->where('sss_bb_transactiondate >', $this->request->getVar('sss_ddd_generatedate'))->orderBy('sss_bb_transactiondate', 'ASC')->get()->getResult();

    //                     foreach ($Emp_allnextEntries as $emp_entries) {
    //                         $Emp_bb_id = $emp_entries->sss_bankbook_id;
    //                         $lastBalance = $emp_entries->sss_bb_lastbalance;
    //                         $Emp_newLastBalance = $lastBalance + $dddempamt; // substract sum of all withdrawl from last balances...
    //                         $Emp_newcurrentBalance = $Emp_newLastBalance + $emp_entries->sss_bb_transamt;
    //                         $emp_new_amountBalances = [
    //                             'sss_bb_lastbalance' => $Emp_newLastBalance,
    //                             'sss_bb_balance' => $Emp_newcurrentBalance,
    //                             'updatedate	' => date('Y-m-d')
    //                         ];

    //                         $nextBankbookentries->update($Emp_bb_id, $emp_new_amountBalances);
    //                     }
    //                     $updatebalindestinationbank_dddemp = new Bankdetails_m();
    //                     $depositeldddempamtdata = [
    //                         'sss_ent_bank_acc_openingbal' => $Emp_newcurrentBalance,
    //                         'sss_ent_bank_last_updated_by' => session('userid'),
    //                         'sss_ent_bank_updated_date' => date('Y-m-d')
    //                     ];
    //                     $updatebalindestinationbank_dddemp->update($embankid, $depositeldddempamtdata);

    //                     // update opening months balancess for employee commission...

    //                     $lastRecord_emp = new Bankbook_m();
    //                     $getlastRecord_transactiondate_emparray = $lastRecord_emp->table('sss_tbl_bankbook')
    //                         ->select('sss_bb_balance,sss_bb_transmonth')
    //                         ->where('sss_allbankid', $embankid)
    //                         ->where('sss_bb_transmonth', $sss_bb_transmonth)
    //                         ->orderBy('sss_bb_transactiondate', 'Desc')
    //                         ->limit(1)
    //                         ->get()
    //                         ->getRow();

    //                     $closing_Bal_emparray = $getlastRecord_transactiondate_emparray->sss_bb_balance;

    //                     $NextMonthsBalances_m = new MonthsBalances_m();
    //                     $getValueofNextMonthBalance_emparray = $NextMonthsBalances_m
    //                         ->where('bankid', $embankid)
    //                         ->where('month >', $month)
    //                         ->where('year', $year)
    //                         ->orderBy('id', 'Asc')
    //                         ->get()
    //                         ->getResult();

    //                     for ($i = 0; $i < count($getValueofNextMonthBalance_emparray); $i++) {

    //                         // Get closing bal of prev month and update in current month ... 
    //                         $NextMonthsBal = new MonthsBalances_m();
    //                         $NextMonthsBal->update($getValueofNextMonthBalance_emparray[$i]->id, ['openingbal' =>  $closing_Bal_emparray]);

    //                         // shift closing bal for null entry...
    //                         $prevClosing_emparray = $closing_Bal_emparray;

    //                         // return the closing balance of current month....

    //                         $closing_Bal_emparray = $lastRecord->table('sss_tbl_bankbook')
    //                             ->select('sss_bb_balance,sss_bb_transmonth')
    //                             ->where('sss_allbankid', $getValueofNextMonthBalance_emparray[$i]->bankid)
    //                             ->where('sss_bb_transmonth', $getValueofNextMonthBalance_emparray[$i]->balancemonth)
    //                             ->orderBy('sss_bb_transactiondate', 'Desc')
    //                             ->get()
    //                             ->getRow();

    //                         if (!empty($closing_Bal_emparray)) {
    //                             $closing_Bal_emparray = $closing_Bal_emparray->sss_bb_balance;
    //                         } else {
    //                             $closing_Bal_emparray = $prevClosing_emparray;
    //                         }
    //                     }
    //                 } else {
    
    //                     // get source bank amout for ddd emp....
    //                     $getOpngBaldddempfromsourcebank = new Bankdetails_m();
    //                     $data['opngbalfordddemp1'] = $getOpngBaldddempfromsourcebank->find($sourceb);
    //                     $opngbalfordddempsfromsourcebank = $data['opngbalfordddemp1']['sss_ent_bank_acc_openingbal'];

    //                     // get ddd emp bank amount...
    //                     $getOpngBaldddemp1 = new Bankdetails_m();
    //                     $data['opngbalfordddemp'] = $getOpngBaldddemp1->find($embankid);
                      
    //                     $opngbalfordddempsfromsempbank = $data['opngbalfordddemp']['sss_ent_bank_acc_openingbal'];
    //                     // deposite ddd emp amount...

    //                     $depositedddempamt = $opngbalfordddempsfromsempbank + $dddempamt;  // deposite balance to destination bank...

    //                     $updatebalindestinationbank_dddemp = new Bankdetails_m();
    //                     $depositeldddempamtdata = [
    //                         'sss_ent_bank_acc_openingbal' => $depositedddempamt,
    //                         'sss_ent_bank_last_updated_by' => session('userid'),
    //                         'sss_ent_bank_updated_date' => date('Y-m-d')
    //                     ];
    //                     $updatebalindestinationbank_dddemp->update($embankid, $depositeldddempamtdata);

    //                     $bbparticulars_dddempdeposite = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' . 'Employee Commission';
                        
    //                     $DepositeDDDEmparray = [
    //                         // 'sss_ddd_id' => 0,
    //                         'sss_ddd_id' => $lastinserted_id,
    //                         'sss_bb_vendorid' => 57,
    //                         'sss_bb_vpid' => 61,
    //                         'sss_bb_particulars' => $bbparticulars_dddempdeposite,
    //                         'sss_bb_sourcebankid' => '',
    //                         'sss_bb_destinationbankid' => $embankid,
    //                         'sss_bb_transamt' => $dddempamt,
    //                         'sss_bb_finalamt' => $dddempamt,
    //                         'sss_bb_transtype' => 'Deposit',
    //                         'sss_bb_iswithdrawl' => '',
    //                         'sss_bb_isdeposit' => $dddempamt,
    //                         'sss_bb_transmode' => $this->request->getVar('sss_ddd_transmode'),
    //                         'sss_bb_transreffno' => $this->request->getVar('sss_ddd_transreffno'),
    //                         'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //                         'sss_bb_transmonth' => $sss_bb_transmonth,
    //                         'sss_bb_lastbalance' => $opngbalfordddempsfromsempbank,
    //                         'sss_bb_balance' => $depositedddempamt,
    //                         'sss_allbankid' => $embankid,
    //                         // 'createdatetime' => microtime(true),
    //                         'createdate' => date('Y-m-d')
    //                     ];
    //         //             // echo "<pre>";print_r($DepositeDDDEmparray);
    //                     $isBankBookEntry->insert($DepositeDDDEmparray);
                        
    //         //             // update opening month balance when dont have next entries for employee commission......

    //                     $lastRecord = new Bankbook_m();
    //                     $getlastRecord_transactiondate_emp = $lastRecord->table('sss_tbl_bankbook')->where('sss_allbankid', $embankid)->where('sss_bb_transmonth', $sss_bb_transmonth)->orderBy('sss_bb_transactiondate', 'Desc')->get()->getRow();
                        
                       
    //                     if (!empty($getlastRecord_transactiondate_emp)) {
                            
    //                         $newopningbal_emp = $getlastRecord_transactiondate_emp->sss_bb_balance;
    //                         $NextMonthsBalances_m = new MonthsBalances_m();
    //                         $getValueofNextMonthBalance_emp = $NextMonthsBalances_m->table('sss_openingbalance_month')->where('bankid', $embankid)->where('month >', $month)->where('year', $year)->orderBy('id', 'Asc')->get()->getResult();
                    
    //                         foreach ($getValueofNextMonthBalance_emp as $nextmonths_openingBalances_emp) {
    //                             $opngmonthbal_id_emp = $nextmonths_openingBalances_emp->id;
    //                             $deposite_nextmonth_opngbalances_emp = [
    //                                 'openingbal' => $newopningbal_emp,
    //                             ];
    //                             // echo "<pre>";print_r($deposite_nextmonth_opngbalances_emp);
    //                             $NextMonthsBalances_m->update($opngmonthbal_id_emp, $deposite_nextmonth_opngbalances_emp);
    //                         }
    //                     }
    //                 }
    //             }
    //         }
            
    //         // all withdrawl entry...

    //         $getnextentriesby_transactiondate = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', $invBankid)->where('sss_bb_transactiondate >', $this->request->getVar('sss_ddd_generatedate'))->where('sss_bb_transmonth', $sss_bb_transmonth)->orderBy('sss_bb_transactiondate', 'ASC')->get()->getRow();
    //         if ($getnextentriesby_transactiondate != '') {
               
    //             $getOpngBal = new Bankdetails_m();
    //             $data['opngbal'] = $getOpngBal->find($sourceb);
    //             $opngbalofsourcebank = $data['opngbal']['sss_ent_bank_acc_openingbal'];
    //             // echo "Source Opening Bal -".$opngbalofsourcebank;exit;
    //             //withdrawl entries....
    //             $tax_lastBalance = $getnextentriesby_transactiondate->sss_bb_lastbalance; // next entries first row of last balances...

    //             $totalTaxx =  $this->request->getVar('totaltax');
    //             // echo "Total Tax".$totalTaxx;exit;
    //             $currentBalance_tax = $tax_lastBalance - $totalTaxx;


    //             $bbparticulars_deposite  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' . $this->request->getVar('taxinvno');
                
    //             $WithdrawlTaxarray = [
    //                 // 'sss_ddd_id' => 0,
    //                 'sss_ddd_id' => $lastinserted_id,
    //                 'sss_bb_vendorid' => 55,
    //                 'sss_bb_vpid' => 55,
    //                 'sss_bb_particulars' => $bbparticulars_deposite,
    //                 'sss_bb_sourcebankid' => $this->request->getVar('sourcebank'),
    //                 'sss_bb_destinationbankid' => '',
    //                 'sss_bb_transamt' => $this->request->getVar('totaltax'),
    //                 'sss_bb_finalamt' => $this->request->getVar('totaltax'),
    //                 'sss_bb_transtype' => 'Withdrawl',
    //                 'sss_bb_iswithdrawl' => $this->request->getVar('totaltax'),
    //                 'sss_bb_isdeposit' => '',
    //                 'sss_bb_transmode' => 'NA',
    //                 'sss_bb_transreffno' => 'NA',
    //                 'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //                 'sss_bb_transmonth' => $sss_bb_transmonth,
    //                 'sss_bb_lastbalance' => $tax_lastBalance,
    //                 'sss_bb_balance' => $currentBalance_tax,
    //                 'sss_allbankid' => $this->request->getVar('sourcebank'),
    //                 // 'createdatetime' => microtime(true),
    //                 'createdate' => date('Y-m-d')

    //             ];
    //             $isBankBookEntry->insert($WithdrawlTaxarray);


    //           // advetisment entries....
    //             $totaladv = $this->request->getVar('totaladvertisment');
    //             $get_Adv_lastBalance = $currentBalance_tax;
    //             $get_Adv_currentBalance = $currentBalance_tax - $totaladv;
    //             $bbparticulars_adv_withdraw  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno')  . ' - ' . $this->request->getVar('advinvno');
    //             $withdrawlAdvArray = [
    //                 // 'sss_ddd_id' => 0,
    //                 'sss_ddd_id' => $lastinserted_id,
    //                 'sss_bb_vendorid' => 56,
    //                 'sss_bb_vpid' => 56,
    //                 'sss_bb_particulars' => $bbparticulars_adv_withdraw,
    //                 'sss_bb_sourcebankid' => $this->request->getVar('sourcebank'),
    //                 'sss_bb_destinationbankid' => '',
    //                 'sss_bb_transamt' => $this->request->getVar('totaladvertisment'),
    //                 'sss_bb_finalamt' => $this->request->getVar('totaladvertisment'),
    //                 'sss_bb_transtype' => 'Withdrawl',
    //                 'sss_bb_iswithdrawl' => $this->request->getVar('totaladvertisment'),
    //                 'sss_bb_isdeposit' => '',
    //                 'sss_bb_transmode' => 'NA',
    //                 'sss_bb_transreffno' => 'NA',
    //                 'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //                 'sss_bb_transmonth' => $sss_bb_transmonth,
    //                 'sss_bb_lastbalance' => $get_Adv_lastBalance,
    //                 'sss_bb_balance' => $get_Adv_currentBalance,
    //                 'sss_allbankid' => $this->request->getVar('sourcebank'),
    //                 // 'createdatetime' => microtime(true),
    //                 'createdate' => date('Y-m-d')
    //             ];
    //             $isBankBookEntry->insert($withdrawlAdvArray);

    //             //Emp Salary...
    //             $totalempsalary = $this->request->getVar('sumofempRoundvalues');
    //             $get_empsalary_lastBalance = $get_Adv_currentBalance;
    //             $get_Empsalary_currentBalance = $get_empsalary_lastBalance - $totalempsalary;
    //             $bbparticulars_emp_withdraw  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' . $this->request->getVar('empinvno');
                
    //             $EmpArray = [
    //                 // 'sss_ddd_id' => 0,
    //                 'sss_ddd_id' => $lastinserted_id,
    //                 'sss_bb_vendorid' => 57,
    //                 'sss_bb_vpid' => 61,
    //                 'sss_bb_particulars' => $bbparticulars_emp_withdraw,
    //                 'sss_bb_sourcebankid' => $this->request->getVar('sourcebank'),
    //                 'sss_bb_destinationbankid' => '',
    //                 'sss_bb_transamt' => $this->request->getVar('sumofempRoundvalues'),
    //                 'sss_bb_finalamt' => $this->request->getVar('sumofempRoundvalues'),
    //                 'sss_bb_transtype' => 'Withdrawl',
    //                 'sss_bb_iswithdrawl' => $this->request->getVar('sumofempRoundvalues'),
    //                 'sss_bb_isdeposit' => '',
    //                 'sss_bb_transmode' => $this->request->getVar('sss_ddd_transmode'),
    //                 'sss_bb_transreffno' => $this->request->getVar('sss_ddd_transreffno'),
    //                 'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //                 'sss_bb_transmonth' => $sss_bb_transmonth,
    //                 'sss_bb_lastbalance' => $get_empsalary_lastBalance,
    //                 'sss_bb_balance' => $get_Empsalary_currentBalance,
    //                 'sss_allbankid' => $this->request->getVar('sourcebank'),
    //                 // 'createdatetime' => microtime(true),
    //                 'createdate' => date('Y-m-d')
    //             ];
    //             $isInserted = $isBankBookEntry->insert($EmpArray);

    //             $allEntries = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', $invBankid)->where('sss_bb_transactiondate >', $this->request->getVar('sss_ddd_generatedate'))->orderBy('sss_bb_transactiondate', 'ASC')->get()->getResult();
    //             $sumofwithdrawled = $this->request->getVar('totaltax') + $this->request->getVar('totaladvertisment') + $this->request->getVar('sumofempRoundvalues');

    //             foreach ($allEntries as $bb_entries) {

    //                 if ($bb_entries->sss_bb_transtype == 'Deposit') {
    //                     $Bb_id = $bb_entries->sss_bankbook_id;
    //                     $lastBalance = $bb_entries->sss_bb_lastbalance;
    //                     $newLastBalance = $lastBalance - $sumofwithdrawled; // substract sum of all withdrawl from last balances...
    //                     $newcurrentBalance = $newLastBalance + $bb_entries->sss_bb_transamt;
    //                     $deposite_new_amountBalances = [
    //                         'sss_bb_lastbalance' => $newLastBalance,
    //                         'sss_bb_balance' => $newcurrentBalance,
    //                         'updatedate	' => date('Y-m-d')
    //                     ];

    //                     $nextBankbookentries->update($Bb_id, $deposite_new_amountBalances);
    //                     $withdrawbankdata = [
    //                         'sss_ent_bank_acc_openingbal' => $newcurrentBalance,
    //                         'sss_ent_bank_last_updated_by' => session('userid'),
    //                         'sss_ent_bank_updated_date' => date('Y-m-d')
    //                     ];
    //                     $getOpngBal->update($sourceb, $withdrawbankdata);

    //                     // update bank for employee commission in openingmonths bank...

    //                 } else {
    //                     // when next entries will be withdrawl...
    //                     $Bb_id = $bb_entries->sss_bankbook_id;
    //                     $lastBalance = $bb_entries->sss_bb_lastbalance;

    //                     $newLastBalance = $lastBalance - $sumofwithdrawled;

    //                     $newcurrentBalance = $newLastBalance - $bb_entries->sss_bb_transamt;

    //                     $withdrwl_new_amountBalances = [
    //                         'sss_bb_lastbalance' => $newLastBalance,
    //                         'sss_bb_balance' => $newcurrentBalance,
    //                         'updatedate	' => date('Y-m-d')
    //                     ];
    //                     $nextBankbookentries->update($Bb_id, $withdrwl_new_amountBalances);

    //                     $withdrawbankdata1 = [
    //                         'sss_ent_bank_acc_openingbal' => $newcurrentBalance,
    //                         'sss_ent_bank_last_updated_by' => session('userid'),
    //                         'sss_ent_bank_updated_date' => date('Y-m-d')
    //                     ];
    //                     $getOpngBal->update($sourceb, $withdrawbankdata1);
    //                 }
    //             }


    //         } else {
               
    //           //update bank balance....
    //             $totaltax = $this->request->getVar('totaltax');
    //             $getOpngBal = new Bankdetails_m();
    //             $data['opngbalfortax'] = $getOpngBal->find($sourceb);
    //             $opngbalofsourcebankfortax = $data['opngbalfortax']['sss_ent_bank_acc_openingbal'];

    //             $withdrawltaxamount = $opngbalofsourcebankfortax - $totaltax; // withdraw tax from source bank....
    //             $withdrawtaxbankdata0 = [
    //                 'sss_ent_bank_acc_openingbal' => $withdrawltaxamount,
    //                 'sss_ent_bank_last_updated_by' => session('userid'),
    //                 'sss_ent_bank_updated_date' => date('Y-m-d')
    //             ];
    //             $updatelastbalinsourcebank->update($sourceb, $withdrawtaxbankdata0);

    //             $bbparticulars_deposite  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' . $this->request->getVar('taxinvno');
    //             $isBankBookEntry = new Bankbook_m();
    //             $WithdrawlTaxarray1 = [
    //                 // 'sss_ddd_id' => 0,
    //                 'sss_ddd_id' => $lastinserted_id,
    //                 'sss_bb_vendorid' => 55,
    //                 'sss_bb_vpid' => 55,
    //                 'sss_bb_particulars' => $bbparticulars_deposite,
    //                 'sss_bb_sourcebankid' => $this->request->getVar('sourcebank'),
    //                 'sss_bb_destinationbankid' => '',
    //                 'sss_bb_transamt' => $this->request->getVar('totaltax'),
    //                 'sss_bb_finalamt' => $this->request->getVar('totaltax'),
    //                 'sss_bb_transtype' => 'Withdrawl',
    //                 'sss_bb_iswithdrawl' => $this->request->getVar('totaltax'),
    //                 'sss_bb_isdeposit' => '',
    //                 'sss_bb_transmode' => 'NA',
    //                 'sss_bb_transreffno' => 'NA',
    //                 'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //                 'sss_bb_transmonth' => $sss_bb_transmonth,
    //                 'sss_bb_lastbalance' => $opngbalofsourcebankfortax,
    //                 'sss_bb_balance' => $withdrawltaxamount,
    //                 'sss_allbankid' => $this->request->getVar('sourcebank'),
    //                 // 'createdatetime' => microtime(true),
    //                 'createdate' => date('Y-m-d')
    //             ];
    //             $isBankBookEntry->insert($WithdrawlTaxarray1);

    //           // withdrawl Adv Array....
    //             $getOpngBal = new Bankdetails_m();
    //             $data['opngbalforadv'] = $getOpngBal->find($sourceb);
    //             $opngbalofsourcebankforadv = $data['opngbalforadv']['sss_ent_bank_acc_openingbal'];
    //             $totaladv1 = $this->request->getVar('totaladvertisment');
    //             $withdrawadvbal = $opngbalofsourcebankforadv - $totaladv1; // withdrawl bank balance
                
    //             $withdrawadvbankdata = [
    //                 'sss_ent_bank_acc_openingbal' => $withdrawadvbal,
    //                 'sss_ent_bank_last_updated_by' => session('userid'),
    //                 'sss_ent_bank_updated_date' => date('Y-m-d')
    //             ];
    //             $updatelastbalinsourcebank->update($sourceb, $withdrawadvbankdata);

    //             $bbparticulars_adv_withdraw  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno')  . ' - ' . $this->request->getVar('advinvno');
    //             $withdrawlAdvArray1 = [
    //                 'sss_ddd_id' => $lastinserted_id,
    //                 'sss_bb_vendorid' => 56,
    //                 'sss_bb_vpid' => 56,
    //                 'sss_bb_particulars' => $bbparticulars_adv_withdraw,
    //                 'sss_bb_sourcebankid' => $this->request->getVar('sourcebank'),
    //                 'sss_bb_destinationbankid' => '',
    //                 'sss_bb_transamt' => $this->request->getVar('totaladvertisment'),
    //                 'sss_bb_finalamt' => $this->request->getVar('totaladvertisment'),
    //                 'sss_bb_transtype' => 'Withdrawl',
    //                 'sss_bb_iswithdrawl' => $this->request->getVar('totaladvertisment'),
    //                 'sss_bb_isdeposit' => '',
    //                 'sss_bb_transmode' => 'NA',
    //                 'sss_bb_transreffno' => 'NA',
    //                 'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //                 'sss_bb_transmonth' => $sss_bb_transmonth,
    //                 'sss_bb_lastbalance' => $opngbalofsourcebankforadv,
    //                 'sss_bb_balance' => $withdrawadvbal,
    //                 'sss_allbankid' => $this->request->getVar('sourcebank'),
    //                 // 'createdatetime' => microtime(true),
    //                 'createdate' => date('Y-m-d')
    //             ];
    //             $isBankBookEntry->insert($withdrawlAdvArray1);
    //             // end withdrawl Adv Array....

    //             //withdrawl Emp Salary...
    //             $totalempsalary1 = $this->request->getVar('sumofempRoundvalues');

    //             $getOpngBal = new Bankdetails_m();
    //             $data['opngbalforemp'] = $getOpngBal->find($sourceb);
    //             $sourcebankopeningbal = $data['opngbalforemp']['sss_ent_bank_acc_openingbal'];
    //             $clsngempsalarybal = $sourcebankopeningbal - $totalempsalary1;

                
    //             $updateempbankdata = [
    //                 'sss_ent_bank_acc_openingbal' => $clsngempsalarybal,
    //                 'sss_ent_bank_last_updated_by' => session('userid'),
    //                 'sss_ent_bank_updated_date' => date('Y-m-d')
    //             ];

    //             $updatelastbalinsourcebank->update($sourceb, $updateempbankdata);

    //             $bbparticulars_emp_withdraw  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' . $this->request->getVar('empinvno');

    //             $EmpArray1 = [
    //                 // 'sss_ddd_id' => 0,
    //                 'sss_ddd_id' => $lastinserted_id,
    //                 'sss_bb_vendorid' => 57,
    //                 'sss_bb_vpid' => 61,
    //                 'sss_bb_particulars' => $bbparticulars_emp_withdraw,
    //                 'sss_bb_sourcebankid' => $this->request->getVar('sourcebank'),
    //                 'sss_bb_destinationbankid' => '',
    //                 'sss_bb_transamt' => $this->request->getVar('sumofempRoundvalues'),
    //                 'sss_bb_finalamt' => $this->request->getVar('sumofempRoundvalues'),
    //                 'sss_bb_transtype' => 'Withdrawl',
    //                 'sss_bb_iswithdrawl' => $this->request->getVar('sumofempRoundvalues'),
    //                 'sss_bb_isdeposit' => '',
    //                 'sss_bb_transmode' => $this->request->getVar('sss_ddd_transmode'),
    //                 'sss_bb_transreffno' => $this->request->getVar('sss_ddd_transreffno'),
    //                 'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //                 'sss_bb_transmonth' => $sss_bb_transmonth,
    //                 'sss_bb_lastbalance' => $sourcebankopeningbal,
    //                 'sss_bb_balance' => $clsngempsalarybal,
    //                 'sss_allbankid' => $this->request->getVar('sourcebank'),
    //                 // 'createdatetime' => microtime(true),
    //                 'createdate' => date('Y-m-d')
    //             ];
    //             $isInserted = $isBankBookEntry->insert($EmpArray1);
    //         }
            
    //         // // update opening month balance when have next entries....
    //         $lastRecord = new Bankbook_m();
    //         $getlastRecord_transactiondate_allwithdrawl_array = $lastRecord->table('sss_tbl_bankbook')
    //             ->select('sss_bb_balance,sss_bb_transmonth')
    //             ->where('sss_allbankid', $sourceb)
    //             ->where('sss_bb_transmonth', $sss_bb_transmonth)
    //             ->orderBy('sss_bb_transactiondate', 'Desc')
    //             ->limit(1)
    //             ->get()
    //             ->getResult();

    //         $closing_Bal_withdrawlarray = $getlastRecord_transactiondate_allwithdrawl_array[0]->sss_bb_balance;

    //         $NextMonthsBalances_m = new MonthsBalances_m();
    //         $getValueofNextMonthBalance_withdrawlarray = $NextMonthsBalances_m
    //             ->where('bankid', $sourceb)
    //             ->where('month >', $month)
    //             ->where('year', $year)
    //             ->orderBy('id', 'Asc')
    //             ->get()
    //             ->getResult();

    //         for ($i = 0; $i < count($getValueofNextMonthBalance_withdrawlarray); $i++) {
    //             // Get closing bal of prev month and update in current month ... 
    //             $NextMonthsBal = new MonthsBalances_m();
    //             $NextMonthsBal->update($getValueofNextMonthBalance_withdrawlarray[$i]->id, ['openingbal' =>  $closing_Bal_withdrawlarray]);

    //              // shift closing bal for null entry...

    //             // $prevClosing_withdrawlarray = $closing_Bal_withdrawlarray;

    //              // return the closing balance of current month....
    //                 $closing_Bal_withdrawlarray = $lastRecord->table('sss_tbl_bankbook')
    //                 ->select('sss_bb_balance,sss_bb_transmonth')
    //                 ->where('sss_allbankid', $getValueofNextMonthBalance_withdrawlarray[$i]->bankid)
    //                 ->where('sss_bb_transmonth', $getValueofNextMonthBalance_withdrawlarray[$i]->balancemonth)
    //                 ->orderBy('sss_bb_transactiondate', 'Desc')
    //                 ->limit(1)
    //                 ->get()
    //                 ->getRow();


    //             $closing_Bal_withdrawlarray = $closing_Bal_withdrawlarray->sss_bb_balance;

    //             // if (!empty($closing_Bal_withdrawlarray)) {
    //             //     //     $closing_Bal_withdrawlarray = $closing_Bal_withdrawlarray->sss_bb_balance;
    //             //     // } else {
    //             //     //     $closing_Bal_withdrawlarray = $prevClosing_withdrawlarray;
    //             //     // }
                
    //         }

    //         // end update openingbalances of openingmonth...

    //         $Taxgetnextentriesby_transactiondate = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', 3)->where('sss_bb_transactiondate >', $this->request->getVar('sss_ddd_generatedate'))->orderBy('sss_bb_transactiondate', 'ASC')->get()->getRow();
            
            
    //         if ($Taxgetnextentriesby_transactiondate != '') {
                
    //             //deposite entries
    //             $tax_destinationbankid = 3;
    //             $tax_lastBalance = $Taxgetnextentriesby_transactiondate->sss_bb_lastbalance; // next entries first row of last balances...
    //             //TAX entries....
    //             $tx = $this->request->getVar('totaltax');
    //             $currentBalance_tax = $tax_lastBalance + $tx;
    //             $bbparticulars_deposite  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' . $this->request->getVar('taxinvno');
                
    //             $DepositeTaxarray = [
    //                 // 'sss_ddd_id' => 0,
    //                 'sss_ddd_id' => $lastinserted_id,
    //                 'sss_bb_vendorid' => 55,
    //                 'sss_bb_vpid' => 55,
    //                 'sss_bb_particulars' => $bbparticulars_deposite,
    //                 'sss_bb_sourcebankid' => '',
    //                 'sss_bb_destinationbankid' => 3,
    //                 'sss_bb_transamt' => $this->request->getVar('totaltax'),
    //                 'sss_bb_finalamt' => $this->request->getVar('totaltax'),
    //                 'sss_bb_transtype' => 'Deposit',
    //                 'sss_bb_iswithdrawl' => '',
    //                 'sss_bb_isdeposit' => $this->request->getVar('totaltax'),
    //                 'sss_bb_transmode' => 'NA',
    //                 'sss_bb_transreffno' => 'NA',
    //                 'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //                 'sss_bb_transmonth' => $sss_bb_transmonth,
    //                 'sss_bb_lastbalance' => $tax_lastBalance,
    //                 'sss_bb_balance' => $currentBalance_tax,
    //                 'sss_allbankid' => 3,
    //                 // // 'createdatetime' => microtime(true),
    //                 'createdate' => date('Y-m-d')
    //             ];
                
    //             $isBankBookEntry->insert($DepositeTaxarray);
                
    //             $Tax_allnextEntries = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', 3)->where('sss_bb_transactiondate >', $this->request->getVar('sss_ddd_generatedate'))->orderBy('sss_bb_transactiondate', 'ASC')->get()->getResult();

    //             foreach ($Tax_allnextEntries as $tax_entries) {

    //                 $Tax_bb_id = $tax_entries->sss_bankbook_id;
    //                 $lastBalance = $tax_entries->sss_bb_lastbalance;
    //                 $taxes = $this->request->getVar('totaltax');
    //                 $Tax_newLastBalance = $lastBalance + $taxes; // substract sum of all withdrawl from last balances...
    //                 $Tax_newcurrentBalance = $Tax_newLastBalance + $tax_entries->sss_bb_transamt;
    //                 $Tax_new_amountBalances = [
    //                     'sss_bb_lastbalance' => $Tax_newLastBalance,
    //                     'sss_bb_balance' => $Tax_newcurrentBalance,
    //                     'updatedate	' => date('Y-m-d')
    //                 ];
    //                 // echo "<pre>";print_r($Tax_new_amountBalances);
    //                 $nextBankbookentries->update($Tax_bb_id, $Tax_new_amountBalances);
    //             }

    //             $updatebalindestinationbank_tax = new Bankdetails_m();

    //             $depositetaxbankdata = [
    //                 'sss_ent_bank_acc_openingbal' => $Tax_newcurrentBalance,
    //                 'sss_ent_bank_last_updated_by' => session('userid'),
    //                 'sss_ent_bank_updated_date' => date('Y-m-d')
    //             ];
    //             $updatebalindestinationbank_tax->update($tax_destinationbankid, $depositetaxbankdata);


    //             // update next entries for tax bank in opening months balances...
    //             $lastRecord = new Bankbook_m();
    //             $getlastRecord_transactiondate_taxarray = $lastRecord->table('sss_tbl_bankbook')
    //                 ->select('sss_bb_balance,sss_bb_transmonth')
    //                 ->where('sss_allbankid', 3)
    //                 ->where('sss_bb_transmonth', $sss_bb_transmonth)
    //                 ->orderBy('sss_bb_transactiondate', 'Desc')
    //                 ->limit(1)
    //                 ->get()
    //                 ->getRow();

    //             $closing_Bal_taxarray = $getlastRecord_transactiondate_taxarray->sss_bb_balance;

    //             $NextMonthsBalances_m = new MonthsBalances_m();
    //             $getValueofNextMonthBalance_taxarray = $NextMonthsBalances_m
    //                 ->where('bankid', 3)
    //                 ->where('month >', $month)
    //                 ->where('year', $year)
    //                 ->orderBy('id', 'Asc')
    //                 ->get()
    //                 ->getResult();

    //             for ($i = 0; $i < count($getValueofNextMonthBalance_taxarray); $i++) {

    //                 // Get closing bal of prev month and update in current month ... 
    //                 $NextMonthsBal = new MonthsBalances_m();
    //                 $NextMonthsBal->update($getValueofNextMonthBalance_taxarray[$i]->id, ['openingbal' =>  $closing_Bal_taxarray]);

    //                 // shift closing bal for null entry...
    //                 // $prevClosing_taxarray = $closing_Bal_taxarray;

    //                 // return the closing balance of current month....

    //                 $closing_Bal_taxarray = $lastRecord->table('sss_tbl_bankbook')
    //                     ->select('sss_bb_balance,sss_bb_transmonth')
    //                     ->where('sss_allbankid', $getValueofNextMonthBalance_taxarray[$i]->bankid)
    //                     ->where('sss_bb_transmonth', $getValueofNextMonthBalance_taxarray[$i]->balancemonth)
    //                     ->orderBy('sss_bb_transactiondate', 'Desc')
    //                     ->limit(1)
    //                     ->get()
    //                     ->getRow();

    //                 $closing_Bal_taxarray = $closing_Bal_taxarray->sss_bb_balance;

    //                 // if (!empty($closing_Bal_taxarray)) {
    //                 // } else {
    //                 //     $closing_Bal_taxarray = $prevClosing_taxarray;
    //                 // }
    //             }

    //         } else {
                
    //             $tax_destinationbankid = 3;
    //             $getOpngBal = new Bankdetails_m();

    //             $data['opngbalfortax1'] = $getOpngBal->find($sourceb); // get source bank for tax
    //             $data['destinationbankfortax'] = $getOpngBal->find($tax_destinationbankid); // get destination bank for tax....

    //             $opngbalofsourcebankfortax = $data['opngbalfortax1']['sss_ent_bank_acc_openingbal'];
    //             $destinationbankOpngBal_tax = $data['destinationbankfortax']['sss_ent_bank_acc_openingbal'];  //deposite destination bank

    //             $taxxs = $this->request->getVar('totaltax');
    //             $tax_destinationbankclsngbal = $destinationbankOpngBal_tax + $taxxs;  // deposite balance to destination bank...
    //             $updatebalindestinationbank_tax = new Bankdetails_m();
    //             $depositetaxbankdata0 = [
    //                 'sss_ent_bank_acc_openingbal' => $tax_destinationbankclsngbal,
    //                 'sss_ent_bank_last_updated_by' => session('userid'),
    //                 'sss_ent_bank_updated_date' => date('Y-m-d')
    //             ];
    //             $updatebalindestinationbank_tax->update($tax_destinationbankid, $depositetaxbankdata0);

    //             $bbparticulars_deposite  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' . $this->request->getVar('taxinvno');

    //             $DepositeTaxarray1 = [
    //                 'sss_ddd_id' => $lastinserted_id,
    //                 'sss_bb_vendorid' => 55,
    //                 'sss_bb_vpid' => 55,
    //                 'sss_bb_particulars' => $bbparticulars_deposite,
    //                 'sss_bb_sourcebankid' => '',
    //                 'sss_bb_destinationbankid' => 3,
    //                 'sss_bb_transamt' => $this->request->getVar('totaltax'),
    //                 'sss_bb_finalamt' => $this->request->getVar('totaltax'),
    //                 'sss_bb_transtype' => 'Deposit',
    //                 'sss_bb_iswithdrawl' => '',
    //                 'sss_bb_isdeposit' => $this->request->getVar('totaltax'),
    //                 'sss_bb_transmode' => 'NA',
    //                 'sss_bb_transreffno' => 'NA',
    //                 'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //                 'sss_bb_transmonth' => $sss_bb_transmonth,
    //                 'sss_bb_lastbalance' => $destinationbankOpngBal_tax,
    //                 'sss_bb_balance' => $tax_destinationbankclsngbal,
    //                 'sss_allbankid' => 3,
    //                 'createdatetime' => microtime(true),
    //                 'createdate' => date('Y-m-d')
    //             ];
    //           // echo "<pre>";print_r($DepositeTaxarray1);exit;
    //             $isBankBookEntry->insert($DepositeTaxarray1);

    //             // update opening months balance when dont have any next tax entries ...
                
                
    //                 $lastRecord = new Bankbook_m();
    //                 $getlastRecord_transactiondate_tax = $lastRecord->table('sss_tbl_bankbook')->where('sss_allbankid',3)->orderBy('sss_bb_transactiondate', 'Desc')->limit(1)->get()->getRow();
                    
    //                 if (!empty($getlastRecord_transactiondate_tax)) {
                        
    //                     $newopningbal_tax = $getlastRecord_transactiondate_tax->sss_bb_balance;
    
    //                     $NextMonthsBalances_m = new MonthsBalances_m();
    //                     $getValueofNextMonthBalance_tax = $NextMonthsBalances_m->table('sss_openingbalance_month')->where('bankid', 3)->where('month >', $month)->where('year', $year)->orderBy('id', 'Asc')->get()->getResult();
                        
    //                     foreach ($getValueofNextMonthBalance_tax as $nextmonths_openingBalances_tax) {
    //                         $opngmonthbal_id_tax = $nextmonths_openingBalances_tax->id;
    //                         $deposite_nextmonth_opngbalances_tax = [
    //                             'openingbal' => $newopningbal_tax,
    //                         ];
                            
    //                         $NextMonthsBalances_m->update($opngmonthbal_id_tax, $deposite_nextmonth_opngbalances_tax);
    //                     }
    //                 }
                    
    //         }
            
    //         $Advgetnextentriesby_transactiondate = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', 2)->where('sss_bb_transactiondate >', $this->request->getVar('sss_ddd_generatedate'))->orderBy('sss_bb_transactiondate', 'ASC')->get()->getRow();
    //         if ($Advgetnextentriesby_transactiondate != '') 
    //         {
    //             $adv_destinationbankid = 2;
    //             $adv_lastBalance = $Advgetnextentriesby_transactiondate->sss_bb_lastbalance; // next entries first row of last balances...
    //             $advertisments = $this->request->getVar('totaladvertisment');
    //             $currentBalance_Adv = $adv_lastBalance + $advertisments;
    //             $bbparticulars_adv_deposite  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' .  $this->request->getVar('advinvno');

    //             $DepositeAdvArray = [
    //                 'sss_ddd_id' => $lastinserted_id,
    //                 'sss_bb_vendorid' => 56,
    //                 'sss_bb_vpid' => 56,
    //                 'sss_bb_particulars' => $bbparticulars_adv_deposite,
    //                 'sss_bb_sourcebankid' => '',
    //                 'sss_bb_destinationbankid' => 2,
    //                 'sss_bb_transamt' => $this->request->getVar('totaladvertisment'),
    //                 'sss_bb_finalamt' => $this->request->getVar('totaladvertisment'),
    //                 'sss_bb_transtype' => 'Deposit',
    //                 'sss_bb_iswithdrawl' => '',
    //                 'sss_bb_isdeposit' => $this->request->getVar('totaladvertisment'),
    //                 'sss_bb_transmode' => 'NA',
    //                 'sss_bb_transreffno' => 'NA',
    //                 'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //                 'sss_bb_transmonth' => $sss_bb_transmonth,
    //                 'sss_bb_lastbalance' => $adv_lastBalance,
    //                 'sss_bb_balance' => $currentBalance_Adv,
    //                 'sss_allbankid' => 2,
    //                 // 'createdatetime' => microtime(true),
    //                 'createdate' => date('Y-m-d')
    //             ];
                
    //             $isBankBookEntry->insert($DepositeAdvArray);
                
                
    //             $Adv_allnextEntries = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', 2)->where('sss_bb_transactiondate >', $this->request->getVar('sss_ddd_generatedate'))->orderBy('sss_bb_transactiondate', 'ASC')->get()->getResult();

    //             foreach ($Adv_allnextEntries as $adv_entries) {
    //                 $Adv_bb_id = $adv_entries->sss_bankbook_id;
    //                 $lastBalance = $adv_entries->sss_bb_lastbalance;
    //                 $ad = $this->request->getVar('totaladvertisment');
    //                 $Adv_newLastBalance = $lastBalance + $ad; // substract sum of all withdrawl from last balances...
    //                 $Adv_newcurrentBalance = $Adv_newLastBalance + $adv_entries->sss_bb_transamt;
    //                 $Adv_new_amountBalances = [
    //                     'sss_bb_lastbalance' => $Adv_newLastBalance,
    //                     'sss_bb_balance' => $Adv_newcurrentBalance,
    //                     'updatedate	' => date('Y-m-d')
    //                 ];
    //                 $nextBankbookentries->update($Adv_bb_id, $Adv_new_amountBalances);
    //             }

    //             $updatebalindestinationbank_withdrawl = new Bankdetails_m();
    //             $depositeadvbankdata1 = [
    //                 'sss_ent_bank_acc_openingbal' => $Adv_newcurrentBalance,
    //                 'sss_ent_bank_last_updated_by' => session('userid'),
    //                 'sss_ent_bank_updated_date' => date('Y-m-d')
    //             ];
    //             $updatebalindestinationbank_withdrawl->update($adv_destinationbankid, $depositeadvbankdata1);


    //             // update next entries for advertisment bank in opening months balances...
                
    //             $lastRecord = new Bankbook_m();
    //             $getlastRecord_transactiondate_advarray = $lastRecord->table('sss_tbl_bankbook')
    //                 ->select('sss_bb_balance,sss_bb_transmonth')
    //                 ->where('sss_allbankid', 2)
    //                 ->where('sss_bb_transmonth', $sss_bb_transmonth)
    //                 ->orderBy('sss_bb_transactiondate', 'Desc')
    //                 ->limit(1)
    //                 ->get()
    //                 ->getRow();

    //             $closing_Bal_advarray = $getlastRecord_transactiondate_advarray->sss_bb_balance;

    //             $NextMonthsBalances_m = new MonthsBalances_m();
    //             $getValueofNextMonthBalance_advarray = $NextMonthsBalances_m
    //                 ->where('bankid', 2)
    //                 ->where('month >', $month)
    //                 ->where('year', $year)
    //                 ->orderBy('id', 'Asc')
    //                 ->get()
    //                 ->getResult();

    //             for ($i = 0; $i < count($getValueofNextMonthBalance_advarray); $i++) {

    //                 // Get closing bal of prev month and update in current month ... 
    //                 $NextMonthsBal = new MonthsBalances_m();
    //                 $NextMonthsBal->update($getValueofNextMonthBalance_advarray[$i]->id, ['openingbal' =>  $closing_Bal_advarray]);

    //                 // shift closing bal for null entry...
    //                 // $prevClosing_taxarray = $closing_Bal_taxarray;

    //                 // return the closing balance of current month....

    //                 $closing_Bal_advarray = $lastRecord->table('sss_tbl_bankbook')
    //                     ->select('sss_bb_balance,sss_bb_transmonth')
    //                     ->where('sss_allbankid', $getValueofNextMonthBalance_advarray[$i]->bankid)
    //                     ->where('sss_bb_transmonth', $getValueofNextMonthBalance_advarray[$i]->balancemonth)
    //                     ->orderBy('sss_bb_transactiondate', 'Desc')
    //                     ->limit(1)
    //                     ->get()
    //                     ->getRow();

    //                 $closing_Bal_advarray = $closing_Bal_advarray->sss_bb_balance;

    //                 // if (!empty($closing_Bal_taxarray)) {
    //                 // } else {
    //                 //     $closing_Bal_taxarray = $prevClosing_taxarray;
    //                 // }
    //             }
    //         } 
    //         else {
               
    //             $adv_destinationbankid1 = 2;
    //             $getOpngBal1 = new Bankdetails_m();

    //             $data['destinationbankforadv'] = $getOpngBal1->find($adv_destinationbankid1); // get destination bank for adv....
    //             $adv_s = $this->request->getVar('totaladvertisment');
    //             $destinationbankOpngBal_adv =  $data['destinationbankforadv']['sss_ent_bank_acc_openingbal'];
    //             $adv_destinationbankclsngbal1 = $destinationbankOpngBal_adv + $adv_s; // adv deposite to destination bank
                
    //             $depositeadvbankdata1 = [
    //                 'sss_ent_bank_acc_openingbal' => $adv_destinationbankclsngbal1,
    //                 'sss_ent_bank_last_updated_by' => session('userid'),
    //                 'sss_ent_bank_updated_date' => date('Y-m-d')
    //             ];
    //             $updatelastbalinsourcebank->update($adv_destinationbankid1, $depositeadvbankdata1);

    //             $bbparticulars_adv_deposite  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' .  $this->request->getVar('advinvno');
                
    //             $DepositeAdvArray1 = [
    //                 // 'sss_ddd_id' => 0,
    //                 'sss_ddd_id' => $lastinserted_id,
    //                 'sss_bb_vendorid' => 56,
    //                 'sss_bb_vpid' => 56,
    //                 'sss_bb_particulars' => $bbparticulars_adv_deposite,
    //                 'sss_bb_sourcebankid' => '',
    //                 'sss_bb_destinationbankid' => 2,
    //                 'sss_bb_transamt' => $this->request->getVar('totaladvertisment'),
    //                 'sss_bb_finalamt' => $this->request->getVar('totaladvertisment'),
    //                 'sss_bb_transtype' => 'Deposit',
    //                 'sss_bb_iswithdrawl' => '',
    //                 'sss_bb_isdeposit' => $this->request->getVar('totaladvertisment'),
    //                 'sss_bb_transmode' => 'NA',
    //                 'sss_bb_transreffno' => 'NA',
    //                 'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //                 'sss_bb_transmonth' => $sss_bb_transmonth,
    //                 'sss_bb_lastbalance' => $destinationbankOpngBal_adv,
    //                 'sss_bb_balance' => $adv_destinationbankclsngbal1,
    //                 'sss_allbankid' => 2,
    //                 // 'createdatetime' => microtime(true),
    //                 'createdate' => date('Y-m-d')
    //             ];
    //             // echo "<pre>";print_r($DepositeAdvArray1);
    //             $isadv = $isBankBookEntry->insert($DepositeAdvArray1);

    //             //update opening month balance for advertisment bank when dont have next entries....
                
    //             $lastRecord = new Bankbook_m();
    //             $getlastRecord_transactiondate_adv = $lastRecord->table('sss_tbl_bankbook')->where('sss_allbankid',2)->orderBy('sss_bb_transactiondate', 'Desc')->limit(1)->get()->getRow();
                    
    //             if (!empty($getlastRecord_transactiondate_adv)) {
                        
    //                     $newopningbal_adv = $getlastRecord_transactiondate_adv->sss_bb_balance;
                    
    //                     $NextMonthsBalances_m = new MonthsBalances_m();
    //                     $getValueofNextMonthBalance_adv = $NextMonthsBalances_m->where('bankid', 2)->where('month >', $month)->where('year', $year)->orderBy('id', 'Asc')->get()->getResult();
                        
    //                     foreach ($getValueofNextMonthBalance_adv as $nextmonths_openingBalances_adv) {
    //                         $opngmonthbal_id_adv = $nextmonths_openingBalances_adv->id;
    //                         $deposite_nextmonth_opngbalances_adv = [
    //                             'openingbal' => $newopningbal_adv,
    //                         ];
    //                         // echo "<pre>";print_r($deposite_nextmonth_opngbalances_adv);
    //                         $NextMonthsBalances_m->update($opngmonthbal_id_adv, $deposite_nextmonth_opngbalances_adv);
    //                     }
    //                 }
            
    //         }
            
            
    //         // get empbank account and make emp's bb entry of deposite and withdrawl.....
    //         // calcualte emp tds and store it into tdstable....
            
    //         $emptds = new Tdsentries_m();
    //         $empTdsArray = [
    //             'sss_vid' => 57,
    //             'sss_vpid' => 57,
    //             'sss_bb_id' => $isInserted,
    //             'sss_bankid' => $this->request->getVar('sourcebank'),
    //             'sss_ddd_id' => $lastinserted_id,
    //             'sss_trans_date' => date('Y-m-d'),
    //             'sss_transamt' => $this->request->getVar('sumofempRoundvalues'),
    //             'sss_tdsamt' => $this->request->getVar('sss_ddd_total_tds'),
    //             'sss_tdsmonth' => $sss_bb_transmonth,
    //             'createdate' => date('Y-m-d'),
    //         ];
    //         $emptds->insert($empTdsArray);

    //         echo json_encode(array("status" => true, "message" => 'Deal Details Draft is Inserted'));
    //     }
    // }
    
    // public function insert_ddd()
    // {
    //     $validation = \Config\Services::validation();
    //     $this->validate([
    //         'sss_ddd_misc' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Please enter Misc. Amount',
    //             ]
    //         ],
    //         'sss_ddd_sbamt_tdsper' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Select TDS Percent',
    //             ]
    //         ],
    //         'sss_ddd_cirilroyality_tdsper' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Select TDS Percent'
    //             ]
    //         ],
    //         'sss_ddd_unknown' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Mention Required Particulars',
    //             ]
    //         ],
    //         'sss_ddd_unknownamt' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Enter Particulars Amount',
    //             ]
    //         ],
    //         'sss_ddd_outcomeroundamt.*' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Select TDS Percent',
    //             ]
    //         ],
    //         'sss_ddd_generatedate' => [
    //             'rules' => 'required',
    //             'errors' => [
    //                 'required' => 'Please Select Date',
    //             ]
    //         ],

    //     ]);
    //     if ($validation->run() == FALSE) {
    //         $errors = $validation->getErrors();
    //         echo json_encode(['code' => 0, 'error' => $errors]);
    //     } else {
    //         unset($_POST['sss_ddd_service_fees']);
    //         unset($_POST['sss_ddd_service_gst']);
    //         unset($_POST['sss_ddd_sbbrkg']);
    //         unset($_POST['sss_ddd_cirilroyality']);
    //         unset($_POST['sss_ddd_gst']);
    //         unset($_POST['sss_ddd_miscexp']);

    //         $dddempamt = 0;
    //         $depositedddempamt = 0;
    //         $embankid = 0;
    //         $opngbalfordddempsfromsourcebank = 0;
    //         $opngbalofsourcebankfortax = 0;
    //         $totaltax = 0;
    //         $withdrawltaxamount = 0;
    //         $tax_destinationbankclsngbal = 0;
    //         $destinationbankOpngBal_tax = 0;
    //         $tax_destinationbankclsngbal = 0;
    //         $opngbalofsourcebankforadv = 0;
    //         $destinationbankOpngBal_adv = 0;
    //         $totaladv = 0;
    //         $withdrawadvbal = 0;
    //         $adv_destinationbankclsngbal = 0;
    //         $clsngempsalarybal = 0;
    //         $sourcebankopeningbal = 0;
    //         $totalempsalary = 0;
    //         $sumofwithdrawled = 0;
    //         $outcomeno = count($_POST['sss_ddd_oc_id']);
    //         $empno = count($_POST['sss_emp_id']);


    //         $payment = new Paymentreceived_m();
    //         $getsourcebankid = $payment->table('sss_tbl_paymentreceived')->where('sss_pr_id', $this->request->getVar('sss_pr_id'))->get()->getRow();

    //         $invoice = new CreateInvoice_m();
    //         $getInvoice = $invoice->find($getsourcebankid->sss_inv_id);
    //         $invBankid = $getInvoice['sss_inv_bankid']; // getbank id for checking into loop of balance reflushing....
    //         $month = 0;
    //         $year = 0;
    //         $dateComps = date_parse($this->request->getVar('sss_ddd_generatedate'));
    //         $year = $dateComps['year'];
    //         $month = $dateComps['month'];
    //         $sss_bb_transmonth = $month . '-' . $year;

    //         $updatelastbalinsourcebank = new Bankdetails_m();
    //         $lastRecord = new Bankbook_m();
    //         $NextMonthsBalances_m = new MonthsBalances_m();
    //         $isBankBookEntry = new Bankbook_m();
    //         $nextBankbookentries = new Bankbook_m();

    //         // save to ddd table....
    //         $insertDDDrecord = new Dealdetaildraft_m();
    //         $ddd_data = [
    //             'sss_ddc_id' => $this->request->getVar('sss_ddc_id'),
    //             'sss_pr_id' => $this->request->getVar('sss_pr_id'),
    //             'sss_ddd_misc' => $this->request->getVar('sss_ddd_misc'),
    //             'sss_ddd_generatedate' => $this->request->getVar('sss_ddd_generatedate'),
    //             'sss_ddd_shno' => $this->request->getVar('sss_ddd_shno'),
    //             'sss_ddd_transmode' => $this->request->getVar('sss_ddd_transmode'),
    //             'sss_ddd_transreffno' => $this->request->getVar('sss_ddd_transreffno'),
    //             'sss_ddd_sbamt_amt' => $this->request->getVar('sss_ddd_sbamt_amt'),
    //             'sss_ddd_sbamt_tdsper' =>  $this->request->getVar('sss_ddd_sbamt_tdsper'),
    //             'sss_ddd_sbamt_tds' => $this->request->getVar('sss_ddd_sbamt_tds'),
    //             'sss_ddd_cirilroyalityamt' => $this->request->getVar('sss_ddd_cirilroyalityamt'),
    //             'sss_ddd_cirilroyality_tdsper' => $this->request->getVar('sss_ddd_cirilroyality_tdsper'),
    //             'sss_ddd_cirilroyality_tds' => $this->request->getVar('sss_ddd_cirilroyality_tds'),
    //             'sss_ddd_unknown' => $this->request->getVar('sss_ddd_unknown'),
    //             'sss_ddd_unknownamt' => $this->request->getVar('sss_ddd_unknownamt'),
    //             'sss_ddd_unknown_tdsper' => $this->request->getVar('sss_ddd_unknown_tdsper'),
    //             'sss_ddd_unknown_tds' => $this->request->getVar('sss_ddd_unknown_tds'),
    //             'sss_ddd_ourshare' => $this->request->getVar('sss_ddd_ourshare'),
    //             'sss_ddd_gst' => $this->request->getVar('sss_ddd_gst'),
    //             'sss_ddd_gst_amt' => $this->request->getVar('sss_ddd_gst_amt'),
    //             'sss_ddd_gst_rounded' => $this->request->getVar('sss_ddd_gst_rounded'),
    //             'sss_ddd_gst_total' => $this->request->getVar('sss_ddd_gst_total'),
    //             'sss_ddd_gst_tds' => $this->request->getVar('sss_ddd_gst_tds'),
    //             'sss_ddd_gst_finalamt' => $this->request->getVar('sss_ddd_gst_finalamt'),
    //             'sss_ddd_total_roundvalue' => $this->request->getVar('sss_ddd_total_roundvalue'),
    //             'sumofempRoundvalues' => $this->request->getVar('sumofempRoundvalues'),
    //             'sss_ddd_sumofroundvalue' => $this->request->getVar('sss_ddd_sumofroundvalue'),
    //             'sss_ddd_total_tds' => $this->request->getVar('sss_ddd_total_tds'),
    //             'sss_ddd_total_finalamt' => $this->request->getVar('sss_ddd_total_finalamt'),
    //             'sss_ddd_balanceincurrent' => $this->request->getVar('sss_ddd_balanceincurrent'),
    //             'sss_ddd_balanceincurrentinper' => $this->request->getVar('sss_ddd_balanceincurrentinper'),
    //             'sss_ddd_status' => true,
    //             'sss_ddd_createby' => session('userid'),
    //             'sss_ddd_createdate' => date('Y-m-d')
    //         ];
    //         // echo "<pre>";print_r($ddd_data);

    //         $isDDDInserted = $insertDDDrecord->insert($ddd_data);
    //         $lastinserted_id = $insertDDDrecord->insertID();
    //         //  $lastinserted_id = 0;  
    //         $insertby = session('userid');
    //         $insertdate = date('Y-m-d');

    //         $sourceb = $this->request->getVar('sourcebank');

    //         $isOutcomes = new DDD_outcome_m();

    //         for ($i = 0; $i < $outcomeno; $i++) {
    //             $outcomevalues = [

    //                 'sss_ddd_id' => $lastinserted_id,
    //                 'sss_ddd_oc_id' => $_POST['sss_ddd_oc_id'][$i],
    //                 'sss_ddd_outcomeamt' => $_POST['sss_ddd_outcomeamt'][$i],
    //                 'sss_ddd_outcomeroundamt' => $_POST['sss_ddd_outcomeroundamt'][$i],
    //                 'sss_ddd_outcometotalamt' => $_POST['sss_ddd_outcometotalamt'][$i],
    //                 'sss_dddoutcome_tds' => $_POST['sss_dddoutcome_tds'][$i],
    //                 'sss_ddd_outcomefinalamt' => $_POST['sss_ddd_outcomefinalamt'][$i],
    //                 'sss_dddoutcome_createdate' => $insertby,
    //                 'sss_dddoutcome_createdby' => $insertdate,
    //             ];
    //             $isOutcomes->insert($outcomevalues);
    //         }

    //         //create bb entries for TAX advertisment and employees..
    //         // $dateComps = date_parse(date('Y-m-d'));

    //         // echo $sss_bb_transmonth;exit;
    //         $isEmps = new DDD_emp_m();

    //         for ($i = 0; $i < $empno; $i++) {
    //             $empvalues = [
    //                 // 'sss_ddd_id' => 0,
    //                 'sss_ddd_id' => $lastinserted_id,
    //                 'sss_emp_id' => $_POST['sss_emp_id'][$i],
    //                 'sss_dddemp_amt' => $_POST['sss_ddd_empamt'][$i],
    //                 'sss_dddemp_roundedamt' => $_POST['sss_ddd_emproundamt'][$i],
    //                 'sss_dddemp_totalamt' => null,
    //                 'sss_dddemp_tds' => $_POST['sss_ddd_emptdsamt'][$i],
    //                 'sss_dddemp_finalamt' => $_POST['sss_ddd_empfinalamt'][$i],
    //                 'sss_dddemp_createdby' => $insertby,
    //                 'sss_dddemp_createdate' => $insertdate,
    //             ];
    //             $isEmps->insert($empvalues);

    //             $emp = new Employee_m();
    //             $getbanksemp0 = $emp->select('sss_emp_id,sss_emp_bankid')->where('sss_hadbank', "Yes")->where('sss_emp_id', $_POST['sss_emp_id'][$i])->get()->getRow();
    //             // echo $getbanksemp0['sss_emp_id'];
    //             $dddempamt = 0;

    //             if (isset($getbanksemp0->sss_emp_id) && isset($getbanksemp0->sss_emp_bankid)) {

    //                 $empid = $getbanksemp0->sss_emp_id;
    //                 $embankid = $getbanksemp0->sss_emp_bankid;

    //                 $empsoutcomes = $isEmps->select('sss_emp_id,sss_dddemp_amt')->where('sss_emp_id', $empid)->orderBy('id', 'Desc')->get()->getRow();
    //                 $dddempamt = $empsoutcomes->sss_dddemp_amt; // get emp amount which had bank...

    //                 $Empgetnextentriesby_transactiondate = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', $embankid)->where('sss_bb_transactiondate >', $this->request->getVar('sss_ddd_generatedate'))->orderBy('sss_bb_transactiondate', 'ASC')->get()->getRow();

    //                 if ($Empgetnextentriesby_transactiondate != '') {
    //                     // echo "Next Employee Entries";
    //                     // echo "<br>";
    //                     $Emp_lastBalance = $Empgetnextentriesby_transactiondate->sss_bb_lastbalance; // next entries first row of last balances...
    //                     $currentBalance_Emp = $Emp_lastBalance + $dddempamt;

    //                     $bbparticulars_dddempdeposite = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' . 'Employee Commission';

    //                     $DepositeDDDEmparray2 = [
    //                         // 'sss_ddd_id' => 0,
    //                         'sss_ddd_id' => $lastinserted_id,
    //                         'sss_bb_vendorid' => 57,
    //                         'sss_bb_vpid' => 61,
    //                         'sss_bb_particulars' => $bbparticulars_dddempdeposite,
    //                         'sss_bb_sourcebankid' => '',
    //                         'sss_bb_destinationbankid' => $embankid,
    //                         'sss_bb_transamt' => $dddempamt,
    //                         'sss_bb_finalamt' => $dddempamt,
    //                         'sss_bb_transtype' => 'Deposit',
    //                         'sss_bb_iswithdrawl' => '',
    //                         'sss_bb_isdeposit' => $dddempamt,
    //                         'sss_bb_transmode' => $this->request->getVar('sss_ddd_transmode'),
    //                         'sss_bb_transreffno' => $this->request->getVar('sss_ddd_transreffno'),
    //                         'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //                         'sss_bb_transmonth' => $sss_bb_transmonth,
    //                         'sss_bb_lastbalance' => $Emp_lastBalance,
    //                         'sss_bb_balance' => $currentBalance_Emp,
    //                         'sss_allbankid' => $embankid,
    //                         // 'createdatetime' => microtime(true),
    //                         'createdate' => date('Y-m-d')
    //                     ];

    //                     $isBankBookEntry->insert($DepositeDDDEmparray2);

    //                     // deposite amount to main bank...
    //                     $getOpngBaldddemp = new Bankdetails_m();
    //                     $data['opngbalfordddemp'] = $getOpngBaldddemp->find($embankid);
    //                     $opngbalfordddempsfromsempbank = $data['opngbalfordddemp']['sss_ent_bank_acc_openingbal'];
    //                     $depositedddempamt0 = $opngbalfordddempsfromsempbank + $currentBalance_Emp;  // deposite balance to destination bank...

    //                     $Emp_allnextEntries = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', $embankid)->where('sss_bb_transactiondate >', $this->request->getVar('sss_ddd_generatedate'))->orderBy('sss_bb_transactiondate', 'ASC')->get()->getResult();

    //                     foreach ($Emp_allnextEntries as $emp_entries) {
    //                         $Emp_bb_id = $emp_entries->sss_bankbook_id;
    //                         $lastBalance = $emp_entries->sss_bb_lastbalance;
    //                         $Emp_newLastBalance = $lastBalance + $dddempamt; // substract sum of all withdrawl from last balances...
    //                         $Emp_newcurrentBalance = $Emp_newLastBalance + $emp_entries->sss_bb_transamt;
    //                         $emp_new_amountBalances = [
    //                             'sss_bb_lastbalance' => $Emp_newLastBalance,
    //                             'sss_bb_balance' => $Emp_newcurrentBalance,
    //                             'updatedate	' => date('Y-m-d')
    //                         ];

    //                         $nextBankbookentries->update($Emp_bb_id, $emp_new_amountBalances);
    //                     }
    //                     $updatebalindestinationbank_dddemp = new Bankdetails_m();
    //                     $depositeldddempamtdata = [
    //                         'sss_ent_bank_acc_openingbal' => $Emp_newcurrentBalance,
    //                         'sss_ent_bank_last_updated_by' => session('userid'),
    //                         'sss_ent_bank_updated_date' => date('Y-m-d')
    //                     ];
    //                     $updatebalindestinationbank_dddemp->update($embankid, $depositeldddempamtdata);

    //                     // update opening months balancess for employee commission...

    //                     $lastRecord_emp = new Bankbook_m();
    //                     $getlastRecord_transactiondate_emparray = $lastRecord_emp->table('sss_tbl_bankbook')
    //                         ->select('sss_bb_balance,sss_bb_transmonth')
    //                         ->where('sss_allbankid', $embankid)
    //                         ->where('sss_bb_transmonth', $sss_bb_transmonth)
    //                         ->orderBy('sss_bb_transactiondate', 'Desc')
    //                         ->limit(1)
    //                         ->get()
    //                         ->getRow();

    //                     $closing_Bal_emparray = $getlastRecord_transactiondate_emparray->sss_bb_balance;


    //                     $getValueofNextMonthBalance_emparray = $NextMonthsBalances_m
    //                         ->where('bankid', $embankid)
    //                         ->where('month >', $month)
    //                         ->where('year', $year)
    //                         ->orderBy('id', 'Asc')
    //                         ->get()
    //                         ->getResult();

    //                     for ($i = 0; $i < count($getValueofNextMonthBalance_emparray); $i++) {

    //                         // Get closing bal of prev month and update in current month ... 
    //                         $NextMonthsBal = new MonthsBalances_m();
    //                         $NextMonthsBal->update($getValueofNextMonthBalance_emparray[$i]->id, ['openingbal' =>  $closing_Bal_emparray]);

    //                         // shift closing bal for null entry...
    //                         $prevClosing_emparray = $closing_Bal_emparray;

    //                         // return the closing balance of current month....

    //                         $closing_Bal_emparray = $lastRecord->table('sss_tbl_bankbook')
    //                             ->select('sss_bb_balance,sss_bb_transmonth')
    //                             ->where('sss_allbankid', $getValueofNextMonthBalance_emparray[$i]->bankid)
    //                             ->where('sss_bb_transmonth', $getValueofNextMonthBalance_emparray[$i]->balancemonth)
    //                             ->orderBy('sss_bb_transactiondate', 'Desc')
    //                             ->get()
    //                             ->getRow();

    //                         if (!empty($closing_Bal_emparray)) {
    //                             $closing_Bal_emparray = $closing_Bal_emparray->sss_bb_balance;
    //                         } else {
    //                             $closing_Bal_emparray = $prevClosing_emparray;
    //                         }
    //                     }
    //                 } else {

    //                     // get source bank amout for ddd emp....
    //                     $getOpngBaldddempfromsourcebank = new Bankdetails_m();
    //                     $data['opngbalfordddemp1'] = $getOpngBaldddempfromsourcebank->find($sourceb);
    //                     $opngbalfordddempsfromsourcebank = $data['opngbalfordddemp1']['sss_ent_bank_acc_openingbal'];

    //                     // get ddd emp bank amount...
    //                     $getOpngBaldddemp1 = new Bankdetails_m();
    //                     $data['opngbalfordddemp'] = $getOpngBaldddemp1->find($embankid);

    //                     $opngbalfordddempsfromsempbank = $data['opngbalfordddemp']['sss_ent_bank_acc_openingbal'];
    //                     // deposite ddd emp amount...

    //                     $depositedddempamt = $opngbalfordddempsfromsempbank + $dddempamt;  // deposite balance to destination bank...

    //                     $updatebalindestinationbank_dddemp = new Bankdetails_m();
    //                     $depositeldddempamtdata = [
    //                         'sss_ent_bank_acc_openingbal' => $depositedddempamt,
    //                         'sss_ent_bank_last_updated_by' => session('userid'),
    //                         'sss_ent_bank_updated_date' => date('Y-m-d')
    //                     ];
    //                     $updatebalindestinationbank_dddemp->update($embankid, $depositeldddempamtdata);

    //                     $bbparticulars_dddempdeposite = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' . 'Employee Commission';

    //                     $DepositeDDDEmparray = [
    //                         // 'sss_ddd_id' => 0,
    //                         'sss_ddd_id' => $lastinserted_id,
    //                         'sss_bb_vendorid' => 57,
    //                         'sss_bb_vpid' => 61,
    //                         'sss_bb_particulars' => $bbparticulars_dddempdeposite,
    //                         'sss_bb_sourcebankid' => '',
    //                         'sss_bb_destinationbankid' => $embankid,
    //                         'sss_bb_transamt' => $dddempamt,
    //                         'sss_bb_finalamt' => $dddempamt,
    //                         'sss_bb_transtype' => 'Deposit',
    //                         'sss_bb_iswithdrawl' => '',
    //                         'sss_bb_isdeposit' => $dddempamt,
    //                         'sss_bb_transmode' => $this->request->getVar('sss_ddd_transmode'),
    //                         'sss_bb_transreffno' => $this->request->getVar('sss_ddd_transreffno'),
    //                         'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //                         'sss_bb_transmonth' => $sss_bb_transmonth,
    //                         'sss_bb_lastbalance' => $opngbalfordddempsfromsempbank,
    //                         'sss_bb_balance' => $depositedddempamt,
    //                         'sss_allbankid' => $embankid,
    //                         // 'createdatetime' => microtime(true),
    //                         'createdate' => date('Y-m-d')
    //                     ];
    //                     $isBankBookEntry->insert($DepositeDDDEmparray);

    //                     // update opening month balance when dont have next entries for employee commission......


    //                     $getlastRecord_transactiondate_emp = $lastRecord->table('sss_tbl_bankbook')->where('sss_allbankid', $embankid)->where('sss_bb_transmonth', $sss_bb_transmonth)->orderBy('sss_bb_transactiondate', 'Desc')->get()->getRow();


    //                     if (!empty($getlastRecord_transactiondate_emp)) {

    //                         $newopningbal_emp = $getlastRecord_transactiondate_emp->sss_bb_balance;

    //                         $getValueofNextMonthBalance_emp = $NextMonthsBalances_m->table('sss_openingbalance_month')->where('bankid', $embankid)->where('month >', $month)->where('year', $year)->orderBy('id', 'Asc')->get()->getResult();

    //                         foreach ($getValueofNextMonthBalance_emp as $nextmonths_openingBalances_emp) {
    //                             $opngmonthbal_id_emp = $nextmonths_openingBalances_emp->id;
    //                             $deposite_nextmonth_opngbalances_emp = [
    //                                 'openingbal' => $newopningbal_emp,
    //                             ];
    //                             // echo "<pre>";print_r($deposite_nextmonth_opngbalances_emp);
    //                             $NextMonthsBalances_m->update($opngmonthbal_id_emp, $deposite_nextmonth_opngbalances_emp);
    //                         }
    //                     }
    //                 }
    //             }
    //         }

    //         // all withdrawl entry...
    //         $getnextentriesby_transactiondate = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', $invBankid)->where('sss_bb_transactiondate >', $this->request->getVar('sss_ddd_generatedate'))->where('sss_bb_transmonth', $sss_bb_transmonth)->orderBy('sss_bb_transactiondate', 'ASC')->get()->getRow();
    //         if ($getnextentriesby_transactiondate != '') {
    //             echo "all Withdrawl";
    //             exit;
    //             $getOpngBal = new Bankdetails_m();
    //             $data['opngbal'] = $getOpngBal->find($sourceb);
    //             $opngbalofsourcebank = $data['opngbal']['sss_ent_bank_acc_openingbal'];
    //             // echo "Source Opening Bal -".$opngbalofsourcebank;exit;
    //             //withdrawl entries....
    //             $tax_lastBalance = $getnextentriesby_transactiondate->sss_bb_lastbalance; // next entries first row of last balances...

    //             $totalTaxx =  $this->request->getVar('totaltax');
    //             // echo "Total Tax".$totalTaxx;exit;
    //             $currentBalance_tax = $tax_lastBalance - $totalTaxx;


    //             $bbparticulars_deposite  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' . $this->request->getVar('taxinvno');

    //             $WithdrawlTaxarray = [
    //                 // 'sss_ddd_id' => 0,
    //                 'sss_ddd_id' => $lastinserted_id,
    //                 'sss_bb_vendorid' => 55,
    //                 'sss_bb_vpid' => 55,
    //                 'sss_bb_particulars' => $bbparticulars_deposite,
    //                 'sss_bb_sourcebankid' => $this->request->getVar('sourcebank'),
    //                 'sss_bb_destinationbankid' => '',
    //                 'sss_bb_transamt' => $this->request->getVar('totaltax'),
    //                 'sss_bb_finalamt' => $this->request->getVar('totaltax'),
    //                 'sss_bb_transtype' => 'Withdrawl',
    //                 'sss_bb_iswithdrawl' => $this->request->getVar('totaltax'),
    //                 'sss_bb_isdeposit' => '',
    //                 'sss_bb_transmode' => 'NA',
    //                 'sss_bb_transreffno' => 'NA',
    //                 'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //                 'sss_bb_transmonth' => $sss_bb_transmonth,
    //                 'sss_bb_lastbalance' => $tax_lastBalance,
    //                 'sss_bb_balance' => $currentBalance_tax,
    //                 'sss_allbankid' => $this->request->getVar('sourcebank'),
    //                 // 'createdatetime' => microtime(true),
    //                 'createdate' => date('Y-m-d')

    //             ];
    //             $isBankBookEntry->insert($WithdrawlTaxarray);


    //             // advetisment entries....
    //             $totaladv = $this->request->getVar('totaladvertisment');
    //             $get_Adv_lastBalance = $currentBalance_tax;
    //             $get_Adv_currentBalance = $currentBalance_tax - $totaladv;
    //             $bbparticulars_adv_withdraw  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno')  . ' - ' . $this->request->getVar('advinvno');
    //             $withdrawlAdvArray = [
    //                 // 'sss_ddd_id' => 0,
    //                 'sss_ddd_id' => $lastinserted_id,
    //                 'sss_bb_vendorid' => 56,
    //                 'sss_bb_vpid' => 56,
    //                 'sss_bb_particulars' => $bbparticulars_adv_withdraw,
    //                 'sss_bb_sourcebankid' => $this->request->getVar('sourcebank'),
    //                 'sss_bb_destinationbankid' => '',
    //                 'sss_bb_transamt' => $this->request->getVar('totaladvertisment'),
    //                 'sss_bb_finalamt' => $this->request->getVar('totaladvertisment'),
    //                 'sss_bb_transtype' => 'Withdrawl',
    //                 'sss_bb_iswithdrawl' => $this->request->getVar('totaladvertisment'),
    //                 'sss_bb_isdeposit' => '',
    //                 'sss_bb_transmode' => 'NA',
    //                 'sss_bb_transreffno' => 'NA',
    //                 'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //                 'sss_bb_transmonth' => $sss_bb_transmonth,
    //                 'sss_bb_lastbalance' => $get_Adv_lastBalance,
    //                 'sss_bb_balance' => $get_Adv_currentBalance,
    //                 'sss_allbankid' => $this->request->getVar('sourcebank'),
    //                 // 'createdatetime' => microtime(true),
    //                 'createdate' => date('Y-m-d')
    //             ];
    //             $isBankBookEntry->insert($withdrawlAdvArray);

    //             //Emp Salary...
    //             $totalempsalary = $this->request->getVar('sumofempRoundvalues');
    //             $get_empsalary_lastBalance = $get_Adv_currentBalance;
    //             $get_Empsalary_currentBalance = $get_empsalary_lastBalance - $totalempsalary;
    //             $bbparticulars_emp_withdraw  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' . $this->request->getVar('empinvno');

    //             $EmpArray = [
    //                 // 'sss_ddd_id' => 0,
    //                 'sss_ddd_id' => $lastinserted_id,
    //                 'sss_bb_vendorid' => 57,
    //                 'sss_bb_vpid' => 61,
    //                 'sss_bb_particulars' => $bbparticulars_emp_withdraw,
    //                 'sss_bb_sourcebankid' => $this->request->getVar('sourcebank'),
    //                 'sss_bb_destinationbankid' => '',
    //                 'sss_bb_transamt' => $this->request->getVar('sumofempRoundvalues'),
    //                 'sss_bb_finalamt' => $this->request->getVar('sumofempRoundvalues'),
    //                 'sss_bb_transtype' => 'Withdrawl',
    //                 'sss_bb_iswithdrawl' => $this->request->getVar('sumofempRoundvalues'),
    //                 'sss_bb_isdeposit' => '',
    //                 'sss_bb_transmode' => $this->request->getVar('sss_ddd_transmode'),
    //                 'sss_bb_transreffno' => $this->request->getVar('sss_ddd_transreffno'),
    //                 'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //                 'sss_bb_transmonth' => $sss_bb_transmonth,
    //                 'sss_bb_lastbalance' => $get_empsalary_lastBalance,
    //                 'sss_bb_balance' => $get_Empsalary_currentBalance,
    //                 'sss_allbankid' => $this->request->getVar('sourcebank'),
    //                 // 'createdatetime' => microtime(true),
    //                 'createdate' => date('Y-m-d')
    //             ];
    //             $isInserted = $isBankBookEntry->insert($EmpArray);

    //             $allEntries = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', $invBankid)->where('sss_bb_transactiondate >', $this->request->getVar('sss_ddd_generatedate'))->orderBy('sss_bb_transactiondate', 'ASC')->get()->getResult();
    //             $sumofwithdrawled = $this->request->getVar('totaltax') + $this->request->getVar('totaladvertisment') + $this->request->getVar('sumofempRoundvalues');

    //             foreach ($allEntries as $bb_entries) {

    //                 if ($bb_entries->sss_bb_transtype == 'Deposit') {
    //                     $Bb_id = $bb_entries->sss_bankbook_id;
    //                     $lastBalance = $bb_entries->sss_bb_lastbalance;
    //                     $newLastBalance = $lastBalance - $sumofwithdrawled; // substract sum of all withdrawl from last balances...
    //                     $newcurrentBalance = $newLastBalance + $bb_entries->sss_bb_transamt;
    //                     $deposite_new_amountBalances = [
    //                         'sss_bb_lastbalance' => $newLastBalance,
    //                         'sss_bb_balance' => $newcurrentBalance,
    //                         'updatedate	' => date('Y-m-d')
    //                     ];

    //                     $nextBankbookentries->update($Bb_id, $deposite_new_amountBalances);
    //                     $withdrawbankdata = [
    //                         'sss_ent_bank_acc_openingbal' => $newcurrentBalance,
    //                         'sss_ent_bank_last_updated_by' => session('userid'),
    //                         'sss_ent_bank_updated_date' => date('Y-m-d')
    //                     ];
    //                     $getOpngBal->update($sourceb, $withdrawbankdata);

    //                     // update bank for employee commission in openingmonths bank...

    //                 } else {
    //                     // when next entries will be withdrawl...
    //                     $Bb_id = $bb_entries->sss_bankbook_id;
    //                     $lastBalance = $bb_entries->sss_bb_lastbalance;

    //                     $newLastBalance = $lastBalance - $sumofwithdrawled;

    //                     $newcurrentBalance = $newLastBalance - $bb_entries->sss_bb_transamt;

    //                     $withdrwl_new_amountBalances = [
    //                         'sss_bb_lastbalance' => $newLastBalance,
    //                         'sss_bb_balance' => $newcurrentBalance,
    //                         'updatedate	' => date('Y-m-d')
    //                     ];
    //                     $nextBankbookentries->update($Bb_id, $withdrwl_new_amountBalances);

    //                     $withdrawbankdata1 = [
    //                         'sss_ent_bank_acc_openingbal' => $newcurrentBalance,
    //                         'sss_ent_bank_last_updated_by' => session('userid'),
    //                         'sss_ent_bank_updated_date' => date('Y-m-d')
    //                     ];
    //                     $getOpngBal->update($sourceb, $withdrawbankdata1);
    //                 }
    //             }
                
    //               $getlastRecord_transactiondate_allwithdrawl_array = $lastRecord->table('sss_tbl_bankbook')
    //             ->select('sss_bb_balance,sss_bb_transmonth')
    //             ->where('sss_allbankid', $sourceb)
    //             ->where('sss_bb_transmonth', $sss_bb_transmonth)
    //             ->orderBy('sss_bb_transactiondate', 'Desc')
    //             ->limit(1)
    //             ->get()
    //             ->getResult();

    //         $closing_Bal_withdrawlarray = $getlastRecord_transactiondate_allwithdrawl_array[0]->sss_bb_balance;


    //         $getValueofNextMonthBalance_withdrawlarray = $NextMonthsBalances_m
    //             ->where('bankid', $sourceb)
    //             ->where('month >', $month)
    //             ->where('year', $year)
    //             ->orderBy('id', 'Asc')
    //             ->get()
    //             ->getResult();

    //         for ($i = 0; $i < count($getValueofNextMonthBalance_withdrawlarray); $i++) {
    //             // Get closing bal of prev month and update in current month ... 
    //             $NextMonthsBal = new MonthsBalances_m();
    //             $NextMonthsBal->update($getValueofNextMonthBalance_withdrawlarray[$i]->id, ['openingbal' =>  $closing_Bal_withdrawlarray]);

    //             // shift closing bal for null entry...

    //             $prevClosing_withdrawlarray = $closing_Bal_withdrawlarray;

    //             // return the closing balance of current month....
    //             $closing_Bal_withdrawlarray = $lastRecord->table('sss_tbl_bankbook')
    //                 ->select('sss_bb_balance,sss_bb_transmonth')
    //                 ->where('sss_allbankid', $getValueofNextMonthBalance_withdrawlarray[$i]->bankid)
    //                 ->where('sss_bb_transmonth', $getValueofNextMonthBalance_withdrawlarray[$i]->balancemonth)
    //                 ->orderBy('sss_bb_transactiondate', 'Desc')
    //                 ->limit(1)
    //                 ->get()
    //                 ->getRow();


    //             $closing_Bal_withdrawlarray = $closing_Bal_withdrawlarray->sss_bb_balance;

    //             if (!empty($closing_Bal_withdrawlarray)) {
    //                 $closing_Bal_withdrawlarray = $closing_Bal_withdrawlarray->sss_bb_balance;
    //             } else {
    //                 $closing_Bal_withdrawlarray = $prevClosing_withdrawlarray;
    //             }
    //         }
    //         } else {
    //                 // echo "No nwxt all Withdrawl";
                
    //             //update bank balance....
    //             $totaltax = $this->request->getVar('totaltax');
    //             $getOpngBal = new Bankdetails_m();
    //             $data['opngbalfortax'] = $getOpngBal->find($sourceb);
    //             $opngbalofsourcebankfortax = $data['opngbalfortax']['sss_ent_bank_acc_openingbal'];

    //             $withdrawltaxamount = $opngbalofsourcebankfortax - $totaltax; // withdraw tax from source bank....
    //             $withdrawtaxbankdata0 = [
    //                 'sss_ent_bank_acc_openingbal' => $withdrawltaxamount,
    //                 'sss_ent_bank_last_updated_by' => session('userid'),
    //                 'sss_ent_bank_updated_date' => date('Y-m-d')
    //             ];
    //             $updatelastbalinsourcebank->update($sourceb, $withdrawtaxbankdata0);

    //             $bbparticulars_deposite  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' . $this->request->getVar('taxinvno');
                
    //             $WithdrawlTaxarray1 = [
    //                 // 'sss_ddd_id' => 0,
    //                 'sss_ddd_id' => $lastinserted_id,
    //                 'sss_bb_vendorid' => 55,
    //                 'sss_bb_vpid' => 55,
    //                 'sss_bb_particulars' => $bbparticulars_deposite,
    //                 'sss_bb_sourcebankid' => $this->request->getVar('sourcebank'),
    //                 'sss_bb_destinationbankid' => '',
    //                 'sss_bb_transamt' => $this->request->getVar('totaltax'),
    //                 'sss_bb_finalamt' => $this->request->getVar('totaltax'),
    //                 'sss_bb_transtype' => 'Withdrawl',
    //                 'sss_bb_iswithdrawl' => $this->request->getVar('totaltax'),
    //                 'sss_bb_isdeposit' => '',
    //                 'sss_bb_transmode' => 'NA',
    //                 'sss_bb_transreffno' => 'NA',
    //                 'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //                 'sss_bb_transmonth' => $sss_bb_transmonth,
    //                 'sss_bb_lastbalance' => $opngbalofsourcebankfortax,
    //                 'sss_bb_balance' => $withdrawltaxamount,
    //                 'sss_allbankid' => $this->request->getVar('sourcebank'),
    //                 // 'createdatetime' => microtime(true),
    //                 'createdate' => date('Y-m-d')
    //             ];
    //             $isBankBookEntry->insert($WithdrawlTaxarray1);

    //             // withdrawl Adv Array....
    //             $getOpngBal = new Bankdetails_m();
    //             $data['opngbalforadv'] = $getOpngBal->find($sourceb);
    //             $opngbalofsourcebankforadv = $data['opngbalforadv']['sss_ent_bank_acc_openingbal'];
    //             $totaladv1 = $this->request->getVar('totaladvertisment');
    //             $withdrawadvbal = $opngbalofsourcebankforadv - $totaladv1; // withdrawl bank balance

    //             $withdrawadvbankdata = [
    //                 'sss_ent_bank_acc_openingbal' => $withdrawadvbal,
    //                 'sss_ent_bank_last_updated_by' => session('userid'),
    //                 'sss_ent_bank_updated_date' => date('Y-m-d')
    //             ];
    //             $updatelastbalinsourcebank->update($sourceb, $withdrawadvbankdata);

    //             $bbparticulars_adv_withdraw  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno')  . ' - ' . $this->request->getVar('advinvno');
    //             $withdrawlAdvArray1 = [
    //                 'sss_ddd_id' => $lastinserted_id,
    //                 'sss_bb_vendorid' => 56,
    //                 'sss_bb_vpid' => 56,
    //                 'sss_bb_particulars' => $bbparticulars_adv_withdraw,
    //                 'sss_bb_sourcebankid' => $this->request->getVar('sourcebank'),
    //                 'sss_bb_destinationbankid' => '',
    //                 'sss_bb_transamt' => $this->request->getVar('totaladvertisment'),
    //                 'sss_bb_finalamt' => $this->request->getVar('totaladvertisment'),
    //                 'sss_bb_transtype' => 'Withdrawl',
    //                 'sss_bb_iswithdrawl' => $this->request->getVar('totaladvertisment'),
    //                 'sss_bb_isdeposit' => '',
    //                 'sss_bb_transmode' => 'NA',
    //                 'sss_bb_transreffno' => 'NA',
    //                 'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //                 'sss_bb_transmonth' => $sss_bb_transmonth,
    //                 'sss_bb_lastbalance' => $opngbalofsourcebankforadv,
    //                 'sss_bb_balance' => $withdrawadvbal,
    //                 'sss_allbankid' => $this->request->getVar('sourcebank'),
    //                 // 'createdatetime' => microtime(true),
    //                 'createdate' => date('Y-m-d')
    //             ];
    //             $isBankBookEntry->insert($withdrawlAdvArray1);
    //             // end withdrawl Adv Array....

    //             //withdrawl Emp Salary...
    //             $totalempsalary1 = $this->request->getVar('sumofempRoundvalues');

    //             $getOpngBal = new Bankdetails_m();
    //             $data['opngbalforemp'] = $getOpngBal->find($sourceb);
    //             $sourcebankopeningbal = $data['opngbalforemp']['sss_ent_bank_acc_openingbal'];
    //             $clsngempsalarybal = $sourcebankopeningbal - $totalempsalary1;


    //             $updateempbankdata = [
    //                 'sss_ent_bank_acc_openingbal' => $clsngempsalarybal,
    //                 'sss_ent_bank_last_updated_by' => session('userid'),
    //                 'sss_ent_bank_updated_date' => date('Y-m-d')
    //             ];

    //             $updatelastbalinsourcebank->update($sourceb, $updateempbankdata);

    //             $bbparticulars_emp_withdraw  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' . $this->request->getVar('empinvno');

    //             $EmpArray1 = [
    //                 // 'sss_ddd_id' => 0,
    //                 'sss_ddd_id' => $lastinserted_id,
    //                 'sss_bb_vendorid' => 57,
    //                 'sss_bb_vpid' => 61,
    //                 'sss_bb_particulars' => $bbparticulars_emp_withdraw,
    //                 'sss_bb_sourcebankid' => $this->request->getVar('sourcebank'),
    //                 'sss_bb_destinationbankid' => '',
    //                 'sss_bb_transamt' => $this->request->getVar('sumofempRoundvalues'),
    //                 'sss_bb_finalamt' => $this->request->getVar('sumofempRoundvalues'),
    //                 'sss_bb_transtype' => 'Withdrawl',
    //                 'sss_bb_iswithdrawl' => $this->request->getVar('sumofempRoundvalues'),
    //                 'sss_bb_isdeposit' => '',
    //                 'sss_bb_transmode' => $this->request->getVar('sss_ddd_transmode'),
    //                 'sss_bb_transreffno' => $this->request->getVar('sss_ddd_transreffno'),
    //                 'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //                 'sss_bb_transmonth' => $sss_bb_transmonth,
    //                 'sss_bb_lastbalance' => $sourcebankopeningbal,
    //                 'sss_bb_balance' => $clsngempsalarybal,
    //                 'sss_allbankid' => $this->request->getVar('sourcebank'),
    //                 // 'createdatetime' => microtime(true),
    //                 'createdate' => date('Y-m-d')
    //             ];
    //             $isBankBookEntry->insert($EmpArray1);
                
    //             $getlastRecord_transactiondate_allwithdrawl_array = $lastRecord->table('sss_tbl_bankbook')
    //             ->select('sss_bb_balance,sss_bb_transmonth')
    //             ->where('sss_allbankid', $sourceb)
    //             ->where('sss_bb_transmonth', $sss_bb_transmonth)
    //             ->orderBy('sss_bb_transactiondate', 'Desc')
    //             ->limit(1)
    //             ->get()
    //             ->getResult();
    //             // echo "<pre>";print_r($getlastRecord_transactiondate_allwithdrawl_array);
    //             $closing_Bal_withdrawlarray = $getlastRecord_transactiondate_allwithdrawl_array[0]->sss_bb_balance;


    //             $getValueofNextMonthBalance_withdrawlarray = $NextMonthsBalances_m
    //                 ->where('bankid', $sourceb)
    //                 ->where('month >', $month)
    //                 ->where('year', $year)
    //                 ->orderBy('id', 'Asc')
    //                 ->get()
    //                 ->getResult();
    //             // echo "<pre>";print_r($getValueofNextMonthBalance_withdrawlarray);exit;
    //             for ($i = 0; $i < count($getValueofNextMonthBalance_withdrawlarray); $i++) {
    //                 // Get closing bal of prev month and update in current month ... 
    //                 $NextMonthsBal = new MonthsBalances_m();
    //                 $NextMonthsBal->update($getValueofNextMonthBalance_withdrawlarray[$i]->id, ['openingbal' =>  $closing_Bal_withdrawlarray]);
    
    //                 // shift closing bal for null entry...
    
    //                 $prevClosing_withdrawlarray = $closing_Bal_withdrawlarray;
    
    //                 // return the closing balance of current month....
    //                 $closing_Bal_withdrawlarray = $lastRecord->table('sss_tbl_bankbook')
    //                     ->select('sss_bb_balance,sss_bb_transmonth')
    //                     ->where('sss_allbankid', $getValueofNextMonthBalance_withdrawlarray[$i]->bankid)
    //                     ->where('sss_bb_transmonth', $getValueofNextMonthBalance_withdrawlarray[$i]->balancemonth)
    //                     ->orderBy('sss_bb_transactiondate', 'Desc')
    //                     ->limit(1)
    //                     ->get()
    //                     ->getRow();
    
    
    //                 $closing_Bal_withdrawlarray = $closing_Bal_withdrawlarray->sss_bb_balance;
    
    //                 if (!empty($closing_Bal_withdrawlarray)) {
    //                     $closing_Bal_withdrawlarray = $closing_Bal_withdrawlarray->sss_bb_balance;
    //                 } else {
    //                     $closing_Bal_withdrawlarray = $prevClosing_withdrawlarray;
    //                 }
    //             }
                    
                
    //         }

    //         // update opening month balance when have next entries....

    //         // $getlastRecord_transactiondate_allwithdrawl_array = $lastRecord->table('sss_tbl_bankbook')
    //         //     ->select('sss_bb_balance,sss_bb_transmonth')
    //         //     ->where('sss_allbankid', $sourceb)
    //         //     ->where('sss_bb_transmonth', $sss_bb_transmonth)
    //         //     ->orderBy('sss_bb_transactiondate', 'Desc')
    //         //     ->limit(1)
    //         //     ->get()
    //         //     ->getResult();

    //         // $closing_Bal_withdrawlarray = $getlastRecord_transactiondate_allwithdrawl_array[0]->sss_bb_balance;


    //         // $getValueofNextMonthBalance_withdrawlarray = $NextMonthsBalances_m
    //         //     ->where('bankid', $sourceb)
    //         //     ->where('month >', $month)
    //         //     ->where('year', $year)
    //         //     ->orderBy('id', 'Asc')
    //         //     ->get()
    //         //     ->getResult();

    //         // for ($i = 0; $i < count($getValueofNextMonthBalance_withdrawlarray); $i++) {
    //         //     // Get closing bal of prev month and update in current month ... 
    //         //     $NextMonthsBal = new MonthsBalances_m();
    //         //     $NextMonthsBal->update($getValueofNextMonthBalance_withdrawlarray[$i]->id, ['openingbal' =>  $closing_Bal_withdrawlarray]);

    //         //     // shift closing bal for null entry...

    //         //     $prevClosing_withdrawlarray = $closing_Bal_withdrawlarray;

    //         //     // return the closing balance of current month....
    //         //     $closing_Bal_withdrawlarray = $lastRecord->table('sss_tbl_bankbook')
    //         //         ->select('sss_bb_balance,sss_bb_transmonth')
    //         //         ->where('sss_allbankid', $getValueofNextMonthBalance_withdrawlarray[$i]->bankid)
    //         //         ->where('sss_bb_transmonth', $getValueofNextMonthBalance_withdrawlarray[$i]->balancemonth)
    //         //         ->orderBy('sss_bb_transactiondate', 'Desc')
    //         //         ->limit(1)
    //         //         ->get()
    //         //         ->getRow();


    //         //     $closing_Bal_withdrawlarray = $closing_Bal_withdrawlarray->sss_bb_balance;

    //         //     if (!empty($closing_Bal_withdrawlarray)) {
    //         //         $closing_Bal_withdrawlarray = $closing_Bal_withdrawlarray->sss_bb_balance;
    //         //     } else {
    //         //         $closing_Bal_withdrawlarray = $prevClosing_withdrawlarray;
    //         //     }
    //         // }

    //         // end update openingbalances of openingmonth...

    //         // tax entries....
    //         $Taxgetnextentriesby_transactiondate = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', 3)->where('sss_bb_transactiondate >', $this->request->getVar('sss_ddd_generatedate'))->orderBy('sss_bb_transactiondate', 'ASC')->get()->getRow();
    //         if ($Taxgetnextentriesby_transactiondate != '') {
                
    //             //deposite entries
    //             $tax_destinationbankid = 3;
    //             $tax_lastBalance = $Taxgetnextentriesby_transactiondate->sss_bb_lastbalance; // next entries first row of last balances...
    //             //TAX entries....
    //             $tx = $this->request->getVar('totaltax');
    //             $currentBalance_tax = $tax_lastBalance + $tx;
    //             $bbparticulars_deposite  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' . $this->request->getVar('taxinvno');
    //             $DepositeTaxarray = [
    //                 // 'sss_ddd_id' => 0,
    //                 'sss_ddd_id' => $lastinserted_id,
    //                 'sss_bb_vendorid' => 55,
    //                 'sss_bb_vpid' => 55,
    //                 'sss_bb_particulars' => $bbparticulars_deposite,
    //                 'sss_bb_sourcebankid' => '',
    //                 'sss_bb_destinationbankid' => 3,
    //                 'sss_bb_transamt' => $this->request->getVar('totaltax'),
    //                 'sss_bb_finalamt' => $this->request->getVar('totaltax'),
    //                 'sss_bb_transtype' => 'Deposit',
    //                 'sss_bb_iswithdrawl' => '',
    //                 'sss_bb_isdeposit' => $this->request->getVar('totaltax'),
    //                 'sss_bb_transmode' => 'NA',
    //                 'sss_bb_transreffno' => 'NA',
    //                 'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //                 'sss_bb_transmonth' => $sss_bb_transmonth,
    //                 'sss_bb_lastbalance' => $tax_lastBalance,
    //                 'sss_bb_balance' => $currentBalance_tax,
    //                 'sss_allbankid' => 3,
    //                 // // 'createdatetime' => microtime(true),
    //                 'createdate' => date('Y-m-d')
    //             ];
    //             $isBankBookEntry->insert($DepositeTaxarray);

    //             $Tax_allnextEntries = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', 3)->where('sss_bb_transactiondate >', $this->request->getVar('sss_ddd_generatedate'))->orderBy('sss_bb_transactiondate', 'ASC')->get()->getResult();

    //             foreach ($Tax_allnextEntries as $tax_entries) {

    //                 $Tax_bb_id = $tax_entries->sss_bankbook_id;
    //                 $lastBalance = $tax_entries->sss_bb_lastbalance;
    //                 $taxes = $this->request->getVar('totaltax');
    //                 $Tax_newLastBalance = $lastBalance + $taxes; // substract sum of all withdrawl from last balances...
    //                 $Tax_newcurrentBalance = $Tax_newLastBalance + $tax_entries->sss_bb_transamt;
    //                 $Tax_new_amountBalances = [
    //                     'sss_bb_lastbalance' => $Tax_newLastBalance,
    //                     'sss_bb_balance' => $Tax_newcurrentBalance,
    //                     'updatedate	' => date('Y-m-d')
    //                 ];
    //                 // echo "<pre>";print_r($Tax_new_amountBalances);
    //                 $nextBankbookentries->update($Tax_bb_id, $Tax_new_amountBalances);
    //             }

    //             $updatebalindestinationbank_tax = new Bankdetails_m();

    //             $depositetaxbankdata = [
    //                 'sss_ent_bank_acc_openingbal' => $Tax_newcurrentBalance,
    //                 'sss_ent_bank_last_updated_by' => session('userid'),
    //                 'sss_ent_bank_updated_date' => date('Y-m-d')
    //             ];
    //             $updatebalindestinationbank_tax->update($tax_destinationbankid, $depositetaxbankdata);

    //             // update opening months balance....
    //             $getlastRecord_transactiondate_taxarray = $lastRecord->table('sss_tbl_bankbook')
    //                 ->select('sss_bb_balance,sss_bb_transmonth')
    //                 ->where('sss_allbankid', 3)
    //                 ->where('sss_bb_transmonth', $sss_bb_transmonth)
    //                 ->orderBy('sss_bb_transactiondate', 'Desc')
    //                 ->limit(1)
    //                 ->get()
    //                 ->getRow();

    //             $closing_Bal_taxarray = $getlastRecord_transactiondate_taxarray->sss_bb_balance;

    //             $getValueofNextMonthBalance_taxarray = $NextMonthsBalances_m
    //                 ->where('bankid', 3)
    //                 ->where('month >', $month)
    //                 ->where('year', $year)
    //                 ->orderBy('id', 'Asc')
    //                 ->get()
    //                 ->getResult();

    //             for ($i = 0; $i < count($getValueofNextMonthBalance_taxarray); $i++) {

    //                 // Get closing bal of prev month and update in current month ... 
    //                 $NextMonthsBal = new MonthsBalances_m();
    //                 $NextMonthsBal->update($getValueofNextMonthBalance_taxarray[$i]->id, ['openingbal' =>  $closing_Bal_taxarray]);

    //                 // shift closing bal for null entry...
    //                 $prevClosing_taxarray = $closing_Bal_taxarray;

    //                 // return the closing balance of current month....

    //                 $closing_Bal_taxarray = $lastRecord->table('sss_tbl_bankbook')
    //                     ->select('sss_bb_balance,sss_bb_transmonth')
    //                     ->where('sss_allbankid', $getValueofNextMonthBalance_taxarray[$i]->bankid)
    //                     ->where('sss_bb_transmonth', $getValueofNextMonthBalance_taxarray[$i]->balancemonth)
    //                     ->orderBy('sss_bb_transactiondate', 'Desc')
    //                     ->limit(1)
    //                     ->get()
    //                     ->getRow();

    //                 if (!empty($closing_Bal_taxarray)) {
    //                     $closing_Bal_taxarray = $closing_Bal_taxarray->sss_bb_balance;
    //                 } else {
    //                     $closing_Bal_taxarray = $prevClosing_taxarray;
    //                 }
    //             }
    //         } else {
    //             echo "No Next Entries";exit;
    //             $tax_destinationbankid = 3;
    //             $getOpngBal = new Bankdetails_m();

    //             $data['opngbalfortax1'] = $getOpngBal->find($sourceb); // get source bank for tax
    //             $data['destinationbankfortax'] = $getOpngBal->find($tax_destinationbankid); // get destination bank for tax....

    //             $opngbalofsourcebankfortax = $data['opngbalfortax1']['sss_ent_bank_acc_openingbal'];
    //             $destinationbankOpngBal_tax = $data['destinationbankfortax']['sss_ent_bank_acc_openingbal'];  //deposite destination bank

    //             $taxxs = $this->request->getVar('totaltax');
    //             $tax_destinationbankclsngbal = $destinationbankOpngBal_tax + $taxxs;  // deposite balance to destination bank...
    //             $updatebalindestinationbank_tax = new Bankdetails_m();
    //             $depositetaxbankdata0 = [
    //                 'sss_ent_bank_acc_openingbal' => $tax_destinationbankclsngbal,
    //                 'sss_ent_bank_last_updated_by' => session('userid'),
    //                 'sss_ent_bank_updated_date' => date('Y-m-d')
    //             ];
    //             $updatebalindestinationbank_tax->update($tax_destinationbankid, $depositetaxbankdata0);

    //             $bbparticulars_deposite  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' . $this->request->getVar('taxinvno');

    //             $DepositeTaxarray1 = [
    //                 'sss_ddd_id' => $lastinserted_id,
    //                 'sss_bb_vendorid' => 55,
    //                 'sss_bb_vpid' => 55,
    //                 'sss_bb_particulars' => $bbparticulars_deposite,
    //                 'sss_bb_sourcebankid' => '',
    //                 'sss_bb_destinationbankid' => 3,
    //                 'sss_bb_transamt' => $this->request->getVar('totaltax'),
    //                 'sss_bb_finalamt' => $this->request->getVar('totaltax'),
    //                 'sss_bb_transtype' => 'Deposit',
    //                 'sss_bb_iswithdrawl' => '',
    //                 'sss_bb_isdeposit' => $this->request->getVar('totaltax'),
    //                 'sss_bb_transmode' => 'NA',
    //                 'sss_bb_transreffno' => 'NA',
    //                 'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //                 'sss_bb_transmonth' => $sss_bb_transmonth,
    //                 'sss_bb_lastbalance' => $destinationbankOpngBal_tax,
    //                 'sss_bb_balance' => $tax_destinationbankclsngbal,
    //                 'sss_allbankid' => 3,
    //                 'createdatetime' => microtime(true),
    //                 'createdate' => date('Y-m-d')
    //             ];
    //             echo "<pre>";print_r($DepositeTaxarray1);exit;
    //             $isTax = $isBankBookEntry->insert($DepositeTaxarray1);

    //             // update opening months balance when dont have any next tax entries ...
    //             if ($isTax > 0) {
                    
    //                 $getlastRecord_transactiondate_tax = $lastRecord->table('sss_tbl_bankbook')
    //                 ->where('sss_allbankid', 3)
    //                 ->orderBy('sss_bb_transactiondate', 'Desc')
    //                 ->limit(1)
    //                 ->get()
    //                 ->getRow();

    //                 if (!empty($getlastRecord_transactiondate_tax)) {
    //                 $newopningbal_tax = $getlastRecord_transactiondate_tax->sss_bb_balance;
    //                 $getValueofNextMonthBalance_tax = $NextMonthsBalances_m->table('sss_openingbalance_month')
    //                     ->where('bankid', 3)
    //                     ->where('month >', $month)
    //                     ->where('year', $year)
    //                     ->orderBy('id', 'Asc')
    //                     ->get()
    //                     ->getResult();
                
    //                 foreach ($getValueofNextMonthBalance_tax as $nextmonths_openingBalances_tax) {
    //                     $opngmonthbal_id_tax = $nextmonths_openingBalances_tax->id;
    //                     $deposite_nextmonth_opngbalances_tax = [
    //                         'openingbal' => $newopningbal_tax,
    //                     ];
    //                     $NextMonthsBalances_m->update($opngmonthbal_id_tax, $deposite_nextmonth_opngbalances_tax);
    //                 }
    // }
    //                 }
    //         }
    //         // update openingmonths balances of tax.....
    //         exit;
    //         // tax entries end..
    //         // advertisment entries...
    //         $Advgetnextentriesby_transactiondate = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', 2)->where('sss_bb_transactiondate >', $this->request->getVar('sss_ddd_generatedate'))->orderBy('sss_bb_transactiondate', 'ASC')->get()->getRow();
    //         if ($Advgetnextentriesby_transactiondate != '') {
    //             $adv_destinationbankid = 2;
    //             $adv_lastBalance = $Advgetnextentriesby_transactiondate->sss_bb_lastbalance; // next entries first row of last balances...
    //             $advertisments = $this->request->getVar('totaladvertisment');
    //             $currentBalance_Adv = $adv_lastBalance + $advertisments;
    //             $bbparticulars_adv_deposite  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' .  $this->request->getVar('advinvno');

    //             $DepositeAdvArray = [
    //                 'sss_ddd_id' => $lastinserted_id,
    //                 'sss_bb_vendorid' => 56,
    //                 'sss_bb_vpid' => 56,
    //                 'sss_bb_particulars' => $bbparticulars_adv_deposite,
    //                 'sss_bb_sourcebankid' => '',
    //                 'sss_bb_destinationbankid' => 2,
    //                 'sss_bb_transamt' => $this->request->getVar('totaladvertisment'),
    //                 'sss_bb_finalamt' => $this->request->getVar('totaladvertisment'),
    //                 'sss_bb_transtype' => 'Deposit',
    //                 'sss_bb_iswithdrawl' => '',
    //                 'sss_bb_isdeposit' => $this->request->getVar('totaladvertisment'),
    //                 'sss_bb_transmode' => 'NA',
    //                 'sss_bb_transreffno' => 'NA',
    //                 'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //                 'sss_bb_transmonth' => $sss_bb_transmonth,
    //                 'sss_bb_lastbalance' => $adv_lastBalance,
    //                 'sss_bb_balance' => $currentBalance_Adv,
    //                 'sss_allbankid' => 2,
    //                 // 'createdatetime' => microtime(true),
    //                 'createdate' => date('Y-m-d')
    //             ];

    //             $isBankBookEntry->insert($DepositeAdvArray);


    //             $Adv_allnextEntries = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', 2)->where('sss_bb_transactiondate >', $this->request->getVar('sss_ddd_generatedate'))->orderBy('sss_bb_transactiondate', 'ASC')->get()->getResult();

    //             foreach ($Adv_allnextEntries as $adv_entries) {
    //                 $Adv_bb_id = $adv_entries->sss_bankbook_id;
    //                 $lastBalance = $adv_entries->sss_bb_lastbalance;
    //                 $ad = $this->request->getVar('totaladvertisment');
    //                 $Adv_newLastBalance = $lastBalance + $ad; // substract sum of all withdrawl from last balances...
    //                 $Adv_newcurrentBalance = $Adv_newLastBalance + $adv_entries->sss_bb_transamt;
    //                 $Adv_new_amountBalances = [
    //                     'sss_bb_lastbalance' => $Adv_newLastBalance,
    //                     'sss_bb_balance' => $Adv_newcurrentBalance,
    //                     'updatedate	' => date('Y-m-d')
    //                 ];
    //                 $nextBankbookentries->update($Adv_bb_id, $Adv_new_amountBalances);
    //             }

    //             $updatebalindestinationbank_withdrawl = new Bankdetails_m();
    //             $depositeadvbankdata1 = [
    //                 'sss_ent_bank_acc_openingbal' => $Adv_newcurrentBalance,
    //                 'sss_ent_bank_last_updated_by' => session('userid'),
    //                 'sss_ent_bank_updated_date' => date('Y-m-d')
    //             ];
    //             $updatebalindestinationbank_withdrawl->update($adv_destinationbankid, $depositeadvbankdata1);

    //             //

    //             //update openingmonths balances of advertisment...
    //             $getlastRecord_transactiondate_advarray = $lastRecord->table('sss_tbl_bankbook')
    //                 ->select('sss_bb_balance,sss_bb_transmonth')
    //                 ->where('sss_allbankid', 2)
    //                 ->where('sss_bb_transmonth', $sss_bb_transmonth)
    //                 ->orderBy('sss_bb_transactiondate', 'Desc')
    //                 ->limit(1)
    //                 ->get()
    //                 ->getRow();

    //             $closing_Bal_advarray = $getlastRecord_transactiondate_advarray->sss_bb_balance;
    //             $getValueofNextMonthBalance_advarray = $NextMonthsBalances_m
    //                 ->where('bankid', 2)
    //                 ->where('month >', $month)
    //                 ->where('year', $year)
    //                 ->orderBy('id', 'Asc')
    //                 ->get()
    //                 ->getResult();

    //             for ($i = 0; $i < count($getValueofNextMonthBalance_advarray); $i++) {

    //                 // Get closing bal of prev month and update in current month ... 
    //                 $NextMonthsBal = new MonthsBalances_m();
    //                 $NextMonthsBal->update($getValueofNextMonthBalance_advarray[$i]->id, ['openingbal' =>  $closing_Bal_advarray]);

    //                 // shift closing bal for null entry...
    //                 $prevClosing_advarray = $closing_Bal_advarray;
    //                 // return the closing balance of current month....
    //                 $closing_Bal_advarray = $lastRecord->table('sss_tbl_bankbook')
    //                     ->select('sss_bb_balance,sss_bb_transmonth')
    //                     ->where('sss_allbankid', $getValueofNextMonthBalance_advarray[$i]->bankid)
    //                     ->where('sss_bb_transmonth', $getValueofNextMonthBalance_advarray[$i]->balancemonth)
    //                     ->orderBy('sss_bb_transactiondate', 'Desc')
    //                     ->limit(1)
    //                     ->get()
    //                     ->getRow();
    //                 if (!empty($closing_Bal_advarray)) {
    //                     $closing_Bal_advarray = $closing_Bal_advarray->sss_bb_balance;
    //                 } else {
    //                     $closing_Bal_taxarray = $prevClosing_advarray;
    //                 }
    //             }
    //         } else {

    //             $adv_destinationbankid1 = 2;
    //             $getOpngBal1 = new Bankdetails_m();

    //             $data['destinationbankforadv'] = $getOpngBal1->find($adv_destinationbankid1); // get destination bank for adv....
    //             $adv_s = $this->request->getVar('totaladvertisment');
    //             $destinationbankOpngBal_adv =  $data['destinationbankforadv']['sss_ent_bank_acc_openingbal'];
    //             $adv_destinationbankclsngbal1 = $destinationbankOpngBal_adv + $adv_s; // adv deposite to destination bank

    //             $depositeadvbankdata1 = [
    //                 'sss_ent_bank_acc_openingbal' => $adv_destinationbankclsngbal1,
    //                 'sss_ent_bank_last_updated_by' => session('userid'),
    //                 'sss_ent_bank_updated_date' => date('Y-m-d')
    //             ];
    //             $updatelastbalinsourcebank->update($adv_destinationbankid1, $depositeadvbankdata1);

    //             $bbparticulars_adv_deposite  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' .  $this->request->getVar('advinvno');

    //             $DepositeAdvArray1 = [
    //                 // 'sss_ddd_id' => 0,
    //                 'sss_ddd_id' => $lastinserted_id,
    //                 'sss_bb_vendorid' => 56,
    //                 'sss_bb_vpid' => 56,
    //                 'sss_bb_particulars' => $bbparticulars_adv_deposite,
    //                 'sss_bb_sourcebankid' => '',
    //                 'sss_bb_destinationbankid' => 2,
    //                 'sss_bb_transamt' => $this->request->getVar('totaladvertisment'),
    //                 'sss_bb_finalamt' => $this->request->getVar('totaladvertisment'),
    //                 'sss_bb_transtype' => 'Deposit',
    //                 'sss_bb_iswithdrawl' => '',
    //                 'sss_bb_isdeposit' => $this->request->getVar('totaladvertisment'),
    //                 'sss_bb_transmode' => 'NA',
    //                 'sss_bb_transreffno' => 'NA',
    //                 'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
    //                 'sss_bb_transmonth' => $sss_bb_transmonth,
    //                 'sss_bb_lastbalance' => $destinationbankOpngBal_adv,
    //                 'sss_bb_balance' => $adv_destinationbankclsngbal1,
    //                 'sss_allbankid' => 2,
    //                 // 'createdatetime' => microtime(true),
    //                 'createdate' => date('Y-m-d')
    //             ];
    //             // echo "<pre>";print_r($DepositeAdvArray1);
    //             $isadv = $isBankBookEntry->insert($DepositeAdvArray1);

    //             //update opening month balance for advertisment bank when dont have next entries....

    //             // if($isadv > 0)
    //             // {
    //             //     $getlastRecord_transactiondate_adv = $lastRecord->table('sss_tbl_bankbook')->where('sss_allbankid', 2)->orderBy('sss_bb_transactiondate', 'Desc')->limit(1)->get()->getRow();
    //             //     if (!empty($getlastRecord_transactiondate_adv)) {
    
    //             //         $newopningbal_adv = $getlastRecord_transactiondate_adv->sss_bb_balance;
    
    
    //             //         $getValueofNextMonthBalance_adv = $NextMonthsBalances_m->where('bankid', 2)->where('month >', $month)->where('year', $year)->orderBy('id', 'Asc')->get()->getResult();
    
    //             //         foreach ($getValueofNextMonthBalance_adv as $nextmonths_openingBalances_adv) {
    //             //             $opngmonthbal_id_adv = $nextmonths_openingBalances_adv->id;
    //             //             $deposite_nextmonth_opngbalances_adv = [
    //             //                 'openingbal' => $newopningbal_adv,
    //             //             ];
    //             //             // echo "<pre>";print_r($deposite_nextmonth_opngbalances_adv);
    //             //             $NextMonthsBalances_m->update($opngmonthbal_id_adv, $deposite_nextmonth_opngbalances_adv);
    //             //         }
    //             //     }
    //             // }
                
    //         }

    //         // advertisement entry end.....

    //         // get empbank account and make emp's bb entry of deposite and withdrawl.....
    //         // calcualte emp tds and store it into tdstable....
    //         $emptds = new Tdsentries_m();
    //         $empTdsArray = [
    //             'sss_vid' => 57,
    //             'sss_vpid' => 57,
    //             'sss_bb_id' => $isInserted,
    //             'sss_bankid' => $this->request->getVar('sourcebank'),
    //             'sss_ddd_id' => $lastinserted_id,
    //             'sss_trans_date' => date('Y-m-d'),
    //             'sss_transamt' => $this->request->getVar('sumofempRoundvalues'),
    //             'sss_tdsamt' => $this->request->getVar('sss_ddd_total_tds'),
    //             'sss_tdsmonth' => $sss_bb_transmonth,
    //             'createdate' => date('Y-m-d'),
    //         ];
    //         $emptds->insert($empTdsArray);

    //         echo json_encode(array("status" => true, "message" => 'Deal Details Draft is Inserted'));
    //     }
    // }

    public function insert_ddd()
    {
        $validation = \Config\Services::validation();
        $this->validate([
            'sss_ddd_misc' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Please enter Misc. Amount',
                ]
            ],
            'sss_ddd_sbamt_tdsper' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Select TDS Percent',
                ]
            ],
            'sss_ddd_cirilroyality_tdsper' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Select TDS Percent'
                ]
            ],
            'sss_ddd_unknown' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Mention Required Particulars',
                ]
            ],
            'sss_ddd_unknownamt' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Enter Particulars Amount',
                ]
            ],
            'sss_ddd_outcomeroundamt.*' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Select TDS Percent',
                ]
            ],
            'sss_ddd_generatedate' => [
                'rules' => 'required',
                'errors' => [
                    'required' => 'Please Select Date',
                ]
            ],

        ]);
        if ($validation->run() == FALSE) {
            $errors = $validation->getErrors();
            echo json_encode(['code' => 0, 'error' => $errors]);
        } else {
            unset($_POST['sss_ddd_service_fees']);
            unset($_POST['sss_ddd_service_gst']);
            unset($_POST['sss_ddd_sbbrkg']);
            unset($_POST['sss_ddd_cirilroyality']);
            unset($_POST['sss_ddd_gst']);
            unset($_POST['sss_ddd_miscexp']);

            $dddempamt = 0;
            $depositedddempamt = 0;
            $embankid = 0;
            $opngbalfordddempsfromsourcebank = 0;
            $opngbalofsourcebankfortax = 0;
            $totaltax = 0;
            $withdrawltaxamount = 0;
            $tax_destinationbankclsngbal = 0;
            $destinationbankOpngBal_tax = 0;
            $tax_destinationbankclsngbal = 0;
            $opngbalofsourcebankforadv = 0;
            $destinationbankOpngBal_adv = 0;
            $totaladv = 0;
            $withdrawadvbal = 0;
            $adv_destinationbankclsngbal = 0;
            $clsngempsalarybal = 0;
            $sourcebankopeningbal = 0;
            $totalempsalary = 0;
            $sumofwithdrawled = 0;
            $outcomeno = count($_POST['sss_ddd_oc_id']);
            $empno = count($_POST['sss_emp_id']);


            $payment = new Paymentreceived_m();
            $getsourcebankid = $payment->table('sss_tbl_paymentreceived')->where('sss_pr_id', $this->request->getVar('sss_pr_id'))->get()->getRow();

            $invoice = new CreateInvoice_m();
            $getInvoice = $invoice->find($getsourcebankid->sss_inv_id);
            $invBankid = $getInvoice['sss_inv_bankid']; // getbank id for checking into loop of balance reflushing....
            $month = 0;
            $year = 0;
            $dateComps = date_parse($this->request->getVar('sss_ddd_generatedate'));
            $year = $dateComps['year'];
            $month = $dateComps['month'];
            $sss_bb_transmonth = $month . '-' . $year;

            $updatelastbalinsourcebank = new Bankdetails_m();
            $NextMonthsBalances_m = new MonthsBalances_m();
            $isEmps = new DDD_emp_m();
            $isBankBookEntry = new Bankbook_m();
            $nextBankbookentries = new Bankbook_m();
            $isOutcomes = new DDD_outcome_m();
            $getOpngBal = new Bankdetails_m();

            $lastRecord = new Bankbook_m();

            // save to ddd table....
            $insertDDDrecord = new Dealdetaildraft_m();
            $ddd_data = [
                'sss_ddc_id' => $this->request->getVar('sss_ddc_id'),
                'sss_pr_id' => $this->request->getVar('sss_pr_id'),
                'sss_ddd_misc' => $this->request->getVar('sss_ddd_misc'),
                'sss_ddd_generatedate' => $this->request->getVar('sss_ddd_generatedate'),
                'sss_ddd_shno' => $this->request->getVar('sss_ddd_shno'),
                'sss_ddd_transmode' => $this->request->getVar('sss_ddd_transmode'),
                'sss_ddd_transreffno' => $this->request->getVar('sss_ddd_transreffno'),
                'sss_ddd_sbamt_amt' => $this->request->getVar('sss_ddd_sbamt_amt'),
                'sss_ddd_sbamt_tdsper' =>  $this->request->getVar('sss_ddd_sbamt_tdsper'),
                'sss_ddd_sbamt_tds' => $this->request->getVar('sss_ddd_sbamt_tds'),
                'sss_ddd_cirilroyalityamt' => $this->request->getVar('sss_ddd_cirilroyalityamt'),
                'sss_ddd_cirilroyality_tdsper' => $this->request->getVar('sss_ddd_cirilroyality_tdsper'),
                'sss_ddd_cirilroyality_tds' => $this->request->getVar('sss_ddd_cirilroyality_tds'),
                'sss_ddd_unknown' => $this->request->getVar('sss_ddd_unknown'),
                'sss_ddd_unknownamt' => $this->request->getVar('sss_ddd_unknownamt'),
                'sss_ddd_unknown_tdsper' => $this->request->getVar('sss_ddd_unknown_tdsper'),
                'sss_ddd_unknown_tds' => $this->request->getVar('sss_ddd_unknown_tds'),
                'sss_ddd_ourshare' => $this->request->getVar('sss_ddd_ourshare'),
                'sss_ddd_gst' => $this->request->getVar('sss_ddd_gst'),
                'sss_ddd_gst_amt' => $this->request->getVar('sss_ddd_gst_amt'),
                'sss_ddd_gst_rounded' => $this->request->getVar('sss_ddd_gst_rounded'),
                'sss_ddd_gst_total' => $this->request->getVar('sss_ddd_gst_total'),
                'sss_ddd_gst_tds' => $this->request->getVar('sss_ddd_gst_tds'),
                'sss_ddd_gst_finalamt' => $this->request->getVar('sss_ddd_gst_finalamt'),
                'sss_ddd_total_roundvalue' => $this->request->getVar('sss_ddd_total_roundvalue'),
                'sumofempRoundvalues' => $this->request->getVar('sumofempRoundvalues'),
                'sss_ddd_sumofroundvalue' => $this->request->getVar('sss_ddd_sumofroundvalue'),
                'sss_ddd_total_tds' => $this->request->getVar('sss_ddd_total_tds'),
                'sss_ddd_total_finalamt' => $this->request->getVar('sss_ddd_total_finalamt'),
                'sss_ddd_balanceincurrent' => $this->request->getVar('sss_ddd_balanceincurrent'),
                'sss_ddd_balanceincurrentinper' => $this->request->getVar('sss_ddd_balanceincurrentinper'),
                'sss_ddd_status' => true,
                'sss_ddd_createby' => session('userid'),
                'sss_ddd_createdate' => date('Y-m-d')
            ];
            // echo "<pre>";print_r($ddd_data);

            $isDDDInserted = $insertDDDrecord->insert($ddd_data);
            $lastinserted_id = $insertDDDrecord->insertID();

            // $lastinserted_id = 0;

            $insertby = session('userid');
            $insertdate = date('Y-m-d');

            $sourceb = $this->request->getVar('sourcebank');

            $isOutcomes = new DDD_outcome_m();

            for ($i = 0; $i < $outcomeno; $i++) {
                $outcomevalues = [

                    'sss_ddd_id' => $lastinserted_id,
                    'sss_ddd_oc_id' => $_POST['sss_ddd_oc_id'][$i],
                    'sss_ddd_outcomeamt' => $_POST['sss_ddd_outcomeamt'][$i],
                    'sss_ddd_outcomeroundamt' => $_POST['sss_ddd_outcomeroundamt'][$i],
                    'sss_ddd_outcometotalamt' => $_POST['sss_ddd_outcometotalamt'][$i],
                    'sss_dddoutcome_tds' => $_POST['sss_dddoutcome_tds'][$i],
                    'sss_ddd_outcomefinalamt' => $_POST['sss_ddd_outcomefinalamt'][$i],
                    'sss_dddoutcome_createdate' => $insertby,
                    'sss_dddoutcome_createdby' => $insertdate,
                ];
                $isOutcomes->insert($outcomevalues);
            }

            //create bb entries for TAX advertisment and employees..
            // $dateComps = date_parse(date('Y-m-d'));

            // echo $sss_bb_transmonth;exit;
            $isEmps = new DDD_emp_m();

            $isBankBookEntry = new Bankbook_m();
            $nextBankbookentries = new Bankbook_m();
            for ($i = 0; $i < $empno; $i++) {
                $empvalues = [
                    'sss_ddd_id' => $lastinserted_id,
                    'sss_emp_id' => $_POST['sss_emp_id'][$i],
                    'sss_dddemp_amt' => $_POST['sss_ddd_empamt'][$i],
                    'sss_dddemp_roundedamt' => $_POST['sss_ddd_emproundamt'][$i],
                    'sss_dddemp_totalamt' => null,
                    'sss_dddemp_tds' => $_POST['sss_ddd_emptdsamt'][$i],
                    'sss_dddemp_finalamt' => $_POST['sss_ddd_empfinalamt'][$i],
                    'sss_dddemp_createdby' => $insertby,
                    'sss_dddemp_createdate' => $insertdate,
                ];
                $isEmps->insert($empvalues);

                $emp = new Employee_m();
                $getbanksemp0 = $emp->select('sss_emp_id,sss_emp_bankid')->where('sss_hadbank', "Yes")->where('sss_emp_id', $_POST['sss_emp_id'][$i])->get()->getRow();
                // echo $getbanksemp0['sss_emp_id'];
                $dddempamt = 0;

                if (isset($getbanksemp0->sss_emp_id) && isset($getbanksemp0->sss_emp_bankid)) {

                    $empid = $getbanksemp0->sss_emp_id;
                    $embankid = $getbanksemp0->sss_emp_bankid;

                    $empsoutcomes = $isEmps->select('sss_emp_id,sss_dddemp_amt')->where('sss_emp_id', $empid)->orderBy('id', 'Desc')->get()->getRow();
                    $dddempamt = $empsoutcomes->sss_dddemp_amt; // get emp amount which had bank...

                    $Empgetnextentriesby_transactiondate = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', $embankid)->where('sss_bb_transactiondate >', $this->request->getVar('sss_ddd_generatedate'))->orderBy('sss_bb_transactiondate', 'ASC')->get()->getRow();

                    if ($Empgetnextentriesby_transactiondate != '') {
                        // echo "Next Employee Entries";
                        // echo "<br>";
                        $Emp_lastBalance = $Empgetnextentriesby_transactiondate->sss_bb_lastbalance; // next entries first row of last balances...
                        $currentBalance_Emp = $Emp_lastBalance + $dddempamt;

                        $bbparticulars_dddempdeposite = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' . 'Employee Commission';

                        $DepositeDDDEmparray2 = [

                            'sss_ddd_id' => $lastinserted_id,
                            'sss_bb_vendorid' => 57,
                            'sss_bb_vpid' => 61,
                            'sss_bb_particulars' => $bbparticulars_dddempdeposite,
                            'sss_bb_sourcebankid' => '',
                            'sss_bb_destinationbankid' => $embankid,
                            'sss_bb_transamt' => $dddempamt,
                            'sss_bb_finalamt' => $dddempamt,
                            'sss_bb_transtype' => 'Deposit',
                            'sss_bb_iswithdrawl' => '',
                            'sss_bb_isdeposit' => $dddempamt,
                            'sss_bb_transmode' => $this->request->getVar('sss_ddd_transmode'),
                            'sss_bb_transreffno' => $this->request->getVar('sss_ddd_transreffno'),
                            'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
                            'sss_bb_transmonth' => $sss_bb_transmonth,
                            'sss_bb_lastbalance' => $Emp_lastBalance,
                            'sss_bb_balance' => $currentBalance_Emp,
                            'sss_allbankid' => $embankid,
                            // 'createdatetime' => microtime(true),
                            'createdate' => date('Y-m-d')
                        ];

                        $isBankBookEntry->insert($DepositeDDDEmparray2);

                        // deposite amount to main bank...
                        $getOpngBaldddemp = new Bankdetails_m();
                        $data['opngbalfordddemp'] = $getOpngBaldddemp->find($embankid);
                        $opngbalfordddempsfromsempbank = $data['opngbalfordddemp']['sss_ent_bank_acc_openingbal'];
                        $depositedddempamt0 = $opngbalfordddempsfromsempbank + $currentBalance_Emp;  // deposite balance to destination bank...

                        $Emp_allnextEntries = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', $embankid)->where('sss_bb_transactiondate >', $this->request->getVar('sss_ddd_generatedate'))->orderBy('sss_bb_transactiondate', 'ASC')->get()->getResult();

                        foreach ($Emp_allnextEntries as $emp_entries) {
                            $Emp_bb_id = $emp_entries->sss_bankbook_id;
                            $lastBalance = $emp_entries->sss_bb_lastbalance;
                            $Emp_newLastBalance = $lastBalance + $dddempamt; // substract sum of all withdrawl from last balances...
                            $Emp_newcurrentBalance = $Emp_newLastBalance + $emp_entries->sss_bb_transamt;
                            $emp_new_amountBalances = [
                                'sss_bb_lastbalance' => $Emp_newLastBalance,
                                'sss_bb_balance' => $Emp_newcurrentBalance,
                                'updatedate	' => date('Y-m-d')
                            ];

                            $nextBankbookentries->update($Emp_bb_id, $emp_new_amountBalances);
                        }
                        $updatebalindestinationbank_dddemp = new Bankdetails_m();
                        $depositeldddempamtdata = [
                            'sss_ent_bank_acc_openingbal' => $Emp_newcurrentBalance,
                            'sss_ent_bank_last_updated_by' => session('userid'),
                            'sss_ent_bank_updated_date' => date('Y-m-d')
                        ];
                        $updatebalindestinationbank_dddemp->update($embankid, $depositeldddempamtdata);

                        // update opening months balancess for employee commission...

                        $lastRecord_emp = new Bankbook_m();
                        $getlastRecord_transactiondate_emparray = $lastRecord_emp->table('sss_tbl_bankbook')
                            ->select('sss_bb_balance,sss_bb_transmonth')
                            ->where('sss_allbankid', $embankid)
                            ->where('sss_bb_transmonth', $sss_bb_transmonth)
                            ->orderBy('sss_bb_transactiondate', 'Desc')
                            ->limit(1)
                            ->get()
                            ->getRow();

                        $closing_Bal_emparray = $getlastRecord_transactiondate_emparray->sss_bb_balance;


                        $getValueofNextMonthBalance_emparray = $NextMonthsBalances_m
                            ->where('bankid', $embankid)
                            ->where('month >', $month)
                            ->where('year', $year)
                            ->orderBy('id', 'Asc')
                            ->get()
                            ->getResult();

                        for ($i = 0; $i < count($getValueofNextMonthBalance_emparray); $i++) {

                            // Get closing bal of prev month and update in current month ... 
                            $NextMonthsBal = new MonthsBalances_m();
                            $NextMonthsBal->update($getValueofNextMonthBalance_emparray[$i]->id, ['openingbal' =>  $closing_Bal_emparray]);

                            // shift closing bal for null entry...
                            $prevClosing_emparray = $closing_Bal_emparray;

                            // return the closing balance of current month....

                            $closing_Bal_emparray = $lastRecord->table('sss_tbl_bankbook')
                                ->select('sss_bb_balance,sss_bb_transmonth')
                                ->where('sss_allbankid', $getValueofNextMonthBalance_emparray[$i]->bankid)
                                ->where('sss_bb_transmonth', $getValueofNextMonthBalance_emparray[$i]->balancemonth)
                                ->orderBy('sss_bb_transactiondate', 'Desc')
                                ->get()
                                ->getRow();

                            if (!empty($closing_Bal_emparray)) {
                                $closing_Bal_emparray = $closing_Bal_emparray->sss_bb_balance;
                            } else {
                                $closing_Bal_emparray = $prevClosing_emparray;
                            }
                        }
                    } else {

                        // get source bank amout for ddd emp....
                        $getOpngBaldddempfromsourcebank = new Bankdetails_m();
                        $data['opngbalfordddemp1'] = $getOpngBaldddempfromsourcebank->find($sourceb);
                        $opngbalfordddempsfromsourcebank = $data['opngbalfordddemp1']['sss_ent_bank_acc_openingbal'];

                        // get ddd emp bank amount...
                        $getOpngBaldddemp1 = new Bankdetails_m();
                        $data['opngbalfordddemp'] = $getOpngBaldddemp1->find($embankid);

                        $opngbalfordddempsfromsempbank = $data['opngbalfordddemp']['sss_ent_bank_acc_openingbal'];
                        // deposite ddd emp amount...

                        $depositedddempamt = $opngbalfordddempsfromsempbank + $dddempamt;  // deposite balance to destination bank...

                        $updatebalindestinationbank_dddemp = new Bankdetails_m();
                        $depositeldddempamtdata = [
                            'sss_ent_bank_acc_openingbal' => $depositedddempamt,
                            'sss_ent_bank_last_updated_by' => session('userid'),
                            'sss_ent_bank_updated_date' => date('Y-m-d')
                        ];
                        $updatebalindestinationbank_dddemp->update($embankid, $depositeldddempamtdata);

                        $bbparticulars_dddempdeposite = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' . 'Employee Commission';

                        $DepositeDDDEmparray = [

                            'sss_ddd_id' => $lastinserted_id,
                            'sss_bb_vendorid' => 57,
                            'sss_bb_vpid' => 61,
                            'sss_bb_particulars' => $bbparticulars_dddempdeposite,
                            'sss_bb_sourcebankid' => '',
                            'sss_bb_destinationbankid' => $embankid,
                            'sss_bb_transamt' => $dddempamt,
                            'sss_bb_finalamt' => $dddempamt,
                            'sss_bb_transtype' => 'Deposit',
                            'sss_bb_iswithdrawl' => '',
                            'sss_bb_isdeposit' => $dddempamt,
                            'sss_bb_transmode' => $this->request->getVar('sss_ddd_transmode'),
                            'sss_bb_transreffno' => $this->request->getVar('sss_ddd_transreffno'),
                            'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
                            'sss_bb_transmonth' => $sss_bb_transmonth,
                            'sss_bb_lastbalance' => $opngbalfordddempsfromsempbank,
                            'sss_bb_balance' => $depositedddempamt,
                            'sss_allbankid' => $embankid,
                            // 'createdatetime' => microtime(true),
                            'createdate' => date('Y-m-d')
                        ];
                        $isBankBookEntry->insert($DepositeDDDEmparray);

                        // update opening month balance when dont have next entries for employee commission......


                        $getlastRecord_transactiondate_emp = $lastRecord->table('sss_tbl_bankbook')->where('sss_allbankid', $embankid)->where('sss_bb_transmonth', $sss_bb_transmonth)->orderBy('sss_bb_transactiondate', 'Desc')->get()->getRow();

                        if (!empty($getlastRecord_transactiondate_emp)) {

                            $newopningbal_emp = $getlastRecord_transactiondate_emp->sss_bb_balance;

                            $getValueofNextMonthBalance_emp = $NextMonthsBalances_m->table('sss_openingbalance_month')->where('bankid', $embankid)->where('month >', $month)->where('year', $year)->orderBy('id', 'Asc')->get()->getResult();

                            foreach ($getValueofNextMonthBalance_emp as $nextmonths_openingBalances_emp) {
                                $opngmonthbal_id_emp = $nextmonths_openingBalances_emp->id;
                                $deposite_nextmonth_opngbalances_emp = [
                                    'openingbal' => $newopningbal_emp,
                                ];
                                // echo "<pre>";print_r($deposite_nextmonth_opngbalances_emp);
                                $NextMonthsBalances_m->update($opngmonthbal_id_emp, $deposite_nextmonth_opngbalances_emp);
                            }
                        }
                    }
                }
            }

            // all withdrawl entry...
            $getnextentriesby_transactiondate = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', $invBankid)->where('sss_bb_transactiondate >', $this->request->getVar('sss_ddd_generatedate'))->where('sss_bb_transmonth', $sss_bb_transmonth)->orderBy('sss_bb_transactiondate', 'ASC')->get()->getRow();
            if ($getnextentriesby_transactiondate != '') {
                $getOpngBal = new Bankdetails_m();
                $data['opngbal'] = $getOpngBal->find($sourceb);
                $opngbalofsourcebank = $data['opngbal']['sss_ent_bank_acc_openingbal'];
                // echo "Source Opening Bal -".$opngbalofsourcebank;exit;
                //withdrawl entries....
                $tax_lastBalance = $getnextentriesby_transactiondate->sss_bb_lastbalance; // next entries first row of last balances...

                $totalTaxx =  $this->request->getVar('totaltax');
                // echo "Total Tax".$totalTaxx;exit;
                $currentBalance_tax = $tax_lastBalance - $totalTaxx;


                $bbparticulars_deposite  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' . $this->request->getVar('taxinvno');

                $WithdrawlTaxarray = [
                    'sss_ddd_id' => $lastinserted_id,
                    'sss_bb_vendorid' => 55,
                    'sss_bb_vpid' => 55,
                    'sss_bb_particulars' => $bbparticulars_deposite,
                    'sss_bb_sourcebankid' => $this->request->getVar('sourcebank'),
                    'sss_bb_destinationbankid' => '',
                    'sss_bb_transamt' => $this->request->getVar('totaltax'),
                    'sss_bb_finalamt' => $this->request->getVar('totaltax'),
                    'sss_bb_transtype' => 'Withdrawl',
                    'sss_bb_iswithdrawl' => $this->request->getVar('totaltax'),
                    'sss_bb_isdeposit' => '',
                    'sss_bb_transmode' => 'NA',
                    'sss_bb_transreffno' => 'NA',
                    'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
                    'sss_bb_transmonth' => $sss_bb_transmonth,
                    'sss_bb_lastbalance' => $tax_lastBalance,
                    'sss_bb_balance' => $currentBalance_tax,
                    'sss_allbankid' => $this->request->getVar('sourcebank'),
                    // 'createdatetime' => microtime(true),
                    'createdate' => date('Y-m-d')

                ];
                $isBankBookEntry->insert($WithdrawlTaxarray);


                // advetisment entries....
                $totaladv = $this->request->getVar('totaladvertisment');
                $get_Adv_lastBalance = $currentBalance_tax;
                $get_Adv_currentBalance = $currentBalance_tax - $totaladv;
                $bbparticulars_adv_withdraw  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno')  . ' - ' . $this->request->getVar('advinvno');
                $withdrawlAdvArray = [

                    'sss_ddd_id' => $lastinserted_id,
                    'sss_bb_vendorid' => 56,
                    'sss_bb_vpid' => 56,
                    'sss_bb_particulars' => $bbparticulars_adv_withdraw,
                    'sss_bb_sourcebankid' => $this->request->getVar('sourcebank'),
                    'sss_bb_destinationbankid' => '',
                    'sss_bb_transamt' => $this->request->getVar('totaladvertisment'),
                    'sss_bb_finalamt' => $this->request->getVar('totaladvertisment'),
                    'sss_bb_transtype' => 'Withdrawl',
                    'sss_bb_iswithdrawl' => $this->request->getVar('totaladvertisment'),
                    'sss_bb_isdeposit' => '',
                    'sss_bb_transmode' => 'NA',
                    'sss_bb_transreffno' => 'NA',
                    'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
                    'sss_bb_transmonth' => $sss_bb_transmonth,
                    'sss_bb_lastbalance' => $get_Adv_lastBalance,
                    'sss_bb_balance' => $get_Adv_currentBalance,
                    'sss_allbankid' => $this->request->getVar('sourcebank'),
                    // 'createdatetime' => microtime(true),
                    'createdate' => date('Y-m-d')
                ];
                $isBankBookEntry->insert($withdrawlAdvArray);

                //Emp Salary...
                $totalempsalary = $this->request->getVar('sumofempRoundvalues');
                $get_empsalary_lastBalance = $get_Adv_currentBalance;
                $get_Empsalary_currentBalance = $get_empsalary_lastBalance - $totalempsalary;
                $bbparticulars_emp_withdraw  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' . $this->request->getVar('empinvno');

                $EmpArray = [

                    'sss_ddd_id' => $lastinserted_id,
                    'sss_bb_vendorid' => 57,
                    'sss_bb_vpid' => 61,
                    'sss_bb_particulars' => $bbparticulars_emp_withdraw,
                    'sss_bb_sourcebankid' => $this->request->getVar('sourcebank'),
                    'sss_bb_destinationbankid' => '',
                    'sss_bb_transamt' => $this->request->getVar('sumofempRoundvalues'),
                    'sss_bb_finalamt' => $this->request->getVar('sumofempRoundvalues'),
                    'sss_bb_transtype' => 'Withdrawl',
                    'sss_bb_iswithdrawl' => $this->request->getVar('sumofempRoundvalues'),
                    'sss_bb_isdeposit' => '',
                    'sss_bb_transmode' => $this->request->getVar('sss_ddd_transmode'),
                    'sss_bb_transreffno' => $this->request->getVar('sss_ddd_transreffno'),
                    'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
                    'sss_bb_transmonth' => $sss_bb_transmonth,
                    'sss_bb_lastbalance' => $get_empsalary_lastBalance,
                    'sss_bb_balance' => $get_Empsalary_currentBalance,
                    'sss_allbankid' => $this->request->getVar('sourcebank'),
                    // 'createdatetime' => microtime(true),
                    'createdate' => date('Y-m-d')
                ];
                $isInserted = $isBankBookEntry->insert($EmpArray);

                // $allEntries = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', $invBankid)->where('sss_bb_transactiondate >', $this->request->getVar('sss_ddd_generatedate'))->orderBy('sss_bb_transactiondate', 'ASC')->get()->getResult();
                
                $allEntries = $nextBankbookentries->table('sss_tbl_bankbook')
                    ->groupBy('sss_bb_transactiondate')
                    ->orderBy('sss_bb_transactiondate', 'asc')
                    ->where('sss_allbankid', $invBankid)
                    ->where('sss_bb_transactiondate >', $this->request->getVar('sss_ddd_generatedate'))
                    ->get()
                    ->getResult();
                
                $sumofwithdrawled = $this->request->getVar('totaltax') + $this->request->getVar('totaladvertisment') + $this->request->getVar('sumofempRoundvalues');

                foreach ($allEntries as $bb_entries) {

                    if ($bb_entries->sss_bb_transtype == 'Deposit') {
                        $Bb_id = $bb_entries->sss_bankbook_id;
                        $lastBalance = $bb_entries->sss_bb_lastbalance;
                        $newLastBalance = $lastBalance - $sumofwithdrawled; // substract sum of all withdrawl from last balances...
                        $newcurrentBalance = $newLastBalance + $bb_entries->sss_bb_transamt;
                        $deposite_new_amountBalances = [
                            'sss_bb_lastbalance' => $newLastBalance,
                            'sss_bb_balance' => $newcurrentBalance,
                            'updatedate	' => date('Y-m-d')
                        ];

                        $nextBankbookentries->update($Bb_id, $deposite_new_amountBalances);
                        $withdrawbankdata = [
                            'sss_ent_bank_acc_openingbal' => $newcurrentBalance,
                            'sss_ent_bank_last_updated_by' => session('userid'),
                            'sss_ent_bank_updated_date' => date('Y-m-d')
                        ];
                        $getOpngBal->update($sourceb, $withdrawbankdata);

                        // update bank for employee commission in openingmonths bank...

                    } else {
                        // when next entries will be withdrawl...
                        $Bb_id = $bb_entries->sss_bankbook_id;
                        $lastBalance = $bb_entries->sss_bb_lastbalance;

                        $newLastBalance = $lastBalance - $sumofwithdrawled;

                        $newcurrentBalance = $newLastBalance - $bb_entries->sss_bb_transamt;

                        $withdrwl_new_amountBalances = [
                            'sss_bb_lastbalance' => $newLastBalance,
                            'sss_bb_balance' => $newcurrentBalance,
                            'updatedate	' => date('Y-m-d')
                        ];
                        $nextBankbookentries->update($Bb_id, $withdrwl_new_amountBalances);

                        $withdrawbankdata1 = [
                            'sss_ent_bank_acc_openingbal' => $newcurrentBalance,
                            'sss_ent_bank_last_updated_by' => session('userid'),
                            'sss_ent_bank_updated_date' => date('Y-m-d')
                        ];
                        $getOpngBal->update($sourceb, $withdrawbankdata1);
                    }
                }
                
            } 
            else {
                //update bank balance....
                $totaltax = $this->request->getVar('totaltax');
                // updating current bank for tax...
                $data['opngbalfortax'] = $getOpngBal->find($sourceb);
                $opngbalofsourcebankfortax = $data['opngbalfortax']['sss_ent_bank_acc_openingbal'];
                $withdrawltaxamount = $opngbalofsourcebankfortax - $totaltax; // withdraw tax from source bank....
                $withdrawtaxbankdata0 = [
                    'sss_ent_bank_acc_openingbal' => $withdrawltaxamount,
                    'sss_ent_bank_last_updated_by' => session('userid'),
                    'sss_ent_bank_updated_date' => date('Y-m-d')
                ];
                $updatelastbalinsourcebank->update($sourceb, $withdrawtaxbankdata0);

                // get previous last entry from bankbook on selected ddd date....
                $ddd_date = $this->request->getVar('sss_ddd_generatedate');
                
                $getlastRecord_transactiondate = $lastRecord->table('sss_tbl_bankbook')->orderBy('sss_bb_transactiondate', 'Desc')->where('sss_allbankid', $sourceb)->where('sss_bb_transactiondate <=', $ddd_date)->get()->getRow();
                // echo "<pre>";print_r($getlastRecord_transactiondate);exit;
                $prevDate_lastbalance = $getlastRecord_transactiondate->sss_bb_balance;
                $currentEntry_TaxBalance = $prevDate_lastbalance - $totaltax;
                
                $bbparticulars_deposite  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' . $this->request->getVar('taxinvno');

                $isBankBookEntry = new Bankbook_m();
                $WithdrawlTaxarray1 = [
                    'sss_ddd_id' => $lastinserted_id,
                    'sss_bb_vendorid' => 55,
                    'sss_bb_vpid' => 55,
                    'sss_bb_particulars' => $bbparticulars_deposite,
                    'sss_bb_sourcebankid' => $this->request->getVar('sourcebank'),
                    'sss_bb_destinationbankid' => '',
                    'sss_bb_transamt' => $this->request->getVar('totaltax'),
                    'sss_bb_finalamt' => $this->request->getVar('totaltax'),
                    'sss_bb_transtype' => 'Withdrawl',
                    'sss_bb_iswithdrawl' => $this->request->getVar('totaltax'),
                    'sss_bb_isdeposit' => '',
                    'sss_bb_transmode' => 'NA',
                    'sss_bb_transreffno' => 'NA',
                    'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
                    'sss_bb_transmonth' => $sss_bb_transmonth,
                    'sss_bb_lastbalance' => $prevDate_lastbalance,
                    'sss_bb_balance' => $currentEntry_TaxBalance,
                    'sss_allbankid' => $this->request->getVar('sourcebank'),
                    // 'createdatetime' => microtime(true),
                    'createdate' => date('Y-m-d')
                ];
                $isBankBookEntry->insert($WithdrawlTaxarray1);

                // withdrawl Adv Array....

                $data['opngbalforadv'] = $getOpngBal->find($sourceb);
                $opngbalofsourcebankforadv = $data['opngbalforadv']['sss_ent_bank_acc_openingbal'];
                $totaladv1 = $this->request->getVar('totaladvertisment');
                $withdrawadvbal = $opngbalofsourcebankforadv - $totaladv1; // withdrawl bank balance

                $withdrawadvbankdata = [
                    'sss_ent_bank_acc_openingbal' => $withdrawadvbal,
                    'sss_ent_bank_last_updated_by' => session('userid'),
                    'sss_ent_bank_updated_date' => date('Y-m-d')
                ];
                $updatelastbalinsourcebank->update($sourceb, $withdrawadvbankdata);

                $lastentry_advBalance = $currentEntry_TaxBalance; // get balance of tax its becomes last balance of adv...
                $currentEntry_advBalance = $lastentry_advBalance - $totaladv1;

                $bbparticulars_adv_withdraw  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno')  . ' - ' . $this->request->getVar('advinvno');
                $withdrawlAdvArray1 = [
                    'sss_ddd_id' => $lastinserted_id,
                    'sss_bb_vendorid' => 56,
                    'sss_bb_vpid' => 56,
                    'sss_bb_particulars' => $bbparticulars_adv_withdraw,
                    'sss_bb_sourcebankid' => $this->request->getVar('sourcebank'),
                    'sss_bb_destinationbankid' => '',
                    'sss_bb_transamt' => $this->request->getVar('totaladvertisment'),
                    'sss_bb_finalamt' => $this->request->getVar('totaladvertisment'),
                    'sss_bb_transtype' => 'Withdrawl',
                    'sss_bb_iswithdrawl' => $this->request->getVar('totaladvertisment'),
                    'sss_bb_isdeposit' => '',
                    'sss_bb_transmode' => 'NA',
                    'sss_bb_transreffno' => 'NA',
                    'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
                    'sss_bb_transmonth' => $sss_bb_transmonth,
                    'sss_bb_lastbalance' => $lastentry_advBalance,
                    'sss_bb_balance' => $currentEntry_advBalance,
                    'sss_allbankid' => $this->request->getVar('sourcebank'),
                    // 'createdatetime' => microtime(true),
                    'createdate' => date('Y-m-d')
                ];
                $isBankBookEntry->insert($withdrawlAdvArray1);
                
                // end withdrawl Adv Array....

                //withdrawl Emp Salary...
                $totalempsalary1 = $this->request->getVar('sumofempRoundvalues');


                $data['opngbalforemp'] = $getOpngBal->find($sourceb);
                $sourcebankopeningbal = $data['opngbalforemp']['sss_ent_bank_acc_openingbal'];
                $clsngempsalarybal = $sourcebankopeningbal - $totalempsalary1;


                $updateempbankdata = [
                    'sss_ent_bank_acc_openingbal' => $clsngempsalarybal,
                    'sss_ent_bank_last_updated_by' => session('userid'),
                    'sss_ent_bank_updated_date' => date('Y-m-d')
                ];
                $updatelastbalinsourcebank->update($sourceb, $updateempbankdata);

                $lastentry_empBalance = $currentEntry_advBalance; // get balance of tax its becomes last balance of adv...
                $currentEntry_empBalance = $lastentry_empBalance - $totalempsalary1;


                $bbparticulars_emp_withdraw  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' . $this->request->getVar('empinvno');

                $EmpArray1 = [
                    'sss_ddd_id' => $lastinserted_id,
                    'sss_bb_vendorid' => 57,
                    'sss_bb_vpid' => 61,
                    'sss_bb_particulars' => $bbparticulars_emp_withdraw,
                    'sss_bb_sourcebankid' => $this->request->getVar('sourcebank'),
                    'sss_bb_destinationbankid' => '',
                    'sss_bb_transamt' => $this->request->getVar('sumofempRoundvalues'),
                    'sss_bb_finalamt' => $this->request->getVar('sumofempRoundvalues'),
                    'sss_bb_transtype' => 'Withdrawl',
                    'sss_bb_iswithdrawl' => $this->request->getVar('sumofempRoundvalues'),
                    'sss_bb_isdeposit' => '',
                    'sss_bb_transmode' => $this->request->getVar('sss_ddd_transmode'),
                    'sss_bb_transreffno' => $this->request->getVar('sss_ddd_transreffno'),
                    'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
                    'sss_bb_transmonth' => $sss_bb_transmonth,
                    'sss_bb_lastbalance' => $lastentry_empBalance,
                    'sss_bb_balance' => $currentEntry_empBalance,
                    'sss_allbankid' => $this->request->getVar('sourcebank'),
                    // 'createdatetime' => microtime(true),
                    'createdate' => date('Y-m-d')
                ];
                $isInserted = $isBankBookEntry->insert($EmpArray1);
            }
            

            // tax entries....
            $Taxgetnextentriesby_transactiondate = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', 3)->where('sss_bb_transactiondate >', $this->request->getVar('sss_ddd_generatedate'))->orderBy('sss_bb_transactiondate', 'ASC')->get()->getRow();
            if ($Taxgetnextentriesby_transactiondate != '') {
                //deposite entries
                $tax_destinationbankid = 3;
                $tax_lastBalance = $Taxgetnextentriesby_transactiondate->sss_bb_lastbalance; // next entries first row of last balances...
                //TAX entries....
                $tx = $this->request->getVar('totaltax');
                $currentBalance_tax = $tax_lastBalance + $tx;
                $bbparticulars_deposite  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' . $this->request->getVar('taxinvno');
                $DepositeTaxarray = [
                    'sss_ddd_id' => $lastinserted_id,
                    'sss_bb_vendorid' => 55,
                    'sss_bb_vpid' => 55,
                    'sss_bb_particulars' => $bbparticulars_deposite,
                    'sss_bb_sourcebankid' => '',
                    'sss_bb_destinationbankid' => 3,
                    'sss_bb_transamt' => $this->request->getVar('totaltax'),
                    'sss_bb_finalamt' => $this->request->getVar('totaltax'),
                    'sss_bb_transtype' => 'Deposit',
                    'sss_bb_iswithdrawl' => '',
                    'sss_bb_isdeposit' => $this->request->getVar('totaltax'),
                    'sss_bb_transmode' => 'NA',
                    'sss_bb_transreffno' => 'NA',
                    'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
                    'sss_bb_transmonth' => $sss_bb_transmonth,
                    'sss_bb_lastbalance' => $tax_lastBalance,
                    'sss_bb_balance' => $currentBalance_tax,
                    'sss_allbankid' => 3,
                    // // 'createdatetime' => microtime(true),
                    'createdate' => date('Y-m-d')
                ];
                $isBankBookEntry->insert($DepositeTaxarray);

                $Tax_allnextEntries = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', 3)->where('sss_bb_transactiondate >', $this->request->getVar('sss_ddd_generatedate'))->orderBy('sss_bb_transactiondate', 'ASC')->get()->getResult();

                foreach ($Tax_allnextEntries as $tax_entries) {

                    $Tax_bb_id = $tax_entries->sss_bankbook_id;
                    $lastBalance = $tax_entries->sss_bb_lastbalance;
                    $taxes = $this->request->getVar('totaltax');
                    $Tax_newLastBalance = $lastBalance + $taxes; // substract sum of all withdrawl from last balances...
                    $Tax_newcurrentBalance = $Tax_newLastBalance + $tax_entries->sss_bb_transamt;
                    $Tax_new_amountBalances = [
                        'sss_bb_lastbalance' => $Tax_newLastBalance,
                        'sss_bb_balance' => $Tax_newcurrentBalance,
                        'updatedate	' => date('Y-m-d')
                    ];
                    // echo "<pre>";print_r($Tax_new_amountBalances);
                    $nextBankbookentries->update($Tax_bb_id, $Tax_new_amountBalances);
                }

                $updatebalindestinationbank_tax = new Bankdetails_m();

                $depositetaxbankdata = [
                    'sss_ent_bank_acc_openingbal' => $Tax_newcurrentBalance,
                    'sss_ent_bank_last_updated_by' => session('userid'),
                    'sss_ent_bank_updated_date' => date('Y-m-d')
                ];
                $updatebalindestinationbank_tax->update($tax_destinationbankid, $depositetaxbankdata);
            } else {

                $tax_destinationbankid = 3;
                $getOpngBal = new Bankdetails_m();

                $data['opngbalfortax1'] = $getOpngBal->find($sourceb); // get source bank for tax
                $data['destinationbankfortax'] = $getOpngBal->find($tax_destinationbankid); // get destination bank for tax....

                $opngbalofsourcebankfortax = $data['opngbalfortax1']['sss_ent_bank_acc_openingbal'];
                $destinationbankOpngBal_tax = $data['destinationbankfortax']['sss_ent_bank_acc_openingbal'];  //deposite destination bank

                $taxxs = $this->request->getVar('totaltax');
                $tax_destinationbankclsngbal = $destinationbankOpngBal_tax + $taxxs;  // deposite balance to destination bank...
                $updatebalindestinationbank_tax = new Bankdetails_m();
                $depositetaxbankdata0 = [
                    'sss_ent_bank_acc_openingbal' => $tax_destinationbankclsngbal,
                    'sss_ent_bank_last_updated_by' => session('userid'),
                    'sss_ent_bank_updated_date' => date('Y-m-d')
                ];
                $updatebalindestinationbank_tax->update($tax_destinationbankid, $depositetaxbankdata0);

                $bbparticulars_deposite  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' . $this->request->getVar('taxinvno');

                $DepositeTaxarray1 = [
                    'sss_ddd_id' => $lastinserted_id,
                    'sss_bb_vendorid' => 55,
                    'sss_bb_vpid' => 55,
                    'sss_bb_particulars' => $bbparticulars_deposite,
                    'sss_bb_sourcebankid' => '',
                    'sss_bb_destinationbankid' => 3,
                    'sss_bb_transamt' => $this->request->getVar('totaltax'),
                    'sss_bb_finalamt' => $this->request->getVar('totaltax'),
                    'sss_bb_transtype' => 'Deposit',
                    'sss_bb_iswithdrawl' => '',
                    'sss_bb_isdeposit' => $this->request->getVar('totaltax'),
                    'sss_bb_transmode' => 'NA',
                    'sss_bb_transreffno' => 'NA',
                    'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
                    'sss_bb_transmonth' => $sss_bb_transmonth,
                    'sss_bb_lastbalance' => $destinationbankOpngBal_tax,
                    'sss_bb_balance' => $tax_destinationbankclsngbal,
                    'sss_allbankid' => 3,
                    'createdatetime' => microtime(true),
                    'createdate' => date('Y-m-d')
                ];
                // echo "<pre>";print_r($DepositeTaxarray1);exit;
                $isBankBookEntry->insert($DepositeTaxarray1);
            }
            // tax entries end..

            // advertisment entries...

            $Advgetnextentriesby_transactiondate = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', 2)->where('sss_bb_transactiondate >', $this->request->getVar('sss_ddd_generatedate'))->orderBy('sss_bb_transactiondate', 'ASC')->get()->getRow();
            if ($Advgetnextentriesby_transactiondate != '') {
                $adv_destinationbankid = 2;
                $adv_lastBalance = $Advgetnextentriesby_transactiondate->sss_bb_lastbalance; // next entries first row of last balances...
                $advertisments = $this->request->getVar('totaladvertisment');
                $currentBalance_Adv = $adv_lastBalance + $advertisments;
                $bbparticulars_adv_deposite  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' .  $this->request->getVar('advinvno');

                $DepositeAdvArray = [
                    'sss_ddd_id' => $lastinserted_id,
                    'sss_bb_vendorid' => 56,
                    'sss_bb_vpid' => 56,
                    'sss_bb_particulars' => $bbparticulars_adv_deposite,
                    'sss_bb_sourcebankid' => '',
                    'sss_bb_destinationbankid' => 2,
                    'sss_bb_transamt' => $this->request->getVar('totaladvertisment'),
                    'sss_bb_finalamt' => $this->request->getVar('totaladvertisment'),
                    'sss_bb_transtype' => 'Deposit',
                    'sss_bb_iswithdrawl' => '',
                    'sss_bb_isdeposit' => $this->request->getVar('totaladvertisment'),
                    'sss_bb_transmode' => 'NA',
                    'sss_bb_transreffno' => 'NA',
                    'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
                    'sss_bb_transmonth' => $sss_bb_transmonth,
                    'sss_bb_lastbalance' => $adv_lastBalance,
                    'sss_bb_balance' => $currentBalance_Adv,
                    'sss_allbankid' => 2,
                    // 'createdatetime' => microtime(true),
                    'createdate' => date('Y-m-d')
                ];
                $isBankBookEntry->insert($DepositeAdvArray);


                $Adv_allnextEntries = $nextBankbookentries->table('sss_tbl_bankbook')->where('sss_allbankid', 2)->where('sss_bb_transactiondate >', $this->request->getVar('sss_ddd_generatedate'))->orderBy('sss_bb_transactiondate', 'ASC')->get()->getResult();

                foreach ($Adv_allnextEntries as $adv_entries) {
                    $Adv_bb_id = $adv_entries->sss_bankbook_id;
                    $lastBalance = $adv_entries->sss_bb_lastbalance;
                    $ad = $this->request->getVar('totaladvertisment');
                    $Adv_newLastBalance = $lastBalance + $ad; // substract sum of all withdrawl from last balances...
                    $Adv_newcurrentBalance = $Adv_newLastBalance + $adv_entries->sss_bb_transamt;
                    $Adv_new_amountBalances = [
                        'sss_bb_lastbalance' => $Adv_newLastBalance,
                        'sss_bb_balance' => $Adv_newcurrentBalance,
                        'updatedate	' => date('Y-m-d')
                    ];
                    $nextBankbookentries->update($Adv_bb_id, $Adv_new_amountBalances);
                }

                $updatebalindestinationbank_withdrawl = new Bankdetails_m();
                $depositeadvbankdata1 = [
                    'sss_ent_bank_acc_openingbal' => $Adv_newcurrentBalance,
                    'sss_ent_bank_last_updated_by' => session('userid'),
                    'sss_ent_bank_updated_date' => date('Y-m-d')
                ];
                $updatebalindestinationbank_withdrawl->update($adv_destinationbankid, $depositeadvbankdata1);

            } else {
                $adv_destinationbankid1 = 2;
                $getOpngBal1 = new Bankdetails_m();

                $data['destinationbankforadv'] = $getOpngBal1->find($adv_destinationbankid1); // get destination bank for adv....
                $adv_s = $this->request->getVar('totaladvertisment');
                $destinationbankOpngBal_adv =  $data['destinationbankforadv']['sss_ent_bank_acc_openingbal'];
                $adv_destinationbankclsngbal1 = $destinationbankOpngBal_adv + $adv_s; // adv deposite to destination bank

                $depositeadvbankdata1 = [
                    'sss_ent_bank_acc_openingbal' => $adv_destinationbankclsngbal1,
                    'sss_ent_bank_last_updated_by' => session('userid'),
                    'sss_ent_bank_updated_date' => date('Y-m-d')
                ];
                $updatelastbalinsourcebank->update($adv_destinationbankid1, $depositeadvbankdata1);

                $bbparticulars_adv_deposite  = $this->request->getVar('clientNameforparticulars') . ' - ' . $this->request->getVar('billnoforparticulars') . ' - ' . $this->request->getVar('sss_ddd_shno') . ' - ' .  $this->request->getVar('advinvno');

                $DepositeAdvArray1 = [
                    'sss_ddd_id' => $lastinserted_id,
                    'sss_bb_vendorid' => 56,
                    'sss_bb_vpid' => 56,
                    'sss_bb_particulars' => $bbparticulars_adv_deposite,
                    'sss_bb_sourcebankid' => '',
                    'sss_bb_destinationbankid' => 2,
                    'sss_bb_transamt' => $this->request->getVar('totaladvertisment'),
                    'sss_bb_finalamt' => $this->request->getVar('totaladvertisment'),
                    'sss_bb_transtype' => 'Deposit',
                    'sss_bb_iswithdrawl' => '',
                    'sss_bb_isdeposit' => $this->request->getVar('totaladvertisment'),
                    'sss_bb_transmode' => 'NA',
                    'sss_bb_transreffno' => 'NA',
                    'sss_bb_transactiondate' => $this->request->getVar('sss_ddd_generatedate'),
                    'sss_bb_transmonth' => $sss_bb_transmonth,
                    'sss_bb_lastbalance' => $destinationbankOpngBal_adv,
                    'sss_bb_balance' => $adv_destinationbankclsngbal1,
                    'sss_allbankid' => 2,
                    // 'createdatetime' => microtime(true),
                    'createdate' => date('Y-m-d')
                ];
                $isBankBookEntry->insert($DepositeAdvArray1);
            }

            // advertisement entry end.....

            // get empbank account and make emp's bb entry of deposite and withdrawl.....

            // calcualte emp tds and store it into tdstable....
            $emptds = new Tdsentries_m();
            $empTdsArray = [
                'sss_vid' => 57,
                'sss_vpid' => 57,
                'sss_bb_id' => $isInserted,
                'sss_bankid' => $this->request->getVar('sourcebank'),
                'sss_ddd_id' => $lastinserted_id,
                'sss_trans_date' => date('Y-m-d'),
                'sss_transamt' => $this->request->getVar('sumofempRoundvalues'),
                'sss_tdsamt' => $this->request->getVar('sss_ddd_total_tds'),
                'sss_tdsmonth' => $sss_bb_transmonth,
                'createdate' => date('Y-m-d'),
            ];
            $emptds->insert($empTdsArray);

            $closing_Bal_withdrawlarray = 0;
            
            // update openingmonth balances for all withdrawl...
            // $getlastRecord_transactiondate_allwithdrawl_array = $lastRecord->table('sss_tbl_bankbook')
            //     ->select('sss_bb_balance,sss_bb_transmonth')
            //     ->orderBy('sss_bb_transactiondate', 'Desc')
            //     ->where('sss_allbankid', $sourceb)
            //     ->where('sss_bb_transmonth', $sss_bb_transmonth)
            //     // ->limit(1)
            //     ->get()
            //     ->getResult();
                
            $getlastRecord_transactiondate_allwithdrawl_array = $lastRecord->table('sss_tbl_bankbook')
                    ->select('sss_bb_balance,sss_bb_transmonth')
                    ->orderBy('sss_bb_transactiondate', 'ASC')
                    ->where('sss_allbankid', $sourceb)
                    ->where('sss_bb_transmonth', $sss_bb_transmonth)
                    ->get()
                    ->getResult();
                    
            $getlastRecord_transactiondate_allwithdrawl = end($getlastRecord_transactiondate_allwithdrawl_array);
                
            if(!empty($getlastRecord_transactiondate_allwithdrawl_array))
            {
                $closing_Bal_withdrawlarray = $getlastRecord_transactiondate_allwithdrawl->sss_bb_balance;
                
                $getValueofNextMonthBalance_withdrawlarray = $NextMonthsBalances_m
                ->where('bankid', $sourceb)
                ->where('month >', $month)
                ->where('year', $year)
                ->orderBy('id', 'Asc')
                ->get()
                ->getResult();
                
                if(!empty($getValueofNextMonthBalance_withdrawlarray))
                {
                    for ($i = 0; $i < count($getValueofNextMonthBalance_withdrawlarray); $i++) 
                    {
                        // Get closing bal of prev month and update in current month ... 
                        $NextMonthsBal = new MonthsBalances_m();
                        $NextMonthsBal->update($getValueofNextMonthBalance_withdrawlarray[$i]->id, ['openingbal' =>  $closing_Bal_withdrawlarray]);
        
                        // shift closing bal for null entry...
        
                        $prevClosing_withdrawlarray = $closing_Bal_withdrawlarray;
        
                        // return the closing balance of current month....
                        $closing_Bal_withdrawlarray = $lastRecord->table('sss_tbl_bankbook')
                            ->select('sss_bb_balance,sss_bb_transmonth')
                            ->where('sss_allbankid', $getValueofNextMonthBalance_withdrawlarray[$i]->bankid)
                            ->where('sss_bb_transmonth', $getValueofNextMonthBalance_withdrawlarray[$i]->balancemonth)
                            ->orderBy('sss_bb_transactiondate', 'Desc')
                            ->limit(1)
                            ->get()
                            ->getRow();
    
                        // $closing_Bal_withdrawlarray = $closing_Bal_withdrawlarray->sss_bb_balance;

                        if (!empty($closing_Bal_withdrawlarray)) {
                            $closing_Bal_withdrawlarray = $closing_Bal_withdrawlarray->sss_bb_balance;
                        } else {
                            $closing_Bal_withdrawlarray = $prevClosing_withdrawlarray;
                        }
                    }
                }
                
            }
            
            
            // for tax bank....
            $closing_Bal_taxarray = 0;
            $getlastRecord_transactiondate_taxarray = $lastRecord->table('sss_tbl_bankbook')
                ->select('sss_bb_balance,sss_bb_transmonth')
                ->orderBy('sss_bb_transactiondate', 'Desc')
                ->where('sss_allbankid', 3)
                ->where('sss_bb_transmonth', $sss_bb_transmonth)
                ->limit(1)
                ->get()
                ->getRow();
                
            if(!empty($getlastRecord_transactiondate_taxarray))
            {
                $closing_Bal_taxarray = $getlastRecord_transactiondate_taxarray->sss_bb_balance;
                $getValueofNextMonthBalance_taxarray = $NextMonthsBalances_m
                ->where('bankid', 3)
                ->where('month >', $month)
                ->where('year', $year)
                ->orderBy('id', 'Asc')
                ->get()
                ->getResult();
                if(!empty($getValueofNextMonthBalance_taxarray))
                {
                    for ($i = 0; $i < count($getValueofNextMonthBalance_taxarray); $i++) 
                    {
                        // Get closing bal of prev month and update in current month ... 
                        $NextMonthsBal = new MonthsBalances_m();
                        $NextMonthsBal->update($getValueofNextMonthBalance_taxarray[$i]->id, ['openingbal' =>  $closing_Bal_taxarray]);
        
                        // shift closing bal for null entry...
                        $prevClosing_taxarray = $closing_Bal_taxarray;
        
                        // return the closing balance of current month....
                        $closing_Bal_taxarray = $lastRecord->table('sss_tbl_bankbook')
                            ->select('sss_bb_balance,sss_bb_transmonth')
                            ->where('sss_allbankid', $getValueofNextMonthBalance_taxarray[$i]->bankid)
                            ->where('sss_bb_transmonth', $getValueofNextMonthBalance_taxarray[$i]->balancemonth)
                            ->orderBy('sss_bb_transactiondate', 'Desc')
                            ->limit(1)
                            ->get()
                            ->getRow();

                        if (!empty($closing_Bal_taxarray)) {
                            $closing_Bal_taxarray = $closing_Bal_taxarray->sss_bb_balance;
                        } else {
                            $closing_Bal_taxarray = $prevClosing_taxarray;
                        }
                    }
                }
                
            }
            
            // for adv array
            $closing_Bal_advarray = 0;
            $getlastRecord_transactiondate_advarray = $lastRecord->table('sss_tbl_bankbook')
                ->select('sss_bb_balance,sss_bb_transmonth')
                ->orderBy('sss_bb_transactiondate', 'Desc')
                ->where('sss_allbankid', 2)
                ->where('sss_bb_transmonth', $sss_bb_transmonth)
                ->limit(1)
                ->get()
                ->getRow();

            if(!empty($getlastRecord_transactiondate_advarray))
            {
                $closing_Bal_advarray = $getlastRecord_transactiondate_advarray->sss_bb_balance;
                $getValueofNextMonthBalance_advarray = $NextMonthsBalances_m
                ->where('bankid', 2)
                ->where('month >', $month)
                ->where('year', $year)
                ->orderBy('id', 'Asc')
                ->get()
                ->getResult();
                
                if(!empty($getValueofNextMonthBalance_advarray))
                {
                    for ($i = 0; $i < count($getValueofNextMonthBalance_advarray); $i++) 
                    {
                        // Get closing bal of prev month and update in current month ... 
                        $NextMonthsBal = new MonthsBalances_m();
                        $NextMonthsBal->update($getValueofNextMonthBalance_advarray[$i]->id, ['openingbal' =>  $closing_Bal_advarray]);
        
                        // shift closing bal for null entry...
                        $prevClosing_advarray = $closing_Bal_advarray;
                        // return the closing balance of current month....
                        $closing_Bal_advarray = $lastRecord->table('sss_tbl_bankbook')
                            ->select('sss_bb_balance,sss_bb_transmonth')
                            ->where('sss_allbankid', $getValueofNextMonthBalance_advarray[$i]->bankid)
                            ->where('sss_bb_transmonth', $getValueofNextMonthBalance_advarray[$i]->balancemonth)
                            ->orderBy('sss_bb_transactiondate', 'Desc')
                            ->limit(1)
                            ->get()
                            ->getRow();
                        
                        if (!empty($closing_Bal_advarray)) {
                            $closing_Bal_advarray = $closing_Bal_advarray->sss_bb_balance;
                        } else {
                            $closing_Bal_taxarray = $prevClosing_advarray;
                        }
                    }
                }
            }
            echo json_encode(array("status" => true, "message" => 'Deal Details Draft is Inserted'));
        }
    }
    




    // public function edit_ddd($dddid)
    // {
    //     $editrecord = new Dealdetaildraft_m();
    //     $data = $editrecord->find($dddid);
    //     $ddcid  = $data['sss_ddc_id'];

    //     $allemprecord = new DDD_emp_m();
    //     $data['emps'] = $allemprecord->table('sss_ddd_employees')->select('sss_ddd_employees.*, sss_tbl_emp.sss_emp_fname,sss_tbl_emp.sss_emp_lname,sss_tbl_emp.sss_emp_share')->join('sss_tbl_emp', 'sss_tbl_emp.sss_emp_id = sss_ddd_employees.sss_emp_id')->where('sss_ddd_id', $dddid)->get()->getResult();

    //     $ddc = new Dealdisbursalchart_m();
    //     $data['ddc'] = $ddc->table('sss_tbl_dealdisbursalchart')->select("sss_tbl_dealdisbursalchart.sss_dd_sbamt, sss_tbl_dealdisbursalchart.sss_dd_royality, sss_tbl_paymentreceived.sss_pr_id,sss_tbl_paymentreceived.sss_pr_tdsamt,sss_tbl_paymentreceived.sss_pr_balanceamt,sss_tbl_paymentreceived.sss_pr_amtreceived,sss_tbl_invoices.sss_inv_id,sss_tbl_invoices.sss_inv_bill_no,sss_tbl_invoices.sss_inv_bill_date,sss_tbl_invoices.sss_inv_amt,sss_tbl_invoices.sss_inv_sgst,sss_tbl_invoices.sss_inv_cgst,sss_tbl_invoices.sss_inv_igst,sss_tbl_invoices.sss_inv_total_amt,sss_tbl_invoices.sss_inv_client_id,sss_tbl_client.sss_client_name")
    //         ->join('sss_tbl_paymentreceived', 'sss_tbl_paymentreceived.sss_pr_id = sss_tbl_dealdisbursalchart.sss_pr_id')
    //         ->join('sss_tbl_invoices', 'sss_tbl_invoices.sss_inv_id = sss_tbl_paymentreceived.sss_inv_id')
    //         ->join('sss_tbl_client', 'sss_tbl_client.sss_client_id = sss_tbl_invoices.sss_inv_client_id')
    //         ->where('sss_dd_id', $ddcid)
    //         ->get()->getRow();
    //     if ($data['ddc']->sss_inv_cgst != "0" || $data['ddc']->sss_inv_sgst != "0") {
    //         $totalgst = $data['ddc']->sss_inv_cgst + $data['ddc']->sss_inv_sgst;
    //         $data['totalgst'] = $totalgst;
    //     } else {
    //         $totalgst = $data['ddc']->sss_inv_igst;
    //         $data['totalgst'] = $totalgst;
    //     }
    //     $alloutcomerecord = new DDD_outcome_m();
    //     $data['outcome'] = $alloutcomerecord->table('sss_ddd_outcomes')->select("sss_ddd_outcomes.*,sss_tbl_outcomes.sss_oc_name,sss_tbl_outcomes.sss_oc_share,sss_tbl_outcomes.sss_oc_type")->join('sss_tbl_outcomes', 'sss_tbl_outcomes.sss_oc_id = sss_ddd_outcomes.sss_ddd_oc_id')->where('sss_ddd_id', $dddid)->get()->getResult();
    //     // echo "<pre>";print_r($data['outcome']);exit;
    //     return view('edit_ddd', $data);
    //     // echo json_encode($data);
    // }

    // public function update_ddd()
    // {
    //     $id = $this->request->getVar('sss_ddd_id');
    //     $occount = count($_POST['sss_ddd_oc_id']);
    //     $isOutcomes = new DDD_outcome_m();
    //     for ($i = 0; $i < $occount; $i++) {
    //         $outcomeid = $_POST['sss_ddd_outcomes_id'][$i];
    //         $sss_ddd_outcomeamt = $_POST['sss_ddd_outcomeamt'][$i];
    //         $sss_ddd_outcomeroundamt = $_POST['sss_ddd_outcomeroundamt'][$i];
    //         $sss_ddd_outcometotalamt = $_POST['sss_ddd_outcometotalamt'][$i];
    //         $sss_ddd_outcomefinalamt = $_POST['sss_ddd_outcomefinalamt'][$i];
    //         $isOutcomes->table('sss_ddd_outcomes')->set(['sss_ddd_outcomeamt' => $sss_ddd_outcomeamt, 'sss_ddd_outcomeroundamt' => $sss_ddd_outcomeroundamt, 'sss_ddd_outcometotalamt' => $sss_ddd_outcometotalamt, 'sss_ddd_outcomefinalamt' => $sss_ddd_outcomefinalamt])->where('sss_ddd_outcomes_id', $outcomeid)->update();
    //     }
    //     $empno = count($_POST['sss_emp_id']);
    //     $isEmps = new DDD_emp_m();
    //     for ($i = 0; $i < $empno; $i++) {
    //         $empid = $_POST['id'][$i];
    //         $sss_dddemp_amt = $_POST['sss_dddemp_amt'][$i];
    //         $sss_ddd_emproundamt = $_POST['sss_ddd_emproundamt'][$i];
    //         $sss_ddd_emptdsamt = $_POST['sss_ddd_emptdsamt'][$i];
    //         $sss_ddd_empfinalamt = $_POST['sss_ddd_empfinalamt'][$i];
    //         $isEmps->table('sss_ddd_employees')->set(['sss_dddemp_amt' => $sss_dddemp_amt, 'sss_dddemp_roundedamt' => $sss_ddd_emproundamt, 'sss_dddemp_tds' => $sss_ddd_emptdsamt, 'sss_dddemp_finalamt' => $sss_ddd_empfinalamt])->where('id', $empid)->update();
    //     }

    //     $updaterecord = new Dealdetaildraft_m();
    //     $data = [
    //         'sss_ddc_id' => $this->request->getVar('sss_ddc_id'),
    //         'sss_ddd_misc' => $this->request->getVar('sss_ddd_misc'),
    //         'sss_ddd_shno' => $this->request->getVar('sss_ddd_shno'),
    //         'sss_ddd_transmode' => $this->request->getVar('sss_ddd_transmode'),
    //         'sss_ddd_transreffno' => $this->request->getVar('sss_ddd_transreffno'),
    //         'sss_ddd_sbamt_amt' => $this->request->getVar('sss_ddd_sbamt_amt'),
    //         'sss_ddd_sbamt_tdsper' =>  $this->request->getVar('sss_ddd_sbamt_tdsper'),
    //         'sss_ddd_sbamt_tds' => $this->request->getVar('sss_ddd_sbamt_tds'),
    //         'sss_ddd_cirilroyalityamt' => $this->request->getVar('sss_ddd_cirilroyalityamt'),
    //         'sss_ddd_cirilroyality_tdsper' => $this->request->getVar('sss_ddd_cirilroyality_tdsper'),
    //         'sss_ddd_cirilroyality_tds' => $this->request->getVar('sss_ddd_cirilroyality_tds'),
    //         'sss_ddd_unknown' => $this->request->getVar('sss_ddd_unknown'),
    //         'sss_ddd_unknownamt' => $this->request->getVar('sss_ddd_unknownamt'),
    //         'sss_ddd_unknown_tdsper' => $this->request->getVar('sss_ddd_unknown_tdsper'),
    //         'sss_ddd_unknown_tds' => $this->request->getVar('sss_ddd_unknown_tds'),
    //         'sss_ddd_ourshare' => $this->request->getVar('sss_ddd_ourshare'),
    //         'sss_ddd_gst' => $this->request->getVar('sss_ddd_gst'),
    //         'sss_ddd_gst_amt' => $this->request->getVar('sss_ddd_gst_amt'),
    //         'sss_ddd_gst_rounded' => $this->request->getVar('sss_ddd_gst_rounded'),
    //         'sss_ddd_gst_total' => $this->request->getVar('sss_ddd_gst_total'),
    //         'sss_ddd_gst_tds' => $this->request->getVar('sss_ddd_gst_tds'),
    //         'sss_ddd_gst_finalamt' => $this->request->getVar('sss_ddd_gst_finalamt'),
    //         'sumofempRoundvalues' => $this->request->getVar('sumofempRoundvalues'),
    //         'sss_ddd_total_roundvalue' => $this->request->getVar('sss_ddd_total_roundvalue'),
    //         'sss_ddd_sumofroundvalue' => $this->request->getVar('sss_ddd_sumofroundvalue'),
    //         'sss_ddd_total_tds' => $this->request->getVar('sss_ddd_total_tds'),
    //         'sss_ddd_total_finalamt' => $this->request->getVar('sss_ddd_total_finalamt'),
    //         'sss_ddd_balanceincurrent' => $this->request->getVar('sss_ddd_balanceincurrent'),
    //         'sss_ddd_balanceincurrentinper' => $this->request->getVar('sss_ddd_balanceincurrentinper'),
    //         'sss_ddd_updateby' => session('userid'),
    //         'sss_ddd_updatedate' => date('Y-m-d')
    //     ];
    //     $isupdated = $updaterecord->update($id, $data);
    //     if (!empty($isupdated)) {
    //         echo json_encode(array("status" => true, "message" => 'Deal Disbursal Draft Updated'));
    //     } else {
    //         echo json_encode(array("status" => false, "message" => 'Something error while updating Deal Disbursal Draft'));
    //     }
    // }

    // public function delete_ddd($dddid)
    // {

    //     $Dealdetaildraft_m = new Dealdetaildraft_m();
    //     $pridForBB = $Dealdetaildraft_m->table('sss_tbl_dealdetaildraft')->where('sss_ddd_id', $dddid)->get()->getRow();

    //     if (!empty($pridForBB)) {
    //         $payment = new Paymentreceived_m();
    //         $getsourcebankid = $payment->table('sss_tbl_paymentreceived')->where('sss_pr_id', $pridForBB->sss_pr_id)->get()->getRow();
    //     }

    //     $invoice = new CreateInvoice_m();
    //     $getInvoice = $invoice->find($getsourcebankid->sss_inv_id);

    //     $Bankbook_m = new Bankbook_m();
    //     $bb = $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $dddid)->get()->getResult();

    //     $getbankid = new Bankdetails_m();

    //     $updatedepositebank = new Bankdetails_m();

    //     foreach ($bb as $b) {

    //         if ($b->sss_bb_transtype == 'Withdrawl' && $b->sss_bb_iswithdrawl != '') {

    //             $ssdddid = $b->sss_ddd_id;
    //             $sbankid = $b->sss_bb_sourcebankid;
    //             $sourcetransamt = $b->sss_bb_iswithdrawl;

    //             $openingbalance = $getbankid->find($sbankid);
    //             $opningbalofwithdrawlbank = $openingbalance['sss_ent_bank_acc_openingbal'];

    //             $bankbalanceupdat = $opningbalofwithdrawlbank + $sourcetransamt;

    //             $sourcebankwithdrawarray = [
    //                 'sss_ent_bank_acc_openingbal' => $bankbalanceupdat,
    //                 'sss_ent_bank_last_updated_by' => session('userid'),
    //                 'sss_ent_bank_updated_date' => date('Y-m-d')
    //             ];

    //             $updatedepositebank->update($sbankid, $sourcebankwithdrawarray);
    //             $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $ssdddid)->delete();
    //         }

    //         if ($b->sss_bb_transtype == 'Deposit' && $b->sss_bb_isdeposit != '') {
    //             $ssdddid = $b->sss_ddd_id;
    //             $dbankid = $b->sss_bb_destinationbankid;
    //             $openingbalance = $getbankid->find($dbankid);
    //             $opningbalofdestinationbank = $openingbalance['sss_ent_bank_acc_openingbal'];
    //             $destinationtransamt = $b->sss_bb_isdeposit;
    //             $depositebankbalanceupdat = $opningbalofdestinationbank - $destinationtransamt;
    //             $destinationbankdepositearray = [
    //                 'sss_ent_bank_acc_openingbal' => $depositebankbalanceupdat,
    //                 'sss_ent_bank_last_updated_by' => session('userid'),
    //                 'sss_ent_bank_updated_date' => date('Y-m-d')
    //             ];
    //             $updatedepositebank->update($dbankid, $destinationbankdepositearray);
    //             $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $ssdddid)->delete();
    //         }
    //     }


    //     $Tdsentries_m = new Tdsentries_m();
    //     $isTDs = $Tdsentries_m->table('sss_tbl_totaltds')->where('sss_ddd_id', $dddid)->delete();  // delete tds entries of DDD..

    //     $isDelete = new Dealdetaildraft_m();
    //     $isDelete->table('sss_tbl_dealdetaildraft')->where('sss_ddd_id', $dddid)->delete();

    //     $allemprecord = new DDD_emp_m();
    //     $allemprecord->table('sss_ddd_employees')->where('sss_ddd_id', $dddid)->delete();

    //     $alloutcomerecord = new DDD_outcome_m();
    //     $alloutcomerecord->table('sss_ddd_outcomes')->where('sss_ddd_id', $dddid)->delete();

    //     echo json_encode(array("status" => TRUE));
    // }

    // without openingmonth///
    // public function delete_ddd($dddid)
    // {
    //     $Dealdetaildraft_m = new Dealdetaildraft_m();
    //     $getbankid = new Bankdetails_m();
    //     $updatedepositebank = new Bankdetails_m();
    //     $payment = new Paymentreceived_m();
    //     $invoice = new CreateInvoice_m();
    //     $Bankbook_m = new Bankbook_m();

    //     // method for checking emphas bank or not...
    //     $isEmp = new Employee_m();

    //     // echo "<pre>";print_r($getbanksemp);exit;
    //     $allemprecord = new DDD_emp_m();
    //     $employees = $allemprecord->table('sss_ddd_employees')->select('sss_ddd_employees.*')->where('sss_ddd_id', $dddid)->get()->getResult();
    //     // echo "<pre>";print_r($employees);exit;

    //     if (!empty($employees)) {
    //         $emps_bankid = 0;
    //         $emps_id = 0;
           
    //         foreach ($employees as $emp) {
    //             $empid = $emp->sss_emp_id;
                
    //             $getbanksemp = $isEmp->select('sss_emp_id,sss_emp_bankid')->where('sss_hadbank', "Yes")->where('sss_emp_id', $empid)->orderBy('sss_emp_id', 'Desc')->get()->getRow();
                
    //             if ($getbanksemp != null) {
    //                 $emps_bankid = $getbanksemp->sss_emp_bankid;
    //             } 
              
    //         }
    //     }
        
        
        
    //     $pridForBB = $Dealdetaildraft_m->table('sss_tbl_dealdetaildraft')->where('sss_ddd_id', $dddid)->get()->getRow();
    //     if (!empty($pridForBB)) {
    //         $getsourcebankid = $payment->table('sss_tbl_paymentreceived')->where('sss_pr_id', $pridForBB->sss_pr_id)->get()->getRow();

    //         $invoice = new CreateInvoice_m();
    //         $getInvoice = $invoice->find($getsourcebankid->sss_inv_id);
    //         $getInvoice['sss_inv_bankid']; // getbank id for checking into loop of balance reflushing....

    //     }

    //     $bb = $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $dddid)->get()->getResult();

    //     foreach ($bb as $b) {
    //         if ($b->sss_bb_transtype == 'Withdrawl' && $b->sss_bb_iswithdrawl != '') {
    //             $ssdddid = $b->sss_ddd_id;

    //             $sbankid = $b->sss_bb_sourcebankid;
    //             $sourcetransamt = $b->sss_bb_iswithdrawl;

    //             $openingbalance = $getbankid->find($sbankid);
    //             $opningbalofwithdrawlbank = $openingbalance['sss_ent_bank_acc_openingbal'];

    //             $bankbalanceupdat = $opningbalofwithdrawlbank + $sourcetransamt;

    //             $sourcebankwithdrawarray = [
    //                 'sss_ent_bank_acc_openingbal' => $bankbalanceupdat,
    //                 'sss_ent_bank_last_updated_by' => session('userid'),
    //                 'sss_ent_bank_updated_date' => date('Y-m-d')
    //             ];

    //             $updatedepositebank->update($sbankid, $sourcebankwithdrawarray);
    //             // $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $ssdddid)->delete();
    //         }
    //         if ($b->sss_bb_transtype == 'Deposit' && $b->sss_bb_isdeposit != '') {
    //             $ssdddid = $b->sss_ddd_id;
    //             $dbankid = $b->sss_bb_destinationbankid;
    //             $openingbalance = $getbankid->find($dbankid);
    //             $opningbalofdestinationbank = $openingbalance['sss_ent_bank_acc_openingbal'];
    //             $destinationtransamt = $b->sss_bb_isdeposit;
    //             $depositebankbalanceupdat = $opningbalofdestinationbank - $destinationtransamt;
    //             $destinationbankdepositearray = [
    //                 'sss_ent_bank_acc_openingbal' => $depositebankbalanceupdat,
    //                 'sss_ent_bank_last_updated_by' => session('userid'),
    //                 'sss_ent_bank_updated_date' => date('Y-m-d')
    //             ];
    //             $updatedepositebank->update($dbankid, $destinationbankdepositearray);
    //             // $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $ssdddid)->delete();
    //         }
    //     }

    //     $BankBook_entries_ofdeletedid = $Bankbook_m->table('sss_tbl_bankbook')->select('sss_bankbook_id,sss_bb_transamt,sss_bb_transtype,sss_bb_transactiondate,sss_allbankid')->where('sss_ddd_id', $dddid)->orderBy('sss_bankbook_id', 'ASC')->get()->getResult();

    //     $lastBankBookEntry = end($BankBook_entries_ofdeletedid); // get last entry of bankbookid end and id pass to next query...
        
    //     $bankbookid = $lastBankBookEntry->sss_bankbook_id;
    //     $bankbookdate = $lastBankBookEntry->sss_bb_transactiondate;
        
    //     // exit;
    //     $isWithdrawled = 0;
    //     $isTax_Deposited = 0;
    //     $isAdv_Deposited = 0;
        
    //     // echo "<pre>";print_r($BankBook_entries_ofdeletedid);exit;
        
    //     foreach ($BankBook_entries_ofdeletedid as $deletedrecord) {
    //         if ($deletedrecord->sss_bb_transtype == 'Withdrawl') {
    //             $isWithdrawled += $deletedrecord->sss_bb_transamt;
    //         } else if ($deletedrecord->sss_bb_transtype == 'Deposit') {

    //             if ($deletedrecord->sss_allbankid == 3) // for tax bank
    //             {
    //                 $isTax_Deposited = $deletedrecord->sss_bb_transamt;
    //             } else if ($deletedrecord->sss_allbankid == 2) // for advertisment bank...
    //             {
    //                 $isAdv_Deposited = $deletedrecord->sss_bb_transamt;
    //             } else if ($deletedrecord->sss_allbankid === $emps_bankid) {

    //                 $isEmp_deposited = $deletedrecord->sss_bb_transamt;
    //             }
    //         }
    //     }

    //     $next_BankBook_entries = $Bankbook_m->table('sss_tbl_bankbook')->where('sss_bb_transactiondate >', $bankbookdate)->orderBy('sss_bankbook_id', 'ASC')->get()->getResult(); // next bankbook entries which from deleting id..

    //     // $next_BankBook_entries = $Bankbook_m->table('sss_tbl_bankbook')->where('sss_bankbook_id >', $bankbookid)->orderBy('sss_bankbook_id', 'ASC')->get()->getResult(); // next bankbook entries which from deleting id..

    //     if (!empty($next_BankBook_entries)) {
    //         foreach ($next_BankBook_entries as $nextentries) {
    //             if ($nextentries->sss_bb_transtype == 'Deposit') {
    //                 if ($nextentries->sss_allbankid == 3) {
    //                     $bankid_Tax = $nextentries->sss_bankbook_id;
    //                     $deposite_lastbalances = $nextentries->sss_bb_lastbalance;
    //                     $newTaxlastBalance = $deposite_lastbalances - $isTax_Deposited;
    //                     $newTaxcurrentBalance = $newTaxlastBalance + $nextentries->sss_bb_transamt;
    //                     $new_TaxBalances_withdrawl = [
    //                         'sss_bb_balance' => $newTaxcurrentBalance,
    //                         'sss_bb_lastbalance' => $newTaxlastBalance,
    //                         'sss_bb_updated_by' => session('userid'),
    //                         'sss_bb_update_date' => date('Y-m-d')
    //                     ];
    //                     $Bankbook_m->update($bankid_Tax, $new_TaxBalances_withdrawl);
    //                 }
    //                 if ($nextentries->sss_allbankid == 2) {
    //                     $bankid_Adv = $nextentries->sss_bankbook_id;
    //                     $Advdeposite_lastbalances = $nextentries->sss_bb_lastbalance;
    //                     $newAdvlastBalance = $Advdeposite_lastbalances - $isAdv_Deposited;
    //                     $newcurrentBalance = $newAdvlastBalance + $nextentries->sss_bb_transamt;
    //                     $new_AdvBalances_withdrawl = [
    //                         'sss_bb_lastbalance' => $newAdvlastBalance,
    //                         'sss_bb_balance' => $newcurrentBalance,
    //                         'sss_bb_updated_by' => session('userid'),
    //                         'sss_bb_update_date' => date('Y-m-d')
    //                     ];
    //                     $Bankbook_m->update($bankid_Adv, $new_AdvBalances_withdrawl);
    //                 }
    //                 if ($nextentries->sss_allbankid == $emps_bankid) {
    //                     $bankid_emp = $nextentries->sss_bankbook_id;
    //                     $Emp_deposite_lastbalances = $nextentries->sss_bb_lastbalance;
    //                     $newEmplastBalance = $Emp_deposite_lastbalances - $isEmp_deposited;
    //                     $newEmpcurrentbalance = $newEmplastBalance + $nextentries->sss_bb_transamt;

    //                     $new_EmpBalances_withdrawl = [
    //                         'sss_bb_balance' => $newEmpcurrentbalance,
    //                         'sss_bb_lastbalance' => $newEmplastBalance,
    //                         'sss_bb_updated_by' => session('userid'),
    //                         'sss_bb_update_date' => date('Y-m-d')
    //                     ];
    //                     $Bankbook_m->update($bankid_emp, $new_EmpBalances_withdrawl);
    //                 }
    //             }
    //             if ($nextentries->sss_bb_transtype == 'Withdrawl') {
    //                 $bankid_redeposite = $nextentries->sss_bankbook_id;
    //                 $withdrwl_lastbalances = $nextentries->sss_bb_lastbalance;
    //                 $newlastBalance_deposited = $withdrwl_lastbalances + $isWithdrawled; // add the withdrawl amount
    //                 $newcurrentbalance_deposited = $newlastBalance_deposited - $nextentries->sss_bb_transamt; // Subtract the withdrawl amount
    //                 $new_Balances_deposite = [
    //                     'sss_bb_balance' => $newcurrentbalance_deposited,
    //                     'sss_bb_lastbalance' => $newlastBalance_deposited,
    //                     'sss_pr_updated_by' => session('userid'),
    //                     'sss_pr_update_date' => date('Y-m-d')
    //                 ];
    //                 // echo "<pre>";print_r($new_Balances_deposite);
    //                 $Bankbook_m->update($bankid_redeposite, $new_Balances_deposite);
    //             }

    //             if ($nextentries->sss_bb_transtype == 'Deposit' && $nextentries->sss_allbankid  == $getInvoice['sss_inv_bankid']) {
    //                 // condition for deposite values when the mid entry of any payment received... 
    //                 $bankid_redeposite = $nextentries->sss_bankbook_id;
    //                 // echo $bankid_redeposite . "<br>";
    //                 $withdrwl_otherlastbalances = $nextentries->sss_bb_lastbalance; // other balance which is deposite bt not in adv , tax or emp bank.
    //                 // echo $withdrwl_otherlastbalances . "<br>";
    //                 $newlastBalance_otherdeposited = $withdrwl_otherlastbalances + $isWithdrawled; // Subtract the withdrawl amount
    //                 $newcurrentbalance_deposited = $newlastBalance_otherdeposited + $nextentries->sss_bb_transamt;; // Subtract the withdrawl amount
    //                 $new_OtherBalances_deposite = [
    //                     'sss_bb_balance' => $newcurrentbalance_deposited,
    //                     'sss_bb_lastbalance' => $newlastBalance_otherdeposited,
    //                     'sss_pr_updated_by' => session('userid'),
    //                     'sss_pr_update_date' => date('Y-m-d')
    //                 ];
    //                 // echo "<pre>";print_r($new_OtherBalances_deposite);
    //                 $Bankbook_m->update($bankid_redeposite, $new_OtherBalances_deposite);
    //             }

    //             if ($nextentries->sss_bb_transtype == 'Withdrawl' && $nextentries->sss_allbankid == $getInvoice['sss_inv_bankid']) {
    //                 // condition for deposite values when the mid entry of any payment received...

    //                 $bankid_redeposite = $nextentries->sss_bankbook_id;
    //                 // echo $bankid_redeposite . "<br>";
    //                 $withdrwl_otherlastbalances = $nextentries->sss_bb_lastbalance; // other balance which is deposite bt not in adv , tax or emp bank.
    //                 // echo $withdrwl_otherlastbalances . "<br>";
    //                 $newlastBalance_otherdeposited = $withdrwl_otherlastbalances + $isWithdrawled; // ADD the withdrawl amount
    //                 $newcurrentbalance_deposited_invbank = $newlastBalance_otherdeposited - $nextentries->sss_bb_transamt;; // Subtract the withdrawl amount
    //                 $new_OtherBalances_deposite = [
    //                     'sss_bb_balance' => $newcurrentbalance_deposited_invbank,
    //                     'sss_bb_lastbalance' => $newlastBalance_otherdeposited,
    //                     'sss_pr_updated_by' => session('userid'),
    //                     'sss_pr_update_date' => date('Y-m-d')
    //                 ];
    //                 // echo "<pre>";print_r($new_OtherBalances_deposite);
    //                 $Bankbook_m->update($bankid_redeposite, $new_OtherBalances_deposite);
    //             }
    //         }
    //     }

    //     $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $dddid)->delete();

    //     $Tdsentries_m = new Tdsentries_m();
    //     $Tdsentries_m->table('sss_tbl_totaltds')->where('sss_ddd_id', $dddid)->delete();  // delete tds entries of DDD..

    //     $isDelete = new Dealdetaildraft_m();
    //     $isDelete->table('sss_tbl_dealdetaildraft')->where('sss_ddd_id', $dddid)->delete();

    //     $allemprecord = new DDD_emp_m();
    //     $allemprecord->table('sss_ddd_employees')->where('sss_ddd_id', $dddid)->delete();

    //     $alloutcomerecord = new DDD_outcome_m();
    //     $alloutcomerecord->table('sss_ddd_outcomes')->where('sss_ddd_id', $dddid)->delete();

    //     echo json_encode(array("status" => TRUE));
    // }
    
    // public function delete_ddd($dddid)
    // {
    //     $Dealdetaildraft_m = new Dealdetaildraft_m();
    //     $getbankid = new Bankdetails_m();
    //     $updatedepositebank = new Bankdetails_m();
    //     $payment = new Paymentreceived_m();
    //     $invoice = new CreateInvoice_m();
    //     $Bankbook_m = new Bankbook_m();
    //     $NextMonthsBalances_m = new MonthsBalances_m();

    //     // method for checking emphas bank or not...
    //     $isEmp = new Employee_m();

    //     // echo "<pre>";print_r($getbanksemp);exit;
    //     $allemprecord = new DDD_emp_m();
    //     $employees = $allemprecord->table('sss_ddd_employees')->select('sss_ddd_employees.*')->where('sss_ddd_id', $dddid)->get()->getResult();

    //     if (!empty($employees)) {
    //         $emps_bankid = 0;
    //         $emps_id = 0;

    //         foreach ($employees as $emp) {
    //             $empid = $emp->sss_emp_id;

    //             $getbanksemp = $isEmp->select('sss_emp_id,sss_emp_bankid')->where('sss_hadbank', "Yes")->where('sss_emp_id', $empid)->orderBy('sss_emp_id', 'Desc')->get()->getRow();

    //             if ($getbanksemp != null) {
    //                 $emps_bankid = $getbanksemp->sss_emp_bankid;
    //             }
    //         }
    //     }

    //     $pridForBB = $Dealdetaildraft_m->table('sss_tbl_dealdetaildraft')->where('sss_ddd_id', $dddid)->get()->getRow();
    //     if (!empty($pridForBB)) {
    //         $getsourcebankid = $payment->table('sss_tbl_paymentreceived')->where('sss_pr_id', $pridForBB->sss_pr_id)->get()->getRow();

    //         $invoice = new CreateInvoice_m();
    //         $getInvoice = $invoice->find($getsourcebankid->sss_inv_id);
    //         $getInvoice['sss_inv_bankid']; // getbank id for checking into loop of balance reflushing....

    //     }

    //     $bb = $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $dddid)->get()->getResult();

    //     foreach ($bb as $b) {
    //         if ($b->sss_bb_transtype == 'Withdrawl' && $b->sss_bb_iswithdrawl != '') {

    //             $ssdddid = $b->sss_ddd_id;

    //             $sbankid = $b->sss_bb_sourcebankid;
    //             $sourcetransamt = $b->sss_bb_iswithdrawl;

    //             $openingbalance = $getbankid->find($sbankid);
    //             $opningbalofwithdrawlbank = $openingbalance['sss_ent_bank_acc_openingbal'];

    //             $bankbalanceupdat = $opningbalofwithdrawlbank + $sourcetransamt;

    //             $sourcebankwithdrawarray = [
    //                 'sss_ent_bank_acc_openingbal' => $bankbalanceupdat,
    //                 'sss_ent_bank_last_updated_by' => session('userid'),
    //                 'sss_ent_bank_updated_date' => date('Y-m-d')
    //             ];

    //             $updatedepositebank->update($sbankid, $sourcebankwithdrawarray);
    //             // $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $ssdddid)->delete();
    //         }
    //         if ($b->sss_bb_transtype == 'Deposit' && $b->sss_bb_isdeposit != '') {
    //             $ssdddid = $b->sss_ddd_id;
    //             $dbankid = $b->sss_bb_destinationbankid;
    //             $openingbalance = $getbankid->find($dbankid);
    //             $opningbalofdestinationbank = $openingbalance['sss_ent_bank_acc_openingbal'];
    //             $destinationtransamt = $b->sss_bb_isdeposit;
    //             $depositebankbalanceupdat = $opningbalofdestinationbank - $destinationtransamt;
    //             $destinationbankdepositearray = [
    //                 'sss_ent_bank_acc_openingbal' => $depositebankbalanceupdat,
    //                 'sss_ent_bank_last_updated_by' => session('userid'),
    //                 'sss_ent_bank_updated_date' => date('Y-m-d')
    //             ];
    //             $updatedepositebank->update($dbankid, $destinationbankdepositearray);
    //             // $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $ssdddid)->delete();
    //         }
    //     }


    //     $BankBook_entries_ofdeletedid = $Bankbook_m->table('sss_tbl_bankbook')->select('sss_bankbook_id,sss_bb_transamt,sss_bb_transtype,sss_bb_transactiondate,sss_allbankid')->where('sss_ddd_id', $dddid)->orderBy('sss_bankbook_id', 'ASC')->get()->getResult();


    //     $lastBankBookEntry = end($BankBook_entries_ofdeletedid); // get last entry of bankbookid end and id pass to next query...

    //     $bankbookid = $lastBankBookEntry->sss_bankbook_id;
    //     $bank_id = $lastBankBookEntry->sss_allbankid;
    //     $bankbookdate = $lastBankBookEntry->sss_bb_transactiondate;

    //     $dateComps = date_parse($bankbookdate);
    //     $year = $dateComps['year'];
    //     $month = $dateComps['month'];

    //     $sss_bb_transmonth = $month . '-' . $year;

    //     $isWithdrawled = 0;
    //     $isTax_Deposited = 0;
    //     $isAdv_Deposited = 0;

    //     // echo "<pre>";print_r($BankBook_entries_ofdeletedid);exit;

    //     $closing_Bal_withdrawlarray = 0;
    //     // update openingmonth balances for all withdrawl...
    //     // for loop use for only gettting invoice bankid from table...
    //     foreach ($BankBook_entries_ofdeletedid as $foropeningmonth) {
    //         if ($foropeningmonth->sss_allbankid == $getInvoice['sss_inv_bankid']) {
    //             $withdrawl_bankid = $foropeningmonth->sss_allbankid;
    //         }

    //         if ($foropeningmonth->sss_allbankid == 3) {
    //             $tax_bankid = $foropeningmonth->sss_allbankid;
    //         }

    //         if ($foropeningmonth->sss_allbankid == 2) {
    //             $adv_bankid = $foropeningmonth->sss_allbankid;
    //         }

    //         if ($foropeningmonth->sss_allbankid == $emps_bankid) {
    //             $emp_bankid = $foropeningmonth->sss_allbankid;
    //         }
    //     }
        

    //     foreach ($BankBook_entries_ofdeletedid as $deletedrecord) {
    //         if ($deletedrecord->sss_bb_transtype == 'Withdrawl') {
    //             $isWithdrawled += $deletedrecord->sss_bb_transamt;
    //         } else if ($deletedrecord->sss_bb_transtype == 'Deposit') {

    //             if ($deletedrecord->sss_allbankid == 3) // for tax bank
    //             {
    //                 $isTax_Deposited = $deletedrecord->sss_bb_transamt;
    //             } else if ($deletedrecord->sss_allbankid == 2) // for advertisment bank...
    //             {
    //                 $isAdv_Deposited = $deletedrecord->sss_bb_transamt;
    //             } else if ($deletedrecord->sss_allbankid === $emps_bankid) {

    //                 $isEmp_deposited = $deletedrecord->sss_bb_transamt;
    //             }
    //         }
    //     }

    //     $next_BankBook_entries = $Bankbook_m->table('sss_tbl_bankbook')->where('sss_bb_transactiondate >', $bankbookdate)->orderBy('sss_bankbook_id', 'ASC')->get()->getResult(); // next bankbook entries which from deleting id..

    //     if (!empty($next_BankBook_entries)) {
    //         foreach ($next_BankBook_entries as $nextentries) {
    //             if ($nextentries->sss_bb_transtype == 'Deposit') {
    //                 if ($nextentries->sss_allbankid == 3) {
    //                     $bankid_Tax = $nextentries->sss_bankbook_id;
    //                     $deposite_lastbalances = $nextentries->sss_bb_lastbalance;
    //                     $newTaxlastBalance = $deposite_lastbalances - $isTax_Deposited;
    //                     $newTaxcurrentBalance = $newTaxlastBalance + $nextentries->sss_bb_transamt;
    //                     $new_TaxBalances_withdrawl = [
    //                         'sss_bb_balance' => $newTaxcurrentBalance,
    //                         'sss_bb_lastbalance' => $newTaxlastBalance,
    //                         'sss_bb_updated_by' => session('userid'),
    //                         'sss_bb_update_date' => date('Y-m-d')
    //                     ];
    //                     $Bankbook_m->update($bankid_Tax, $new_TaxBalances_withdrawl);
    //                 }
    //                 if ($nextentries->sss_allbankid == 2) {
    //                     $bankid_Adv = $nextentries->sss_bankbook_id;
    //                     $Advdeposite_lastbalances = $nextentries->sss_bb_lastbalance;
    //                     $newAdvlastBalance = $Advdeposite_lastbalances - $isAdv_Deposited;
    //                     $newcurrentBalance = $newAdvlastBalance + $nextentries->sss_bb_transamt;
    //                     $new_AdvBalances_withdrawl = [
    //                         'sss_bb_lastbalance' => $newAdvlastBalance,
    //                         'sss_bb_balance' => $newcurrentBalance,
    //                         'sss_bb_updated_by' => session('userid'),
    //                         'sss_bb_update_date' => date('Y-m-d')
    //                     ];
    //                     $Bankbook_m->update($bankid_Adv, $new_AdvBalances_withdrawl);
    //                 }
    //                 if ($nextentries->sss_allbankid == $emps_bankid) {
    //                     $bankid_emp = $nextentries->sss_bankbook_id;
    //                     $Emp_deposite_lastbalances = $nextentries->sss_bb_lastbalance;
    //                     $newEmplastBalance = $Emp_deposite_lastbalances - $isEmp_deposited;
    //                     $newEmpcurrentbalance = $newEmplastBalance + $nextentries->sss_bb_transamt;

    //                     $new_EmpBalances_withdrawl = [
    //                         'sss_bb_balance' => $newEmpcurrentbalance,
    //                         'sss_bb_lastbalance' => $newEmplastBalance,
    //                         'sss_bb_updated_by' => session('userid'),
    //                         'sss_bb_update_date' => date('Y-m-d')
    //                     ];
    //                     $Bankbook_m->update($bankid_emp, $new_EmpBalances_withdrawl);
    //                 }
    //             }
    //             if ($nextentries->sss_bb_transtype == 'Withdrawl') {
    //                 $bankid_redeposite = $nextentries->sss_bankbook_id;
    //                 $withdrwl_lastbalances = $nextentries->sss_bb_lastbalance;
    //                 $newlastBalance_deposited = $withdrwl_lastbalances + $isWithdrawled; // add the withdrawl amount
    //                 $newcurrentbalance_deposited = $newlastBalance_deposited - $nextentries->sss_bb_transamt; // Subtract the withdrawl amount
    //                 $new_Balances_deposite = [
    //                     'sss_bb_balance' => $newcurrentbalance_deposited,
    //                     'sss_bb_lastbalance' => $newlastBalance_deposited,
    //                     'sss_pr_updated_by' => session('userid'),
    //                     'sss_pr_update_date' => date('Y-m-d')
    //                 ];
    //                 // echo "<pre>";print_r($new_Balances_deposite);
    //                 $Bankbook_m->update($bankid_redeposite, $new_Balances_deposite);
    //             }

    //             if ($nextentries->sss_bb_transtype == 'Deposit' && $nextentries->sss_allbankid  == $getInvoice['sss_inv_bankid']) {
    //                 // condition for deposite values when the mid entry of any payment received... 
    //                 $bankid_redeposite = $nextentries->sss_bankbook_id;
    //                 // echo $bankid_redeposite . "<br>";
    //                 $withdrwl_otherlastbalances = $nextentries->sss_bb_lastbalance; // other balance which is deposite bt not in adv , tax or emp bank.
    //                 // echo $withdrwl_otherlastbalances . "<br>";
    //                 $newlastBalance_otherdeposited = $withdrwl_otherlastbalances + $isWithdrawled; // Subtract the withdrawl amount
    //                 $newcurrentbalance_deposited = $newlastBalance_otherdeposited + $nextentries->sss_bb_transamt;; // Subtract the withdrawl amount
    //                 $new_OtherBalances_deposite = [
    //                     'sss_bb_balance' => $newcurrentbalance_deposited,
    //                     'sss_bb_lastbalance' => $newlastBalance_otherdeposited,
    //                     'sss_pr_updated_by' => session('userid'),
    //                     'sss_pr_update_date' => date('Y-m-d')
    //                 ];
    //                 // echo "<pre>";print_r($new_OtherBalances_deposite);
    //                 $Bankbook_m->update($bankid_redeposite, $new_OtherBalances_deposite);
    //             }

    //             if ($nextentries->sss_bb_transtype == 'Withdrawl' && $nextentries->sss_allbankid == $getInvoice['sss_inv_bankid']) {
    //                 // condition for deposite values when the mid entry of any payment received...

    //                 $bankid_redeposite = $nextentries->sss_bankbook_id;
    //                 // echo $bankid_redeposite . "<br>";
    //                 $withdrwl_otherlastbalances = $nextentries->sss_bb_lastbalance; // other balance which is deposite bt not in adv , tax or emp bank.
    //                 // echo $withdrwl_otherlastbalances . "<br>";
    //                 $newlastBalance_otherdeposited = $withdrwl_otherlastbalances + $isWithdrawled; // ADD the withdrawl amount
    //                 $newcurrentbalance_deposited_invbank = $newlastBalance_otherdeposited - $nextentries->sss_bb_transamt;; // Subtract the withdrawl amount
    //                 $new_OtherBalances_deposite = [
    //                     'sss_bb_balance' => $newcurrentbalance_deposited_invbank,
    //                     'sss_bb_lastbalance' => $newlastBalance_otherdeposited,
    //                     'sss_pr_updated_by' => session('userid'),
    //                     'sss_pr_update_date' => date('Y-m-d')
    //                 ];
    //                 // echo "<pre>";print_r($new_OtherBalances_deposite);
    //                 $Bankbook_m->update($bankid_redeposite, $new_OtherBalances_deposite);
    //             }
    //         }
    //     }

    //     $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $dddid)->delete();

    //     $Tdsentries_m = new Tdsentries_m();
    //     $Tdsentries_m->table('sss_tbl_totaltds')->where('sss_ddd_id', $dddid)->delete();  // delete tds entries of DDD..

    //     $isDelete = new Dealdetaildraft_m();
    //     $isDelete->table('sss_tbl_dealdetaildraft')->where('sss_ddd_id', $dddid)->delete();

    //     $allemprecord = new DDD_emp_m();
    //     $allemprecord->table('sss_ddd_employees')->where('sss_ddd_id', $dddid)->delete();

    //     $alloutcomerecord = new DDD_outcome_m();
    //     $alloutcomerecord->table('sss_ddd_outcomes')->where('sss_ddd_id', $dddid)->delete();

    //     // update openingmonths balances...
    //     // get current openingmonth balances and update only closing bal....

    //     if (!empty($withdrawl_bankid)) {
    //         $getlastRecord_transactiondate_allwithdrawl_array = $Bankbook_m->table('sss_tbl_bankbook')
    //             ->select('sss_bb_balance,sss_bb_transmonth')
    //             ->where('sss_allbankid', $withdrawl_bankid)
    //             ->where('sss_bb_transmonth', $sss_bb_transmonth)
    //             ->orderBy('sss_bb_transactiondate', 'Desc')
    //             ->limit(1)
    //             ->get()
    //             ->getResult();

    //         if (!empty($getlastRecord_transactiondate_allwithdrawl_array)) {

    //             $closing_Bal_withdrawlarray = $getlastRecord_transactiondate_allwithdrawl_array[0]->sss_bb_balance;

    //             $getValueofNextMonthBalance_withdrawlarray = $NextMonthsBalances_m
    //                 ->where('bankid', $withdrawl_bankid)
    //                 ->where('month >', $month)
    //                 ->where('year', $year)
    //                 ->orderBy('id', 'Asc')
    //                 ->get()
    //                 ->getResult();

    //             if (!empty($getValueofNextMonthBalance_withdrawlarray)) {
    //                 for ($i = 0; $i < count($getValueofNextMonthBalance_withdrawlarray); $i++) {
    //                     // Get closing bal of prev month and update in current month ... 
    //                     $NextMonthsBal = new MonthsBalances_m();
    //                     $NextMonthsBal->update($getValueofNextMonthBalance_withdrawlarray[$i]->id, ['openingbal' =>  $closing_Bal_withdrawlarray]);

    //                     // shift closing bal for null entry...

    //                     $prevClosing_withdrawlarray = $closing_Bal_withdrawlarray;

    //                     // return the closing balance of current month....
    //                     $closing_Bal_withdrawlarray = $Bankbook_m->table('sss_tbl_bankbook')
    //                         ->select('sss_bb_balance,sss_bb_transmonth')
    //                         ->where('sss_allbankid', $getValueofNextMonthBalance_withdrawlarray[$i]->bankid)
    //                         ->where('sss_bb_transmonth', $getValueofNextMonthBalance_withdrawlarray[$i]->balancemonth)
    //                         ->orderBy('sss_bb_transactiondate', 'Desc')
    //                         // ->limit(1)
    //                         ->get()
    //                         ->getRow();


    //                     // $closing_Bal_withdrawlarray = $closing_Bal_withdrawlarray->sss_bb_balance;

    //                     if (!empty($closing_Bal_withdrawlarray)) {
    //                         $closing_Bal_withdrawlarray = $closing_Bal_withdrawlarray->sss_bb_balance;
    //                     } else {
    //                         $closing_Bal_withdrawlarray = $prevClosing_withdrawlarray;
    //                     }
    //                 }
    //             }
    //         }
    //     }
    //     if (!empty($tax_bankid)) {

    //         $getlastRecord_transactiondate_tax_array = $Bankbook_m->table('sss_tbl_bankbook')
    //             ->select('sss_bb_balance,sss_bb_transmonth')
    //             ->where('sss_allbankid', $tax_bankid)
    //             ->where('sss_bb_transmonth', $sss_bb_transmonth)
    //             ->orderBy('sss_bb_transactiondate', 'Desc')
    //             ->limit(1)
    //             ->get()
    //             ->getResult();

    //         if (!empty($getlastRecord_transactiondate_tax_array)) {

    //             $closing_Bal_taxarray = $getlastRecord_transactiondate_tax_array[0]->sss_bb_balance;
    //             $getValueofNextMonthBalance_taxarray = $NextMonthsBalances_m
    //                 ->where('bankid', $tax_bankid)
    //                 ->where('month >', $month)
    //                 ->where('year', $year)
    //                 ->orderBy('id', 'Asc')
    //                 ->get()
    //                 ->getResult();

    //             if (!empty($getValueofNextMonthBalance_taxarray)) {
    //                 for ($i = 0; $i < count($getValueofNextMonthBalance_taxarray); $i++) {
    //                     // Get closing bal of prev month and update in current month ... 
    //                     $NextMonthsBal = new MonthsBalances_m();
    //                     $NextMonthsBal->update($getValueofNextMonthBalance_taxarray[$i]->id, ['openingbal' =>  $closing_Bal_taxarray]);

    //                     // shift closing bal for null entry...

    //                     $prevClosing_taxarray = $closing_Bal_taxarray;

    //                     // return the closing balance of current month....
    //                     $closing_Bal_taxarray = $Bankbook_m->table('sss_tbl_bankbook')
    //                         ->select('sss_bb_balance,sss_bb_transmonth')
    //                         ->where('sss_allbankid', $getValueofNextMonthBalance_taxarray[$i]->bankid)
    //                         ->where('sss_bb_transmonth', $getValueofNextMonthBalance_taxarray[$i]->balancemonth)
    //                         ->orderBy('sss_bb_transactiondate', 'Desc')
    //                         ->limit(1)
    //                         ->get()
    //                         ->getRow();


    //                     // $closing_Bal_taxarray = $closing_Bal_taxarray->sss_bb_balance;

    //                     if (!empty($closing_Bal_taxarray)) {
    //                         $closing_Bal_taxarray = $closing_Bal_taxarray->sss_bb_balance;
    //                     } else {
    //                         $closing_Bal_taxarray = $prevClosing_taxarray;
    //                     }
    //                 }
    //             }
    //         }
    //     }
    //     if (!empty($adv_bankid)) {
    //         $getlastRecord_transactiondate_adv_array = $Bankbook_m->table('sss_tbl_bankbook')
    //             ->select('sss_bb_balance,sss_bb_transmonth')
    //             ->where('sss_allbankid', $adv_bankid)
    //             ->where('sss_bb_transmonth', $sss_bb_transmonth)
    //             ->orderBy('sss_bb_transactiondate', 'Desc')
    //             ->limit(1)
    //             ->get()
    //             ->getResult();

    //         if (!empty($getlastRecord_transactiondate_adv_array)) {

    //             $closing_Bal_advarray = $getlastRecord_transactiondate_adv_array[0]->sss_bb_balance;

    //             $getValueofNextMonthBalance_advarray = $NextMonthsBalances_m
    //                 ->where('bankid', $adv_bankid)
    //                 ->where('month >', $month)
    //                 ->where('year', $year)
    //                 ->orderBy('id', 'Asc')
    //                 ->get()
    //                 ->getResult();

    //             if (!empty($getValueofNextMonthBalance_advarray)) {
    //                 for ($i = 0; $i < count($getValueofNextMonthBalance_advarray); $i++) {
    //                     // Get closing bal of prev month and update in current month ... 
    //                     $NextMonthsBal = new MonthsBalances_m();
    //                     $NextMonthsBal->update($getValueofNextMonthBalance_advarray[$i]->id, ['openingbal' =>  $closing_Bal_advarray]);

    //                     // shift closing bal for null entry...
    //                     $prevClosing_taxarray = $closing_Bal_advarray;

    //                     // return the closing balance of current month....
    //                     $closing_Bal_taxarray = $Bankbook_m->table('sss_tbl_bankbook')
    //                         ->select('sss_bb_balance,sss_bb_transmonth')
    //                         ->where('sss_allbankid', $getValueofNextMonthBalance_advarray[$i]->bankid)
    //                         ->where('sss_bb_transmonth', $getValueofNextMonthBalance_advarray[$i]->balancemonth)
    //                         ->orderBy('sss_bb_transactiondate', 'Desc')
    //                         ->limit(1)
    //                         ->get()
    //                         ->getRow();
    //                     // $closing_Bal_taxarray = $closing_Bal_taxarray->sss_bb_balance;

    //                     if (!empty($closing_Bal_advarray)) {
    //                         $closing_Bal_advarray = $closing_Bal_advarray->sss_bb_balance;
    //                     } else {
    //                         $closing_Bal_advarray = $prevClosing_taxarray;
    //                     }
    //                 }
    //             }
    //         }
    //     }

    //     if (!empty($emp_bankid)) {
           
    //         $getlastRecord_transactiondate_emp_array = $Bankbook_m->table('sss_tbl_bankbook')
    //             ->select('sss_bb_balance,sss_bb_transmonth')
    //             ->where('sss_allbankid', $emp_bankid)
    //             ->where('sss_bb_transmonth', $sss_bb_transmonth)
    //             ->orderBy('sss_bb_transactiondate', 'Desc')
    //             ->limit(1)
    //             ->get()
    //             ->getResult();
    //         // echo "<pre>";print_r($getlastRecord_transactiondate_emp_array);
    //         if (!empty($getlastRecord_transactiondate_emp_array)) {

    //             $closing_Bal_emparray = $getlastRecord_transactiondate_emp_array[0]->sss_bb_balance;

    //             $getValueofNextMonthBalance_emparray = $NextMonthsBalances_m
    //                 ->where('bankid', $emp_bankid)
    //                 ->where('month >', $month)
    //                 ->where('year', $year)
    //                 ->orderBy('id', 'Asc')
    //                 ->get()
    //                 ->getResult();

    //             if (!empty($getValueofNextMonthBalance_emparray)) {
    //                 for ($i = 0; $i < count($getValueofNextMonthBalance_emparray); $i++) {
    //                     // Get closing bal of prev month and update in current month ... 
    //                     $NextMonthsBal = new MonthsBalances_m();
    //                     $NextMonthsBal->update($getValueofNextMonthBalance_emparray[$i]->id, ['openingbal' =>  $closing_Bal_emparray]);

    //                     // shift closing bal for null entry...
    //                     $prevClosing_emparray = $closing_Bal_emparray;

    //                     // return the closing balance of current month....
    //                     $closing_Bal_emparray = $Bankbook_m->table('sss_tbl_bankbook')
    //                         ->select('sss_bb_balance,sss_bb_transmonth')
    //                         ->where('sss_allbankid', $getValueofNextMonthBalance_emparray[$i]->bankid)
    //                         ->where('sss_bb_transmonth', $getValueofNextMonthBalance_emparray[$i]->balancemonth)
    //                         ->orderBy('sss_bb_transactiondate', 'Desc')
    //                         ->limit(1)
    //                         ->get()
    //                         ->getRow();
    //                     if (!empty($closing_Bal_emparray)) {
    //                         $closing_Bal_emparray = $closing_Bal_emparray->sss_bb_balance;
    //                     } else {
    //                         $closing_Bal_emparray = $prevClosing_emparray;
    //                     }
    //                 }
    //             }
    //         }
    //     }


    //     echo json_encode(array("status" => TRUE));
    // }
    
        public function delete_ddd($dddid)
    {
        $Dealdetaildraft_m = new Dealdetaildraft_m();
        $getbankid = new Bankdetails_m();
        $updatedepositebank = new Bankdetails_m();
        $payment = new Paymentreceived_m();
        $invoice = new CreateInvoice_m();
        $Bankbook_m = new Bankbook_m();
        $NextMonthsBalances_m = new MonthsBalances_m();

        // method for checking emphas bank or not...
        $isEmp = new Employee_m();

        // echo "<pre>";print_r($getbanksemp);exit;
        $allemprecord = new DDD_emp_m();
        $employees = $allemprecord->table('sss_ddd_employees')->select('sss_ddd_employees.*')->where('sss_ddd_id', $dddid)->get()->getResult();

        if (!empty($employees)) {
            $emps_bankid = 0;
            $emps_id = 0;

            foreach ($employees as $emp) {
                $empid = $emp->sss_emp_id;

                $getbanksemp = $isEmp->select('sss_emp_id,sss_emp_bankid')->where('sss_hadbank', "Yes")->where('sss_emp_id', $empid)->orderBy('sss_emp_id', 'Desc')->get()->getRow();

                if ($getbanksemp != null) {
                    $emps_bankid = $getbanksemp->sss_emp_bankid;
                }
            }
        }

        $pridForBB = $Dealdetaildraft_m->table('sss_tbl_dealdetaildraft')->where('sss_ddd_id', $dddid)->get()->getRow();
        if (!empty($pridForBB)) {
            $getsourcebankid = $payment->table('sss_tbl_paymentreceived')->where('sss_pr_id', $pridForBB->sss_pr_id)->get()->getRow();

            $invoice = new CreateInvoice_m();
            $getInvoice = $invoice->find($getsourcebankid->sss_inv_id);
            $getInvoice['sss_inv_bankid']; // getbank id for checking into loop of balance reflushing....

        }

        $bb = $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $dddid)->get()->getResult();

        foreach ($bb as $b) {
            if ($b->sss_bb_transtype == 'Withdrawl' && $b->sss_bb_iswithdrawl != '') {

                $ssdddid = $b->sss_ddd_id;

                $sbankid = $b->sss_bb_sourcebankid;
                $sourcetransamt = $b->sss_bb_iswithdrawl;

                $openingbalance = $getbankid->find($sbankid);
                $opningbalofwithdrawlbank = $openingbalance['sss_ent_bank_acc_openingbal'];

                $bankbalanceupdat = $opningbalofwithdrawlbank + $sourcetransamt;

                $sourcebankwithdrawarray = [
                    'sss_ent_bank_acc_openingbal' => $bankbalanceupdat,
                    'sss_ent_bank_last_updated_by' => session('userid'),
                    'sss_ent_bank_updated_date' => date('Y-m-d')
                ];

                $updatedepositebank->update($sbankid, $sourcebankwithdrawarray);
                // $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $ssdddid)->delete();
            }
            if ($b->sss_bb_transtype == 'Deposit' && $b->sss_bb_isdeposit != '') {
                $ssdddid = $b->sss_ddd_id;
                $dbankid = $b->sss_bb_destinationbankid;
                $openingbalance = $getbankid->find($dbankid);
                $opningbalofdestinationbank = $openingbalance['sss_ent_bank_acc_openingbal'];
                $destinationtransamt = $b->sss_bb_isdeposit;
                $depositebankbalanceupdat = $opningbalofdestinationbank - $destinationtransamt;
                $destinationbankdepositearray = [
                    'sss_ent_bank_acc_openingbal' => $depositebankbalanceupdat,
                    'sss_ent_bank_last_updated_by' => session('userid'),
                    'sss_ent_bank_updated_date' => date('Y-m-d')
                ];
                $updatedepositebank->update($dbankid, $destinationbankdepositearray);
                // $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $ssdddid)->delete();
            }
        }


        $BankBook_entries_ofdeletedid = $Bankbook_m->table('sss_tbl_bankbook')->select('sss_bankbook_id,sss_bb_transamt,sss_bb_transtype,sss_bb_transactiondate,sss_allbankid')->where('sss_ddd_id', $dddid)->orderBy('sss_bankbook_id', 'ASC')->get()->getResult();


        $lastBankBookEntry = end($BankBook_entries_ofdeletedid); // get last entry of bankbookid end and id pass to next query...

        $bankbookid = $lastBankBookEntry->sss_bankbook_id;
        $bank_id = $lastBankBookEntry->sss_allbankid;
        $bankbookdate = $lastBankBookEntry->sss_bb_transactiondate;

        $dateComps = date_parse($bankbookdate);
        $year = $dateComps['year'];
        $month = $dateComps['month'];

        $sss_bb_transmonth = $month . '-' . $year;

        $isWithdrawled = 0;
        $isTax_Deposited = 0;
        $isAdv_Deposited = 0;

        // echo "<pre>";print_r($BankBook_entries_ofdeletedid);exit;

        $closing_Bal_withdrawlarray = 0;
        // update openingmonth balances for all withdrawl...
        // for loop use for only gettting invoice bankid from table...
        foreach ($BankBook_entries_ofdeletedid as $foropeningmonth) {
            if ($foropeningmonth->sss_allbankid == $getInvoice['sss_inv_bankid']) {
                $withdrawl_bankid = $foropeningmonth->sss_allbankid;
            }

            if ($foropeningmonth->sss_allbankid == 3) {
                $tax_bankid = $foropeningmonth->sss_allbankid;
            }

            if ($foropeningmonth->sss_allbankid == 2) {
                $adv_bankid = $foropeningmonth->sss_allbankid;
            }

            if ($foropeningmonth->sss_allbankid == $emps_bankid) {
                $emp_bankid = $foropeningmonth->sss_allbankid;
            }
        }


        foreach ($BankBook_entries_ofdeletedid as $deletedrecord) {
            if ($deletedrecord->sss_bb_transtype == 'Withdrawl') {
                $isWithdrawled += $deletedrecord->sss_bb_transamt;
            } else if ($deletedrecord->sss_bb_transtype == 'Deposit') {

                if ($deletedrecord->sss_allbankid == 3) // for tax bank
                {
                    $isTax_Deposited = $deletedrecord->sss_bb_transamt;
                } else if ($deletedrecord->sss_allbankid == 2) // for advertisment bank...
                {
                    $isAdv_Deposited = $deletedrecord->sss_bb_transamt;
                } else if ($deletedrecord->sss_allbankid === $emps_bankid) {

                    $isEmp_deposited = $deletedrecord->sss_bb_transamt;
                }
            }
        }

        $next_BankBook_entries = $Bankbook_m->table('sss_tbl_bankbook')->where('sss_bb_transactiondate >', $bankbookdate)->orderBy('sss_bb_transactiondate', 'ASC')->get()->getResult(); // next bankbook entries which from deleting id..

        if (!empty($next_BankBook_entries)) {
            foreach ($next_BankBook_entries as $nextentries) {
                if ($nextentries->sss_bb_transtype == 'Deposit') {
                    if ($nextentries->sss_allbankid == 3) {
                        $bankid_Tax = $nextentries->sss_bankbook_id;
                        $deposite_lastbalances = $nextentries->sss_bb_lastbalance;
                        $newTaxlastBalance = $deposite_lastbalances - $isTax_Deposited;
                        $newTaxcurrentBalance = $newTaxlastBalance + $nextentries->sss_bb_transamt;
                        $new_TaxBalances_withdrawl = [
                            'sss_bb_balance' => $newTaxcurrentBalance,
                            'sss_bb_lastbalance' => $newTaxlastBalance,
                            'sss_bb_updated_by' => session('userid'),
                            'sss_bb_update_date' => date('Y-m-d')
                        ];
                        $Bankbook_m->update($bankid_Tax, $new_TaxBalances_withdrawl);
                    }
                    if ($nextentries->sss_allbankid == 2) {
                        $bankid_Adv = $nextentries->sss_bankbook_id;
                        $Advdeposite_lastbalances = $nextentries->sss_bb_lastbalance;
                        $newAdvlastBalance = $Advdeposite_lastbalances - $isAdv_Deposited;
                        $newcurrentBalance = $newAdvlastBalance + $nextentries->sss_bb_transamt;
                        $new_AdvBalances_withdrawl = [
                            'sss_bb_lastbalance' => $newAdvlastBalance,
                            'sss_bb_balance' => $newcurrentBalance,
                            'sss_bb_updated_by' => session('userid'),
                            'sss_bb_update_date' => date('Y-m-d')
                        ];
                        $Bankbook_m->update($bankid_Adv, $new_AdvBalances_withdrawl);
                    }
                    if ($nextentries->sss_allbankid == $emps_bankid) {
                        $bankid_emp = $nextentries->sss_bankbook_id;
                        $Emp_deposite_lastbalances = $nextentries->sss_bb_lastbalance;
                        $newEmplastBalance = $Emp_deposite_lastbalances - $isEmp_deposited;
                        $newEmpcurrentbalance = $newEmplastBalance + $nextentries->sss_bb_transamt;

                        $new_EmpBalances_withdrawl = [
                            'sss_bb_balance' => $newEmpcurrentbalance,
                            'sss_bb_lastbalance' => $newEmplastBalance,
                            'sss_bb_updated_by' => session('userid'),
                            'sss_bb_update_date' => date('Y-m-d')
                        ];
                        $Bankbook_m->update($bankid_emp, $new_EmpBalances_withdrawl);
                    }
                }
                if ($nextentries->sss_bb_transtype == 'Withdrawl') {
                    $bankid_redeposite = $nextentries->sss_bankbook_id;
                    $withdrwl_lastbalances = $nextentries->sss_bb_lastbalance;
                    $newlastBalance_deposited = $withdrwl_lastbalances + $isWithdrawled; // add the withdrawl amount
                    $newcurrentbalance_deposited = $newlastBalance_deposited - $nextentries->sss_bb_transamt; // Subtract the withdrawl amount
                    $new_Balances_deposite = [
                        'sss_bb_balance' => $newcurrentbalance_deposited,
                        'sss_bb_lastbalance' => $newlastBalance_deposited,
                        'sss_pr_updated_by' => session('userid'),
                        'sss_pr_update_date' => date('Y-m-d')
                    ];
                    // echo "<pre>";print_r($new_Balances_deposite);
                    $Bankbook_m->update($bankid_redeposite, $new_Balances_deposite);
                }

                if ($nextentries->sss_bb_transtype == 'Deposit' && $nextentries->sss_allbankid  == $getInvoice['sss_inv_bankid']) {
                    // condition for deposite values when the mid entry of any payment received... 
                    $bankid_redeposite = $nextentries->sss_bankbook_id;
                    // echo $bankid_redeposite . "<br>";
                    $withdrwl_otherlastbalances = $nextentries->sss_bb_lastbalance; // other balance which is deposite bt not in adv , tax or emp bank.
                    // echo $withdrwl_otherlastbalances . "<br>";
                    $newlastBalance_otherdeposited = $withdrwl_otherlastbalances + $isWithdrawled; // Subtract the withdrawl amount
                    $newcurrentbalance_deposited = $newlastBalance_otherdeposited + $nextentries->sss_bb_transamt;; // Subtract the withdrawl amount
                    $new_OtherBalances_deposite = [
                        'sss_bb_balance' => $newcurrentbalance_deposited,
                        'sss_bb_lastbalance' => $newlastBalance_otherdeposited,
                        'sss_pr_updated_by' => session('userid'),
                        'sss_pr_update_date' => date('Y-m-d')
                    ];
                    // echo "<pre>";print_r($new_OtherBalances_deposite);
                    $Bankbook_m->update($bankid_redeposite, $new_OtherBalances_deposite);
                }

                if ($nextentries->sss_bb_transtype == 'Withdrawl' && $nextentries->sss_allbankid == $getInvoice['sss_inv_bankid']) {
                    // condition for deposite values when the mid entry of any payment received...

                    $bankid_redeposite = $nextentries->sss_bankbook_id;
                    // echo $bankid_redeposite . "<br>";
                    $withdrwl_otherlastbalances = $nextentries->sss_bb_lastbalance; // other balance which is deposite bt not in adv , tax or emp bank.
                    // echo $withdrwl_otherlastbalances . "<br>";
                    $newlastBalance_otherdeposited = $withdrwl_otherlastbalances + $isWithdrawled; // ADD the withdrawl amount
                    $newcurrentbalance_deposited_invbank = $newlastBalance_otherdeposited - $nextentries->sss_bb_transamt;; // Subtract the withdrawl amount
                    $new_OtherBalances_deposite = [
                        'sss_bb_balance' => $newcurrentbalance_deposited_invbank,
                        'sss_bb_lastbalance' => $newlastBalance_otherdeposited,
                        'sss_pr_updated_by' => session('userid'),
                        'sss_pr_update_date' => date('Y-m-d')
                    ];
                    // echo "<pre>";print_r($new_OtherBalances_deposite);
                    $Bankbook_m->update($bankid_redeposite, $new_OtherBalances_deposite);
                }
            }
        }

        // update openingmonths balances...
        // get current openingmonth balances and update only closing bal....

        $Bankbook_m->table('sss_tbl_bankbook')->where('sss_ddd_id', $dddid)->delete();

        $Tdsentries_m = new Tdsentries_m();
        $Tdsentries_m->table('sss_tbl_totaltds')->where('sss_ddd_id', $dddid)->delete();  // delete tds entries of DDD..

        $isDelete = new Dealdetaildraft_m();
        $isDelete->table('sss_tbl_dealdetaildraft')->where('sss_ddd_id', $dddid)->delete();

        $allemprecord = new DDD_emp_m();
        $allemprecord->table('sss_ddd_employees')->where('sss_ddd_id', $dddid)->delete();

        $alloutcomerecord = new DDD_outcome_m();
        $alloutcomerecord->table('sss_ddd_outcomes')->where('sss_ddd_id', $dddid)->delete();


        if (!empty($withdrawl_bankid)) {
            $get_lastRecord_transactiondate_allwithdrawl_array = $Bankbook_m->table('sss_tbl_bankbook')
                ->select('sss_bb_balance,sss_bb_transmonth')
                ->orderBy('sss_bb_transactiondate', 'Asc')
                ->where('sss_allbankid', $withdrawl_bankid)
                ->where('sss_bb_transmonth', $sss_bb_transmonth)
                ->get()
                ->getResult();
            
            $getlastRecord_transactiondate_allwithdrawl_array = end($get_lastRecord_transactiondate_allwithdrawl_array);

            if (!empty($getlastRecord_transactiondate_allwithdrawl_array)) {

                $closing_Bal_withdrawlarray = $getlastRecord_transactiondate_allwithdrawl_array->sss_bb_balance;

                $getValueofNextMonthBalance_withdrawlarray = $NextMonthsBalances_m
                    ->where('bankid', $withdrawl_bankid)
                    ->where('month >', $month)
                    ->where('year', $year)
                    ->orderBy('id', 'Asc')
                    ->get()
                    ->getResult();

                if (!empty($getValueofNextMonthBalance_withdrawlarray)) {

                    for ($i = 0; $i < count($getValueofNextMonthBalance_withdrawlarray); $i++) {
                        // Get closing bal of prev month and update in current month ... 
                        $NextMonthsBal = new MonthsBalances_m();
                        $NextMonthsBal->update($getValueofNextMonthBalance_withdrawlarray[$i]->id, ['openingbal' =>  $closing_Bal_withdrawlarray]);

                        // shift closing bal for null entry...
                        $prevClosing_withdrawlarray = $closing_Bal_withdrawlarray;

                        // return the closing balance of current month....
                        $closing_Bal_withdrawlarray = $Bankbook_m->table('sss_tbl_bankbook')
                            ->select('sss_bb_balance,sss_bb_transmonth')
                            ->orderBy('sss_bb_transactiondate', 'Desc')
                            ->where('sss_allbankid', $getValueofNextMonthBalance_withdrawlarray[$i]->bankid)
                            ->where('sss_bb_transmonth', $getValueofNextMonthBalance_withdrawlarray[$i]->balancemonth)
                            ->get()
                            ->getRow();

                        // $closing_Bal_withdrawlarray = $closing_Bal_withdrawlarray->sss_bb_balance;

                        if (!empty($closing_Bal_withdrawlarray)) {
                            $closing_Bal_withdrawlarray = $closing_Bal_withdrawlarray->sss_bb_balance;
                        } else {
                            $closing_Bal_withdrawlarray = $prevClosing_withdrawlarray;
                        }
                    }
                }
            }
        }

        if (!empty($tax_bankid)) {
            $get_lastRecord_transactiondate_tax_array = $Bankbook_m->table('sss_tbl_bankbook')
                ->select('sss_bb_balance,sss_bb_transmonth')
                ->orderBy('sss_bb_transactiondate', 'Asc')
                ->where('sss_allbankid', $tax_bankid)
                ->where('sss_bb_transmonth', $sss_bb_transmonth)
                ->get()
                ->getResult();
            $getlastRecord_transactiondate_tax_array = end($get_lastRecord_transactiondate_tax_array);

            if (!empty($getlastRecord_transactiondate_tax_array)) {

                $closing_Bal_taxarray = $getlastRecord_transactiondate_tax_array->sss_bb_balance;
                $getValueofNextMonthBalance_taxarray = $NextMonthsBalances_m
                    ->where('bankid', $tax_bankid)
                    ->where('month >', $month)
                    ->where('year', $year)
                    ->orderBy('id', 'Asc')
                    ->get()
                    ->getResult();

                if (!empty($getValueofNextMonthBalance_taxarray)) {
                    for ($i = 0; $i < count($getValueofNextMonthBalance_taxarray); $i++) {
                        // Get closing bal of prev month and update in current month ... 
                        $NextMonthsBal = new MonthsBalances_m();
                        $NextMonthsBal->update($getValueofNextMonthBalance_taxarray[$i]->id, ['openingbal' =>  $closing_Bal_taxarray]);

                        // shift closing bal for null entry...

                        $prevClosing_taxarray = $closing_Bal_taxarray;

                        // return the closing balance of current month....
                        $closing_Bal_taxarray = $Bankbook_m->table('sss_tbl_bankbook')
                            ->select('sss_bb_balance,sss_bb_transmonth')
                            ->orderBy('sss_bb_transactiondate', 'Desc')
                            ->where('sss_allbankid', $getValueofNextMonthBalance_taxarray[$i]->bankid)
                            ->where('sss_bb_transmonth', $getValueofNextMonthBalance_taxarray[$i]->balancemonth)
                            // ->limit(1)
                            ->get()
                            ->getRow();


                        // $closing_Bal_taxarray = $closing_Bal_taxarray->sss_bb_balance;

                        if (!empty($closing_Bal_taxarray)) {
                            $closing_Bal_taxarray = $closing_Bal_taxarray->sss_bb_balance;
                        } else {
                            $closing_Bal_taxarray = $prevClosing_taxarray;
                        }
                    }
                }
            }
        }

        if (!empty($adv_bankid)) {
            $get_lastRecord_transactiondate_adv_array = $Bankbook_m->table('sss_tbl_bankbook')
                ->select('sss_bb_balance,sss_bb_transmonth')
                ->orderBy('sss_bb_transactiondate', 'Desc')
                ->where('sss_allbankid', $adv_bankid)
                ->where('sss_bb_transmonth', $sss_bb_transmonth)
                ->get()
                ->getResult();

            $getlastRecord_transactiondate_adv_array = end($get_lastRecord_transactiondate_adv_array);
            if (!empty($getlastRecord_transactiondate_adv_array)) {

                $closing_Bal_advarray = $getlastRecord_transactiondate_adv_array->sss_bb_balance;

                $getValueofNextMonthBalance_advarray = $NextMonthsBalances_m
                    ->where('bankid', $adv_bankid)
                    ->where('month >', $month)
                    ->where('year', $year)
                    ->orderBy('id', 'Asc')
                    ->get()
                    ->getResult();

                if (!empty($getValueofNextMonthBalance_advarray)) {
                    for ($i = 0; $i < count($getValueofNextMonthBalance_advarray); $i++) {
                        // Get closing bal of prev month and update in current month ... 
                        $NextMonthsBal = new MonthsBalances_m();
                        $NextMonthsBal->update($getValueofNextMonthBalance_advarray[$i]->id, ['openingbal' =>  $closing_Bal_advarray]);

                        // shift closing bal for null entry...
                        $prevClosing_taxarray = $closing_Bal_advarray;
                        // return the closing balance of current month....
                        $closing_Bal_taxarray = $Bankbook_m->table('sss_tbl_bankbook')
                            ->select('sss_bb_balance,sss_bb_transmonth')
                            ->orderBy('sss_bb_transactiondate', 'Desc')
                            ->where('sss_allbankid', $getValueofNextMonthBalance_advarray[$i]->bankid)
                            ->where('sss_bb_transmonth', $getValueofNextMonthBalance_advarray[$i]->balancemonth)
                            ->get()
                            ->getRow();
                        // $closing_Bal_taxarray = $closing_Bal_taxarray->sss_bb_balance;

                        if (!empty($closing_Bal_advarray)) {
                            $closing_Bal_advarray = $closing_Bal_advarray->sss_bb_balance;
                        } else {
                            $closing_Bal_advarray = $prevClosing_taxarray;
                        }
                    }
                }
            }
        }

        if (!empty($emp_bankid)) {

            $get_lastRecord_transactiondate_emp_array = $Bankbook_m->table('sss_tbl_bankbook')
                ->select('sss_bb_balance,sss_bb_transmonth')
                ->orderBy('sss_bb_transactiondate', 'Desc')
                ->where('sss_allbankid', $emp_bankid)
                ->where('sss_bb_transmonth', $sss_bb_transmonth)
                ->get()
                ->getResult();
            $getlastRecord_transactiondate_emp_array = end($get_lastRecord_transactiondate_emp_array);
            // echo "<pre>";print_r($getlastRecord_transactiondate_emp_array);
            if (!empty($getlastRecord_transactiondate_emp_array)) {

                $closing_Bal_emparray = $getlastRecord_transactiondate_emp_array->sss_bb_balance;

                $getValueofNextMonthBalance_emparray = $NextMonthsBalances_m
                    ->where('bankid', $emp_bankid)
                    ->where('month >', $month)
                    ->where('year', $year)
                    ->orderBy('id', 'Asc')
                    ->get()
                    ->getResult();

                if (!empty($getValueofNextMonthBalance_emparray)) {
                    for ($i = 0; $i < count($getValueofNextMonthBalance_emparray); $i++) {
                        // Get closing bal of prev month and update in current month ... 
                        $NextMonthsBal = new MonthsBalances_m();
                        $NextMonthsBal->update($getValueofNextMonthBalance_emparray[$i]->id, ['openingbal' =>  $closing_Bal_emparray]);

                        // shift closing bal for null entry...
                        $prevClosing_emparray = $closing_Bal_emparray;

                        // return the closing balance of current month....
                        $closing_Bal_emparray = $Bankbook_m->table('sss_tbl_bankbook')
                            ->select('sss_bb_balance,sss_bb_transmonth')
                            ->orderBy('sss_bb_transactiondate', 'Desc')
                            ->where('sss_allbankid', $getValueofNextMonthBalance_emparray[$i]->bankid)
                            ->where('sss_bb_transmonth', $getValueofNextMonthBalance_emparray[$i]->balancemonth)
                            ->get()
                            ->getRow();
                        if (!empty($closing_Bal_emparray)) {
                            $closing_Bal_emparray = $closing_Bal_emparray->sss_bb_balance;
                        } else {
                            $closing_Bal_emparray = $prevClosing_emparray;
                        }
                    }
                }
            }
        }

        echo json_encode(array("status" => TRUE));
    }
}
